| package |
package := Package name: 'GlorpCollectionTypeModels'.
package paxVersion: 1;
	basicComment: 'This is part of the GLORP system, an open-source library (LGPL(S)) for persisting Smalltalk objects in relational databases. For more information see the #notice property, the accompanying files and/or the web sites http://www.glorp.org or http://www.sourceforge.net/projects/glorp '.

package basicPackageVersion: 'image'.


package classNames
	add: #GlorpCollectionTypeModelsPackage;
	add: #GlorpCollectionTypesDescriptorSystem;
	add: #GlorpCollectionTypesWithClassModelsDescriptorSystem;
	add: #GlorpThingOne;
	add: #GlorpThingWithLotsOfDifferentCollections;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: 'GlorpExpressions';
	add: 'GlorpMappings';
	add: 'GlorpTestModels';
	yourself).

package!

"Class Definitions"!

Object subclass: #GlorpCollectionTypeModelsPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpThingOne
	instanceVariableNames: 'id name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpThingWithLotsOfDifferentCollections
	instanceVariableNames: 'id array orderedCollection set bag sortedCollection name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestDescriptorSystem subclass: #GlorpCollectionTypesDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpCollectionTypesDescriptorSystem subclass: #GlorpCollectionTypesWithClassModelsDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

GlorpCollectionTypeModelsPackage guid: (GUID fromString: '{FE3A4F74-0729-4C3C-9F40-05491B46E48C}')!
GlorpCollectionTypeModelsPackage comment: 'This class represents package information for the GlorpCollectionTypeModels package, for systems that don''t have things like package properties to store things like copyright and license information.

LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you''ll need to release the
source of any modifications.

If you require any further clarification, we''d be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'!
!GlorpCollectionTypeModelsPackage categoriesForClass!Unclassified! !
!GlorpCollectionTypeModelsPackage class methodsFor!

LICENSE
"LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you'll need to release the
source of any modifications.

If you require any further clarification, we'd be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"! !
!GlorpCollectionTypeModelsPackage class categoriesFor: #LICENSE!instance creation!public! !

GlorpThingOne guid: (GUID fromString: '{E817C530-A1DB-4C2F-81A8-77DFA00FCBBE}')!
GlorpThingOne comment: 'This just exists to be put in collections.

Instance Variables:
	id	<SmallInteger>	description of id
	name	<String>	description of name

'!
!GlorpThingOne categoriesForClass!Unclassified! !
!GlorpThingOne methodsFor!

<= aThingOne
	^self name <= aThingOne name.!

id
	^id!

id: anInteger
	id := anInteger!

name
	^name!

name: aString
	name := aString! !
!GlorpThingOne categoriesFor: #<=!comparing!private! !
!GlorpThingOne categoriesFor: #id!accessing!private! !
!GlorpThingOne categoriesFor: #id:!accessing!private! !
!GlorpThingOne categoriesFor: #name!accessing!private! !
!GlorpThingOne categoriesFor: #name:!accessing!private! !

!GlorpThingOne class methodsFor!

named: aString
	^self new name: aString.! !
!GlorpThingOne class categoriesFor: #named:!instance creation!private! !

GlorpThingWithLotsOfDifferentCollections guid: (GUID fromString: '{FA4D9716-DD45-4A8A-B3A5-0E407E59D0E1}')!
GlorpThingWithLotsOfDifferentCollections comment: ''!
!GlorpThingWithLotsOfDifferentCollections categoriesForClass!Unclassified! !
!GlorpThingWithLotsOfDifferentCollections methodsFor!

array
	^array!

array: anObject
	array := anObject!

bag
	^bag!

bag: anObject
	bag := anObject!

id
	^id!

id: anObject
	id := anObject!

initialize
	array := #().
	orderedCollection := OrderedCollection new.
	set := Set new.
	bag := Bag new.
	sortedCollection := #() asSortedCollection.!

name
	^name!

name: anObject
	name := anObject!

orderedCollection
	^orderedCollection!

orderedCollection: anObject
	orderedCollection := anObject!

set
	^set!

set: anObject
	set := anObject!

sortedCollection
	^sortedCollection!

sortedCollection: anObject
	sortedCollection := anObject! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #array!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #array:!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #bag!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #bag:!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #id!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #id:!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #initialize!initialize-release!public! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #name!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #name:!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #orderedCollection!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #orderedCollection:!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #set!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #set:!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #sortedCollection!accessing!private! !
!GlorpThingWithLotsOfDifferentCollections categoriesFor: #sortedCollection:!accessing!private! !

!GlorpThingWithLotsOfDifferentCollections class methodsFor!

example1
	| example array |
	example := self new.
	example name: 'fred'.
	array := Array with: (GlorpThingOne named: 'array1') with: (GlorpThingOne named: 'array2') with: (GlorpThingOne named: 'array3').
	example array: array.
	example set add: (GlorpThingOne named: 'set1').
	example set add: (GlorpThingOne named: 'set2').	
	example orderedCollection add: (GlorpThingOne named: 'orderedCollection1').
	example orderedCollection add: (GlorpThingOne named: 'orderedCollection2').
	example bag add: (GlorpThingOne named: 'bag1').
	example bag add: (GlorpThingOne named: 'bag2').
	example sortedCollection add: (GlorpThingOne named: 'sorted1').
	example sortedCollection add: (GlorpThingOne named: 'sorted2').
	example sortedCollection add: (GlorpThingOne named: 'sorted3').
	example sortedCollection add: (GlorpThingOne named: 'sorted4').
	^example.!

exampleForOrdering
	| example |
	example := self new.
	example name: 'order'.
	example orderedCollection add: (GlorpThingOne named: 'oc6').
	example orderedCollection add: (GlorpThingOne named: 'oc5').
	example orderedCollection add: (GlorpThingOne named: 'oc4').
	example orderedCollection add: (GlorpThingOne named: 'oc3').
	example orderedCollection add: (GlorpThingOne named: 'oc7').
	example orderedCollection add: (GlorpThingOne named: 'oc8').
	example array: (#('a1' 'a2' 'a3' 'a9' 'a8' 'a7') collect: [:each | GlorpThingOne named: each]).
	^example!

new
	"Answer a newly created and initialized instance."

	^super new initialize! !
!GlorpThingWithLotsOfDifferentCollections class categoriesFor: #example1!examples!private! !
!GlorpThingWithLotsOfDifferentCollections class categoriesFor: #exampleForOrdering!examples!private! !
!GlorpThingWithLotsOfDifferentCollections class categoriesFor: #new!instance creation!private! !

GlorpCollectionTypesDescriptorSystem guid: (GUID fromString: '{C6CC3388-8868-421C-B498-8A7A25B51F5A}')!
GlorpCollectionTypesDescriptorSystem comment: ''!
!GlorpCollectionTypesDescriptorSystem categoriesForClass!Unclassified! !
!GlorpCollectionTypesDescriptorSystem methodsFor!

allTableNames

	^#('GR_THINGWITHCOLLECTIONS' 'GR_THINGONE' 'GR_THING_LINK').!

constructAllClasses
	^super constructAllClasses add: GlorpThingWithLotsOfDifferentCollections; add: GlorpThingOne; yourself.!

descriptorForGlorpThingOne: aDescriptor 
	aDescriptor table: self thingOneTable.
	aDescriptor addMapping: (DirectMapping from: #id to: (self thingOneTable fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (self thingOneTable fieldNamed: 'NAME')).!

descriptorForGlorpThingWithLotsOfDifferentCollections: aDescriptor
	| ocMapping |
	aDescriptor table: self ownerTable.
	aDescriptor
		addMapping:
			(DirectMapping from: #id to: (self ownerTable fieldNamed: 'ID')).
	aDescriptor
		addMapping:
			(DirectMapping from: #name to: (self ownerTable fieldNamed: 'NAME')).
	aDescriptor
		addMapping:
			((OneToManyMapping new)
				attributeName: #array;
				referenceClass: GlorpThingOne;
				collectionType: Array;
				orderBy: [:each | (each getTable: self thingOneTable) getField: 'ARRAY_POSITION'];
				writeTheOrderField;
				join:
						(Join
								from: (self ownerTable fieldNamed: 'ID')
								to: (self thingOneTable fieldNamed: 'ARRAY_OWNER'))).
	aDescriptor
		addMapping:
			((OneToManyMapping new)
				attributeName: #set;
				referenceClass: GlorpThingOne;
				collectionType: Set;
				join:
						(Join
								from: (self ownerTable fieldNamed: 'ID')
								to: (self thingOneTable fieldNamed: 'SET_OWNER'))).
	ocMapping := ((ManyToManyMapping new)
				attributeName: #orderedCollection;
				referenceClass: GlorpThingOne;
				collectionType: OrderedCollection;
				join:
						(Join
								from: (self ownerTable fieldNamed: 'ID')
								to: (self linkTable fieldNamed: 'OWNER_ID')
								from: 'O'
								to: (self linkTable fieldNamed: 'TYPE'))).
	ocMapping orderBy: [:each | (each getTable: self linkTable) getField: 'POSITION'].
	ocMapping writeTheOrderField.
	aDescriptor addMapping: ocMapping.

	aDescriptor
		addMapping:
			((ManyToManyMapping new)
				attributeName: #bag;
				referenceClass: GlorpThingOne;
				collectionType: Bag;
				join:
						(Join
								from: (self ownerTable fieldNamed: 'ID')
								to: (self linkTable fieldNamed: 'OWNER_ID')
								from: 'B'
								to: (self linkTable fieldNamed: 'TYPE'))).
	aDescriptor
		addMapping:
			((ManyToManyMapping new)
				attributeName: #sortedCollection;
				referenceClass: GlorpThingOne;
				collectionType: SortedCollection;
				join:
						(Join
								from: (self ownerTable fieldNamed: 'ID')
								to: (self linkTable fieldNamed: 'OWNER_ID')
								from: 'S'
								to: (self linkTable fieldNamed: 'TYPE'))).!

linkTable
	^self tableNamed: 'GR_THING_LINK'.!

ownerTable
	^self tableNamed: 'GR_THINGWITHCOLLECTIONS'.!

tableForGR_THING_LINK: aTable
	| ownerId thingId |
	ownerId := aTable createFieldNamed: 'OWNER_ID' type: platform int4.
	aTable addForeignKeyFrom: ownerId to: (self ownerTable fieldNamed: 'ID').
	thingId := aTable createFieldNamed: 'THING_ID' type: platform int4.
	aTable
		addForeignKeyFrom: thingId
		to: (self thingOneTable fieldNamed: 'ID').
	aTable createFieldNamed: 'TYPE' type: (platform char: 1).
	aTable createFieldNamed: 'POSITION' type: platform int4.!

tableForGR_THINGONE: aTable
	| setOwnerId arrayOwnerId |
	(aTable createFieldNamed: 'ID' type: platform serial) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20).
	setOwnerId := aTable createFieldNamed: 'SET_OWNER' type: platform int4.
	aTable addForeignKeyFrom: setOwnerId
		to: (self ownerTable fieldNamed: 'ID').

	arrayOwnerId := aTable createFieldNamed: 'ARRAY_OWNER' type: platform int4.
	aTable addForeignKeyFrom: arrayOwnerId
		to: (self ownerTable fieldNamed: 'ID').
	aTable createFieldNamed: 'ARRAY_POSITION' type: platform int4.!

tableForGR_THINGWITHCOLLECTIONS: aTable

	(aTable createFieldNamed: 'ID' type: platform serial) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20).!

thingOneTable
	^self tableNamed: 'GR_THINGONE'.! !
!GlorpCollectionTypesDescriptorSystem categoriesFor: #allTableNames!accessing!private! !
!GlorpCollectionTypesDescriptorSystem categoriesFor: #constructAllClasses!accessing!private! !
!GlorpCollectionTypesDescriptorSystem categoriesFor: #descriptorForGlorpThingOne:!descriptors!private! !
!GlorpCollectionTypesDescriptorSystem categoriesFor: #descriptorForGlorpThingWithLotsOfDifferentCollections:!descriptors!private! !
!GlorpCollectionTypesDescriptorSystem categoriesFor: #linkTable!private!tables! !
!GlorpCollectionTypesDescriptorSystem categoriesFor: #ownerTable!private!tables! !
!GlorpCollectionTypesDescriptorSystem categoriesFor: #tableForGR_THING_LINK:!private!tables! !
!GlorpCollectionTypesDescriptorSystem categoriesFor: #tableForGR_THINGONE:!private!tables! !
!GlorpCollectionTypesDescriptorSystem categoriesFor: #tableForGR_THINGWITHCOLLECTIONS:!private!tables! !
!GlorpCollectionTypesDescriptorSystem categoriesFor: #thingOneTable!private!tables! !

GlorpCollectionTypesWithClassModelsDescriptorSystem guid: (GUID fromString: '{AC2EFFBA-C6E8-4D1D-8288-618E94E75A44}')!
GlorpCollectionTypesWithClassModelsDescriptorSystem comment: ''!
!GlorpCollectionTypesWithClassModelsDescriptorSystem categoriesForClass!Unclassified! !
!GlorpCollectionTypesWithClassModelsDescriptorSystem methodsFor!

classModelForGlorpThingWithLotsOfDifferentCollections: aClassModel

	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name.
	aClassModel newAttributeNamed: #array collection: Array of: GlorpThingOne.
	aClassModel newAttributeNamed: #set collection: Set of: GlorpThingOne.
	aClassModel newAttributeNamed: #orderedCollection collection: OrderedCollection of: GlorpThingOne.
	aClassModel newAttributeNamed: #bag collection: Bag of: GlorpThingOne.
	aClassModel newAttributeNamed: #sortedCollection collection: SortedCollection of: GlorpThingOne.!

descriptorForGlorpThingWithLotsOfDifferentCollections: aDescriptor
	| ocMapping |
	aDescriptor table: self ownerTable.
	(aDescriptor newMapping: DirectMapping)
		from: #id to: (self ownerTable fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping)
		from: #name to: (self ownerTable fieldNamed: 'NAME').
	(aDescriptor newMapping: OneToManyMapping)
		attributeName: #array;
		orderBy: [:each | (each getTable: self thingOneTable) getField: 'ARRAY_POSITION'];
		writeTheOrderField;
			join:
				(Join
					from: (self ownerTable fieldNamed: 'ID')
					to: (self thingOneTable fieldNamed: 'ARRAY_OWNER')).
	(aDescriptor newMapping: OneToManyMapping)
		attributeName: #set;
		join:
			(Join
				from: (self ownerTable fieldNamed: 'ID')
				to: (self thingOneTable fieldNamed: 'SET_OWNER')).
	ocMapping := (aDescriptor newMapping: ManyToManyMapping)
		attributeName: #orderedCollection;
		join:
			(Join
				from: (self ownerTable fieldNamed: 'ID')
				to: (self linkTable fieldNamed: 'OWNER_ID')
				from: 'O'
				to: (self linkTable fieldNamed: 'TYPE')).
	ocMapping orderBy: [:each | (each getTable: self linkTable) getField: 'POSITION'].
	ocMapping writeTheOrderField.

	(aDescriptor newMapping: ManyToManyMapping)
		attributeName: #bag;
		join:
			(Join
				from: (self ownerTable fieldNamed: 'ID')
				to: (self linkTable fieldNamed: 'OWNER_ID')
				from: 'B'
				to: (self linkTable fieldNamed: 'TYPE')).
	(aDescriptor newMapping: ManyToManyMapping)
		attributeName: #sortedCollection;
		join:
			(Join
				from: (self ownerTable fieldNamed: 'ID')
				to: (self linkTable fieldNamed: 'OWNER_ID')
				from: 'S'
				to: (self linkTable fieldNamed: 'TYPE')).! !
!GlorpCollectionTypesWithClassModelsDescriptorSystem categoriesFor: #classModelForGlorpThingWithLotsOfDifferentCollections:!class models!private! !
!GlorpCollectionTypesWithClassModelsDescriptorSystem categoriesFor: #descriptorForGlorpThingWithLotsOfDifferentCollections:!descriptors!private! !

"Binary Globals"!

