| package |
package := Package name: 'GlorpDBTypeTests'.
package paxVersion: 1;
	basicComment: 'This is part of the GLORP system, an open-source library (LGPL(S)) for persisting Smalltalk objects in relational databases. For more information see the #notice property, the accompanying files and/or the web sites http://www.glorp.org or http://www.sourceforge.net/projects/glorp '.

package basicPackageVersion: 'image'.


package classNames
	add: #AbstractLOBTest;
	add: #GlorpBlobTest;
	add: #GlorpBooleanTest;
	add: #GlorpChar2Test;
	add: #GlorpChar4Test;
	add: #GlorpClobTest;
	add: #GlorpDatabaseTypeDBTests;
	add: #GlorpDatabaseTypeIndividualDBTests;
	add: #GlorpDateTest;
	add: #GlorpDBTypeTestsPackage;
	add: #GlorpFloat4Test;
	add: #GlorpFloat8Test;
	add: #GlorpInt2Test;
	add: #GlorpInt4Test;
	add: #GlorpInt8Test;
	add: #GlorpIntegerTest;
	add: #GlorpNumeric52Test;
	add: #GlorpNumeric5Test;
	add: #GlorpNumeric5ZeroTest;
	add: #GlorpNumericTest;
	add: #GlorpTextTest;
	add: #GlorpTimestampTest;
	add: #GlorpTimeTest;
	add: #GlorpTypeComparisonTest;
	add: #GlorpVarchar10Test;
	add: #GlorpVarchar1Test;
	add: #GlorpVarchar2Test;
	add: #GlorpVarchar4Test;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: 'GlorpDatabase';
	add: 'GlorpDatabaseTypes';
	add: 'GlorpDBTests';
	add: 'GlorpExpressions';
	add: 'GlorpMappings';
	add: 'GlorpMisc';
	add: 'GlorpTestModels';
	yourself).

package!

"Class Definitions"!

Object subclass: #GlorpDBTypeTestsPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpDatabaseTypeDBTests
	instanceVariableNames: 'type stType connection session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpDatabaseTypeIndividualDBTests
	instanceVariableNames: 'type stType connection session table'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpTypeComparisonTest
	instanceVariableNames: 'platform'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #AbstractLOBTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpBooleanTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpChar2Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpChar4Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpDateTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpFloat4Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpFloat8Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpInt2Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpInt4Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpInt8Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpIntegerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpNumeric52Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpNumeric5Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpNumeric5ZeroTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpNumericTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpTimestampTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpTimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpVarchar10Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpVarchar1Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpVarchar2Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseTypeIndividualDBTests subclass: #GlorpVarchar4Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
AbstractLOBTest subclass: #GlorpBlobTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
AbstractLOBTest subclass: #GlorpClobTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
AbstractLOBTest subclass: #GlorpTextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

GlorpDBTypeTestsPackage guid: (GUID fromString: '{8680E24D-6810-4469-9F96-190E9C6D04A9}')!
GlorpDBTypeTestsPackage comment: 'This class represents package information for the GlorpDBTypeTests package, for systems that don''t have things like package properties to store things like copyright and license information.

LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you''ll need to release the
source of any modifications.

If you require any further clarification, we''d be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'!
!GlorpDBTypeTestsPackage categoriesForClass!Unclassified! !
!GlorpDBTypeTestsPackage class methodsFor!

LICENSE
"LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you'll need to release the
source of any modifications.

If you require any further clarification, we'd be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"! !
!GlorpDBTypeTestsPackage class categoriesFor: #LICENSE!instance creation!public! !

GlorpDatabaseTypeDBTests guid: (GUID fromString: '{3D392F48-CE1E-4833-B0C5-DE2D134C41A4}')!
GlorpDatabaseTypeDBTests comment: ''!
!GlorpDatabaseTypeDBTests categoriesForClass!Unclassified! !
!GlorpDatabaseTypeDBTests methodsFor!

platform
	^connection platform!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	connection := session accessor.!

tearDown
	super tearDown.
	session reset.
	session := nil.!

testReadTime
	self platform readTime: '18:06:22.12' for: self platform time.!

testSerial
	"type := PGSerialType instance.
	self assert: false.

	self assert: (type typeString = 'SERIAL')"!

testTimeWithTimeZone

	| time |
	"
	type := PGTimeWithTimeZoneType instance.
	time := Dialect timestampNow.

	self assert: false. This needs some thought.
	self assert: (self helpTestType: type withValue: time).	
	self assert: (type typeString = 'TIME WITH TIME ZONE')"!

testTypeParametersNotAliased

	| type2 type3 |
	type := (self platform) varchar.
	self assert: type width isNil.
	self assert: (type2 := self platform varChar: 5) width = 5.
	self assert: type width isNil.
	type3 := self platform varChar: 10.
	self assert: type3 width = 10.
	self assert: type2 width = 5.
	self assert: type width isNil.!

testVarBinary
	"Needs doing"
	self needsWork: 'write the test'.! !
!GlorpDatabaseTypeDBTests categoriesFor: #platform!accessing!private! !
!GlorpDatabaseTypeDBTests categoriesFor: #setUp!private!setup! !
!GlorpDatabaseTypeDBTests categoriesFor: #tearDown!private!setup! !
!GlorpDatabaseTypeDBTests categoriesFor: #testReadTime!infrastructure tests!private! !
!GlorpDatabaseTypeDBTests categoriesFor: #testSerial!private!tests! !
!GlorpDatabaseTypeDBTests categoriesFor: #testTimeWithTimeZone!private!tests! !
!GlorpDatabaseTypeDBTests categoriesFor: #testTypeParametersNotAliased!private!tests! !
!GlorpDatabaseTypeDBTests categoriesFor: #testVarBinary!private!tests! !

!GlorpDatabaseTypeDBTests class methodsFor!

resources
	^Array with: (Smalltalk at: #GlorpSessionResource)! !
!GlorpDatabaseTypeDBTests class categoriesFor: #resources!accessing!private! !

GlorpDatabaseTypeIndividualDBTests guid: (GUID fromString: '{059BFDBF-59BB-4EB1-93C0-7D1D65538A62}')!
GlorpDatabaseTypeIndividualDBTests comment: ''!
!GlorpDatabaseTypeIndividualDBTests categoriesForClass!Unclassified! !
!GlorpDatabaseTypeIndividualDBTests methodsFor!

compareFloatInModel: read with: original
	read isNil ifTrue: [^false].
	read test = original ifTrue: [^true].
	read test isNil ifTrue: [^false].
	^(read test - original) abs <= 0.00001.!

createTypeTestTable
	| system |
	connection doDDLOperation: [
		connection
			dropTableNamed: 'TYPETESTS'
			ifAbsent: [:ex | ex return: nil].
		table := DatabaseTable named: 'TYPETESTS'.
		table
			createFieldNamed: 'test'
			type: type.
		(table createFieldNamed: 'id' type: session system platform inMemorySequence) bePrimaryKey.
		connection
			createTable: table
			ifError:
				[:ex | 
				Transcript show: 'CANNOT CREATE TABLE'.
             		self signalFailure: ex messageText.
				ex return: nil].
	].
	system := self systemFor: table.
	session system: system.
	^table.!

defaultDatabaseType
	self subclassResponsibility.!

helpTestExplicitReadBackFor: dbOutValue
	"Read back the row with the given value, using an explicit where clause."
	| queryStream result |
	queryStream := SQLStringSelectCommand sqlString: String new parameters: #() useBinding: false session: session.
	queryStream nextPutAll: 'SELECT TEST,ID FROM TYPETESTS WHERE TEST '.
	queryStream nextPutAll: (dbOutValue isNil ifTrue: [' IS '] ifFalse: [' = ']).
	type print: dbOutValue on: queryStream.
	result := connection executeSQLString: queryStream contents.
	result isEmpty ifTrue: [^nil].
	^(result atIndex: 1) atIndex: 1.!

helpTestFloat: anObject
	"Don't try and read back an equal float, it'll likely fail on precision issues"

	self
		helpTestValue: anObject
		compareModelWith:
			[:read :original | self compareFloatInModel: read with: original]
		compareWith:
			[:read :original | original isNil or: [(read - original) abs <= 0.00001]].!

helpTestInvalidValue: anObject
	self helpTestValue: anObject
		compareModelWith: [:read :original | read isNil or: [ read test ~= original ]]
		compareWith: [:read :original | read ~= original]!

helpTestValue: anObject 
	"Don't try and read back an equal float, it'll likely fail on precision issues"

	self 
		helpTestValue: anObject
		compareModelWith: 
			[:read :original | 
			read notNil and: 
					[(original isKindOf: Float) or: 
							[original class == Dialect doublePrecisionFloatClass 
								or: [read test = original]]]]
		compareWith: [:read :original | read = original]!

helpTestValue: anObject compareModelWith: modelBlock compareWith: aBlock 
	self 
		helpTestValueWithSQLWrite: anObject
		compareModelWith: modelBlock
		compareWith: aBlock.
	self 
		helpTestValueWithUnitOfWorkWrite: anObject
		compareModelWith: modelBlock!

helpTestValue: anObject compareWith: aBlock 
	self 
		helpTestValue: anObject
		compareModelWith: [:read :original | true]
		compareWith: aBlock!

helpTestValueWithSQLWrite: anObject compareModelWith: modelBlock compareWith: aBlock

	| dbInValue readObject row converter dbOutValue typeTestModel system dbInValue2 readObject2 command |

	system := self systemFor: table.
	session system: system.
	row := DatabaseRow newForTable: table.
	row owner: GlorpTypeTestsModelClass new.
	converter := type converterForStType: (stType isNil ifTrue: [anObject class] ifFalse: [stType]).
	dbOutValue := converter convert: anObject toDatabaseRepresentationAs: type.
	row atFieldNamed: 'test' put: dbOutValue.
	self inTransactionDo: [
	session writeRow: row.

	command := SQLStringCommand new setSQLString:  'SELECT TEST, ID FROM TYPETESTS'.
	command maximumLobSizeToRetrieveDirectly: ((dbOutValue class = ByteArray or: [dbOutValue isString]) ifTrue: [dbOutValue size] ifFalse: [42]).
	dbInValue := (session accessor executeCommand: command) first atIndex: 1.
	readObject := converter convert: dbInValue fromDatabaseRepresentationAs: type.

	(session platform canUseInWhereClause: dbOutValue type: type) ifTrue: [
		dbInValue2 := self helpTestExplicitReadBackFor: dbOutValue.
		readObject2 := converter convert: dbInValue2 fromDatabaseRepresentationAs: type].

	(session platform canUseInWhereClause: anObject type: type) ifTrue: [
		typeTestModel := self readBackModelWithValue: anObject.
		self assert: (modelBlock value: typeTestModel value: anObject)]
	].
	self assert: (aBlock value: readObject value: anObject).
	readObject2 isNil ifFalse: [
		self assert: (aBlock value: readObject2 value: anObject)].!

helpTestValueWithUnitOfWorkWrite: anObject compareModelWith: aBlock
	| typeTestModel system model |
	system := self systemFor: table.
	session system: system.
	self inTransactionDo: [
	session beginUnitOfWork.
	model := GlorpTypeTestsModelClass new test: anObject.
	session register: model.
	session commitUnitOfWork.
	session reset.
	(session platform canUseInWhereClause: anObject type: type) ifTrue: [
		typeTestModel := self readBackModelWithValue: anObject.
		self assert: (aBlock value: typeTestModel value: anObject)]].!

initialize!

inTransactionDo: aBlock
	"Like the one in session, but always rollback."
	| alreadyInTransaction result |
	[ 
	alreadyInTransaction := session isInTransaction.
	alreadyInTransaction ifFalse: [session beginTransaction].
	result := aBlock argumentCount = 1 ifTrue: [aBlock value: self] ifFalse: [aBlock value].
	alreadyInTransaction ifFalse: [session rollbackTransaction]]
		ifCurtailed:
			[alreadyInTransaction ifFalse: [session rollbackTransaction]].
	^result.!

platform
	^connection platform!

readBackModelWithValue: anObject
	^session
		readOneOf: GlorpTypeTestsModelClass
		where: [:each | each test = anObject].!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	connection := session accessor.
	type := self defaultDatabaseType.
	table := self createTypeTestTable.!

systemFor: aTable
	| system descriptor mapping model |
	system := DynamicDescriptorSystem new.
	model := system addClassModelFor: GlorpTypeTestsModelClass.
	model newAttributeNamed: #id.
	model newAttributeNamed: #test type: stType.
	system privateTableAt: aTable name put: aTable.
	descriptor := Descriptor new.
	descriptor system: system.
	descriptor classModel: model.
	descriptor table: aTable.
	descriptor
		addMapping: (DirectMapping from: #id to: (aTable fieldNamed: 'id')).
	stType isNil
		ifTrue:
			[mapping := DirectMapping from: #test to: (aTable fieldNamed: 'test')]
		ifFalse:
			[mapping := DirectMapping
				from: #test
				type: stType
				to: (aTable fieldNamed: 'test')].
	descriptor addMapping: mapping.
	system privateDescriptorAt: GlorpTypeTestsModelClass put: descriptor.
	^system.!

tearDown
	super tearDown.
	session doDDLOperation: [
		connection
			dropTableNamed: 'TYPETESTS'
			ifAbsent: [:ex | ex return: nil]].
	session reset.
	session := nil.! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #compareFloatInModel:with:!helpers!private! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #createTypeTestTable!private!setUp! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #defaultDatabaseType!private!setUp! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #helpTestExplicitReadBackFor:!helpers!public! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #helpTestFloat:!helpers!private! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #helpTestInvalidValue:!helpers!private! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #helpTestValue:!helpers!private! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #helpTestValue:compareModelWith:compareWith:!helpers!private! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #helpTestValue:compareWith:!helpers!private! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #helpTestValueWithSQLWrite:compareModelWith:compareWith:!helpers!private! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #helpTestValueWithUnitOfWorkWrite:compareModelWith:!helpers!private! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #initialize!initializing!private! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #inTransactionDo:!helpers!private! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #platform!accessing!private! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #readBackModelWithValue:!helpers!private! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #setUp!private!setUp! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #systemFor:!private!setUp! !
!GlorpDatabaseTypeIndividualDBTests categoriesFor: #tearDown!private!setUp! !

!GlorpDatabaseTypeIndividualDBTests class methodsFor!

resources
	^Array with: GlorpDatabaseLoginResource with: (Smalltalk at: #GlorpSessionResource).! !
!GlorpDatabaseTypeIndividualDBTests class categoriesFor: #resources!private!resources! !

GlorpTypeComparisonTest guid: (GUID fromString: '{BEB7D356-80EE-43EC-AEFC-5FF8343FAC32}')!
GlorpTypeComparisonTest comment: ''!
!GlorpTypeComparisonTest categoriesForClass!Unclassified! !
!GlorpTypeComparisonTest methodsFor!

setUp
	super setUp.
	platform := DatabasePlatform new!

testIntegerishNumberToNumber
	self deny: (GlorpNumericType new platform: platform) = (GlorpNumericType new platform: platform; precision: 2).
	self deny: (GlorpNumericType new platform: platform) hash = (GlorpNumericType new platform: platform; precision: 2) hash.
	self deny: (GlorpNumericType new platform: platform; precision: 2) = (GlorpNumericType new platform: platform).
	self deny: (GlorpNumericType new platform: platform; precision: 2) hash = (GlorpNumericType new platform: platform) hash.!

testIntegerToInteger
	self assert: (GlorpIntegerType new platform: platform) = (GlorpIntegerType new platform: platform).
	self assert: (GlorpIntegerType new platform: platform) hash = (GlorpIntegerType new platform: platform) hash.!

testIntegerToIntegerishNumber
	self assert: (GlorpIntegerType new platform: platform) = (GlorpNumericType new platform: platform).
	self assert: (GlorpIntegerType new platform: platform) hash = (GlorpNumericType new platform: platform) hash.
	self assert: (GlorpNumericType new platform: platform) = (GlorpIntegerType new platform: platform).
	self assert: (GlorpNumericType new platform: platform) hash = (GlorpIntegerType new platform: platform) hash.!

testIntegerToNumber
	self deny: (GlorpIntegerType new platform: platform) = (GlorpNumericType new platform: platform; precision: 2).
	self deny: (GlorpIntegerType new platform: platform) hash = (GlorpNumericType new platform: platform; precision: 2) hash.
	self deny: (GlorpNumericType new platform: platform; precision: 2) = (GlorpIntegerType new platform: platform).
	self deny: (GlorpNumericType new platform: platform; precision: 2) hash = (GlorpIntegerType new platform: platform) hash.!

testNumberToNumber
	self assert: (GlorpNumericType new platform: platform; precision: 2) = (GlorpNumericType new platform: platform; precision: 2).
	self assert: (GlorpNumericType new platform: platform; precision: 2) hash = (GlorpNumericType new platform: platform; precision: 2) hash.
	self assert: (GlorpNumericType new platform: platform; precision: 2) = (GlorpNumericType new platform: platform; precision: 2).
	self assert: (GlorpNumericType new platform: platform; precision: 2) hash = (GlorpNumericType new platform: platform; precision: 2) hash.! !
!GlorpTypeComparisonTest categoriesFor: #setUp!private!running! !
!GlorpTypeComparisonTest categoriesFor: #testIntegerishNumberToNumber!private!testing! !
!GlorpTypeComparisonTest categoriesFor: #testIntegerToInteger!private!testing! !
!GlorpTypeComparisonTest categoriesFor: #testIntegerToIntegerishNumber!private!testing! !
!GlorpTypeComparisonTest categoriesFor: #testIntegerToNumber!private!testing! !
!GlorpTypeComparisonTest categoriesFor: #testNumberToNumber!private!testing! !

AbstractLOBTest guid: (GUID fromString: '{27D30805-A62A-4E85-97FB-06CD769DC737}')!
AbstractLOBTest comment: ''!
!AbstractLOBTest categoriesForClass!Unclassified! !
!AbstractLOBTest methodsFor!

adjustForMaximumSize: aValue
	^aValue size > session platform maximumQueryValueSize 
		ifTrue: [(aValue copyFrom: 1 to: session platform maximumQueryValueSize - 2), '%']
		ifFalse: [aValue].!

convertToTypeFrom: anObject
	"For SQL-Server, return the function which converts anObject's value to my type."
	
	^anObject
		ifNotNil:
			[FunctionExpression for: #convertTo: withArguments: (Array with: anObject asGlorpExpression) basedOn: type asGlorpExpression system: session system]!

helpTestExplicitReadBackFor: dbOutValue
	"Read back the row with the given value, using an explicit where clause."
	| queryStream result compareClause|
	queryStream := SQLStringSelectCommand sqlString: nil parameters: #() useBinding: session useBinding session: session.
	queryStream nextPutAll: 'SELECT TEST,ID FROM TYPETESTS WHERE TEST'.
	compareClause := self platform isSQLServerPlatform ifTrue: [' = '] ifFalse: [' LIKE '].
	queryStream nextPutAll: (dbOutValue isNil ifTrue: [' IS '] ifFalse: [compareClause]).
	(dbOutValue notNil and: [type requiresCast]) ifTrue: [queryStream nextPutAll: ' CAST ('].
	(self platform isSQLServerPlatform and: [dbOutValue notNil and: [type requiresConvertToVarbinary]])
		ifTrue: [queryStream nextPutAll: ' CONVERT(varbinary(max),'].
	(queryStream canBind: dbOutValue to: type) 
		ifTrue: [
			queryStream parameters: (Array with: dbOutValue).
			queryStream nextPutAll: '?']
		ifFalse: [type print: dbOutValue on: queryStream].
	(dbOutValue notNil and: [type requiresCast]) ifTrue: [
		queryStream nextPutAll: ' AS '.
		queryStream nextPutAll: type queryType typeName.
		queryStream nextPutAll: ')'].
	(self platform isSQLServerPlatform and: [dbOutValue notNil and: [type requiresConvertToVarbinary]])
		ifTrue: [queryStream nextPutAll: ')'].
	result := connection executeCommand: queryStream.
	result isEmpty ifTrue: [^nil].
	^(result atIndex: 1) atIndex: 1.!

helpTestValue: anObject compareModelWith: modelBlock compareWith: aBlock 
	| dbOutValue |
	dbOutValue := self adjustForMaximumSize: anObject.
	^super helpTestValue: dbOutValue compareModelWith: modelBlock compareWith: aBlock.!

readBackModelWithValue: anObject
	"For SQL-Server, use CONVERT (which is easier than CAST for now), with = instead of LIKE."
	
	^self platform isSQLServerPlatform
		ifTrue:
			[| converted |
			converted := self convertToTypeFrom: anObject.
			session
				readOneOf: GlorpTypeTestsModelClass
				where: [:each | each test = converted]]
		ifFalse:
			[session
				readOneOf: GlorpTypeTestsModelClass
				where: [:each | each test like: anObject]]

	"^session
		readOneOf: GlorpTypeTestsModelClass
		where: [:each | each test like: (Cast value: anObject as: type queryType)]."! !
!AbstractLOBTest categoriesFor: #adjustForMaximumSize:!private! !
!AbstractLOBTest categoriesFor: #convertToTypeFrom:!private! !
!AbstractLOBTest categoriesFor: #helpTestExplicitReadBackFor:!private! !
!AbstractLOBTest categoriesFor: #helpTestValue:compareModelWith:compareWith:!private! !
!AbstractLOBTest categoriesFor: #readBackModelWithValue:!private! !

GlorpBooleanTest guid: (GUID fromString: '{92864C96-2F70-43B4-A785-D8F82D5C919B}')!
GlorpBooleanTest comment: ''!
!GlorpBooleanTest categoriesForClass!Unclassified! !
!GlorpBooleanTest methodsFor!

defaultDatabaseType
	^self platform boolean.!

testBoolean
	stType := Boolean.
	self helpTestValue: nil compareWith: [:read :original |
		self platform usesNullForFalse ifTrue: [read = false] ifFalse: [read = nil]].
	self helpTestValue: true.
	self helpTestValue: false.! !
!GlorpBooleanTest categoriesFor: #defaultDatabaseType!private!types! !
!GlorpBooleanTest categoriesFor: #testBoolean!private!tests! !

GlorpChar2Test guid: (GUID fromString: '{CB08379D-234F-4352-9F3A-26D189EE3873}')!
GlorpChar2Test comment: ''!
!GlorpChar2Test categoriesForClass!Unclassified! !
!GlorpChar2Test methodsFor!

defaultDatabaseType
	^self platform char width: 2!

testChar2

	stType := String.
	self helpTestValue: nil.
	self helpTestValue: '' compareWith: [:read :original |
		self platform usesNullForEmptyStrings ifTrue: [read = nil] ifFalse: [read = original]].
	self helpTestValue: 'a'.
	self helpTestValue: 'ab'.
	self helpTestInvalidValue: 'abc'.
	self helpTestInvalidValue: 'abcd'.
	self helpTestInvalidValue: 'abcde'.
	
	self assert: (type typeString asUppercase = (self platform char: 2) typeString asUppercase)! !
!GlorpChar2Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpChar2Test categoriesFor: #testChar2!private!tests! !

GlorpChar4Test guid: (GUID fromString: '{1486B470-17A8-4659-B1DC-0C223CAE7104}')!
GlorpChar4Test comment: ''!
!GlorpChar4Test categoriesForClass!Unclassified! !
!GlorpChar4Test methodsFor!

defaultDatabaseType
	^self platform char width: 4.!

testChar4

	stType := String.
	self helpTestValue: nil.
	self helpTestValue: '' compareWith: [:read :original |
		self platform usesNullForEmptyStrings ifTrue: [read = nil] ifFalse: [read = original]].
	self helpTestValue: 'a'.
	self helpTestValue: 'ab'.
	self helpTestValue: 'abc'.
	self helpTestValue: 'abcd'.
	self helpTestInvalidValue: 'abcde'.
	stType := Symbol.
	self helpTestValue: #abcd.
	
	self assert: (type typeString asUppercase= (self platform char: 4) typeString asUppercase)! !
!GlorpChar4Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpChar4Test categoriesFor: #testChar4!private!tests! !

GlorpDateTest guid: (GUID fromString: '{B9ABBCAF-5A04-4707-98AD-72FE47A04D07}')!
GlorpDateTest comment: ''!
!GlorpDateTest categoriesForClass!Unclassified! !
!GlorpDateTest methodsFor!

defaultDatabaseType
	^self platform date!

testDate
	| date |
	date := Date today.
	stType := Date.

	self helpTestValue: date.
	self helpTestValue: nil!

testDateCast
	"SQLite does not have time-related types:  they are all mapped to strings.  I have not debugged why this test fails yet but assume it is completely unrealistic to expect a string to be cast to a timestamp."

	| date model |
	date := Date today.
	session transact: [session register: (GlorpTypeTestsModelClass new test: date)].
	model := session readOneOf: GlorpTypeTestsModelClass where: [:each | (each test cast: session platform date) = date].
	self deny: model isNil description: 'This test will fail on SQLite which has no DB Date type;  see test comment'.
	self assert: model test = date.

	model := model := session platform isDB2Platform
		ifTrue: [session readOneOf: GlorpTypeTestsModelClass where: [:each | (each test timestamp: each test time0) = date]]
		ifFalse:
			[session readOneOf: GlorpTypeTestsModelClass where: [:each | (each test cast: session platform timestamp) = date]].
	self deny: model isNil.
	self assert: model test = date.

	model := session readOneOf: GlorpTypeTestsModelClass where: [:each | each test asDate = date].
	self deny: model isNil.
	self assert: model test = date! !
!GlorpDateTest categoriesFor: #defaultDatabaseType!private!types! !
!GlorpDateTest categoriesFor: #testDate!public!tests! !
!GlorpDateTest categoriesFor: #testDateCast!public!tests! !

GlorpFloat4Test guid: (GUID fromString: '{3A148209-D664-4ABD-97AA-10CAA1C70AB2}')!
GlorpFloat4Test comment: ''!
!GlorpFloat4Test categoriesForClass!Unclassified! !
!GlorpFloat4Test methodsFor!

defaultDatabaseType
	^self platform float4.!

testFloat4

	self helpTestFloat: nil.
	self helpTestValue: 3.14 compareWith: [:read :original |
		read - original <= 0.00001].! !
!GlorpFloat4Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpFloat4Test categoriesFor: #testFloat4!private!tests! !

GlorpFloat8Test guid: (GUID fromString: '{B2E04FFD-923D-414D-A125-E56CA79078FD}')!
GlorpFloat8Test comment: ''!
!GlorpFloat8Test categoriesForClass!Unclassified! !
!GlorpFloat8Test methodsFor!

defaultDatabaseType
	^self platform float8!

testFloat8
	type := (self platform) double.

	self helpTestFloat: nil.
	self helpTestValue: (Dialect coerceToDoublePrecisionFloat: 3.14) compareWith: [:read :original |
		read - original <= 0.0000001].! !
!GlorpFloat8Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpFloat8Test categoriesFor: #testFloat8!private!types! !

GlorpInt2Test guid: (GUID fromString: '{5EBCCC26-2211-4989-BEB7-8E72CB0429AB}')!
GlorpInt2Test comment: ''!
!GlorpInt2Test categoriesForClass!Unclassified! !
!GlorpInt2Test methodsFor!

defaultDatabaseType
	^self platform int2.!

testBooleanToInteger
	stType := Boolean.
	self helpTestValue: nil.
	self helpTestValue: true.
	self helpTestValue: false.!

testInt2
	self helpTestValue: nil.
	self helpTestValue: 32123.! !
!GlorpInt2Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpInt2Test categoriesFor: #testBooleanToInteger!private!tests! !
!GlorpInt2Test categoriesFor: #testInt2!private!tests! !

GlorpInt4Test guid: (GUID fromString: '{F472D6C4-112A-4F23-BE6C-34333877884A}')!
GlorpInt4Test comment: ''!
!GlorpInt4Test categoriesForClass!Unclassified! !
!GlorpInt4Test methodsFor!

defaultDatabaseType
	^self platform int4!

testInt4
	self helpTestValue: nil.
	self helpTestValue: 3212321.! !
!GlorpInt4Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpInt4Test categoriesFor: #testInt4!private!tests! !

!GlorpInt4Test class methodsFor!

new
	"Answer a newly created and initialized instance."

	^super new initialize! !
!GlorpInt4Test class categoriesFor: #new!instance creation!private! !

GlorpInt8Test guid: (GUID fromString: '{43C8AD39-8993-4FE4-9BA9-7B71F068360F}')!
GlorpInt8Test comment: ''!
!GlorpInt8Test categoriesForClass!Unclassified! !
!GlorpInt8Test methodsFor!

defaultDatabaseType
	^self platform int8!

testInt8
	type := (self platform) int8.
	self helpTestValue: nil.
	self helpTestValue: 3212321555.! !
!GlorpInt8Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpInt8Test categoriesFor: #testInt8!private!tests! !

GlorpIntegerTest guid: (GUID fromString: '{CA5A6F13-88FB-4882-9462-69DA4DA7EB75}')!
GlorpIntegerTest comment: ''!
!GlorpIntegerTest categoriesForClass!Unclassified! !
!GlorpIntegerTest methodsFor!

defaultDatabaseType
	^self platform integer.!

testInteger
	type := (self platform) integer.
	self helpTestValue: nil.
	self helpTestValue: 3212321.! !
!GlorpIntegerTest categoriesFor: #defaultDatabaseType!private!types! !
!GlorpIntegerTest categoriesFor: #testInteger!private!tests! !

GlorpNumeric52Test guid: (GUID fromString: '{24DCA9AF-E1AE-452D-987E-6C3D5F65F7FE}')!
GlorpNumeric52Test comment: ''!
!GlorpNumeric52Test categoriesForClass!Unclassified! !
!GlorpNumeric52Test methodsFor!

defaultDatabaseType
	^(self platform numeric)
		precision: 5;
		scale: 2.!

testNumeric52
	self platform supportsVariableSizedNumerics ifFalse: [^self].
	self helpTestFloat: nil.
	self helpTestFloat: 12.
	self helpTestFloat: 321.12.
	self helpTestInvalidValue: 17.098.
	self helpTestFloat: 3.14.
	self helpTestFloat: (Dialect coerceToDoublePrecisionFloat: 12).
	self helpTestFloat: (Dialect coerceToDoublePrecisionFloat: 321.12).
	self helpTestInvalidValue: (Dialect coerceToDoublePrecisionFloat: 17.098).
	self helpTestFloat: (Dialect coerceToDoublePrecisionFloat: 3.14).
	self helpTestFloat: (Dialect readFixedPointFrom: '321.12').
	self helpTestInvalidValue: (Dialect readFixedPointFrom: '321.123').
	self helpTestFloat: (Dialect readFixedPointFrom: '3.14').
	self helpTestFloat: (Dialect readFixedPointFrom: '3.1' ).! !
!GlorpNumeric52Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpNumeric52Test categoriesFor: #testNumeric52!private!tests! !

GlorpNumeric5Test guid: (GUID fromString: '{8A3AC9B3-FFC1-4371-8556-247F2EA4684C}')!
GlorpNumeric5Test comment: ''!
!GlorpNumeric5Test categoriesForClass!Unclassified! !
!GlorpNumeric5Test methodsFor!

defaultDatabaseType
	^self platform numeric scale: 5.!

testNumeric5

	| fixed |

	self platform supportsVariableSizedNumerics ifFalse: [^self].

	self helpTestFloat: nil.
	self helpTestFloat: 12.
	self helpTestFloat: 10991.
	self helpTestFloat: (Dialect readFixedPointFrom: '3.0').
	fixed := Dialect readFixedPointFrom: '321.12'.
	self platform supportsDecimalsOnAllNumerics
		ifTrue: [
			self helpTestFloat: fixed.
			self helpTestFloat: 3.14]
		ifFalse: [
			self helpTestInvalidValue: fixed.
			self helpTestInvalidValue: 3.14].! !
!GlorpNumeric5Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpNumeric5Test categoriesFor: #testNumeric5!private!tests! !

GlorpNumeric5ZeroTest guid: (GUID fromString: '{F88DB917-039F-4BB0-A1EC-1057AFF24D94}')!
GlorpNumeric5ZeroTest comment: ''!
!GlorpNumeric5ZeroTest categoriesForClass!Unclassified! !
!GlorpNumeric5ZeroTest methodsFor!

defaultDatabaseType
	^self platform numeric precision: 5; scale: 0.!

testNumeric5Zero
	self platform supportsVariableSizedNumerics ifFalse: [^self].

	self helpTestFloat: nil.
	self helpTestFloat: 12.	
	self helpTestFloat: 10991.		
	self helpTestFloat: (Dialect coerceToDoublePrecisionFloat: 3.0).
	self helpTestInvalidValue: (Dialect coerceToDoublePrecisionFloat: 321.12).
	self helpTestFloat: (Dialect readFixedPointFrom: '3.0').
	self helpTestInvalidValue: (Dialect readFixedPointFrom: '321.12').
	self helpTestInvalidValue: 3.14.! !
!GlorpNumeric5ZeroTest categoriesFor: #defaultDatabaseType!private!tests! !
!GlorpNumeric5ZeroTest categoriesFor: #testNumeric5Zero!private!tests! !

GlorpNumericTest guid: (GUID fromString: '{20673EAA-55E3-46D7-B055-665834C4C3EC}')!
GlorpNumericTest comment: ''!
!GlorpNumericTest categoriesForClass!Unclassified! !
!GlorpNumericTest methodsFor!

defaultDatabaseType
	"DB2 default precision is only 5, which needs to be increased for this test."

	^self platform isDB2Platform
		ifTrue: [self platform numeric precision: 10]
		ifFalse: [self platform numeric]!

testNumeric
	| floatSelector |
	self helpTestFloat: 12.	
	self helpTestFloat: nil.
	self helpTestFloat: (Dialect readFixedPointFrom: '12345678').
	self platform supportsDecimalsOnAllNumerics ifTrue: [
		self helpTestValue: 3.14  compareWith: [:read :original |
			read - original <= 0.00001]]
		ifFalse: [self helpTestInvalidValue: 3.14].
	floatSelector := self platform supportsDecimalsOnAllNumerics ifTrue: [#helpTestFloat:] ifFalse: [#helpTestInvalidValue:].
	self perform: floatSelector with: (Dialect coerceToDoublePrecisionFloat:  321.12).
	self perform: floatSelector with: (Dialect coerceToDoublePrecisionFloat: 321.123).
	self perform: floatSelector with: (Dialect coerceToDoublePrecisionFloat: (Dialect readFixedPointFrom: '321.123456789')).
	self perform: floatSelector with: (Dialect coerceToDoublePrecisionFloat: 3.14).
	self perform: floatSelector with: (Dialect coerceToDoublePrecisionFloat: 3.1).
	self perform: floatSelector with: (Dialect readFixedPointFrom:  '321.12').
	self perform: floatSelector with: (Dialect readFixedPointFrom: '321.123').
	self perform: floatSelector with: (Dialect readFixedPointFrom: '3.14').
	self perform: floatSelector with: (Dialect readFixedPointFrom: '3.1').! !
!GlorpNumericTest categoriesFor: #defaultDatabaseType!public!types! !
!GlorpNumericTest categoriesFor: #testNumeric!private!tests! !

GlorpTimestampTest guid: (GUID fromString: '{ABC83746-5F3C-4590-A027-35155D94DC4E}')!
GlorpTimestampTest comment: ''!
!GlorpTimestampTest categoriesForClass!Unclassified! !
!GlorpTimestampTest methodsFor!

compareTime: read to: original
	"GNU Smalltalk seems to be quite lone in following the ANSI standard..."

	| zeroDuration max min |
	"MS SQL Server fails randomly because it has a resolution of 3 ms only."
	session platform isSQLServerPlatform
		ifTrue:
			[max := original addMilliseconds: 3.
			min := original addMilliseconds: -3.
			^read between: min and: max].	"Otherwise"
	^session platform supportsMillisecondsInTimes
		ifTrue: [read = original]
		ifFalse: [read = original or: [read = (original addMilliseconds: -1 * original milliseconds)]]!

defaultDatabaseType
	^self platform timestamp!

testTimeStamp
	"This has to be UTC because postgres has time zones and will try and compensate"

	| time |
	time := Dialect timestampNow.
	session platform supportsMillisecondsInTimes ifFalse: [time millisecond: 0].
	self helpTestValue: nil.
	self
		helpTestValue: time
		compareWith:
			[:read :original | 
			"MS SQL Server fails randomly because it has a resolution of 3 ms only."
			"GNU Smalltalk seems to be quite lone in following the ANSI standard..."
			self compareTime: read to: original]!

testTimeStampBetweenAnd
	| record time newRecord |
	session system: (GlorpDemoDescriptorSystem forPlatform: session platform).
	self
		inTransactionDo:
			[record := (GlorpRecordWithUpdateTime new)
				id: 12;
				name: 'thing'.
			session modify: record in: [].
			session reset.
			record := session readOneOf: GlorpRecordWithUpdateTime.
			time := record updateTime.
			session reset.
			newRecord := session
				readOneOf: GlorpRecordWithUpdateTime
				where:
					[:each | 
					each updateTime
						between: (time subtractSeconds: 1)
						and: (time addSeconds: 1)].
			self assert: newRecord id = record id.].!

testTimeStampCast
	"SQLite does not have time-related types:  they are all mapped to strings.  I have not debugged why this test fails yet but assume it is completely unrealistic to expect a string to be cast to a timestamp."

	| timestamp model |
	timestamp := Dialect timestampNow.
	timestamp millisecond: 0.
	session transact: [session register: (GlorpTypeTestsModelClass new test: timestamp)].
	model := session
		readOneOf: GlorpTypeTestsModelClass
		where: [:each | (each test cast: session platform timestamp) = timestamp].
	self deny: model isNil description: 'This test will fail on SQLite which has no DB Timestamp type;  see test comment'.
	self assert: (self compareTime: model test to: timestamp).
	model := session
		readOneOf: GlorpTypeTestsModelClass
		where: [:each | (each test cast: session platform date) = timestamp].
	self deny: model isNil.
	self assert: (self compareTime: model test to: timestamp).

	model := session readOneOf: GlorpTypeTestsModelClass where: [:each | each test asTimestamp = timestamp].
	self deny: model isNil.
	self assert: (self compareTime: model test to: timestamp)!

testTimeStampCompare
	| record time newRecord |
	session system: (GlorpDemoDescriptorSystem forPlatform: session platform).
	self
		inTransactionDo:
			[record := (GlorpRecordWithUpdateTime new)
				id: 12;
				name: 'thing'.
			session modify: record in: [].
			session reset.
			record := session readOneOf: GlorpRecordWithUpdateTime.
			time := record updateTime.
			session reset.
			newRecord := session
				readOneOf: GlorpRecordWithUpdateTime
				where:
					[:each | 
						(each updateTime > (time subtractSeconds: 1))
						& (each updateTime < (time addSeconds: 1))].
			self assert: newRecord id = record id].! !
!GlorpTimestampTest categoriesFor: #compareTime:to:!public!tests! !
!GlorpTimestampTest categoriesFor: #defaultDatabaseType!private!types! !
!GlorpTimestampTest categoriesFor: #testTimeStamp!public!tests! !
!GlorpTimestampTest categoriesFor: #testTimeStampBetweenAnd!private!tests! !
!GlorpTimestampTest categoriesFor: #testTimeStampCast!public!tests! !
!GlorpTimestampTest categoriesFor: #testTimeStampCompare!private!tests! !

GlorpTimeTest guid: (GUID fromString: '{CEB44108-9B69-4776-9236-5E7D35211658}')!
GlorpTimeTest comment: ''!
!GlorpTimeTest categoriesForClass!Unclassified! !
!GlorpTimeTest methodsFor!

defaultDatabaseType
	^self platform time!

testTime
	self helpTestValue: nil.
	self
		helpTestValue: Time now
		compareWith:
			[:read :original | 
			(read hours = original hours and: [read minutes = original minutes])
				and: [read seconds truncated = original seconds truncated]].! !
!GlorpTimeTest categoriesFor: #defaultDatabaseType!private!types! !
!GlorpTimeTest categoriesFor: #testTime!private!tests! !

GlorpVarchar10Test guid: (GUID fromString: '{B835F9A0-95A6-4589-903E-B92D9D85C073}')!
GlorpVarchar10Test comment: ''!
!GlorpVarchar10Test categoriesForClass!Unclassified! !
!GlorpVarchar10Test methodsFor!

defaultDatabaseType
	^self platform varchar: 10.!

testVarCharWithEscapedCharacters
	stType := String.
	self helpTestValue: nil.
	#($\ $~ $` $!! $@ $# $$ $% $^ $& $* $( $) $_ $- $+ $= $| $} ${ $] $[ $" $' $: $; $? $/ $> $. $< $,)
		do: [:ea | self helpTestValue: 'abc' , (String with: ea) , 'def']! !
!GlorpVarchar10Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpVarchar10Test categoriesFor: #testVarCharWithEscapedCharacters!private!tests! !

GlorpVarchar1Test guid: (GUID fromString: '{DC63F792-2406-438C-BB37-0FBF88878B4E}')!
GlorpVarchar1Test comment: ''!
!GlorpVarchar1Test categoriesForClass!Unclassified! !
!GlorpVarchar1Test methodsFor!

defaultDatabaseType
	^self platform varchar: 1.!

testBooleanToTFString

	stType := Boolean.
	self helpTestValue: nil.
	self helpTestValue: true.
	self helpTestValue: false.! !
!GlorpVarchar1Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpVarchar1Test categoriesFor: #testBooleanToTFString!private!tests! !

GlorpVarchar2Test guid: (GUID fromString: '{BF121E21-5B4D-47B4-98D1-195E52F135B5}')!
GlorpVarchar2Test comment: ''!
!GlorpVarchar2Test categoriesForClass!Unclassified! !
!GlorpVarchar2Test methodsFor!

defaultDatabaseType
	^self platform varchar: 2.!

testVarChar2
	stType := String.
	self helpTestValue: nil.
	self helpTestValue: '' compareWith: [:read :original |
		self platform usesNullForEmptyStrings ifTrue: [read = nil] ifFalse: [read = original]].
	self helpTestValue: 'a'.
	self helpTestValue: 'ab'.
	self helpTestInvalidValue: 'abc'.
	self helpTestInvalidValue: 'abcd'.
	self helpTestInvalidValue: 'abcde'.! !
!GlorpVarchar2Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpVarchar2Test categoriesFor: #testVarChar2!private!tests! !

GlorpVarchar4Test guid: (GUID fromString: '{E1E93243-87D8-4970-BB8F-BE9F67F84716}')!
GlorpVarchar4Test comment: ''!
!GlorpVarchar4Test categoriesForClass!Unclassified! !
!GlorpVarchar4Test methodsFor!

defaultDatabaseType
	^self platform varchar: 4.!

testVarChar4
	stType := String.
	self helpTestValue: nil.
	self helpTestValue: '' compareWith: [:read :original |
		self platform usesNullForEmptyStrings ifTrue: [read = nil] ifFalse: [read = original]].
	self helpTestValue: 'a'.
	self helpTestValue: 'ab'.
	self helpTestValue: 'abc'.
	self helpTestValue: 'abcd'.
	stType := Symbol.
	self helpTestValue: #abcd.
	stType := nil.
	self helpTestInvalidValue: 'abcde'.! !
!GlorpVarchar4Test categoriesFor: #defaultDatabaseType!private!types! !
!GlorpVarchar4Test categoriesFor: #testVarChar4!private!tests! !

GlorpBlobTest guid: (GUID fromString: '{6ACE2186-D6CC-4AB9-B35F-9B3CF7BE7105}')!
GlorpBlobTest comment: ''!
!GlorpBlobTest categoriesForClass!Unclassified! !
!GlorpBlobTest methodsFor!

adjustForMaximumSize: anObject
	^anObject.!

blob255
	^ByteArray withAll: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255)!

defaultDatabaseType
	^self platform blob.!

largeBlob
	"Make a significant sized blob. 64k+ a bit should do"
	| blobStream |
	blobStream := WriteStream on: (ByteArray new: 10000).
	(((2 raisedTo: 16) + 100.0) / 255.0) ceiling timesRepeat: [
		blobStream nextPutAll: self blob255].
	^blobStream contents.!

mediumlargeBlob
	"Make a Blob just under 32K in size"
	"self new mediumlargeBlob"
	| blobStream |
	blobStream := WriteStream on: (ByteArray new: 10000).
	(((2 raisedTo: 15) - 600.0) / 255.0) ceiling timesRepeat: [
		blobStream nextPutAll: self blob255].
	^blobStream contents.!

testBlob
	self helpTestValue: nil.
	self helpTestValue: (ByteArray withAll: #(1 2 3 4 255)).
	stType := String.
	self helpTestValue: 'abcdef'.!

testBlobWithSubstring
	"Test our ability to query with substring against a blob. This is severely limited in Postgresql, and may be limited in others.
	The compare blocks once looked clean, like this:
		[:each | (each test copyFrom: 1 to: 3) = 'hgf'].
	but the DB2 compare blocks would need to look like this:
		[:each | (each test copyFrom: 1 to: 3) like: 'hgf'].
	Rather than duplicate the blocks, the operator was switched to:
		[:each | (each test copyFrom: 1 to: 3) perform: compare with: 'hgf'].
	which results in the desired SQL, although in code it looks unpleasant."

	| result system compare |
	session platform supportsStringQueryOnBlobs ifFalse: [^self knownFailure].
	compare := session platform isDB2Platform
		ifTrue: [ #like: ]
		ifFalse: [ #= ].
	stType := String.
	self inTransactionDo: [
		system := self systemFor: table.
		session system: system.
		session inUnitOfWorkDo: [
			| model |
			model := GlorpTypeTestsModelClass new test: 'hgfedcbazyx'.
			session register: model].
		session reset.
		result := session read: GlorpTypeTestsModelClass where: [:each | (each test copyFrom: 1 to: 3) perform: compare with: 'hgf'].
		self assert: result size = 1.
		result := session read: GlorpTypeTestsModelClass where: [:each | (each test copyFrom: 1 to: 3) perform: compare with: 'abc'].
		self assert: result size = 0.
		result := session read: GlorpTypeTestsModelClass where: [:each | (each test copyFrom: 4 to: 6) perform: compare with: 'edc'].
		self assert: result size = 1.
		result := session read: GlorpTypeTestsModelClass where: [:each | (each test copyFrom: 7 to: 9) perform: compare with: 'baz'].
		self assert: result size = 1.

		result := session read: GlorpTypeTestsModelClass where: [:each | (each test copyFrom: 1 to: 6) perform: compare with: 'hgfedc'].
		self assert: result size = 1].!

testDefaultBlobPrinting
	"Test out default (SQL-92 syntax) byte array printing"
	| stream |
	stream := WriteStream on: String new.
	type := type copy.
	type platform: DatabasePlatform new.
	type print: (ByteArray with: 0) on: stream.
	self assert: stream contents = 'X''00'''.
	stream reset.
	type print: (ByteArray with: 16rFF) on: stream.
	self assert: stream contents = 'X''FF'''.
	stream reset.
	type print: (ByteArray with: 16r47) on: stream.
	self assert: stream contents = 'X''47'''.
	stream reset.
	type print: (ByteArray withAll: #(1 2 16rFE)) asByteArray on: stream.
	self assert: stream contents = 'X''0102FE'''.!

testLargeBlob
	| blob |
	blob := self mediumlargeBlob.
	(session platform useBinding not and: [blob size > session platform maximumQueryValueSize])
		ifTrue: [Transcript cr; show: '******* Skipping large unbound blob test']
		ifFalse: [self helpTestValue: blob].
	blob := self largeBlob.
	(session platform useBinding not and: [blob size > session platform maximumQueryValueSize])
		ifFalse: [self helpTestValue: blob].! !
!GlorpBlobTest categoriesFor: #adjustForMaximumSize:!private!tests! !
!GlorpBlobTest categoriesFor: #blob255!private!tests! !
!GlorpBlobTest categoriesFor: #defaultDatabaseType!private!types! !
!GlorpBlobTest categoriesFor: #largeBlob!private!tests! !
!GlorpBlobTest categoriesFor: #mediumlargeBlob!private!tests! !
!GlorpBlobTest categoriesFor: #testBlob!private!tests! !
!GlorpBlobTest categoriesFor: #testBlobWithSubstring!public!tests! !
!GlorpBlobTest categoriesFor: #testDefaultBlobPrinting!private!tests! !
!GlorpBlobTest categoriesFor: #testLargeBlob!private!tests! !

GlorpClobTest guid: (GUID fromString: '{5C2CFC11-57FB-44CC-8348-3900BDB29F4C}')!
GlorpClobTest comment: ''!
!GlorpClobTest categoriesForClass!Unclassified! !
!GlorpClobTest methodsFor!

defaultDatabaseType
	^self platform clob.!

longString
	"Make a significant sized stringlob. 64k+ a bit should do"
	| stream |
	stream := WriteStream on: (String new: 10000).
	(((2 raisedTo: 16) + 100.0) / 255.0) ceiling timesRepeat: [
		stream nextPutAll: self string255].
	^stream contents.!

string255
	^'abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstu'.!

testClob
	self helpTestValue: nil.
	self helpTestValue: 'abcdef'.!

testLargeClob
	"The long test here not only fails, it messes up the driver so that other tests fail"
	(session platform class == AccessPlatform and: [session useBinding not])
		ifTrue: [^self].
	self helpTestValue: self longString.! !
!GlorpClobTest categoriesFor: #defaultDatabaseType!private!types! !
!GlorpClobTest categoriesFor: #longString!private!tests! !
!GlorpClobTest categoriesFor: #string255!private!tests! !
!GlorpClobTest categoriesFor: #testClob!private!tests! !
!GlorpClobTest categoriesFor: #testLargeClob!private!tests! !

GlorpTextTest guid: (GUID fromString: '{9201A2EF-E781-434E-A1F1-FA90EF68D436}')!
GlorpTextTest comment: ''!
!GlorpTextTest categoriesForClass!Unclassified! !
!GlorpTextTest methodsFor!

defaultDatabaseType
	^self platform text!

longString
	"Make a significant sized stringlob. 64k+ a bit should do"
	| stream |
	stream := WriteStream on: (String new: 10000).
	(((2 raisedTo: 16) + 100.0) / 255.0) ceiling timesRepeat: [
		stream nextPutAll: self string255].
	^stream contents.!

string255
	^'abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstu'.!

testLargeText
	"For Access, the long test here not only fails, it messes up the driver so that other tests fail"
	(session platform class == AccessPlatform and: [session useBinding not])
		ifTrue: [^self].
	self helpTestValue: self longString.!

testSymbol
	"Test that we can store a Symbol as text. This is particularly interesting because then we have to go through a non-empty type converter, and those need to take into account that text type, although a string type, probably doesn't have a maximum width."
	stType := Symbol.
	self helpTestValue: #'ASymbolStoredAsText'.!

testText
"	self helpTestValue: nil."
	self helpTestValue: 'Now is the time for all good squeakers to come to the aid of the mouse'.! !
!GlorpTextTest categoriesFor: #defaultDatabaseType!private!types! !
!GlorpTextTest categoriesFor: #longString!private!tests! !
!GlorpTextTest categoriesFor: #string255!private!tests! !
!GlorpTextTest categoriesFor: #testLargeText!private!tests! !
!GlorpTextTest categoriesFor: #testSymbol!private!tests! !
!GlorpTextTest categoriesFor: #testText!private!tests! !

"Binary Globals"!

