| package |
package := Package name: 'GlorpDatabaseTypes'.
package paxVersion: 1;
	basicComment: 'This package contains the different database types that Glorp has, for all of the different databases.

This is part of the GLORP system, an open-source library (LGPL(S)) for persisting Smalltalk objects in relational databases. For more information see the #notice property, the accompanying files and/or the web sites http://www.glorp.org or http://www.sourceforge.net/projects/glorp 
'.

package basicPackageVersion: 'image'.


package classNames
	add: #DB2IdentityType;
	add: #GlorpAbstractIntegerType;
	add: #GlorpAbstractNumericType;
	add: #GlorpAbstractStringType;
	add: #GlorpBlobType;
	add: #GlorpBooleanType;
	add: #GlorpCharType;
	add: #GlorpClobType;
	add: #GlorpDatabaseType;
	add: #GlorpDatabaseTypesPackage;
	add: #GlorpDateType;
	add: #GlorpDoubleType;
	add: #GlorpFloatType;
	add: #GlorpInMemorySequenceDatabaseType;
	add: #GlorpIntegerType;
	add: #GlorpMSSQLFloatType;
	add: #GlorpMSSQLSysnameType;
	add: #GlorpMySQLClobType;
	add: #GlorpNumericType;
	add: #GlorpPGTimeWithTimeZoneType;
	add: #GlorpSerialType;
	add: #GlorpSmallIntType;
	add: #GlorpTextType;
	add: #GlorpTimeStampType;
	add: #GlorpTimeType;
	add: #GlorpVarBinaryType;
	add: #GlorpVarCharType;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: 'GlorpExpressions';
	add: 'GlorpMisc';
	yourself).

package!

"Class Definitions"!

Object subclass: #GlorpDatabaseType
	instanceVariableNames: 'platform selector typeString'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpDatabaseTypesPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseType subclass: #GlorpAbstractNumericType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseType subclass: #GlorpAbstractStringType
	instanceVariableNames: 'width queryType'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseType subclass: #GlorpBlobType
	instanceVariableNames: 'queryType'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseType subclass: #GlorpBooleanType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseType subclass: #GlorpDateType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseType subclass: #GlorpInMemorySequenceDatabaseType
	instanceVariableNames: 'representationType'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'count'!
GlorpDatabaseType subclass: #GlorpMSSQLSysnameType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseType subclass: #GlorpPGTimeWithTimeZoneType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseType subclass: #GlorpTimeStampType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseType subclass: #GlorpTimeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseType subclass: #GlorpVarBinaryType
	instanceVariableNames: 'width'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpAbstractNumericType subclass: #GlorpAbstractIntegerType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpAbstractNumericType subclass: #GlorpDoubleType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpAbstractNumericType subclass: #GlorpFloatType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpAbstractNumericType subclass: #GlorpMSSQLFloatType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpAbstractNumericType subclass: #GlorpNumericType
	instanceVariableNames: 'precision scale'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpAbstractIntegerType subclass: #GlorpIntegerType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpAbstractIntegerType subclass: #GlorpSerialType
	instanceVariableNames: 'generated sequence'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpAbstractIntegerType subclass: #GlorpSmallIntType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSerialType subclass: #DB2IdentityType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpAbstractStringType subclass: #GlorpCharType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpAbstractStringType subclass: #GlorpClobType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpAbstractStringType subclass: #GlorpTextType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpAbstractStringType subclass: #GlorpVarCharType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpClobType subclass: #GlorpMySQLClobType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

GlorpDatabaseType guid: (GUID fromString: '{202EF20C-E0FE-481C-9D80-FD0D0E253443}')!
GlorpDatabaseType comment: 'This is an abstract superclass for objects representing types in the database. Each one will correspond to a particular simple type that we can store and retrieve from the database. e.g. int, varchar, and so on. For types that are variable sizes, different instances may represent, e.g. varchar(5) vs. varchar(20). While the classes may be reused across different databases, a database platform is expected to be able to return the types that it knows about as instances of these clasess. So you can send #varchar to OraclePlatform and get back one of these.

Subclasses must implement the following messages:
	exdi specific
		exdiType

Instance Variables
	platform	<DatabasePlatform>	The platform that owns us.
	typeString	<String>	Our name in the database.
	selector <Symbol> The name of the message we can send to the platform to get ourselves or an equivalent type back again.

'!
!GlorpDatabaseType categoriesForClass!Unclassified! !
!GlorpDatabaseType methodsFor!

= aType
	^self basicEquals: aType.!

basicEquals: aType
	self class == aType class ifFalse: [^false].
	self platform == aType platform ifFalse: [^false].
	self typeString = aType typeString ifFalse: [^false].
	^true.!

converterForStType: aClass

	^self platform nullConverter.!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	self subclassResponsibility.!

generatesOverExistingValues
	"Do we generate our value even if there's alread one present in the field"

	^false.!

glorpPrintSelectSQLOn: aCommand
	self printSelectSQLOn: aCommand withParameters: #().!

glorpPrintSQLOn: aCommand
	aCommand nextPutAll: self typeString.!

hash
	^self platform hash bitXor: self typeString hash!

hasParameters
	"Return true if this has modifiable parameters. That is, when we return one of these, should we return a copy rather than trying to save space be re-using instances"
	^false.!

hasSequence
	^false.!

hasWidth
	"Return true if this type has a width attribute - basically meaning it's a string or LOB type. Note that this is different from the isVariableWidth test, which tells us if a field has fixed vs. varying width. So a CHAR field hasWidth=>true, but isVariableWidth=>false, while a VARCHAR field hasWidth=>true isVariableWidth=>false, and a NUMBER has both false."
	^false.!

impliedSmalltalkType
	"Return the Smalltalk type which most commonly corresponds to our database type. By default, Object if we don't have any more specific information."
	^Object.!

initialize!

initializeForField: aDatabaseField in: aDescriptorSystem!

isGenerated

	^false!

isIdentityColumn
	^false.!

isSerial
	"answer if this is a database-generated primary key column"

	^false!

isStringType
	"Return true if the type of values this stores are strings"
	^false.!

isVariable
	^false.!

isVariableWidth
	"Return true if this type allows varying length data within a particular instance. e.g., this is true for a varchar, but false for a fixed size character field"
	^false.!

platform

	^platform!

platform: aDatabasePlatform

	platform := aDatabasePlatform.!

postWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow!

postWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: aSession!

precision: anInteger

	^self error: ((self class name asString), ' is not a variable precision type.')!

preWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: anAccessor
	aDatabaseField defaultValue isNil ifTrue: [^self].
	(aDatabaseRow hasValueFor: aDatabaseField) ifTrue: [^self].
	"Default values will not write if this field is constrained to a primary key generator"
	(aDatabaseRow expectsToGetValueFor: aDatabaseField) ifTrue: [^self].
	aDatabaseRow at: aDatabaseField put: (aDatabaseField defaultValue).!

print: aValue on: aStream
	aValue glorpPrintSQLOn: aStream.!

printCollection: aCollection on: aStream
	aCollection glorpPrintSQLOn: aStream for: self.!

printNullCastOn: aStream
	"Some platforms, eg., DB2, need to cast NULL for collections, as in
	SELECT ... WHERE ... IN (CAST(NULL AS type))."
	
	| expr |
	expr := FunctionExpression
		for: #cast:
		withArguments: (Array with: (ConstantExpression for: self))
		basedOn: (ConstantExpression for: nil).
	expr printSelectSQLOn: aStream withParameters: #()!

printSelectSQLOn: aCommand withParameters: aDictionary
	aCommand nextPutAll: self typeString.!

queryType
	"If we can't pass this type in as an argument to a query (e.g. a blob) then return a type we can use instead"
	^self.!

requiresCast
	^false.!

requiresConvertToVarbinary
	"This is a hack for testing against SQL Server"
	^false.!

scale: anInteger

	^self error: ((self class name asString), ' is not a variable scale type.')!

selector
	^selector!

selector: aSymbol
	selector := aSymbol!

sequence
	^nil!

size: anInteger

	^self error: ((self class name asString), ' is not a variable sized type.')!

typeName
	"An alias that can be used to print the non-parameterized name"
	^typeString.!

typeString

	^typeString.!

typeString: aString

	typeString := aString!

underlyingType
	^self.! !
!GlorpDatabaseType categoriesFor: #=!comparing!private! !
!GlorpDatabaseType categoriesFor: #basicEquals:!comparing!private! !
!GlorpDatabaseType categoriesFor: #converterForStType:!converting!private! !
!GlorpDatabaseType categoriesFor: #exdiType!exdi specific!private! !
!GlorpDatabaseType categoriesFor: #generatesOverExistingValues!private!testing! !
!GlorpDatabaseType categoriesFor: #glorpPrintSelectSQLOn:!private!SQL! !
!GlorpDatabaseType categoriesFor: #glorpPrintSQLOn:!private!SQL! !
!GlorpDatabaseType categoriesFor: #hash!comparing!private! !
!GlorpDatabaseType categoriesFor: #hasParameters!private!testing! !
!GlorpDatabaseType categoriesFor: #hasSequence!private!testing! !
!GlorpDatabaseType categoriesFor: #hasWidth!private!testing! !
!GlorpDatabaseType categoriesFor: #impliedSmalltalkType!converting!private! !
!GlorpDatabaseType categoriesFor: #initialize!initialize!private! !
!GlorpDatabaseType categoriesFor: #initializeForField:in:!initialize!private! !
!GlorpDatabaseType categoriesFor: #isGenerated!private!testing! !
!GlorpDatabaseType categoriesFor: #isIdentityColumn!private!testing! !
!GlorpDatabaseType categoriesFor: #isSerial!private!testing! !
!GlorpDatabaseType categoriesFor: #isStringType!private!testing! !
!GlorpDatabaseType categoriesFor: #isVariable!private!testing! !
!GlorpDatabaseType categoriesFor: #isVariableWidth!private!testing! !
!GlorpDatabaseType categoriesFor: #platform!private!SQL! !
!GlorpDatabaseType categoriesFor: #platform:!private!SQL! !
!GlorpDatabaseType categoriesFor: #postWriteAssignSequenceValueFor:in:!private!SQL! !
!GlorpDatabaseType categoriesFor: #postWriteAssignSequenceValueFor:in:using:!private!SQL! !
!GlorpDatabaseType categoriesFor: #precision:!accessing!private! !
!GlorpDatabaseType categoriesFor: #preWriteAssignSequenceValueFor:in:using:!private!SQL! !
!GlorpDatabaseType categoriesFor: #print:on:!private!SQL! !
!GlorpDatabaseType categoriesFor: #printCollection:on:!private!SQL! !
!GlorpDatabaseType categoriesFor: #printNullCastOn:!public!SQL! !
!GlorpDatabaseType categoriesFor: #printSelectSQLOn:withParameters:!private!SQL! !
!GlorpDatabaseType categoriesFor: #queryType!accessing!private! !
!GlorpDatabaseType categoriesFor: #requiresCast!private!testing! !
!GlorpDatabaseType categoriesFor: #requiresConvertToVarbinary!private!testing! !
!GlorpDatabaseType categoriesFor: #scale:!accessing!private! !
!GlorpDatabaseType categoriesFor: #selector!accessing!private! !
!GlorpDatabaseType categoriesFor: #selector:!accessing!private! !
!GlorpDatabaseType categoriesFor: #sequence!accessing!private! !
!GlorpDatabaseType categoriesFor: #size:!accessing!private! !
!GlorpDatabaseType categoriesFor: #typeName!private!SQL! !
!GlorpDatabaseType categoriesFor: #typeString!private!SQL! !
!GlorpDatabaseType categoriesFor: #typeString:!accessing!private! !
!GlorpDatabaseType categoriesFor: #underlyingType!accessing!private! !

!GlorpDatabaseType class methodsFor!

instance

	^super new!

new
	^super new initialize.!

padToThreeDigits: anInteger

	| string |
	string := anInteger truncated printString.
	string size = 3 ifTrue: [^string].
	string size = 2 ifTrue: [^'0', string].
	string size = 1 ifTrue: [^'00', string].!

padToTwoDigits: anInteger

	| string |
	string := anInteger truncated printString.
	^string size = 1 ifTrue: ['0', string] ifFalse: [string].! !
!GlorpDatabaseType class categoriesFor: #instance!instance creation!private! !
!GlorpDatabaseType class categoriesFor: #new!instance creation!private! !
!GlorpDatabaseType class categoriesFor: #padToThreeDigits:!printing!private! !
!GlorpDatabaseType class categoriesFor: #padToTwoDigits:!printing!private! !

GlorpDatabaseTypesPackage guid: (GUID fromString: '{95B01F91-B068-41C7-96BE-0F5C6E780CAB}')!
GlorpDatabaseTypesPackage comment: 'This class represents package information for the GlorpDatabaseTypes package, for systems that don''t have things like package properties to store things like copyright and license information.

LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you''ll need to release the
source of any modifications.

If you require any further clarification, we''d be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'!
!GlorpDatabaseTypesPackage categoriesForClass!Unclassified! !
!GlorpDatabaseTypesPackage class methodsFor!

LICENSE
"LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you'll need to release the
source of any modifications.

If you require any further clarification, we'd be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"! !
!GlorpDatabaseTypesPackage class categoriesFor: #LICENSE!instance creation!public! !

GlorpAbstractNumericType guid: (GUID fromString: '{1F75514B-61D4-4597-9B52-40000DEBE17D}')!
GlorpAbstractNumericType comment: ''!
!GlorpAbstractNumericType categoriesForClass!Unclassified! !
!GlorpAbstractNumericType methodsFor!

impliedSmalltalkType
	^Number.! !
!GlorpAbstractNumericType categoriesFor: #impliedSmalltalkType!converting!private! !

GlorpAbstractStringType guid: (GUID fromString: '{33512F7A-E112-4A3F-8F00-7856B80AC04C}')!
GlorpAbstractStringType comment: ''!
!GlorpAbstractStringType categoriesForClass!Unclassified! !
!GlorpAbstractStringType methodsFor!

= aType
	super = aType ifFalse: [^false].
	self width = aType width ifFalse: [^false].
	self queryType == self ifFalse: [
		self queryType = aType queryType ifFalse: [^false]].
	^true.!

converterForStType: aClass
	(aClass includesBehavior: Boolean) ifTrue: [^self platform converterNamed: #booleanToStringTF].
	(aClass includesBehavior: Symbol) ifTrue: [^self platform converterNamed: #symbolToString].
	width isNil ifFalse: [
		(aClass includesBehavior: String) ifTrue: [^self platform converterNamed: #stringToString]].
	(aClass includesBehavior: Integer) ifTrue: [^self platform converterNamed: #integerToString].
	^super converterForStType: aClass.!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#String.!

hash
	^self queryType == self
		ifTrue: [super hash bitXor: self width hash]
		ifFalse: [(super hash bitXor: self width hash) bitXor: self queryType hash]!

hasParameters
	"Return true if this has modifiable parameters. That is, when we return one of these, should we return a copy rather than trying to save space be re-using instances"
	^true.!

hasWidth
	"Return true if this type has a width attribute - basically meaning it's a string or LOB type. Note that this is different from the isVariableWidth test, which tells us if a field has fixed vs. varying width. So a CHAR field hasWidth=>true, but isVariableWidth=>false, while a VARCHAR field hasWidth=>true isVariableWidth=>false, and a NUMBER has both false."
	^true.!

impliedSmalltalkType
	^String.!

isStringType
	^true.!

isVariableWidth
	self subclassResponsibility.!

queryType
	queryType isNil ifTrue: [^self].
	^queryType.!

queryType: aType
	queryType := aType!

typeName
	^typeString.!

typeName: aString
	typeString := aString.!

typeString
	typeString isNil
		ifTrue:
			[typeString := self typeName.
			width isNil
				ifFalse: [typeString := typeString , '(' , width printString , ')']].
	^typeString.!

typeString: aString
	"If we set the typeString, we are presumably setting it to the non-parameterized name as well"
	typeString := aString.
	super typeString: aString.!

width
	^width.!

width: anInteger

	width := anInteger = 0 ifTrue: [nil] ifFalse: [anInteger]! !
!GlorpAbstractStringType categoriesFor: #=!comparing!private! !
!GlorpAbstractStringType categoriesFor: #converterForStType:!converting!private! !
!GlorpAbstractStringType categoriesFor: #exdiType!exdi specific!private! !
!GlorpAbstractStringType categoriesFor: #hash!comparing!private! !
!GlorpAbstractStringType categoriesFor: #hasParameters!private!testing! !
!GlorpAbstractStringType categoriesFor: #hasWidth!private!testing! !
!GlorpAbstractStringType categoriesFor: #impliedSmalltalkType!converting!private! !
!GlorpAbstractStringType categoriesFor: #isStringType!private!testing! !
!GlorpAbstractStringType categoriesFor: #isVariableWidth!private!testing! !
!GlorpAbstractStringType categoriesFor: #queryType!accessing!private! !
!GlorpAbstractStringType categoriesFor: #queryType:!accessing!private! !
!GlorpAbstractStringType categoriesFor: #typeName!private! !
!GlorpAbstractStringType categoriesFor: #typeName:!private! !
!GlorpAbstractStringType categoriesFor: #typeString!private!SQL! !
!GlorpAbstractStringType categoriesFor: #typeString:!private!SQL! !
!GlorpAbstractStringType categoriesFor: #width!accessing!private! !
!GlorpAbstractStringType categoriesFor: #width:!accessing!private! !

GlorpBlobType guid: (GUID fromString: '{838CE903-8FD7-45A2-9357-B5C365D96A23}')!
GlorpBlobType comment: ''!
!GlorpBlobType categoriesForClass!Unclassified! !
!GlorpBlobType methodsFor!

= aType
	super = aType ifFalse: [^false].
	self queryType == self ifTrue: [^true].
	self queryType = aType queryType
		 ifFalse: [^false].
	^true.!

converterForStType: aClass
	(aClass includesBehavior: String) ifTrue: [^self platform converterNamed: #byteArrayToString].
	self platform isPostgreSQLPlatform ifTrue: [^self platform converterNamed: #byteArrayToSQLString].
	self platform isOcelotPlatform ifTrue: [^self platform converterNamed: #blobDataToStream].
	^self platform nullConverter!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#ByteArray.!

hash
	^self queryType == self
		ifTrue: [super hash]
		ifFalse: [super hash bitXor: self queryType hash]!

impliedSmalltalkType
	^ByteArray.!

initialize
	super initialize.
	typeString := 'blob'!

print: aValue on: aStream
	self platform printBlob: (aValue isNil ifTrue: [nil] ifFalse: [aValue asByteArray]) on: aStream for: self.!

queryType
	"Return the type that we can cast an argument to in order to match against this"
	queryType isNil ifTrue: [^self].
	^queryType.!

queryType: aType
	"Set the type that we can cast an argument to in order to match against this"
	queryType := aType.!

requiresConvertToVarbinary
	"This is a hack for testing against SQL Server"
	^true.! !
!GlorpBlobType categoriesFor: #=!comparing!private! !
!GlorpBlobType categoriesFor: #converterForStType:!private!types! !
!GlorpBlobType categoriesFor: #exdiType!exdi specific!private! !
!GlorpBlobType categoriesFor: #hash!comparing!private! !
!GlorpBlobType categoriesFor: #impliedSmalltalkType!private!types! !
!GlorpBlobType categoriesFor: #initialize!initialize!private! !
!GlorpBlobType categoriesFor: #print:on:!private!SQL! !
!GlorpBlobType categoriesFor: #queryType!private!types! !
!GlorpBlobType categoriesFor: #queryType:!private!types! !
!GlorpBlobType categoriesFor: #requiresConvertToVarbinary!private!testing! !

GlorpBooleanType guid: (GUID fromString: '{ADBA8CF2-7A57-46B4-842F-7D260C372EB5}')!
GlorpBooleanType comment: ''!
!GlorpBooleanType categoriesForClass!Unclassified! !
!GlorpBooleanType methodsFor!

converterForStType: aClass
	(aClass includesBehavior: Boolean) ifTrue: [^self platform converterNamed: #booleanToBoolean].
	^self platform nullConverter.!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#Boolean.!

impliedSmalltalkType
	^Boolean.!

print: aValue on: aStream
	aStream nextPutAll: (self platform printBoolean: aValue for: self).! !
!GlorpBooleanType categoriesFor: #converterForStType:!converting!private! !
!GlorpBooleanType categoriesFor: #exdiType!exdi specific!private! !
!GlorpBooleanType categoriesFor: #impliedSmalltalkType!converting!private! !
!GlorpBooleanType categoriesFor: #print:on:!private!SQL! !

GlorpDateType guid: (GUID fromString: '{3F7606F0-D3A0-49E3-B2A1-020983D7B0D0}')!
GlorpDateType comment: ''!
!GlorpDateType categoriesForClass!Unclassified! !
!GlorpDateType methodsFor!

converterForStType: aClass

	^self platform converterNamed: #date.!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^self platform exdiTypeForDates.!

impliedSmalltalkType
	^Date.!

initialize
	super initialize.
	typeString := 'date'!

print: aValue on: aStream
	aStream nextPutAll: (self platform printDate: aValue for: self).! !
!GlorpDateType categoriesFor: #converterForStType:!converting!private! !
!GlorpDateType categoriesFor: #exdiType!exdi specific!private! !
!GlorpDateType categoriesFor: #impliedSmalltalkType!converting!private! !
!GlorpDateType categoriesFor: #initialize!initialize!private! !
!GlorpDateType categoriesFor: #print:on:!private!SQL! !

GlorpInMemorySequenceDatabaseType guid: (GUID fromString: '{A449AEB2-DDB6-4FBB-B778-CDC55FC22577}')!
GlorpInMemorySequenceDatabaseType comment: ''!
!GlorpInMemorySequenceDatabaseType categoriesForClass!Unclassified! !
!GlorpInMemorySequenceDatabaseType methodsFor!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^representationType exdiType.!

impliedSmalltalkType
	^Integer.!

isGenerated

	^true!

preWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: anAccessor

	aDatabaseRow at: aDatabaseField put: (self class next)!

representedBy: dbType

	representationType := dbType!

typeName

	^representationType typeName.!

typeString

	^representationType typeString! !
!GlorpInMemorySequenceDatabaseType categoriesFor: #exdiType!exdi specific!private! !
!GlorpInMemorySequenceDatabaseType categoriesFor: #impliedSmalltalkType!converting!private! !
!GlorpInMemorySequenceDatabaseType categoriesFor: #isGenerated!private!testing! !
!GlorpInMemorySequenceDatabaseType categoriesFor: #preWriteAssignSequenceValueFor:in:using:!private!SQL! !
!GlorpInMemorySequenceDatabaseType categoriesFor: #representedBy:!initialize-release!private! !
!GlorpInMemorySequenceDatabaseType categoriesFor: #typeName!private!SQL! !
!GlorpInMemorySequenceDatabaseType categoriesFor: #typeString!private!SQL! !

!GlorpInMemorySequenceDatabaseType class methodsFor!

next

	(count isNil)
	ifTrue: [count := 0].
	count := count + 1.
	^count!

representedBy: dbType

	^super new
		representedBy: dbType!

reset

	count := 0! !
!GlorpInMemorySequenceDatabaseType class categoriesFor: #next!accessing!private! !
!GlorpInMemorySequenceDatabaseType class categoriesFor: #representedBy:!instance creation!private! !
!GlorpInMemorySequenceDatabaseType class categoriesFor: #reset!accessing!private! !

GlorpMSSQLSysnameType guid: (GUID fromString: '{52CDEBFD-8426-4013-B7FA-2D623A8A6BD7}')!
GlorpMSSQLSysnameType comment: ''!
!GlorpMSSQLSysnameType categoriesForClass!Unclassified! !
!GlorpMSSQLSysnameType methodsFor!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#String.!

impliedSmalltalkType
	^String.!

isStringType
	^true.!

typeString

	^'sysname'.! !
!GlorpMSSQLSysnameType categoriesFor: #exdiType!exdi specific!private! !
!GlorpMSSQLSysnameType categoriesFor: #impliedSmalltalkType!converting!private! !
!GlorpMSSQLSysnameType categoriesFor: #isStringType!private!testing! !
!GlorpMSSQLSysnameType categoriesFor: #typeString!private!SQL! !

GlorpPGTimeWithTimeZoneType guid: (GUID fromString: '{38471A96-0860-4EAD-99A1-4CBF2CAD0048}')!
GlorpPGTimeWithTimeZoneType comment: ''!
!GlorpPGTimeWithTimeZoneType categoriesForClass!Unclassified! !
!GlorpPGTimeWithTimeZoneType methodsFor!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#Timestamp.!

initialize
	super initialize.
	typeString := 'TIME WITH TIME ZONE'.! !
!GlorpPGTimeWithTimeZoneType categoriesFor: #exdiType!exdi specific!private! !
!GlorpPGTimeWithTimeZoneType categoriesFor: #initialize!initialize!private! !

GlorpTimeStampType guid: (GUID fromString: '{2DAC36B7-81CA-4FF6-8A02-2DFF8EEF5FED}')!
GlorpTimeStampType comment: ''!
!GlorpTimeStampType categoriesForClass!Unclassified! !
!GlorpTimeStampType methodsFor!

converterForStType: aClass
	aClass = Date ifTrue: [^self platform converterNamed: #timestampToDate].
	^self platform converterNamed: #timestamp.!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#Timestamp.!

impliedSmalltalkType
	^Dialect timestampClass.!

print: aValue on: aStream
	self platform printTimestamp: aValue on: aStream for: self.! !
!GlorpTimeStampType categoriesFor: #converterForStType:!converting!private! !
!GlorpTimeStampType categoriesFor: #exdiType!exdi specific!private! !
!GlorpTimeStampType categoriesFor: #impliedSmalltalkType!converting!private! !
!GlorpTimeStampType categoriesFor: #print:on:!private!SQL! !

GlorpTimeType guid: (GUID fromString: '{9ED819AA-6CF7-4763-A1B8-60C64CCA56E1}')!
GlorpTimeType comment: ''!
!GlorpTimeType categoriesForClass!Unclassified! !
!GlorpTimeType methodsFor!

converterForStType: aClass

	^self platform converterNamed: #time.!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#Time.!

impliedSmalltalkType
	^Time.!

print: aValue on: aStream
	aStream nextPutAll: (self platform printTime: aValue for: self).! !
!GlorpTimeType categoriesFor: #converterForStType:!conversion-times!private! !
!GlorpTimeType categoriesFor: #exdiType!exdi specific!private! !
!GlorpTimeType categoriesFor: #impliedSmalltalkType!converting!private! !
!GlorpTimeType categoriesFor: #print:on:!private!SQL! !

GlorpVarBinaryType guid: (GUID fromString: '{798C539E-9D99-46D1-A842-33B21A94F75C}')!
GlorpVarBinaryType comment: ''!
!GlorpVarBinaryType categoriesForClass!Unclassified! !
!GlorpVarBinaryType methodsFor!

exdiType
	^#ByteArray.!

hasParameters
	"Return true if this has modifiable parameters. That is, when we return one of these, should we return a copy rather than trying to save space be re-using instances"
	^true.!

impliedSmalltalkType
	^ByteArray.!

initialize
	super initialize.
	typeString := 'varbinary'!

isVariableWidth
	"Return true if this type allows varying length data within a particular instance. e.g., this is true for a varchar, but false for a fixed size character field"
	^true.!

width
	^width.!

width: anInteger

	width := anInteger! !
!GlorpVarBinaryType categoriesFor: #exdiType!exdi specific!private! !
!GlorpVarBinaryType categoriesFor: #hasParameters!private!testing! !
!GlorpVarBinaryType categoriesFor: #impliedSmalltalkType!private!testing! !
!GlorpVarBinaryType categoriesFor: #initialize!initialize-release!private! !
!GlorpVarBinaryType categoriesFor: #isVariableWidth!private!testing! !
!GlorpVarBinaryType categoriesFor: #width!accessing!private! !
!GlorpVarBinaryType categoriesFor: #width:!accessing!private! !

GlorpAbstractIntegerType guid: (GUID fromString: '{79451294-53BF-475C-A319-75FF75BE68EB}')!
GlorpAbstractIntegerType comment: ''!
!GlorpAbstractIntegerType categoriesForClass!Unclassified! !
!GlorpAbstractIntegerType methodsFor!

converterForStType: aClass
	(aClass includesBehavior: Boolean) ifTrue: [^self platform converterNamed: #booleanToInteger].
	^self platform converterNamed: #numberToInteger.!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#Integer.!

impliedSmalltalkType
	^Integer.! !
!GlorpAbstractIntegerType categoriesFor: #converterForStType:!converting!private! !
!GlorpAbstractIntegerType categoriesFor: #exdiType!exdi specific!private! !
!GlorpAbstractIntegerType categoriesFor: #impliedSmalltalkType!converting!private! !

GlorpDoubleType guid: (GUID fromString: '{3BF821D7-0CFC-4859-88B7-9419F142BA4A}')!
GlorpDoubleType comment: ''!
!GlorpDoubleType categoriesForClass!Unclassified! !
!GlorpDoubleType methodsFor!

converterForStType: aClass

	^self platform converterNamed: #numberToDouble.!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#Double.!

impliedSmalltalkType
	^Dialect doublePrecisionFloatClass.!

initialize
	super initialize.
	typeString := 'double precision'.! !
!GlorpDoubleType categoriesFor: #converterForStType:!converting!private! !
!GlorpDoubleType categoriesFor: #exdiType!exdi specific!private! !
!GlorpDoubleType categoriesFor: #impliedSmalltalkType!converting!private! !
!GlorpDoubleType categoriesFor: #initialize!initialize!private! !

GlorpFloatType guid: (GUID fromString: '{C6669745-A4C1-491C-A721-F15DB7C9349B}')!
GlorpFloatType comment: ''!
!GlorpFloatType categoriesForClass!Unclassified! !
!GlorpFloatType methodsFor!

converterForStType: aClass

	^self platform converterNamed: #numberToFloat.!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#Float.!

impliedSmalltalkType
	^Float.!

initialize
	super initialize.
	typeString := 'float4'.! !
!GlorpFloatType categoriesFor: #converterForStType:!converting!private! !
!GlorpFloatType categoriesFor: #exdiType!exdi specific!private! !
!GlorpFloatType categoriesFor: #impliedSmalltalkType!converting!private! !
!GlorpFloatType categoriesFor: #initialize!initialize!private! !

GlorpMSSQLFloatType guid: (GUID fromString: '{684D55AC-697E-41E6-B19B-191929BD8DB6}')!
GlorpMSSQLFloatType comment: ''!
!GlorpMSSQLFloatType categoriesForClass!Unclassified! !
!GlorpMSSQLFloatType methodsFor!

converterForStType: aClass

	^self platform converterNamed: #numberToDouble.!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#Float.!

impliedSmalltalkType
	^Float.!

initialize
	super initialize.
	typeString := 'float'.!

typeString
	^'float'.! !
!GlorpMSSQLFloatType categoriesFor: #converterForStType:!private!SQL! !
!GlorpMSSQLFloatType categoriesFor: #exdiType!exdi specific!private! !
!GlorpMSSQLFloatType categoriesFor: #impliedSmalltalkType!converting!private! !
!GlorpMSSQLFloatType categoriesFor: #initialize!initialize!private! !
!GlorpMSSQLFloatType categoriesFor: #typeString!private!SQL! !

GlorpNumericType guid: (GUID fromString: '{68126CCE-0ECC-4EA6-8327-9E48F5EF327F}')!
GlorpNumericType comment: ''!
!GlorpNumericType categoriesForClass!Unclassified! !
!GlorpNumericType methodsFor!

= aType

	"We do a special case check here that something that reads back as numeric with no scale/precision counts as being the same as an integer type"
	((aType class == self platform integer class) and: [self isIntegerType]) ifTrue: [^true].
	super = aType ifFalse: [^false].
	self precision = aType precision ifFalse: [^false].
	self scale = aType scale ifFalse: [^false].
	^true.!

converterForStType: aClass
	(aClass includesBehavior: Boolean) ifTrue: [^self platform converterNamed: #booleanToInteger].
	^self platform converterNamed: #numberToNumber.!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"

	"Can we do better than this??"
	^#FixedPoint!

hash
	"A very special case here, if we're effectively an Integer, then we need to hash in a way compatible with GlorpIntegerType"
	self isIntegerType ifTrue: [^self platform hash bitXor: self impliedSmalltalkType hash].
	^(super hash bitXor: self precision hash) bitXor: self scale hash!

hasParameters
	"Return true if this has modifiable parameters. That is, when we return one of these, should we return a copy rather than trying to save space be re-using instances"
	^true.!

impliedSmalltalkType
	self isIntegerType ifTrue: [^Integer].
	^super impliedSmalltalkType!

initialize
	super initialize.
	typeString := 'numeric'.!

isIntegerType
	"If we have no precision and no scale, we're effectively an Integer"
	^self precision isNil and: [self scale isNil]!

precision
	^precision.!

precision: anInteger

	precision := anInteger.!

scale
	^scale.!

scale: anInteger

	scale := anInteger.!

typeString
	| w |
	platform supportsVariableSizedNumerics ifFalse: [^typeString].
	w := WriteStream on: String new.
	w nextPutAll: typeString.
	precision isNil 
		ifFalse: 
			[w nextPutAll: '(' , precision printString.
			scale isNil ifFalse: [w nextPutAll: ',' , scale printString].
			w nextPutAll: ')'].
	^w contents! !
!GlorpNumericType categoriesFor: #=!comparing!private! !
!GlorpNumericType categoriesFor: #converterForStType:!converting!private! !
!GlorpNumericType categoriesFor: #exdiType!exdi specific!private! !
!GlorpNumericType categoriesFor: #hash!comparing!private! !
!GlorpNumericType categoriesFor: #hasParameters!private!testing! !
!GlorpNumericType categoriesFor: #impliedSmalltalkType!converting!private! !
!GlorpNumericType categoriesFor: #initialize!initialize!private! !
!GlorpNumericType categoriesFor: #isIntegerType!private!testing! !
!GlorpNumericType categoriesFor: #precision!accessing!private! !
!GlorpNumericType categoriesFor: #precision:!accessing!private! !
!GlorpNumericType categoriesFor: #scale!accessing!private! !
!GlorpNumericType categoriesFor: #scale:!accessing!private! !
!GlorpNumericType categoriesFor: #typeString!private!SQL! !

GlorpIntegerType guid: (GUID fromString: '{B5C7E298-DD8A-480E-9577-FDB83C6FCDA2}')!
GlorpIntegerType comment: ''!
!GlorpIntegerType categoriesForClass!Unclassified! !
!GlorpIntegerType methodsFor!

= aType
	(aType class == self platform numeric class and: [aType isIntegerType]) ifTrue: [^true].
	^super = aType!

hash
	"Our hash must be identical to GlorpNumericType's hash when it is an #isInteger"
	^self platform hash bitXor: self impliedSmalltalkType hash!

initialize
	super initialize.
	typeString := 'integer'.! !
!GlorpIntegerType categoriesFor: #=!comparing!private! !
!GlorpIntegerType categoriesFor: #hash!comparing!private! !
!GlorpIntegerType categoriesFor: #initialize!initialize!private! !

GlorpSerialType guid: (GUID fromString: '{0CC0F6F0-39A1-45CB-BD96-87B9DC8972E1}')!
GlorpSerialType comment: ''!
!GlorpSerialType categoriesForClass!Unclassified! !
!GlorpSerialType methodsFor!

hasParameters
	^true.!

hasSequence
	^true.!

initialize
	super initialize.
	generated := true.!

initializeForField: aDatabaseField in: aDescriptorSystem
	sequence isNil ifFalse: [^self].
	sequence := aDescriptorSystem databaseSequenceNamed: (aDescriptorSystem sequenceNameForField: aDatabaseField).
	sequence schema: aDatabaseField table schema.!

isGenerated
	"answer if we should autogenerate a value for this type, i.e. if it is a database-generated primary key column"

	^generated!

isIdentityColumn
	^self sequence isIdentityColumn.!

isSerial
	"answer if this is a database-generated primary key column"

	^true!

postWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: anAccessor

	^sequence postWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: anAccessor.!

preWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: anAccessor

	^sequence preWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: anAccessor.!

printSelectSQLOn: aCommand withParameters: aDictionary
	"We record our type as serial, but that isn't really useful for a cast. We assume serials are integers, so just print a generic integer type instead."
	self platform integer printSelectSQLOn: aCommand withParameters: aDictionary.!

sequence
	^sequence.!

sequence: aDatabaseSequence
	sequence := aDatabaseSequence.! !
!GlorpSerialType categoriesFor: #hasParameters!accessing!private! !
!GlorpSerialType categoriesFor: #hasSequence!private!testing! !
!GlorpSerialType categoriesFor: #initialize!initialize!private! !
!GlorpSerialType categoriesFor: #initializeForField:in:!initialize!private! !
!GlorpSerialType categoriesFor: #isGenerated!accessing!private! !
!GlorpSerialType categoriesFor: #isIdentityColumn!private!testing! !
!GlorpSerialType categoriesFor: #isSerial!private!testing! !
!GlorpSerialType categoriesFor: #postWriteAssignSequenceValueFor:in:using:!private!sequencing! !
!GlorpSerialType categoriesFor: #preWriteAssignSequenceValueFor:in:using:!private!sequencing! !
!GlorpSerialType categoriesFor: #printSelectSQLOn:withParameters:!private!testing! !
!GlorpSerialType categoriesFor: #sequence!accessing!private! !
!GlorpSerialType categoriesFor: #sequence:!accessing!private! !

GlorpSmallIntType guid: (GUID fromString: '{67E345E0-9932-4E00-BD08-C05AA7C8C9F7}')!
GlorpSmallIntType comment: ''!
!GlorpSmallIntType categoriesForClass!Unclassified! !
!GlorpSmallIntType methodsFor!

initialize
	super initialize.
	typeString := 'smallint'.! !
!GlorpSmallIntType categoriesFor: #initialize!initialize!private! !

DB2IdentityType guid: (GUID fromString: '{200541AC-36E8-4552-B33D-245B01B1F01C}')!
DB2IdentityType comment: 'DB2IdentityType represents identity column types in DB2. Glorp prefers sequences over identity columns, and uses sequences when generating schemas. But since pre-exisitng DB2 tables may contain identity columns, this class is necessary. See also, DB2Sequence and DB2IdentitySequence.
'!
!DB2IdentityType categoriesForClass!Unclassified! !
!DB2IdentityType methodsFor!

initializeForField: aDatabaseField in: aDescriptorSystem

	sequence isNil ifFalse: [^self].
	sequence := aDescriptorSystem
				databaseIdentitySequenceNamed: (aDescriptorSystem sequenceNameForField: aDatabaseField).
	sequence schema: aDatabaseField table schema!

isIdentityColumn
	^true! !
!DB2IdentityType categoriesFor: #initializeForField:in:!initialize!public! !
!DB2IdentityType categoriesFor: #isIdentityColumn!public!testing! !

GlorpCharType guid: (GUID fromString: '{99F7AC1F-DC3D-4DBB-94FC-C4AACD053EF6}')!
GlorpCharType comment: ''!
!GlorpCharType categoriesForClass!Unclassified! !
!GlorpCharType methodsFor!

initialize
	super initialize.
	typeString := 'char'.!

isVariableWidth
	^false.!

typeString

	^self typeName, '(', width printString, ')'.! !
!GlorpCharType categoriesFor: #initialize!initialize!private! !
!GlorpCharType categoriesFor: #isVariableWidth!private!testing! !
!GlorpCharType categoriesFor: #typeString!accessing!private! !

GlorpClobType guid: (GUID fromString: '{44CF26F7-3CD6-441B-A9EB-01F511546172}')!
GlorpClobType comment: ''!
!GlorpClobType categoriesForClass!Unclassified! !
!GlorpClobType methodsFor!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#LargeString.!

hasParameters
	"Return true if this has modifiable parameters. That is, when we return one of these, should we return a copy rather than trying to save space be re-using instances"
	^false.!

initialize
	super initialize.
	typeString := 'text'.
	width := nil.!

isVariableWidth
	^true.!

requiresCast
	^self platform isPostgreSQLPlatform or: [self platform isSQLServerPlatform]! !
!GlorpClobType categoriesFor: #exdiType!exdi specific!private! !
!GlorpClobType categoriesFor: #hasParameters!private!testing! !
!GlorpClobType categoriesFor: #initialize!initialize!private! !
!GlorpClobType categoriesFor: #isVariableWidth!private!testing! !
!GlorpClobType categoriesFor: #requiresCast!public!testing! !

GlorpTextType guid: (GUID fromString: '{7695CF5E-BE18-4A2D-9E7E-1C35BBC45846}')!
GlorpTextType comment: ''!
!GlorpTextType categoriesForClass!Unclassified! !
!GlorpTextType methodsFor!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#LargeString.!

initialize
	super initialize.
	typeString := 'text'.!

isVariableWidth
	^true.! !
!GlorpTextType categoriesFor: #exdiType!exdi specific!private! !
!GlorpTextType categoriesFor: #initialize!initialize!private! !
!GlorpTextType categoriesFor: #isVariableWidth!private!testing! !

GlorpVarCharType guid: (GUID fromString: '{799F948A-7471-42AF-BB02-6154BC06A6A8}')!
GlorpVarCharType comment: ''!
!GlorpVarCharType categoriesForClass!Unclassified! !
!GlorpVarCharType methodsFor!

initialize
	super initialize.
	typeString := 'varchar'.!

isVariableWidth
	"Return true if this type allows varying length data within a particular instance. e.g., this is true for a varchar, but false for a fixed size character field"
	^true.!

typeString
	
	^self typeName,   ( width ifNil: [''] ifNotNil: [ :w |'(', w printString, ')'])! !
!GlorpVarCharType categoriesFor: #initialize!initialize!private! !
!GlorpVarCharType categoriesFor: #isVariableWidth!private!testing! !
!GlorpVarCharType categoriesFor: #typeString!accessing!private! !

GlorpMySQLClobType guid: (GUID fromString: '{6B295168-471D-4BBC-801D-56D546140B8B}')!
GlorpMySQLClobType comment: 'MySQL clobs come back from the driver as binary data, so we need to make a subclass that knows it needs a converter for its incoming data.'!
!GlorpMySQLClobType categoriesForClass!Unclassified! !
"Binary Globals"!

