| package |
package := Package name: 'GlorpExtensions'.
package paxVersion: 1;
	basicComment: 'This package contains extensions that Glorp uses, which can be defined in a way that''s portable between different Smalltalk dialects. Extensions which aren''t portable are normally in the Glorp<Dialect>Port package.

This is part of the GLORP system, an open-source library (LGPL(S)) for persisting Smalltalk objects in relational databases. For more information see the #notice property, the accompanying files and/or the web sites http://www.glorp.org or http://www.sourceforge.net/projects/glorp 
'.

package basicPackageVersion: 'image'.


package classNames
	add: #AddingWriteStream;
	add: #GlorpExtensionsPackage;
	yourself.

package methodNames
	add: #Association -> #glorpAtIdentity:ifAbsent:;
	add: #Association -> #keysAndValuesDo:;
	add: #ByteArray -> #glorpIsCollection;
	add: #ByteArray -> #glorpPrintSQLOn:;
	add: #Collection -> #glorpAddAll:;
	add: #Collection -> #glorpAddAllToDictionary:;
	add: #Collection -> #glorpGroupedBy:;
	add: #Collection -> #glorpIsCollection;
	add: #Collection -> #glorpPrintSQLOn:;
	add: #Collection -> #glorpPrintSQLOn:for:;
	add: #Collection -> #glorpRegisterCollectionInternalsIn:;
	add: #Collection -> #writeStream;
	add: #Date -> #glorpPrintSQLOn:;
	add: #Dictionary -> #glorpAddAll:;
	add: #IdentityDictionary -> #glorpAtIdentity:ifAbsent:;
	add: #Object -> #asGlorpExpression;
	add: #Object -> #asGlorpExpressionOn:;
	add: #Object -> #asGlorpExpressionOn:basedOn:withUltimateBase:;
	add: #Object -> #glorpBasicSize;
	add: #Object -> #glorpCanHaveDescriptorDirectly;
	add: #Object -> #glorpIsCollection;
	add: #Object -> #glorpPostFetch:;
	add: #Object -> #glorpPostFetchValidate:;
	add: #Object -> #glorpPostWrite:;
	add: #Object -> #glorpPreWrite:;
	add: #Object -> #glorpPrintSelectSQLOn:;
	add: #Object -> #glorpPrintSQLOn:;
	add: #Object -> #glorpRealObject;
	add: #Object -> #isGlorpExpression;
	add: #Object -> #isGlorpProxy;
	add: #Object -> #needsWork:;
	add: #Object -> #todo;
	add: #Object -> #yourSelf;
	add: #OrderedCollection -> #writeStream;
	add: #ReadStream -> #actuallyAtEnd;
	add: #ReadStream -> #collect:;
	add: #ReadStream -> #collectionTypeFor:;
	add: #ReadStream -> #detect:;
	add: #ReadStream -> #detect:ifNone:;
	add: #ReadStream -> #includes:;
	add: #ReadStream -> #newCollectionOfSize:for:;
	add: #ReadStream -> #select:;
	add: #ReadStream -> #statement:;
	add: #SortedCollection -> #writeStream;
	add: #String -> #glorpIsCollection;
	add: #String -> #glorpPrintSQLOn:;
	add: #String -> #like:;
	add: #Time -> #glorpPadToTwoDigits:;
	add: #Time -> #glorpPrintSQLOn:;
	add: #UndefinedObject -> #glorpPrintSQLOn:;
	add: 'Dialect class' -> #addSeconds:to:;
	add: 'Dialect class' -> #addTimeForDolphin:seconds:;
	add: 'Dialect class' -> #argumentCountFor:;
	add: 'Dialect class' -> #basicIsDolphin;
	add: 'Dialect class' -> #basicIsGNU;
	add: 'Dialect class' -> #basicIsObjectStudio;
	add: 'Dialect class' -> #basicIsSqueak;
	add: 'Dialect class' -> #basicIsVisualAge;
	add: 'Dialect class' -> #basicIsVisualWorks;
	add: 'Dialect class' -> #basicIsVisualWorksWithoutNamespaces;
	add: 'Dialect class' -> #coerceToDoublePrecisionFloat:;
	add: 'Dialect class' -> #determineDialect;
	add: 'Dialect class' -> #dialectName;
	add: 'Dialect class' -> #doesPrecisionOf:equal:;
	add: 'Dialect class' -> #doublePrecisionFloatClass;
	add: 'Dialect class' -> #error;
	add: 'Dialect class' -> #fitHashIntoSmallInteger:;
	add: 'Dialect class' -> #fixedPointClass;
	add: 'Dialect class' -> #garbageCollect;
	add: 'Dialect class' -> #glorpConstantExpressionClass;
	add: 'Dialect class' -> #instVarNameFor:;
	add: 'Dialect class' -> #isBlock:;
	add: 'Dialect class' -> #isDolphin;
	add: 'Dialect class' -> #isFloatingPoint:;
	add: 'Dialect class' -> #isGNU;
	add: 'Dialect class' -> #isHeadless;
	add: 'Dialect class' -> #isNamespaceAware;
	add: 'Dialect class' -> #isObjectStudio;
	add: 'Dialect class' -> #isSqueak;
	add: 'Dialect class' -> #isVisualAge;
	add: 'Dialect class' -> #isVisualWorks;
	add: 'Dialect class' -> #isVWWithNameSpaces;
	add: 'Dialect class' -> #lookedUpNames;
	add: 'Dialect class' -> #lookupClassNamed:inContextOf:;
	add: 'Dialect class' -> #lookupClassNamed:inContextOf:ifAbsent:;
	add: 'Dialect class' -> #newDateWithYears:months:days:;
	add: 'Dialect class' -> #newTimestampFromDate:time:;
	add: 'Dialect class' -> #newTimestampWithYears:months:days:hours:minutes:seconds:milliseconds:offset:;
	add: 'Dialect class' -> #newTimeWithHours:minutes:seconds:milliseconds:;
	add: 'Dialect class' -> #quitTheImage;
	add: 'Dialect class' -> #readFixedPointFrom:;
	add: 'Dialect class' -> #reset;
	add: 'Dialect class' -> #singlePrecisionFloatClass;
	add: 'Dialect class' -> #smalltalkAssociationAt:;
	add: 'Dialect class' -> #smalltalkAssociationAt:ifAbsent:;
	add: 'Dialect class' -> #smalltalkAt:;
	add: 'Dialect class' -> #smalltalkAt:ifAbsent:;
	add: 'Dialect class' -> #supportsMillisecondsInTimes;
	add: 'Dialect class' -> #supportsMillisecondsInTimeStamps;
	add: 'Dialect class' -> #timeOffsetFromGMT;
	add: 'Dialect class' -> #timestampClass;
	add: 'Dialect class' -> #timestampNow;
	add: 'Dialect class' -> #timestampNowUTC;
	add: 'Dialect class' -> #tokensBasedOn:in:;
	add: 'Dialect class' -> #totalSeconds;
	add: 'Dialect class' -> #unbindableClassNames;
	add: 'Dialect class' -> #weakValueDictionaryClass;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: 'GlorpExpressions';
	add: 'GlorpMisc';
	yourself).

package!

"Class Definitions"!

Object subclass: #AddingWriteStream
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpExtensionsPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!Association methodsFor!

glorpAtIdentity: aKey ifAbsent: aBlock
	"A cheat to let use use this like an identity dictionary"

	^key == aKey ifTrue: [value] ifFalse: [aBlock value]!

keysAndValuesDo: aBlock
	"A memory allocation hack. Let us use a single association in place of a dictionary"
	aBlock value: key value: value.! !
!Association categoriesFor: #glorpAtIdentity:ifAbsent:!accessing!public! !
!Association categoriesFor: #keysAndValuesDo:!accessing!private! !

!ByteArray methodsFor!

glorpIsCollection
	"For our purposes, these aren't collections, but rather a simple database type"
	^false.!

glorpPrintSQLOn: aCommand
	|strm|
	strm := WriteStream on: String new.
	strm nextPutAll: '0x'.
	strm nextPutAll: self asHexString.
	aCommand nextPutAll: strm contents! !
!ByteArray categoriesFor: #glorpIsCollection!private!testing! !
!ByteArray categoriesFor: #glorpPrintSQLOn:!glorp!private! !

!Collection methodsFor!

glorpAddAll: aCollection
	^self addAll: aCollection.!

glorpAddAllToDictionary: aDictionary
	"Assumes that we are a collection of associations"
	self do: [:each | aDictionary add: each].!

glorpGroupedBy: aBlock
	"Same as VW groupedBy:. This is too useful not to be able to use, but we don't want to conflict with other dialects/extensions that might implement, so make our own prefixed version"

	"Return a dictionary whose keys are the result of evaluating aBlock for all elements in
	 the collection, and the value for each key is the collection of elements that evaluated
	 to that key. e.g.
	     #(1 2 3 4 5) groupedBy: [:each | each odd]
	   a Dictionary  
	     true ---> #( 1 3 5)
	     false --> #(2 4)"

	| result |
	result := Dictionary new.
	self do:
		[:each | | key collection |
		key := aBlock value: each.
		collection := result at: key ifAbsentPut: [OrderedCollection new].
		collection add: each].
	self species ~~ OrderedCollection ifTrue:
		["Convert the result collections to be the right type.
		  Note that it should be safe to modify the dictionary
		  while iterating because we only replace values for existing keys"
		result keysAndValuesDo:
			[:key :value | result at: key put: (self species withAll: value)]].

	^result!

glorpIsCollection

	^true.!

glorpPrintSQLOn: aCommand
	aCommand nextPut: $(.
	self isEmpty
		ifTrue: [aCommand nextPutAll: 'NULL']
		ifFalse:
			[GlorpHelper
				do: [:each | each glorpPrintSQLOn: aCommand]
				for: self
				separatedBy: [aCommand nextPutAll: ', ']].
	aCommand nextPut: $).!

glorpPrintSQLOn: aStream for: aType
	aStream nextPut: $(.
	self isEmpty
		ifTrue: [aStream nextPutAll: 'NULL']
		ifFalse:
			[GlorpHelper
				do: [:each | aType print: each on: aStream]
				for: self
				separatedBy: [aStream nextPutAll: ', ']].
	aStream nextPut: $).!

glorpRegisterCollectionInternalsIn: anObjectTransaction 
	"Explicitly register any internal structures (e.g. a VW identity dictionary's valueArray) with the transaction. Assume we can safely register everything inside the collection reflectively. The obvious exceptions would be dependents and sortblocks. This is a cheat, and for peculiar cases you'll need to override this in the subclass"

	| names |
	names := self class allInstVarNames.
	(1 to: names size) do: 
			[:index | 
			(#('dependents' 'sortBlock') includes: (names at: index)) 
				ifFalse: [anObjectTransaction register: (self instVarAt: index)]]!

writeStream
	^AddingWriteStream on: self! !
!Collection categoriesFor: #glorpAddAll:!adding!private! !
!Collection categoriesFor: #glorpAddAllToDictionary:!adding!private! !
!Collection categoriesFor: #glorpGroupedBy:!enumerating!private! !
!Collection categoriesFor: #glorpIsCollection!private!testing! !
!Collection categoriesFor: #glorpPrintSQLOn:!glorp!private! !
!Collection categoriesFor: #glorpPrintSQLOn:for:!glorp!private! !
!Collection categoriesFor: #glorpRegisterCollectionInternalsIn:!glorp!private! !
!Collection categoriesFor: #writeStream!private!streams! !

!Date methodsFor!

glorpPrintSQLOn: aCommand
	"Print the date in ISO format. 'yyyy-mm-dd'  Don't rely on any dialect-specific formatting or padding mechanisms"
	| monthString dayString |
	aCommand 
		nextPut: $';
		print: self year;
		nextPut: $-.
	monthString := self monthIndex printString.
	monthString size = 1 ifTrue: [aCommand nextPut: $0 ].
	aCommand nextPutAll: monthString.
	aCommand nextPut: $-.
	dayString := self dayOfMonth printString.
	dayString size = 1 ifTrue: [aCommand nextPut: $0 ].
	aCommand nextPutAll: dayString.
	aCommand nextPut: $'.! !
!Date categoriesFor: #glorpPrintSQLOn:!printing!private! !

!Dialect class methodsFor!

addSeconds: seconds to: aTime

	self isVisualWorks ifTrue: [^ Time fromSeconds: aTime asSeconds + seconds].
	self isDolphin ifTrue: [^ self addTimeForDolphin: aTime seconds: seconds].
	self isGNU ifTrue: [^ aTime addSeconds: seconds].
	self isVisualAge ifTrue: [^Time fromSeconds: aTime asSeconds + seconds].
	self error: 'not implemented'.
	^ self!

addTimeForDolphin: aTime seconds: seconds

	"Dolphin's time/date arithmetic is pretty weak, especially for timestamps. Hack around it. This is likely only to work for seconds <24 hours"

	| result |

	^ aTime class == Time
		ifTrue: [Time fromMilliseconds: (aTime asMilliseconds + (seconds * 1000)) \\ 86400000.]
		ifFalse: [
			result := self timestampClass date: aTime date
				time: (self addTimeForDolphin: aTime time seconds: seconds).
			(seconds > 0 and: [result time < aTime time.])
				ifTrue: [result date: (result date addDays: 1).].
			(seconds < 0 and: [result time > aTime time.])
				ifTrue: [result date: (result date addDays: -1).].
			^ result
		]!

argumentCountFor: aBlock
	"argumentCount would also work"
	Dialect isDolphin ifTrue: [^aBlock argumentCount].
	self error: 'not implemented yet'.
	^self!

basicIsDolphin
	^Smalltalk includesKey: #DolphinSplash.!

basicIsGNU
	^Smalltalk includesKey: #BindingDictionary.!

basicIsObjectStudio
	^Smalltalk class name == #SmalltalkClass.!

basicIsSqueak

	^ (Smalltalk respondsTo: #vmVersion) and: [(Smalltalk vmVersion copyFrom: 1 to: 6) = 'Squeak'.]!

basicIsVisualAge

	^ Smalltalk class name == #EsSmalltalkNamespace
	"	| sys |
	sys := Smalltalk at: #System ifAbsent: [^false].
	(sys respondsTo: #vmType) ifFalse: [^false].
	^sys vmType = 'ES'"!

basicIsVisualWorks

	^ Smalltalk class name == #NameSpace
	"Smalltalk class selectors do: [ :s | 
		(s == #versionName and: [ (Smalltalk versionName copyFrom: 1 to: 11) = 'VisualWorks']) 
		    ifTrue: [^true]].
	^false"!

basicIsVisualWorksWithoutNamespaces
	^Smalltalk class name == #SystemDictionary!

coerceToDoublePrecisionFloat: aNumber
	^aNumber asFloat!

determineDialect
	self basicIsDolphin ifTrue: [^ dialectName := #Dolphin].
	self basicIsGNU ifTrue: [^ dialectName := #GNU].
	self basicIsVisualAge ifTrue: [^ dialectName := #VisualAge].
	self basicIsVisualWorks ifTrue: [^ dialectName := #VisualWorks].
	self basicIsSqueak ifTrue: [^ dialectName := #Squeak].
	self basicIsObjectStudio ifTrue: [^dialectName := #ObjectStudio].
	self basicIsVisualWorksWithoutNamespaces ifTrue: [^dialectName := #VisualWorks].
	self error: 'I don''t know what dialect this is'.
	^ self!

dialectName

	dialectName isNil ifTrue: [self determineDialect.].
	^ dialectName!

doesPrecisionOf: aNumber equal: aPrecision
	^aNumber class == self fixedPointClass and: [aNumber scale = aPrecision].!

doublePrecisionFloatClass

	self isVisualWorks ifTrue: [^ self smalltalkAt: #Double].
	self isGNU ifTrue: [^ self smalltalkAt: #FloatD].
	^ Float!

error
	"If VASmalltalk 8 has switched entirely to ANSI exceptions, perhaps we can retire this.
Meanwhile, it is used in some Glorp on:do: calls."

	^Dialect isVisualAge
		ifTrue: [Error, (Dialect smalltalkAt: #ExError)]
		ifFalse: [Error]!

fitHashIntoSmallInteger: aNumber
	"Truncate the number to fit into smallinteger range. Mostly useful for ObjectStudio where hashes have to be 16 bits or less"
	^Dialect isObjectStudio ifTrue: [aNumber hash] ifFalse: [aNumber].!

fixedPointClass
	!

garbageCollect
	MemoryManager current compact!

glorpConstantExpressionClass
	^ConstantExpression.!

instVarNameFor: aName
	^aName asString!

isBlock: anObject
	"Return true if this is a block"
	self isVisualAge ifTrue: [^anObject isKindOf: (self smalltalkAt: #Block)].
	^anObject class == [] class.!

isDolphin

	^ self dialectName = #Dolphin!

isFloatingPoint: aNumber
	^aNumber class == self doublePrecisionFloatClass or: [aNumber class == Float].!

isGNU

	^ self dialectName = #GNU!

isHeadless
	^SessionManager current isConsoleApplication!

isNamespaceAware
	isNamespaceAware isNil ifTrue: [isNamespaceAware := self basicIsVisualWorks].
	^isNamespaceAware!

isObjectStudio

	^ self dialectName = #ObjectStudio!

isSqueak

	^ self dialectName = #Squeak!

isVisualAge

	^ self dialectName = #VisualAge!

isVisualWorks

	^ self dialectName = #VisualWorks!

isVWWithNameSpaces
	"For cases where our hacked backports of asQualifiedReference and etc. to VW3 are not sufficient."

	^self isVisualWorks and: [self isNamespaceAware]!

lookedUpNames
	lookedUpNames isNil ifTrue: [lookedUpNames := IdentityDictionary new].
	^lookedUpNames.!

lookupClassNamed: aString inContextOf: aClass
	"Look up the class by name, but use the namespace of the class. Mostly useful if we're trying to guess from unqualified names in dialects with namespaces."
	^self lookupClassNamed: aString inContextOf: aClass ifAbsent: [nil].!

lookupClassNamed: aString inContextOf: aClass ifAbsent: aBlock
	"Look up the class by name, but use the namespace of the class. Mostly useful if we're trying to guess from unqualified names in dialects with namespaces."
	self isVisualWorks ifFalse: [^self smalltalkAt: aString ifAbsent: aBlock].
	^aClass environment at: aString ifAbsent: aBlock.!

newDateWithYears: years months: months days: days
	^Date newDay: days monthIndex: months year: years!

newTimestampFromDate: aDate time: aTime

	self isVisualWorks ifTrue: [^self timestampClass fromDate: aDate andTime: aTime].
	self error: 'Not yet implemented'.!

newTimestampWithYears: years
	months: months
	days: days
	hours: hours
	minutes: minutes
	seconds: seconds
	milliseconds: millis
	offset: offset

	| date time |
	date := self newDateWithYears: years months: months days: days.
	time := self newTimeWithHours: hours minutes: minutes seconds: seconds milliseconds: millis.
	^TimeStamp date: date time: time!

newTimeWithHours: hours minutes: minutes seconds: seconds milliseconds: milliseconds
	^Time fromMilliseconds: ((hours * 60 * 60) + (minutes * 60) + seconds) * 1000 + milliseconds!

quitTheImage
	"Quit the entire image"

	self isVisualWorks ifTrue: [^(self smalltalkAt: #ObjectMemory) quit].
	self isSqueak ifTrue: [^(self smalltalkAt: #SmalltalkImage) current snapshot: false andQuit: true].
	self isDolphin ifTrue: [^(self smalltalkAt: #SessionManager) current quit].
	self isVisualAge ifTrue: [^  self error: 'Not implemented yet'.].
	self isObjectStudio ifTrue: [^ self error: 'Not implemented yet'.].
	self isGNU ifTrue: [^ self error: 'Not implemented yet'.].
	self error: 'not implemented yet'.
	^ self!

readFixedPointFrom: aString

	self isVisualWorks ifTrue: [^ (self smalltalkAt: #FixedPoint) readFrom: (ReadStream on: aString)].
	(self isDolphin or: [self isSqueak]) ifTrue: [^ Number readFrom: (ReadStream on: aString , 's')].
	self isGNU
		ifTrue: [
			^ (Number readFrom: (ReadStream on: aString)) asScaledDecimal:
				aString size - (aString indexOf: $. ifAbsent: [aString size.])
		].
	self isVisualAge ifTrue: [ ^(self smalltalkAt: #Decimal) fromString: aString].
	self isObjectStudio ifTrue: [^(self smalltalkAt: #Decimal) newString: aString].
	self error: 'not implemented'.
	^ self!

reset
	"self reset"
	lookedUpNames := nil.
	timestampClass := nil.
	dialectName := nil.!

singlePrecisionFloatClass
	^ Float!

smalltalkAssociationAt: aName

	^ self smalltalkAssociationAt: aName ifAbsent: [self error: 'element not found'.]!

smalltalkAssociationAt: aName ifAbsent: aBlock

	self isVisualWorks ifTrue: [^ aName asQualifiedReference].
	^ Smalltalk associationAt: aName asSymbol ifAbsent: aBlock!

smalltalkAt: aName

	^ self smalltalkAt: aName ifAbsent: [self error: 'element not found'].!

smalltalkAt: aName ifAbsent: aBlock
	"We may look these names up a lot, so cache them in a small, local dictionary"
	| cached value symbol |
	symbol := aName asSymbol.
	cached := self lookedUpNames at: symbol ifAbsent: [nil].
	cached isNil ifFalse: [
		cached isBehavior ifFalse: [^cached]].
	value := self isVisualWorks
			ifTrue: [((symbol includes: $.)
				ifTrue: [symbol asStrictReference]
				ifFalse: [symbol asQualifiedReference]) valueOrDo: [^aBlock value]]
			ifFalse: [Smalltalk at: symbol ifAbsent: aBlock].
	self lookedUpNames
		at: symbol
		put: value.
	^value.!

supportsMillisecondsInTimes

	self isGNU ifTrue: [^ false].
	self isVisualWorks ifTrue: [^ false].
	self isSqueak ifTrue: [^false].
	self isDolphin ifTrue: [^ true].
	self isVisualAge ifTrue: [^ true].
	self isObjectStudio ifTrue: [^true]. "Sort of. Supports hundredths of a second"
	^ self!

supportsMillisecondsInTimeStamps

	self isGNU ifTrue: [^ false].
	self isVisualWorks ifTrue: [^ true].
	self isDolphin ifTrue: [^ true].
	self isVisualAge ifTrue: [^ true].
	self isObjectStudio ifTrue: [^true].
	self error: 'not yet implemented'.
	^ self!

timeOffsetFromGMT

	self isVisualWorks ifTrue: [^(self smalltalkAt: #TimeZone) default secondsFromGMT / (60 * 60)].
	self isGNU ifTrue: [Time timezoneBias / (60 * 60)].
	^ 0!

timestampClass
	timestampClass == nil ifFalse: [^timestampClass].
	(Dialect isSqueak or: [Dialect isDolphin]) ifTrue: [^timestampClass := self smalltalkAt: #TimeStamp].
	self error: 'Not yet implemented'.
	^self!

timestampNow
	Dialect isDolphin ifTrue: [^self timestampClass current].
	self error: 'Not yet implemented'.
	^self!

timestampNowUTC
	Dialect isDolphin ifTrue: [self error: 'not supported'].
	self error: 'Not yet implemented'.
	^self!

tokensBasedOn: aString in: stringToTokenize

	self isVisualWorks ifTrue: [^ stringToTokenize tokensBasedOn: aString first].
	self isSqueak ifTrue: [^ stringToTokenize findTokens: aString].
	self isDolphin ifTrue: [^ stringToTokenize subStrings: aString].
	self isVisualAge ifTrue: [^ (stringToTokenize subStrings: aString first)].
	self isObjectStudio ifTrue: [^(stringToTokenize asArrayOfSubstringsDelimiter: aString first)].
	self isGNU ifTrue: [^ stringToTokenize subStrings: aString first].
	self error: 'not implemented yet'.
	^ self!

totalSeconds

	self isGNU ifTrue: [^ Time utcSecondClock].
	self isVisualAge ifTrue: [^ (self smalltalkAt: #AbtTimestamp) now totalSeconds].
	^ Time totalSeconds!

unbindableClassNames

	self isVisualWorks ifTrue: [^ #()].
	^ #()!

weakValueDictionaryClass
	^WeakLookupTable! !
!Dialect class categoriesFor: #addSeconds:to:!dates!private! !
!Dialect class categoriesFor: #addTimeForDolphin:seconds:!dates!private! !
!Dialect class categoriesFor: #argumentCountFor:!general portability!public! !
!Dialect class categoriesFor: #basicIsDolphin!private! !
!Dialect class categoriesFor: #basicIsGNU!private! !
!Dialect class categoriesFor: #basicIsObjectStudio!private! !
!Dialect class categoriesFor: #basicIsSqueak!private! !
!Dialect class categoriesFor: #basicIsVisualAge!private! !
!Dialect class categoriesFor: #basicIsVisualWorks!private! !
!Dialect class categoriesFor: #basicIsVisualWorksWithoutNamespaces!private! !
!Dialect class categoriesFor: #coerceToDoublePrecisionFloat:!numbers!private! !
!Dialect class categoriesFor: #determineDialect!private! !
!Dialect class categoriesFor: #dialectName!identifying!private! !
!Dialect class categoriesFor: #doesPrecisionOf:equal:!numbers!private! !
!Dialect class categoriesFor: #doublePrecisionFloatClass!numbers!public! !
!Dialect class categoriesFor: #error!general portability!private! !
!Dialect class categoriesFor: #fitHashIntoSmallInteger:!general portability!private! !
!Dialect class categoriesFor: #fixedPointClass!numbers!public! !
!Dialect class categoriesFor: #garbageCollect!general portability!private! !
!Dialect class categoriesFor: #glorpConstantExpressionClass!forward references!private! !
!Dialect class categoriesFor: #instVarNameFor:!general portability!private! !
!Dialect class categoriesFor: #isBlock:!general portability!private! !
!Dialect class categoriesFor: #isDolphin!identifying!private! !
!Dialect class categoriesFor: #isFloatingPoint:!numbers!private! !
!Dialect class categoriesFor: #isGNU!identifying!private! !
!Dialect class categoriesFor: #isHeadless!general portability!private! !
!Dialect class categoriesFor: #isNamespaceAware!identifying!private! !
!Dialect class categoriesFor: #isObjectStudio!identifying!private! !
!Dialect class categoriesFor: #isSqueak!identifying!private! !
!Dialect class categoriesFor: #isVisualAge!identifying!private! !
!Dialect class categoriesFor: #isVisualWorks!identifying!private! !
!Dialect class categoriesFor: #isVWWithNameSpaces!identifying!private! !
!Dialect class categoriesFor: #lookedUpNames!private! !
!Dialect class categoriesFor: #lookupClassNamed:inContextOf:!class lookup!private! !
!Dialect class categoriesFor: #lookupClassNamed:inContextOf:ifAbsent:!class lookup!private! !
!Dialect class categoriesFor: #newDateWithYears:months:days:!dates!private! !
!Dialect class categoriesFor: #newTimestampFromDate:time:!dates!private! !
!Dialect class categoriesFor: #newTimestampWithYears:months:days:hours:minutes:seconds:milliseconds:offset:!dates!private! !
!Dialect class categoriesFor: #newTimeWithHours:minutes:seconds:milliseconds:!dates!private! !
!Dialect class categoriesFor: #quitTheImage!general portability!public! !
!Dialect class categoriesFor: #readFixedPointFrom:!dates!private! !
!Dialect class categoriesFor: #reset!private! !
!Dialect class categoriesFor: #singlePrecisionFloatClass!numbers!private! !
!Dialect class categoriesFor: #smalltalkAssociationAt:!class lookup!private! !
!Dialect class categoriesFor: #smalltalkAssociationAt:ifAbsent:!class lookup!private! !
!Dialect class categoriesFor: #smalltalkAt:!class lookup!private! !
!Dialect class categoriesFor: #smalltalkAt:ifAbsent:!class lookup!private! !
!Dialect class categoriesFor: #supportsMillisecondsInTimes!dates!private! !
!Dialect class categoriesFor: #supportsMillisecondsInTimeStamps!dates!private! !
!Dialect class categoriesFor: #timeOffsetFromGMT!dates!public! !
!Dialect class categoriesFor: #timestampClass!dates!public! !
!Dialect class categoriesFor: #timestampNow!dates!private! !
!Dialect class categoriesFor: #timestampNowUTC!dates!private! !
!Dialect class categoriesFor: #tokensBasedOn:in:!general portability!public! !
!Dialect class categoriesFor: #totalSeconds!dates!private! !
!Dialect class categoriesFor: #unbindableClassNames!binding!private! !
!Dialect class categoriesFor: #weakValueDictionaryClass!general portability!private! !

!Dictionary methodsFor!

glorpAddAll: aCollection
	"An addAll: that can work for either a dictionary argument or a collection of associations"
	aCollection glorpAddAllToDictionary: self.! !
!Dictionary categoriesFor: #glorpAddAll:!adding!private! !

!IdentityDictionary methodsFor!

glorpAtIdentity: aKey ifAbsent: aBlock
	^self at: aKey ifAbsent: aBlock.! !
!IdentityDictionary categoriesFor: #glorpAtIdentity:ifAbsent:!accessing!private! !

!Object methodsFor!

asGlorpExpression
	^GlorpHelper glorpConstantExpressionClass for: self.!

asGlorpExpressionOn: anExpression

	^self asGlorpExpression.!

asGlorpExpressionOn: anExpression basedOn: aMessageArchiver withUltimateBase: aBaseExpression

	^self asGlorpExpression.!

glorpBasicSize
	^self basicSize.!

glorpCanHaveDescriptorDirectly
	^self isBehavior.!

glorpIsCollection

	^false.!

glorpPostFetch: aSession
	"This is a selector that objects can implement in order to receive notification when Glorp has read them."!

glorpPostFetchValidate: aSession
	"This allows us to do post-read notification of the objects. Note that if this method explicitly returns a false, then we will treat that as meaning that the object is invalid and should not be read. Yes, this is kind of a hack."!

glorpPostWrite: aSession!

glorpPreWrite: aSession
	"This is a selector that objects can implement in order to receive notification when Glorp is about to write them. Only objects that have pending modifications will receive this notice. However, note that because of that, the data to be written will have already been calculated before this method is called, which makes it difficult to use this to update the method. If you want to put in audit information (e.g. the time at which the object was written, the associated username) then you probably want to use a generator associated with the field instead. See, for example GlorpRecordWithUpdate in the test suite."!

glorpPrintSelectSQLOn: aCommand

	self glorpPrintSQLOn: aCommand.!

glorpPrintSQLOn: aCommand

	self printOn: aCommand.!

glorpRealObject
	"Return the real object. Will force instantiation of a proxy, even on compilers which inline yourself"
	^self.!

isGlorpExpression
	^false.!

isGlorpProxy
	^false.!

needsWork: aString

	^self.!

todo
	"marker"!

yourSelf
	"Return the real object. Will force instantiation of a proxy, even on compilers which inline yourself"
	^self.! !
!Object categoriesFor: #asGlorpExpression!glorp!private! !
!Object categoriesFor: #asGlorpExpressionOn:!glorp!private! !
!Object categoriesFor: #asGlorpExpressionOn:basedOn:withUltimateBase:!glorp!private! !
!Object categoriesFor: #glorpBasicSize!glorp!private! !
!Object categoriesFor: #glorpCanHaveDescriptorDirectly!glorp!private! !
!Object categoriesFor: #glorpIsCollection!glorp!private! !
!Object categoriesFor: #glorpPostFetch:!glorp!private! !
!Object categoriesFor: #glorpPostFetchValidate:!glorp!private! !
!Object categoriesFor: #glorpPostWrite:!glorp!private! !
!Object categoriesFor: #glorpPreWrite:!glorp!private! !
!Object categoriesFor: #glorpPrintSelectSQLOn:!glorp!private! !
!Object categoriesFor: #glorpPrintSQLOn:!glorp!private! !
!Object categoriesFor: #glorpRealObject!glorp!private! !
!Object categoriesFor: #isGlorpExpression!glorp!private! !
!Object categoriesFor: #isGlorpProxy!glorp!private! !
!Object categoriesFor: #needsWork:!glorp!private! !
!Object categoriesFor: #todo!glorp!private! !
!Object categoriesFor: #yourSelf!glorp!private! !

!OrderedCollection methodsFor!

writeStream
	^AddingWriteStream on: self! !
!OrderedCollection categoriesFor: #writeStream!As yet unclassified!private! !

!ReadStream methodsFor!

actuallyAtEnd
	"For working around a VA cursor problem"
	^self atEnd!

collect: aBlock
	| newStream |
	newStream := collection species new writeStream.
	[self atEnd] whileFalse: [newStream nextPut: (aBlock value: self next)].
	^newStream contents

"Use #writeStream, not WriteStream on: collection species, for portability;  VA cannot stream over all AdditiveSequenceableCollections."!

collectionTypeFor: aClass
	^aClass.!

detect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.
	Answer the first element for which aBlock evaluates to true."

	^self detect: aBlock ifNone: [self error: 'not found']!

detect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.
	Answer the first element for which aBlock evaluates to true."

	self do: [:each | (aBlock value: each) ifTrue: [^each]].
	^exceptionBlock value!

includes: anObject
	self do: [:each | each = anObject ifTrue: [^true]].
	^false.!

newCollectionOfSize: aSize for: aCollectionType

	^aCollectionType isBehavior ifTrue: [aCollectionType new: aSize] ifFalse: [aCollectionType copyEmpty: aSize].!

select: aBlock
	| newStream |
	newStream := collection species new writeStream.
	[self atEnd] whileFalse: [
		| current |
		current := self next.
		(aBlock value: current) ifTrue: [newStream nextPut: current]].
	^newStream contents

"Use #writeStream, not WriteStream on: collection species, for portability;  VA cannot stream over all AdditiveSequenceableCollections."!

statement: aGlorpPreparedStatement
	"This is the statement used to create us. If it's coming back to a simple read stream, then we must have already used all its data, and can thus reuse it"
	aGlorpPreparedStatement busy: false.! !
!ReadStream categoriesFor: #actuallyAtEnd!Not categorized!private! !
!ReadStream categoriesFor: #collect:!Not categorized!private! !
!ReadStream categoriesFor: #collectionTypeFor:!building objects!private! !
!ReadStream categoriesFor: #detect:!Not categorized!private! !
!ReadStream categoriesFor: #detect:ifNone:!Not categorized!private! !
!ReadStream categoriesFor: #includes:!Not categorized!private! !
!ReadStream categoriesFor: #newCollectionOfSize:for:!Not categorized!private! !
!ReadStream categoriesFor: #select:!Not categorized!private! !
!ReadStream categoriesFor: #statement:!Not categorized!private! !

!SortedCollection methodsFor!

writeStream
	^AddingWriteStream on: self.! !
!SortedCollection categoriesFor: #writeStream!private!streams! !

!String methodsFor!

glorpIsCollection
	"For our purposes, these aren't collections, but rather a simple database type"
	^false.!

glorpPrintSQLOn: aCommand
	| platform requiresEscape |
	platform := [aCommand platform] on: MessageNotUnderstood do: [:ex | ex return: nil].
	aCommand nextPut: $'.
	1
		to: self size
		do:
			[:i | 
			| char |
			char := self at: i.
			requiresEscape := platform isNil ifTrue: [false] ifFalse: [platform requiresEscapeFor: char].
			requiresEscape
				ifTrue: [aCommand nextPutAll: (aCommand platform escapeFor: char)]
				ifFalse: [aCommand nextPut: char]].
	aCommand nextPut: $'.!

like: wildcardString
	" 'abcde' like: 'abc%'  "

	| newString |
	newString := wildcardString copy.
	newString := newString copyReplacing: $% withObject: $*.
	newString := newString copyReplacing: $_ withObject: $#.
	^newString match: self! !
!String categoriesFor: #glorpIsCollection!glorp!private! !
!String categoriesFor: #glorpPrintSQLOn:!glorp!private! !
!String categoriesFor: #like:!glorp!public! !

!Time methodsFor!

glorpPadToTwoDigits: anInteger
	| string |
	string := anInteger truncated printString.
	^string size = 1 ifTrue: ['0', string] ifFalse: [string].!

glorpPrintSQLOn: aCommand
	"Print as 24 hour time"

	aCommand 
		nextPut: $';
		nextPutAll: 	(self glorpPadToTwoDigits: self hours);
		nextPut: $:;
		nextPutAll: (self glorpPadToTwoDigits: self minutes);
		nextPut: $:;
		nextPutAll: (self glorpPadToTwoDigits: self seconds);
		nextPut: $'.! !
!Time categoriesFor: #glorpPadToTwoDigits:!printing!private! !
!Time categoriesFor: #glorpPrintSQLOn:!printing!private! !

!UndefinedObject methodsFor!

glorpPrintSQLOn: aCommand

	aCommand nextPutAll: 'NULL'.! !
!UndefinedObject categoriesFor: #glorpPrintSQLOn:!printing!private! !

"End of package definition"!

"Source Globals"!

"Classes"!

AddingWriteStream guid: (GUID fromString: '{7195CE97-DB05-4379-AAAB-5200BB16AA22}')!
AddingWriteStream comment: 'Why *can''t* you stream onto a set? Or a bag, or a SortedCollection? No good reason that I can see. This implements only a subset of stream behaviour, that which is necessary to let us build up collections where we have to "append" elements using #add: rather than #at:put: and explicit grows.

Instance Variables:
	target	<Collection>	The thing we''re streaming onto.

'!
!AddingWriteStream categoriesForClass!Unclassified! !
!AddingWriteStream methodsFor!

contents
	^target.!

nextPut: anObject
	target add: anObject.!

nextPutAll: aCollection
	target glorpAddAll: aCollection.!

on: aSet
	target := aSet.!

target
	^target!

target: aCollection
	target := aCollection! !
!AddingWriteStream categoriesFor: #contents!accessing!private! !
!AddingWriteStream categoriesFor: #nextPut:!accessing!private! !
!AddingWriteStream categoriesFor: #nextPutAll:!accessing!private! !
!AddingWriteStream categoriesFor: #on:!accessing!private! !
!AddingWriteStream categoriesFor: #target!accessing!private! !
!AddingWriteStream categoriesFor: #target:!accessing!private! !

!AddingWriteStream class methodsFor!

on: aCollection
	^self new target: aCollection.! !
!AddingWriteStream class categoriesFor: #on:!instance creation!private! !

GlorpExtensionsPackage guid: (GUID fromString: '{F1241F92-7F68-4220-AFFE-24ECE09C43FF}')!
GlorpExtensionsPackage comment: 'This class represents package information for the GlorpExtensions package, for systems that don''t have things like package properties to store things like copyright and license information.

LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you''ll need to release the
source of any modifications.

If you require any further clarification, we''d be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'!
!GlorpExtensionsPackage categoriesForClass!Unclassified! !
!GlorpExtensionsPackage class methodsFor!

LICENSE
"LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you'll need to release the
source of any modifications.

If you require any further clarification, we'd be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"! !
!GlorpExtensionsPackage class categoriesFor: #LICENSE!instance creation!public! !

"Binary Globals"!

