| package |
package := Package name: 'GlorpDBTests'.
package paxVersion: 1;
	basicComment: 'This is part of the GLORP system, an open-source library (LGPL(S)) for persisting Smalltalk objects in relational databases. For more information see the #notice property, the accompanying files and/or the web sites http://www.glorp.org or http://www.sourceforge.net/projects/glorp '.

package basicPackageVersion: 'image'.


package classNames
	add: #GlorpCompositeKeyTest;
	add: #GlorpConditionalMappingDBTest;
	add: #GlorpConstantValueInRelationshipTest;
	add: #GlorpCursoredCollectionDBTest;
	add: #GlorpDatabaseBasedTest;
	add: #GlorpDatabaseBasicTest;
	add: #GlorpDatabaseIndexTest;
	add: #GlorpDatabaseLoginResource;
	add: #GlorpDatabaseLoginTest;
	add: #GlorpDatabaseSequenceTest;
	add: #GlorpDatabaseSessionTest;
	add: #GlorpDatabaseTableTest;
	add: #GlorpDBTestsPackage;
	add: #GlorpDeleteTest;
	add: #GlorpDemoTablePopulatorResource;
	add: #GlorpDirectMappingDBTest;
	add: #GlorpEmbeddedMappingDBTest;
	add: #GlorpFilteringQueryDBTest;
	add: #GlorpGettingPrimaryKeyFromMappingTest;
	add: #GlorpInsertUpdateTest;
	add: #GlorpManyToManyDBTest;
	add: #GlorpMappingDBTest;
	add: #GlorpMockAccessor;
	add: #GlorpMockSession;
	add: #GlorpObjectComparisonJoinsTest;
	add: #GlorpObjectComparisonSubselectTest;
	add: #GlorpObjectMappedToFunctionTest;
	add: #GlorpObjectMappedToImaginaryTableTest;
	add: #GlorpOneToManyDBTest;
	add: #GlorpOneToOneDBTest;
	add: #GlorpOptimisticLockingTest;
	add: #GlorpOwnerSlaveTest;
	add: #GlorpPartialWritesTest;
	add: #GlorpProxyTest;
	add: #GlorpQueryStub;
	add: #GlorpQueryUnionTest;
	add: #GlorpReadingDifferentCollectionsTest;
	add: #GlorpReadingDifferentCollectionsThroughMappingsTest;
	add: #GlorpReadingDifferentCollectionsThroughMappingsWithClassModelsTest;
	add: #GlorpReadingPersonWithEmailAddressesTest;
	add: #GlorpReadingTest;
	add: #GlorpReadQueryTest;
	add: #GlorpRowDifferencingTest;
	add: #GlorpSelectCommandTest;
	add: #GlorpSessionBasedTest;
	add: #GlorpSessionResource;
	add: #GlorpSimpleQueryTest;
	add: #GlorpTestUpdatingTimestampInRecord;
	add: #GlorpTimedProxyReaperTest;
	add: #GlorpTypeTestsModelClass;
	add: #GlorpUnitOfWorkTest;
	add: #GlorpVariableTypeTest;
	add: #GlorpVirtualCollectionBasicTest;
	add: #GlorpWritingTest;
	add: #TestCommandPermission;
	yourself.

package methodNames
	add: #DefaultableThing -> #boolean;
	add: #DefaultableThing -> #boolean:;
	add: #DefaultableThing -> #id;
	add: #DefaultableThing -> #id:;
	add: #DefaultableThing -> #integer;
	add: #DefaultableThing -> #integer:;
	add: #GlorpDemoDescriptorSystem -> #writeCustomer1Rows;
	add: #GlorpDemoDescriptorSystem -> #writeCustomerWithDualAccountOwners;
	add: 'DescriptorSystem class' -> #createTables;
	add: 'DescriptorSystem class' -> #dropTables;
	add: 'DescriptorSystem class' -> #recreateTables;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: 'GlorpCollectionTypeModels';
	add: 'GlorpCore';
	add: 'GlorpDatabase';
	add: 'GlorpDatabaseTypes';
	add: 'GlorpExpressions';
	add: 'GlorpMappings';
	add: 'GlorpMisc';
	add: 'GlorpQueries';
	add: 'GlorpTestModels';
	add: 'GlorpUnitOfWork';
	add: '..\..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

Object subclass: #GlorpDBTestsPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpTypeTestsModelClass
	instanceVariableNames: 'id test'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
DatabaseAccessor subclass: #GlorpMockAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSession subclass: #GlorpMockSession
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
AbstractReadQuery subclass: #GlorpQueryStub
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpConstantValueInRelationshipTest
	instanceVariableNames: 'session system'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpDatabaseBasedTest
	instanceVariableNames: 'system'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpDatabaseBasicTest
	instanceVariableNames: 'system'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpDatabaseLoginTest
	instanceVariableNames: 'login accessor'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpDatabaseSessionTest
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpDeleteTest
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpInsertUpdateTest
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpMappingDBTest
	instanceVariableNames: 'system session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpPartialWritesTest
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpProxyTest
	instanceVariableNames: 'session proxy'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpReadingDifferentCollectionsTest
	instanceVariableNames: 'system session singleQuery allQuery singleResult allResult'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpReadingDifferentCollectionsThroughMappingsTest
	instanceVariableNames: 'system session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpReadingPersonWithEmailAddressesTest
	instanceVariableNames: 'session personRow addressRow emailAddress1Row emailAddress2Row id1 id2'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpReadingTest
	instanceVariableNames: 'system session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpReadQueryTest
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpSimpleQueryTest
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpTimedProxyReaperTest
	instanceVariableNames: 'reaper'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpUnitOfWorkTest
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpWritingTest
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpRowDifferencingTest
	instanceVariableNames: 'session currentObject currentObjectRowMap correspondenceMap differenceMap mementoObject mementoObjectRowMap'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpSessionBasedTest
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpCompositeKeyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpCursoredCollectionDBTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpDatabaseSequenceTest
	instanceVariableNames: 'sequence table row2 row1'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpFilteringQueryDBTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpGettingPrimaryKeyFromMappingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpObjectComparisonJoinsTest
	instanceVariableNames: 'itinerary1 itinerary2'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpObjectMappedToFunctionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpObjectMappedToImaginaryTableTest
	instanceVariableNames: 'example example2'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpOptimisticLockingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpQueryUnionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpSelectCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpTestUpdatingTimestampInRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpVirtualCollectionBasicTest
	instanceVariableNames: 'vc'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #TestCommandPermission
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpObjectComparisonJoinsTest subclass: #GlorpObjectComparisonSubselectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpMappingDBTest subclass: #GlorpConditionalMappingDBTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpMappingDBTest subclass: #GlorpDatabaseIndexTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpMappingDBTest subclass: #GlorpDatabaseTableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpMappingDBTest subclass: #GlorpDirectMappingDBTest
	instanceVariableNames: 'person personId'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpMappingDBTest subclass: #GlorpEmbeddedMappingDBTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpMappingDBTest subclass: #GlorpManyToManyDBTest
	instanceVariableNames: 'customer customerId accountId1 accountId2 accountId3 treeNodeClass'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpMappingDBTest subclass: #GlorpOneToManyDBTest
	instanceVariableNames: 'person personId emailId1 emailId2 emailId3'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpMappingDBTest subclass: #GlorpOneToOneDBTest
	instanceVariableNames: 'person personId'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpMappingDBTest subclass: #GlorpOwnerSlaveTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpMappingDBTest subclass: #GlorpVariableTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpReadingDifferentCollectionsThroughMappingsTest subclass: #GlorpReadingDifferentCollectionsThroughMappingsWithClassModelsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestResource subclass: #GlorpDatabaseLoginResource
	instanceVariableNames: 'accessor login'
	classVariableNames: 'DefaultLogin'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestResource subclass: #GlorpDemoTablePopulatorResource
	instanceVariableNames: 'login'
	classVariableNames: 'NeedsSetup'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestResource subclass: #GlorpSessionResource
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!DefaultableThing methodsFor!

boolean
	^boolean!

boolean: anObject
	boolean := anObject!

id
	^id!

id: anObject
	id := anObject!

integer
	^integer!

integer: anObject
	integer := anObject! !
!DefaultableThing categoriesFor: #boolean!accessing!private! !
!DefaultableThing categoriesFor: #boolean:!accessing!private! !
!DefaultableThing categoriesFor: #id!accessing!private! !
!DefaultableThing categoriesFor: #id:!accessing!private! !
!DefaultableThing categoriesFor: #integer!accessing!private! !
!DefaultableThing categoriesFor: #integer:!accessing!private! !

!DescriptorSystem class methodsFor!

createTables
	"Create the tables for this descriptor system. This will fail if the tables already exist. Use recreateTables for that."
	^self createTablesFor: GlorpDatabaseLoginResource current login.!

dropTables
	"Drop and re-create the tables for this descriptor system."
	^self dropTablesFor: GlorpDatabaseLoginResource current login.!

recreateTables
	"Drop and re-create the tables for this descriptor system."
	^self recreateTablesFor: GlorpDatabaseLoginResource current login.! !
!DescriptorSystem class categoriesFor: #createTables!private!utility! !
!DescriptorSystem class categoriesFor: #dropTables!private!utility! !
!DescriptorSystem class categoriesFor: #recreateTables!private!utility! !

!GlorpDemoDescriptorSystem methodsFor!

writeCustomer1Rows
	| linkRow2 id2 id1 accountRow1 customerRow accountRow2 linkRow1 |
	customerRow := self exampleCustomerRow1.
	accountRow1 := self exampleAccountRow1.
	accountRow2 := self exampleAccountRow2.
	linkRow1 := self exampleCALinkRow1.
	linkRow2 := self exampleCALinkRow2.
	session writeRow: customerRow.
	session writeRow: accountRow1.
	session writeRow: accountRow2.
	session writeRow: linkRow1.
	session writeRow: linkRow2.
	id1 := accountRow1 at: (accountRow1 table fieldNamed: 'ID').
	id2 := accountRow2 at: (accountRow2 table fieldNamed: 'ID').
	^Array with: id1 with: id2.!

writeCustomerWithDualAccountOwners
	| linkRow2 id2 id1 accountRow1 accountRow2 linkRow1 customer1Row customer2Row linkRow4 |
	customer1Row := self exampleCustomerRow1.
	customer2Row := self exampleCustomerRow2.
	accountRow1 := self exampleAccountRow1.
	accountRow2 := self exampleAccountRow2.
	linkRow1 := self exampleCALinkRow1.
	linkRow2 := self exampleCALinkRow2.
	linkRow4 := self exampleCALinkRow4.
	session writeRow: customer1Row.
	session writeRow: customer2Row.
	session writeRow: accountRow1.
	session writeRow: accountRow2.
	session writeRow: linkRow1.
	session writeRow: linkRow2.
	session writeRow: linkRow4.
	id1 := accountRow1 at: (accountRow1 table fieldNamed: 'ID').
	id2 := accountRow2 at: (accountRow2 table fieldNamed: 'ID').
	^Array with: id1 with: id2.! !
!GlorpDemoDescriptorSystem categoriesFor: #writeCustomer1Rows!private!support! !
!GlorpDemoDescriptorSystem categoriesFor: #writeCustomerWithDualAccountOwners!private!support! !

"End of package definition"!

"Source Globals"!

"Classes"!

GlorpDBTestsPackage guid: (GUID fromString: '{5FE37CB8-81D2-45D2-BB76-43E489A1B1D3}')!
GlorpDBTestsPackage comment: 'This class represents package information for the GlorpDBTests package, for systems that don''t have things like package properties to store things like copyright and license information.

LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you''ll need to release the
source of any modifications.

If you require any further clarification, we''d be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'!
!GlorpDBTestsPackage categoriesForClass!Unclassified! !
!GlorpDBTestsPackage class methodsFor!

LICENSE
"LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you'll need to release the
source of any modifications.

If you require any further clarification, we'd be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"! !
!GlorpDBTestsPackage class categoriesFor: #LICENSE!instance creation!public! !

GlorpTypeTestsModelClass guid: (GUID fromString: '{85B1DFB7-74D8-4AFC-AEDA-023D509CCBE2}')!
GlorpTypeTestsModelClass comment: ''!
!GlorpTypeTestsModelClass categoriesForClass!Unclassified! !
!GlorpTypeTestsModelClass methodsFor!

test
	^test.!

test: anObject
	test:= anObject.! !
!GlorpTypeTestsModelClass categoriesFor: #test!As yet unclassified!private! !
!GlorpTypeTestsModelClass categoriesFor: #test:!As yet unclassified!private! !

GlorpMockAccessor guid: (GUID fromString: '{C69FEDBC-FDC2-40E8-8DA9-989E606143F0}')!
GlorpMockAccessor comment: ''!
!GlorpMockAccessor categoriesForClass!Unclassified! !
!GlorpMockAccessor methodsFor!

basicExecuteSQLString: aString
	^ReadStream on: #(#(3)).!

executeCommand: aCommand returnCursor: aBoolean
	| result |
	result := #(#(3)).
	^aBoolean ifTrue: [result readStream] ifFalse: [result].!

executeSQLString: aString
	^#((3)).! !
!GlorpMockAccessor categoriesFor: #basicExecuteSQLString:!executing!private! !
!GlorpMockAccessor categoriesFor: #executeCommand:returnCursor:!executing!private! !
!GlorpMockAccessor categoriesFor: #executeSQLString:!executing!private! !

GlorpMockSession guid: (GUID fromString: '{A70C91FB-BF11-4623-9727-F3116C1597C8}')!
GlorpMockSession comment: ''!
!GlorpMockSession categoriesForClass!Unclassified! !
!GlorpMockSession methodsFor!

accessor
	^GlorpMockAccessor new.!

initialize

	super initialize.
	rows := OrderedCollection new.!

rows

	^rows.!

useBinding
	^true.!

writeHomogeneousRows: aCollection
	aCollection do: [:each | self writeRow: each].
	^true.!

writeRow: aRow
	aRow shouldBeWritten ifFalse: [^true].
	aRow preWriteAssignSequencesUsing: self.
	rows add: aRow.
	aRow postWriteAssignSequencesUsing: self accessor.
	^true.! !
!GlorpMockSession categoriesFor: #accessor!accessing!private! !
!GlorpMockSession categoriesFor: #initialize!initialize!private! !
!GlorpMockSession categoriesFor: #rows!accessing!private! !
!GlorpMockSession categoriesFor: #useBinding!private!testing! !
!GlorpMockSession categoriesFor: #writeHomogeneousRows:!private!read/write! !
!GlorpMockSession categoriesFor: #writeRow:!public!read/write! !

!GlorpMockSession class methodsFor!

new

	^super new initialize.! !
!GlorpMockSession class categoriesFor: #new!instance creation!private! !

GlorpQueryStub guid: (GUID fromString: '{2ACDE016-B932-4274-ADB9-CD03D23292AE}')!
GlorpQueryStub comment: 'A test class. This behaves like a query, but doesn''t go to the database, it just returns whatever it was told to return on its creation, regardless of the parameters or session.

Instance Variables:
	result	<Object>	The thing we should return.

'!
!GlorpQueryStub categoriesForClass!Unclassified! !
!GlorpQueryStub methodsFor!

executeWithParameters: parameterArray in: aSession 

	aSession register: result.
	^result.!

initialize

	super initialize.
	readsOneObject := true.!

result
	^result!

result: anObject
	result := anObject! !
!GlorpQueryStub categoriesFor: #executeWithParameters:in:!executing!private! !
!GlorpQueryStub categoriesFor: #initialize!initialize!private! !
!GlorpQueryStub categoriesFor: #result!accessing!private! !
!GlorpQueryStub categoriesFor: #result:!accessing!private! !

!GlorpQueryStub class methodsFor!

newQuery
	^self new.! !
!GlorpQueryStub class categoriesFor: #newQuery!instance creation!private! !

GlorpConstantValueInRelationshipTest guid: (GUID fromString: '{44EC65C4-3EA4-46C4-8776-36B3B9BBB621}')!
GlorpConstantValueInRelationshipTest comment: ''!
!GlorpConstantValueInRelationshipTest categoriesForClass!Unclassified! !
!GlorpConstantValueInRelationshipTest methodsFor!

idsFor: aCollection

	^(aCollection collect: [:each | each id]) asSortedCollection asArray.!

sampleWorker

	| worker job3 |
	worker := GlorpWorker new.
	worker id: 1234.
	worker name: 'Some Worker'.
	worker pendingJobs add: (GlorpJob new id: 1; description: 'job 1').
	worker pendingJobs add: (GlorpJob new id: 2; description: 'job 2').
	worker finishedJobs add: (job3 := GlorpJob new id: 3; description: 'job 3').
	worker finishedJobs add: (GlorpJob new id: 4; description: 'job 4').
	worker priorityJobs add: job3.
	^worker.!

setUp
	system := GlorpWorkerDescriptorSystem forPlatform: GlorpDatabaseLoginResource defaultLogin database.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	session system: system.!

testRead

	| worker |
	[session beginTransaction.
	self writeTestData.
	worker := session execute: (Query returningOneOf: GlorpWorker where: [:each | each id = 1234]).

	self assert: (self idsFor: worker pendingJobs) = #(1 2).
	self assert: (self idsFor: worker finishedJobs) = #(3 4).
	self assert: (self idsFor: worker priorityJobs) = #(3).

	] ensure: [session rollbackTransaction].!

testReadWithJoin
	| worker |
	[session beginTransaction.
	self writeTestData.
	worker := session
		execute:
			(Query returningOneOf: GlorpWorker where: [:each | each pendingJobs id = 1]).
	self assert: worker id = 1234] ensure: [session rollbackTransaction].!

testWrite

	| worker sampleWorker |
	[session beginTransaction.
	session beginUnitOfWork.
	sampleWorker := self sampleWorker.
	session register: sampleWorker.
	session commitUnitOfWork.
	session reset.
	worker := session execute: (Query returningOneOf: GlorpWorker where: [:each | each id = 1234]).

	self assert: (self idsFor: worker pendingJobs) = #(1 2).
	self assert: (self idsFor: worker finishedJobs) = #(3 4).
	self assert: (self idsFor: worker priorityJobs) = #(3).

	] ensure: [session rollbackTransaction].!

writeTestData

	session writeRow: system exampleWorkerRow.
	session writeRow: (system exampleJobRow: 1 finished: false).
	session writeRow: (system exampleJobRow: 2 finished: false).
	session writeRow: (system exampleJobRow: 3 finished: true).
	session writeRow: (system exampleJobRow: 4 finished: true).
	session writeRow: system exampleLinkRow1.
	session writeRow: system exampleLinkRow2.! !
!GlorpConstantValueInRelationshipTest categoriesFor: #idsFor:!private!support! !
!GlorpConstantValueInRelationshipTest categoriesFor: #sampleWorker!private!support! !
!GlorpConstantValueInRelationshipTest categoriesFor: #setUp!private!support! !
!GlorpConstantValueInRelationshipTest categoriesFor: #testRead!private!tests! !
!GlorpConstantValueInRelationshipTest categoriesFor: #testReadWithJoin!private!tests! !
!GlorpConstantValueInRelationshipTest categoriesFor: #testWrite!private!tests! !
!GlorpConstantValueInRelationshipTest categoriesFor: #writeTestData!private!support! !

!GlorpConstantValueInRelationshipTest class methodsFor!

resources
	^Array with: GlorpDatabaseLoginResource with: GlorpDemoTablePopulatorResource.! !
!GlorpConstantValueInRelationshipTest class categoriesFor: #resources!private!resources! !

GlorpDatabaseBasedTest guid: (GUID fromString: '{78E31563-2D7A-402C-A9C4-7129763B79EA}')!
GlorpDatabaseBasedTest comment: ''!
!GlorpDatabaseBasedTest categoriesForClass!Unclassified! !
!GlorpDatabaseBasedTest methodsFor!

setUp
	system := GlorpDemoDescriptorSystem forPlatform: GlorpDatabaseLoginResource defaultLogin database.
	system session: GlorpMockSession new.
	system session system: system.! !
!GlorpDatabaseBasedTest categoriesFor: #setUp!private!support! !

GlorpDatabaseBasicTest guid: (GUID fromString: '{0B93BBA0-4446-4A1E-9401-CC5A0840DA2F}')!
GlorpDatabaseBasicTest comment: ''!
!GlorpDatabaseBasicTest categoriesForClass!Unclassified! !
!GlorpDatabaseBasicTest methodsFor!

accessor
	^self databaseLoginResource accessor!

databaseLoginResource
	^GlorpDatabaseLoginResource current.!

setUp

	super setUp.
	system := GlorpDemoDescriptorSystem forPlatform: GlorpDatabaseLoginResource defaultLogin database.!

testBeginTransactionWithCommit
	self assert: self accessor isInTransaction not.
	self accessor beginTransaction.
	self assert: self accessor isInTransaction.
	self accessor commitTransaction.
	self assert: self accessor isInTransaction not!

testBeginTransactionWithRollback
	self assert: self accessor isInTransaction not.
	self accessor beginTransaction.
	self assert: self accessor isInTransaction.
	self accessor rollbackTransaction.
	self assert: self accessor isInTransaction not!

testCreateTable
	| selectResult presentFlag |
	presentFlag := true.
	[[self accessor beginTransaction.
	self accessor
		executeSQLStringNoResult: 'CREATE TABLE GLORP_TEST_CREATE (ID varchar(4))'] 
		ensure: [self accessor commitTransaction].
	selectResult := self accessor
		executeSQLString: 'SELECT * FROM GLORP_TEST_CREATE'.
	self assert: selectResult isEmpty]
		ensure:
			[[self accessor
				beginTransaction;
				dropTableNamed: 'GLORP_TEST_CREATE'
					ifAbsent: [:ex |presentFlag := false. ex sunitExitWith: nil]]
				ensure: [self accessor commitTransaction]].
	self assert: presentFlag
		description: 'Tried to drop the created table but it was already absent'.!

testDropMissingTable
	| absentFlag |
	absentFlag := false.
	[self accessor beginTransaction.
	self accessor 
		dropTableNamed: 'GLORP_TEST_DROP' 
		ifAbsent: [:ex  | absentFlag := true. ex sunitExitWith: nil]]
	ensure: [self accessor rollbackTransaction].
	self assert: absentFlag!

testNameBinding
	| selectResult |
	"This is more of a low-level db functionality test than a glorp test, but it's convenient to be able ot write it here"
	Dialect isVisualWorks ifFalse: [^self].
	[self accessor beginTransaction.
	self accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (10,''abc'')'.
	self accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (20,''def'')'.
	self accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (30,''ghi'')'.
	selectResult := self accessor 
		executeSQLString: 'SELECT * FROM STUFF WHERE ID = :key OR ID = :value'
			binding: 10->30.

	self assert: selectResult size = 2]
		ensure: [self accessor rollbackTransaction].!

testPositionalBinding
	| selectResult | 
	"This is more of a low-level db functionality test than a glorp test, but it's convenient to be able ot write it here"
	Dialect isVisualWorks ifFalse: [^self].
	[self accessor beginTransaction.
	self accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (10,''abc'')'.
	self accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (20,''def'')'.
	self accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (30,''ghi'')'.
	selectResult := self accessor 
		executeSQLString: 'SELECT * FROM STUFF WHERE ID = :2 OR ID = :17'
			binding: #(nil 10 nil nil nil nil nil nil nil nil nil nil nil nil nil nil 20).

	self assert: selectResult size = 2]
		ensure: [self accessor rollbackTransaction].!

testReadEmpty
	| results |
	results := self accessor
				executeSQLString: 'SELECT * FROM PERSON'.
	self assert: results size = 0!

testReadStatement
	| results |
	results := self accessor
				executeSQLString: 'SELECT * FROM STUFF ORDER BY ID'.
	self assert: results size = 5.
	self assert: results first size = 2.
	self assert: results first last =  'abc'!

testRollbackRemovesData
	"Just to make sure I'm not losing my mind"
	| numAddresses newNumAddresses|
	numAddresses := (self accessor executeSQLString: 'SELECT * FROM GR_ADDRESS') size.
	self accessor beginTransaction.
	self accessor executeSQLStringNoResult: 'INSERT INTO GR_ADDRESS (ID,STREET,HOUSE_NUM)  VALUES (111,''Main Street'',''77777'')'.
	newNumAddresses := (self accessor executeSQLString: 'SELECT * FROM GR_ADDRESS') size.
	self assert: newNumAddresses = (numAddresses + 1).
	self accessor rollbackTransaction.
	self assert: numAddresses = (self accessor executeSQLString: 'SELECT * FROM GR_ADDRESS') size.! !
!GlorpDatabaseBasicTest categoriesFor: #accessor!accessing!private! !
!GlorpDatabaseBasicTest categoriesFor: #databaseLoginResource!private!support! !
!GlorpDatabaseBasicTest categoriesFor: #setUp!private!support! !
!GlorpDatabaseBasicTest categoriesFor: #testBeginTransactionWithCommit!private!tests! !
!GlorpDatabaseBasicTest categoriesFor: #testBeginTransactionWithRollback!private!tests! !
!GlorpDatabaseBasicTest categoriesFor: #testCreateTable!private!tests! !
!GlorpDatabaseBasicTest categoriesFor: #testDropMissingTable!private!tests! !
!GlorpDatabaseBasicTest categoriesFor: #testNameBinding!private!tests! !
!GlorpDatabaseBasicTest categoriesFor: #testPositionalBinding!private!tests! !
!GlorpDatabaseBasicTest categoriesFor: #testReadEmpty!private!tests! !
!GlorpDatabaseBasicTest categoriesFor: #testReadStatement!private!tests! !
!GlorpDatabaseBasicTest categoriesFor: #testRollbackRemovesData!private!tests! !

!GlorpDatabaseBasicTest class methodsFor!

resources
	^Array with: GlorpDatabaseLoginResource with: GlorpDemoTablePopulatorResource.! !
!GlorpDatabaseBasicTest class categoriesFor: #resources!private!resources! !

GlorpDatabaseLoginTest guid: (GUID fromString: '{8B427F99-C014-45F1-9C57-5A69C0AECB6F}')!
GlorpDatabaseLoginTest comment: ''!
!GlorpDatabaseLoginTest categoriesForClass!Unclassified! !
!GlorpDatabaseLoginTest methodsFor!

accessor

	^accessor.!

setUp
	super setUp.
	login := GlorpDatabaseLoginResource defaultLogin copy.
	accessor := DatabaseAccessor forLogin: login.!

testLogin
	self assert: self accessor isLoggedIn not.
	self accessor login.
	self assert: self accessor isLoggedIn.
	self accessor logout.
	self assert: self accessor isLoggedIn not!

testSecureLoginDiscardsPassword
	| oldValue |
	self assert: self accessor isLoggedIn not.
	oldValue := self accessor currentLogin secure.
	[self accessor currentLogin secure: true.
	self accessor login.
	self assert: accessor currentLogin password isNil.
	self accessor logout]
		ensure: [self accessor currentLogin secure: oldValue].!

testUnsecureLoginDoesNotDiscardPassword
	| oldValue |
	self assert: self accessor isLoggedIn not.
	oldValue := self accessor currentLogin secure.
	[self accessor currentLogin secure: false.
	self accessor login.
	self assert: accessor currentLogin password notNil.
	self accessor logout]
		ensure: [self accessor currentLogin secure: oldValue].!

testUnsuccessfulLogin

	| anotherAccessor invalidLogin |
	"Some databases can't fail to log in."
	login database supportsAuthentication ifFalse: [^self].

	invalidLogin := GlorpDatabaseLoginResource defaultLogin copy.
	invalidLogin
		password: 'you will never ever guess this password';
		username: 'not a valid user name'.
	anotherAccessor := DatabaseAccessor forLogin: invalidLogin.

	self assert: anotherAccessor isLoggedIn not.
	anotherAccessor loginIfError: [:ex | ].
	Dialect isVisualAge		"The isLoggedIn is unreliable under VA, can return false positive"
		ifFalse: [self assert: anotherAccessor isLoggedIn not]
		ifTrue: [Transcript cr; show: self class name, '>>testUnsuccessfulLogin skips a trivial isLoggedIn check, saying it was unreliable under VA55, could return false positive, later versions not yet verified'].
	anotherAccessor logout.! !
!GlorpDatabaseLoginTest categoriesFor: #accessor!accessing!private! !
!GlorpDatabaseLoginTest categoriesFor: #setUp!public!support! !
!GlorpDatabaseLoginTest categoriesFor: #testLogin!private!tests! !
!GlorpDatabaseLoginTest categoriesFor: #testSecureLoginDiscardsPassword!public!tests! !
!GlorpDatabaseLoginTest categoriesFor: #testUnsecureLoginDoesNotDiscardPassword!public!tests! !
!GlorpDatabaseLoginTest categoriesFor: #testUnsuccessfulLogin!private!tests! !

!GlorpDatabaseLoginTest class methodsFor!

resources

	^Array with: GlorpDatabaseLoginResource.! !
!GlorpDatabaseLoginTest class categoriesFor: #resources!private!resources! !

GlorpDatabaseSessionTest guid: (GUID fromString: '{F263D206-9157-4EFF-B615-548D771F17AA}')!
GlorpDatabaseSessionTest comment: ''!
!GlorpDatabaseSessionTest categoriesForClass!Unclassified! !
!GlorpDatabaseSessionTest methodsFor!

setUp

	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.!

tearDown
	super tearDown.
	session reset.
	session := nil.!

testWriteRow
	| rowToWrite fields rowReadFromDatabase |
	rowToWrite := session system examplePersonRow2.
	
	[session beginTransaction.
	session writeRow: rowToWrite.
	rowReadFromDatabase := (session accessor
				executeSQLString: 'SELECT * FROM ' , rowToWrite table name) first.
	fields := rowToWrite table fields.
	(1 to: fields size) with: fields
		do: [:index :field | self assert: (rowReadFromDatabase atIndex: index) = (rowToWrite at: field)]] 
			ensure: [session rollbackTransaction]! !
!GlorpDatabaseSessionTest categoriesFor: #setUp!private!support! !
!GlorpDatabaseSessionTest categoriesFor: #tearDown!private!support! !
!GlorpDatabaseSessionTest categoriesFor: #testWriteRow!private!tests! !

!GlorpDatabaseSessionTest class methodsFor!

resources

	^Array with: (Smalltalk at: #GlorpSessionResource).! !
!GlorpDatabaseSessionTest class categoriesFor: #resources!private!resources! !

GlorpDeleteTest guid: (GUID fromString: '{F524447E-8856-4909-AFF7-D1F260F63FE4}')!
GlorpDeleteTest comment: 'This tests deletions.'!
!GlorpDeleteTest categoriesForClass!Unclassified! !
!GlorpDeleteTest methodsFor!

checkCustomerDeletedInDatabase
	| result |
	result := session accessor 
				executeSQLString: 'SELECT * FROM GR_CUSTOMER WHERE ID=1'.
	self assert: result isEmpty!

checkCustomerNotInCache
	self assert: (session cacheLookupForClass: GlorpCustomer key: 1) isNil!

checkCustomerStillInCache
	self assert: (session cacheLookupForClass: GlorpCustomer key: 1) notNil!

checkFoldersDeletedInDatabase
	| result generalResult |
	result := session accessor 
				executeSQLString: 'SELECT * FROM GR_FOLDER WHERE USER_ID=1'.
	self assert: result isEmpty.

	generalResult := session accessor 
				executeSQLString: 'SELECT * FROM GR_FOLDER'.
	self assert: generalResult size = 1.!

checkFoldersExistInDatabase
	| result |
	result := session accessor 
				executeSQLString: 'SELECT * FROM GR_FOLDER WHERE USER_ID=1'.
	self assert: result size = 2.!

checkFoldersNotInCache
	self assert: (session cacheLookupForClass: GlorpFolder key: #(1 'One')) isNil.
	self assert: (session cacheLookupForClass: GlorpFolder key: #(1 'One-A')) isNil.!

checkMessagesDeletedInDatabase
	| result generalResult |
	result := session accessor 
				executeSQLString: 'SELECT * FROM GR_MESSAGE WHERE USER_ID = 1'.
	self assert: result isEmpty.

	generalResult := session accessor 
				executeSQLString: 'SELECT * FROM GR_MESSAGE'.
	self assert: generalResult size = 1.!

checkPersonDeletedInDatabase
	| result |
	result := session accessor 
				executeSQLString: 'SELECT * FROM PERSON WHERE ID=1'.
	self assert: result isEmpty!

doDeleteAndDoubleAddOfFoldersFor: user
	| new2 removed new |
	^session
		modify: user
		in:
			[user folders do: [:each | each printString].
			removed := user folders detect: [:each | each name = 'One'].
			user folders remove: removed.
			new := GlorpFolder new name: 'One'.
			new user: user.
			user folders add: new.
			new2 := GlorpFolder new name: 'One'.
			new2 user: user.
			user folders add: new2].!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.!

setUpCustomer
	session beginTransaction.
	session accessor 
		executeSQLStringNoResult: 'INSERT INTO GR_CUSTOMER VALUES (1,''Fred Flintstone'')'.
	^session readOneOf: GlorpCustomer where: [:each | each id = 1].!

setUpFolders

	session system: (GlorpCompositeKeyDescriptorSystem forPlatform: session platform).
	session beginTransaction.
	session transact: [session register: session system example1].
	session reset.!

setUpPersonWithAddress
	session beginTransaction.
	session accessor 
		executeSQLStringNoResult: 'INSERT INTO GR_ADDRESS VALUES (2,''Paseo Montril'', ''999'')'.
	session accessor 
		executeSQLStringNoResult: 'INSERT INTO PERSON VALUES (1,''Fred Flintstone'', 2)'.
	^session readOneOf: GlorpPerson where: [:each | each id = 1].!

tearDown
	super tearDown.
	session reset.
	session := nil.!

testCascadingDeleteAcrossNil
	| person addressRows personRows |
	session inTransactionDo: [session accessor dropConstraint: (session system tableNamed: 'PERSON') foreignKeyConstraints first].
	[
	((session system descriptorFor: GlorpPerson) mappingForAttributeNamed: #address) beExclusive.
	self setUpPersonWithAddress .

	session accessor executeSQLString: 'delete from GR_ADDRESS where ID = 2'.
	session reset.
	person := session readOneOf: GlorpPerson.
	"First, make sure this doesn't walkback"
	[session beginUnitOfWork.
	session delete: person] ensure: [session commitUnitOfWork].
	"Now make sure the address is left"
	addressRows := session accessor executeSQLString: 'SELECT * FROM GR_ADDRESS'.
	self assert: addressRows isEmpty.
	personRows :=  session accessor executeSQLString: 'SELECT * FROM PERSON'.
	self assert: personRows isEmpty.
	
	] 
		ensure: [
			session rollbackTransaction.
			session inTransactionDo: [session accessor createTableFKConstraints: (session system tableNamed: 'PERSON') ifError: [self halt]]]!

testCascadingDeleteInstantiating
	| user |
	
	[self setUpFolders.
	self checkFoldersExistInDatabase.
	user := session readOneOf: GlorpUser where: [:each | each name = 'User One'].
	session beginUnitOfWork.
	user folders do: [:each | each printString].
	session delete: user.
	session commitUnitOfWork.
	self checkFoldersNotInCache.
	self checkFoldersDeletedInDatabase.
	self checkMessagesDeletedInDatabase] 
			ensure: [session rollbackTransaction]!

testCascadingDeleteWithoutInstantiating
	| user |
	
	[self setUpFolders.
	self checkFoldersExistInDatabase.
	user := session readOneOf: GlorpUser where: [:each | each name = 'User One'].
	session beginUnitOfWork.
	session delete: user.
	session commitUnitOfWork.
	self checkFoldersNotInCache.
	self checkFoldersDeletedInDatabase] 
			ensure: [session rollbackTransaction]!

testDeleteAndReinsertTwiceWhenRemovingFromAnExclusiveCollection
	"Make sure that if we add a new thing twice, we get the expected failure of a primary key conflict."

	| user |
	[self setUpFolders.
	self checkFoldersExistInDatabase.
	user := session
		readOneOf: GlorpUser
		where: [:each | each name = 'User One'].
	self
		should: [self doDeleteAndDoubleAddOfFoldersFor: user]
		raise: GlorpDatabaseWriteError] ensure: [session rollbackTransaction].!

testDeleteAndReinsertWhenRemovingFromAnExclusiveCollection
	"Test that if we delete something and then re-insert with the same primary key, that it gets converted to an update. This is not really advisable as something to do, since you're really violating the primary key = object identity correspondence, but it can reasonably happen if you're using domain primary keys, link tables reified as objects, or other circumstances"
	| user removed result generalResult new |
	
	[self setUpFolders.
	self checkFoldersExistInDatabase.
	user := session readOneOf: GlorpUser where: [:each | each name = 'User One'].
	session modify: user in: [
		user folders do: [:each | each printString].
		removed := user folders detect: [:each | each name = 'One'].
		user folders remove: removed.
		new := GlorpFolder new name: 'One'.
		new user: user.
		user folders add: new].
	self assert: (session cacheLookupForClass: GlorpFolder key: #(1 'One')) == new.
	result := session accessor executeSQLString: 'SELECT * FROM GR_FOLDER WHERE USER_ID=1'.
	self assert: result size = 2.

	generalResult := session accessor executeSQLString: 'SELECT * FROM GR_FOLDER'.
	self assert: generalResult size = 3.

	result := session accessor executeSQLString: 'SELECT * FROM GR_MESSAGE WHERE USER_ID = 1'.
	self assert: result isEmpty.

	generalResult := session accessor executeSQLString: 'SELECT * FROM GR_MESSAGE'.
	self assert: generalResult size = 1.] 
			ensure: [session rollbackTransaction]!

testDeleteFromAnExclusiveCollectionContainingNil
	| user removed |
	
	[self setUpFolders.
	self checkFoldersExistInDatabase.
	user := session readOneOf: GlorpUser where: [:each | each name = 'User One'].
	session modify: user in: [
		user folders do: [:each | each printString].
		removed := user folders detect: [:each | each name = 'One'].
		user folders remove: removed.
		user folders add: nil]
	"The only assertion is that we shouldn't be crashing here."
	] 
			ensure: [session rollbackTransaction]!

testDeleteMultipleTable
	| passengerRow1 passengerRow2 passenger rows frequentFlyerRow1 frequentFlyerRow2 |
	
	[
	session beginTransaction.
	passengerRow1 := session system examplePassengerRow.
	session writeRow: passengerRow1.
	frequentFlyerRow1 := session system exampleFrequentFlyerRow.
	session writeRow: frequentFlyerRow1.
	passengerRow2 := session system examplePassengerRow2.
	session writeRow: passengerRow2.
	frequentFlyerRow2 := session system exampleFrequentFlyerRow2.
	session writeRow: frequentFlyerRow2.
	passenger := session readOneOf: GlorpPassenger.
	session delete: passenger.
	rows := session accessor executeSQLString: 'SELECT * FROM FREQUENT_FLYER'.
	self assert: rows size = 1.
	rows := session accessor executeSQLString: 'SELECT * FROM PASSENGER'.
	self assert: rows size = 1.
	] 
			ensure: [session rollbackTransaction]!

testDeleteMultipleTableWithOneMissing
	| passengerRow1 passengerRow2 passenger rows frequentFlyerRow2 |
	
	[
	session beginTransaction.
	passengerRow1 := session system examplePassengerRow.
	session writeRow: passengerRow1.
	passengerRow2 := session system examplePassengerRow2.
	session writeRow: passengerRow2.
	frequentFlyerRow2 := session system exampleFrequentFlyerRow2.
	session writeRow: frequentFlyerRow2.
	passenger := session readOneOf: GlorpPassenger where: [:each | each id = 1].
	session delete: passenger.
	rows := session accessor executeSQLString: 'SELECT * FROM FREQUENT_FLYER'.
	self assert: rows size = 1.
	rows := session accessor executeSQLString: 'SELECT * FROM PASSENGER'.
	self assert: rows size = 1.
	] 
			ensure: [session rollbackTransaction]!

testDeleteWhenRemovingFromAnExclusiveCollection
	| user removed result generalResult |
	
	[self setUpFolders.
	self checkFoldersExistInDatabase.
	user := session readOneOf: GlorpUser where: [:each | each name = 'User One'].
	session modify: user in: [
		user folders do: [:each | each printString].
		removed := user folders detect: [:each | each name = 'One'].
		user folders remove: removed].
	self assert: (session cacheLookupForClass: GlorpFolder key: #(1 'One')) isNil.
	result := session accessor executeSQLString: 'SELECT * FROM GR_FOLDER WHERE USER_ID=1'.
	self assert: result size = 1.

	generalResult := session accessor executeSQLString: 'SELECT * FROM GR_FOLDER'.
	self assert: generalResult size = 2.

	result := session accessor executeSQLString: 'SELECT * FROM GR_MESSAGE WHERE USER_ID = 1'.
	self assert: result isEmpty.

	generalResult := session accessor executeSQLString: 'SELECT * FROM GR_MESSAGE'.
	self assert: generalResult size = 1.] 
			ensure: [session rollbackTransaction]!

testNormalDeleteOnFolders
	| user |
	
	[self setUpFolders.
	self checkFoldersExistInDatabase.
	user := session readOneOf: GlorpUser where: [:each | each name = 'User One'].
	session beginUnitOfWork.
	session delete: user.
	user folders do: [:each | 
		session delete: each.
		each messages do: [:eachMessage |
			session delete: eachMessage]].
	session commitUnitOfWork.
	self checkFoldersNotInCache.
	self checkFoldersDeletedInDatabase.
	self checkMessagesDeletedInDatabase] 
			ensure: [session rollbackTransaction]!

testUnitOfWorkDelete
	| customer result |
	
	[customer := self setUpCustomer.
	session beginUnitOfWork.
	session delete: customer.
	result := session accessor 
				executeSQLString: 'SELECT * FROM GR_CUSTOMER WHERE ID=1'.
	self assert: result size = 1.
	self 
		assert: (session readOneOf: GlorpCustomer where: [:each | each id = 1]) isNil.
	self checkCustomerStillInCache.
	session commitUnitOfWork.
	self checkCustomerNotInCache.
	self checkCustomerDeletedInDatabase] 
			ensure: [session rollbackTransaction]!

testUnitOfWorkDeleteOrder
	| person |
	
	[person := self setUpPersonWithAddress.
	session beginUnitOfWork.
	session delete: person.
	session delete: person address.
	session commitUnitOfWork.
	self checkPersonDeletedInDatabase.] 
			ensure: [session rollbackTransaction]! !
!GlorpDeleteTest categoriesFor: #checkCustomerDeletedInDatabase!private!tests! !
!GlorpDeleteTest categoriesFor: #checkCustomerNotInCache!private!tests! !
!GlorpDeleteTest categoriesFor: #checkCustomerStillInCache!private!tests! !
!GlorpDeleteTest categoriesFor: #checkFoldersDeletedInDatabase!private!tests! !
!GlorpDeleteTest categoriesFor: #checkFoldersExistInDatabase!private!tests! !
!GlorpDeleteTest categoriesFor: #checkFoldersNotInCache!private!tests! !
!GlorpDeleteTest categoriesFor: #checkMessagesDeletedInDatabase!private!tests! !
!GlorpDeleteTest categoriesFor: #checkPersonDeletedInDatabase!private!tests! !
!GlorpDeleteTest categoriesFor: #doDeleteAndDoubleAddOfFoldersFor:!private!tests! !
!GlorpDeleteTest categoriesFor: #setUp!private!support! !
!GlorpDeleteTest categoriesFor: #setUpCustomer!private!tests! !
!GlorpDeleteTest categoriesFor: #setUpFolders!private!support! !
!GlorpDeleteTest categoriesFor: #setUpPersonWithAddress!private!tests! !
!GlorpDeleteTest categoriesFor: #tearDown!private!support! !
!GlorpDeleteTest categoriesFor: #testCascadingDeleteAcrossNil!private!tests! !
!GlorpDeleteTest categoriesFor: #testCascadingDeleteInstantiating!private!tests! !
!GlorpDeleteTest categoriesFor: #testCascadingDeleteWithoutInstantiating!private!tests! !
!GlorpDeleteTest categoriesFor: #testDeleteAndReinsertTwiceWhenRemovingFromAnExclusiveCollection!private!tests! !
!GlorpDeleteTest categoriesFor: #testDeleteAndReinsertWhenRemovingFromAnExclusiveCollection!private!tests! !
!GlorpDeleteTest categoriesFor: #testDeleteFromAnExclusiveCollectionContainingNil!private!tests! !
!GlorpDeleteTest categoriesFor: #testDeleteMultipleTable!private!tests! !
!GlorpDeleteTest categoriesFor: #testDeleteMultipleTableWithOneMissing!private!tests! !
!GlorpDeleteTest categoriesFor: #testDeleteWhenRemovingFromAnExclusiveCollection!private!tests! !
!GlorpDeleteTest categoriesFor: #testNormalDeleteOnFolders!private!tests! !
!GlorpDeleteTest categoriesFor: #testUnitOfWorkDelete!private!tests! !
!GlorpDeleteTest categoriesFor: #testUnitOfWorkDeleteOrder!private!tests! !

GlorpInsertUpdateTest guid: (GUID fromString: '{03A0417F-CA86-4033-966E-315D2ED56269}')!
GlorpInsertUpdateTest comment: ''!
!GlorpInsertUpdateTest categoriesForClass!Unclassified! !
!GlorpInsertUpdateTest methodsFor!

rowFor: anObject

	| rowMap rows |
	rowMap := RowMap new.
	session createRowsFor: anObject in: rowMap.
	rows := rowMap rowsForKey: anObject.
	self assert: rows size = 1.
	^rows first.!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.!

testFunctionalInsertUpdateForInsert

	| testObject |
	[session beginTransaction.
	session beginUnitOfWork.
	testObject := GlorpCustomer example1.
	testObject id: 876.
	session register: testObject.
	session commitUnitOfWork.
	self assert: (testObject seenPreWrite = true).
	self assert: (testObject seenPostWrite = true).

	session beginUnitOfWork.
	session register: testObject.
	testObject name: 'Change of name'.
	session commitUnitOfWork]
		ensure: [session rollbackTransaction]!

testRowOwnership

	| aCustomer rowMap |
	aCustomer := GlorpCustomer new.
	rowMap := RowMap new.
	(session descriptorFor: GlorpCustomer) createRowsFor: aCustomer in: rowMap.
	rowMap rowsDo: [:each | 
		self assert: each owner = aCustomer].!

testShouldInsertForInsert

	| testObject row |
	testObject := GlorpCustomer example1.
	testObject id: 876.
	row :=self rowFor: testObject.
	self assert: (session shouldInsert: row).!

testShouldInsertForUpdate

	| testObject row |
	session beginUnitOfWork.
	testObject := GlorpCustomer example1.
	testObject id: 876.
	session cacheAt: 876 put: testObject.
	row :=self rowFor: testObject.
	self deny: (session shouldInsert: row).! !
!GlorpInsertUpdateTest categoriesFor: #rowFor:!private!support! !
!GlorpInsertUpdateTest categoriesFor: #setUp!private!support! !
!GlorpInsertUpdateTest categoriesFor: #testFunctionalInsertUpdateForInsert!private!tests! !
!GlorpInsertUpdateTest categoriesFor: #testRowOwnership!private!tests! !
!GlorpInsertUpdateTest categoriesFor: #testShouldInsertForInsert!private!tests! !
!GlorpInsertUpdateTest categoriesFor: #testShouldInsertForUpdate!private!tests! !

!GlorpInsertUpdateTest class methodsFor!

resources

	^Array with: (Smalltalk at: #GlorpSessionResource).! !
!GlorpInsertUpdateTest class categoriesFor: #resources!private!resources! !

GlorpMappingDBTest guid: (GUID fromString: '{2224AC97-ADF3-4F5E-9FBB-557939736249}')!
GlorpMappingDBTest comment: ''!
!GlorpMappingDBTest categoriesForClass!Unclassified! !
!GlorpMappingDBTest methodsFor!

inTransactionDo: aBlock
	[session beginTransaction.
	aBlock value] ensure: [session rollbackTransaction].!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	system := session system.!

tearDown
	super tearDown.
	session reset.
	session resetPermissions.
	session := nil.
	system := nil.! !
!GlorpMappingDBTest categoriesFor: #inTransactionDo:!private!support! !
!GlorpMappingDBTest categoriesFor: #setUp!private!Running! !
!GlorpMappingDBTest categoriesFor: #tearDown!private!support! !

!GlorpMappingDBTest class methodsFor!

isAbstract
	^self sunitName = #GlorpMappingDBTest!

resources
	^Array with: (Smalltalk at: #GlorpSessionResource).! !
!GlorpMappingDBTest class categoriesFor: #isAbstract!private!testing! !
!GlorpMappingDBTest class categoriesFor: #resources!private!resources! !

GlorpPartialWritesTest guid: (GUID fromString: '{513EE1D4-0538-46B2-8329-B8832F3B11D0}')!
GlorpPartialWritesTest comment: ''!
!GlorpPartialWritesTest categoriesForClass!Unclassified! !
!GlorpPartialWritesTest methodsFor!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.!

testNoDifferenceNoWrite
self todo!

testWritingNewObject
self todo!

testWritingObjectWithAddedComponent
self todo!

testWritingObjectWithChangedAttribute
self todo!

testWritingObjectWithChangedComponent
self todo!

testWritingObjectWithChangedComponentAttribute
self todo!

testWritingObjectWithDeletedComponent
self todo!

testWritingObjectWithDeletedRelationship
self todo! !
!GlorpPartialWritesTest categoriesFor: #setUp!private!support! !
!GlorpPartialWritesTest categoriesFor: #testNoDifferenceNoWrite!private!tests! !
!GlorpPartialWritesTest categoriesFor: #testWritingNewObject!private!tests! !
!GlorpPartialWritesTest categoriesFor: #testWritingObjectWithAddedComponent!private!tests! !
!GlorpPartialWritesTest categoriesFor: #testWritingObjectWithChangedAttribute!private!tests! !
!GlorpPartialWritesTest categoriesFor: #testWritingObjectWithChangedComponent!private!tests! !
!GlorpPartialWritesTest categoriesFor: #testWritingObjectWithChangedComponentAttribute!private!tests! !
!GlorpPartialWritesTest categoriesFor: #testWritingObjectWithDeletedComponent!private!tests! !
!GlorpPartialWritesTest categoriesFor: #testWritingObjectWithDeletedRelationship!private!tests! !

GlorpProxyTest guid: (GUID fromString: '{3951FA12-EC68-4F50-B4BF-65F6910629CB}')!
GlorpProxyTest comment: ''!
!GlorpProxyTest categoriesForClass!Unclassified! !
!GlorpProxyTest methodsFor!

setUp
	| stub |
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	proxy := Proxy new.
	proxy session: session.
	stub := (Smalltalk at: #GlorpQueryStub) returningOneOf: GlorpAddress where: [:address | address id = 1].
	stub result: 42.
	proxy query: stub.
	proxy parameters: #()!

testAdHocProxy
	"Some dialects (e.g. VA) inline yourself so we must send yourSelf."

	| p |
	p := AdHocProxy readBlock: ['instantiated!!'].
	self assert: p printString = '{uninstantiated AdHocProxy}'.
	self assert: p isInstantiated not.
	p yourSelf.
	self assert: p isInstantiated.
	self assert: p printString = '{''instantiated!!''}'.
	p uninstantiate.
	self deny: p isInstantiated.!

testCreation
	| otherProxy |
	self deny: proxy isInstantiated.
	otherProxy := Proxy new.
	self deny: otherProxy isInstantiated.!

testInstantiationFromStub

	self assert: (proxy getValue notNil).
	self assert: proxy = 42.
	self assert: proxy isInstantiated.!

testPrintingInstantiated

	proxy getValue.
	self assert: proxy printString = ('{', proxy getValue printString, '}').!

testPrintingUninstantiated

	self assert: proxy printString = '{uninstantiated GlorpAddress}'.!

testPrintingUninstantiatedCollection
	proxy query readsOneObject: false.
	self assert: proxy printString = '{uninstantiated collection of GlorpAddress}'.! !
!GlorpProxyTest categoriesFor: #setUp!public!support! !
!GlorpProxyTest categoriesFor: #testAdHocProxy!private!tests! !
!GlorpProxyTest categoriesFor: #testCreation!private!tests! !
!GlorpProxyTest categoriesFor: #testInstantiationFromStub!private!tests! !
!GlorpProxyTest categoriesFor: #testPrintingInstantiated!private!tests! !
!GlorpProxyTest categoriesFor: #testPrintingUninstantiated!private!tests! !
!GlorpProxyTest categoriesFor: #testPrintingUninstantiatedCollection!private!tests! !

!GlorpProxyTest class methodsFor!

resources

	^Array with: (Smalltalk at: #GlorpSessionResource).! !
!GlorpProxyTest class categoriesFor: #resources!private!resources! !

GlorpReadingDifferentCollectionsTest guid: (GUID fromString: '{C3A6E5A3-60F8-4993-A1EB-A8D024307DA3}')!
GlorpReadingDifferentCollectionsTest comment: ''!
!GlorpReadingDifferentCollectionsTest categoriesForClass!Unclassified! !
!GlorpReadingDifferentCollectionsTest methodsFor!

check: aClass
	| collectionClass |
	collectionClass := aClass isBehavior ifTrue: [aClass] ifFalse: [aClass class].
	singleQuery collectionType: aClass.
	allQuery collectionType: aClass.
	singleResult := session execute: singleQuery.
	allResult := session execute: allQuery.
	self assert: singleResult class == collectionClass.
	self assert: allResult class == collectionClass.
	self assert: singleResult size = 1.
	self assert: allResult size = 2.!

setUp
	
	| |
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	system := session system.
	session beginTransaction.
	self writeAccountRows.
	singleQuery := Query returningManyOf: GlorpBankAccount
				where: [:passenger | passenger id = 6].
	allQuery := Query returningManyOf: GlorpBankAccount.!

tearDown

	session rollbackTransaction.!

testArray
	self check: Array.!

testBlank
	singleResult := session execute: singleQuery.
	allResult := session execute: allQuery.
	self assert: singleResult class == Array.
	self assert: allResult class == Array.
	self assert: singleResult size = 1.
	self assert: allResult size = 2.!

testOrderedCollection
	self check: OrderedCollection.!

testSet
	self check: Set.!

testSortedCollection
	self check: SortedCollection.
	self assert: allResult first <= allResult last.!

testSortedCollectionReversed
	self check: (SortedCollection sortBlock: [:a :b | b <= a]).
	self assert: allResult last <= allResult first.!

writeAccountRows
	| accountRow1 accountRow2 |

	accountRow1 := session system exampleAccountRow1. 
	accountRow2 := session system exampleAccountRow2.
	session writeRow: accountRow1.
	session writeRow: accountRow2.! !
!GlorpReadingDifferentCollectionsTest categoriesFor: #check:!private!tests! !
!GlorpReadingDifferentCollectionsTest categoriesFor: #setUp!private!setup! !
!GlorpReadingDifferentCollectionsTest categoriesFor: #tearDown!private!setup! !
!GlorpReadingDifferentCollectionsTest categoriesFor: #testArray!private!tests! !
!GlorpReadingDifferentCollectionsTest categoriesFor: #testBlank!private!tests! !
!GlorpReadingDifferentCollectionsTest categoriesFor: #testOrderedCollection!private!tests! !
!GlorpReadingDifferentCollectionsTest categoriesFor: #testSet!private!tests! !
!GlorpReadingDifferentCollectionsTest categoriesFor: #testSortedCollection!private!tests! !
!GlorpReadingDifferentCollectionsTest categoriesFor: #testSortedCollectionReversed!private!tests! !
!GlorpReadingDifferentCollectionsTest categoriesFor: #writeAccountRows!private!setup! !

GlorpReadingDifferentCollectionsThroughMappingsTest guid: (GUID fromString: '{793C216F-F9D4-47AB-B439-B30CD6FD4D47}')!
GlorpReadingDifferentCollectionsThroughMappingsTest comment: ''!
!GlorpReadingDifferentCollectionsThroughMappingsTest categoriesForClass!Unclassified! !
!GlorpReadingDifferentCollectionsThroughMappingsTest methodsFor!

descriptorClass
	^GlorpCollectionTypesDescriptorSystem.!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	system := self descriptorClass forPlatform: session platform.
	session system: system.
	session beginTransaction.!

tearDown
	super tearDown.
	session rollbackTransaction.!

testReadBack
	"Some dialects (e.g. VA) inline yourself so we must send yourSelf."

	| thing list |
	self writeRows.
	session reset.
	list := session readManyOf: GlorpThingWithLotsOfDifferentCollections.
	self assert: list size = 1.
	thing := list first.
	self assert: thing array size = 3.
	self
		assert:
			(self validateFor: thing array against: #('array1' 'array2' 'array3')).
	self assert: thing array yourSelf class = Array.
	self assert: thing set size = 2.
	self assert: thing set yourSelf class = Set.
	self assert: (self validateFor: thing set against: #('set1' 'set2')).
	self assert: thing orderedCollection size = 2.
	self assert: thing orderedCollection yourSelf class = OrderedCollection.
	self
		assert:
			(self
				validateFor: thing orderedCollection
				against: #('orderedCollection1' 'orderedCollection2')).
	self assert: thing orderedCollection first name = 'orderedCollection1'.
	self assert: thing bag size = 2.
	self assert: thing bag yourSelf class = Bag.
	self assert: (self validateFor: thing bag against: #('bag1' 'bag2')).
	self assert: thing sortedCollection size = 4.
	self assert: thing sortedCollection yourSelf class = SortedCollection.
	self assert:
			(thing sortedCollection collect: [:each | each name]) asArray
				= #('sorted1' 'sorted2' 'sorted3' 'sorted4').!

testReadBackOneOfSeveral
	"Some dialects (e.g. VA) inline yourself so we must send yourSelf."

	| thing list |
	self writeMore.
	session reset.
	list := session readManyOf: GlorpThingWithLotsOfDifferentCollections where: [:each | each name = 'fred'].
	self assert: list size = 1.
	thing := list first.
	self assert: thing array size = 3.
	self
		assert:
			(self validateFor: thing array against: #('array1' 'array2' 'array3')).
	self assert: thing array yourSelf class = Array.
	self assert: thing set size = 2.
	self assert: thing set yourSelf class = Set.
	self assert: (self validateFor: thing set against: #('set1' 'set2')).
	self assert: thing orderedCollection size = 2.
	self assert: thing orderedCollection yourSelf class = OrderedCollection.
	self
		assert:
			(self
				validateFor: thing orderedCollection
				against: #('orderedCollection1' 'orderedCollection2')).
	self assert: thing bag size = 2.
	self assert: thing bag yourSelf class = Bag.
	self assert: (self validateFor: thing bag against: #('bag1' 'bag2')).
	self assert: thing sortedCollection size = 4.
	self assert: thing sortedCollection yourSelf class = SortedCollection.
	self assert:
			(thing sortedCollection collect: [:each | each name]) asArray
				= #('sorted1' 'sorted2' 'sorted3' 'sorted4').!

testReadCollectionWithOrder
	| thing list |
	session transact: [session register: GlorpThingWithLotsOfDifferentCollections exampleForOrdering].
	session reset.
	list := session readManyOf: GlorpThingWithLotsOfDifferentCollections.
	self assert: list size = 1.
	thing := list first.
	self assert: thing orderedCollection size = 6.
	self
		assert:
			(thing orderedCollection collect: [:each | each name]) asArray = #('oc6' 'oc5' 'oc4' 'oc3' 'oc7' 'oc8')!

testReadManyToManyWithOrder
	| thing list |
	session transact: [session register: GlorpThingWithLotsOfDifferentCollections exampleForOrdering].
	session reset.
	list := session readManyOf: GlorpThingWithLotsOfDifferentCollections.
	self assert: list size = 1.
	thing := list first.
	self assert: thing orderedCollection size = 6.
	self
		assert:
			(thing orderedCollection collect: [:each | each name]) asArray = #('oc6' 'oc5' 'oc4' 'oc3' 'oc7' 'oc8')!

testReadOneToManyWithOrder
	| thing list |
	session transact: [session register: GlorpThingWithLotsOfDifferentCollections exampleForOrdering].
	session reset.
	list := session readManyOf: GlorpThingWithLotsOfDifferentCollections.
	self assert: list size = 1.
	thing := list first.
	self assert: thing array size = 6.
	self
		assert:
			(thing array collect: [:each | each name]) asArray = #('a1' 'a2' 'a3' 'a9' 'a8' 'a7')!

validateFor: aCollection against: expectedArrayContents
	^(aCollection collect: [:each | each name]) asSortedCollection asArray
		= expectedArrayContents.!

writeMore

	| other |
	session transact: [
		session register: GlorpThingWithLotsOfDifferentCollections example1.
		other := GlorpThingWithLotsOfDifferentCollections example1.
		other name: 'barney'.
		session register: other].!

writeRows

	session transact: [
		session register: GlorpThingWithLotsOfDifferentCollections example1].! !
!GlorpReadingDifferentCollectionsThroughMappingsTest categoriesFor: #descriptorClass!private!setup! !
!GlorpReadingDifferentCollectionsThroughMappingsTest categoriesFor: #setUp!private!setup! !
!GlorpReadingDifferentCollectionsThroughMappingsTest categoriesFor: #tearDown!private!setup! !
!GlorpReadingDifferentCollectionsThroughMappingsTest categoriesFor: #testReadBack!private!tests! !
!GlorpReadingDifferentCollectionsThroughMappingsTest categoriesFor: #testReadBackOneOfSeveral!private!tests! !
!GlorpReadingDifferentCollectionsThroughMappingsTest categoriesFor: #testReadCollectionWithOrder!private!tests! !
!GlorpReadingDifferentCollectionsThroughMappingsTest categoriesFor: #testReadManyToManyWithOrder!private!tests! !
!GlorpReadingDifferentCollectionsThroughMappingsTest categoriesFor: #testReadOneToManyWithOrder!private!tests! !
!GlorpReadingDifferentCollectionsThroughMappingsTest categoriesFor: #validateFor:against:!private!tests! !
!GlorpReadingDifferentCollectionsThroughMappingsTest categoriesFor: #writeMore!private!setup! !
!GlorpReadingDifferentCollectionsThroughMappingsTest categoriesFor: #writeRows!private!setup! !

!GlorpReadingDifferentCollectionsThroughMappingsTest class methodsFor!

resources
	^Array with: GlorpDatabaseLoginResource with: GlorpDemoTablePopulatorResource with: (Smalltalk at: #GlorpSessionResource).! !
!GlorpReadingDifferentCollectionsThroughMappingsTest class categoriesFor: #resources!private!resources! !

GlorpReadingPersonWithEmailAddressesTest guid: (GUID fromString: '{1048EE41-449F-4B52-A5D6-AFF4BB876CA6}')!
GlorpReadingPersonWithEmailAddressesTest comment: ''!
!GlorpReadingPersonWithEmailAddressesTest categoriesForClass!Unclassified! !
!GlorpReadingPersonWithEmailAddressesTest methodsFor!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	session beginTransaction.
	addressRow := session system exampleAddressRow.
	session writeRow: addressRow.
	personRow := session system examplePersonRow1.
	session writeRow: personRow.
	emailAddress1Row := session system exampleEmailAddressRow1.
	emailAddress2Row := session system exampleEmailAddressRow2.
	id1 := emailAddress1Row at: (emailAddress1Row table fieldNamed: 'ID').
	id2 := emailAddress2Row at: (emailAddress2Row table fieldNamed: 'ID').
	session writeRow: emailAddress1Row.
	session writeRow: emailAddress2Row.!

tearDown
	super tearDown.
	session rollbackTransaction.
	session reset.
	session := nil.!

testObjectsNotAddedTwiceWhenReadingMultipleObjectsOneToMany
	"Read in the objects first, so they're in cache. Make sure they don't get the collection built up twice."
	| people |

	people := session readManyOf: GlorpPerson.
	self testReadMultipleObjectsOneToMany.
	^people.!

testPreparedStatementsAreFaster
	"Not really a good test, since there are lots of other factors. And since we don't support this on all dialects/databases, they might easily be the same. Maybe should remove this test, but on the other hand it's the most useful feedback that the prepared statements are actually good for something"
	| timePrepared timeUnPrepared| 
	session reusePreparedStatements: true.
	session reset.
	timeUnPrepared := Time millisecondsToRun: [
		session readManyOf: GlorpPerson where: [:eachPerson | eachPerson id = 3].
		session readManyOf: GlorpPerson where: [:eachPerson | eachPerson id ~= 3].
		session readManyOf: GlorpPerson where: [:eachPerson | eachPerson id >= 3]].
	session reset.
	timePrepared := Time millisecondsToRun: [
		3 timesRepeat: [ | query |
			query := Query returningManyOf: GlorpPerson where: [:eachPerson | eachPerson id = (eachPerson parameter: 1)].
			query executeWithParameters: #(3) in: session]].
	(session accessor numberOfPreparedStatements < 1) ifTrue: [^self "Unsupported, don't bother testing"].
	Transcript cr; show: 'Time reusing prepared statements = ', timePrepared printString.
	Transcript cr; show: 'Time not reusing prepared statements = ', timeUnPrepared printString.
	"Give a little bit of room, so if they take roughly the same amount of time it'll still pass"
	self assert: (timePrepared * 0.8 )< timeUnPrepared.!

testPreparedStatementsAreReused

	| | 
	"This test only makes sense if binding is on" 
	session useBinding ifFalse: [^self].
	session reusePreparedStatements: true.
	session reset.
	session readManyOf: GlorpPerson where: [:eachPerson | eachPerson id = 3].
	session readManyOf: GlorpPerson where: [:eachPerson | eachPerson id ~= 3].
	session readManyOf: GlorpPerson where: [:eachPerson | eachPerson id >= 3].
	self assert: session accessor numberOfPreparedStatements = 3.
	session reset.
	1 to: 3 do: [:i | | query |
			query := Query returningManyOf: GlorpPerson where: [:eachPerson | eachPerson id = (eachPerson parameter: 1)].
			query executeWithParameters: (Array with: i) in: session].
	self assert: session accessor numberOfPreparedStatements = 1.!

testReadMultipleObjectsOneToMany
	| query result person addresses |

	query := Query returningManyOf: GlorpPerson where: [:eachPerson | eachPerson id = 3].
	query alsoFetch: [:each | each emailAddresses].
	result := query executeIn: session.
	self assert: result size = 1.
	person := result first.
	addresses := person emailAddresses.
	self deny: addresses isGlorpProxy.
	self assert: addresses size = 2.
	self 
		assert: (addresses first id = id1 or: [addresses last id = id1]).
	self 
		assert: (addresses first id = id2 or: [addresses last id = id2]).
	self assert: addresses first id ~= addresses last id.!

testReadPersonWithEmailAddresses
	| query result emailAddresses |
	query := Query
		returningOneOf:GlorpPerson
		where: [:person | person id = 3].
	result := query executeIn: session.
	emailAddresses := result emailAddresses getValue.
	self assert: emailAddresses size = 2.
	self
		assert:
			(emailAddresses first id = id1 or: [emailAddresses last id = id1]).
	self
		assert:
			(emailAddresses first id = id2 or: [emailAddresses last id = id2]).
	self assert: emailAddresses first id ~= emailAddresses last id.! !
!GlorpReadingPersonWithEmailAddressesTest categoriesFor: #setUp!private!support! !
!GlorpReadingPersonWithEmailAddressesTest categoriesFor: #tearDown!private!support! !
!GlorpReadingPersonWithEmailAddressesTest categoriesFor: #testObjectsNotAddedTwiceWhenReadingMultipleObjectsOneToMany!private!tests! !
!GlorpReadingPersonWithEmailAddressesTest categoriesFor: #testPreparedStatementsAreFaster!private!tests! !
!GlorpReadingPersonWithEmailAddressesTest categoriesFor: #testPreparedStatementsAreReused!private!tests! !
!GlorpReadingPersonWithEmailAddressesTest categoriesFor: #testReadMultipleObjectsOneToMany!private!tests! !
!GlorpReadingPersonWithEmailAddressesTest categoriesFor: #testReadPersonWithEmailAddresses!private!tests! !

!GlorpReadingPersonWithEmailAddressesTest class methodsFor!

resources
	^Array with: (Smalltalk at: #GlorpSessionResource).! !
!GlorpReadingPersonWithEmailAddressesTest class categoriesFor: #resources!private!resources! !

GlorpReadingTest guid: (GUID fromString: '{BCB870CC-C077-485B-AB1E-2C4302264A13}')!
GlorpReadingTest comment: 'This tests the full reading mechanism, writing out some rows manually and then doing various read operations.

Instance Variables:
	session	<Session>	
	system	<GlorpDemoDescriptorSystem>	

'!
!GlorpReadingTest categoriesForClass!Unclassified! !
!GlorpReadingTest methodsFor!

checkExpiryTime
	""
	| rowToWrite address modifiedRow expiryTime newExpiryTime |
	
	[session beginTransaction.
	rowToWrite := session system exampleAddressRow.
	session writeRow: rowToWrite.
	address := session readOneOf: GlorpAddress
				where: [:each | each id = 123].
	expiryTime := ((session cacheFor: address) basicAt: 123 ifAbsent: [#(nil)]) at: 1.
	modifiedRow := session system exampleModifiedAddressRow.
	modifiedRow owner: address. "Otherwise it thinks it's an insert"
	session writeRow: modifiedRow.
	(Delay forSeconds: 1) wait.
	address := session readOneOf: GlorpAddress
				where: [:each | each id = 123].
	newExpiryTime := ((session cacheFor: address) basicAt: 123 ifAbsent: [#(nil)]) at: 1.
	self assert: newExpiryTime > expiryTime.
	self assert: address street = 'Paseo Montril'] 
			ensure: [session rollbackTransaction].!

checkExpiryTime: aBlock
	""
	| rowToWrite address modifiedRow expiryTime newExpiryTime |
	
	[session beginTransaction.
	rowToWrite := session system exampleAddressRow.
	session writeRow: rowToWrite.
	address := session readOneOf: GlorpAddress
				where: [:each | each id = 123].
	expiryTime := ((session cacheFor: address) basicAt: 123 ifAbsent: [#(nil)]) at: 1.
	modifiedRow := session system exampleModifiedAddressRow.
	modifiedRow owner: address. "Otherwise it thinks it's an insert"
	session writeRow: modifiedRow.
	(Delay forSeconds: 1) wait.
	address := session readOneOf: GlorpAddress
				where: [:each | each id = 123].
	newExpiryTime := ((session cacheFor: address) basicAt: 123 ifAbsent: [#(nil)]) at: 1.
	aBlock value: expiryTime value: newExpiryTime value: address] 
			ensure: [session rollbackTransaction].!

checkRefreshDoing: aBlock
	"Check that we refresh correctly doing the action specified by aBlock"
	| rowToWrite address modifiedRow |
	
	[session beginTransaction.
	rowToWrite := session system exampleAddressRow.
	session writeRow: rowToWrite.
	address := session readOneOf: GlorpAddress
				where: [:each | each id = 123].
	modifiedRow := session system exampleModifiedAddressRow.
	modifiedRow owner: address. "Otherwise it thinks it's an insert"
	session writeRow: modifiedRow.
	aBlock value: address.
	self assert: address street = 'Something Else'.] 
			ensure: [session rollbackTransaction].!

helperForTestReadEmbeddedOneToOne
	| transRow query result |
	
	[session beginTransaction.
	transRow := session system exampleBankTransactionRow.
	session writeRow: transRow.
	query := Query returningOneOf: GlorpBankTransaction
				where: [:each | each id = each id].
	result := query executeIn: session] 
			ensure: [session rollbackTransaction].
	self assert: result serviceCharge notNil.
	self assert: result serviceCharge description = 'additional overcharge'.
	self assert: result amount currency = #CDN.
	self assert: result amount amount = 7.
	self assert: result serviceCharge amount currency = #USD.
	self assert: result serviceCharge amount amount = 2.
	^result.!

session
	^session.!

session: anObject
	session := anObject!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	system := session system.!

tearDown
	super tearDown.
	session reset.
	session := nil.
	system := nil.!

testCompoundAND
	| object query results rowToWrite |
	
	[session beginTransaction.
	rowToWrite := session system exampleAddressRow.
	session writeRow: rowToWrite.
	query := Query returningManyOf: GlorpAddress
				where: [:address | address id < 124 AND: (address id  > 122) AND: (address id ~= nil)].
	results := query executeIn: session] 
			ensure: [session rollbackTransaction].
	self assert: results size = 1.
	object := results first.
	self assert: object class = GlorpAddress.
	self assert: object id = 123.
	self assert: object street = 'Paseo Montril'.
	self assert: object number = '10185'!

testConversionOnConstantQueryParams
	| query result transRow | 
	
	[
	session beginTransaction.
	transRow := session system exampleBankTransactionRow.
	session writeRow: transRow.
	query := Query returningManyOf: GlorpBankTransaction where: [:trans | trans amount currency = #CDN].
	result := session execute: query.
	self assert: result size = 1.
	self assert: result first amount amount = 7] 
			ensure: [session rollbackTransaction]!

testConversionOnConstantQueryParams2
	| query result transRow |
	
	[
	session beginTransaction.
	transRow := session system exampleBankTransactionRow.
	session writeRow: transRow.
	query := Query returningManyOf: GlorpBankTransaction where: [:trans | trans amount amount = 7].
	result := session execute: query.
	self assert: result size = 1.
	self assert: result first amount amount = 7] 
			ensure: [session rollbackTransaction]!

testCount
	| query result account extraAccount |
	
	[session beginTransaction.
	self writeCustomer1Rows.
	extraAccount := session system exampleAccountRow3.
	session writeRow: extraAccount.


	query := Query returningManyOf: GlorpBankAccount.
	query retrieve: [:each | each id count].
	result := query executeIn: session.
	self assert: result size = 1.
	self assert: result first = 3.
	account := result first] 
			ensure: [session rollbackTransaction]!

testCountOnRelatedAttribute
	| query result account extraAccount |
	
	[session beginTransaction.
	self writeCustomer1Rows.
	extraAccount := session system exampleAccountRow3.
	session writeRow: extraAccount.


	query := Query returningManyOf: GlorpBankAccount.
	query retrieve: [:each | each accountHolders id count].
	result := query executeIn: session.
	self assert: result size = 1.
	self assert: result first = 2.
	account := result first] 
			ensure: [session rollbackTransaction]!

testCountStar
	| query result account extraAccount |
	
	[session beginTransaction.
	self writeCustomer1Rows.
	extraAccount := session system exampleAccountRow3.
	session writeRow: extraAccount.


	query := Query returningManyOf: GlorpBankAccount.
	query retrieve: [:each | each countStar].
	result := query executeIn: session.
	self assert: result size = 1.
	self assert: result first = 3.
	account := result first] 
			ensure: [session rollbackTransaction]!

testCountStarInRetrieveWithConstants
	| query result account extraAccount |
	
	[session beginTransaction.
	self writeCustomer1Rows.
	extraAccount := session system exampleAccountRow3.
	session writeRow: extraAccount.


	query := Query returningManyOf: GlorpBankAccount.
	query session: session.
	query retrieve: [:each | each countStar].
	query retrieve: [:each | 'X'].
	result := query executeIn: session.
	self assert: result size = 1.
	self assert: result first = #(3 'X').
	account := result first] 
			ensure: [session rollbackTransaction]!

testCountStarOnRelatedObject
	| query result account extraAccount |
	
	[session beginTransaction.
	self writeCustomer1Rows.
	extraAccount := session system exampleAccountRow3.
	session writeRow: extraAccount.

	query := Query returningManyOf: GlorpBankAccount.
	query retrieve: [:each | each accountHolders countStar].
	result := query executeIn: session.
	self assert: result size = 1.
	self assert: result first = 2.
	account := result first] 
			ensure: [session rollbackTransaction]!

testCountStarOnRelatedObjectAttribute
	| query result account extraAccount |
	
	[session beginTransaction.
	self writeCustomer1Rows.
	extraAccount := session system exampleAccountRow3.
	session writeRow: extraAccount.


	query := Query returningManyOf: GlorpBankAccount.
	query retrieve: [:each | each accountHolders id countStar].
	result := query executeIn: session.
	self assert: result size = 1.
	self assert: result first = 2.
	account := result first] 
			ensure: [session rollbackTransaction]!

testCountStarOnRelatedObjectWithGroupBy
	| query result extraAccount |
	
	[session beginTransaction.
	self writeCustomer1Rows.
	extraAccount := session system exampleAccountRow3.
	session writeRow: extraAccount.

	query := Query returningManyOf: GlorpBankAccount.
	query retrieve: [:each | each accountHolders countStar].
	query groupBy: [:each | each id].
	result := query executeIn: session.
	self assert: result = #(1 1 )] 
			ensure: [session rollbackTransaction]!

testCustomSQLInAccountsMapping
	"Test using custom sql for the mapping's query. This will only work if using binding."

	| query id1 id2 result accounts backRef1 backRef2 accountIds |
	session useBinding ifFalse: [^self].
	((session system descriptorFor: GlorpCustomer) 
		mappingForAttributeNamed: #accounts)
			query sql: 'SELECT t1.ID, t1.BANK_CODE, t1.BRANCH_NO, t1.ACCT_NO
 FROM BANK_ACCT t1, CUSTOMER_ACCT_LINK t2
 WHERE ((t2.ACCT_ID = t1.ID) AND (t2.CUSTOMER_ID = ?))'.
	[session beginTransaction.
	accountIds := self writeCustomer1Rows.
	id1 := accountIds at: 1.
	id2 := accountIds at: 2.
	query := Query returningOneOf: GlorpCustomer
				where: [:person | person id = 27].
	result := session execute: query.
	accounts := result accounts getValue.
	self assert: accounts size = 2.
	self assert: (accounts first id = id1 or: [accounts last id = id1]).
	self assert: (accounts first id = id2 or: [accounts last id = id2]).
	self assert: accounts first id ~= accounts last id.
	backRef1 := accounts first accountHolders getValue.
	self assert: backRef1 size = 1.
	self assert: backRef1 first = result.
	backRef2 := accounts first accountHolders getValue.
	self assert: backRef2 size = 1.
	self assert: backRef2 first = result] 
			ensure: [session rollbackTransaction]!

testCustomSQLInAddressMapping
	| object query results rowToWrite |
	
	[session beginTransaction.
	rowToWrite := session system exampleAddressRow.
	session writeRow: rowToWrite.
	query := Query returningManyOf: GlorpAddress.
	query sql: 'select id, street, house_num from gr_address where id = 123'.
	results := query executeIn: session] 
			ensure: [session rollbackTransaction].
	self assert: results size = 1.
	object := results first.
	self assert: object class = GlorpAddress.
	self assert: object id = 123.
	self assert: object street = 'Paseo Montril'.
	self assert: object number = '10185'!

testDeletedObjectsNotReadInManyQuery
	| query anAccount accounts someAccountId |
	[session beginTransaction.
	someAccountId := self writeCustomer1Rows first.
	session beginUnitOfWork.
	query := Query returningOneOf: GlorpBankAccount
				where: [:each | each id = someAccountId].
	anAccount := session execute: query.
	self assert: anAccount class == GlorpBankAccount.
	self assert: anAccount id = someAccountId.
	session delete: anAccount.
	accounts := session readManyOf: GlorpBankAccount.
	self assert: accounts size = 1.
	self deny: (accounts includes: anAccount).
	self deny: (accounts anySatisfy: [:each | each id = someAccountId]).
] 
			ensure: [session rollbackTransaction]!

testDeletedObjectsNotReadInOneQuery
	| query anAccount someAccountId account |
	[session beginTransaction.
	someAccountId := self writeCustomer1Rows first.
	session beginUnitOfWork.
	query := Query returningOneOf: GlorpBankAccount
				where: [:each | each id = someAccountId].
	anAccount := session execute: query.
	self assert: anAccount class == GlorpBankAccount.
	self assert: anAccount id = someAccountId.
	session delete: anAccount.
	account := session readOneOf: GlorpBankAccount where: [:each | each id = someAccountId].
	self assert: account isNil] 
			ensure: [session rollbackTransaction]!

testDeleteWithEmbedded
	| transaction uow |
	
	[session beginTransaction.
	session beginUnitOfWork.
	self writeCustomer1RowsWithTransactions.
	transaction := (session readManyOf: GlorpBankTransaction) first.
	session delete: transaction.
	uow := session privateGetCurrentUnitOfWork.
	self assert: (uow willDelete: transaction).
	self assert: (uow willDelete: transaction amount).
	self assert: (uow willDelete: transaction serviceCharge).
	self assert: (uow willDelete: transaction serviceCharge amount).
	session commitUnitOfWork] 
			ensure: [session rollbackTransaction]!

testExpiryTimeNotReset
	| cachePolicy |
	cachePolicy := TimedExpiryCachePolicy new.
	cachePolicy timeoutSeconds: 3.
	cachePolicy expiryAction: #refresh.
	(session descriptorFor: GlorpAddress) cachePolicy: cachePolicy.
	self checkExpiryTime: [:expiryTime :newExpiryTime :address | 
		self assert: newExpiryTime = expiryTime.
		self assert: address street = 'Paseo Montril'].!

testExpiryTimeReset
	| cachePolicy |
	cachePolicy := TimedExpiryCachePolicy new.
	cachePolicy timeoutSeconds: 4.
	cachePolicy expiryAction: #remove.
	(session descriptorFor: GlorpAddress) cachePolicy: cachePolicy.
	self checkExpiryTime: [:expiryTime :newExpiryTime :address | 
		self assert: newExpiryTime > expiryTime.
		self assert: address street = 'Paseo Montril'].!

testExpiryTimeReset2
	| cachePolicy |
	cachePolicy := TimedExpiryCachePolicy new.
	cachePolicy timeoutSeconds: 4.
	cachePolicy expiryAction: #notifyAndRemove.
	(session descriptorFor: GlorpAddress) cachePolicy: cachePolicy.
	self checkExpiryTime: [:expiryTime :newExpiryTime :address | 
		self assert: newExpiryTime > expiryTime.
		self assert: address street = 'Paseo Montril'].!

testInFromJoin
	| query result |
	[session beginTransaction.
	self writeReservationData.
	query := Query returningManyOf: GlorpItinerary where: [:each | each reservation passengers 
		anySatisfyJoin: [:eachPassenger | eachPassenger airline id in: #(73 74)]].
	result := session execute: query.
	self assert: (result allSatisfy: [:each | each reservation passengers anySatisfy: [:eachPassenger | #(73 74) includes: eachPassenger airline id]]).
	self assert: result size = 2] ensure: [session rollbackTransaction].!

testInFromSubselect
	| query result |
	[session beginTransaction.
	self writeReservationData.
	query := Query returningManyOf: GlorpItinerary where: [:each | each reservation passengers 
		anySatisfyExists: [:eachPassenger | eachPassenger airline id in: #(73 74)]].
	result := session execute: query.
	self assert: (result allSatisfy: [:each | each reservation passengers anySatisfy: [:eachPassenger | #(73 74) includes: eachPassenger airline id]]).
	self assert: result size = 2] ensure: [session rollbackTransaction].!

testMax
	| query result account |
	
	[session beginTransaction.
	self writeCustomer1Rows.

	query := Query returningManyOf: GlorpBankAccount.
	query retrieve: [:each | each accountNumber accountNumber max].
	result := query executeIn: session.
	self assert: result size = 1.
	self assert: result first = '4'.
	account := result first] 
			ensure: [session rollbackTransaction]!

testMin
	| query result account |
	
	[session beginTransaction.
	self writeCustomer1Rows.

	query := Query returningManyOf: GlorpBankAccount.
	query retrieve: [:each | each accountNumber accountNumber min].
	result := query executeIn: session.
	self assert: result size = 1.
	self assert: result first = '3'.
	account := result first] 
			ensure: [session rollbackTransaction]!

testNonIntrusiveAlsoFetch
	| alsoFetchQuery query results | 

	"If a platform has no outer joins (!!) we cannot execute
	 this test."
	(session system platform supportsANSIJoins or: [
		session system platform useMicrosoftOuterJoins or: [
		session system platform useOracleOuterJoins ]])
			ifFalse: [ ^self ].

	[session beginTransaction.
	session beginUnitOfWork.
	session register: GlorpPerson example1.
	session register: (GlorpPerson example1
							id: 2;
							address: nil;
							yourself).
	session commitUnitOfWork.
	alsoFetchQuery := Query
						returningManyOf: GlorpPerson
						where: nil.
	alsoFetchQuery alsoFetch: [:ea | ea address asOuterJoin].
	query := Query
					returningManyOf: GlorpPerson
					where: nil.
	results := alsoFetchQuery executeIn: session.
	self assert: results size = 2.
	results := query executeIn: session.
	self assert: results size = 2] 
			ensure: [session rollbackTransaction].!

testNonRefreshAddress
	"Test that if we don't set the refresh flag on the query we don't re-read the data"
	| query rowToWrite address modifiedRow |
	
	[session beginTransaction.
	rowToWrite := session system exampleAddressRow.
	session writeRow: rowToWrite.
	address := session readOneOf: GlorpAddress
				where: [:each | each id = 123].
	modifiedRow := session system exampleModifiedAddressRow.
	modifiedRow owner: address. "Otherwise it thinks it's an insert"
	session writeRow: modifiedRow.
	query := Query returningOneOf: GlorpAddress where: [:each | each id = 123].
	query executeIn: session.
	self assert: address street = 'Paseo Montril'.] 
			ensure: [session rollbackTransaction].!

testQueryHasLimit
	self deny: (SimpleQuery returningManyOf: GlorpAddress) hasLimit.
	self assert: (SimpleQuery returningManyOf: GlorpAddress limit: 10) hasLimit.
	self assert: (SimpleQuery returningManyOf: GlorpAddress limit: -10) hasLimit.

	self assert: (SimpleQuery returningManyOf: GlorpAddress) limitMakesSense.
	self assert: (SimpleQuery returningManyOf: GlorpAddress limit: 10) limitMakesSense.
	self deny: (SimpleQuery returningManyOf: GlorpAddress limit: 0) limitMakesSense.
	self deny: (SimpleQuery returningManyOf: GlorpAddress limit: -10) limitMakesSense.!

testQueryHasOffset
	self deny: (SimpleQuery returningManyOf: GlorpAddress) hasOffset.
	self assert: ((SimpleQuery returningManyOf: GlorpAddress) offset: 10; yourself) hasOffset.
	self deny: ((SimpleQuery returningManyOf: GlorpAddress) offset: 0; yourself) hasOffset.
	self deny: ((SimpleQuery returningManyOf: GlorpAddress) offset: -10; yourself) hasOffset.!

testReadAccountsWithCompoundAnySatisfyExists
	| query result |
	
	[| block |
	session beginTransaction.
	self writeCustomer1Rows.
	block := 
			[:account | 
			account accountHolders anySatisfyExists: [:each | (each id = 27) & (each name = 'aCustomer')]].
	query := Query returningManyOf: GlorpBankAccount where: block.
	result := session execute: query.
	self assert: result size = 2] 
			ensure: [session rollbackTransaction]!

testReadAccountsWithCompoundAnySatisfyJoin
	| query result |
	
	[| block |
	session beginTransaction.
	self writeCustomer1Rows.
	block := 
			[:account | 
			account accountHolders anySatisfyJoin: [:each | (each id = 27) & (each name = 'aCustomer')]].
	query := Query returningManyOf: GlorpBankAccount where: block.
	result := session execute: query.
	self assert: result size = 2] 
			ensure: [session rollbackTransaction]!

testReadAccountsWithMultipleAnySatisfyExists
	| query result |
	 
	[| block |
	session beginTransaction.
	self writeCustomer1Rows.
	block := 
			[:account | 
			(account accountHolders anySatisfyExists: [:each | each id = 24]) 
				| (account accountHolders anySatisfyExists: [:each | each id = 27])].
	query := Query returningManyOf: GlorpBankAccount where: block.
	result := session execute: query.
	self assert: result size = 2] 
			ensure: [session rollbackTransaction]!

testReadAccountsWithMultipleAnySatisfyJoin
	| query result |
	 
	[| block |
	session beginTransaction.
	self writeCustomer1Rows.
	block := 
			[:account | 
			(account accountHolders anySatisfyJoin: [:each | each id = 24]) 
				| (account accountHolders anySatisfyJoin: [:each | each id = 27])].
	query := Query returningManyOf: GlorpBankAccount where: block.
	result := session execute: query.
	self assert: result size = 2] 
			ensure: [session rollbackTransaction]!

testReadAccountsWithMultipleAnySatisfyMixed1
	| query result |
	 
	[| block |
	session beginTransaction.
	self writeCustomer1Rows.
	block := 
			[:account | 
			(account accountHolders anySatisfyJoin: [:each | each id = 24]) 
				| (account accountHolders anySatisfyExists: [:each | each id = 27])].
	query := Query returningManyOf: GlorpBankAccount where: block.
	result := session execute: query.
	self assert: result size = 2] 
			ensure: [session rollbackTransaction]!

testReadAccountsWithMultipleAnySatisfyMixed2
	| query result |
	 
	[| block |
	session beginTransaction.
	self writeCustomer1Rows.
	block := 
			[:account | 
			(account accountHolders anySatisfyExists: [:each | each id = 24]) 
				| (account accountHolders anySatisfyJoin: [:each | each id = 27])].
	query := Query returningManyOf: GlorpBankAccount where: block.
	result := session execute: query.
	self assert: result size = 2] 
			ensure: [session rollbackTransaction]!

testReadAccountsWithNestedAnySatisfyExists
	| query result |
	[| block |
	session beginTransaction.
	self writeCustomer1RowsWithTransactions.
	block := 
			[:account | 
			account accountHolders anySatisfyExists: [:each | each transactions anySatisfyExists: [:eachTrans |
			eachTrans id ~= nil]]].
	query := Query returningManyOf: GlorpBankAccount where: block.
	result := session execute: query.
	self assert: result size = 2] 
			ensure: [session rollbackTransaction]!

testReadAccountsWithNestedAnySatisfyJoin
	| query result |
	[| block |
	session beginTransaction.
	self writeCustomer1RowsWithTransactions.
	block := 
			[:account | 
			account accountHolders anySatisfyJoin: [:each | each transactions anySatisfyJoin: [:eachTrans |
			eachTrans id ~= nil]]].
	query := Query returningManyOf: GlorpBankAccount where: block.
	result := session execute: query.
	self assert: result size = 2] 
			ensure: [session rollbackTransaction]!

testReadAccountsWithNestedAnySatisfyMixed1
	| query result |
	[| block |
	session beginTransaction.
	self writeCustomer1RowsWithTransactions.
	block := 
			[:account | 
			account accountHolders anySatisfyExists: [:each | each transactions anySatisfyJoin: [:eachTrans |
			eachTrans id ~= nil]]].
	query := Query returningManyOf: GlorpBankAccount where: block.
	result := session execute: query.
	self assert: result size = 2] 
			ensure: [session rollbackTransaction]!

testReadAccountsWithNestedAnySatisfyMixed2
	| query result |
	[| block |
	session beginTransaction.
	self writeCustomer1RowsWithTransactions.
	block := 
			[:account | 
			account accountHolders anySatisfyJoin: [:each | each transactions anySatisfyExists: [:eachTrans |
			eachTrans id ~= nil]]].
	query := Query returningManyOf: GlorpBankAccount where: block.
	result := session execute: query.
	self assert: result size = 2] 
			ensure: [session rollbackTransaction]!

testReadAddress
	| object query results rowToWrite |
	
	[session beginTransaction.
	rowToWrite := session system exampleAddressRow.
	session writeRow: rowToWrite.
	query := Query returningManyOf: GlorpAddress
				where: [:address | address id = 123].
	results := query executeIn: session] 
			ensure: [session rollbackTransaction].
	self assert: results size = 1.
	object := results first.
	self assert: object class = GlorpAddress.
	self assert: object id = 123.
	self assert: object street = 'Paseo Montril'.
	self assert: object number = '10185'!

testReadAddressProxy
	| object query results rowToWrite proxy | 

	[session beginTransaction.
		rowToWrite := session system exampleAddressRow.
		session writeRow: rowToWrite.
		query := (Query
			returningManyOf: GlorpAddress
			where: ([:address | address id = 123]) ) returnProxies: true.
		results := query executeIn: session.
		self assert: (results size = 1).
		proxy := results first.
		object := proxy getValue]
	ensure: [session rollbackTransaction].

	self assert: (proxy isGlorpProxy).
	self assert: (object class = GlorpAddress).
	self assert: (object id = 123).
	self assert: (object street = 'Paseo Montril').
	self assert: (object number = '10185').!

testReadAddressProxyAlreadyInMemory
	"Check that if the object is already in memory we don't create a proxy for it, just return the instance Unless explicitly asked, in which case we return a proxy."
	| object object2 query results rowToWrite |

	[session beginTransaction.
		rowToWrite := session system exampleAddressRow.
		session writeRow: rowToWrite.
		object := session readOneOf: GlorpAddress where: [:address | address id = 123].
		self deny: (object class inheritsFrom: Proxy).
		object2 := session readOneOf: GlorpAddress where: [:address | address id = 123].
		self deny: (object class inheritsFrom: Proxy).
		self assert: object2 == object.
		object := nil.
		object2 := nil.
		Dialect garbageCollect.
		(Delay forSeconds: 2) wait.
		query := (Query
			returningManyOf: GlorpAddress
			where: ([:address | address id = 123]) ) returnProxies: true.
		results := query executeIn: session.
		session accessor denyReads.
		self assert: (results size = 1).
		object := results first]
	ensure: [session rollbackTransaction].

	self assert: (object class = Proxy).
	self deny: object isInstantiated.
	self assert: (object id = 123).
	self assert: (object street = 'Paseo Montril').
	self assert: (object number = '10185').
	session accessor permitEverything.!

testReadAddressSubstring
	| object query results rowToWrite results2 |
	
	[session beginTransaction.
	rowToWrite := session system exampleAddressRow.
	session writeRow: rowToWrite.
	query := Query returningManyOf: GlorpAddress
				where: [:address | (address street copyFrom: 1 to: 5) = 'Paseo'].
	results := query executeIn: session.
	query := Query returningManyOf: GlorpAddress
				where: [:address | (address street copyFrom: 7 to: 13) = 'Montril'].
	results2 := query executeIn: session] 
			ensure: [session rollbackTransaction].
	self assert: results size = 1.
	object := results first.
	self assert: object class = GlorpAddress.
	self assert: object id = 123.
	self assert: object street = 'Paseo Montril'.
	self assert: object number = '10185'.
	self assert: results2 size = 1.
	self assert: results2 first = results first.!

testReadAddressWithCustomSQL
	| object query results rowToWrite |
	
	[session beginTransaction.
	rowToWrite := session system exampleAddressRow.
	session writeRow: rowToWrite.
	query := Query returningManyOf: GlorpAddress.
	query sql: 'select id, street, house_num from gr_address where id = 123'.
	results := query executeIn: session] 
			ensure: [session rollbackTransaction].
	self assert: results size = 1.
	object := results first.
	self assert: object class = GlorpAddress.
	self assert: object id = 123.
	self assert: object street = 'Paseo Montril'.
	self assert: object number = '10185'!

testReadAddressWithCustomSQLBinding
	"Test that we can bind to custom SQL. If not binding, don't run this test."
	| object query results rowToWrite |
	
	session useBinding ifFalse: [^self].
	[session beginTransaction.
	rowToWrite := session system exampleAddressRow.
	session writeRow: rowToWrite.
	query := Query returningManyOf: GlorpAddress.
	query sql: 'select id, street, house_num from gr_address where id = ?'.
	results := query executeWithParameters: #(123) in: session] 
			ensure: [session rollbackTransaction].
	self assert: results size = 1.
	object := results first.
	self assert: object class = GlorpAddress.
	self assert: object id = 123.
	self assert: object street = 'Paseo Montril'.
	self assert: object number = '10185'!

testReadAdHoc 
	| queryTime table row time idField times |
	
	[
	session beginTransaction.
	
	table := session system tableNamed: 'TRANSFORMED_TIME'.
	row := DatabaseRow newForTable: table.
	idField := (table fieldNamed: 'ID').
	row at: idField put: 3.
	time := Time now.
	row at: (table fieldNamed: 'TIMEFIELD') put: time asSeconds.

	session writeRow: row.
	queryTime := GlorpTransformedTime  new id: 3; time: time.
	times := session readManyOf: GlorpTransformedTime where: [:each | each time = time].
	self assert: times size = 1.
	self assert: times first time asSeconds = time asSeconds.
	] 
			ensure: [session rollbackTransaction]!

testReadAdHocProxied
	| table row time idField times time2 |
	((session system descriptorFor: GlorpTransformedTime) mappingForAttributeNamed: #time) shouldProxy: true.
	[
	session beginTransaction.
	
	table := session system tableNamed: 'TRANSFORMED_TIME'.
	row := DatabaseRow newForTable: table.
	idField := (table fieldNamed: 'ID').
	row at: idField put: 3.
	time := Time now.
	row at: (table fieldNamed: 'TIMEFIELD') put: time asSeconds.
	session writeRow: row.

	row := DatabaseRow newForTable: table.
	row at: idField put: 4.
	time2 := Dialect addSeconds: 10 to: Time now.
	row at: (table fieldNamed: 'TIMEFIELD') put: time2 asSeconds.
	session writeRow: row.

	times := session read: GlorpTransformedTime orderBy: [:each | each time].
	self assert: times size = 2.
	self assert: times first time class == AdHocProxy.
	self assert: times first time asSeconds = time asSeconds.
	self assert: times last time asSeconds = time2 asSeconds.
	] 
			ensure: [session rollbackTransaction]!

testReadAllAddress
	| object results rowToWrite |
	
	[session beginTransaction.
	rowToWrite := session system exampleAddressRow.
	session writeRow: rowToWrite.
	results := session readManyOf: GlorpAddress] 
			ensure: [session rollbackTransaction].
	self assert: results size = 1.
	object := results first.
	self assert: object class = GlorpAddress.
	self assert: object id = 123.
	self assert: object street = 'Paseo Montril'.
	self assert: object number = '10185'!

testReadCompressedMoney
	| object query results rowToWrite |
	
	[session beginTransaction.
	rowToWrite := session system exampleCompressedMoneyRow.
	session writeRow: rowToWrite.
	query := Query returningManyOf: GlorpCompressedMoney
				where: [:money | money id ~= 0].
	results := query executeIn: session] 
			ensure: [session rollbackTransaction].
	self assert: results size = 1.
	object := results first.
	self assert: object class = GlorpCompressedMoney.
	self assert: object amount = 12.
	self assert: object currency = 'CDN'.!

testReadCompressedMoney2
	| object query results rowToWrite |
	
	[session beginTransaction.
	rowToWrite := session system exampleCompressedMoneyRow.
	session writeRow: rowToWrite.
	query := Query returningManyOf: GlorpCompressedMoney
				where: [:money | money = (GlorpCompressedMoney new id: 123; currency: 'CDN'; amount: 12)].
	results := query executeIn: session] 
			ensure: [session rollbackTransaction].
	self assert: results size = 1.
	object := results first.
	self assert: object class = GlorpCompressedMoney.
	self assert: object amount = 12.
	self assert: object currency = 'CDN'.!

testReadCustomerAndAddTransaction
	| query  customer accountIds newCustomer rawRows |
	
	[session beginTransaction.
	accountIds := self writeCustomer1Rows.
	session beginUnitOfWork.
	query := Query returningOneOf: GlorpCustomer
				where: [:person | person id = 27].
	customer := session execute: query.
	customer addTransaction: GlorpBankTransaction example1.
	session commitUnitOfWork.
	newCustomer := session execute: query.
	self assert: customer == newCustomer.
	self assert: customer transactions first owner yourSelf == customer.
	rawRows := session accessor executeSQLString: 'SELECT ID, NAME FROM GR_CUSTOMER'.
	self assert: rawRows size = 1.
	self assert: (rawRows first atIndex: 1) = 27.
	] 
			ensure: [session rollbackTransaction]!

testReadCustomerWithAccounts
	| query id1 id2 result accounts backRef1 backRef2 accountIds |
	
	[session beginTransaction.
	accountIds := self writeCustomer1Rows.
	id1 := accountIds at: 1.
	id2 := accountIds at: 2.
	query := Query returningOneOf: GlorpCustomer
				where: [:person | person id = 27].
	result := session execute: query.
	self assert: result seenPostFetch = true.
	accounts := result accounts getValue.
	self assert: accounts size = 2.
	self assert: (accounts first id = id1 or: [accounts last id = id1]).
	self assert: (accounts first id = id2 or: [accounts last id = id2]).
	self assert: accounts first id ~= accounts last id.
	backRef1 := accounts first accountHolders getValue.
	self assert: backRef1 size = 1.
	self assert: backRef1 first = result.
	backRef2 := accounts first accountHolders getValue.
	self assert: backRef2 size = 1.
	self assert: backRef2 first = result] 
			ensure: [session rollbackTransaction]!

testReadCustomerWithAnySatisfyExists
	| query result accounts |
	
	[session beginTransaction.
	self writeCustomer1Rows.
	query := Query returningManyOf: GlorpCustomer
				where: 
					[:person | 
					person accounts anySatisfyExists: [:each | each accountNumber branchNumber > 0]].
	result := session execute: query.
	self assert: result size = 1.
	accounts := result first accounts getValue.
	self assert: accounts size = 2.
	query := Query returningManyOf: GlorpCustomer
				where: 
					[:person | 
					person accounts anySatisfy: [:each | each accountNumber branchNumber = 2]].
	result := session execute: query.
	self assert: result size = 1.
	accounts := result first accounts getValue.
	self assert: accounts size = 2] 
			ensure: [session rollbackTransaction]!

testReadCustomerWithAnySatisfyJoin
	| query result accounts |
	
	[session beginTransaction.
	self writeCustomer1Rows.
	query := Query returningManyOf: GlorpCustomer
				where: 
					[:person | 
					person accounts anySatisfyJoin: [:each | each accountNumber branchNumber > 0]].
	result := session execute: query.
	self assert: result size = 1.
	accounts := result first accounts getValue.
	self assert: accounts size = 2.
	query := Query returningManyOf: GlorpCustomer
				where: 
					[:person | 
					person accounts anySatisfy: [:each | each accountNumber branchNumber = 2]].
	result := session execute: query.
	self assert: result size = 1.
	accounts := result first accounts getValue.
	self assert: accounts size = 2] 
			ensure: [session rollbackTransaction]!

testReadCustomerWithIncludes
	| query result accounts account |
	
	[session beginTransaction.
	self writeCustomer1Rows.
	account := session readOneOf: GlorpBankAccount where: [:each | each accountNumber branchNumber = 2].
	query := Query returningManyOf: GlorpCustomer
				where: 
					[:person | 
					person accounts includes: account].
	result := session execute: query.
	self assert: result size = 1.
	accounts := result first accounts getValue.
	self assert: (accounts includes: account).
	self assert: accounts size = 2] 
			ensure: [session rollbackTransaction]!

testReadCustomerWithMultipleAnySatisfyExists
	| query result |
	
	[| block |
	session beginTransaction.
	self writeCustomer1Rows.
	block := 
			[:person | 
			(person accounts anySatisfyExists: [:each | each accountNumber branchNumber = 2]) 
				& (person accounts 
						anySatisfyExists: [:each | each accountNumber branchNumber = 3])].
	query := Query returningManyOf: GlorpCustomer where: block.
	result := session execute: query.
	self assert: result size = 1] 
			ensure: [session rollbackTransaction]!

testReadCustomerWithMultipleAnySatisfyJoin
	| query result |
	
	[| block |
	session beginTransaction.
	self writeCustomer1Rows.
	block := 
			[:person | 
			(person accounts anySatisfyJoin: [:each | each accountNumber branchNumber = 2]) 
				& (person accounts 
						anySatisfyJoin: [:each | each accountNumber branchNumber = 3])].
	query := Query returningManyOf: GlorpCustomer where: block.
	result := session execute: query.
	self assert: result size = 1] 
			ensure: [session rollbackTransaction]!

testReadEmbeddedObjectDirectly
	| serviceCharges transRow |
	
	[
	session beginTransaction.
	transRow := session system exampleBankTransactionRow.
	session writeRow: transRow.
	transRow := session system exampleBankTransactionRow2.
	session writeRow: transRow.
	serviceCharges := session readManyOf: GlorpServiceCharge.
	self assert: serviceCharges size = 2.
	self deny: serviceCharges first == serviceCharges last.
	] 
			ensure: [session rollbackTransaction]!

testReadEmbeddedOneToOne

	self helperForTestReadEmbeddedOneToOne.!

testReadMultiFieldAdHoc
	| object query results rowToWrite row2 |
	
	[session beginTransaction.
	rowToWrite := session system exampleCompressedMoneyRow.
	row2 := session system exampleCompressedMoneyRow2.
	session writeRow: rowToWrite.
	session writeRow: row2.

	query := Query returningManyOf: GlorpCompressedMoney
				where: [:money | money array = #('CDN' 12)].
	results := query executeIn: session] 
			ensure: [session rollbackTransaction].
	self assert: results size = 1.
	object := results first.
	self assert: object class = GlorpCompressedMoney.
	self assert: object amount = 12.
	self assert: object currency = 'CDN'.!

testReadMultipleObjectsManyToMany1
	| query result account |
	
	[session beginTransaction.
	self writeCustomer1Rows.

	query := Query returningManyOf: GlorpBankAccount.
	query alsoFetch: [:each | each accountHolders].
	result := query executeIn: session.
	self assert: result size = 2.
	account := result first.
	self deny: account accountHolders isGlorpProxy.
	self assert: account accountHolders size = 1.
	self assert: (account accountHolders first == (result last accountHolders first))] 
			ensure: [session rollbackTransaction]!

testReadMultipleObjectsManyToMany2
	| query result customer |
	
	[session beginTransaction.
	self writeCustomer1Rows.

	query := Query returningManyOf: GlorpCustomer.
	query retrieve: [:each | each ].
	query alsoFetch: [:each | each accounts].
	result := query executeIn: session.
	self assert: result size = 1.
	customer := result first.
	self deny: customer accounts class isGlorpProxy.
	self assert: customer accounts size = 2] 
			ensure: [session rollbackTransaction]!

testReadMultipleObjectsManyToMany3
	| query result customer array |
	
	[session beginTransaction.
	self writeCustomer1Rows.

	query := Query returningManyOf: GlorpCustomer.
	query retrieve: [:each | each ].
	query retrieve: [:each | each accounts].
	result := query executeIn: session.
	self assert: result size = 1.
	array := result first.
	customer := array first.
	self deny: customer accounts isGlorpProxy.
	self assert: customer accounts size = 2.
	self assert: customer accounts == array last] 
			ensure: [session rollbackTransaction]!

testReadMultipleObjectsManyToMany4
	"If we read just a to-many relation, then it doesn't get knitted and we just get a collection of the target"
	| query result |
	
	[session beginTransaction.
	self writeCustomer1Rows.

	query := Query returningManyOf: GlorpCustomer where: [:each | each id ~= 7].
	query retrieve: [:each | each accounts].
	result := query executeIn: session.
	self assert: result size = 2.
	self assert: session privateGetCache numberOfElements = 2.
	self assert: (result allSatisfy: [:each | each class == GlorpBankAccount]).
	self assert: result first ~= result last] 
			ensure: [session rollbackTransaction]!

testReadMultipleObjectsToManyAlsoFetchTwoLevels
	| query result account transactions |
	
	[session beginTransaction.
	self write2CustomerRowsWith3Transactions.
	session beginUnitOfWork.

	query := Query returningManyOf: GlorpBankAccount.
	query alsoFetch: [:each | each accountHolders].
	query alsoFetch: [:each | each accountHolders transactions].
	result := query executeIn: session.
	self assert: result size = 2.
	account := result detect: [:each | each id = 9874].
	self deny: result first == result last.
	self deny: account accountHolders isGlorpProxy.
	self assert: account accountHolders size = 1.
	transactions := account accountHolders first transactions.
	self deny: transactions isGlorpProxy.
	self assert: transactions size = 2.
	self assert: account accountHolders first == (result at: 2) accountHolders first] 
			ensure: [session rollbackTransaction]!

testReadPassenger
	| passengerRow1 passengerRow2 query result |
	
	[session beginTransaction.
	passengerRow1 := session system examplePassengerRow.
	session writeRow: passengerRow1.
	passengerRow2 := session system exampleFrequentFlyerRow.
	session writeRow: passengerRow2.
	query := Query returningOneOf: GlorpPassenger
				where: [:passenger | passenger id = 1].
	result := query executeIn: session.
	self assert: result id = 1.
	self assert: result name = 'Some Passenger'.
	self assert: result frequentFlyerPoints = 10000] 
			ensure: [session rollbackTransaction]!

testReadRelationshipField
	| query results |
	
	[session beginTransaction.
	query := Query returningManyOf: GlorpItinerary where: [:each | ((each getTable: 'ITINERARY') getField: 'RES_ID') = nil].
	results := query executeIn: session] 
			ensure: [session rollbackTransaction].
	self assert: results size = 0.!

testReadReservationWithJoinToPassenger
	| reservations |
	
	[session beginTransaction.
	self writeReservationData.
	session beginUnitOfWork.
	reservations := session readManyOf: GlorpReservation
				where: [:each | each passenger id = 3].
	self assert: reservations size = 1.
	self assert: reservations first passengers size = 1.] 
			ensure: [session rollbackTransaction]!

testReadReservationWithPassenger
	
	| reservation passenger reservations |
	[session beginTransaction.
	self writeReservationData.
	session beginUnitOfWork.
	"This doesn't validate so well. We want to make sure that the passenger table read uses a join and gets back only the one row, but it's hard to test that. Putting in an error check in the query for readOne... that returns multiple would work, but is kind of intrusive"
	reservations := session readManyOf: GlorpReservation where: [:each | each id = 2].
	self assert: reservations size = 1.
	reservation := reservations first.
	passenger := reservation passenger.
	passenger id.
	] 
			ensure: [session rollbackTransaction]!

testReadTransactionsWithIndependentSubselect
	| query result query2 matchingResult |
	
	[session beginTransaction.
	self write2CustomerRowsWith3Transactions.
	query := Query returningManyOf: GlorpBankTransaction where: [:each |
		each exists: (Query readManyOf: GlorpCustomer where: [:eachCustomer |
			(eachCustomer id = each owner id) & (eachCustomer name = 'anotherCustomer')])].
	query orderBy: [:each | each owner name].
	"Another way of saying the same thing"
	query2 := Query returningManyOf: GlorpBankTransaction where: [:each | each owner name = 'anotherCustomer'].
	result := session execute: query.
	matchingResult := session execute: query2.
	self assert: result size = matchingResult size.
	result with: matchingResult do: [:one :other |
		self assert: one = other]] 
			ensure: [session rollbackTransaction]!

testReadTransactionsWithIndependentSubselectAndNot
	| query result query2 matchingResult |
	
	[session beginTransaction.
	self write2CustomerRowsWith3Transactions.
	query := Query returningManyOf: GlorpBankTransaction where: [:each |
		each notExists: (Query readManyOf: GlorpCustomer where: [:eachCustomer |
			(eachCustomer id = each owner id) & (eachCustomer name = 'anotherCustomer')])].
	query orderBy: [:each | each owner name].
	"Another way of saying the same thing"
	query2 := Query returningManyOf: GlorpBankTransaction where: [:each | each owner name ~= 'anotherCustomer'].
	query2 orderBy: [:each | each owner name].
	result := session execute: query.
	matchingResult := session execute: query2.
	self assert: result size = matchingResult size.
	result with: matchingResult do: [:one :other |
		self assert: one = other]] 
			ensure: [session rollbackTransaction]!

testReadTransactionsWithMaxSubselect
	| query result |
	
	[session beginTransaction.
	self write2CustomerRowsWith3Transactions.
	query := Query returningManyOf: GlorpBankTransaction where: [:each |
		each amount amount = ((Query readManyOf: GlorpBankTransaction
			where: [:eachTrans | eachTrans owner = each owner]) 
				retrieve: [:eachTrans | eachTrans amount amount max])].
	query orderBy: [:each | each owner name].
	result := session execute: query.
	self assert: result size = 2.
	self assert: result first amount amount = 10.
	self assert: result last amount amount = 11.
	self assert: result first owner id ~= result last owner id] 
			ensure: [session rollbackTransaction]!

testReadTransactionsWithMaxSubselectAndRetrieveMax
	| query result |
	
	[session beginTransaction.
	self write2CustomerRowsWith3Transactions.
	query := Query returningManyOf: GlorpBankTransaction where: [:each |
		each amount amount = ((Query readManyOf: GlorpBankTransaction
			where: [:eachTrans | eachTrans owner = each owner]) 
				retrieveMax: [:eachTrans | eachTrans amount amount])].
	query orderBy: [:each | each owner name].
	result := session execute: query.
	self assert: result size = 2.
	self assert: result first amount amount = 10.
	self assert: result last amount amount = 11.
	self assert: result first owner id ~= result last owner id] 
			ensure: [session rollbackTransaction]!

testReadWithCacheHits
	| query addressRow result1 result2 |
	
	[session beginTransaction.
	addressRow := session system exampleAddressRow.
	session writeRow: addressRow.
	query := Query returningOneOf: GlorpAddress
				where: [:address | address id = 123].
	result1 := query executeIn: session.
	result2 := query executeIn: session.
	self assert: result1 == result2] 
			ensure: [session rollbackTransaction]!

testReadWithFalseWhereClause
	| query id1 id2 result accountIds |
	
	[session beginTransaction.
	accountIds := self writeCustomer1Rows.
	id1 := accountIds at: 1.
	id2 := accountIds at: 2.
	query := Query returningManyOf: GlorpBankAccount
				where: false.
	result := session execute: query.
	self assert: result size = 0] 
			ensure: [session rollbackTransaction]!

testReadWithLimit
	| results |
	session platform supportsLimit ifFalse: [^self].
	results := Set new.
	[session beginTransaction.
	session
		inUnitOfWorkDo:
			[(1 to: 5) do: [:i | session register: ((GlorpAddress new)
													id: i;
													yourself)]].
	results
		add: (session execute: (SimpleQuery returningManyOf: GlorpAddress limit: 3)) size;
		add: (session execute: (SimpleQuery returningManyOf: GlorpAddress where: true limit: 3)) size;
		add: (session execute: (SimpleQuery readManyOf: GlorpAddress limit: 3)) size;
		add: (session execute: (SimpleQuery readManyOf: GlorpAddress where: true limit: 3)) size;
		add: (session readManyOf: GlorpAddress limit: 3) size;
		add: (session readManyOf: GlorpAddress where: true limit: 3) size.
	self assert: (results allSatisfy: [:ea | ea = 3])] ensure: [session rollbackTransaction].!

testReadWithLimitAndOffset

	session platform supportsOffset ifFalse: [^self].
	[session beginTransaction.
	session
		inUnitOfWorkDo:
			[(1 to: 5) do: [:i | session register: ((GlorpAddress new)
													id: i;
													yourself)]].
	self assert: (session execute: ((SimpleQuery returningManyOf: GlorpAddress limit: 2)
									offset: 2;
									yourself)) size = 2.
	self assert: (session execute: ((SimpleQuery returningManyOf: GlorpAddress limit: 0)
									offset: 2;
									yourself)) size = 0.
	self assert: (session execute: ((SimpleQuery returningManyOf: GlorpAddress)
									offset: 6;
									yourself)) size = 0] ensure: [session rollbackTransaction].!

testReadWithNilWhereClause
	| query id1 id2 result accountIds |
	
	[session beginTransaction.
	accountIds := self writeCustomer1Rows.
	id1 := accountIds at: 1.
	id2 := accountIds at: 2.
	query := Query returningManyOf: GlorpBankAccount
				where: nil.
	result := session execute: query.
	self assert: result size = 2] 
			ensure: [session rollbackTransaction]!

testReadWithObjectEqualityToEmbeddedObject
	| query result |
	 
	[session beginTransaction.
	self writeCustomer1RowsWith2Transactions.
	query := Query
	returningManyOf: GlorpBankTransaction
	where: [:trans | trans amount = (GlorpMoney currency: #CDN amount: 7)].
	result := session execute: query.
	self assert: result size = 1.
	self assert: result first amount amount = 7.
	self assert: result first amount currency = #CDN] 
			ensure: [session rollbackTransaction]!

testReadWithObjectEqualityToEmbeddedObjectNested
	| query result |
	 
	[session beginTransaction.
	self writeCustomer1RowsWith2Transactions.
	query := Query
		 returningManyOf: GlorpBankTransaction
	where: [:trans | trans serviceCharge amount = (GlorpMoney currency: #CHF amount: 2)].
	result := session execute: query.
	self assert: result size = 1.
	self assert: result first serviceCharge amount amount = 2.
	self assert: result first serviceCharge amount currency = #CHF] 
			ensure: [session rollbackTransaction]!

testReadWithOffset
	session platform supportsOffset ifFalse: [^self].
	[session beginTransaction.
	session
		inUnitOfWorkDo:
			[(1 to: 5) do: [:i | session register: ((GlorpAddress new)
													id: i;
													yourself)]].
	self assert: (session execute: ((SimpleQuery returningManyOf: GlorpAddress)
									offset: 2;
									yourself)) size = 3] ensure: [session rollbackTransaction].!

testReadWithTrueWhereClause
	| query id1 id2 result accountIds |
	
	[session beginTransaction.
	accountIds := self writeCustomer1Rows.
	id1 := accountIds at: 1.
	id2 := accountIds at: 2.
	query := Query returningManyOf: GlorpBankAccount
				where: true.
	result := session execute: query.
	self assert: result size = 2] 
			ensure: [session rollbackTransaction]!

testRefreshAddress
	"Check that we refresh correctly when the refresh flag is set"
	| query rowToWrite address modifiedRow |
	
	[session beginTransaction.
	rowToWrite := session system exampleAddressRow.
	session writeRow: rowToWrite.
	address := session readOneOf: GlorpAddress
				where: [:each | each id = 123].
	modifiedRow := session system exampleModifiedAddressRow.
	modifiedRow owner: address. "Otherwise it thinks it's an insert"
	session writeRow: modifiedRow.
	query := Query returningOneOf: GlorpAddress where: [:each | each id = 123].
	query shouldRefresh: true.
	query executeIn: session.
	self assert: address street = 'Something Else'.] 
			ensure: [session rollbackTransaction].!

testRegisteringWithEmbeddedMapping

	| bankTrans |
	session beginUnitOfWork.
	bankTrans := self helperForTestReadEmbeddedOneToOne.
	self assert: (session isRegistered: bankTrans).
	self assert: (session isRegistered: bankTrans serviceCharge).
	self assert: (session isRegistered: bankTrans serviceCharge amount).!

testSequencePolicyForInsert
	| testObject |

	GlorpInMemorySequenceDatabaseType reset.
	[session beginTransaction.
	session beginUnitOfWork.
	testObject := GlorpAirline new.
	session register: testObject.
	session commitUnitOfWork.
	self assert: testObject id = 1]
		ensure: [session rollbackTransaction]!

testSessionRefresh
	"Check that we refresh correctly when the refresh flag is set"
	self checkRefreshDoing: [:anAddress | session refresh: anAddress].!

testSessionRefreshOnExpiry
	"Check that we refresh correctly when an object has expired"
	| cachePolicy |
	cachePolicy := TimedExpiryCachePolicy new.
	cachePolicy timeout: 0.
	cachePolicy expiryAction: #refresh.
	(session descriptorFor: GlorpAddress) cachePolicy: cachePolicy.
	self checkRefreshDoing: [:anAddress |
		session readOneOf: GlorpAddress where: [:each | each id = 123]].!

testSessionRefreshOnExpiryWithCacheLookupOnly
	"Check that we refresh correctly when an object has expired, doing only a cache lookup, not an explicit read"
	| cachePolicy |
	cachePolicy := TimedExpiryCachePolicy new.
	cachePolicy timeout: 0.
	cachePolicy expiryAction: #refresh.
	(session descriptorFor: GlorpAddress) cachePolicy: cachePolicy.
	self checkRefreshDoing: [:anAddress |
		session privateGetCache lookupClass: GlorpAddress key: 123 ifAbsent: [nil]].!

testSessionRefreshOnProxyExpiry
	"Check that we refresh correctly when an object has expired"
	| cachePolicy |
	cachePolicy := TimedStrongCachePolicy new.
	cachePolicy timeout: 0.
	cachePolicy expiryAction: #refresh.
	(session descriptorFor: GlorpAddress) cachePolicy: cachePolicy.
	self checkRefreshDoing: [:anAddress |
		session readOneOf: GlorpAddress where: [:each | each id = 123]].!

testSessionRefreshOnProxyExpiryWithCacheLookupOnly
	"Check that we refresh correctly when an object has expired, doing only a cache lookup, not an explicit read"
	| cachePolicy |
	cachePolicy := TimedStrongCachePolicy new.
	cachePolicy timeout: 0.
	cachePolicy expiryAction: #refresh.
	(session descriptorFor: GlorpAddress) cachePolicy: cachePolicy.
	self checkRefreshDoing: [:anAddress |
		session privateGetCache lookupClass: GlorpAddress key: 123 ifAbsent: [nil]].!

testShortCircuitEmptyReturnWhenLimitMeansNoResults
	self deny: (SimpleQuery returningManyOf: GlorpAddress limit: 3) shortCircuitEmptyReturn.
	self assert: (SimpleQuery returningManyOf: GlorpAddress limit: 0) shortCircuitEmptyReturn.
	self assert: (SimpleQuery returningManyOf: GlorpAddress limit: -3) shortCircuitEmptyReturn!

testSum
	| query result |
	
	[session beginTransaction.
	self writeCustomer1Rows.

	query := Query returningManyOf: GlorpBankAccount.
	query retrieve: [:each | each accountNumber branchNumber sum].
	result := query executeIn: session.
	self assert: result size = 1.
	self assert: result first = 5] 
			ensure: [session rollbackTransaction]!

write2CustomerRowsWith3Transactions
	| table row aGlorpDemoDescriptorSystem |
	session system writeCustomerWithDualAccountOwners.
	aGlorpDemoDescriptorSystem := session system.
	table := aGlorpDemoDescriptorSystem tableNamed: 'BANK_TRANS'.
	row := DatabaseRow newForTable: table.
	row atFieldNamed: 'ID' put: nil.
	row atFieldNamed: 'AMT_CURR' put: 'CDN'.
	row atFieldNamed: 'AMT_AMT' put: 9.
	row atFieldNamed: 'SRVC_DESC' put: 'additional overcharge'.
	row atFieldNamed: 'SRVC_AMT_CURR' put: 'CHF'.
	row atFieldNamed: 'SRVC_AMT_AMT' put: 2.
	row atFieldNamed: 'OWNER_ID' put: 27.
	session writeRow: row.
	row := DatabaseRow newForTable: table.
	row atFieldNamed: 'ID' put: nil.
	row atFieldNamed: 'AMT_CURR' put: 'USD'.
	row atFieldNamed: 'AMT_AMT' put: 10.
	row atFieldNamed: 'SRVC_DESC' put: 'additional overcharge'.
	row atFieldNamed: 'SRVC_AMT_CURR' put: 'CHF'.
	row atFieldNamed: 'SRVC_AMT_AMT' put: 2.
	row atFieldNamed: 'OWNER_ID' put: 27.
	session writeRow: row.
	row := DatabaseRow newForTable: table.
	row atFieldNamed: 'ID' put: nil.
	row atFieldNamed: 'AMT_CURR' put: 'EUR'.
	row atFieldNamed: 'AMT_AMT' put: 11.
	row atFieldNamed: 'SRVC_DESC' put: 'additional overcharge'.
	row atFieldNamed: 'SRVC_AMT_CURR' put: 'EUR'.
	row atFieldNamed: 'SRVC_AMT_AMT' put: 2.
	row atFieldNamed: 'OWNER_ID' put: 28.
	session writeRow: row.!

writeCustomer1Rows
	^system writeCustomer1Rows.!

writeCustomer1RowsWith2Transactions
	| table row aGlorpDemoDescriptorSystem |
	self writeCustomer1RowsWithTransactions.
	aGlorpDemoDescriptorSystem := session system.
	table := aGlorpDemoDescriptorSystem tableNamed: 'BANK_TRANS'.
	row := DatabaseRow newForTable: table.
	row atFieldNamed: 'ID' put: nil.
	row atFieldNamed: 'AMT_CURR' put: 'USD'.
	row atFieldNamed: 'AMT_AMT' put: 9.
	row atFieldNamed: 'SRVC_DESC' put: 'additional overcharge'.
	row atFieldNamed: 'SRVC_AMT_CURR' put: 'CHF'.
	row atFieldNamed: 'SRVC_AMT_AMT' put: 2.
	row atFieldNamed: 'OWNER_ID' put: 27.
	session writeRow: row.!

writeCustomer1RowsWithTransactions
	| table row aGlorpDemoDescriptorSystem |
	self writeCustomer1Rows.
	aGlorpDemoDescriptorSystem := session system.
	table := aGlorpDemoDescriptorSystem tableNamed: 'BANK_TRANS'.
	row := DatabaseRow newForTable: table.
	row atFieldNamed: 'ID' put: nil.
	row atFieldNamed: 'AMT_CURR' put: 'CDN'.
	row atFieldNamed: 'AMT_AMT' put: 7.
	row atFieldNamed: 'SRVC_DESC' put: 'additional overcharge'.
	row atFieldNamed: 'SRVC_AMT_CURR' put: 'USD'.
	row atFieldNamed: 'SRVC_AMT_AMT' put: 2.
	row atFieldNamed: 'OWNER_ID' put: 27.
	session writeRow: row.!

writeReservationData
	session beginUnitOfWork.
	session register: GlorpItinerary example1.
	session register: GlorpItinerary example2.
	session commitUnitOfWork.
	session writeRow: session system examplePassengerRow.
	session initializeCache! !
!GlorpReadingTest categoriesFor: #checkExpiryTime!private!support! !
!GlorpReadingTest categoriesFor: #checkExpiryTime:!private!support! !
!GlorpReadingTest categoriesFor: #checkRefreshDoing:!private!support! !
!GlorpReadingTest categoriesFor: #helperForTestReadEmbeddedOneToOne!private!support! !
!GlorpReadingTest categoriesFor: #session!accessing!private! !
!GlorpReadingTest categoriesFor: #session:!accessing!private! !
!GlorpReadingTest categoriesFor: #setUp!private!support! !
!GlorpReadingTest categoriesFor: #tearDown!private!support! !
!GlorpReadingTest categoriesFor: #testCompoundAND!private!tests! !
!GlorpReadingTest categoriesFor: #testConversionOnConstantQueryParams!private!tests! !
!GlorpReadingTest categoriesFor: #testConversionOnConstantQueryParams2!private!tests! !
!GlorpReadingTest categoriesFor: #testCount!private!tests-functions! !
!GlorpReadingTest categoriesFor: #testCountOnRelatedAttribute!private!tests-functions! !
!GlorpReadingTest categoriesFor: #testCountStar!private!tests-functions! !
!GlorpReadingTest categoriesFor: #testCountStarInRetrieveWithConstants!public!tests-functions! !
!GlorpReadingTest categoriesFor: #testCountStarOnRelatedObject!private!tests-functions! !
!GlorpReadingTest categoriesFor: #testCountStarOnRelatedObjectAttribute!private!tests-functions! !
!GlorpReadingTest categoriesFor: #testCountStarOnRelatedObjectWithGroupBy!private!tests-functions! !
!GlorpReadingTest categoriesFor: #testCustomSQLInAccountsMapping!private!tests-sql! !
!GlorpReadingTest categoriesFor: #testCustomSQLInAddressMapping!private!tests-sql! !
!GlorpReadingTest categoriesFor: #testDeletedObjectsNotReadInManyQuery!private!tests! !
!GlorpReadingTest categoriesFor: #testDeletedObjectsNotReadInOneQuery!private!tests! !
!GlorpReadingTest categoriesFor: #testDeleteWithEmbedded!private!tests! !
!GlorpReadingTest categoriesFor: #testExpiryTimeNotReset!private!tests-refreshing! !
!GlorpReadingTest categoriesFor: #testExpiryTimeReset!private!tests-refreshing! !
!GlorpReadingTest categoriesFor: #testExpiryTimeReset2!private!tests-refreshing! !
!GlorpReadingTest categoriesFor: #testInFromJoin!private!tests-in! !
!GlorpReadingTest categoriesFor: #testInFromSubselect!private!tests-in! !
!GlorpReadingTest categoriesFor: #testMax!private!tests-functions! !
!GlorpReadingTest categoriesFor: #testMin!private!tests-functions! !
!GlorpReadingTest categoriesFor: #testNonIntrusiveAlsoFetch!private!tests! !
!GlorpReadingTest categoriesFor: #testNonRefreshAddress!private!tests-refreshing! !
!GlorpReadingTest categoriesFor: #testQueryHasLimit!private!tests! !
!GlorpReadingTest categoriesFor: #testQueryHasOffset!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAccountsWithCompoundAnySatisfyExists!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAccountsWithCompoundAnySatisfyJoin!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAccountsWithMultipleAnySatisfyExists!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAccountsWithMultipleAnySatisfyJoin!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAccountsWithMultipleAnySatisfyMixed1!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAccountsWithMultipleAnySatisfyMixed2!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAccountsWithNestedAnySatisfyExists!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAccountsWithNestedAnySatisfyJoin!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAccountsWithNestedAnySatisfyMixed1!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAccountsWithNestedAnySatisfyMixed2!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAddress!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAddressProxy!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAddressProxyAlreadyInMemory!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAddressSubstring!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAddressWithCustomSQL!private!tests-sql! !
!GlorpReadingTest categoriesFor: #testReadAddressWithCustomSQLBinding!private!tests-sql! !
!GlorpReadingTest categoriesFor: #testReadAdHoc!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAdHocProxied!private!tests! !
!GlorpReadingTest categoriesFor: #testReadAllAddress!private!tests! !
!GlorpReadingTest categoriesFor: #testReadCompressedMoney!private!tests! !
!GlorpReadingTest categoriesFor: #testReadCompressedMoney2!private!tests! !
!GlorpReadingTest categoriesFor: #testReadCustomerAndAddTransaction!private!tests! !
!GlorpReadingTest categoriesFor: #testReadCustomerWithAccounts!private!tests! !
!GlorpReadingTest categoriesFor: #testReadCustomerWithAnySatisfyExists!private!tests! !
!GlorpReadingTest categoriesFor: #testReadCustomerWithAnySatisfyJoin!private!tests! !
!GlorpReadingTest categoriesFor: #testReadCustomerWithIncludes!private!tests! !
!GlorpReadingTest categoriesFor: #testReadCustomerWithMultipleAnySatisfyExists!private!tests! !
!GlorpReadingTest categoriesFor: #testReadCustomerWithMultipleAnySatisfyJoin!private!tests! !
!GlorpReadingTest categoriesFor: #testReadEmbeddedObjectDirectly!private!tests! !
!GlorpReadingTest categoriesFor: #testReadEmbeddedOneToOne!private!tests! !
!GlorpReadingTest categoriesFor: #testReadMultiFieldAdHoc!private!tests! !
!GlorpReadingTest categoriesFor: #testReadMultipleObjectsManyToMany1!private!tests! !
!GlorpReadingTest categoriesFor: #testReadMultipleObjectsManyToMany2!private!tests! !
!GlorpReadingTest categoriesFor: #testReadMultipleObjectsManyToMany3!private!tests! !
!GlorpReadingTest categoriesFor: #testReadMultipleObjectsManyToMany4!private!tests! !
!GlorpReadingTest categoriesFor: #testReadMultipleObjectsToManyAlsoFetchTwoLevels!private!tests! !
!GlorpReadingTest categoriesFor: #testReadPassenger!private!tests! !
!GlorpReadingTest categoriesFor: #testReadRelationshipField!private!tests! !
!GlorpReadingTest categoriesFor: #testReadReservationWithJoinToPassenger!private!tests! !
!GlorpReadingTest categoriesFor: #testReadReservationWithPassenger!private!tests! !
!GlorpReadingTest categoriesFor: #testReadTransactionsWithIndependentSubselect!private!tests! !
!GlorpReadingTest categoriesFor: #testReadTransactionsWithIndependentSubselectAndNot!private!tests! !
!GlorpReadingTest categoriesFor: #testReadTransactionsWithMaxSubselect!private!tests! !
!GlorpReadingTest categoriesFor: #testReadTransactionsWithMaxSubselectAndRetrieveMax!private!tests! !
!GlorpReadingTest categoriesFor: #testReadWithCacheHits!private!tests! !
!GlorpReadingTest categoriesFor: #testReadWithFalseWhereClause!private!tests! !
!GlorpReadingTest categoriesFor: #testReadWithLimit!private!tests! !
!GlorpReadingTest categoriesFor: #testReadWithLimitAndOffset!private!tests! !
!GlorpReadingTest categoriesFor: #testReadWithNilWhereClause!private!tests! !
!GlorpReadingTest categoriesFor: #testReadWithObjectEqualityToEmbeddedObject!private!tests! !
!GlorpReadingTest categoriesFor: #testReadWithObjectEqualityToEmbeddedObjectNested!private!tests! !
!GlorpReadingTest categoriesFor: #testReadWithOffset!private!tests! !
!GlorpReadingTest categoriesFor: #testReadWithTrueWhereClause!private!tests! !
!GlorpReadingTest categoriesFor: #testRefreshAddress!private!tests-refreshing! !
!GlorpReadingTest categoriesFor: #testRegisteringWithEmbeddedMapping!private!tests! !
!GlorpReadingTest categoriesFor: #testSequencePolicyForInsert!private!tests! !
!GlorpReadingTest categoriesFor: #testSessionRefresh!private!tests-refreshing! !
!GlorpReadingTest categoriesFor: #testSessionRefreshOnExpiry!private!tests-refreshing! !
!GlorpReadingTest categoriesFor: #testSessionRefreshOnExpiryWithCacheLookupOnly!private!tests-refreshing! !
!GlorpReadingTest categoriesFor: #testSessionRefreshOnProxyExpiry!private!tests-refreshing! !
!GlorpReadingTest categoriesFor: #testSessionRefreshOnProxyExpiryWithCacheLookupOnly!private!tests-refreshing! !
!GlorpReadingTest categoriesFor: #testShortCircuitEmptyReturnWhenLimitMeansNoResults!private!tests! !
!GlorpReadingTest categoriesFor: #testSum!private!tests-functions! !
!GlorpReadingTest categoriesFor: #write2CustomerRowsWith3Transactions!private!support! !
!GlorpReadingTest categoriesFor: #writeCustomer1Rows!private!support! !
!GlorpReadingTest categoriesFor: #writeCustomer1RowsWith2Transactions!private!support! !
!GlorpReadingTest categoriesFor: #writeCustomer1RowsWithTransactions!private!support! !
!GlorpReadingTest categoriesFor: #writeReservationData!private!support! !

!GlorpReadingTest class methodsFor!

resources

	^Array with: (Smalltalk at: #GlorpSessionResource) with: GlorpDemoTablePopulatorResource.! !
!GlorpReadingTest class categoriesFor: #resources!private!resources! !

GlorpReadQueryTest guid: (GUID fromString: '{2D084DA5-6E2F-4642-911A-0FC31DDD9AEF}')!
GlorpReadQueryTest comment: ''!
!GlorpReadQueryTest categoriesForClass!Unclassified! !
!GlorpReadQueryTest methodsFor!

helpTestSingleOrderingBy: aBlock setup: setupBlock

	| query result realBlock |
	query := Query returningManyOf: GlorpAddress.
	query orderBy: aBlock.
	realBlock := query expressionBlockFor: aBlock.
	result := session execute: query.
	self verifyOrderFor: result byAttribute: realBlock.!

setUp

	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	session system: (GlorpDemoDescriptorSystem forPlatform: GlorpDatabaseLoginResource defaultLogin database).
	session beginTransaction.
	self writeAddressDoubleOrderingRows.
	self writePersonOrderingRows.!

tearDown

	super tearDown.
	session rollbackTransaction.
	session reset.
	session := nil.!

testCriteriaSetup
	| query |
	query := Query returningOneOf: GlorpAddress where: [:each | each id = 12].
	query session: session.
	query setUpExpressions.
	self assert: query whereClause class == RelationExpression.
	self assert: query whereClause ultimateBaseExpression descriptor 
				== (session descriptorFor: GlorpAddress)!

testDescendingSingleOrdering
	| query result sortedResult |
	
	query := Query returningManyOf: GlorpAddress where: [:each | each street ~= 'Beta'].
	query orderBy: [:each | each street descending].
	result := session execute: query.
	sortedResult := result 
				asSortedCollection: [:a :b | a street > b street].
	self assert: sortedResult asArray = result asArray.!

testDoubleOrderingAddress
	| query |
	query := Query returningManyOf: GlorpAddress.
	query orderBy: [:each | each street].
	query orderBy: [:each | each number].
	self validateDoubleOrderFor: query.!

testIn
	| query result |
	
	query := Query returningManyOf: GlorpAddress where: [:each | each street in: #('Beta' 'Alpha')].
	result := session execute: query.
	self assert: (result allSatisfy: [:each | #('Beta' 'Alpha') includes: each street]).
	self assert: result size = 4.!

testInEmpty
	"This test generates an error in DB2 because DB2 claims that IN (NULL) is invalid,
	since not even NULL can be IN (NULL) (since NULL isn't equal to itself)."

	| query result |
	session platform isDB2Platform ifTrue: [^self].
	query := Query returningManyOf: GlorpAddress where: [:each | each street in: #()].
	result := session execute: query.
	self assert: result isEmpty!

testInInteger
	| query result |
	
	query := Query returningManyOf: GlorpAddress where: [:each | each id in: #(1 2)].
	result := session execute: query.
	self assert: (result allSatisfy: [:each | #(1 2) includes: each id]).
	self assert: result size = 2.!

testInSymbol
	| query result transRow transRow2 |
	transRow := session system exampleBankTransactionRow.
	session writeRow: transRow.	
	transRow2 := session system exampleBankTransactionRow2.
	session writeRow: transRow2.	
	query := Query returningManyOf: GlorpBankTransaction where: [:each | each amount currency in: #(#USD #CDN)].
	result := session execute: query.
	self assert: (result allSatisfy: [:each | each amount currency = #CDN]).
	self assert: result size = 1.
	query := Query returningManyOf: GlorpBankTransaction where: [:each | each amount currency in: #(#USD #DM)].
	result := session execute: query.
	self assert: result isEmpty.!

testLike
	| query result |
	
	query := Query returningManyOf: GlorpAddress where: [:each | each street like: 'Be%'].
	result := session execute: query.
	self assert: (result allSatisfy: [:each | each street = 'Beta']).
	self assert: result size = 3.!

testMixedDoubleOrderingAddress
	| query |
	query := Query returningManyOf: GlorpAddress.
	query orderBy: [:each | each street descending].
	query orderBy: [:each | each number].
	self validateDoubleOrderMixedFor: query.!

testOrderingByRelatedObjectAttribute
	| query result |
	query := Query returningManyOf: GlorpPerson.
	query orderBy: [:each | each address street].
	result := session execute: query.
	self verifyOrderFor: result byAttribute: [:each | each address street].!

testOrderingWithNonEmptyWhereClause

	| query result |
	query := Query returningManyOf: GlorpPerson where: [:each | each id ~= 12].
	query orderBy: #(#address #street).
	result := session execute: query.
	self verifyOrderFor: result byAttribute: [:each | each address street].!

testReadDataItemsFromEmbeddedObject

	| query result transRow id |
	transRow := session system exampleBankTransactionRow.
	session writeRow: transRow.
	id := transRow atFieldNamed: 'ID'.
	query := Query returningManyOf: GlorpBankTransaction.
	query retrieve: [:each | each id].
	query retrieve: [:each | each serviceCharge description].
	result := query executeIn: session.
	self assert: result size = 1.
	self assert: result first = (Array with: id with: 'additional overcharge').!

testReadDistinctIds

	| query result |
	query := Query returningManyOf: GlorpPerson.
	query retrieve: [:each | each id distinct].
	result := query executeIn: session.
	self assert: (result asSortedCollection asArray = #(86 87 88)).!

testReadDistinctIdsWithWhereClause

	| query result |
	query := Query returningManyOf: GlorpPerson.
	query retrieve: [:each | each id distinct].
	query whereClause: [:each | each id ~= 423421].
	result := query executeIn: session.
	self assert: (result asSortedCollection asArray = #(86 87 88)).!

testReadDistinctRelatedAttribute

	| query result allStreets |
	query := Query returningManyOf: GlorpPerson.
	query retrieve: [:each | each address street distinct].
	result := query executeIn: session.
	self assert: (result asSortedCollection asArray = #('Alpha' 'Beta' 'Gamma')).
	allStreets := (session readManyOf: GlorpAddress) collect: [:each | each street].
	self assert: allStreets size = 5.!

testReadMultipleObjects

	| query result tracing addressReadSeparately personReadSeparately allResults |
	query := Query returningManyOf: GlorpPerson.
	tracing := Tracing new.
	tracing retrieve: [:each | each ].
	tracing retrieve: [:each | each address].
	query tracing: tracing.
	query orderBy: #id.
	allResults := query executeIn: session.
	self assert: allResults size = 3.
	result := allResults first.
	self assert: (result at: 1) id = 86.
	self assert: ((result at: 1) class == GlorpPerson).
	self assert: (result at: 1) address == (result at: 2).
	self assert: ((result at: 2) class == GlorpAddress).
	self assert: ((result at: 2) id = 2).
	addressReadSeparately := session readOneOf: GlorpAddress where: [:each | each id = 2].
	self assert: result last == addressReadSeparately.
	personReadSeparately := session readOneOf: GlorpPerson where: [:each | each id = 86].
	self assert: personReadSeparately == result first.
	self assert: personReadSeparately address yourSelf == result last.!

testReadObjectsAndData

	| query result tracing addressReadSeparately personReadSeparately |
	query := Query returningManyOf: GlorpPerson.
	tracing := Tracing new.
	tracing retrieve: [:each | each id].
	tracing retrieve: [:each | each address].
	query tracing: tracing.
	query orderBy: #id.
	result := query executeIn: session.
	self assert: result size = 3.
	self assert: (result first at: 1) = 86.
	self assert: ((result first at: 2) class == GlorpAddress).
	self assert: ((result first at: 2) id = 2).
	addressReadSeparately := session readOneOf: GlorpAddress where: [:each | each id = 2].
	self assert: result first last == addressReadSeparately.
	personReadSeparately := session readOneOf: GlorpPerson where: [:each | each id = 86].
	self assert: personReadSeparately address yourSelf == result first last.!

testReadOneWithObjects

	| query result |
	query := Query returningOneOf: GlorpPerson where: [:each | each id = 86].
	query retrieve: [:each | each].
	query retrieve: [:each | each address].
	query orderBy: [:each | each id].
	result := query executeIn: session.
	self assert: result first id = 86.
	self assert: (result first address yourSelf == result last).!

testReadOnlyPrimaryKeys

	| query result |
	query := Query returningManyOf: GlorpPerson.
	query retrieve: [:each | each id].
	result := query executeIn: session.
	self assert: (result asSortedCollection asArray = #(86 87 88)).!

testReadTwoDataItems

	| query result tracing|
	query := Query returningManyOf: GlorpPerson.
	tracing := Tracing new.
	tracing retrieve: [:each | each id].
	tracing retrieve: [:each | each name].
	query tracing: tracing.
	result := query executeIn: session.
	self assert: result size = 3.
	self assert: (result includes: #(86 'person1')).
	self assert: (result includes: #(87 'person2')).
	self assert: (result includes: #(88 'person3')).!

testReadTwoDataItemsFromDifferentObjects

	| query result tracing|
	query := Query returningManyOf: GlorpPerson.
	tracing := Tracing new.
	tracing retrieve: [:each | each id].
	tracing retrieve: [:each | each address street].
	query tracing: tracing.
	query orderBy: #id.
	result := query executeIn: session.
	self assert: result size = 3.
	self assert: result first = #(86 'Beta').
	self assert: (result at: 2) = #(87 'Gamma').
	self assert: result last = #(88 'Alpha').!

testReadTwoObjects

	| query result |
	query := Query returningManyOf: GlorpPerson.
	query retrieve: [:each | each].
	query retrieve: [:each | each address].
	query orderBy: [:each | each id].
	result := query executeIn: session.
	self assert: result size = 3.
	self assert: (result first atIndex: 1) id = 86.
	self assert: ((result first atIndex: 1) address yourSelf == result first last).!

testSingleOrderingAddress1

	self 
		helpTestSingleOrderingBy: [:each | each street]
		setup: [self writeAddressOrderingRows].!

testSingleOrderingAddress2

	self 
		helpTestSingleOrderingBy: [:each | each number]
		setup: [self writeAddressOrderingRows].!

testSingleOrderingBySymbol

	self 
		helpTestSingleOrderingBy: #street
		setup: [self writeAddressOrderingRows].!

testSymbolsOrderingByRelatedObjectAttribute

	| query result |
	query := Query returningManyOf: GlorpPerson.
	query orderBy: #(#address #street).
	result := session execute: query.
	self verifyOrderFor: result byAttribute: [:each | each address street].!

validateDoubleOrderFor: query 
	| result sortedResult |
	result := session execute: query.
	sortedResult := result asSortedCollection: 
					[:a :b | 
					a street = b street 
						ifTrue: [a number <= b number]
						ifFalse: [a street < b street]].
	^self assert: sortedResult asArray = result asArray!

validateDoubleOrderMixedFor: query 
	| result sortedResult |
	result := session execute: query.
	sortedResult := result asSortedCollection: 
					[:a :b | 
					a street = b street 
						ifTrue: [a number <= b number]
						ifFalse: [a street > b street]].
	^self assert: sortedResult asArray = result asArray!

verifyOrderFor: result byAttribute: aBlock
	1 to: result size - 1
		do: 
			[:i | 
			| a b |
			a := result at: i.
			b := result at: i + 1.
			self assert: (aBlock value: a) <= (aBlock value: b)]!

writeAddressDoubleOrderingRows

	self writeAddressOrderingRows.
	session writeRow: session system exampleAddressRowForOrdering4.
	session writeRow: session system exampleAddressRowForOrdering5.!

writeAddressOrderingRows

	session writeRow: session system exampleAddressRowForOrdering1.
	session writeRow: session system exampleAddressRowForOrdering2.
	session writeRow: session system exampleAddressRowForOrdering3.!

writePersonOrderingRows

	session writeRow: session system examplePersonRowForOrdering1.
	session writeRow: session system examplePersonRowForOrdering2.
	session writeRow: session system examplePersonRowForOrdering3.! !
!GlorpReadQueryTest categoriesFor: #helpTestSingleOrderingBy:setup:!private!tests-ordering! !
!GlorpReadQueryTest categoriesFor: #setUp!private!support! !
!GlorpReadQueryTest categoriesFor: #tearDown!private!support! !
!GlorpReadQueryTest categoriesFor: #testCriteriaSetup!private!tests! !
!GlorpReadQueryTest categoriesFor: #testDescendingSingleOrdering!private!tests-ordering! !
!GlorpReadQueryTest categoriesFor: #testDoubleOrderingAddress!private!tests-ordering! !
!GlorpReadQueryTest categoriesFor: #testIn!private!tests! !
!GlorpReadQueryTest categoriesFor: #testInEmpty!public!tests! !
!GlorpReadQueryTest categoriesFor: #testInInteger!private!tests! !
!GlorpReadQueryTest categoriesFor: #testInSymbol!private!tests! !
!GlorpReadQueryTest categoriesFor: #testLike!private!tests! !
!GlorpReadQueryTest categoriesFor: #testMixedDoubleOrderingAddress!private!tests-ordering! !
!GlorpReadQueryTest categoriesFor: #testOrderingByRelatedObjectAttribute!private!tests-ordering! !
!GlorpReadQueryTest categoriesFor: #testOrderingWithNonEmptyWhereClause!private!tests-ordering! !
!GlorpReadQueryTest categoriesFor: #testReadDataItemsFromEmbeddedObject!private!tests-data reading! !
!GlorpReadQueryTest categoriesFor: #testReadDistinctIds!private!tests-data reading! !
!GlorpReadQueryTest categoriesFor: #testReadDistinctIdsWithWhereClause!private!tests-data reading! !
!GlorpReadQueryTest categoriesFor: #testReadDistinctRelatedAttribute!private!tests-data reading! !
!GlorpReadQueryTest categoriesFor: #testReadMultipleObjects!private!tests! !
!GlorpReadQueryTest categoriesFor: #testReadObjectsAndData!private!tests-data reading! !
!GlorpReadQueryTest categoriesFor: #testReadOneWithObjects!private!tests-data reading! !
!GlorpReadQueryTest categoriesFor: #testReadOnlyPrimaryKeys!private!tests-data reading! !
!GlorpReadQueryTest categoriesFor: #testReadTwoDataItems!public!tests-data reading! !
!GlorpReadQueryTest categoriesFor: #testReadTwoDataItemsFromDifferentObjects!private!tests-data reading! !
!GlorpReadQueryTest categoriesFor: #testReadTwoObjects!private!tests-data reading! !
!GlorpReadQueryTest categoriesFor: #testSingleOrderingAddress1!private!tests-ordering! !
!GlorpReadQueryTest categoriesFor: #testSingleOrderingAddress2!private!tests-ordering! !
!GlorpReadQueryTest categoriesFor: #testSingleOrderingBySymbol!private!tests-ordering! !
!GlorpReadQueryTest categoriesFor: #testSymbolsOrderingByRelatedObjectAttribute!private!tests-ordering! !
!GlorpReadQueryTest categoriesFor: #validateDoubleOrderFor:!private!support! !
!GlorpReadQueryTest categoriesFor: #validateDoubleOrderMixedFor:!private!support! !
!GlorpReadQueryTest categoriesFor: #verifyOrderFor:byAttribute:!private!support! !
!GlorpReadQueryTest categoriesFor: #writeAddressDoubleOrderingRows!private!support! !
!GlorpReadQueryTest categoriesFor: #writeAddressOrderingRows!private!support! !
!GlorpReadQueryTest categoriesFor: #writePersonOrderingRows!private!support! !

!GlorpReadQueryTest class methodsFor!

resources

	^Array with: (Smalltalk at: #GlorpSessionResource).! !
!GlorpReadQueryTest class categoriesFor: #resources!private!resources! !

GlorpSimpleQueryTest guid: (GUID fromString: '{8D993CA1-2D0D-46EB-BC75-2AA8ACF47731}')!
GlorpSimpleQueryTest comment: ''!
!GlorpSimpleQueryTest categoriesForClass!Unclassified! !
!GlorpSimpleQueryTest methodsFor!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.!

setUpQueryBasic: query 
	| |
	query session: session.
	query setUpExpressions.
	query setupTracing.!

setUpQueryFields: query 
	self setUpQueryBasic: query.
	query computeFields.!

setUpQueryFully: query 
	self setUpQueryBasic: query.
	query prepare!

skipToString
	^session platform supportsANSIJoins ifTrue: ['join '] ifFalse: ['where '].!

tearDown
	super tearDown.
	session reset.
	session := nil.!

testCaseInsensitiveQuery
	| result |
	session platform supportsCaseInsensitiveLike ifFalse: [^self].
	[session beginUnitOfWork.
	session beginTransaction.
	session register: GlorpAddress example1.
	session commitUnitOfWork.
	result := session
				readOneOf: GlorpAddress
				where: [:address | address street ilike: 'WeSt%'].
	self assert: result street = 'West 47th Ave'] 
			ensure: [session rollbackTransaction]!

testComputingFieldsForDirectMappings

	| query table |
	query := SimpleQuery returningOneOf: GlorpAddress where: [:each | each id = 1].
	self setUpQueryFields: query.
	
	table := session system tableNamed: 'GR_ADDRESS'.
	self assert: (query fields = table fields).!

testComputingFieldsForDirectMappingsWithFullPrepare

	| query table |
	query := Query readOneOf: GlorpAddress where: [:each | each id = 1].
	query session: session.
	query prepare.
	
	table := session system tableNamed: 'GR_ADDRESS'.
	self assert: ((query fields collect: [:each | each table parent fieldNamed: each name])= table fields).!

testComputingFieldsForReferenceMappings

	| query table |
	query := SimpleQuery returningOneOf: GlorpPerson where: [:each | each id = 1].
	self setUpQueryFields: query.
	
	table := session system tableNamed: 'PERSON'.
	self assert: (query fields = table fields).!

testComputingFieldsForReferenceMappingsWithFullPrepare

	| query table |
	query := SimpleQuery returningOneOf: GlorpPerson where: [:each | each id = 1].
	query session: session.
	query prepare.
	
	table := session system tableNamed: 'PERSON'.
	self assert: ((query fields collect: [:each | each table parent fieldNamed: each name])= table fields).!

testDescriptorAssignmentToCriteria

	| query |
	query := SimpleQuery returningOneOf: GlorpAddress where: [:each | each id = 1].
	query session: session.
	query setUpExpressions.
	self assert: query whereClause ultimateBaseExpression descriptor == (session descriptorFor: GlorpAddress).!

testDoubleOrderSQL

	| query sql |
	query := SimpleQuery returningManyOf: GlorpAddress.
	query orderBy: [:each | each id].
	query orderBy: [:each | each number].
	self setUpQueryFully: query.
	sql := (query sqlWith: Dictionary new) sqlString.
	self assert: ('* from gr_address t1 order by t1.id, t1.house_num' match: sql asLowercase).!

testFieldAliasingForEmbeddedMappings

	| query table |
	query := SimpleQuery returningOneOf: GlorpBankTransaction where: [:each | each id = 1].
	self setUpQueryFields: query.
	table := session system tableNamed: 'BANK_TRANS'.
	self assert: (query fields = table fields).
	self assert: (query builders first translateFieldPosition: (table fieldNamed: 'ID')) = 1.
	self assert: (query builders first translateFieldPosition: (table fieldNamed: 'OWNER_ID')) = 2.!

testJoinExpressionWithMultipleTables
	| query sql sqlStream result command |
	"<Grumble grumble> stupid incompatibilities"
	query := SimpleQuery returningOneOf: GlorpPassenger where: [:each | each id = 1].
	query session: session.
	query prepare.
	command := query sqlWith: Dictionary new.
	command useBinding: false.
	sql := command sqlString.
	sqlStream := ReadStream on: sql asLowercase.
	sqlStream skipToAll: self skipToString.
	result := sqlStream upToEnd.
	session platform supportsANSIJoins
		ifTrue: [self assert: ('frequent_flyer t2 on *t1.id = t2.id*<n> where *t1.id = 1*' expandMacros match: result)]
		ifFalse: [self assert: ('*(t1.id = 1) and ((t1.id = t2.id*' match: result)]!

testOrderSQL

	| query sql |
	query := SimpleQuery returningManyOf: GlorpAddress.
	query orderBy: [:each | each id].
	self setUpQueryFully: query.
	sql := (query sqlWith: Dictionary new) sqlString.
	self assert: ('* from gr_address t1 order by t1.id' match: sql asLowercase).! !
!GlorpSimpleQueryTest categoriesFor: #setUp!private!support! !
!GlorpSimpleQueryTest categoriesFor: #setUpQueryBasic:!private!tests! !
!GlorpSimpleQueryTest categoriesFor: #setUpQueryFields:!private!tests! !
!GlorpSimpleQueryTest categoriesFor: #setUpQueryFully:!private!tests! !
!GlorpSimpleQueryTest categoriesFor: #skipToString!private!tests! !
!GlorpSimpleQueryTest categoriesFor: #tearDown!private!support! !
!GlorpSimpleQueryTest categoriesFor: #testCaseInsensitiveQuery!private!tests! !
!GlorpSimpleQueryTest categoriesFor: #testComputingFieldsForDirectMappings!private!tests! !
!GlorpSimpleQueryTest categoriesFor: #testComputingFieldsForDirectMappingsWithFullPrepare!private!tests! !
!GlorpSimpleQueryTest categoriesFor: #testComputingFieldsForReferenceMappings!private!tests! !
!GlorpSimpleQueryTest categoriesFor: #testComputingFieldsForReferenceMappingsWithFullPrepare!private!tests! !
!GlorpSimpleQueryTest categoriesFor: #testDescriptorAssignmentToCriteria!private!tests! !
!GlorpSimpleQueryTest categoriesFor: #testDoubleOrderSQL!private!tests-ordering! !
!GlorpSimpleQueryTest categoriesFor: #testFieldAliasingForEmbeddedMappings!private!tests! !
!GlorpSimpleQueryTest categoriesFor: #testJoinExpressionWithMultipleTables!public!tests! !
!GlorpSimpleQueryTest categoriesFor: #testOrderSQL!private!tests-ordering! !

!GlorpSimpleQueryTest class methodsFor!

resources

	^Array with: (Smalltalk at: #GlorpSessionResource).! !
!GlorpSimpleQueryTest class categoriesFor: #resources!private!resources! !

GlorpTimedProxyReaperTest guid: (GUID fromString: '{383556AB-C9A8-441D-BB8B-4ACFD3143FC2}')!
GlorpTimedProxyReaperTest comment: ''!
!GlorpTimedProxyReaperTest categoriesForClass!Unclassified! !
!GlorpTimedProxyReaperTest methodsFor!

README

	"Unfortunately, these tests are timing sensitive. They may intermittently fail, when in fact they are working as advertised.
	Rerun failed tests individually. If a test consistently fails, then it likely indicates a bug."!

setUp
	reaper := TimedProxyReaper new.
	reaper delay: 0.5!

tearDown

	reaper release.
	reaper := nil.!

testAddObjects
	| proxies |
	proxies := OrderedCollection new.
	1
		to: 10
		do:
			[:index | 
			proxies
				add:
					(TimedProxy
						returningOneOf: Object
						where: nil
						in: nil).
			proxies last glorpSecondsToLive: 1000.
			reaper add: proxies last].

	(Delay forSeconds: 1) wait.
	proxies do: [:proxy | self should: [reaper includes: proxy]]!

testExpireObjects
	| proxies |
	proxies := OrderedCollection new.
	1
		to: 10
		do:
			[:index | 
			proxies
				add:
					(TimedProxy
						returningOneOf: Object
						where: nil
						in: nil).
			proxies last glorpSecondsToLive: 1.
			reaper add: proxies last].

	(Delay forSeconds: 5) wait.
	proxies do: [:proxy | self shouldnt: [reaper includes: proxy]]!

testTouchAndExpireObjectsWhileOtherObjectsAreBeingReaped
	| expiringProxy proxy |
	reaper delay: 0.25.
	expiringProxy := TimedProxy
		returningOneOf: Object
		where: nil
		in: nil.
	expiringProxy glorpSecondsToLive: 1.
	proxy := TimedProxy
		returningOneOf: Object
		where: nil
		in: nil.
	proxy glorpSecondsToLive: 2.

	reaper
		add: proxy;
		add: expiringProxy.
	self assert: (reaper includes: proxy).
	self assert: (reaper includes: expiringProxy).
	(Delay forSeconds: 1) wait.
	proxy glorpTouch.
	(Delay forSeconds: 1.5) wait.
	self assert: (reaper includes: proxy).
	self deny: (reaper includes: expiringProxy).
	(Delay forSeconds: 2) wait.
	self deny: (reaper includes: proxy)!

testTouchObjects
	| proxy |
	reaper delay: 0.25.
	proxy := TimedProxy
		returningOneOf: Object
		where: nil
		in: nil.
	proxy glorpSecondsToLive: 2.
	reaper add: proxy.
	(Delay forSeconds: 1) wait.
	proxy glorpTouch.
	(Delay forSeconds: 1.1) wait.
	self should: [reaper includes: proxy].
	(Delay forSeconds: 2) wait.
	self shouldnt: [reaper includes: proxy]! !
!GlorpTimedProxyReaperTest categoriesFor: #README!private!tests! !
!GlorpTimedProxyReaperTest categoriesFor: #setUp!private!support! !
!GlorpTimedProxyReaperTest categoriesFor: #tearDown!private!support! !
!GlorpTimedProxyReaperTest categoriesFor: #testAddObjects!public!tests! !
!GlorpTimedProxyReaperTest categoriesFor: #testExpireObjects!public!tests! !
!GlorpTimedProxyReaperTest categoriesFor: #testTouchAndExpireObjectsWhileOtherObjectsAreBeingReaped!public!tests! !
!GlorpTimedProxyReaperTest categoriesFor: #testTouchObjects!public!tests! !

GlorpUnitOfWorkTest guid: (GUID fromString: '{B581E55C-BC05-48BB-93B6-745142B0B811}')!
GlorpUnitOfWorkTest comment: ''!
!GlorpUnitOfWorkTest categoriesForClass!Unclassified! !
!GlorpUnitOfWorkTest methodsFor!

exampleCustomerProxy
	| p |
	p := Proxy new.
	p session: session.
	p query: (GlorpQueryStub returningOneOf: GlorpCustomer where: [:a | a id = 3]).
	p query result: (GlorpCustomer new id: 3).
	^p!

exampleCustomerWithTransactionsProxy
	| customer |
	customer := GlorpCustomer new.
	customer transactions: self exampleTransactionsProxy.
	^customer!

exampleTransactionsProxy
	| p |
	p := Proxy new.
	p session: session.
	p query: (GlorpQueryStub returningOneOf: GlorpBankTransaction where: [:a | a id ~= 0]).
	p query result: (Array with: GlorpBankTransaction example1 with: GlorpBankTransaction example1).
	^p!

exampleTransactionWithCustomerProxy
	| transaction |
	transaction := GlorpBankTransaction example1.
	transaction owner: self exampleCustomerProxy.
	^transaction!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.!

tearDown
	super tearDown.
	session reset.
	session resetPermissions.
	session := nil.!

testAutomaticRegistrationOnRead
	| p c |
	p := self exampleCustomerProxy.
	c := p getValue.
	session beginUnitOfWork.
	session register: p.
	self assert: (session isRegistered: p).
	self assert: (session isRegistered: c).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction isRegistered: p).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction isRegistered: c).!

testCheckIfInstantiationRequiredForDirectMapping
	| c1 mapping proxy |
	c1 := GlorpCustomer new.
	proxy := Proxy new.
	c1 name: proxy.
	session beginUnitOfWork.
	session register: c1.
	mapping := (session descriptorFor: GlorpCustomer) mappingForAttributeNamed: #name.
	self deny: (session privateGetCurrentUnitOfWork instantiateIfRequiredFor: c1 mapping: mapping).!

testCheckIfInstantiationRequiredForRelationshipInstantiatedProxy
	| c1 mapping proxy |
	c1 := GlorpCustomer new.
	proxy := Proxy new.
	proxy query: (GlorpQueryStub new session: session; result: 'foo').
	proxy session: session.
	proxy yourSelf.
	c1 accounts: proxy.
	session beginUnitOfWork.
	session register: c1.
	c1 accounts: #().
	mapping := (session descriptorFor: GlorpCustomer) mappingForAttributeNamed: #accounts.
	self deny: (session privateGetCurrentUnitOfWork instantiateIfRequiredFor: c1 mapping: mapping).!

testCheckIfInstantiationRequiredForRelationshipNoChange
	"Note that we explicitly register the objects as being old (even though they aren't) so that we don't force instantation of the related objects, which is what we're trying to test."
	| c1 mapping proxy |
	c1 := GlorpCustomer new.
	proxy := Proxy new.
	c1 accounts: proxy.
	session beginUnitOfWork.
	session privateRegisterAsOld: c1.
	mapping := (session descriptorFor: GlorpCustomer) mappingForAttributeNamed: #accounts.
	self deny: (session privateGetCurrentUnitOfWork instantiateIfRequiredFor: c1 mapping: mapping).!

testCheckIfInstantiationRequiredForRelationshipNoProxy
	| c1 mapping |
	c1 := GlorpCustomer new.
	c1 accounts: #().
	session beginUnitOfWork.
	session register: c1.
	c1 accounts: nil.
	mapping := (session descriptorFor: GlorpCustomer) mappingForAttributeNamed: #accounts.
	self deny: (session privateGetCurrentUnitOfWork instantiateIfRequiredFor: c1 mapping: mapping).!

testCheckIfInstantiationRequiredForRelationshipWithChange
	"Note that we explicitly register the objects as being old (even though they aren't) so that we don't force instantation of the related objects, which is what we're trying to test."
	| c1 mapping proxy |
	c1 := GlorpCustomer new.
	proxy := Proxy new.
	proxy session: session.
	proxy query: (GlorpQueryStub new result: 'foo').
	c1 accounts: proxy.
	session beginUnitOfWork.
	session privateRegisterAsOld: c1.
	c1 accounts: #().
	mapping := (session descriptorFor: GlorpCustomer) mappingForAttributeNamed: #accounts.
	self assert: (session privateGetCurrentUnitOfWork instantiateIfRequiredFor: c1 mapping: mapping).!

testCheckIfInstantiationRequiredForToManyRelationshipFromNew
	"Note that we force the object to be registered as new, just to make absolutely sure it's being treated as a new object."
	| c1 proxy |
	c1 := GlorpCustomer new.
	proxy := Proxy new.
	proxy session: session.
	c1 accounts: proxy.
	session beginUnitOfWork.
	session privateRegisterAsNew: c1.
	self assert: (proxy isInstantiated).!

testCommitOrderAtSessionLevel

	| tables | 
	tables := session tablesInCommitOrder.
	tables first name = 'CUSTOMER'.
	self unfinished.!

testInTransactionDoSuccessful
	"This has to test that a transaction completed successfully, so unlike most other tests, we have to clean up the evidence afterwards"

	| result endResult |
	[session inTransactionDo: [
		session writeRow: session system exampleAddressRow].
	result := session readManyOf: GlorpAddress.
	self assert: result size = 1.
	self assert: result first id = 123]
		ensure: [session inTransactionDo: [session accessor executeSQLStringNoResult: 'DELETE FROM GR_ADDRESS']].
	endResult := session readManyOf: GlorpAddress.
	self assert: endResult size = 0.!

testInTransactionDoUnsuccessful

	| result initial|
	initial := session readManyOf: GlorpAddress.
	self assert: initial isEmpty.
	[session inTransactionDo: [
		session writeRow: session system exampleAddressRow.
		self error: 'no you don''t']] on: Dialect error do: [:ex | ex return: nil].
	result := session readManyOf: GlorpAddress.
	self assert: result size = 0.!

testinUnitOfWorkSuccessful

	| result |
	[session beginTransaction.
	session inUnitOfWorkDo: [
		session register: (GlorpReservation new id: 345)].
	result := session readManyOf: GlorpReservation.
	self assert: result size = 1.
	self assert: result first id = 345]
		ensure: [session rollbackTransaction].!

testinUnitOfWorkUnsuccessful

	| result |
	[session beginTransaction.
	[session inUnitOfWorkDo: [
		session register: (GlorpReservation new id: 345).
		self error: 'aaaagh']] on: Dialect error do: [:ex | ex return: nil].
	result := session readManyOf: GlorpReservation.
	self assert: result size = 0]
		ensure: [session rollbackTransaction].!

testOriginalValueFor
	| c1 mapping |
	c1 := GlorpCustomer new.
	c1 name: 'fred'.
	session beginUnitOfWork.
	session register: c1.
	c1 name: 'barney'.
	mapping := (session descriptorFor: GlorpCustomer) mappingForAttributeNamed: #name.
	self assert: (session privateGetCurrentUnitOfWork originalValueFor: c1 mapping: mapping) = 'fred'.!

testPostRegister
	| c1 t1 t2 |
	c1 := GlorpCustomer example2.
	[session beginTransaction.
	session beginUnitOfWork.
	t1 := GlorpBankTransaction new.
	t2 := GlorpBankTransaction new.
	c1 addTransaction: t1.
	c1 addTransaction: t2.
	session register: c1.
	self assert: (session isRegistered: c1).
	self assert: (session isRegistered: t1).
	self assert: (session isRegistered: t2).
	session commitUnitOfWork]
		ensure: [session rollbackTransaction].
	"Need some assertions on what was written"
	self unfinished.!

testPreRegister
	
	| c1 t1 t2 trans |
	c1 := GlorpCustomer example2.
	[session beginTransaction.
	session beginUnitOfWork.
	session register: c1.
	t1 := GlorpBankTransaction new.
	t2 := GlorpBankTransaction new.
	c1 addTransaction: t1.
	c1 addTransaction: t2.
	trans := session privateGetCurrentUnitOfWork privateGetTransaction.
	session commitUnitOfWork.
	self assert: (trans isRegistered: c1).
	self assert: (trans isRegistered: t1).
	self assert: (trans isRegistered: t2).]
		ensure: [session rollbackTransaction].
	"Need some assertions on what got written"
	self unfinished.!

testRegisterAll
	| c1 c2 collection |
	c1 := GlorpCustomer new.
	c2 := GlorpCustomer new.
	session beginUnitOfWork.
	collection := Array with: c1 with: c2.
	session registerAll: collection.
	self assert: (session isRegistered: c1).
	self assert: (session isRegistered: c2).
	self deny: (session isRegistered: collection).!

testRegisterCollection
	| c1 c2 collection |
	c1 := GlorpCustomer new.
	c2 := GlorpCustomer new.
	session beginUnitOfWork.
	collection := Array with: c1 with: c2.
	session register: collection.
	self assert: (session isRegistered: c1).
	self assert: (session isRegistered: collection).!

testRegisterEmbeddedInTargetDontRefetch
	" This tests for a problem with embedded objects suddenly becoming nil. This can happen when an object is part of a to-many relation. If the relation is followed during the registering phase the query will wrongly replace the embedded object even though requiresPopulating is false. When the object itself is already registered the replaced embedded object won't be registered."

	| transactionId customer |
	
	[session beginTransaction.
	session inUnitOfWorkDo: 
			[customer := GlorpCustomer example1.
			customer id: 42.
			session register: customer].
	transactionId := customer transactions first id.
	customer := nil.
	session initializeCache.
	session inUnitOfWorkDo: 
			[| transaction amount |
			transaction := session readOneOf: GlorpBankTransaction
						where: [:each | each id = transactionId].
			amount := transaction amount.
			transaction owner transactions getValue.
			self assert: amount == transaction amount]] 
			ensure: [session rollbackTransaction]!

testRegisterExistingCollection
	| c1 |
	c1 := GlorpCustomer new.
	session beginUnitOfWork.
	session register: c1.
	session register: c1 transactions.
	self assert: (session isRegistered: c1).
	self assert: (session isRegistered: c1 transactions).
	self deny: (session isNew: c1 transactions).!

testRegisteringAndForcingUpdate
	"Test that we can force the first customer to be rewritten, even if it hasn't been modified by using the forceSaveOf: call"
	| customer triedToWrite row table map otherCustomer |
	session beginTransaction.
	customer := GlorpCustomer example1 id: 7.
	otherCustomer := GlorpCustomer example2 id: 8.
	session modify: (Array with: customer with: otherCustomer) in: [].
	session accessor denyWrites.
	session modify: customer in: [].
	session beginUnitOfWork.
	session register: otherCustomer.
	session save: customer.
	[session commitUnitOfWork] on: GlorpIllegalCommand do: [:ex |
		triedToWrite := true.
		table := session system tableNamed: 'GR_CUSTOMER'.
		map := session privateGetCurrentUnitOfWork privateGetRowMap subMapForTable: table.
		row := map at: map keys asArray first.
		self assert: (row at: row fields first) = 7.
		self assert: (row at: row fields last) = 'Fred Flintstone'.
		self assert: map size = 1.
	].
	self assert: triedToWrite.
	session rollbackTransaction.!

testRegisteringAndForcingUpdateToDatabase
	"Test going round trip to the database with forceSaveOf:. This odesn't assert much, but is mostly to make sure we aren't doing an insert instead of an update."
	| customer otherCustomer |
	session beginTransaction.
	customer := GlorpCustomer example1 id: 7.
	otherCustomer := GlorpCustomer example2 id: 8.
	session modify: (Array with: customer with: otherCustomer) in: [].
	session inUnitOfWorkDo: [
		session register: otherCustomer.
		session save: customer].
	session rollbackTransaction.!

testRegisterInstantiatedProxy
	| p c |
	p := self exampleCustomerProxy.
	c := p getValue.
	session beginUnitOfWork.
	session register: p.
	self assert: (session isRegistered: p).
	self assert: (session isRegistered: c).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction isRegistered: p).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction isRegistered: c).!

testRegisterObjectWithCollectionProxyThenInstantiate
	"Note that we explicitly register the objects as being old (even though they aren't) so that we don't force instantation of the related objects, which is what we're trying to test."
	| customer transactions |
	customer := self exampleCustomerWithTransactionsProxy.
	session beginUnitOfWork.
	session privateRegisterAsOld: customer.
	self deny: customer transactions isInstantiated.
	transactions := customer transactions getValue.
	self assert: customer transactions isInstantiated.
	session register: transactions.
	self assert: (session isRegistered: transactions first).
	self assert: (session isRegistered: customer).
	self assert: (session isRegistered: transactions).
	self assert: (session isRegistered: customer transactions).!

testRegisterObjectWithInstantiatedProxy
	| transaction customer |
	transaction := self exampleTransactionWithCustomerProxy.
	customer := transaction owner getValue.
	session beginUnitOfWork.
	session register: transaction.
	self assert: (session isRegistered: transaction).
	self assert: (session isRegistered: customer).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction 
				isRegistered: transaction).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction 
				isRegistered: customer).
	self assert: transaction owner isInstantiated.!

testRegisterObjectWithNilCollection
	| c1 |
	c1 := GlorpCustomer new.
	c1 transactions: nil.
	session beginUnitOfWork.
	session register: c1.
	self assert: (session isRegistered: c1).!

testRegisterObjectWithProxy
	"Note that we explicitly register the objects as being old (even though they aren't) so that we don't force instantation of the related objects, which is what we're trying to test."
	| transaction |
	transaction := self exampleTransactionWithCustomerProxy.
	session beginUnitOfWork.
	session privateRegisterAsOld: transaction.
	self assert: (session isRegistered: transaction).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction 
				isRegistered: transaction).
	self deny: transaction owner isInstantiated.!

testRegisterObjectWithProxyThenInstantiate
	"Note that we explicitly register the objects as being old (even though they aren't) so that we don't force instantation of the related objects, which is what we're trying to test."
	| transaction customer |
	transaction := self exampleTransactionWithCustomerProxy.
	session beginUnitOfWork.
	session privateRegisterAsOld: transaction.
	self deny: transaction owner isInstantiated.
	customer := transaction owner getValue.
	session register: transaction.
	self assert: (session isRegistered: transaction).
	self assert: (session isRegistered: customer).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction 
				isRegistered: transaction).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction 
				isRegistered: customer).
	self assert: transaction owner isInstantiated!

testRegisterObjectWithProxyThenInstantiateAndReregister
	| transaction customer |
	transaction := self exampleTransactionWithCustomerProxy.
	session beginUnitOfWork.
	session register: transaction.
	customer := transaction owner getValue.
	session register: transaction.
	self assert: (session isRegistered: transaction).
	self assert: (session isRegistered: customer).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction 
				isRegistered: transaction).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction 
				isRegistered: customer).
	self assert: transaction owner isInstantiated!

testRegisterProxy
	| p |
	p := self exampleCustomerProxy.
	session beginUnitOfWork.
	session register: p.
	self deny: (session isRegistered: p).
	self deny: (session isRegistered: p query result).
	p getValue.
	self assert: (session isRegistered: p).
	self assert: (session isRegistered: p query result).!

testRegisterProxyThenInstantiateAndReregister
	| p c |
	p := self exampleCustomerProxy.
	session beginUnitOfWork.
	session register: p.
	c := p getValue.
	session register: p.
	self assert: (session isRegistered: p).
	self assert: (session isRegistered: c).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction 
				isRegistered: p).
	self assert: (session privateGetCurrentUnitOfWork privateGetTransaction 
				isRegistered: c)!

testRollbackOneToManyAfterAdd
	| customer t1 t2 transList amount |
	customer := GlorpCustomer example1.
	t1 := customer transactions first.
	t2 := customer transactions last.
	transList := customer transactions.
	amount := t1 amount.
	session beginUnitOfWork.
	session register: customer.
	20 timesRepeat: [customer addTransaction: (GlorpBankTransaction new)].
	customer transactions first amount: 65543.
	session rollbackUnitOfWork.
	self assert: customer transactions == transList.
	self assert: customer transactions size = 2.
	self assert: customer transactions first == t1.
	self assert: customer transactions last == t2.
	self assert: t1 amount == amount.!

testRollbackOneToManyAfterReplace
	| customer t1 t2 transList |
	customer := GlorpCustomer example1.
	t1 := customer transactions first.
	t2 := customer transactions last.
	transList := customer transactions.
	session beginUnitOfWork.
	session register: customer.
	customer transactions: OrderedCollection new.
	session rollbackUnitOfWork.
	self assert: customer transactions == transList.
	self assert: customer transactions size = 2.
	self assert: customer transactions first == t1.
	self assert: customer transactions last == t2.!

testRollbackOneToManyProxy
	| customer t1 t2 transList |
	customer := GlorpCustomer example1.
	t1 := customer transactions first.
	t2 := customer transactions last.
	transList := customer transactions.
	session beginUnitOfWork.
	session register: customer.
	customer transactions: OrderedCollection new.
	session rollbackUnitOfWork.
	self assert: customer transactions == transList.
	self assert: customer transactions size = 2.
	self assert: customer transactions first == t1.
	self assert: customer transactions last == t2.!

testRollbackOneToManyWithList
	"Check that dependents aren't being registered for the collection"
	| customer marker |
	"Lists only exist in VW"
	Dialect isVisualWorks ifFalse: [^self].
	marker := Object new.
	customer := GlorpCustomer example1.
	customer transactions: (customer transactions asList).
	customer transactions addDependent: marker.
	session beginUnitOfWork.
	session register: customer.
	20 timesRepeat: [customer addTransaction: (GlorpBankTransaction new)].
	session rollbackUnitOfWork.
	self assert: customer transactions class == (Dialect smalltalkAt: #List).
	self assert: customer transactions size = 2.
	self should: [customer transactions privateAt: 3] raise: Object subscriptOutOfBoundsSignal.
	self assert: (customer transactions dependents includes: marker).
	self deny: (session isRegistered: marker).!

testRollbackOneToOne
	| transaction customer |
	transaction := GlorpBankTransaction new.
	customer := GlorpCustomer new.
	transaction owner: customer.
	session beginUnitOfWork.
	session register: transaction.
	transaction owner: GlorpCustomer new.
	session rollbackUnitOfWork.
	self assert: transaction owner == customer.!

testRollbackOneToOneWithProxy
	| transaction customerProxy |
	transaction := self exampleTransactionWithCustomerProxy.
	customerProxy := transaction owner.
	session beginUnitOfWork.
	session register: transaction.
	transaction owner: GlorpCustomer new.
	session rollbackUnitOfWork.
	self assert: transaction owner == customerProxy!

testTransactSuccessful
	"This has to test that a transaction completed successfully, so unlike most other tests, we have to clean up the evidence afterwards"

	| result |
	[session transact: [
		session register: (GlorpReservation new id: 345)].
	result := session readManyOf: GlorpReservation.
	self assert: result size = 1.
	self assert: result first id = 345]
		ensure: [session transact: [session accessor executeSQLStringNoResult: 'DELETE FROM RESERVATION']].!

testTransactUnsuccessful

	| result |
	[session transact: [
		session register: (GlorpReservation new id: 345).
		self error: 'didn''t work']] on: Dialect error do: [:ex | ex return: nil].
	result := session readManyOf: GlorpReservation.
	self assert: result size = 0.!

testWriteObjectWithNilCollection
	| c1 query customer |
	c1 := GlorpCustomer new.
	c1 transactions: nil.
	c1 id: 9999.
	[session beginTransaction.
	session beginUnitOfWork.
	session register: c1.
	session commitUnitOfWork.
	query := Query returningOneOf: GlorpCustomer where: [:each | each id = 9999].
	query shouldRefresh: true.
	customer := session execute: query.
	self assert: customer transactions notNil.
	self assert: customer transactions isEmpty.
	]
		ensure: [session rollbackTransaction].! !
!GlorpUnitOfWorkTest categoriesFor: #exampleCustomerProxy!private!support! !
!GlorpUnitOfWorkTest categoriesFor: #exampleCustomerWithTransactionsProxy!private!support! !
!GlorpUnitOfWorkTest categoriesFor: #exampleTransactionsProxy!private!support! !
!GlorpUnitOfWorkTest categoriesFor: #exampleTransactionWithCustomerProxy!private!support! !
!GlorpUnitOfWorkTest categoriesFor: #setUp!private!support! !
!GlorpUnitOfWorkTest categoriesFor: #tearDown!private!support! !
!GlorpUnitOfWorkTest categoriesFor: #testAutomaticRegistrationOnRead!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testCheckIfInstantiationRequiredForDirectMapping!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testCheckIfInstantiationRequiredForRelationshipInstantiatedProxy!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testCheckIfInstantiationRequiredForRelationshipNoChange!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testCheckIfInstantiationRequiredForRelationshipNoProxy!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testCheckIfInstantiationRequiredForRelationshipWithChange!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testCheckIfInstantiationRequiredForToManyRelationshipFromNew!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testCommitOrderAtSessionLevel!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testInTransactionDoSuccessful!private!tests-transaction wrappers! !
!GlorpUnitOfWorkTest categoriesFor: #testInTransactionDoUnsuccessful!private!tests-transaction wrappers! !
!GlorpUnitOfWorkTest categoriesFor: #testinUnitOfWorkSuccessful!private!tests-transaction wrappers! !
!GlorpUnitOfWorkTest categoriesFor: #testinUnitOfWorkUnsuccessful!private!tests-transaction wrappers! !
!GlorpUnitOfWorkTest categoriesFor: #testOriginalValueFor!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testPostRegister!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testPreRegister!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterAll!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterCollection!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterEmbeddedInTargetDontRefetch!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterExistingCollection!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisteringAndForcingUpdate!private!tests-forcing update! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisteringAndForcingUpdateToDatabase!private!tests-forcing update! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterInstantiatedProxy!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterObjectWithCollectionProxyThenInstantiate!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterObjectWithInstantiatedProxy!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterObjectWithNilCollection!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterObjectWithProxy!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterObjectWithProxyThenInstantiate!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterObjectWithProxyThenInstantiateAndReregister!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterProxy!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRegisterProxyThenInstantiateAndReregister!private!tests-registration! !
!GlorpUnitOfWorkTest categoriesFor: #testRollbackOneToManyAfterAdd!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testRollbackOneToManyAfterReplace!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testRollbackOneToManyProxy!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testRollbackOneToManyWithList!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testRollbackOneToOne!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testRollbackOneToOneWithProxy!private!tests! !
!GlorpUnitOfWorkTest categoriesFor: #testTransactSuccessful!private!tests-transaction wrappers! !
!GlorpUnitOfWorkTest categoriesFor: #testTransactUnsuccessful!private!tests-transaction wrappers! !
!GlorpUnitOfWorkTest categoriesFor: #testWriteObjectWithNilCollection!private!tests! !

!GlorpUnitOfWorkTest class methodsFor!

resources

	^Array with: (Smalltalk at: #GlorpSessionResource).! !
!GlorpUnitOfWorkTest class categoriesFor: #resources!private!resources! !

GlorpWritingTest guid: (GUID fromString: '{A693FE58-402E-4668-89F5-076A1BFE604A}')!
GlorpWritingTest comment: ''!
!GlorpWritingTest categoriesForClass!Unclassified! !
!GlorpWritingTest methodsFor!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.!

tearDown
	super tearDown.
	session reset.
	session := nil.!

testLargeWrite
	"This is really just a performance test. No assertions. It should take on the order of 10 seconds. If it starts taking 10 minutes, it indicates a potential problem...."
	| customer |
	session beginTransaction.
	[customer := GlorpCustomer new.
	customer name: 'foo'.
     customer id: 123.
	1 to: 5000 do: [:i | | transaction |
		transaction := GlorpBankTransaction new.
		transaction amount amount: i.
		customer addTransaction: transaction].
	session beginUnitOfWork.
	session register: customer.
	session commitUnitOfWork]
		ensure: [session rollbackTransaction].!

testMultipleWritesAndReads
	"Trying to narrow down on a problem with SQLiteEXDI"

	| names customers |
	session beginTransaction.
	[session beginUnitOfWork.
	names := OrderedCollection new.
	1 to: 10
		do: 
			[:i | 
			| nm |
			nm := 'John Doe ' , i printString.
			names add: nm.
			session register: ((GlorpCustomer new)
									id: i;
									name: nm;
									yourself)].
	session commitUnitOfWork.
	customers := session readManyOf: GlorpCustomer.
	self assert: (names asSortedCollection isSameSequenceAs: (customers collect: [:ea | ea name]) asSortedCollection).
	] 
			ensure: [session rollbackTransaction]!

testRegistrationFromWrittenObject
	| customer trans transactions |
	session beginTransaction.
	[customer := GlorpCustomer new.
	customer name: 'foo'.
     customer id: 123.
	session beginUnitOfWork.
	session register: customer.
	session commitUnitOfWork.
	trans := GlorpBankTransaction new.
	session beginUnitOfWork.
	session readOneOf: GlorpCustomer where: [:each | each id = customer id].
	customer addTransaction: trans.
	session commitUnitOfWork.
	transactions := session accessor executeSQLString: 'SELECT ID FROM BANK_TRANS WHERE OWNER_ID = ', customer id printString.
	self assert: transactions size = 1.
	self assert: (trans id = (transactions first atIndex: 1))]
		ensure: [session rollbackTransaction].! !
!GlorpWritingTest categoriesFor: #setUp!private!support! !
!GlorpWritingTest categoriesFor: #tearDown!private!support! !
!GlorpWritingTest categoriesFor: #testLargeWrite!private!tests! !
!GlorpWritingTest categoriesFor: #testMultipleWritesAndReads!private!tests! !
!GlorpWritingTest categoriesFor: #testRegistrationFromWrittenObject!private!tests! !

GlorpRowDifferencingTest guid: (GUID fromString: '{2FD4BC9C-9E35-4E44-8389-DC2CA9BF25DF}')!
GlorpRowDifferencingTest comment: ''!
!GlorpRowDifferencingTest categoriesForClass!Unclassified! !
!GlorpRowDifferencingTest methodsFor!

addRowsFor: object to: rowMap 
	| descriptor |
	descriptor := system descriptorFor: object class.
	descriptor createRowsFor: object in: rowMap.!

computeDifference
	currentObjectRowMap := self generateRowMapFor: currentObject.
	correspondenceMap := self correspond: currentObject to: mementoObject.
	mementoObjectRowMap := self generateMementoRowMapFor: mementoObject withCorrespondenceMap: correspondenceMap.
	differenceMap := currentObjectRowMap differenceFrom: mementoObjectRowMap.!

correspond: person1 to: person2 
	| correspondanceMap |
	correspondanceMap := IdentityDictionary new.
	correspondanceMap at: person1 put: person2.
	person1 address notNil ifTrue: 
		[correspondanceMap at: person1 address put: person2 address.
		"Now fix it up so this actually looks like a real memento"
		person2 address: person1 address].
	^correspondanceMap!

generateMementoRowMapFor: person withCorrespondenceMap: aDictionary
	| rowMap |
	rowMap := RowMapForMementos withCorrespondenceMap: aDictionary.
	self addRowsFor: person to: rowMap.
	(person address notNil and: [(aDictionary at: person address ifAbsent: [nil]) notNil]) ifTrue: [self addRowsFor: (aDictionary at: person address) to: rowMap].
	^rowMap!

generateRowMapFor: person 
	| rowMap |
	rowMap := RowMap new.
	self addRowsFor: person to: rowMap.
	person address notNil ifTrue: [self addRowsFor: person address to: rowMap].
	^rowMap!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	system := session system.
	session beginUnitOfWork.!

testDifferenceFromAnotherObject
	currentObject := GlorpPerson example1.
	mementoObject := GlorpPerson example2.
	self computeDifference.
	self assert: differenceMap numberOfEntries = 2.
	self 
		assert: (differenceMap 
				numberOfEntriesForTable: (system tableNamed: 'PERSON')) = 1.
	self 
		assert: (differenceMap 
				numberOfEntriesForTable: (system tableNamed: 'GR_ADDRESS')) = 1!

testDifferenceFromSameObjectWithAddedComponent
"	Commenting these out because I think the setup is just wrong.
currentObject := Person example1.
	mementoObject := Person example1WithNoAddress.
	self computeDifference.
	self assert: differenceMap numberOfEntries = 2.
	self 
		assert: (differenceMap 
				numberOfEntriesForTable: (system tableNamed: 'PERSON')) = 1.
	self 
		assert: (differenceMap 
				numberOfEntriesForTable: (system tableNamed: 'GR_ADDRESS')) = 1"!

testDifferenceFromSameObjectWithChangedAttribute
	currentObject := GlorpPerson example1.
	mementoObject := GlorpPerson example1WithDifferentName.
	self computeDifference.
	self assert: differenceMap numberOfEntries = 1.
	self 
		assert: (differenceMap 
				numberOfEntriesForTable: (system tableNamed: 'PERSON')) = 1!

testDifferenceFromSameObjectWithChangedComponent
	"Commenting these out because I think the setup is just wrong"
	"currentObject := Person example1.
	mementoObject := Person example1WithDifferentAddress.

	currentObjectRowMap := self generateRowMapFor: currentObject."

	"Before changes occur, all original objects are registered with the unit of work.  
		To mimic that, the original person's address needs to be added to current (after changes) "
"	self addRowsFor: mementoObject address to: currentObjectRowMap.
	correspondenceMap := self correspond: currentObject to: mementoObject.
	correspondenceMap at: mementoObject address put: mementoObject address.
	correspondenceMap removeKey: currentObject address.
	mementoObjectRowMap := self generateMementoRowMapFor: mementoObject withCorrespondenceMap: correspondenceMap.
	differenceMap := currentObjectRowMap differenceFrom: mementoObjectRowMap.
	self assert: differenceMap numberOfEntries = 2.
	self 
		assert: (differenceMap 
				numberOfEntriesForTable: (system tableNamed: 'PERSON')) = 1.
	self 
		assert: (differenceMap 
				numberOfEntriesForTable: (system tableNamed: 'GR_ADDRESS')) = 1"!

testDifferenceFromSameObjectWithChangedComponentAttribute
	currentObject := GlorpPerson example1.
	mementoObject := GlorpPerson example1WithChangedAddress.
	self computeDifference.
	self assert: differenceMap numberOfEntries = 1.
	self 
		assert: (differenceMap 
				numberOfEntriesForTable: (system tableNamed: 'GR_ADDRESS')) = 1!

testDifferenceFromSameObjectWithDeletedComponent
	"Commenting these out because I think the setup is just wrong"
"	currentObject := Person example1WithNoAddress.
	mementoObject := Person example1.
	self computeDifference.
	self assert: differenceMap numberOfEntries = 1.
	self 
		assert: (differenceMap 
				numberOfEntriesForTable: (system tableNamed: 'PERSON')) = 1"!

testEquality
	| addressRow1 addressRow2 |
	addressRow1 := session system exampleAddressRow.
	addressRow2 := session system exampleAddressRowWithDifferentStreet.
	self assert: (addressRow1 equals: addressRow1).
	self assert: (addressRow1 equals: addressRow2) not.!

testNoDifference2
	| |
	currentObject := GlorpPerson example1.
	mementoObject := GlorpPerson example1.
	self computeDifference.
	self assert: differenceMap numberOfEntries = 0.! !
!GlorpRowDifferencingTest categoriesFor: #addRowsFor:to:!private!support! !
!GlorpRowDifferencingTest categoriesFor: #computeDifference!private!tests! !
!GlorpRowDifferencingTest categoriesFor: #correspond:to:!private!support! !
!GlorpRowDifferencingTest categoriesFor: #generateMementoRowMapFor:withCorrespondenceMap:!private!support! !
!GlorpRowDifferencingTest categoriesFor: #generateRowMapFor:!private!support! !
!GlorpRowDifferencingTest categoriesFor: #setUp!private!support! !
!GlorpRowDifferencingTest categoriesFor: #testDifferenceFromAnotherObject!private!tests! !
!GlorpRowDifferencingTest categoriesFor: #testDifferenceFromSameObjectWithAddedComponent!private!tests! !
!GlorpRowDifferencingTest categoriesFor: #testDifferenceFromSameObjectWithChangedAttribute!private!tests! !
!GlorpRowDifferencingTest categoriesFor: #testDifferenceFromSameObjectWithChangedComponent!private!tests! !
!GlorpRowDifferencingTest categoriesFor: #testDifferenceFromSameObjectWithChangedComponentAttribute!private!tests! !
!GlorpRowDifferencingTest categoriesFor: #testDifferenceFromSameObjectWithDeletedComponent!private!tests! !
!GlorpRowDifferencingTest categoriesFor: #testEquality!private!tests! !
!GlorpRowDifferencingTest categoriesFor: #testNoDifference2!private!tests! !

GlorpSessionBasedTest guid: (GUID fromString: '{4BED4FFF-6BC8-4D2C-A49B-31C7E0332A28}')!
GlorpSessionBasedTest comment: ''!
!GlorpSessionBasedTest categoriesForClass!Unclassified! !
!GlorpSessionBasedTest methodsFor!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	system session: session.
	session system: system.!

tearDown
	super tearDown.
	session isNil ifFalse: [session reset. session resetPermissions].
	session := nil.! !
!GlorpSessionBasedTest categoriesFor: #setUp!private!support! !
!GlorpSessionBasedTest categoriesFor: #tearDown!private!support! !

!GlorpSessionBasedTest class methodsFor!

resources
	^Array with: GlorpDatabaseLoginResource with: (Smalltalk at: #GlorpSessionResource) with: GlorpDemoTablePopulatorResource.! !
!GlorpSessionBasedTest class categoriesFor: #resources!private!resources! !

GlorpCompositeKeyTest guid: (GUID fromString: '{A242E756-E050-43E2-AEC8-483340A86A8F}')!
GlorpCompositeKeyTest comment: ''!
!GlorpCompositeKeyTest categoriesForClass!Unclassified! !
!GlorpCompositeKeyTest methodsFor!

setUp
	super setUp.
	system := (GlorpCompositeKeyDescriptorSystem forPlatform: session platform).
	session system: system.
	session beginTransaction.
	session transact: [session register: system example1].
	session reset.!

tearDown
	session rollbackTransaction.
	session resetPermissions.
	super tearDown.!

testAlsoFetch
	| users |
	users := session readManyOf: GlorpUser.!

testBasicReadFolder
	| folders |
	folders := (session readManyOf: GlorpFolder) asSortedCollection: [:a :b | a name <= b name].
	self assert: folders size = 3.
	self assert: folders first name = 'One'.
	self assert: folders last name = 'Two'.!

testBasicReadMessage
	| messages |
	messages := (session readManyOf: GlorpMessage) asSortedCollection: [:a :b | a subject <= b subject].
	self assert: messages size = 3.
	self assert: messages first subject = 'also goes in folder 1'.
	self assert: (messages at: 2) subject = 'goes in folder 1'.
	self assert: messages last subject = 'goes in folder 2'.!

testBasicReadUser
	| users |
	users := (session readManyOf: GlorpUser) asSortedCollection: [:a :b | a id <= b id].
	self assert: users size = 2.
	self assert: users first name = 'User One'.
	self assert: users last name = 'User Two'.!

testFaulting
	| users user1 sortedFolders user2 |
	users := session readManyOf: GlorpUser.
	user1 := users detect: [:each | each id = 1].
	self assert: user1 folders size = 2.
	sortedFolders := user1 folders asSortedCollection: [:a :b | a name < b name].
	self assert: sortedFolders first name = 'One'.
	user2 := users detect: [:each | each id = 2].
	self assert: user2 folders first messages first subject = 'goes in folder 2'.!

testFolderIdentity
	| folders |
	folders := session readManyOf: GlorpFolder.
	folders do: [:each | | individualFolders individualFolder otherIndividualFolder|
		individualFolders := session readManyOf: GlorpFolder where: [:eachFolder | eachFolder = each].
		self assert: individualFolders size = 1.
		individualFolder := individualFolders first.
		otherIndividualFolder := session readOneOf: GlorpFolder where: [:eachFolder | eachFolder = each].
		self assert: individualFolder == each.
		self assert: otherIndividualFolder == individualFolder].!

testMessageIdentity
	| messages |
	messages := session readManyOf: GlorpMessage.
	messages do: [:each | | individualMessages individualMessage otherIndividualMessage|
		individualMessages := session readManyOf: GlorpMessage where: [:eachMessage | eachMessage = each].
		self assert: individualMessages size = 1.
		individualMessage := individualMessages first.
		otherIndividualMessage := session readOneOf: GlorpMessage where: [:eachMessage | eachMessage = each].
		self assert: individualMessage == each.
		self assert: otherIndividualMessage == individualMessage].!

testReadWithCacheHitFromExpression
	| message |
	session reset.
	message := session readOneOf: GlorpMessage where: [:each | each subject = 'goes in folder 1'].
	self assert: message folder name = 'One'.
	session accessor permitNothing.
	session readOneOf: GlorpFolder where: [:each | each user id = 1 & (each name = 'One')].!

testReadWithCacheHitFromJoin
	| message |
	session reset.
	message := session readOneOf: GlorpMessage where: [:each | each subject = 'goes in folder 1'].
	session readOneOf: GlorpFolder where: [:each | each user id = 1 & (each name = 'One')].
	session accessor permitNothing.
	self assert: message folder name = 'One'.!

testReadWithCacheHitFromParameterizedExpression
	| message query |
	session reset.
	message := session readOneOf: GlorpMessage where: [:each | each subject = 'goes in folder 1'].
	self assert: message folder name = 'One'.
	session accessor permitNothing.
	query := Query readOneOf: GlorpFolder where: [:each | each user id = (each parameter: 1)  & (each name = (each parameter: 2))].
	query executeWithParameters: #(1 'One') in: session.!

testReadWithJoins
	| users |
	users := session readManyOf: GlorpUser where: [:each | each folders anySatisfyJoin: [:eachFolder |
		eachFolder messages anySatisfyJoin: [:eachMessage | eachMessage subject = 'goes in folder 1']]].
	self assert: users size = 1.
	self assert: users first id = 1.!

testReadWithSubselect
	| users |
	users := session readManyOf: GlorpUser where: [:each | each folders anySatisfyExists: [:eachFolder |
		eachFolder messages anySatisfyExists: [:eachMessage | eachMessage subject = 'goes in folder 1']]].
	self assert: users size = 1.
	self assert: users first id = 1.!

testReadWithSubselectAndINClause
	| users |
	self should: [
		users := session readManyOf: GlorpUser where: [:each | 
			each folders anySatisfyExists: [:eachFolder |
				| q |
				q := Query read: GlorpFolder.
				eachFolder in: q]]]
		raise: GlorpInvalidExpressionError.!

testUserIdentity
	| users |
	users := session readManyOf: GlorpUser.
	users
		do:
			[:each | 
			| individualUser otherIndividualUser individualUsers |
			individualUsers := session
				readManyOf: GlorpUser
				where: [:eachIndividual | eachIndividual id = each id].
			self assert: individualUsers size = 1.
			individualUser := individualUsers first.
			otherIndividualUser := session
				readOneOf: GlorpUser
				where: [:eachIndividual | eachIndividual id = each id].
			self assert: individualUser == each.
			self assert: otherIndividualUser == individualUser].!

testUserIdentityViaMessage
	| users |
	users := session readManyOf: GlorpUser.
	users
		do:
			[:each | 
			each folders
				do:
					[:eachFolder | 
					eachFolder messages
						do: [:eachMessage | 
							self assert: eachMessage folder yourSelf == eachFolder.
							self assert: eachMessage user yourSelf == each]]].!

testUserIdentityViaMessageInUnitOfWork
	session beginUnitOfWork.
	[self testUserIdentityViaMessage] ensure: [session rollbackUnitOfWork].! !
!GlorpCompositeKeyTest categoriesFor: #setUp!private!setup! !
!GlorpCompositeKeyTest categoriesFor: #tearDown!private!setup! !
!GlorpCompositeKeyTest categoriesFor: #testAlsoFetch!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testBasicReadFolder!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testBasicReadMessage!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testBasicReadUser!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testFaulting!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testFolderIdentity!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testMessageIdentity!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testReadWithCacheHitFromExpression!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testReadWithCacheHitFromJoin!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testReadWithCacheHitFromParameterizedExpression!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testReadWithJoins!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testReadWithSubselect!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testReadWithSubselectAndINClause!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testUserIdentity!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testUserIdentityViaMessage!private!tests- basic reading! !
!GlorpCompositeKeyTest categoriesFor: #testUserIdentityViaMessageInUnitOfWork!private!tests- basic reading! !

GlorpCursoredCollectionDBTest guid: (GUID fromString: '{14501C86-62E3-4FDE-8F37-64F3A9C5AAD5}')!
GlorpCursoredCollectionDBTest comment: ''!
!GlorpCursoredCollectionDBTest categoriesForClass!Unclassified! !
!GlorpCursoredCollectionDBTest methodsFor!

setUp
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	session beginTransaction.
	self writePersonRows.!

tearDown
	session rollbackTransaction.
	super tearDown.!

testParallelStreams
	| query person query2 stream1 stream2 address person2 address2 |
	session platform supportsMultipleOpenCursors ifFalse: [^self].
	query := Query returningManyOf: GlorpPerson.
	query orderBy: [:each | each id].
	query collectionType: GlorpCursoredStream.
	query2 := Query returningManyOf: GlorpAddress.
	query2 orderBy: [:each | each id].
	query2 collectionType: GlorpCursoredStream.
	stream1 := session execute: query.
	self assert: session privateGetCache numberOfElements = 0.
	stream2 := session execute: query2.
	person := stream1 next.
	self assert: session privateGetCache numberOfElements = 1.
	self assert: person id = 86.
	address := stream2 next.
	self assert: address id = 1.
	self assert: address street = 'Alpha'.
	self assert: session privateGetCache numberOfElements = 2.
	person2 := stream1 next.
	address2 := stream2 next.
	self assert: person2 class == GlorpPerson.
	self assert: address2 class == GlorpAddress.
	self assert: address2 street = 'Beta'.

"SQLite allows multiple processes to have the database file open at once, and multiple processes can read the database at once.  Thus we let that platform return true to #supportsMultipleOpenCursors.  When a process wants to write, it must lock the entire database file for the duration of its update (normally a few milliseconds, during which other processes wait on the writer to finish, then continue).  However this database locking is therefore dependent on the OS file-system and can show issues.  This test, after passing all its assertions, has been seen to fail in tearDown's rollback of the transaction due to 'database is locked'.  The presumption is that both cursors rollback and so appear like competing writes even though neither is really.   Releasing the cursors ends contention and lets the rollback succeed."
	session platform class == SQLite3Platform ifTrue:
		[stream1 release. stream1 := nil.
		stream2 release. stream2 := nil].!

testReadAsStream
	| query stream person restOfPeople |
	query := Query returningManyOf: GlorpPerson.
	query orderBy: [:each | each id].
	query collectionType: GlorpCursoredStream.
	stream := session execute: query.
	self assert: session privateGetCache numberOfElements = 0.
	person := stream next.
	self assert: session privateGetCache numberOfElements = 1.
	self assert: person id = 86.
	restOfPeople := stream upToEnd.
	self assert: restOfPeople size = 2.
	self assert: session privateGetCache numberOfElements = 3.!

testReadEmptyStream
	| query stream person |
	query := Query returningManyOf: GlorpPerson where: [:each | each id = 999].
	query collectionType: GlorpCursoredStream.
	stream := session execute: query.
	self assert: session privateGetCache numberOfElements = 0.
	person := stream next.
	self assert: session privateGetCache numberOfElements = 0.
	self assert: person isNil.
	self assert: stream atEnd.!

testReadLiteralEmptyStream
	| query stream person |
	query := Query returningManyOf: GlorpPerson where: false.
	query collectionType: GlorpCursoredStream.
	stream := session execute: query.
	self assert: session privateGetCache numberOfElements = 0.
	person := stream next.
	self assert: session privateGetCache numberOfElements = 0.
	self assert: person isNil.
	self assert: stream atEnd.!

writePersonRows
	session writeRow: session system exampleAddressRowForOrdering1.
	session writeRow: session system exampleAddressRowForOrdering2.
	session writeRow: session system exampleAddressRowForOrdering3.
	session writeRow: session system examplePersonRowForOrdering1.
	session writeRow: session system examplePersonRowForOrdering2.
	session writeRow: session system examplePersonRowForOrdering3.! !
!GlorpCursoredCollectionDBTest categoriesFor: #setUp!private!support! !
!GlorpCursoredCollectionDBTest categoriesFor: #tearDown!private!support! !
!GlorpCursoredCollectionDBTest categoriesFor: #testParallelStreams!private!tests! !
!GlorpCursoredCollectionDBTest categoriesFor: #testReadAsStream!private!tests! !
!GlorpCursoredCollectionDBTest categoriesFor: #testReadEmptyStream!private!tests! !
!GlorpCursoredCollectionDBTest categoriesFor: #testReadLiteralEmptyStream!private!tests! !
!GlorpCursoredCollectionDBTest categoriesFor: #writePersonRows!private!support! !

GlorpDatabaseSequenceTest guid: (GUID fromString: '{82B08D13-0B17-4005-B05C-5ED69CE752AF}')!
GlorpDatabaseSequenceTest comment: ''!
!GlorpDatabaseSequenceTest categoriesForClass!Unclassified! !
!GlorpDatabaseSequenceTest methodsFor!

assignSequences
	| accessor |
	accessor := session isNil ifFalse: [session accessor].
	row1 preWriteAssignSequencesUsing: session.
	row1 postWriteAssignSequencesUsing: accessor.
	row2 preWriteAssignSequencesUsing: session.
	row2 postWriteAssignSequencesUsing: accessor!

row1Value
	^row1 atFieldNamed: 'ID'.!

row2Value
	^row2 atFieldNamed: 'ID'.!

setUp
	super setUp.
	table := session system tableNamed: 'BANK_TRANS'.
	sequence := (table fieldNamed: 'ID') type sequence.
	row1 := DatabaseRow newForTable: table.
	row2 := DatabaseRow newForTable: table.!

testGetNextValue
	session platform usesIdentityColumns ifTrue: [^self].
	self assignSequences.
	self assert: self row2Value = (self row1Value + 1).!

testReservedNumberAllocation
	session := nil.
	sequence reservedNumbers add: 23; add: 24.
	self assignSequences.
	self assert: self row1Value = 23.
	self assert: self row2Value = 24.!

testReserveEmpty
	session platform usesIdentityColumns ifTrue: [^self].
	sequence reserveSequenceNumbers: 2 in: session for: table.
	session := nil.
	self assignSequences.
	self assert: self row1Value + 1 = self row2Value.!

testReserveUsingTable
	session platform usesIdentityColumns ifTrue: [^self].
	[session beginTransaction.
	self writeTransactionRow: 65.
	self writeTransactionRow: 66.
	self writeTransactionRow: 67.
	sequence
		reserveSequenceNumbers: 7
		in: session
		for: table] ensure: [session rollbackTransaction].
	session := nil.
	self assignSequences.
	self assert: self row1Value + 1 = self row2Value.!

writeTransactionRow: anInteger
	| tempRow |
	tempRow := DatabaseRow newForTable: table.
	session platform usesIdentityColumns ifFalse: [
		tempRow atFieldNamed: 'ID' put: anInteger].
	tempRow atFieldNamed: 'AMT_CURR' put: 'CDN'.
	session writeRow: tempRow.! !
!GlorpDatabaseSequenceTest categoriesFor: #assignSequences!public!tests! !
!GlorpDatabaseSequenceTest categoriesFor: #row1Value!private!tests! !
!GlorpDatabaseSequenceTest categoriesFor: #row2Value!private!tests! !
!GlorpDatabaseSequenceTest categoriesFor: #setUp!private!setup! !
!GlorpDatabaseSequenceTest categoriesFor: #testGetNextValue!private!tests! !
!GlorpDatabaseSequenceTest categoriesFor: #testReservedNumberAllocation!private!tests! !
!GlorpDatabaseSequenceTest categoriesFor: #testReserveEmpty!private!tests! !
!GlorpDatabaseSequenceTest categoriesFor: #testReserveUsingTable!private!tests! !
!GlorpDatabaseSequenceTest categoriesFor: #writeTransactionRow:!private!tests! !

GlorpFilteringQueryDBTest guid: (GUID fromString: '{D748F72C-B439-4255-8D87-0F001DC716B0}')!
GlorpFilteringQueryDBTest comment: ''!
!GlorpFilteringQueryDBTest categoriesForClass!Unclassified! !
!GlorpFilteringQueryDBTest methodsFor!

setUp
	super setUp.
	session beginTransaction.!

tearDown
	session rollbackTransaction.
	session resetPermissions.
	super tearDown.!

testReadDictionary
	| entryMapping encyclopedias query readBackEncyclopedias canadian plagiarists |
	session system: (GlorpEncyclopediaDescriptorSystem forPlatform: session platform).
	system := session system.
	encyclopedias := system exampleEncyclopedias.
	entryMapping := (system descriptorFor: GlorpEncyclopedia) mappingForAttributeNamed: #entries.
	entryMapping useFilteredRead.
	session transact: [session register: encyclopedias].
	session reset.
	query := Query readManyOf: GlorpEncyclopedia.
	query orderBy: [:each | each name].
	readBackEncyclopedias := session execute: query.
	canadian := readBackEncyclopedias first.
	self assert: canadian entries size = 3.
	session accessor permitNothing.

	self assert: (canadian entries at: 'abcde') id = 'two'.
	self assert: (canadian entries at: '12345') id = 'one'.
	self assert: (canadian entries at: 'unique') id = 'three'.
	plagiarists := readBackEncyclopedias at: 2.
	self assert: plagiarists entries size = 2.
	self assert: (plagiarists entries at: '54321') = (canadian entries at: '12345').
	self assert: (plagiarists entries at: 'edcba') = (canadian entries at: 'abcde').
	self assert: readBackEncyclopedias last entries isEmpty.!

testReadOneToMany
	"This doesn't actually short-circuit interestingly, because of the shared holder"
	| accounts txMapping tx1 tx2 otherHolder |
	(GlorpReadingTest new session: session) write2CustomerRowsWith3Transactions.
	txMapping := (system descriptorFor: GlorpCustomer) mappingForAttributeNamed: #transactions.
	txMapping useFilteredRead.
	accounts := session execute: ((Query returningManyOf: GlorpBankAccount where: [:each | each id ~= 2]) orderBy: [:each | each id]).
	"Account 9874, 1 holder, 2 transactions"
	tx1 := accounts last accountHolders first transactions.
	"Account 6, 2 holders, 1 with 1 transaction, 1 shared with 9874" 
	otherHolder := accounts first accountHolders detect: [:each | each id = 28].
	tx2 := otherHolder transactions.
	self assert: (tx1 collect: [:each | each amount currency]) asSortedCollection asArray = #(#CDN #USD).
	self assert: (tx2 collect: [:each | each amount currency]) asSortedCollection asArray = #(EUR).!

testReadOneToMany2
	| accounts txMapping otherHolder holder |
	(GlorpReadingTest new session: session) write2CustomerRowsWith3Transactions.
	txMapping := (system descriptorFor: GlorpCustomer) mappingForAttributeNamed: #transactions.
	txMapping useFilteredRead.
	accounts := session execute: ((Query returningManyOf: GlorpBankAccount where: [:each | each id ~= 2]) orderBy: [:each | each id]).
	"Account 6, 2 holders, 1 with 1 transaction, 1 shared with 9874" 
	holder := accounts first accountHolders detect: [:each | each id = 28].
	otherHolder := accounts first accountHolders detect: [:each | each id = 27].
	self assert:  (holder transactions collect: [:each | each amount currency]) asSortedCollection asArray = #(#EUR).
	session accessor permitNothing.
	self assert: (otherHolder transactions collect: [:each | each amount currency]) asSortedCollection asArray = #(#CDN #USD).!

testReadOneToManyEmptyCriteria
	| accounts txMapping otherHolder holder |
	(GlorpReadingTest new session: session) write2CustomerRowsWith3Transactions.
	txMapping := (system descriptorFor: GlorpCustomer) mappingForAttributeNamed: #transactions.
	txMapping useFilteredRead.
	accounts := session execute: (Query returningManyOf: GlorpBankAccount).
	accounts := accounts asSortedCollection: [:a :b | a id <= b id].
	"Account 6, 2 holders, 1 with 1 transaction, 1 shared with 9874" 
	holder := accounts first accountHolders detect: [:each | each id = 28].
	otherHolder := accounts first accountHolders detect: [:each | each id = 27].
	self assert:  (holder transactions collect: [:each | each amount currency]) asSortedCollection asArray = #(#EUR).
	session accessor permitNothing.
	self assert: (otherHolder transactions collect: [:each | each amount currency]) asSortedCollection asArray = #(#CDN #USD).!

testReadOneToManyNoProxy
	"This doesn't actually short-circuit interestingly, because of the shared holder"
	| accounts txMapping tx1 tx2 otherHolder |
	(GlorpReadingTest new session: session) write2CustomerRowsWith3Transactions.
	txMapping := (system descriptorFor: GlorpCustomer) mappingForAttributeNamed: #transactions.
	txMapping shouldProxy: false.
	txMapping useFilteredRead.
	accounts := session execute: ((Query returningManyOf: GlorpBankAccount where: [:each | each id ~= 2]) orderBy: [:each | each id]).
	"Account 9874, 1 holder, 2 transactions"
	tx1 := accounts last accountHolders first transactions.
	"Account 6, 2 holders, 1 with 1 transaction, 1 shared with 9874" 
	otherHolder := accounts first accountHolders detect: [:each | each id = 28].
	tx2 := otherHolder transactions.
	self assert: (tx1 collect: [:each | each amount currency]) asSortedCollection asArray = #(#CDN #USD).
	self assert: (tx2 collect: [:each | each amount currency]) asSortedCollection asArray = #(EUR).!

testReadOneToOne
	| people addressMapping |
	session writeRow: session system exampleAddressRowForOrdering1.
	session writeRow: session system exampleAddressRowForOrdering2.
	session writeRow: session system exampleAddressRowForOrdering3.

	session writeRow: session system examplePersonRowForOrdering1.
	session writeRow: session system examplePersonRowForOrdering2.
	session writeRow: session system examplePersonRowForOrdering3.

	addressMapping := (system descriptorFor: GlorpPerson) mappingForAttributeNamed: #address.
	addressMapping useFilteredRead.
	people := session execute: (Query returningManyOf: GlorpPerson where: [:each | each id ~= 2]).
	people first address yourSelf.
	session accessor permitNothing.
	people := people asSortedCollection: [:a :b | a id <= b id].
	self assert: people first address id = 2.
	self assert: (people at: 2) address id = 3.
	self assert: (people at: 3) address id = 1.
	self assert: people size = 3.!

testTwoLevelRead
	"A one-many and a many-many"
	| accounts txMapping otherHolder holder accountMapping |
	(GlorpReadingTest new session: session) write2CustomerRowsWith3Transactions.
	txMapping := (system descriptorFor: GlorpCustomer) mappingForAttributeNamed: #transactions.
	txMapping useFilteredRead.
	accountMapping := (system descriptorFor: GlorpBankAccount) mappingForAttributeNamed: #accountHolders.
	accountMapping useFilteredRead.
	accounts := session execute: ((Query returningManyOf: GlorpBankAccount where: [:each | each id ~= 2]) orderBy: [:each | each id]).
	"Account 6, 2 holders, 1 with 1 transaction, 1 shared with 9874" 
	self assert: accounts first accountHolders size = 2.
	holder := accounts first accountHolders detect: [:each | each id = 28].
	holder transactions yourSelf.
	session accessor permitNothing.
	self assert: (accounts last accountHolders collect: [:each | each id]) asArray = #(27).
	otherHolder := accounts first accountHolders detect: [:each | each id = 27].
	self assert:  (holder transactions collect: [:each | each amount currency]) asSortedCollection asArray = #(#EUR).
	session accessor permitNothing.
	self assert: (otherHolder transactions collect: [:each | each amount currency]) asSortedCollection asArray = #(#CDN #USD).! !
!GlorpFilteringQueryDBTest categoriesFor: #setUp!private!support! !
!GlorpFilteringQueryDBTest categoriesFor: #tearDown!private!support! !
!GlorpFilteringQueryDBTest categoriesFor: #testReadDictionary!private!tests! !
!GlorpFilteringQueryDBTest categoriesFor: #testReadOneToMany!private!tests! !
!GlorpFilteringQueryDBTest categoriesFor: #testReadOneToMany2!private!tests! !
!GlorpFilteringQueryDBTest categoriesFor: #testReadOneToManyEmptyCriteria!private!tests! !
!GlorpFilteringQueryDBTest categoriesFor: #testReadOneToManyNoProxy!private!tests! !
!GlorpFilteringQueryDBTest categoriesFor: #testReadOneToOne!private!tests! !
!GlorpFilteringQueryDBTest categoriesFor: #testTwoLevelRead!private!tests! !

GlorpGettingPrimaryKeyFromMappingTest guid: (GUID fromString: '{5C6D93D7-5ACF-4FB3-BDCE-257F1936950D}')!
GlorpGettingPrimaryKeyFromMappingTest comment: ''!
!GlorpGettingPrimaryKeyFromMappingTest categoriesForClass!Unclassified! !
!GlorpGettingPrimaryKeyFromMappingTest methodsFor!

createData
	"Create seed data"
	| doc attb att |
	doc := GlorpDocument new initialize.
	attb := GlorpAttachmentBytes new content: 'Hello, Alan'.
	att := (GlorpAttachment new)
				index: 1;
				mimeType: 'text/plain';
				attachmentBytes: attb.
	session modify: doc in: [doc attachments add: att].!

setUp
	super setUp.
	system := GlorpDocumentDescriptorSystem forPlatform: system platform.
	session system: system.
	session beginTransaction.!

tearDown
	session rollbackTransaction.
	super tearDown.!

testUnchangedInUnitOfWork
 
	| doc |
	self createData.
	session reset.
	doc := session readOneOf: GlorpDocument.
	"Something changed? Should not."
	session modify: doc in: [].
	doc := nil.
	session reset.

	doc := session readOneOf: GlorpDocument.
	self assert: doc attachments size = 1.
	doc attachments do: 
			[:each | 
			self assert: each attachmentBytes content yourSelf notNil].
	"The bug would cause this to write out the attachment over again, generating a primary key constraint error. Just in case that doesn't catch it, do a count"
	session accessor permitNothingDuring: [
		session modify: doc in: []].
	self assert: (session count: GlorpDocument) = 1.
	self assert: (session count: GlorpAttachment) = 1.
	self assert: (session count: GlorpAttachmentBytes) = 1.
	self assert: doc id notNil.
	((session accessor executeSQLString: 'SELECT * FROM ATTACHMENT') first do: [:each | self assert: each notNil]).
	((session accessor executeSQLString: 'SELECT * FROM ATTACHMENTBYTES') first do: [:each | self assert: each notNil])! !
!GlorpGettingPrimaryKeyFromMappingTest categoriesFor: #createData!private!tests! !
!GlorpGettingPrimaryKeyFromMappingTest categoriesFor: #setUp!private!support! !
!GlorpGettingPrimaryKeyFromMappingTest categoriesFor: #tearDown!private!support! !
!GlorpGettingPrimaryKeyFromMappingTest categoriesFor: #testUnchangedInUnitOfWork!private!tests! !

GlorpObjectComparisonJoinsTest guid: (GUID fromString: '{F0601892-CD1A-4452-B925-4C8332AADD8A}')!
GlorpObjectComparisonJoinsTest comment: ''!
!GlorpObjectComparisonJoinsTest categoriesForClass!Unclassified! !
!GlorpObjectComparisonJoinsTest methodsFor!

setUp
	super setUp.
	session system useJoinsForAnySatisfy: true.
	session beginTransaction.
	itinerary1 := GlorpItinerary example1.
	itinerary2 := GlorpItinerary example2.
	itinerary2 reservation passenger: nil.
	itinerary2 reservation passengers: #().

	session transact: [
		session register: itinerary1.
		session register: itinerary2].!

tearDown
	
	session rollbackTransaction.
	itinerary1 := nil.
	itinerary2 := nil.
	super tearDown.!

testBasicEqualNil

	| reservations |
	reservations := session readManyOf: GlorpReservation where: [:each |
		each passenger isNIL].
	self assert: reservations size = 1.
	self assert: reservations first id = 7.!

testBasicNotNil

	| reservations |
	reservations := session readManyOf: GlorpReservation where: [:each |
		each passenger notNIL].
	self assert: reservations size = 1.
	self assert: reservations first id = 2.
	self assert: reservations first passenger id = 3.!

testEqualNil

	| reservations |
	reservations := session readManyOf: GlorpReservation where: [:each |
		each passengers anySatisfy: [:eachPassenger | eachPassenger isNIL]].
	self assert: reservations size = 1.
	self assert: reservations first id = 7.!

testEqualToIdsInExpression
	"Just to verify that this works when not directly comparing objects"

	| reservations |
	reservations := session readManyOf: GlorpReservation where: [:each |
		each passengers anySatisfy: [:eachPassenger | eachPassenger id = each passenger id]].
	self assert: reservations size = 1.
	self assert: reservations first id = 2.
	self assert: reservations first passenger id = 3.!

testEqualToObjectInExpression
	"A somewhat contrived example of comparing two relationships that should end up with the same object, because they're actually mapped the same way. But will fail if the passenger is nil"

	| reservations |
	reservations := session readManyOf: GlorpReservation where: [:each |
		each passengers anySatisfy: [:eachPassenger | eachPassenger = each passenger]].
	self assert: reservations size = 1.
	self assert: reservations first id = 2.
	self assert: reservations first passenger id = 3.!

testEqualToObjectInMemory
	| reservations |
	reservations := session readManyOf: GlorpReservation where: [:each |
		each passengers anySatisfy: [:eachPassenger | eachPassenger = itinerary1 reservation passenger]].
	self assert: reservations size = 1.
	self assert: reservations first id = 2.
	self assert: reservations first passenger id = 3.!

testNotEqualToObjectInExpression
	"A somewhat contrived example of comparing two relationships that should end up with the same object, because they're actually mapped the same way. But will fail if the passenger is nil, because nil ~= nil"

	| reservations |
	reservations := session readManyOf: GlorpReservation where: [:each |
		each passengers anySatisfy: [:eachPassenger | eachPassenger ~= each passenger]].
	self assert: reservations isEmpty.!

testNotEqualToObjectInMemory
	| reservations |
	reservations := session readManyOf: GlorpReservation where: [:each |
		each passengers anySatisfy: [:eachPassenger | eachPassenger ~= (GlorpPassenger new id: 7)]].
	self assert: reservations size = 1.
	self assert: reservations first id = 2.
	self assert: reservations first passenger id = 3.!

testNotNil

	| reservations |
	reservations := session readManyOf: GlorpReservation where: [:each |
		each passengers anySatisfy: [:eachPassenger | eachPassenger notNIL]].
	self assert: reservations size = 1.
	self assert: reservations first id = 2.
	self assert: reservations first passenger id = 3.! !
!GlorpObjectComparisonJoinsTest categoriesFor: #setUp!private!support! !
!GlorpObjectComparisonJoinsTest categoriesFor: #tearDown!private!support! !
!GlorpObjectComparisonJoinsTest categoriesFor: #testBasicEqualNil!private!tests! !
!GlorpObjectComparisonJoinsTest categoriesFor: #testBasicNotNil!private!tests! !
!GlorpObjectComparisonJoinsTest categoriesFor: #testEqualNil!private!tests! !
!GlorpObjectComparisonJoinsTest categoriesFor: #testEqualToIdsInExpression!private!tests! !
!GlorpObjectComparisonJoinsTest categoriesFor: #testEqualToObjectInExpression!private!tests! !
!GlorpObjectComparisonJoinsTest categoriesFor: #testEqualToObjectInMemory!private!tests! !
!GlorpObjectComparisonJoinsTest categoriesFor: #testNotEqualToObjectInExpression!private!tests! !
!GlorpObjectComparisonJoinsTest categoriesFor: #testNotEqualToObjectInMemory!private!tests! !
!GlorpObjectComparisonJoinsTest categoriesFor: #testNotNil!private!tests! !

GlorpObjectMappedToFunctionTest guid: (GUID fromString: '{FBB171F1-3CFD-41C9-9CDF-DB6A26910F41}')!
GlorpObjectMappedToFunctionTest comment: ''!
!GlorpObjectMappedToFunctionTest categoriesForClass!Unclassified! !
!GlorpObjectMappedToFunctionTest methodsFor!

setUp
	| accountRow3 |
	super setUp.
	session beginTransaction.
	system writeCustomer1Rows.
	accountRow3 := system exampleAccountRow3.
	session writeRow: accountRow3.!

tearDown
	session rollbackTransaction.
	super tearDown.!

testBasicRead
	| branches |
	branches := session readManyOf: GlorpBankBranch.
	self assert: branches size = 3.
	self assert: (branches collect: [:each | each branchNumber]) asSortedCollection = #(2 3 712) asSortedCollection.!

testCache
	| branches branch2 branch3 |
	branches := session readManyOf: GlorpBankBranch.
	branch2 := session readOneOf: GlorpBankBranch where: [:each | each branchNumber = 2].
	branch3 := session readOneOf: GlorpBankBranch where: [:each | each branchNumber = 3].
	self deny: branch2 == branch3.
	self assert: (branches includes: branch2).
	self assert: (branches includes: branch3).!

testNoWriteValidation
	| |
	(session system descriptorFor: GlorpBankBranch) mappings next readOnly: false.
	self should: [session system validate] raise: Dialect error.!

testReadQueryingAttributes
	| branches |
	branches := session readManyOf: GlorpBankBranch where: [:each |
		each accounts anySatisfy: [:eachAccount |
			eachAccount accountNumber accountNumber in: #( '3' '4')]].
	self assert: branches size = 2.
	self assert: branches asSet size = 2.!

testRelationships
	| branch accounts |
	branch := session readOneOf: GlorpBankBranch where: [:each | each branchNumber = 2].
	accounts := branch accounts yourSelf.
	self assert: accounts size = 1.
	self assert: accounts first id = 9874.! !
!GlorpObjectMappedToFunctionTest categoriesFor: #setUp!private!support! !
!GlorpObjectMappedToFunctionTest categoriesFor: #tearDown!private!support! !
!GlorpObjectMappedToFunctionTest categoriesFor: #testBasicRead!private!tests! !
!GlorpObjectMappedToFunctionTest categoriesFor: #testCache!private!tests! !
!GlorpObjectMappedToFunctionTest categoriesFor: #testNoWriteValidation!private!tests! !
!GlorpObjectMappedToFunctionTest categoriesFor: #testReadQueryingAttributes!private!tests! !
!GlorpObjectMappedToFunctionTest categoriesFor: #testRelationships!public!support! !

GlorpObjectMappedToImaginaryTableTest guid: (GUID fromString: '{6F03CB05-709A-4943-B645-6E33DC11A3EA}')!
GlorpObjectMappedToImaginaryTableTest comment: ''!
!GlorpObjectMappedToImaginaryTableTest categoriesForClass!Unclassified! !
!GlorpObjectMappedToImaginaryTableTest methodsFor!

queryForComplexSubselectRead: anInteger
	"This exercises doubly-nested subselects, which caused a problem in a user application with joining to the wrong table. The gist of the query is stores where more than anInteger different customers have made rentals"

	| q1 q2 q3 |
	q1 := Query
		readManyOf: GlorpVideoStore
		where: [:store | 
			q2 := Query
				count: GlorpVideoCustomer
				where: [:customer | 
					q3 := Query
						readManyOf: GlorpVideoRental
						where: [:rental | rental store = store].
					q3 retrieve: [:trade | trade customerName].
					customer name in: q3].
			(store getConstant: anInteger) <= q2].
	^q1.!

queryForComplexSubselectRead2: anInteger
	"This exercises doubly-nested subselects, which caused a problem in a user application with joining to the wrong table. The gist of the query is stores where more than anInteger different customers have made rentals"

	| q1 q2 q3 |
	q1 := Query
		readManyOf: GlorpVideoStore
		where: [:store | 
			q2 := Query
				count: GlorpVideoCustomer
				where: [:customer | 
					q3 := Query
						readManyOf: GlorpVideoRental
						where: [:rental | rental customer = customer AND: (rental store = store)].
					q3 retrieve: [:trade | trade customerName].
					customer name in: q3].
			(store getConstant: anInteger) <= q2].
	^q1.!

setUp
	super setUp.
	system := GlorpVideoDescriptorSystem forPlatform: session platform.
	session system: system.
	session beginTransaction.
	example := system exampleStore1.
	example2 := system exampleStore2.
	session inUnitOfWorkDo: [session register: example. session register: example2.].
	session reset.!

tearDown
	session rollbackTransaction.
	super tearDown.!

testComplexSubselectRead
	"This exercises doubly-nested subselects, which caused a problem in a user application with joining to the wrong table"

	| |
	self assert: (session execute: (self queryForComplexSubselectRead: 3)) size = 1.
	self assert: (session execute: (self queryForComplexSubselectRead: 4)) size = 0.!

testComplexSubselectRead2
	"This exercises doubly-nested subselects, which caused a problem in a user application with joining to the wrong table"

	| |
	self assert: (session execute: (self queryForComplexSubselectRead2: 1)) size = 1.
	self assert: (session execute: (self queryForComplexSubselectRead2: 0)) size = 2.!

testReadBackAllCustomer
	| customers |
	customers := session readManyOf: GlorpVideoCustomer.
	self assert: ((customers collect: [:each | each name]) asSortedCollection asArray) = #('Adrian' 'Bob' 'Carol' 'David' 'Eleanor' 'Francois' 'George' 'Hieronymous').!

testReadBackEntireExample
	| store |
	store := session readOneOf: GlorpVideoStore where: [:each | each id = 1].
	example assertEqual: store.!

testReadCustomerWhere
	| customers |
	customers := session readManyOf: GlorpVideoCustomer where: [:each | each name like: '%an%'].
	self assert: ((customers collect: [:each | each name]) asSortedCollection asArray) = #('Adrian'  'Eleanor' 'Francois').!

testReadCustomerWhereWithJoin
	| customers |
	customers := session readManyOf: GlorpVideoCustomer where: [:each | each onlinePurchases anySatisfy: [:eachPurchase | eachPurchase price > 2]].
	self assert: ((customers collect: [:each | each name]) asSortedCollection asArray) = #('Adrian'  'George' ).!

testSelectByBoolean

	| inStore notInStore inStoreImplied notInStoreImplied |
	inStore := session read: GlorpVideoPurchase where: [:each | each inStore = true].
	notInStore := session read: GlorpVideoPurchase where: [:each | each inStore = false].
	self assert: inStore size = 7.
	self assert: notInStore size = 3.
	inStoreImplied := session read: GlorpVideoPurchase where: [:each | each inStore].
	notInStoreImplied := session read: GlorpVideoPurchase where: [:each | each inStore not].
	self assert: inStoreImplied size = 7.
	self assert: notInStoreImplied size = 3.!

testWrite
	"Write and validate that it basically got written correctly, in terms of number and keys of db rows"

	| storeRows storeRow purchaseRows purchaseKeys rentalRows rentalKeys |
	storeRows := session accessor
		executeSQLString: 'SELECT * FROM VIDEO_STORE'.
	storeRows := storeRows asSortedCollection: [:a :b | a first <= b first].
	self assert: storeRows size = 2.
	storeRow := storeRows first.
	self assert: storeRow size = 2.
	self assert: storeRow first = 1.
	self assert: storeRow last = 'Als Video'.
	storeRow := storeRows last.
	self assert: storeRow first = 2.
	self assert: storeRow last = 'Bonzai Video'.
	purchaseRows := session accessor
		executeSQLString: 'SELECT * FROM VIDEO_PURCHASE'.
	self assert: purchaseRows size = 10.
	purchaseKeys := (purchaseRows collect: [:each | each atIndex: 1])
		asSortedCollection.
	self assert: purchaseKeys asArray = #(1 2 3 101 102 103 104 105 106 107).
	rentalRows := session accessor
		executeSQLString: 'SELECT * FROM VIDEO_RENTAL'.
	self assert: rentalRows size = 4.
	rentalKeys := (rentalRows collect: [:each | each atIndex: 1])
		asSortedCollection.
	self assert: rentalKeys asArray = #(1001 1002 1003 1004).! !
!GlorpObjectMappedToImaginaryTableTest categoriesFor: #queryForComplexSubselectRead:!private!tests! !
!GlorpObjectMappedToImaginaryTableTest categoriesFor: #queryForComplexSubselectRead2:!private!tests! !
!GlorpObjectMappedToImaginaryTableTest categoriesFor: #setUp!private!support! !
!GlorpObjectMappedToImaginaryTableTest categoriesFor: #tearDown!private!support! !
!GlorpObjectMappedToImaginaryTableTest categoriesFor: #testComplexSubselectRead!private!tests! !
!GlorpObjectMappedToImaginaryTableTest categoriesFor: #testComplexSubselectRead2!private!tests! !
!GlorpObjectMappedToImaginaryTableTest categoriesFor: #testReadBackAllCustomer!private!tests! !
!GlorpObjectMappedToImaginaryTableTest categoriesFor: #testReadBackEntireExample!private!tests! !
!GlorpObjectMappedToImaginaryTableTest categoriesFor: #testReadCustomerWhere!private!tests! !
!GlorpObjectMappedToImaginaryTableTest categoriesFor: #testReadCustomerWhereWithJoin!private!tests! !
!GlorpObjectMappedToImaginaryTableTest categoriesFor: #testSelectByBoolean!private!tests! !
!GlorpObjectMappedToImaginaryTableTest categoriesFor: #testWrite!private!tests! !

GlorpOptimisticLockingTest guid: (GUID fromString: '{2C2E79F7-E058-49F1-86E7-32D2A0C41B4E}')!
GlorpOptimisticLockingTest comment: ''!
!GlorpOptimisticLockingTest categoriesForClass!Unclassified! !
!GlorpOptimisticLockingTest methodsFor!

changeABookFrom: books
	^session
		transact:
			[session register: books.
			books first copiesInStock: books first copiesInStock - 1].!

setUp
	super setUp.
	session system: GlorpLockingDescriptorSystem new.
	session beginTransaction.
	session transact: [session register: session system example1].!

tearDown
	session rollbackTransaction.
	super tearDown.!

testSuccessfulUpdate
	| books versions newVersions |
	books := session readManyOf: GlorpBook orderBy: #id.
	versions := (session accessor executeSQLString: 'SELECT VERSION FROM BOOK ORDER BY ID') collect: [:each | each first].
	session modify: books in: [
		books do: [:each | each copiesInStock: (each copiesInStock * 2)]].
	newVersions := (session accessor executeSQLString: 'SELECT VERSION FROM BOOK ORDER BY ID') collect: [:each | each first].
	self assert: newVersions = (versions collect: [:each | each + 1]).!

testSuccessfulUpdateOntoNullVersionField
	| books copies someBook |
	someBook := session readOneOf: GlorpBook.
	session accessor executeSQLString: 'UPDATE BOOK SET VERSION = NULL WHERE ID = ', someBook id printString. 
	session reset.
	books := session read: GlorpBook orderBy: #id.
		copies := books collect: [:each | each copiesInStock].
	session transact: [
		session register: books.
		books do: [:each | each copiesInStock: (each copiesInStock - 1)]].
	session reset.
	books := session readManyOf: GlorpBook orderBy: #id.
	self assert: (books collect: [:each | each copiesInStock]) = (copies collect: [:each | each - 1]).!

testSuccessfulUpdateTwiceWithRefresh
	| book |
	book := session readOneOf: GlorpBook where: [:each | each title like: 'Mastering%'].
	session modify: book in: [
		book copiesInStock: 4].
	session refresh: book.
	self assert: book copiesInStock = 4.
	"Make sure we've properly updated the optimistic lock field"
	session modify: book in: [
		book copiesInStock: 7].
	session reset.
	book := session readOneOf: GlorpBook where: [:each | each title like: 'Mastering%'].
	self assert: book copiesInStock = 7.!

testSuccessfulUpdateTwiceWithRefreshAndSaveAndContinue
	| book |
	session beginUnitOfWork.
	book := session readOneOf: GlorpBook where: [:each | each title like: 'Mastering%'].
	book copiesInStock: 4.
	session saveAndContinue.
	session refresh: book.
	self assert: book copiesInStock = 4.
	"Make sure we've properly updated the optimistic lock field"
	book copiesInStock: 7.
	session commitUnitOfWork.
	session reset.
	book := session readOneOf: GlorpBook where: [:each | each title like: 'Mastering%'].
	self assert: book copiesInStock = 7.!

testUnsuccessfulUpdateProceedingAndFailing
	| books |
	books := session readManyOf: GlorpBook.
	session accessor
		executeSQLStringNoResult: 'UPDATE BOOK SET COPIES_IN_STOCK = 7, VERSION = 3'.
	self should: [[self changeABookFrom: books] on: GlorpWriteFailure do: [:ex | ex resume: false]] raise: GlorpTransactionFailure.
		
	session reset.
	books := session readManyOf: GlorpBook.
	self assert: (books collect: [:each | each copiesInStock]) = #( 7 7).!

testUnsuccessfulUpdateProceedingAnyway
	| books |
	books := session readManyOf: GlorpBook.
	session accessor
		executeSQLStringNoResult: 'UPDATE BOOK SET COPIES_IN_STOCK = 7, VERSION = 3'.
	[self changeABookFrom: books] on: GlorpWriteFailure do: [:ex | ex resume: true].
		
	session reset.
	books := session readManyOf: GlorpBook.
	self assert: (books collect: [:each | each copiesInStock]) = #( 7 7).!

testUnsuccessfulUpdateWithNoAction
	"This is a little quirky. SUnit's action in should:raise: is to exit the exception with true. So the thing just short circuits, and we don't get a transaction failure because we killed the whole unit of work. This is, in general, what will happen if we handle and don't resume the write failures."
	| books |
	books := session readManyOf: GlorpBook.
	session accessor
		executeSQLStringNoResult: 'UPDATE BOOK SET COPIES_IN_STOCK = 7, VERSION = 3'.
	self shouldnt: [
		self should: [self changeABookFrom: books] raise: GlorpWriteFailure]
		raise: GlorpTransactionFailure.
	session reset.
	books := session readManyOf: GlorpBook.
	self assert: (books collect: [:each | each copiesInStock]) = #(7 7).! !
!GlorpOptimisticLockingTest categoriesFor: #changeABookFrom:!private!tests! !
!GlorpOptimisticLockingTest categoriesFor: #setUp!private!support! !
!GlorpOptimisticLockingTest categoriesFor: #tearDown!private!support! !
!GlorpOptimisticLockingTest categoriesFor: #testSuccessfulUpdate!private!tests! !
!GlorpOptimisticLockingTest categoriesFor: #testSuccessfulUpdateOntoNullVersionField!private!tests! !
!GlorpOptimisticLockingTest categoriesFor: #testSuccessfulUpdateTwiceWithRefresh!private!tests! !
!GlorpOptimisticLockingTest categoriesFor: #testSuccessfulUpdateTwiceWithRefreshAndSaveAndContinue!private!tests! !
!GlorpOptimisticLockingTest categoriesFor: #testUnsuccessfulUpdateProceedingAndFailing!private!tests! !
!GlorpOptimisticLockingTest categoriesFor: #testUnsuccessfulUpdateProceedingAnyway!private!tests! !
!GlorpOptimisticLockingTest categoriesFor: #testUnsuccessfulUpdateWithNoAction!private!tests! !

GlorpQueryUnionTest guid: (GUID fromString: '{65F73257-D87D-4DCF-A4D8-D85A5D875DAB}')!
GlorpQueryUnionTest comment: 'This tests the ability to do a union operation on queries, returning results corresponding to multiple different queries.'!
!GlorpQueryUnionTest categoriesForClass!Unclassified! !
!GlorpQueryUnionTest methodsFor!

setUp
	super setUp.
	session beginTransaction.
	self writeAddressOrderingRows.!

tearDown
	session rollbackTransaction.
	super tearDown.!

testBasicExcept
	| query1 query2 union result |
	query1 := Query returningManyOf: GlorpAddress where: [:each | each id = 1].
	query2 := Query returningManyOf: GlorpAddress where: [:each | each id = 2].	
	union := query1 except: query2.
	result := session execute: union.
	self assert: result size = 1.!

testBasicExcept2
	| query1 query2 union result |
	query1 := Query returningManyOf: GlorpAddress where: [:each | each id in: #(1 2)].	
	query2 := Query returningManyOf: GlorpAddress where: [:each | each id = 1].
	union := query1 except: query2.
	result := session execute: union.
	self assert: result size = 1.
	self assert: result first id = 2.!

testBasicExcept3
	| query1 query2 union result |
	query1 := Query returningManyOf: GlorpAddress where: [:each | each id = 1].
	query2 := Query returningManyOf: GlorpAddress where: [:each | each street = 'Alpha'].	
	union := query1 except: query2.
	result := session execute: union.
	self assert: result size = 0.!

testBasicIntersect
	| query1 query2 union result |
	query1 := Query returningManyOf: GlorpAddress where: [:each | each id = 1].
	query2 := Query returningManyOf: GlorpAddress where: [:each | each id = 2].	
	union := query1 intersect: query2.
	result := session execute: union.
	self assert: result size = 0.!

testBasicIntersect2
	| query1 query2 union result |
	query1 := Query returningManyOf: GlorpAddress where: [:each | each id = 1].
	query2 := Query returningManyOf: GlorpAddress where: [:each | each id in: #(1 2)].	
	union := query1 intersect: query2.
	result := session execute: union.
	self assert: result size = 1.!

testBasicIntersect3
	| query1 query2 union result |
	query1 := Query returningManyOf: GlorpAddress where: [:each | each id = 1].
	query2 := Query returningManyOf: GlorpAddress where: [:each | each street = 'Alpha'].	
	union := query1 intersect: query2.
	result := session execute: union.
	self assert: result size = 1.!

testBasicUnion
	| query1 query2 union result |
	query1 := Query returningManyOf: GlorpAddress where: [:each | each id = 1].
	query2 := Query returningManyOf: GlorpAddress where: [:each | each id = 2].	
	union := query1 unionAll: query2.
	result := session execute: union.
	self assert: result size = 2.
	self assert: result first id = 1.
	self assert: result last id = 2.
	self assert: (result allSatisfy: [:each | each class == GlorpAddress]).!

testCompoundCommandCreate
	| query1 union command |
	query1 := Query returningManyOf: GlorpAddress.
	union := query1 unionAll: query1.
	union session: session.
	command := union sqlWith: #().
	self assert: command class == CompoundSelectCommand.!

testCreateCompoundQuery
	| query1 union |
	query1 := Query returningManyOf: GlorpAddress.
	union := query1 unionAll: query1.
	self assert: union class == CompoundQuery.!

testOrderByInUnion
	| query1 query2 union result |
	self writePeople.
	query1 := Query returningManyOf: GlorpAddress where: [:each | each id > 1].
	query1 retrieve: #id.
	query2 := Query returningManyOf: GlorpPerson.
	query2 retrieve: [:each | each id].
	union := query1 unionAll: query2.
	union orderBy: [:each | each id descending].
	result := session execute: union.
	self assert: result = #(87 86 3 2).!

testThreeWayUnion
	| query1 query2 union result query3 |
	query1 := Query returningManyOf: GlorpAddress where: [:each | each id = 1].
	query2 := Query returningManyOf: GlorpAddress where: [:each | each id = 2].	
	query3 := Query returningManyOf: GlorpAddress where: [:each | each id = 3].	

	union := (query1 unionAll: query2) unionAll: query3.
	union orderBy: [:each | each id].
	result := session execute: union.
	self assert: result size = 3.
	self assert: result first id = 1.
	self assert: result last id = 3.
	self assert: (result allSatisfy: [:each | each class == GlorpAddress]).!

testUnionSQL
	"Use expandMacros to avoid platform-specific line-end conventions blocking string matching."

	| query1 union command |
	query1 := Query returningManyOf: GlorpAddress where: [:each | each id = 1].
	union := query1 unionAll: query1.
	union session: session.
	command := union sqlWith: #().
	self assert: ('SELECT * FROM (*SELECT *<n> FROM GR_ADDRESS t1<n> WHERE *t1.ID = * UNION ALL *SELECT *<n> FROM GR_ADDRESS t1<n> WHERE *t1.ID = *' expandMacros match: command sqlString).!

testUnionWithEmpty
	| query1 query2 union result |
	query1 := Query returningManyOf: GlorpAddress where: false.
	query2 := Query returningManyOf: GlorpAddress where: [:each | each id = 2].	
	union := query1 unionAll: query2.
	result := session execute: union.
	self assert: result size = 1.
	self assert: result first id = 2.
	self assert: (result allSatisfy: [:each | each class == GlorpAddress]).!

testUnionWithParameters
	| query1 query2 union result field1 dict |
	field1 := (system tableNamed: 'GR_ADDRESS') fieldNamed: 'ID'.
	query1 := Query returningManyOf: GlorpAddress where: [:each | each id = (each parameter: field1)].
	query2 := Query returningManyOf: GlorpAddress where: [:each | each id = ((each parameter: field1) + 1)].	
	union := query1 unionAll: query2.
	union orderBy: [:each | each id].
	dict := Dictionary new at: field1 put: 2; yourself.
	result := union executeWithParameters: dict in: session.
	self assert: result size = 2.
	self assert: result first id = 2.
	self assert: result last id = 3.
	self assert: (result allSatisfy: [:each | each class == GlorpAddress]).!

testUnionWithRetrieveDisaparateResults
	| query1 query2 union result |
	self writePeople.
	query1 := Query returningManyOf: GlorpAddress.
	query1 retrieve: #id.
	query2 := Query returningManyOf: GlorpPerson.
	query2 retrieve: #id.
	union := query1 unionAll: query2.
	result := session execute: union.
	self assert: result asSortedCollection asArray = #(1 2 3 86 87).!

testUnionWithRetrieveThoroughlyDisaparateResults
	"Fields from mismatched tables"
	| query1 query2 union result |
	self writePeople.
	query1 := Query returningManyOf: GlorpAddress.
	query1 retrieve: [:each | each street].
	query2 := Query returningManyOf: GlorpPerson.
	query2 retrieve: [:each | each name].
	union := query1 unionAll: query2.
	result := session execute: union.
	self assert: result asSortedCollection asArray = #('Alpha' 'Beta' 'Gamma' 'person1' 'person2').!

testUnionWithRetrieveThoroughlyDisaparateResults2
	"The tables will get aliased differently, make sure that works"

	| query1 query2 union result |
	self writePeople.
	query1 := Query returningManyOf: GlorpAddress where: [:each | each id = 2].
	query1 retrieve: [:each | each street].
	query2 := Query returningManyOf: GlorpPerson where: [:each | each id = 87].
	query2 retrieve: [:each | each address street].
	union := query1 unionAll: query2.
	result := session execute: union.
	self assert: result asSortedCollection asArray = #('Beta' 'Gamma').!

writeAddressOrderingRows

	session writeRow: session system exampleAddressRowForOrdering1.
	session writeRow: session system exampleAddressRowForOrdering2.
	session writeRow: session system exampleAddressRowForOrdering3.!

writePeople

	session writeRow: session system examplePersonRowForOrdering1.
	session writeRow: session system examplePersonRowForOrdering2.! !
!GlorpQueryUnionTest categoriesFor: #setUp!private!support! !
!GlorpQueryUnionTest categoriesFor: #tearDown!private!support! !
!GlorpQueryUnionTest categoriesFor: #testBasicExcept!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testBasicExcept2!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testBasicExcept3!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testBasicIntersect!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testBasicIntersect2!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testBasicIntersect3!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testBasicUnion!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testCompoundCommandCreate!private!tests-unit! !
!GlorpQueryUnionTest categoriesFor: #testCreateCompoundQuery!private!tests-unit! !
!GlorpQueryUnionTest categoriesFor: #testOrderByInUnion!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testThreeWayUnion!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testUnionSQL!private!tests-unit! !
!GlorpQueryUnionTest categoriesFor: #testUnionWithEmpty!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testUnionWithParameters!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testUnionWithRetrieveDisaparateResults!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testUnionWithRetrieveThoroughlyDisaparateResults!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #testUnionWithRetrieveThoroughlyDisaparateResults2!private!tests-functional! !
!GlorpQueryUnionTest categoriesFor: #writeAddressOrderingRows!private!support! !
!GlorpQueryUnionTest categoriesFor: #writePeople!private!support! !

GlorpSelectCommandTest guid: (GUID fromString: '{30D54BCD-129E-4D19-A3F5-29C069D88546}')!
GlorpSelectCommandTest comment: ''!
!GlorpSelectCommandTest categoriesForClass!Unclassified! !
!GlorpSelectCommandTest methodsFor!

testExecute
	| command dict result string |
	dict := #('abc' 'Smalltalk').
	string := session useBinding
		ifTrue: ['SELECT ID FROM STUFF WHERE THING=? OR THING = ?']
		ifFalse:
			['SELECT ID FROM STUFF WHERE THING=''abc'' OR THING = ''Smalltalk'''].
	command := SQLStringSelectCommand
		sqlString: string
		parameters: dict
		useBinding: session useBinding
		session: session.
	result := session accessor executeCommand: command.
	self assert: result size = 2.
	self assert: result first first = 12.
	self assert: result last first = 113141.! !
!GlorpSelectCommandTest categoriesFor: #testExecute!public!tests! !

GlorpTestUpdatingTimestampInRecord guid: (GUID fromString: '{9A4C7335-7E84-4CC1-B5B9-FBD004341CED}')!
GlorpTestUpdatingTimestampInRecord comment: ''!
!GlorpTestUpdatingTimestampInRecord categoriesForClass!Unclassified! !
!GlorpTestUpdatingTimestampInRecord methodsFor!

testUpdating

	| record firstTime secondTime |
	session beginTransaction.
	[
	"First verify that when we insert, a timestamp is set"
	record := GlorpRecordWithUpdateTime new id: 12; name: 'thing'.
	session modify: record in: [ ].
	session reset.
	record := session readOneOf: GlorpRecordWithUpdateTime.
	self assert: record id = 12.
	firstTime := record updateTime asSeconds.
	self assert: (firstTime - TimeStamp current asSeconds) < 2.
	"Now wait long enough for the timestamp to definitely change, and verify that if modify the object it changes"
	(Delay forSeconds: 2) wait.
	session modify: record in: [record name: 'different'].
	secondTime := record updateTime asSeconds.
	self deny: secondTime = firstTime.
	"Now verify that if we don't modify the object, we don't write the timestamp, or put it into the object"
	(Delay forSeconds: 2) wait.
	session modify: record in: [].
	self assert: record updateTime asSeconds = secondTime.
	session reset.
	record := session readOneOf: GlorpRecordWithUpdateTime.
	self assert: record updateTime asSeconds = secondTime.]
		ensure: [session rollbackTransaction].!

testUpdatingComment
	"Test that we update the unmapped comment field. We just put the printString of time now into the field, so most of the same sort of logic applies as in testUpdating."

	| record time time2 rows |
	session beginTransaction.
	[
	"First verify that when we insert, a comment is set"
	record := GlorpRecordWithUpdateTime new id: 12; name: 'thing'.
	time := Time now printString.
	session modify: record in: [ ].
	time2 := Time now printString.
	session reset.
	rows := session accessor executeSQLString: 'SELECT UPDATE_COMMENT from RECORD_WITH_UPDATE'.
	"Just in case the seconds flipped in that interval between us noting the time and the value being generated, check against before and after. I really can't see there being more than a one second gap in there"
	self assert: (rows first first = time or: [rows first first = time2]).

	"Now wait long enough for the time to definitely change, and verify that if modify the object it changes"
	(Delay forSeconds: 2) wait.
	record := session readOneOf: GlorpRecordWithUpdateTime.
	time := Time now printString.
	session modify: record in: [record name: 'different'].
	time2 := Time now printString.
	rows := session accessor executeSQLString: 'SELECT UPDATE_COMMENT from RECORD_WITH_UPDATE'.
	"Just in case the seconds flipped in that interval between us noting the time and the value being generated, check against before and after. I really can't see there being more than a one second gap in there"
	self assert: (rows first first = time or: [rows first first = time2]).

	"Now verify that if we don't modify the object, we don't write the comment, or put it into the object"
	(Delay forSeconds: 2) wait.
	session modify: record in: [].
	rows := session accessor executeSQLString: 'SELECT UPDATE_COMMENT from RECORD_WITH_UPDATE'.
	"Now verify that we still have the previous time value"
	self assert: (rows first first = time or: [rows first first = time2]).
]
		ensure: [session rollbackTransaction].!

testUpdatingOtherThing
	"Test that we update the mapped other thing field. We just put the printString of time now into the field, so most of the same sort of logic applies as in testUpdating."

	| record time time2 newThing |
	session beginTransaction.
	[
	"First verify that when we insert, a comment is set"
	record := GlorpRecordWithUpdateTime new id: 12; name: 'thing'.
	time := Time now printString.
	session modify: record in: [ ].
	time2 := Time now printString.
	session reset.
	newThing := session readOneOf: GlorpRecordWithUpdateTime.
	"Just in case the seconds flipped in that interval between us noting the time and the value being generated, check against before and after. I really can't see there being more than a one second gap in there"
	self assert: (newThing updateSomeOtherThing = time or: [newThing updateSomeOtherThing = time2]).

	"Now wait long enough for the time to definitely change, and verify that if modify the object it changes"
	(Delay forSeconds: 2) wait.
	session reset.
	record := session readOneOf: GlorpRecordWithUpdateTime.
	time := Time now printString.
	session modify: record in: [record name: 'different'].
	time2 := Time now printString.
	session reset.
	newThing := session readOneOf: GlorpRecordWithUpdateTime.
	self assert: (newThing updateSomeOtherThing = time or: [newThing updateSomeOtherThing = time2]).

	record := session readOneOf: GlorpRecordWithUpdateTime.
	"Now verify that if we don't modify the object, we don't write the comment, or put it into the object"
	(Delay forSeconds: 2) wait.
	session modify: record in: [].
	session reset.
	newThing := session readOneOf: GlorpRecordWithUpdateTime.
	self assert: (newThing updateSomeOtherThing = time or: [newThing updateSomeOtherThing = time2]).

]
		ensure: [session rollbackTransaction].! !
!GlorpTestUpdatingTimestampInRecord categoriesFor: #testUpdating!private!tests! !
!GlorpTestUpdatingTimestampInRecord categoriesFor: #testUpdatingComment!private!tests! !
!GlorpTestUpdatingTimestampInRecord categoriesFor: #testUpdatingOtherThing!private!tests! !

GlorpVirtualCollectionBasicTest guid: (GUID fromString: '{BAD643E9-4A57-4D2E-8131-87A543F21851}')!
GlorpVirtualCollectionBasicTest comment: ''!
!GlorpVirtualCollectionBasicTest categoriesForClass!Unclassified! !
!GlorpVirtualCollectionBasicTest methodsFor!

realObjects
	"Get the real objects from a virtual collection without resorting to any of its mechanisms except do:, so we can validate against more complex things."
	^self realObjectsFrom: vc.!

realObjectsFrom: aVirtualCollection
	"Get the real objects from a virtual collection without resorting to any of its mechanisms except do:, so we can validate against more complex things."
	| all |
	all := OrderedCollection new.
	aVirtualCollection do: [:each | all add: each].
	^all.!

setUp
	super setUp.
	session beginTransaction.
	self writePersonRows.
	vc := session virtualCollectionOf: GlorpPerson.!

tearDown
	session rollbackTransaction.
	super tearDown.!

testCollect
	| ids |
	ids := vc collect: [:each | each id].
	
	self assert: ids size = 3.
	ids do: [:each | self assert: each isInteger].!

testCreation
	
	self assert: vc notNil.
	self should: [vc isKindOf: GlorpVirtualCollection].!

testDo

	| all |
	all := OrderedCollection new.
	vc do: [:each |
		self assert: (each isKindOf: GlorpPerson).
		all add: each.
		].
	self assert: all size = 3.
	self assert: all asSet size = 3.
	self assert: (all collect: [:each | each id]) asSortedCollection asArray = #(86 87 88).!

testInject
	| sumofIds |
	sumofIds := vc inject: 0 into: [:sum :each | sum + each id].
	self assert: sumofIds = (86 + 87 + 88).!

testIsEmpty
	| vc2 |
	self deny: vc isEmpty.
	vc2 := vc select: [:each | each id = 98].
	self assert: vc2 isEmpty.!

testReject
	| vc2 |
	vc2 := vc reject: [:each | each id > 87 ].
	self deny: vc isInstantiated.
	self deny: vc2 isInstantiated.
	self assert: vc2 size = 2.
	self deny: vc isInstantiated.
	self assert: vc size = 3.
	self assert: (self realObjectsFrom: vc2) size = 2.!

testSelect
	| vc2 |
	vc2 := vc select: [:each | each id <= 87 ].
	self deny: vc isInstantiated.
	self deny: vc2 isInstantiated.
	self assert: vc2 size = 2.
	self deny: vc isInstantiated.
	self assert: vc size = 3.
	self assert: (self realObjectsFrom: vc2) size = 2.!

writePersonRows
	session writeRow: session system exampleAddressRowForOrdering1.
	session writeRow: session system exampleAddressRowForOrdering2.
	session writeRow: session system exampleAddressRowForOrdering3.
	session writeRow: session system examplePersonRowForOrdering1.
	session writeRow: session system examplePersonRowForOrdering2.
	session writeRow: session system examplePersonRowForOrdering3.! !
!GlorpVirtualCollectionBasicTest categoriesFor: #realObjects!private!support! !
!GlorpVirtualCollectionBasicTest categoriesFor: #realObjectsFrom:!private!support! !
!GlorpVirtualCollectionBasicTest categoriesFor: #setUp!private!support! !
!GlorpVirtualCollectionBasicTest categoriesFor: #tearDown!private!support! !
!GlorpVirtualCollectionBasicTest categoriesFor: #testCollect!private!tests! !
!GlorpVirtualCollectionBasicTest categoriesFor: #testCreation!private!tests! !
!GlorpVirtualCollectionBasicTest categoriesFor: #testDo!private!tests! !
!GlorpVirtualCollectionBasicTest categoriesFor: #testInject!private!tests! !
!GlorpVirtualCollectionBasicTest categoriesFor: #testIsEmpty!private!tests! !
!GlorpVirtualCollectionBasicTest categoriesFor: #testReject!private!tests! !
!GlorpVirtualCollectionBasicTest categoriesFor: #testSelect!private!tests! !
!GlorpVirtualCollectionBasicTest categoriesFor: #writePersonRows!private!support! !

TestCommandPermission guid: (GUID fromString: '{9B2251F3-7499-45BD-A283-EAF7D48CA459}')!
TestCommandPermission comment: ''!
!TestCommandPermission categoriesForClass!Unclassified! !
!TestCommandPermission methodsFor!

testAlsoDeny
	| person |
	[session beginTransaction.
	self writeTestRows.
	session accessor denyCommand: InsertCommand.
	session accessor alsoDenyCommand: DeleteCommand.
	person := session readOneOf: GlorpPerson where: nil.
	self
		should:
			[session
				inUnitOfWorkDo:
					[session register: person.
					session delete: person]]
		raise: GlorpIllegalCommand] ensure: [session rollbackTransaction].!

testDenyReads
	| person address |
	[session beginTransaction.
	self writeTestRows.
	person := session readOneOf: GlorpPerson where: nil.
	address := person address yourSelf.
	session accessor denyReads.
	self should: [session readOneOf: GlorpPerson where: nil] raise: GlorpIllegalCommand.
	session inUnitOfWorkDo: [
		session register: person.
		session delete: address.
		person address: (GlorpAddress new id: 7).
		person name: 'Quigley Quagmire']]
	ensure: [session rollbackTransaction].!

testForbiddenDelete
	| person |
	[session beginTransaction.
	self writeTestRows.
	session accessor denyCommand: DeleteCommand.
	person := session readOneOf: GlorpPerson where: nil.
	self
		should:
			[session
				inUnitOfWorkDo:
					[session register: person.
					session delete: person address.
					person address: nil]]
		raise: GlorpIllegalCommand] ensure: [session rollbackTransaction].!

testForbiddenDeleteAllowsUpdateAndInsert
	| person |
	[session beginTransaction.
	self writeTestRows.
	session accessor denyCommand: DeleteCommand.
	person := session readOneOf: GlorpPerson where: nil.
	session inUnitOfWorkDo: [
		session register: person.
		person address: (GlorpAddress new id: 7).
		person name: 'Quigley Quagmire']]
	ensure: [session rollbackTransaction].!

testInsertOnlyAllowsInsert
	| person |
	[session beginTransaction.
	self writeTestRows.
	session accessor insertOnly.
	person := session readOneOf: GlorpPerson where: nil.
	session
		inUnitOfWorkDo:
			[session register: person.
			session register: (GlorpPerson new id: 4)]]
		ensure: [session rollbackTransaction].!

testInsertOnlyForbidsDelete
	| person |
	[session beginTransaction.
	self writeTestRows.
	session accessor insertOnly.
	person := session readOneOf: GlorpPerson where: nil.
	self
		should:
			[session
				inUnitOfWorkDo:
					[session register: person.
					session delete: person]]
		raise: GlorpIllegalCommand] ensure: [session rollbackTransaction].!

testInsertOnlyForbidsUpdate
	| person |
	[session beginTransaction.
	self writeTestRows.
	session accessor denyWrites.
	person := session readOneOf: GlorpPerson where: nil.
	self
		should:
			[session
				inUnitOfWorkDo:
					[session register: person.
					person name: 'Quigley Quagmire']]
		raise: GlorpIllegalCommand] ensure: [session rollbackTransaction].!

testPermitEverything
	session accessor permitEverything.
	[session beginTransaction.
	self writeTestRows.
	session inUnitOfWorkDo: [ | person |
		person := session readOneOf: GlorpPerson where: nil.
		session delete: person address.
		person address: (GlorpAddress new id: 7).
		person name: 'Quigley Quagmire']]
	ensure: [session rollbackTransaction].!

testPermitNothing
	session accessor permitNothing.
	self should: [session readManyOf: GlorpPerson] raise: GlorpIllegalCommand.
	self
		should:
			[session accessor executeCommand: InsertCommand new]
		raise: GlorpIllegalCommand.
	self
		should:
			[session accessor executeCommand: UpdateCommand new]
		raise: GlorpIllegalCommand.
	self
		should:
			[session accessor executeCommand: DeleteCommand new]
		raise: GlorpIllegalCommand.
	self
		should:
			[session accessor
				executeCommand: SQLStringSelectCommand new]
		raise: GlorpIllegalCommand.!

testReadOnlyForbidsDelete
	| person |
	[session beginTransaction.
	self writeTestRows.
	session accessor denyWrites.
	person := session readOneOf: GlorpPerson where: nil.
	self
		should:
			[session
				inUnitOfWorkDo:
					[session register: person.
					session delete: person]]
		raise: GlorpIllegalCommand] ensure: [session rollbackTransaction].!

testReadOnlyForbidsInsert
	| person |
	[session beginTransaction.
	self writeTestRows.
	session accessor denyWrites.
	person := session readOneOf: GlorpPerson where: nil.
	self
		should:
			[session
				inUnitOfWorkDo:
					[session register: person.
					person address: (GlorpAddress new id: 7)]]
		raise: GlorpIllegalCommand] ensure: [session rollbackTransaction].!

testReadOnlyForbidsUpdate
	| person |
	[session beginTransaction.
	self writeTestRows.
	session accessor denyWrites.
	person := session readOneOf: GlorpPerson where: nil.
	self
		should:
			[session
				inUnitOfWorkDo:
					[session register: person.
					person name: 'Quigley Quagmire']]
		raise: GlorpIllegalCommand] ensure: [session rollbackTransaction].!

writeTestRows
	| addressRow personRow |
	addressRow := session system exampleAddressRow.
	session writeRow: addressRow.
	personRow := session system examplePersonRow1.
	session writeRow: personRow.! !
!TestCommandPermission categoriesFor: #testAlsoDeny!private!tests! !
!TestCommandPermission categoriesFor: #testDenyReads!private!tests! !
!TestCommandPermission categoriesFor: #testForbiddenDelete!private!tests! !
!TestCommandPermission categoriesFor: #testForbiddenDeleteAllowsUpdateAndInsert!private!tests! !
!TestCommandPermission categoriesFor: #testInsertOnlyAllowsInsert!private!tests! !
!TestCommandPermission categoriesFor: #testInsertOnlyForbidsDelete!private!tests! !
!TestCommandPermission categoriesFor: #testInsertOnlyForbidsUpdate!private!tests! !
!TestCommandPermission categoriesFor: #testPermitEverything!private!tests! !
!TestCommandPermission categoriesFor: #testPermitNothing!private!tests! !
!TestCommandPermission categoriesFor: #testReadOnlyForbidsDelete!private!tests! !
!TestCommandPermission categoriesFor: #testReadOnlyForbidsInsert!private!tests! !
!TestCommandPermission categoriesFor: #testReadOnlyForbidsUpdate!private!tests! !
!TestCommandPermission categoriesFor: #writeTestRows!private!support! !

GlorpObjectComparisonSubselectTest guid: (GUID fromString: '{8D2FAE1D-7C81-4B95-8198-C8EC40AC1AA5}')!
GlorpObjectComparisonSubselectTest comment: ''!
!GlorpObjectComparisonSubselectTest categoriesForClass!Unclassified! !
!GlorpObjectComparisonSubselectTest methodsFor!

setUp
	super setUp.
	session system useJoinsForAnySatisfy: false.! !
!GlorpObjectComparisonSubselectTest categoriesFor: #setUp!private!support! !

GlorpConditionalMappingDBTest guid: (GUID fromString: '{D4944715-9A45-4672-8DC6-5477E9FA2219}')!
GlorpConditionalMappingDBTest comment: ''!
!GlorpConditionalMappingDBTest categoriesForClass!Unclassified! !
GlorpDatabaseIndexTest guid: (GUID fromString: '{C7D09134-34C0-45A9-9C42-DC59CE7B5B3E}')!
GlorpDatabaseIndexTest comment: ''!
!GlorpDatabaseIndexTest categoriesForClass!Unclassified! !
!GlorpDatabaseIndexTest methodsFor!

testNameGeneration
	| platform table field index |
	platform := GlorpDatabaseLoginResource defaultPlatform.
	table := DatabaseTable new
						name: 'A_VERY_VERY_VERY_LONG_TABLE_NAME';
						yourself.
	field := table createFieldNamed: 'A_VERY_LONG_FIELD_NAME' type: platform serial.
	index := table addIndexForField: field.
	self assert: index name size <= platform maximumLengthOfTableName.!

testNameGenerationLong
	| platform table field index |
	"SQL Server has very long IDs"
	platform := SQLServerPlatform new.
	table := DatabaseTable new
						name: 'A_VERY_VERY_VERY_LONG_TABLE_NAME';
						yourself.
	field := table createFieldNamed: 'A_VERY_LONG_FIELD_NAME' type: platform serial.
	index := table addIndexForField: field.
	self assert: index name size <= platform maximumLengthOfTableName.
	self assert: index name = (table name, '_', field name, '_IDX').! !
!GlorpDatabaseIndexTest categoriesFor: #testNameGeneration!private!tests! !
!GlorpDatabaseIndexTest categoriesFor: #testNameGenerationLong!private!tests! !

GlorpDatabaseTableTest guid: (GUID fromString: '{52EC2E8E-224D-4E63-8C28-6307640AD1B1}')!
GlorpDatabaseTableTest comment: ''!
!GlorpDatabaseTableTest categoriesForClass!Unclassified! !
!GlorpDatabaseTableTest methodsFor!

testFKUniqueNames

	| platform contactTable linkTable companyId personId |
	platform := GlorpDatabaseLoginResource defaultPlatform.
	contactTable := DatabaseTable new
						name: 'CONTACT';
						yourself.
	contactTable createFieldNamed: 'ID' type: platform serial.

	linkTable := DatabaseTable new
						name: 'COMPANY_PERSON_LINK';
						yourself.
	companyId := linkTable createFieldNamed: 'COMPANY_ID' type: platform int4.
	personId := linkTable createFieldNamed: 'PERSON_ID' type: platform int4.
	linkTable
		addForeignKeyFrom: companyId to: (contactTable fieldNamed: 'ID');
		addForeignKeyFrom: personId to: (contactTable fieldNamed: 'ID').
	self assert: (linkTable foreignKeyConstraints collect: [:ea | ea name asSymbol]) asSet size = linkTable foreignKeyConstraints size.!

testIndexes

	| platform contactTable idField name1Field name2Field |
	platform := GlorpDatabaseLoginResource defaultPlatform.
	contactTable := DatabaseTable new
						name: 'CONTACT';
						yourself.
	idField := (contactTable createFieldNamed: 'ID' type: platform serial) beIndexed.
	self assert: contactTable indexes size = 1.
	self assert: (contactTable hasIndexForField: idField).
	name1Field := contactTable createFieldNamed: 'NAME1' type: platform varchar.
	name2Field := contactTable createFieldNamed: 'NAME2' type: platform varchar.
	self deny: (contactTable hasIndexForField: name1Field).
	contactTable addIndexForFields: (Array with: name1Field with: name2Field).
	self assert: contactTable indexes size = 2.
	self assert: (contactTable hasIndexForField: idField).
	self assert: (contactTable hasIndexForField: name1Field).
	self assert: (contactTable hasIndexForField: name2Field).! !
!GlorpDatabaseTableTest categoriesFor: #testFKUniqueNames!private!tests! !
!GlorpDatabaseTableTest categoriesFor: #testIndexes!private!tests! !

GlorpDirectMappingDBTest guid: (GUID fromString: '{A5EC6245-B7CA-41E5-8FB2-DD149143969E}')!
GlorpDirectMappingDBTest comment: ''!
!GlorpDirectMappingDBTest categoriesForClass!Unclassified! !
!GlorpDirectMappingDBTest methodsFor!

readPerson
	| results query |
	query := Query
		returningManyOf: GlorpPerson
		where: [:pers | pers id = personId].
	results := query executeIn: session.
	self assert: results size = 1.
	person := results first.!

testMappingToSubselect

	| personDescriptor people |
	[session beginTransaction.
	self writeAddress.
	self writeHomelessPerson.
	self writePersonWithEmailAddresses.
	personDescriptor := system descriptorFor: GlorpPerson.
	(personDescriptor newMapping: DirectMapping)
		beReadOnly;
		type: Boolean;
		from: #hasEmail 
		to: [:each | each emailAddresses notEmpty].
	people := session read: GlorpPerson orderBy: #id.
	self assert: people first hasEmail.
	self deny: people last hasEmail.
	self assert: people first emailAddresses notEmpty.
	self assert: people last emailAddresses isEmpty.
	 ]
		ensure: [session rollbackTransaction].!

testReadWithDirectFieldReference

	| peopleWithAddresses peopleWithoutAddresses addressIdField |
	[session beginTransaction.
	self writeAddress.
	self writeHomelessPerson.
	self writeHomefulPerson.
	addressIdField := (session system tableNamed: 'PERSON') fieldNamed: 'ADDRESS_ID'.
	peopleWithAddresses := session readManyOf: GlorpPerson where: [:each | (each getField: addressIdField) notNIL].
	peopleWithoutAddresses := session readManyOf: GlorpPerson where: [:each | (each getField: addressIdField) isNIL].
	self assert: peopleWithAddresses size = 1.
	self assert: peopleWithoutAddresses size = 1.
	self assert: peopleWithAddresses first id = 3.
	self assert: peopleWithoutAddresses first id = 4.
	 ]
		ensure: [session rollbackTransaction].!

testReadWithPseudoVariableMapping

	| peopleWithAddresses peopleWithoutAddresses |
	[session beginTransaction.
	self writeAddress.
	self writeHomelessPerson.
	self writeHomefulPerson.
	peopleWithAddresses := session readManyOf: GlorpPerson where: [:each | each addressId notNIL].
	peopleWithoutAddresses := session readManyOf: GlorpPerson where: [:each | each addressId isNIL].
	self assert: peopleWithAddresses size = 1.
	self assert: peopleWithoutAddresses size = 1.
	self assert: peopleWithAddresses first id = 3.
	self assert: peopleWithoutAddresses first id = 4.]
		ensure: [session rollbackTransaction].!

testUpdate
	|newPerson |
	self inTransactionDo: [
		session beginUnitOfWork.
		newPerson := GlorpPerson example1.
		personId := newPerson id.
		session register: newPerson.
		session commitUnitOfWork.
		session reset.
		self readPerson.
		session inUnitOfWorkDo: [
			session register: person.
			person name: 'something else'].
		session reset.
		self readPerson.
		self assert: person id = newPerson id.
		self assert: person name = 'something else'].!

testUpdateWithDefaultValue
	"Check that default values don't revert if we update the object in some other way.  (This test does not in fact error in Glorp 7.7 - 69 and earlier, so needs revision.)"

	self inTransactionDo:
		[| thing |
		session transact: [thing := DefaultableThing new id: 1].
		session reset.
		thing := session readOneOf: DefaultableThing.
		self assert: thing integer = 4.
		session modify: thing in: [thing integer: 7].
		session reset.
		thing := session readOneOf: DefaultableThing.
		session modify: thing in: [thing boolean: true].
		self assert: thing integer = 7].!

testWriteWithDefaultValue
	| rawDBResult field converter dbValue raw |
	self
		inTransactionDo:
			[| thing |
			session transact: [thing := DefaultableThing new id: 1].
			session reset.
			thing := session readOneOf: DefaultableThing.
			self assert: thing boolean = false.
			field := (system tableNamed: 'DEFAULTABLE_THING') fieldNamed: 'MY_BOOL'.
			converter := field converterForStType: Boolean.
			dbValue := converter convert: false toDatabaseRepresentationAs: field type.
			rawDBResult := session accessor executeSQLString: 'select MY_BOOL from DEFAULTABLE_THING'.	"The conversion back might get done by us, or might get done by the EXDI layer, Accomodate either possibility as long as it comes out to something equivalent to what we thought it ought to be."
			raw := rawDBResult first first.
			self
				assert: (raw = dbValue or: [raw = false or: [(converter convert: raw fromDatabaseRepresentationAs: Boolean) not]]).
			self assert: thing integer = 4]!

writeAddress
	| addressRow |
	addressRow := session system exampleAddressRow.
	session writeRow: addressRow.!

writeHomefulPerson
	| personRow |
	personRow := session system examplePersonRow1.
	session writeRow: personRow.
	personId := personRow atFieldNamed: 'ID'.!

writeHomelessPerson
	| personRow |
	personRow := session system examplePersonRow2.
	session writeRow: personRow.
	personId := personRow atFieldNamed: 'ID'.!

writePersonWithEmailAddresses
	| personRow emailAddress1Row emailAddress2Row |
	personRow := session system examplePersonRow1.
	personId := personRow atFieldNamed: 'ID'.
	session writeRow: personRow.
	emailAddress1Row := session system exampleEmailAddressRow1.
	emailAddress2Row := session system exampleEmailAddressRow2.
	emailAddress1Row at: (emailAddress1Row table fieldNamed: 'ID').
	emailAddress2Row at: (emailAddress2Row table fieldNamed: 'ID').
	session writeRow: emailAddress1Row.
	session writeRow: emailAddress2Row.! !
!GlorpDirectMappingDBTest categoriesFor: #readPerson!private!tests! !
!GlorpDirectMappingDBTest categoriesFor: #testMappingToSubselect!private!tests! !
!GlorpDirectMappingDBTest categoriesFor: #testReadWithDirectFieldReference!private!tests! !
!GlorpDirectMappingDBTest categoriesFor: #testReadWithPseudoVariableMapping!private!tests! !
!GlorpDirectMappingDBTest categoriesFor: #testUpdate!private!tests! !
!GlorpDirectMappingDBTest categoriesFor: #testUpdateWithDefaultValue!private!support! !
!GlorpDirectMappingDBTest categoriesFor: #testWriteWithDefaultValue!public!support! !
!GlorpDirectMappingDBTest categoriesFor: #writeAddress!private!support! !
!GlorpDirectMappingDBTest categoriesFor: #writeHomefulPerson!private!support! !
!GlorpDirectMappingDBTest categoriesFor: #writeHomelessPerson!private!support! !
!GlorpDirectMappingDBTest categoriesFor: #writePersonWithEmailAddresses!private!support! !

GlorpEmbeddedMappingDBTest guid: (GUID fromString: '{36D42B5B-0321-4903-B7E7-C9EB6CC22CB2}')!
GlorpEmbeddedMappingDBTest comment: 'This exercises the EmbeddedValueOneToOneMapping.'!
!GlorpEmbeddedMappingDBTest categoriesForClass!Unclassified! !
!GlorpEmbeddedMappingDBTest methodsFor!

setUp
	super setUp.
	session beginTransaction.
	self writeAgents.
	session reset.!

tearDown
	session rollbackTransaction.
	super tearDown.!

testModifyAgents
	| agents |
	agents := session read: GlorpTravelAgent orderBy: #id.
	session modify: agents in: [
		agents first name: 'Something Else'.
		(agents at: 2) name: 'something else again'].
	session reset.
	agents := session read: GlorpTravelAgent orderBy: #id.
	self assert: agents size = 3.
	self assert: agents first agency yourSelf = (agents at: 2) agency yourSelf.
	self deny: agents first agency yourSelf == (agents at: 2) agency yourSelf.
	self deny: agents first agency yourSelf = agents last agency yourSelf.
	self assert: agents first name = 'Something Else'.
	self assert: (agents at: 2) name = 'something else again'.!

testModifyAgentsReadOnlyAgency
	"Test that if the agency mappings are all read-only, that we don't cause an error by trying to generate entries in the row map for its primary keys."

	(session system descriptorFor: GlorpTravelAgency) mappings do: [:each | each beReadOnly].
	[self testModifyAgents] ensure: [
		(session system descriptorFor: GlorpTravelAgency) mappings do: [:each | each readOnly: false]].!

testReadAgents
	| agents |
	agents := session read: GlorpTravelAgent orderBy: #id.
	self assert: agents size = 3.
	self assert: agents first agency yourSelf = (agents at: 2) agency yourSelf.
	self deny: agents first agency yourSelf == (agents at: 2) agency yourSelf.
	self deny: agents first agency yourSelf = agents last agency yourSelf.!

writeAgents
	| agent1 agent2 agent3 |
	agent1 := GlorpTravelAgent new id: 1; name: 'Agent One'.
	agent1 agency: (GlorpTravelAgency new name: 'Agency One').
	agent2 := GlorpTravelAgent new id: 2; name: 'Agent Two'.
	agent2 agency: agent1 agency.
	agent3 := GlorpTravelAgent new id: 3; name: 'Agent Three'.
	agent3 agency: (GlorpTravelAgency new name: 'Agency Two').
	session modify: (Array with: agent1 with: agent2 with: agent3) in: [].! !
!GlorpEmbeddedMappingDBTest categoriesFor: #setUp!private!support! !
!GlorpEmbeddedMappingDBTest categoriesFor: #tearDown!private!support! !
!GlorpEmbeddedMappingDBTest categoriesFor: #testModifyAgents!private!tests! !
!GlorpEmbeddedMappingDBTest categoriesFor: #testModifyAgentsReadOnlyAgency!private!tests! !
!GlorpEmbeddedMappingDBTest categoriesFor: #testReadAgents!private!tests! !
!GlorpEmbeddedMappingDBTest categoriesFor: #writeAgents!private!support! !

GlorpManyToManyDBTest guid: (GUID fromString: '{4999E8EE-9104-43F5-BD00-5CE24677E817}')!
GlorpManyToManyDBTest comment: ''!
!GlorpManyToManyDBTest categoriesForClass!Unclassified! !
!GlorpManyToManyDBTest methodsFor!

checkAccounts

	| sorted numberOfAccounts |
	numberOfAccounts := (accountId1 isNil ifTrue: [0] ifFalse: [1]) + (accountId2 isNil ifTrue: [0] ifFalse: [1]) + (accountId3 isNil ifTrue: [0] ifFalse: [1]).
	self assert: customer accounts size = numberOfAccounts.
	sorted := customer accounts asSortedCollection: [:a :b | a id <= b id].
	accountId1 isNil ifFalse: [self assert: sorted first id = accountId1].
	accountId2 isNil ifFalse: [self assert: (sorted at: 2) id = accountId2].
	accountId3 isNil ifFalse: [self assert: sorted last id = accountId3].
	self assert: (customer accounts collect: [:each | each id]) asSet size = customer accounts size.!

checkNumberOfAccounts: anInteger
	| accountRows |
	accountRows := session accessor
		executeSQLString: 'SELECT * FROM BANK_ACCT'.
	self assert: accountRows size = anInteger.!

checkNumberOfLinkRows: anInteger
	| linkRows |
	linkRows := session accessor
		executeSQLString: 'SELECT * FROM CUSTOMER_ACCT_LINK'.
	self assert: linkRows size = anInteger.!

inUnitOfWorkDo: aBlock initializeWith: initBlock
	"Set up a bunch of the normal data, read the objects, then run the block in a unit of work"
	initBlock value.
	session beginUnitOfWork.
	self readCustomer.
	aBlock value.
	session commitUnitOfWork.
	session reset.!

readCustomer
	| results query |
	query := Query
		returningManyOf: GlorpCustomer
		where: [:cust | cust id = customerId].
	results := query executeIn: session.
	self assert: results size = 1.
	customer := results first.!

readCustomer: aCustomerId
	| results query |
	query := Query
		returningManyOf: GlorpCustomer
		where: [:cust | cust id = aCustomerId].
	results := query executeIn: session.
	self assert: results size = 1.
	^results first.!

session: aDatabaseSession
	session := aDatabaseSession.!

testReadAndDeleteNodes
	"Make sure we don't delete out of order and that links disappear."
	| nodes links |
	self inTransactionDo: [
		self writeNodeWithChildren.
		session reset.
		session transact: [
			nodes := session read: GlorpTreeNode.
			nodes do: [:each | session delete: each]].
		links := session accessor executeSQLString: 'SELECT * FROM TREE_NODE_LINK'.
		self assert: links size = 0].!

testReadCustomerAndAddAccount
	self
		inTransactionDo:
			[
			self 
				inUnitOfWorkDo: [customer addAccount: (GlorpBankAccount new id: 77473)]
				initializeWith: [self writeCustomerWithAccounts].
			self readCustomer.
			accountId3 := 77473.
			self checkAccounts.
			self checkNumberOfLinkRows: 4].!

testReadCustomerAndDeleteAccount
	self
		inTransactionDo:[
			[self 
				inUnitOfWorkDo: [ | account| 
					account := customer accounts detect: [:each | each id = 9874].
					session delete: account]
				initializeWith: [self writeCustomerWithAccounts]]
				on: Dialect error
				do: [:ex | Transcript show: 'integrity violation'; cr.^self].
			self readCustomer.
			accountId2 := nil.
			self checkAccounts.
			self checkNumberOfLinkRows: 2.
			self checkNumberOfAccounts: 2].!

testReadCustomerAndDeleteAccountProperly
	"Do both the delete and the patching up of relationships"
	self
		inTransactionDo:
			[
			self 
				inUnitOfWorkDo: [ | account| 
					account := customer accounts detect: [:each | each id = 9874].
					session delete: account.
					customer removeAccount: account]
				initializeWith: [self writeCustomerWithAccounts].
			self readCustomer.
			accountId2 := nil.
			self checkAccounts.
			self checkNumberOfLinkRows: 2.
			self checkNumberOfAccounts: 2].!

testReadCustomerAndRemoveAccount
	self
		inTransactionDo:
			[self
				inUnitOfWorkDo:
					[| account |
					account := customer accounts detect: [:each | each id = 9874].
					customer accounts remove: account]
				initializeWith: [self writeCustomerWithAccounts].
			self readCustomer.
			accountId2 := nil.
			self checkAccounts.
			self checkNumberOfLinkRows: 2].!

testReadCustomerAndReplaceAccounts
	self
		inTransactionDo:
			[self
				inUnitOfWorkDo:
					[| account |
					account := GlorpBankAccount new id: 99999.
					customer accounts do: [:each | each accountHolders remove: customer].
					customer accounts: (Array with: account)]
				initializeWith: [self writeCustomerWithAccounts].
			self readCustomer.
			accountId1 := 99999.
			accountId2 := nil.
			self checkAccounts.
			self checkNumberOfLinkRows: 2.
			self checkNumberOfAccounts: 4].!

testReadCustomerAndReplaceAccountsWithoutInstantiatingHolders
	"This works, but only fortuitously. If the accounts haven't been read into memory, we don't have to remove their object-level references to the account holder, because changing one side of the relationship in memory is enough to cause the link rows to be deleted"
	self
		inTransactionDo:
			[self
				inUnitOfWorkDo:
					[| account |
					account := GlorpBankAccount new id: 99999.
					customer accounts: (Array with: account)]
				initializeWith: [self writeCustomerWithAccounts].
			self readCustomer.
			accountId1 := 99999.
			accountId2 := nil.
			self checkAccounts.
			self checkNumberOfLinkRows: 2.
			self checkNumberOfAccounts: 4].!

testReadCustomerAndReplaceAccountsWithRemoval
	self
		inTransactionDo:
			[self
				inUnitOfWorkDo:
					[| account |
					account := customer accounts detect: [:each | each id = 6].
					customer accounts: (Array with: account)]
				initializeWith: [self writeCustomerWithAccounts].
			self readCustomer.
			accountId2 := nil.
			self checkAccounts.
			self checkNumberOfLinkRows: 2].!

testReadCustomerAndReplaceInstantiatedAccountsWithEmpty
	self
		inTransactionDo:
			[self
				inUnitOfWorkDo:
					[customer accounts yourSelf. 
					customer accounts: #()]
				initializeWith: [self writeCustomerWithAccounts].
			self readCustomer.
			accountId1 := nil.
			accountId2 := nil.
			self checkAccounts.
			self checkNumberOfLinkRows: 1.
			self checkNumberOfAccounts: 3].!

testReadCustomerAndReplaceUninstantiatedAccountsWithEmpty
	self
		inTransactionDo:
			[self
				inUnitOfWorkDo:
					[customer accounts: #()]
				initializeWith: [self writeCustomerWithAccounts].
			self readCustomer.
			accountId1 := nil.
			accountId2 := nil.
			self checkAccounts.
			self checkNumberOfLinkRows: 1.
			self checkNumberOfAccounts: 3].!

testReadCustomerOrderByLinkTableField

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session readManyOf: GlorpCustomer.
			customers do: [:each | | sortedAccounts |
				sortedAccounts := each accounts asSortedCollection: [:a :b | a id <= b id].
				self assert: each accountsSortedById asArray = sortedAccounts asArray]].!

testReadCustomerOrderByLinkTableFieldDescending

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session readManyOf: GlorpCustomer.
			customers do: [:each | | sortedAccounts |
				sortedAccounts := each accounts asSortedCollection: [:a :b | a id <= b id].
				self assert: each accountsSortedByIdDescending asArray = sortedAccounts asArray reverse]].!

testReadCustomerOrderingByCountSubselect
	"DB2 (as of 9.8) does not support an ORDER BY clause with correlated column references.	The ORDER BY sub-select here refers back to the selected column, so we skip this for DB2."

	| customers |
	session platform isDB2Platform ifTrue: [^self].
	self
		inTransactionDo:
			[| sorted |
			self writeCustomerWithAccounts.
			customers := session
				read: GlorpCustomer
				orderBy: [:each | each accounts sqlCount].
			sorted := (customers asSortedCollection: [:a :b | a accounts size <= b accounts size]) asArray.
			self assert: customers = sorted.
			customers := session
				read: GlorpCustomer
				orderBy: [:each | each accounts sqlCount descending].
			self assert: customers reverse = sorted].!

testReadCustomerWithAverageSubselect

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				read: GlorpCustomer
				where:
					[:each | 
					(each average: [:eachCust | eachCust accounts id]) = ((9874 + 6) / 2)].
		self assert: customers size = 1.
		self assert: customers first id = 27.
		customers := session
				read: GlorpCustomer
				where:
					[:each | 
					(each accounts id sqlAverage) = 22].
		self assert: customers size = 1.
		self assert: customers first id = 28.].!

testReadCustomerWithCountSubselect

	| customersWithOneAccount customersWithTwoAccounts customersWithLessThanFiveAccounts |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customersWithOneAccount := session
				read: GlorpCustomer
				where:
					[:each | 
					(each getConstant: 1) = (each count: [:eachCust | eachCust accounts])].
			customersWithTwoAccounts := session
				read: GlorpCustomer
				where:
					[:each | 
					(each count: [:eachCust | eachCust accounts]) = 2].
			"fully general syntax. doesn't require any helper methods, just the existence of the function"
			customersWithLessThanFiveAccounts := session
				read: GlorpCustomer
				where: [:each | (each aggregate: each accounts as: #countStar) < 5].
		self assert: customersWithOneAccount size = 1.
		self assert: customersWithOneAccount first id = 28.
		self assert: customersWithTwoAccounts size = 1.
		self assert: customersWithTwoAccounts first id = 27.
		self assert: customersWithLessThanFiveAccounts size = 2].!

testReadCustomerWithCountSubselectAlternateSyntax

	| customersWithOneAccount customersWithTwoAccounts |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customersWithOneAccount := session
				read: GlorpCustomer
				where:
					[:each | 
					(each getConstant: 1) = (each accounts sqlCount)].
			customersWithTwoAccounts := session
				read: GlorpCustomer
				where:
					[:each | 
					each accounts sqlCount = 2].
		self assert: customersWithOneAccount size = 1.
		self assert: customersWithOneAccount first id = 28.
		self assert: customersWithTwoAccounts size = 1.
		self assert: customersWithTwoAccounts first id = 27].!

testReadCustomerWithEqualityComparisonToAccountsUsingInClause
	"Test doing a primary key rewrite of the where clause in a subselect, to the result of another subselect"

	| customers accounts |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			accounts := session read: GlorpBankAccount where: [:each | each id = 22].
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					eachCustomer accounts
						anySatisfyExists: [:eachAccount | eachAccount in: accounts]].
			self assert: customers size = 1.
			customers do: [:each | each accounts do: [:eachAcct | self assert: eachAcct id = 22]]].!

testReadCustomerWithEqualitySubSelectToAccountsUsingInClause
	"Test doing a primary key rewrite of the where clause in a subselect, to the result of another subselect"

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					eachCustomer accounts
						anySatisfyExists: [:eachAccount | eachAccount in: (Query read: GlorpBankAccount where: [:accts2 | accts2 id <> 12])]].
			self assert: customers size = 2.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					eachCustomer accounts
						anySatisfyExists: [:eachAccount | 
							eachAccount in: (Query read: GlorpBankAccount where: [:accts2 | accts2 id = 22])]].
			self assert: customers size = 1.
			customers do: [:each | each accounts do: [:eachAcct | self assert: eachAcct id = 22]]].!

testReadCustomerWithFilteredSubSelectToAccounts1

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					(eachCustomer accounts select: [:eachAccount | eachAccount accountNumber bankCode = '2']) sqlCount > 0].
			self assert: customers size = 2].!

testReadCustomerWithFilteredSubSelectToAccounts2

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					(eachCustomer accounts select: [:eachAccount | eachAccount accountNumber bankCode = '2']) sqlCount > 1].
			self assert: customers size = 0].!

testReadCustomerWithFilteredSubSelectToAccounts3

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					(eachCustomer accounts select: [:eachAccount | eachAccount id > 5 ]) sqlCount <= 1].
			self assert: customers size = 1].!

testReadCustomerWithFilteredSubSelectToAccountsAndAggregate
	"Test with a filtered read to accounts, where we've used an aggregate function to find the customer with the maximum primary key for the given id"

	| query |
	((session system descriptorFor: GlorpCustomer) mappingForAttributeNamed: #accounts) useFilteredRead.
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			query := Query readOneOf: GlorpCustomer where: [:each |
				| q |
				q := Query read: GlorpCustomer where: [:eachPundle |
					eachPundle name = 'aCustomer'].
				q retrieve: [:x | x id max].
				each id = q].
			customer := session execute: query.
			self assert: customer name = 'aCustomer'.
			self assert: (customer accounts collect: [:each | each id]) asSortedCollection asArray = #(6 9874)].!

testReadCustomerWithIsEmptyAndFilteredSubselectsToAccounts

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | (eachCustomer accounts select: [:each | each id > 30]) isEmpty].
			self assert: customers size = 1.
			self assert: customers first id = 28].!

testReadCustomerWithIsEmptySubselectToAccounts1

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | eachCustomer accounts isEmpty].
			self assert: customers size = 0].!

testReadCustomerWithJoinToAccounts

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					eachCustomer accounts
						anySatisfyJoin: [:eachAccount | eachAccount accountNumber bankCode = '2']].
			self assert: customers size = 2].!

testReadCustomerWithJoinToAccounts2

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					eachCustomer accounts
						anySatisfyJoin: [:eachAccount | eachAccount accountNumber branchNumber = 3]].
			self assert: customers size = 1].!

testReadCustomerWithMaxSubselect

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				read: GlorpCustomer
				where:
					[:each | 
					(each max: [:eachCust | eachCust accounts id]) = 9874].
		self assert: customers size = 1.
		self assert: customers first id = 27.
		customers := session
				read: GlorpCustomer
				where:
					[:each | 
					(each accounts id sqlMax) = 22].
		self assert: customers size = 1.
		self assert: customers first id = 28.].!

testReadCustomerWithMinSubselect

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				read: GlorpCustomer
				where:
					[:each | 
					(each min: [:eachCust | eachCust accounts id]) = 6].
		self assert: customers size = 1.
		self assert: customers first id = 27.
		customers := session
				read: GlorpCustomer
				where:
					[:each | 
					(each accounts id sqlMin) = 22].
		self assert: customers size = 1.
		self assert: customers first id = 28.].!

testReadCustomerWithNotEmptyAndFilteredSubselectsToAccounts

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | (eachCustomer accounts select: [:each | each id > 30]) notEmpty].
			self assert: customers size = 1.
			self assert: customers first id = 27].!

testReadCustomerWithSimpleJoinToAccounts

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					eachCustomer accounts
						anySatisfyJoin: [:eachAccount | eachAccount id <> 12]].
			self assert: customers size = 2].!

testReadCustomerWithSimpleSubSelectToAccounts

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					eachCustomer accounts
						anySatisfyExists: [:eachAccount | eachAccount id <> 12]].
			self assert: customers size = 2].!

testReadCustomerWithSubSelectToAccounts

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					eachCustomer accounts
						anySatisfyExists: [:eachAccount | eachAccount accountNumber bankCode = '2']].
			self assert: customers size = 2].!

testReadCustomerWithSubSelectToAccounts2

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					eachCustomer accounts
						anySatisfyExists: [:eachAccount | eachAccount accountNumber branchNumber = 3]].
			self assert: customers size = 1].!

testReadCustomerWithSubSelectToAccountsUsingInClause
	"Test doing an IN clause with the result of another subselect"

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					eachCustomer accounts
						anySatisfyExists: [:eachAccount | 
							| q |
							q := Query read: GlorpBankAccount where: [:accts2 | accts2 id <> 12].
							q retrieve: #id.
							eachAccount id in: q]].
			self assert: customers size = 2.
			customers := session
				readManyOf: GlorpCustomer
				where:
					[:eachCustomer | 
					eachCustomer accounts
						anySatisfyExists: [:eachAccount | 
							| q |
							q := Query read: GlorpBankAccount where: [:accts2 | accts2 id = 22].
							q retrieve: #id.
							eachAccount id in: q]].
			self assert: customers size = 1.
			customers do: [:each | each accounts do: [:eachAcct | self assert: eachAcct id = 22]].
].!

testReadCustomerWithSumSubselect

	| customers |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			customers := session
				read: GlorpCustomer
				where:
					[:each | 
					(each sum: [:eachCust | eachCust accounts accountNumber branchNumber]) < 6].
		self assert: customers size = 1.
		self assert: customers first id = 27.
		customers := session
				read: GlorpCustomer
				where:
					[:each | 
					(each accounts accountNumber branchNumber sqlSum) > 6].
		self assert: customers size = 1.
		self assert: customers first id = 28.].!

testReadNode
	| allNodes |
	self inTransactionDo: [
		self writeNodeWithChildren.
		session reset.
		allNodes := session readManyOf: GlorpTreeNode orderBy: #id.
		self assert: (allNodes collect: [:each | each id]) asArray = #( 1 2 3).
		self assert: allNodes first children size = 2.
		self assert: (allNodes first children collect: [:each | each id]) asSortedCollection asArray = #( 2 3)].!

testReadNodeAndDeleteChild
	| node1 node3 links nodes |
	self inTransactionDo: [
		self writeNodeWithChildren.
		session reset.
		node1 := session readOneOf: GlorpTreeNode where: [:each | each id = 1].
		node3 := (node1 children asSortedCollection: [:a :b | a id <= b id]) last.
		session transact: [
			session register: node1.
			session delete: node3.
			node1 children remove: node3].
		links := session accessor executeSQLString: 'SELECT * FROM TREE_NODE_LINK'.
		self assert: links size = 1.
		self assert: links first first = 1. 
		self assert: links first last = 2.
		nodes := session accessor executeSQLString: 'SELECT * FROM TREE_NODE'.
		self deny: (nodes anySatisfy: [:each | each first = node3 id]).
		self assert: nodes size = 2
		].!

testReadNodeAndDeleteChildWithSaveAndContinue
	"This exercises two things. First, there's a bug in save and continue with deleted objects resurrecting. Second, make sure that if we delete both parent and child, the link goes away"
	| node1 node3 links nodes node2 |
	self inTransactionDo: [
		self writeNodeWithChildren.
		session reset.
		node1 := session readOneOf: GlorpTreeNode where: [:each | each id = 1].
		node2 := (node1 children asSortedCollection: [:a :b | a id <= b id]) first.
		node3 := (node1 children asSortedCollection: [:a :b | a id <= b id]) last.
		session beginUnitOfWork.
			[session register: node1.
			session delete: node3.
			node1 children remove: node3] ensure: [session saveAndContinue].
		links := session accessor executeSQLString: 'SELECT * FROM TREE_NODE_LINK'.
		self assert: links size = 1.
		self assert: links first first = 1. 
		self assert: links first last = 2.
		nodes := session accessor executeSQLString: 'SELECT * FROM TREE_NODE'.
		self deny: (nodes anySatisfy: [:each | each first = node3 id]).
		self assert: nodes size = 2.

			[session register: node1.
			session delete: node2.
			session delete: node1] ensure: [session saveAndContinue].
		nodes := session accessor executeSQLString: 'SELECT * FROM TREE_NODE'.
		self assert: nodes isEmpty.
		links := session accessor executeSQLString: 'SELECT * FROM TREE_NODE_LINK'.
		self assert: links isEmpty.
		].!

testReadNodeAndDeleteParent
	| node1 links |
	self inTransactionDo: [
		self writeNodeWithChildren.
		session reset.
		session transact: [
		node1 := session readOneOf: GlorpTreeNode where: [:each | each id = 1].
		session delete: node1.
		node1 children: #()].
		links := session accessor executeSQLString: 'SELECT * FROM TREE_NODE_LINK'.
		self assert: links size = 0].!

testWriteCustomersAndAccounts
	| newCustomer1 newCustomer2 newCustomer3 joint withBaby1 withBaby2 hisChecking herChecking |
	self
		inTransactionDo:
			[
			session beginUnitOfWork.
			newCustomer1 := GlorpCustomer exampleD1.
			newCustomer2 := GlorpCustomer exampleD2.
			newCustomer3 := GlorpCustomer exampleD3.
			hisChecking := GlorpBankAccount new id: 301.
			herChecking := GlorpBankAccount new id: 302.
			joint := GlorpBankAccount new id: 303.
			withBaby1 := GlorpBankAccount new id: 304.
			withBaby2 := GlorpBankAccount new id: 305.
			newCustomer1 id: 201; accounts: (OrderedCollection with: hisChecking with: joint with: withBaby1).
			newCustomer2 id: 202; accounts: (OrderedCollection with: herChecking with: joint with: withBaby2).
			newCustomer3 id: 203; accounts: (OrderedCollection with: withBaby1 with: withBaby2).
			session register: newCustomer1;
				register: newCustomer2;
				register: newCustomer3.
			session commitUnitOfWork.
			session reset.
			newCustomer1 := self readCustomer: 201.
			self assert: newCustomer1 accounts size = 3.
			newCustomer2 := self readCustomer: 202.
			self assert: newCustomer2 accounts size = 3.
			newCustomer3 := self readCustomer: 203.
			self assert: newCustomer3 accounts size = 2.
			self checkNumberOfAccounts: 5.
			self checkNumberOfLinkRows: 8].!

testWriteCustomersAndAccountsAndDelete
	| newCustomer1 newCustomer2 newCustomer3 joint withBaby1 withBaby2 hisChecking herChecking |
	self
		inTransactionDo:
			[
			session beginUnitOfWork.
			newCustomer1 := GlorpCustomer exampleD1.
			newCustomer2 := GlorpCustomer exampleD2.
			newCustomer3 := GlorpCustomer exampleD3.
			hisChecking := GlorpBankAccount new id: 301.
			herChecking := GlorpBankAccount new id: 302.
			joint := GlorpBankAccount new id: 303.
			withBaby1 := GlorpBankAccount new id: 304.
			withBaby2 := GlorpBankAccount new id: 305.
			newCustomer1 id: 201; accounts: (OrderedCollection with: hisChecking with: joint with: withBaby1).
			newCustomer2 id: 202; accounts: (OrderedCollection with: herChecking with: joint with: withBaby2).
			newCustomer3 id: 203; accounts: (OrderedCollection with: withBaby1 with: withBaby2).
			session register: newCustomer1;
				register: newCustomer2;
				register: newCustomer3.
			session commitUnitOfWork.
			session reset.
			newCustomer1 := self readCustomer: 201.
			self assert: newCustomer1 accounts size = 3.
			newCustomer2 := self readCustomer: 202.
			self assert: newCustomer2 accounts size = 3.
			newCustomer3 := self readCustomer: 203.
			self assert: newCustomer3 accounts size = 2.
			self checkNumberOfAccounts: 5.
			self checkNumberOfLinkRows: 8.
			session reset.	
			session transact: [ | cust acct |		
				cust := self readCustomer: 201.
				acct := cust accounts detect: [:ea| ea id = 301] ifNone: [nil].
				acct notNil ifTrue: [session delete: acct].
				session delete: cust].
			self checkNumberOfAccounts: 4.
			self checkNumberOfLinkRows: 5].!

testWriteCustomerWithAccounts
	| newCustomer |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			session beginUnitOfWork.
			newCustomer := GlorpCustomer example1.
			newCustomer id: 12.
			customerId := 12.
			newCustomer accounts: (OrderedCollection with: (GlorpBankAccount new id: 223)).
			session register: newCustomer.
			session commitUnitOfWork.
			session reset.
			self readCustomer.
			accountId1 := 223.
			accountId2 := nil.
			self checkAccounts.
			self checkNumberOfAccounts: 4.
			self checkNumberOfLinkRows: 4].!

testWriteCustomerWithNoAccounts
	| newCustomer |
	self
		inTransactionDo:
			[session beginUnitOfWork.
			newCustomer := GlorpCustomer example1.
			newCustomer id: 12.
			customerId := 12.
			session register: newCustomer.
			session commitUnitOfWork.
			session reset.
			self readCustomer.
			accountId1 := nil.
			accountId2 := nil.
			self checkAccounts.
			self checkNumberOfAccounts: 0.
			self checkNumberOfLinkRows: 0].!

testWriteCustomerWithTwoAccounts
	| newCustomer |
	self
		inTransactionDo:
			[self writeCustomerWithAccounts.
			session beginUnitOfWork.
			newCustomer := GlorpCustomer example1.
			newCustomer id: 12.
			customerId := 12.
			newCustomer accounts: (OrderedCollection with: (GlorpBankAccount new id: 223)).
			newCustomer accounts add: (GlorpBankAccount new id: 224).
			session register: newCustomer.
			session commitUnitOfWork.
			session reset.
			self readCustomer.
			accountId1 := 223.
			accountId2 := 224.
			self checkAccounts.
			self checkNumberOfAccounts: 5.
			self checkNumberOfLinkRows: 5].!

treeNodeClass
	treeNodeClass isNil ifTrue: [treeNodeClass := GlorpTreeNode].
	^treeNodeClass.!

treeNodeClass: aClass
	treeNodeClass := aClass.!

writeCustomerWithAccounts
	| customerRow accountRow1 accountRow2 linkRow1 linkRow2 customerRow2 accountRow3 linkRow3 |

	customerRow := session system exampleCustomerRow1.
	customerId := customerRow atFieldNamed: 'ID'.
	customerRow2 := session system exampleCustomerRow2.
	accountRow1 := session system exampleAccountRow1. 
	accountId2 := accountRow1 atFieldNamed: 'ID'.
	accountRow2 := session system exampleAccountRow2.
	accountId1 := accountRow2 atFieldNamed: 'ID'.
	accountRow3 := session system exampleAccountRow3.
	linkRow1 := session system exampleCALinkRow1.
	linkRow2 := session system exampleCALinkRow2.
	linkRow3 := session system exampleCALinkRow3.
	session writeRow: customerRow.
	session writeRow: customerRow2.
	session writeRow: accountRow1.
	session writeRow: accountRow2.
	session writeRow: accountRow3.
	session writeRow: linkRow1.
	session writeRow: linkRow2.
	session writeRow: linkRow3.!

writeNodeWithChildren
	| node1 node2 node2a |
	node1 := self treeNodeClass new id: 1.
	node2 := self treeNodeClass new id: 2.
	node2a := self treeNodeClass new id: 3.
	node1 children add: node2.
	node1 children add: node2a.
	session inUnitOfWorkDo: [session register: node1].! !
!GlorpManyToManyDBTest categoriesFor: #checkAccounts!private!support! !
!GlorpManyToManyDBTest categoriesFor: #checkNumberOfAccounts:!private!tests-read! !
!GlorpManyToManyDBTest categoriesFor: #checkNumberOfLinkRows:!private!tests-read! !
!GlorpManyToManyDBTest categoriesFor: #inUnitOfWorkDo:initializeWith:!private!support! !
!GlorpManyToManyDBTest categoriesFor: #readCustomer!private!support! !
!GlorpManyToManyDBTest categoriesFor: #readCustomer:!public!support! !
!GlorpManyToManyDBTest categoriesFor: #session:!As yet unclassified!private! !
!GlorpManyToManyDBTest categoriesFor: #testReadAndDeleteNodes!private!tests-nodes! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerAndAddAccount!private!tests-read! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerAndDeleteAccount!private!tests-read! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerAndDeleteAccountProperly!private!tests-read! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerAndRemoveAccount!private!tests-read! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerAndReplaceAccounts!private!tests-read! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerAndReplaceAccountsWithoutInstantiatingHolders!private!tests-read! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerAndReplaceAccountsWithRemoval!private!tests-read! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerAndReplaceInstantiatedAccountsWithEmpty!private!tests-read! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerAndReplaceUninstantiatedAccountsWithEmpty!private!tests-read! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerOrderByLinkTableField!private!tests-join! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerOrderByLinkTableFieldDescending!private!tests-join! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerOrderingByCountSubselect!public!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithAverageSubselect!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithCountSubselect!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithCountSubselectAlternateSyntax!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithEqualityComparisonToAccountsUsingInClause!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithEqualitySubSelectToAccountsUsingInClause!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithFilteredSubSelectToAccounts1!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithFilteredSubSelectToAccounts2!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithFilteredSubSelectToAccounts3!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithFilteredSubSelectToAccountsAndAggregate!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithIsEmptyAndFilteredSubselectsToAccounts!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithIsEmptySubselectToAccounts1!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithJoinToAccounts!private!tests-join! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithJoinToAccounts2!private!tests-join! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithMaxSubselect!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithMinSubselect!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithNotEmptyAndFilteredSubselectsToAccounts!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithSimpleJoinToAccounts!private!tests-join! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithSimpleSubSelectToAccounts!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithSubSelectToAccounts!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithSubSelectToAccounts2!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithSubSelectToAccountsUsingInClause!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadCustomerWithSumSubselect!private!tests-subselect! !
!GlorpManyToManyDBTest categoriesFor: #testReadNode!private!tests-nodes! !
!GlorpManyToManyDBTest categoriesFor: #testReadNodeAndDeleteChild!private!tests-nodes! !
!GlorpManyToManyDBTest categoriesFor: #testReadNodeAndDeleteChildWithSaveAndContinue!private!tests-nodes! !
!GlorpManyToManyDBTest categoriesFor: #testReadNodeAndDeleteParent!private!tests-nodes! !
!GlorpManyToManyDBTest categoriesFor: #testWriteCustomersAndAccounts!public!tests-write! !
!GlorpManyToManyDBTest categoriesFor: #testWriteCustomersAndAccountsAndDelete!public!tests-write! !
!GlorpManyToManyDBTest categoriesFor: #testWriteCustomerWithAccounts!private!tests-write! !
!GlorpManyToManyDBTest categoriesFor: #testWriteCustomerWithNoAccounts!private!tests-write! !
!GlorpManyToManyDBTest categoriesFor: #testWriteCustomerWithTwoAccounts!private!tests-write! !
!GlorpManyToManyDBTest categoriesFor: #treeNodeClass!private!tests-nodes! !
!GlorpManyToManyDBTest categoriesFor: #treeNodeClass:!private!tests-nodes! !
!GlorpManyToManyDBTest categoriesFor: #writeCustomerWithAccounts!private!support! !
!GlorpManyToManyDBTest categoriesFor: #writeNodeWithChildren!private!tests-nodes! !

GlorpOneToManyDBTest guid: (GUID fromString: '{EBF2516F-3622-4322-8646-310627B38F14}')!
GlorpOneToManyDBTest comment: ''!
!GlorpOneToManyDBTest categoriesForClass!Unclassified! !
!GlorpOneToManyDBTest methodsFor!

checkEmailAddresses: emailAddresses
	| sorted numberOfAddresses |
	numberOfAddresses := (emailId1 isNil ifTrue: [0] ifFalse: [1]) + (emailId2 isNil ifTrue: [0] ifFalse: [1]) + (emailId3 isNil ifTrue: [0] ifFalse: [1]).
	self assert: emailAddresses size = numberOfAddresses.
	sorted := emailAddresses asSortedCollection: [:a :b | a id <= b id].
	emailId1 isNil ifFalse: [self assert: sorted first id = emailId1].
	emailId2 isNil ifFalse: [self assert: (sorted at: 2) id = emailId2].
	emailId3 isNil ifFalse: [self assert: sorted last id = emailId3].
	self assert: (emailAddresses collect: [:each | each id]) asSet size = emailAddresses size.!

checkNumberOfEmailAddressesInDB: numberOfAddresses
	| databaseAddresses |
	databaseAddresses := session accessor executeSQLString: 'SELECT * FROM EMAIL_ADDRESS'.
	self assert: databaseAddresses size = numberOfAddresses.!

inUnitOfWorkDo: aBlock initializeWith: initBlock
	"Set up a bunch of the normal data, read the objects, then run the block in a unit of work"
	initBlock value.
	session beginUnitOfWork.
	self readPerson.
	aBlock value.
	session commitUnitOfWork.
	session reset.!

readPerson
	| results query |
	query := Query
		returningManyOf: GlorpPerson
		where: [:pers | pers id = personId].
	results := query executeIn: session.
	self assert: results size = 1.
	person := results first.!

setUpSomeExtraPeople
	self
		inUnitOfWorkDo:
			[| otherPerson |
			session register: (GlorpPerson new id: 9924365).
			otherPerson := GlorpPerson new id: 12121.
			otherPerson
				emailAddresses:
					(OrderedCollection
						with:
							((GlorpEmailAddress new)
								id: 7;
								host: 'asdfasdf')).
			session register: otherPerson]
		initializeWith: [self writePersonWithEmailAddresses].!

tearDown
	((session system descriptorFor: GlorpPerson) mappingForAttributeNamed: #emailAddresses) isExclusive: false.
	super tearDown.!

testReadActionWithCollection
	| collection |
	self
		inTransactionDo:
			[collection := OrderedCollection new.
			self writePersonWithEmailAddresses.
			((session system descriptorFor: GlorpPerson)
				mappingForAttributeNamed: #emailAddresses)
				proxyAction:
					[:owner :object | object do: [:each | collection add: owner -> each]].
			person := session readOneOf: GlorpPerson.
			person emailAddresses yourSelf.
			self assert: collection size = 2.
			self assert: collection first = (person -> person emailAddresses first).
			self assert: collection last = (person -> person emailAddresses last)].!

testReadJustTheEmailAddressNotThePersonAndWriteBackWithChanges
	| addresses addressRows |
	"We won't have the person object to set a value for the PERSON_ID field. Ensure that we don't write a null for that field, or otherwise modify things."
	self inTransactionDo: [	
		self writePersonWithEmailAddresses.
		session beginUnitOfWork.
		addresses := session readManyOf: GlorpEmailAddress.
		addresses do: [:each | each host: 'bar.org'].
		self assert: ((session privateGetCache cacheForClass: GlorpPerson) at: 3 ifAbsent: [nil]) isNil.
		session commitUnitOfWork.
		addressRows := session accessor executeSQLString: 'SELECT PERSON_ID, HOST_NAME from EMAIL_ADDRESS'.
		self assert: addressRows size = 2.
		addressRows do: [:each | 
			self assert: (each atIndex: 1) = 3.
			self assert: (each atIndex: 2) = 'bar.org'].
].!

testReadJustTheEmailAddressNotThePersonAndWriteBackWithNoChanges
	| addresses addressRows |
	"We won't have the person object to set a value for the PERSON_ID field. Ensure that we don't write a null for that field, or otherwise modify things."
	self inTransactionDo: [	
		self writePersonWithEmailAddresses.
		session beginUnitOfWork.
		addresses := session readManyOf: GlorpEmailAddress.
		self assert: ((session privateGetCache cacheForClass: GlorpPerson) at: 3 ifAbsent: [nil]) isNil.
		session commitUnitOfWork.
		addressRows := session accessor executeSQLString: 'SELECT PERSON_ID from EMAIL_ADDRESS'.
		self assert: addressRows size = 2.
		addressRows do: [:each | self assert: (each atIndex: 1) = 3].
].!

testReadPersonAndAddEmailAddress
	| |
	self
		inTransactionDo:
			[
			self 
				inUnitOfWorkDo: [person emailAddresses add: (GlorpEmailAddress new id: 99876; user: 'postmaster'; host: 'foo.com')]
				initializeWith: [self writePersonWithEmailAddresses].
			emailId3 := 99876.
			self readPerson.
			self checkEmailAddresses: person emailAddresses].!

testReadPersonAndAddEmailAddressProxy
	| address |
	self
		inTransactionDo:
			[self
				inUnitOfWorkDo:
					[| query |
					query := Query
						readOneOf: GlorpEmailAddress
						where: [:each | each id = 99876].
					query proxyType: Proxy.
					address := session execute: query.
					address yourSelf.
					person emailAddresses add: address.
					self assert: person emailAddresses last class == Proxy]
				initializeWith:
					[self writePersonWithEmailAddresses.
					session
						transact:
							[(GlorpEmailAddress new)
								id: 99876;
								user: 'postmaster';
								host: 'foo.com'].
						session reset].
			emailId3 := 99876.
			self readPerson.
			self checkEmailAddresses: person emailAddresses].!

testReadPersonAndAddEmailAddressTwice
	| personRow addressRow |
	self
		inTransactionDo:
			[self
				inUnitOfWorkDo:
					[person emailAddresses
						add:
							((GlorpEmailAddress new)
								id: 99876;
								user: 'postmaster';
								host: 'foo.com')]
				initializeWith:
					[addressRow := session system exampleAddressRow.
					session writeRow: addressRow.
					personRow := session system examplePersonRow1.
					personId := personRow atFieldNamed: 'ID'.
					session writeRow: personRow].
			self
				inUnitOfWorkDo:
					[person emailAddresses
						add:
							((GlorpEmailAddress new)
								id: 99991;
								user: 'someone';
								host: 'foo.com')]
				initializeWith: [].
			emailId1 := 99876.
			emailId2 := 99991.
			self readPerson.
			self checkEmailAddresses: person emailAddresses].!

testReadPersonAndDeleteEmailAddress
	self
		inTransactionDo:
			[
			self 
				inUnitOfWorkDo: [
					session delete: person emailAddresses last. 
					person emailAddresses removeLast. ]
				initializeWith: [self writePersonWithEmailAddresses].
			emailId2 := nil.
			self readPerson.
			self checkEmailAddresses: person emailAddresses.
			self checkNumberOfEmailAddressesInDB: 1].!

testReadPersonAndRemoveEmailAddress
	self
		inTransactionDo:
			[
			self 
				inUnitOfWorkDo: [person emailAddresses removeLast]
				initializeWith: [self writePersonWithEmailAddresses].
			emailId2 := nil.
			self readPerson.
			self checkEmailAddresses: person emailAddresses.
			self checkNumberOfEmailAddressesInDB: 2].!

testReadPersonAndReplaceEmailAddressesWithDifferent
	| |
	self
		inTransactionDo:
			[self 
				inUnitOfWorkDo: [
					person emailAddresses: (Array with: (GlorpEmailAddress new id: 99876; user: 'postmaster'; host: 'foo.com')) ]
				initializeWith: [self writePersonWithEmailAddresses].
			emailId1 := 99876.
			emailId2 := nil.
			self readPerson.
			self checkEmailAddresses: person emailAddresses.
			self checkNumberOfEmailAddressesInDB: 3].!

testReadPersonAndReplaceEmailAddressesWithRemoval
	| |
	self
		inTransactionDo:
			[self 
				inUnitOfWorkDo: [
					person emailAddresses: (Array with: person emailAddresses first) ]
				initializeWith: [self writePersonWithEmailAddresses].
			emailId2 := nil.
			self readPerson.
			self checkEmailAddresses: person emailAddresses.
			self checkNumberOfEmailAddressesInDB: 2].!

testReadPersonAndReplaceInstantiatedEmailAddressesWithEmpty
	| |
	self
		inTransactionDo:
			[self 
				inUnitOfWorkDo: [
					person emailAddresses yourSelf. 
					person emailAddresses: #(). ]
				initializeWith: [self writePersonWithEmailAddresses].
			emailId1 := nil.
			emailId2 := nil.
			self readPerson.
			self checkEmailAddresses: person emailAddresses.
			self checkNumberOfEmailAddressesInDB: 2].!

testReadPersonAndReplaceUninstantiatedEmailAddressesWithEmpty
	| |
	self
		inTransactionDo:
			[
			self 
				inUnitOfWorkDo: [person emailAddresses: #().]
				initializeWith: [self writePersonWithEmailAddresses].
			emailId1 := nil.
			emailId2 := nil.
			self readPerson.
			self checkEmailAddresses: person emailAddresses.
			self checkNumberOfEmailAddressesInDB: 2].!

testReadPersonWithEmailAddresses
	| query result emailAddresses |
	self
		inTransactionDo:
			[self writePersonWithEmailAddresses.
			query := Query
				returningOneOf: GlorpPerson
				where: [:eachPerson | eachPerson id = personId].
			result := query executeIn: session.
			emailAddresses := result emailAddresses getValue.
			self checkEmailAddresses: emailAddresses].!

testReadPersonWithExistsWithAlsoFetch
	| people query |
	self inTransactionDo: 
			[self setUpSomeExtraPeople.
			query := ReadQuery readManyOf: GlorpPerson
						where: 
							[:eachPerson | 
							eachPerson emailAddresses 
								anySatisfyExists: [:eachEmail | eachEmail host = 'objectpeople.com']].
			query alsoFetch: [:e | e address].
			people := query executeIn: session.
			self assert: people size = 1]!

testReadPersonWithIsEmptySubselectToEmailAddresses
	| people |
	self
		inTransactionDo:
			[self setUpSomeExtraPeople.
			people := session
				readManyOf: GlorpPerson
				where:
					[:eachPerson | eachPerson emailAddresses isEmpty].
			self assert: people size = 1].!

testReadPersonWithJoinToEmailAddresses
	| people |
	self
		inTransactionDo:
			[self setUpSomeExtraPeople.
			people := session
				readManyOf: GlorpPerson
				where:
					[:eachPerson | 
					eachPerson emailAddresses
						anySatisfyJoin: [:eachEmail | eachEmail host = 'objectpeople.com']].
			self assert: people size = 1].!

testReadPersonWithJoinWithAlsoFetch
	| people query |
	self inTransactionDo: 
			[self setUpSomeExtraPeople.
			query := ReadQuery readManyOf: GlorpPerson
						where: 
							[:eachPerson | 
							eachPerson emailAddresses anySatisfyJoin: 
									[:eachEmail | 
									eachEmail host = 'objectpeople.com' | (eachEmail host = 'cs.uiuc.edu')]].
			query alsoFetch: [:e | e address].
			people := query executeIn: session.
			self assert: people size = 1]!

testReadPersonWithNegativeJoinToEmailAddresses
	"Read with a negative condition. Note that this excludes the person with no e-mail addresses, as we're not doing an outer join"
	| people |
	self
		inTransactionDo:
			[self setUpSomeExtraPeople.
			people := session
				readManyOf: GlorpPerson
				where:
					[:eachPerson | 
					eachPerson emailAddresses
						anySatisfyJoin: [:eachEmail | eachEmail host ~= 'objectpeople.com']].
			self assert: people size = 2].!

testReadPersonWithNegativeSubselectToEmailAddresses
	"Read with a negative condition. Note that this excludes the person with no e-mail addresses, as we're not doing an outer join"
	| people |
	self
		inTransactionDo:
			[self setUpSomeExtraPeople.
			people := session
				readManyOf: GlorpPerson
				where:
					[:eachPerson | 
					eachPerson emailAddresses
						anySatisfyExists: [:eachEmail | eachEmail host ~= 'objectpeople.com']].
			self assert: people size = 2].!

testReadPersonWithNotEmptySubselectToEmailAddresses
	| people |
	self
		inTransactionDo:
			[self setUpSomeExtraPeople.
			people := session
				readManyOf: GlorpPerson
				where:
					[:eachPerson | eachPerson emailAddresses notEmpty].
			self assert: people size = 2].!

testReadPersonWithSubselectToEmailAddresses
	| people |
	self
		inTransactionDo:
			[self setUpSomeExtraPeople.
			people := session
				readManyOf: GlorpPerson
				where:
					[:eachPerson | 
					eachPerson emailAddresses
						anySatisfyExists: [:eachEmail | eachEmail host = 'objectpeople.com']].
			self assert: people size = 1].!

testUpdatePersonWithNilEmailAddressesAndExclusiveRelationship

	| newPerson |
	((session system descriptorFor: GlorpPerson) mappingForAttributeNamed: #emailAddresses) beExclusive.
	self inTransactionDo: [
		session beginUnitOfWork.
		newPerson := GlorpPerson new.
		newPerson id: 231.
		personId := 231.
		session register: newPerson.
		session commitUnitOfWork.
		session reset.
		self readPerson.
		session modify: person in: [person emailAddresses: nil].
		session reset.
		self readPerson.
		self assert: person emailAddresses isEmpty.
		self checkNumberOfEmailAddressesInDB: 0].!

testWritePersonWithEmailAddresses

	| newPerson |
	self inTransactionDo: [
		session beginUnitOfWork.
		newPerson := GlorpPerson example1.
		newPerson id: 231.
		personId := 231.	
		newPerson emailAddresses: OrderedCollection new.
		newPerson emailAddresses add: (GlorpEmailAddress new id: 2; user: 'one'; host: 'blorch.ca').
		newPerson emailAddresses add: (GlorpEmailAddress new id: 3; user: 'two'; host: 'blorch.ca').
		emailId1 := 2.
		emailId2 := 3.
		session register: newPerson.
		session commitUnitOfWork.
		session reset.
		self readPerson.
		self checkEmailAddresses: person emailAddresses.
		self checkNumberOfEmailAddressesInDB: 2].!

testWritePersonWithNilEmailAddresses

	| newPerson |
	self inTransactionDo: [
		session beginUnitOfWork.
		newPerson := GlorpPerson new.
		newPerson id: 231.
		personId := 231.
		newPerson emailAddresses: nil.
		session register: newPerson.
		session commitUnitOfWork.
		session reset.
		self readPerson.
		self assert: person emailAddresses isEmpty.
		self checkNumberOfEmailAddressesInDB: 0].!

testWritePersonWithNilEmailAddressesAndExclusiveRelationship

	| newPerson |
	((session system descriptorFor: GlorpPerson) mappingForAttributeNamed: #emailAddresses) beExclusive.
	self inTransactionDo: [
		session beginUnitOfWork.
		newPerson := GlorpPerson new.
		newPerson id: 231.
		personId := 231.
		newPerson emailAddresses: nil.
		session register: newPerson.
		session commitUnitOfWork.
		session reset.
		self readPerson.
		self assert: person emailAddresses isEmpty.
		self checkNumberOfEmailAddressesInDB: 0].!

testWritePersonWithNoEmailAddresses

	| newPerson |
	self inTransactionDo: [
		session beginUnitOfWork.
		newPerson := GlorpPerson new.
		newPerson id: 231.
		personId := 231.
		session register: newPerson.
		session commitUnitOfWork.
		session reset.
		self readPerson.
		self assert: person emailAddresses isEmpty.
		self checkNumberOfEmailAddressesInDB: 0].!

testWritePersonWithNoEmailAddresses2

	| newPerson |
	self inTransactionDo: [
		session beginUnitOfWork.
		newPerson := GlorpPerson new.
		newPerson id: 231.
		personId := 231.
		newPerson emailAddresses: OrderedCollection new.
		session register: newPerson.
		session commitUnitOfWork.
		session reset.
		self readPerson.
		self assert: person emailAddresses isEmpty.
		self checkNumberOfEmailAddressesInDB: 0].!

writePersonWithEmailAddresses
	| addressRow personRow emailAddress1Row emailAddress2Row |
	addressRow := session system exampleAddressRow.
	session writeRow: addressRow.
	personRow := session system examplePersonRow1.
	personId := personRow atFieldNamed: 'ID'.
	session writeRow: personRow.
	emailAddress1Row := session system exampleEmailAddressRow1.
	emailAddress2Row := session system exampleEmailAddressRow2.
	emailId1 := emailAddress1Row at: (emailAddress1Row table fieldNamed: 'ID').
	emailId2 := emailAddress2Row at: (emailAddress2Row table fieldNamed: 'ID').
	session writeRow: emailAddress1Row.
	session writeRow: emailAddress2Row.! !
!GlorpOneToManyDBTest categoriesFor: #checkEmailAddresses:!private!support! !
!GlorpOneToManyDBTest categoriesFor: #checkNumberOfEmailAddressesInDB:!private!support! !
!GlorpOneToManyDBTest categoriesFor: #inUnitOfWorkDo:initializeWith:!private!support! !
!GlorpOneToManyDBTest categoriesFor: #readPerson!private!support! !
!GlorpOneToManyDBTest categoriesFor: #setUpSomeExtraPeople!private!tests-join! !
!GlorpOneToManyDBTest categoriesFor: #tearDown!private!support! !
!GlorpOneToManyDBTest categoriesFor: #testReadActionWithCollection!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadJustTheEmailAddressNotThePersonAndWriteBackWithChanges!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadJustTheEmailAddressNotThePersonAndWriteBackWithNoChanges!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonAndAddEmailAddress!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonAndAddEmailAddressProxy!public!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonAndAddEmailAddressTwice!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonAndDeleteEmailAddress!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonAndRemoveEmailAddress!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonAndReplaceEmailAddressesWithDifferent!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonAndReplaceEmailAddressesWithRemoval!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonAndReplaceInstantiatedEmailAddressesWithEmpty!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonAndReplaceUninstantiatedEmailAddressesWithEmpty!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonWithEmailAddresses!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonWithExistsWithAlsoFetch!private!tests! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonWithIsEmptySubselectToEmailAddresses!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonWithJoinToEmailAddresses!private!tests-join! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonWithJoinWithAlsoFetch!private!tests! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonWithNegativeJoinToEmailAddresses!private!tests-join! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonWithNegativeSubselectToEmailAddresses!private!tests-join! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonWithNotEmptySubselectToEmailAddresses!private!tests-read! !
!GlorpOneToManyDBTest categoriesFor: #testReadPersonWithSubselectToEmailAddresses!private!tests-join! !
!GlorpOneToManyDBTest categoriesFor: #testUpdatePersonWithNilEmailAddressesAndExclusiveRelationship!private!tests-write! !
!GlorpOneToManyDBTest categoriesFor: #testWritePersonWithEmailAddresses!private!tests-write! !
!GlorpOneToManyDBTest categoriesFor: #testWritePersonWithNilEmailAddresses!private!tests-write! !
!GlorpOneToManyDBTest categoriesFor: #testWritePersonWithNilEmailAddressesAndExclusiveRelationship!private!tests-write! !
!GlorpOneToManyDBTest categoriesFor: #testWritePersonWithNoEmailAddresses!private!tests-write! !
!GlorpOneToManyDBTest categoriesFor: #testWritePersonWithNoEmailAddresses2!private!tests-write! !
!GlorpOneToManyDBTest categoriesFor: #writePersonWithEmailAddresses!private!support! !

GlorpOneToOneDBTest guid: (GUID fromString: '{7EC9B735-2D51-4C51-965C-F583BA04C8D7}')!
GlorpOneToOneDBTest comment: ''!
!GlorpOneToOneDBTest categoriesForClass!Unclassified! !
!GlorpOneToOneDBTest methodsFor!

additionalTests

	"It would be good to have tests here for a foreign key 'pointing' the other direction. Also composite keys (once those work)"!

checkAddress
	self assert: person address isGlorpProxy.
	self assert: person address getValue id = 123.
	^self assert: person address getValue class == GlorpAddress.!

checkNoAddress
	self deny: person address isGlorpProxy.
	self assert: person address == nil.!

checkNoAddressesInDB
	| addresses addressKeys |
	addresses := session accessor executeSQLString: 'SELECT * FROM GR_ADDRESS'.
	self assert: addresses isEmpty.
	addressKeys := session accessor executeSQLString: 'SELECT ADDRESS_ID FROM PERSON'.
	self assert: (addressKeys size = 1).
	self assert: (addressKeys first atIndex: 1) = nil.!

checkPerson
	self assert: person class = GlorpPerson.
	self assert: person id = personId.
	self assert: person name = 'aPerson'.!

inUnitOfWorkDo: aBlock
	"Set up a bunch of the normal data, read the objects, then run the block in a unit of work"
	self inUnitOfWorkDo: aBlock initializeWith: [self writePersonWithAddress].!

inUnitOfWorkDo: aBlock initializeWith: initBlock
	"Set up a bunch of the normal data, read the objects, then run the block in a unit of work"
	initBlock value.
	session beginUnitOfWork.
	self readPerson.
	aBlock value.
	session commitUnitOfWork.
	session reset.!

readPerson
	| results query |
	query := Query
		returningManyOf: GlorpPerson
		where: [:pers | pers id = personId].
	results := query executeIn: session.
	self assert: results size = 1.
	person := results first.!

testLinkTableRead
	| customers |
	system := GlorpLinkTableAnywhereDescriptorSystem forPlatform: system platform.
	session system: system.
	self inTransactionDo: [
		self writeCustomersWithOneAccountEach.
		session reset.
		customers := session readManyOf: GlorpCustomer.
		self assert: ((customers collect: [:each | each accounts id]) asSortedCollection asArray = #(22 9874))].!

testLinkTableWrite
	system := GlorpLinkTableAnywhereDescriptorSystem
		forPlatform: system platform.
	session system: system.
	self
		inTransactionDo:
			[| rows row |
			self
				inUnitOfWorkDo:
					[| cust1 acct1 |
					cust1 := GlorpCustomer new.
					cust1 id: 2.
					cust1 name: 'Violet Baudelaire'.
					acct1 := GlorpBankAccount new.
					acct1 id: 3.
					cust1 accounts: acct1.
					session register: cust1].
			session reset.
			rows := session accessor
				executeSQLString:
					'select * from GR_CUSTOMER t1, BANK_ACCT t2, CUSTOMER_ACCT_LINK t3 WHERE t3.ACCT_ID = t2.ID AND t3.CUSTOMER_ID = t1.ID'.
			self assert: rows size = 1.
			row := rows first.
			self assert: (row asArray = (OrderedCollection new add: 2; add: 'Violet Baudelaire'; add: 3; add: nil; add: nil; add: nil; add: 2; add: 3; yourself) asArray)].!

testReadAction
	| collection |
	self
		inTransactionDo:
			[collection := OrderedCollection new.
			self writePersonWithAddress.
			((session system descriptorFor: GlorpPerson)
				mappingForAttributeNamed: #address)
				proxyAction: [:owner :object | collection add: owner -> object].
			person := session readOneOf: GlorpPerson.
			person address yourSelf.
			self assert: collection size = 1.
			self assert: collection first = (person -> person address yourSelf)].!

testReadPersonAndAddAddress
	self inTransactionDo: [
		self 
			inUnitOfWorkDo: [person address: (GlorpAddress new id: 5555; street: 'hello'; number: 'world')]
			initializeWith: [self writeHomelessPerson].
		self readPerson.
		self checkPerson].!

testReadPersonAndAddBogusCollectionInsteadOfAddress
	self inTransactionDo: [
		self should: [self 
				inUnitOfWorkDo: [person address: #()]
				initializeWith: [self writeHomelessPerson]]
			raise: GlorpInvalidTypeError].!

testReadPersonAndAddBogusObjectInsteadOfAddress
	self inTransactionDo: [
		self should: [self 
				inUnitOfWorkDo: [person address: GlorpPerson new]
				initializeWith: [self writeHomelessPerson]]
			raise: GlorpInvalidTypeError].!

testReadPersonAndAddBogusObjectInsteadOfEmailAddresses
	self inTransactionDo: [
		self should: [self 
				inUnitOfWorkDo: [person emailAddresses: 42]
				initializeWith: [self writeHomelessPerson]]
			raise: GlorpInvalidTypeError].!

testReadPersonAndAddBogusObjectInsteadOfEmailAddresses2
	self inTransactionDo: [
		self should: [self 
				inUnitOfWorkDo: [person emailAddresses: GlorpEmailAddress new]
				initializeWith: [self writeHomelessPerson]]
			raise: GlorpInvalidTypeError].!

testReadPersonAndRemoveAddress
	self inTransactionDo: [
		self inUnitOfWorkDo: [
			session delete: person address.
			person address: nil.].
		self readPerson.
		self checkPerson.
		self checkNoAddress.
		self checkNoAddressesInDB].!

testReadPersonAndReplaceAddress
	self inTransactionDo:
		[self inUnitOfWorkDo: 
			[person	address: ((GlorpAddress new) id: 12; street: 'foo'; number: '1234')].
		self readPerson.
		self checkPerson.
		self assert: person address isGlorpProxy.
		self assert: person address getValue id = 12.
		self assert: person address getValue street = 'foo'.].!

testReadPersonAndReplaceAdressWithDifferentProxy
	| proxy |
	self inTransactionDo: 
			[
			session writeRow: session system exampleAddressRowForOrdering1.
			self inUnitOfWorkDo: 
					[ | field |
					proxy := Proxy new.
					proxy query: person address query copy.
					field := (session system tableNamed: 'PERSON') fieldNamed: 'ADDRESS_ID'.
					proxy parameters: (IdentityDictionary new at: field put: 1; yourself).
					proxy session: person address session.
					person address: proxy].
			self readPerson.
			self checkPerson.
			self assert: person address isGlorpProxy.
			self assert: person address getValue notNil.
			self assert: person address getValue id = 1]!

testReadPersonAndReplaceAdressWithProxy
	| proxy |
	self inTransactionDo: 
			[self inUnitOfWorkDo: 
					[proxy := Proxy new.
					proxy query: person address query copy.
					proxy parameters: person address parameters copy.
					proxy session: person address session.
					person address: proxy].
			self readPerson.
			self checkPerson.
			self assert: person address isGlorpProxy.
			self assert: person address getValue notNil.
			self assert: person address getValue id = 123]!

testReadPersonAndUpdateName
	"Test to make sure that if we never instantiate the address, we don't have problems with that relationship"
	self inTransactionDo:
		[self inUnitOfWorkDo: 
			[person	name: 'new name'].
		self deny: person address isInstantiated.
		session reset.
		self readPerson.
		self assert: person name = 'new name'.
		self assert: person address isGlorpProxy.
		self assert: person address getValue id = 123.
		self assert: person address getValue street = 'Paseo Montril'.].!

testReadPersonWithAddress
	self inTransactionDo: [
		self writePersonWithAddress.
		self readPerson.
		self checkPerson.
		self checkAddress].!

testReadPersonWithJoinToAddress
	| people |
	self inTransactionDo: [
		self writePersonWithAddress.
		people := session readManyOf: GlorpPerson where: [:eachPerson | eachPerson address street = 'Paseo Montril'].
		self assert: people size = 1.
		person := people first.
		self assert: person address street = 'Paseo Montril'.
		self assert: person address id = 123].!

testReadPersonWithoutAddress
	self inTransactionDo: [
		self writeHomelessPerson.
		self writeAddress.
		self readPerson.
		self checkPerson.
		self checkNoAddress].!

testReadWithCacheHitFromExpression
	self
		inTransactionDo:
			[self
				inUnitOfWorkDo:
					[self assert: person address yourSelf id = 123.
					session accessor permitNothing.
					session readOneOf: GlorpAddress where: [:each | each id = 123]]].!

testReadWithCacheHitFromJoin
	self inTransactionDo: [
		self 
			inUnitOfWorkDo: [
				session readOneOf: GlorpAddress.
				session accessor permitNothing.
				self assert: (person address yourSelf id = 123)]].!

testReRegisteringAfterUpdate
	"Test that even if we re-register the object after it's been modified, we still write the changes."

	self
		inTransactionDo:
			[self writePersonWithAddress.
			session reset.
			session beginUnitOfWork.
			person := (session read: GlorpPerson) first.
			person name: 'new name'.
			session register: person.
			session commitUnitOfWork.
			session reset.
			self readPerson.
			self assert: person name = 'new name'].!

testWritePersonWithAddress
	|newPerson |
	self inTransactionDo: [
		session beginUnitOfWork.
		newPerson := GlorpPerson example1.
		personId := newPerson id.
		session register: newPerson.
		session commitUnitOfWork.
		session reset.
		self readPerson.
		self assert: person id = newPerson id.
		self assert: person name = newPerson name.
		self assert: person address id = newPerson address id.
		self assert: person address street = newPerson address street].!

testWritePersonWithoutAddress
	|newPerson |
	self inTransactionDo: [
		session beginUnitOfWork.
		newPerson := GlorpPerson example1.
		newPerson address: nil.
		personId := newPerson id.
		session register: newPerson.
		session commitUnitOfWork.
		session reset.
		self readPerson.
		self assert: person id = newPerson id.
		self assert: person name = newPerson name.
		self assert: person address yourSelf == nil.
		self checkNoAddressesInDB].!

writeAddress
	| addressRow |
	addressRow := session system exampleAddressRow.
	session writeRow: addressRow.!

writeCustomersWithOneAccountEach
	| customerRow accountRow1 accountRow2 linkRow1 linkRow2 customerRow2 |

	customerRow := session system exampleCustomerRow1.
	customerRow2 := session system exampleCustomerRow2.
	accountRow1 := session system exampleAccountRow1. 
	accountRow2 := session system exampleAccountRow3.
	linkRow1 := session system exampleCALinkRow1.
	linkRow2 := session system exampleCALinkRow3.
	session writeRow: customerRow.
	session writeRow: customerRow2.
	session writeRow: accountRow1.
	session writeRow: accountRow2.
	session writeRow: linkRow1.
	session writeRow: linkRow2.!

writeHomefulPerson
	| personRow |
	personRow := session system examplePersonRow1.
	session writeRow: personRow.
	personId := personRow atFieldNamed: 'ID'.!

writeHomelessPerson
	| personRow |
	personRow := session system examplePersonRow2.
	session writeRow: personRow.
	personId := personRow atFieldNamed: 'ID'.!

writePersonWithAddress
	self writeAddress.
	self writeHomefulPerson.! !
!GlorpOneToOneDBTest categoriesFor: #additionalTests!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #checkAddress!private!support! !
!GlorpOneToOneDBTest categoriesFor: #checkNoAddress!private!support! !
!GlorpOneToOneDBTest categoriesFor: #checkNoAddressesInDB!private!support! !
!GlorpOneToOneDBTest categoriesFor: #checkPerson!private!support! !
!GlorpOneToOneDBTest categoriesFor: #inUnitOfWorkDo:!private!support! !
!GlorpOneToOneDBTest categoriesFor: #inUnitOfWorkDo:initializeWith:!private!support! !
!GlorpOneToOneDBTest categoriesFor: #readPerson!private!support! !
!GlorpOneToOneDBTest categoriesFor: #testLinkTableRead!private!tests-link table! !
!GlorpOneToOneDBTest categoriesFor: #testLinkTableWrite!private!tests-link table! !
!GlorpOneToOneDBTest categoriesFor: #testReadAction!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonAndAddAddress!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonAndAddBogusCollectionInsteadOfAddress!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonAndAddBogusObjectInsteadOfAddress!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonAndAddBogusObjectInsteadOfEmailAddresses!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonAndAddBogusObjectInsteadOfEmailAddresses2!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonAndRemoveAddress!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonAndReplaceAddress!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonAndReplaceAdressWithDifferentProxy!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonAndReplaceAdressWithProxy!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonAndUpdateName!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonWithAddress!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonWithJoinToAddress!private!tests-join! !
!GlorpOneToOneDBTest categoriesFor: #testReadPersonWithoutAddress!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadWithCacheHitFromExpression!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReadWithCacheHitFromJoin!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testReRegisteringAfterUpdate!private!tests-read! !
!GlorpOneToOneDBTest categoriesFor: #testWritePersonWithAddress!private!tests-write! !
!GlorpOneToOneDBTest categoriesFor: #testWritePersonWithoutAddress!private!tests-write! !
!GlorpOneToOneDBTest categoriesFor: #writeAddress!private!support! !
!GlorpOneToOneDBTest categoriesFor: #writeCustomersWithOneAccountEach!private!tests-link table! !
!GlorpOneToOneDBTest categoriesFor: #writeHomefulPerson!private!support! !
!GlorpOneToOneDBTest categoriesFor: #writeHomelessPerson!private!support! !
!GlorpOneToOneDBTest categoriesFor: #writePersonWithAddress!private!support! !

GlorpOwnerSlaveTest guid: (GUID fromString: '{B41D643C-196D-4EBB-AA63-D6D11474940F}')!
GlorpOwnerSlaveTest comment: ''!
!GlorpOwnerSlaveTest categoriesForClass!Unclassified! !
!GlorpOwnerSlaveTest methodsFor!

test1
	| owner slaves table field |
	self
		inTransactionDo:
			[owner := GlorpOwner new.
			owner id: 1.
			slaves := OrderedCollection new.
			1 to: 5 do: [:id | slaves add: (GlorpSlave new id: id)].
			owner slaves: slaves.
			owner slave: slaves last.
			session beginUnitOfWork.
			session register: owner.
			session commitUnitOfWork.
			session reset.
			owner := session readOneOf: GlorpOwner where: [:each | each id = 1].
			self assert: owner slaves isEmpty not.
			table := session system tableNamed: 'GLORP_SLAVE'.
			field := table fieldNamed: 'OWNER_ID'.
			slaves := session
				readManyOf: GlorpSlave
				where: [:each | ((each getTable: table) getField: field) ~= nil].
			self assert: slaves size = 5].!

testSortOrder
	"Validate that it doesn't matter what order we put in the input, the tables come out in the correct sort order."
	| justTheseTables sorted sorted2 |
	justTheseTables := Array with: (system tableNamed: 'GLORP_OWNER') with: (system tableNamed: 'GLORP_SLAVE').
	sorted := (TableSorter for: justTheseTables) sort.
	sorted2 := (TableSorter for: justTheseTables reverse) sort.
	self assert: sorted = sorted2.
	self assert: sorted first name = 'GLORP_SLAVE'.! !
!GlorpOwnerSlaveTest categoriesFor: #test1!private!tests! !
!GlorpOwnerSlaveTest categoriesFor: #testSortOrder!private!tests! !

GlorpVariableTypeTest guid: (GUID fromString: '{20D2CE99-D3E4-4EEC-9821-0128FC13F52A}')!
GlorpVariableTypeTest comment: 'This exercises trying to map to objects that might be of multiple types, not related by inheritance. '!
!GlorpVariableTypeTest categoriesForClass!Unclassified! !
!GlorpVariableTypeTest methodsFor!

setUp
	super setUp.
	system := GlorpVariableTypeTestSystem forPlatform: session system platform.
	session system: system.!

testRead
	| gallery image |
	self inTransactionDo: [
		gallery := GlorpGallery new name: 'Some Gallery'.
		gallery images add: (GlorpImageFile example1).
		session modify: gallery in: [].
		session reset.
		gallery := session readOneOf: GlorpGallery.
		self assert: gallery images size = 1.
		image := gallery images first.
		self assert: image class = GlorpImageFile.
		self assert: image bits = GlorpImageFile example1 bits.
		].!

testReadBoth
	| gallery image link |
	self inTransactionDo: [
		gallery := GlorpGallery new name: 'Some Gallery'.
		gallery images add: (GlorpImageFile example2); add: (GlorpImageFile example1).
		session modify: gallery in: [].
		session reset.
		gallery := session readOneOf: GlorpGallery.
		self assert: gallery images size = 2.
		self assert: (gallery images select: [:each | each class = GlorpImageFile]) size = 1.
		image := gallery images detect: [:each | each class = GlorpImageFile].
		link := gallery images detect: [:each | each class = GlorpImageLink].
		self assert: (gallery images collect: [:each | each id]) asSet size = 2.
		self assert: image bits = (GlorpImageFile example1 bits).
		self assert: image thumbnailBits = (GlorpImageFile example1 bits).
		self assert: image thumbnailBits = (GlorpImageFile example2 thumbnailBits).


		].!

testReadLarge
	| gallery image |
	self inTransactionDo: [
		gallery := GlorpGallery new name: 'Some Gallery'.
		gallery images add: (GlorpImageFile example2).
		session modify: gallery in: [].
		session reset.
		gallery := session readOneOf: GlorpGallery.
		self assert: gallery images size = 1.
		image := gallery images first.
		self assert: image class = GlorpImageLink.
		self assert: image thumbnailBits = (GlorpImageFile example2 thumbnailBits) .
		].!

testWrite
	| gallery images links |
	self inTransactionDo: [
		gallery := GlorpGallery new name: 'Some Gallery'.
		gallery images add: (GlorpImageFile example1).
		session modify: gallery in: [].
		session reset.
		images := session accessor executeSQLString: 'SELECT * FROM GLORP_IMAGE_FILE'.
		self assert: images size = 1.
		links := session accessor executeSQLString: 'SELECT GALLERY_ID, IMAGE_ID, LARGE FROM GALLERY_LINK'.
		self assert: links size = 1.
		self assert: links first last ='F'].!

testWriteLarge
	| gallery images links |
	self inTransactionDo: [
		gallery := GlorpGallery new name: 'Some Gallery'.
		gallery images add: (GlorpImageFile example2).
		session modify: gallery in: [].
		session reset.
		images := session accessor executeSQLString: 'SELECT * FROM GLORP_IMAGE_FILE'.
		self assert: images size = 1.
		links := session accessor executeSQLString: 'SELECT GALLERY_ID, IMAGE_ID, LARGE FROM GALLERY_LINK'.
		self assert: links size = 1.
		self assert: links first last = 'T'].! !
!GlorpVariableTypeTest categoriesFor: #setUp!private!Running! !
!GlorpVariableTypeTest categoriesFor: #testRead!private!testing! !
!GlorpVariableTypeTest categoriesFor: #testReadBoth!private!testing! !
!GlorpVariableTypeTest categoriesFor: #testReadLarge!private!testing! !
!GlorpVariableTypeTest categoriesFor: #testWrite!private!testing! !
!GlorpVariableTypeTest categoriesFor: #testWriteLarge!private!testing! !

GlorpReadingDifferentCollectionsThroughMappingsWithClassModelsTest guid: (GUID fromString: '{DB70B1B3-07F3-4FCF-83CF-4D7B78BC2F67}')!
GlorpReadingDifferentCollectionsThroughMappingsWithClassModelsTest comment: ''!
!GlorpReadingDifferentCollectionsThroughMappingsWithClassModelsTest categoriesForClass!Unclassified! !
!GlorpReadingDifferentCollectionsThroughMappingsWithClassModelsTest methodsFor!

descriptorClass
	^GlorpCollectionTypesWithClassModelsDescriptorSystem.! !
!GlorpReadingDifferentCollectionsThroughMappingsWithClassModelsTest categoriesFor: #descriptorClass!private!setup! !

GlorpDatabaseLoginResource guid: (GUID fromString: '{8AE75BAF-5E09-44AD-A16E-A705C1A53711}')!
GlorpDatabaseLoginResource comment: ''!
!GlorpDatabaseLoginResource categoriesForClass!Unclassified! !
!GlorpDatabaseLoginResource methodsFor!

accessor
	^accessor!

accessor: anObject
	accessor := anObject!

login
	^login!

login: anObject
	"We don't attempt to be secure on logins being used for tests. Make sure we don't surprise someone by modifying the original instance."

	login := anObject copy.
	login secure: false.!

platform
	^login database!

setUp
	Transcript show: self class name asString, ' setUp'; cr.
	super setUp.
	self login: self class defaultLogin.
	accessor := DatabaseAccessor forLogin: login.
	accessor login.!

tearDown

	Transcript show: self class name asString, ' tearDown'; cr.
	accessor notNil ifTrue: [[accessor logout] on: Dialect error do: [:ex | ]].! !
!GlorpDatabaseLoginResource categoriesFor: #accessor!accessing!private! !
!GlorpDatabaseLoginResource categoriesFor: #accessor:!accessing!private! !
!GlorpDatabaseLoginResource categoriesFor: #login!accessing!private! !
!GlorpDatabaseLoginResource categoriesFor: #login:!accessing!public! !
!GlorpDatabaseLoginResource categoriesFor: #platform!accessing!private! !
!GlorpDatabaseLoginResource categoriesFor: #setUp!initialize/release!public! !
!GlorpDatabaseLoginResource categoriesFor: #tearDown!initialize/release!private! !

!GlorpDatabaseLoginResource class methodsFor!

constructEventsTriggered
	^(super constructEventsTriggered)
		add: #changedDefaultLogin;
		yourself!

defaultAccessLogin
	"To set the default database login for Access, execute the following statement."
	"self defaultAccessLogin."

	^DefaultLogin := (Login new)
		database: AccessPlatform new;
		username: 'whatever';
		password: '';
		connectString: 'access'!

defaultDB2Login
	"To set the default database login to Oracle, execute the following statement."
	"self defaultDB2Login."

	^DefaultLogin := (Login new)
		database: DB2Platform new;
		username: 'sames';
		password: 'sames';
		connectString: 'store'!

defaultFirebirdLogin
	"To set the default database login to Firebird, execute the following statement."
	"self defaultFirebirdLogin."

	^DefaultLogin := (Login new)
		database: FirebirdPlatform new;
		username: 'BaseSystem';
		password: 'BaseSyst';
		connectString: 'firebirdGlorpTestDB'!

defaultLogin
	"Return the default Login."

	DefaultLogin isNil ifTrue: [^DefaultLogin := self defaultPostgreSQLLoginForVPN].
	DefaultLogin database useBinding: DatabasePlatform useBindingIfSupported.
	^DefaultLogin!

defaultLogin: aLogin 
	DefaultLogin := aLogin.
	self trigger: #changedDefaultLogin!

defaultMysqlLogin
	"To set the default database login to MySQL, execute the following statement."
	"self defaultMysqlLogin."

	^DefaultLogin := (Login new)
		database: MySQLPlatform new;
		username: '';
		password: '';
		connectString: 'test'.!

defaultOracleLiteLogin
	"To set the default database login to Oracle, execute the following statement."
	"self defaultOracleLiteLogin."

	^DefaultLogin := (Login new)
		database: OraclePlatform new;
		username: 'System';
		password: 'password';
		connectString: 'odbc:polite'!

defaultOracleLogin
	"To set the default database login to Oracle, execute the following statement."
	"self defaultOracleLogin."

	^DefaultLogin := (Login new)
		database: OraclePlatform new;
		username: 'System';
		password: 'manager';
		connectString: ''!

defaultOracleLogin2
	"To set the default database login to Oracle, execute the following statement."
	"self defaultOracleLogin2."

	^DefaultLogin := (Login new)
		database: OraclePlatform new;
		username: 'system';
		password: 'password';
		connectString: ''!

defaultOracleODBCLogin
	"To set the default database login to Oracle, execute the following statement."
	"self defaultOracleODBCLogin."

	^DefaultLogin := (Login new)
		database: OracleODBCPlatform new;
		username: 'System';
		password: 'manager';
		connectString: 'oracle'!

defaultPersonalOracleLogin
	"To set the default database login to Oracle, execute the following statement."
	"self defaultPersonalOracleLogin."

	^DefaultLogin := (Login new)
		database: OraclePlatform new;
		username: 'system';
		password: 'manager';
		connectString: ''!

defaultPlatform
	^self defaultLogin database.!

defaultPostgreSQLInternetLogin
	"To set the default database login to PostgreSQL, execute the following statement."
	"self defaultPostgreSQLInternetLogin."

	^DefaultLogin := (Login new)
		database: PostgreSQLPlatform new;
		username: 'guest';
		password: 'guest';
		connectString: 'store.cincomsmalltalk.com:5432_glorptest'.!

defaultPostgreSQLLocalLogin
	"To set the default database login to PostgreSQL, execute the following statement."
	"self defaultPostgreSQLLocalLogin."

	^DefaultLogin := (Login new)
		database: PostgreSQLPlatform new;
		username: 'glorp';
		password: '';
		connectString: '192.168.1.99:5432_test'.!

defaultPostgreSQLLogin
	"To set the default database login to PostgreSQL, execute the following statement."
	"self defaultPostgreSQLLogin."

	^DefaultLogin := (Login new)
		database: PostgreSQLPlatform new;
		username: 'glorp-test';
		password: 'simple';
		connectString: '192.168.0.18_glorp-test'.!

defaultPostgreSQLLoginForGlorpStore
	"To set the default database login to PostgreSQL, execute the following statement."
	"self defaultPostgreSQLLoginForGlorpStore."

	^DefaultLogin := (Login new)
		database: PostgreSQLPlatform new;
		username: 'store-glorp-test';
		password: 'simple';
		connectString: '192.168.0.18_store-glorp-test'.!

defaultPostgreSQLLoginForVPN
	"To set the default database login to PostgreSQL, execute the following statement."
	"self defaultPostgreSQLLoginForVPN."

	^DefaultLogin := (Login new)
		database: PostgreSQLPlatform new;
		username: 'dbadmin';
		password: 'dbadmin';
		connectString: 'curly.parcplace.com:5432_template1'.!

defaultSQLiteLocalLogin
	"To set the default database login to SQLite, change the connectString to an appropriate path and execute the following statement."
	"self defaultSQLiteLocalLogin."

	^DefaultLogin := (Login new)
		database: SQLite3Platform new;
		username: '';
		password: '';
		connectString: 'C:\MyPath\StoreData\glorpTestSQLite.db'.!

defaultSQLServerLogin
	"To set the default database login for Dolphin, execute the following statement."
	"self defaultSQLServerLogin."

	^DefaultLogin := (Login new)
		database: SQLServerPlatform new;
		username: 'glorptest';
		password: 'password';
		connectString: 'glorptest'! !
!GlorpDatabaseLoginResource class categoriesFor: #constructEventsTriggered!accessing!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultAccessLogin!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultDB2Login!data!public! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultFirebirdLogin!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultLogin!accessing!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultLogin:!accessing!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultMysqlLogin!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultOracleLiteLogin!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultOracleLogin!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultOracleLogin2!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultOracleODBCLogin!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultPersonalOracleLogin!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultPlatform!accessing!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultPostgreSQLInternetLogin!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultPostgreSQLLocalLogin!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultPostgreSQLLogin!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultPostgreSQLLoginForGlorpStore!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultPostgreSQLLoginForVPN!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultSQLiteLocalLogin!data!private! !
!GlorpDatabaseLoginResource class categoriesFor: #defaultSQLServerLogin!data!private! !

GlorpDemoTablePopulatorResource guid: (GUID fromString: '{0943EB9B-83B6-473F-ACB8-097EAD5D3CC0}')!
GlorpDemoTablePopulatorResource comment: ''!
!GlorpDemoTablePopulatorResource categoriesForClass!Unclassified! !
!GlorpDemoTablePopulatorResource methodsFor!

populateStuffTable
 
	login accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (12,''abc'')'.
	login accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (13, ''hey nonny nonny'')'.
	login accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (42, ''yabba dabba doo'')'.
	login accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (9625, ''the band played on'')'.
	login accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (113141, ''Smalltalk'')'.!

setUp
	
	super setUp.
	login := GlorpDatabaseLoginResource current.
	self class needsSetup ifFalse: [^self].
	login accessor doDDLOperation:
			[GlorpTestDescriptorSystem glorpAllSubclasses
				do: [:eachSystemClass | 
					self setUpSystem: (eachSystemClass forPlatform: login platform) setUpDefaults].
			self populateStuffTable].!

setUpSystem: system 
	| errorBlock |
	login accessor dropTables: ((TableSorter for: system allTables) sort reverse).
	errorBlock := [:ex | Transcript show: ex description; cr. ex pass].
	system platform areSequencesExplicitlyCreated ifTrue: [
		login accessor dropSequences: system allSequences.
		system allSequences do: [:each |
			login accessor createSequence: each ifError: errorBlock]].
	system allTables do: [:each | 
			login accessor createTable: each
				ifError: errorBlock].
	system allTables do: [:each |
			login accessor createTableIndexes: each ifError: errorBlock]. 
	"SQLite3 doesn't support adding/dropping constraints."
	system platform supportsConstraints ifTrue: [
		system allTables do: [:each | 
				login accessor createTableFKConstraints: each ifError: errorBlock]].

	self class needsSetup: false! !
!GlorpDemoTablePopulatorResource categoriesFor: #populateStuffTable!private!setup! !
!GlorpDemoTablePopulatorResource categoriesFor: #setUp!private!setup! !
!GlorpDemoTablePopulatorResource categoriesFor: #setUpSystem:!public!setup! !

!GlorpDemoTablePopulatorResource class methodsFor!

invalidateSetup
	"GlorpDemoTablePopulatorResource invalidateSetup"

	NeedsSetup := true.
	self reset.!

needsSetup
	NeedsSetup isNil ifTrue: [NeedsSetup := true].
	^NeedsSetup!

needsSetup: aBoolean

	NeedsSetup := aBoolean.!

resources

	^Array with: GlorpDatabaseLoginResource.! !
!GlorpDemoTablePopulatorResource class categoriesFor: #invalidateSetup!private!setup! !
!GlorpDemoTablePopulatorResource class categoriesFor: #needsSetup!private!setup! !
!GlorpDemoTablePopulatorResource class categoriesFor: #needsSetup:!private!setup! !
!GlorpDemoTablePopulatorResource class categoriesFor: #resources!private!setup! !

GlorpSessionResource guid: (GUID fromString: '{A249A2D4-512B-4194-9A4B-37A4613A160E}')!
GlorpSessionResource comment: ''!
!GlorpSessionResource categoriesForClass!Unclassified! !
!GlorpSessionResource methodsFor!

glorpTestsSystem
	"We want to prep the GlorpDemoTablePopulatorResource but subclasses using different systems may not;  put it here where it will be overridden."

	GlorpDemoTablePopulatorResource current.
	^GlorpDemoDescriptorSystem forPlatform: GlorpDatabaseLoginResource defaultLogin database!

newSession

	self setUp.
	^self session.!

session

	^session.!

setAccessor
	
	session accessor: GlorpDatabaseLoginResource current accessor.!

setUp
	
	super setUp.
	session := self glorpTestsSystem
		sessionForLogin: GlorpDatabaseLoginResource current login.
	self setAccessor.!

tearDown
	super tearDown.	
	session logout.! !
!GlorpSessionResource categoriesFor: #glorpTestsSystem!private!setup! !
!GlorpSessionResource categoriesFor: #newSession!accessing!private! !
!GlorpSessionResource categoriesFor: #session!accessing!private! !
!GlorpSessionResource categoriesFor: #setAccessor!private!setup! !
!GlorpSessionResource categoriesFor: #setUp!private!setup! !
!GlorpSessionResource categoriesFor: #tearDown!private!setup! !

!GlorpSessionResource class methodsFor!

resources

	^Array with: GlorpDatabaseLoginResource with: GlorpDemoTablePopulatorResource.! !
!GlorpSessionResource class categoriesFor: #resources!private!resources! !

"Binary Globals"!

