| package |
package := Package name: 'GlorpExpressions'.
package paxVersion: 1;
	basicComment: 'This package defines classes for Glorp expressoins.  These are normally created from "query blocks", and then converted into SQL. It also contains the Join classes, used in Descriptors.

This is part of the GLORP system, an open-source library (LGPL(S)) for persisting Smalltalk objects in relational databases. For more information see the #notice property, the accompanying files and/or the web sites http://www.glorp.org or http://www.sourceforge.net/projects/glorp 
'.

package basicPackageVersion: 'image'.


package classNames
	add: #BaseExpression;
	add: #Case;
	add: #Cast;
	add: #CollectionExpression;
	add: #ConstantExpression;
	add: #DualRoleFunction;
	add: #EmptyExpression;
	add: #ExpressionGroup;
	add: #FieldExpression;
	add: #FunctionExpression;
	add: #GeneralSubSelectExpression;
	add: #GlorpExpression;
	add: #GlorpExpressionsPackage;
	add: #InfixFunction;
	add: #Join;
	add: #JoinBaseExpression;
	add: #MappingExpression;
	add: #ObjectExpression;
	add: #ParameterExpression;
	add: #PostfixFunction;
	add: #PrefixFunction;
	add: #RelationExpression;
	add: #StandaloneFunction;
	add: #SubSelectBaseExpression;
	add: #SubSelectExpression;
	add: #SubstringFunction;
	add: #TableExpression;
	add: #VariableJoin;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: 'GlorpMisc';
	yourself).

package!

"Class Definitions"!

Object subclass: #GlorpExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpExpressionsPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #Join
	instanceVariableNames: 'sources targets base outerJoin owningMapping'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #VariableJoin
	instanceVariableNames: 'joins'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpExpression subclass: #ConstantExpression
	instanceVariableNames: 'value alias'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpExpression subclass: #EmptyExpression
	instanceVariableNames: 'base value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpExpression subclass: #ExpressionGroup
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpExpression subclass: #FieldExpression
	instanceVariableNames: 'field base alias'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpExpression subclass: #FunctionExpression
	instanceVariableNames: 'function base alias symbol type'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'functions'!
GlorpExpression subclass: #GeneralSubSelectExpression
	instanceVariableNames: 'query base'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpExpression subclass: #ObjectExpression
	instanceVariableNames: 'mappingExpressions requiresDistinct tableAliases fieldAliases'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpExpression subclass: #ParameterExpression
	instanceVariableNames: 'base lookupKey'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpExpression subclass: #RelationExpression
	instanceVariableNames: 'relation leftChild rightChild outerJoin'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
FunctionExpression subclass: #DualRoleFunction
	instanceVariableNames: 'arguments whereClauseVersion selectListVersion'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
FunctionExpression subclass: #InfixFunction
	instanceVariableNames: 'argument arguments functionParts'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
FunctionExpression subclass: #PostfixFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
FunctionExpression subclass: #PrefixFunction
	instanceVariableNames: 'arguments separator argumentModifierBlock'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
FunctionExpression subclass: #StandaloneFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
PrefixFunction subclass: #Case
	instanceVariableNames: 'argumentTypes'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
PrefixFunction subclass: #Cast
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
PrefixFunction subclass: #SubstringFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
ObjectExpression subclass: #BaseExpression
	instanceVariableNames: 'descriptor availableSubSelectNumber'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
ObjectExpression subclass: #MappingExpression
	instanceVariableNames: 'name base outerJoin mapping phantom'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
ObjectExpression subclass: #TableExpression
	instanceVariableNames: 'table base'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
BaseExpression subclass: #JoinBaseExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
BaseExpression subclass: #SubSelectBaseExpression
	instanceVariableNames: 'trueBase'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
RelationExpression subclass: #CollectionExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
RelationExpression subclass: #SubSelectExpression
	instanceVariableNames: 'query localBase'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

GlorpExpression guid: (GUID fromString: '{62A2A737-8337-40BA-833A-D037BF61C84C}')!
GlorpExpression comment: 'This is the superclass of Glorp expression tree nodes. These are used to represent the where clause of a query, or things that describe relationships between objects and/or represent boolean expressions evaluated against them. They are typically created by converting a block into an expression using asGlorpExpression. Then they are used in generating the SQL string to be sent to the database.

Subclasses must implement the following messages:
	accessing
		canHaveBase
	api
		base
		get:withArguments:
	converting
		asJoin
	navigating
		ultimateBaseExpression
	preparing
		asExpressionJoiningSource:toTarget:
		rebuildOn:startingFrom:withOuterScopeBase:
	printing
		printOnlySelfOn:
		printTreeOn:

'!
!GlorpExpression categoriesForClass!Unclassified! !
!GlorpExpression methodsFor!

, anExpression
	^self get: #, withArguments: (Array with: anExpression asGlorpExpression).!

addBoundExpressionsIn: aQuery to: boundExpressions!

additionalExpressions

	^#().!

additionalExpressionsIn: aQuery 
	"Return the collection of additional expressions (representing joins) that this expression tree requires. Because some additional expressions may in turn have their own additional expressions (mapping joins represented by general expressions), repeat until we don't get any more."

	| allExpressions newExpressions allNewExpressions expressionsConsidered |
	allExpressions := ExpressionGroup with: self.
	allExpressions addAll: aQuery ordering.
	allExpressions add: aQuery groupBy.
	allExpressions addAll: aQuery tracing additionalExpressions.
	expressionsConsidered := IdentitySet new.
	allNewExpressions := OrderedCollection new.
	newExpressions := nil.
	[newExpressions := (newExpressions isNil ifTrue: [allExpressions] ifFalse: [newExpressions])
		inject: ExpressionGroup new 
		into: [:sum :each | 
			((expressionsConsidered includes: each) not and: [
				each queryLevelBaseExpression == aQuery baseExpression]) ifTrue: [
					sum addAll: each additionalExpressions.
					expressionsConsidered add: each].
			sum].
	allNewExpressions addAll: newExpressions children.
	newExpressions isEmpty] whileFalse.
	^allNewExpressions.!

addToTargetFields: aCollection
	"If we can provide target fields, add them to the collection"
	^self.!

allControlledTables
	"Return all the tables that we control, directly or indirectly. Basically, if we are a mapping expression with a link table, return the link table as well as any tables of ours."
	^self tables.!

allRelationsFor: rootExpression do: aBlock andBetweenDo: anotherBlock
	"In any normal relationship, there's only one thing. Just do it"
	aBlock value: rootExpression leftChild value: rootExpression rightChild.!

allSatisfy: aBlock
	"Answer true if aBlock answers true for any element of the receiver.
	 An empty collection answers false."

	self do: [:each| (aBlock value: each) ifFalse: [^false]].
	^true!

allTables

	^self inject: Set new into: [:sum :each | 
		sum addAll: each tables. sum].!

allTablesToPrint

	^self inject: Set new into: [:sum :each | 
		sum addAll: each tablesToPrint. sum].!

allTablesToPrintStoppingAt: aSubSelectBaseExpression

	^self inject: Set new into: [:sum :each | 
		each queryLevelBaseExpression == aSubSelectBaseExpression ifTrue: [
			sum addAll: each tablesToPrint]. sum].!

AND: anExpression
	"This method doesn't really have to exist, because it would be inferred using operationFor:, but it's included here for efficiency and to make it a little less confusing how relation expression get created. Note that the two expression must already be  built on the same base!!"

	anExpression isNil ifTrue: [^self].
	anExpression == true ifTrue: [^self].
	anExpression == false ifTrue: [^false].
	(anExpression isGlorpExpression and: [anExpression isEmptyExpression]) ifTrue: [^self].
	^RelationExpression named: #AND basedOn: self withArguments: (Array with: anExpression).!

AND: anExpression AND: otherExpression
	"A convenience method to allow easy conjunction of multiple ANDs at the same level"
	^(self AND: anExpression) AND: otherExpression.!

AND: anExpression AND: otherExpression AND: thirdExpression
	"A convenience method to allow easy conjunction of multiple ANDs at the same level"
	^((self AND: anExpression) AND: otherExpression) AND: thirdExpression.!

AND: anExpression AND: otherExpression AND: thirdExpression AND: fourthExpression
	"A convenience method to allow easy conjunction of multiple ANDs at the same level"
	^(((self AND: anExpression) AND: otherExpression) AND: thirdExpression) AND: fourthExpression.!

anySatisfy: aBlock
	"Answer true if aBlock answers true for any element of the receiver.
	 An empty collection answers false."

	self do: [:each| (aBlock value: each) ifTrue: [^true]].
	^false!

asDistinctFieldOn: anExpression
	^(self asGlorpExpressionOn: anExpression) get: #distinct withArguments: #().!

asExpressionJoiningSource: source toTarget: target
	"Create a general expression which represents this relationship where the values of the targets (which are normally parameters) are supplied out of the context provided by 'target' and the source fields are referencing things out of the context of source. Produces something suitable for ANDing into an expression when doing a join
   Example: If we had CUSTOMER.ADDRESS_ID = ADDRESS.ID as a parameter, and we want to AND this into an expression [:customer | customer address street = 'Main'] then we have customer as a base, and we get 
	(customer.ADDRESS.STREET = 'Main') AND (customer.CUSTOMER.ADDRESS_ID = customer.ADDRESS.ID)
	The primary key expression for the relationship has been translated into field references into the customer and address tables in a particular context."

	self subclassResponsibility.!

asField
	"If we correspond to a single field, return it"
	^self field.!

asGeneralGlorpExpression
	"Convert the result to a general (tree-format) expression, if it's the more limited join expression"
	^self.!

asGeneralGlorpExpressionWithFields
	"Convert the result to a general (tree-format) expression, if it's the more limited join expression."
	^self.!

asGlorpExpression

	^self.!

asGlorpExpressionForDescriptor: aDescriptor

	self ultimateBaseExpression descriptor: aDescriptor.!

asGlorpExpressionOn: aBaseExpression
	aBaseExpression ultimateBaseExpression == self ultimateBaseExpression
		ifTrue: [^self].
	^self rebuildOn: aBaseExpression.!

asGlorpExpressionOn: aBaseExpression basedOn: oldBaseExpression withUltimateBase: ultimateBaseExpression
	^self
		rebuildOn: aBaseExpression
		startingFrom: oldBaseExpression
		withOuterScopeBase: ultimateBaseExpression.!

asGlorpExpressionOn: aBaseExpression in: aQuery

	^self asGlorpExpressionOn: aBaseExpression.!

asGlorpExpressionOn: anExpression withUltimateBase: aBaseExpression
	"Build the expression, knowing that some parts of it may refer to an outer context based on aBaseExpression. This is primarily useful for subselect blocks"
	^self rebuildOn: anExpression startingFrom: self queryLevelBaseExpression withOuterScopeBase: aBaseExpression.!

asIndependentJoins
	"If this is an ANDed clause, split it into independent joins"
	^Array with: self.!

asJoin
	self subclassResponsibility.!

asNonDistinctField
	^self!

assignTableAliasesStartingAt: anInteger prefix: aString
	^anInteger.!

base

	self subclassResponsibility.!

beOuterJoin
	^self.!

bindingType
	^self type.!

canBeUsedForRetrieve
	"Return true if this is a valid argument for a retrieve: clause"
	^false.!

canBind
	"Return true if this represents a value that can be bound into a prepared statement"
	^false.!

canHaveBase
	"Return true if this type of expression can have a base expression on which other things can be built. Doesn't say whether we actually have a valid one or not."
	^self subclassResponsibility.!

canKnit
	"Return true if, when building objects, we can knit the object corresponding to this expression to a related object. Roughly speaking, is this a mapping expression"
	^false.!

canPrint
	"Return true if we can print into a where clause"
	^true.!

canTranslateFields
	"Return true if we are a mapping expression and can thus translate from fields into their aliased version for a particular query."
	^false.!

className

	^self class name.!

collect: aBlock

	| newCollection |
	newCollection := OrderedCollection new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^newCollection.!

condenseBooleanEquality
	^self.!

condenseBooleanEqualityExpressions
	^self.!

condensePrimaryKeyComparisons
	^self.!

detect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.
	Answer the first element for which aBlock evaluates to true."

	^self detect: aBlock ifNone: [self notFoundError]!

detect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.
	Answer the first element for which aBlock evaluates to true."

	self do: [:each | (aBlock value: each) ifTrue: [^each]].
	^exceptionBlock value!

displayString

	| stream |
	stream := String new writeStream.
	self printOnlySelfOn: stream.
	^stream contents.!

do: aBlock
	"Iterate over the expression tree"

	self do: aBlock skipping: IdentitySet new.!

do: aBlock skipping: aSet
	"Iterate over the expression tree. Keep track of who has already been visited, so we don't get trapped in cycles or visit nodes twice."

	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	aBlock value: self.!

equals: anExpression

	^RelationExpression named: #= basedOn: self withArguments: (Array with: anExpression).!

field
	^nil.!

fieldFromMeOrSubclasses
	"For mapping expression, return the field for this mapping, but if the field is not mapped, and the class uses inheritance, check for subclasses, and use a random one of the subclass mappings. For all others, just return the field."
	^self field.!

generalExpressionPart
	"If we have a mixture of joins and general expressions, return only the general part"
	^self.!

get: aSymbol withArguments: anArray

	self subclassResponsibility.!

getFunction: aSymbol withArguments: anArray

	| expression |
	expression := FunctionExpression for: aSymbol withArguments: anArray basedOn: self.
	expression isNil ifTrue: [^nil].
	^expression.!

getFunction: aSymbol withArguments: anArray in: system

	| expression |
	expression := FunctionExpression for: aSymbol withArguments: anArray basedOn: self system: system.
	expression isNil ifTrue: [^nil].
	^expression.!

hasBindableExpressionsIn: aCommand
	^false.!

hasDescriptor

	^false.!

hasImpliedClauses
	"Return true if this implies additional SQL clauses beyond just a single field expression"
	^false.!

hasProvidedAdditionalExpressions
	"Return true if we have already provided additional expressions to some query. Only important when we're preparing a subselect and don't want to bring in joins that are part of the main query"
	^true.!

hasTableAliases
	^false.!

in: anExpression

	^RelationExpression named: #IN basedOn: self withArguments: (Array with: anExpression).!

initialize!

inject: anObject into: aBlock

	| sum |
	sum := anObject.
	self do: [:each | sum := aBlock value: sum value: each].
	^sum!

inspectorHierarchies
	| hierarchy |
	hierarchy := ((Smalltalk at: #Tools ifAbsent: [^#()])
		at: #Trippy ifAbsent: [^#()])
		at: #Hierarchy ifAbsent: [^#()].
	^Array with: (hierarchy
			id: #expression
			label: 'Expression Tree'
			parentBlock: [:each | nil]
			childrenBlock: [:each | each inspectorChildren])!

inverseJoin
	"We assume that only the parts that are actually joins ought to invert"
	| new |
	new := self asGlorpExpressionOn: BaseExpression new.
	new do: [:each |
		each replaceJoinsWithInverse].
	^new.!

isConstantExpression
	^false.!

isDistinct
	^false.!

isEmptyExpression
	^false.!

isGlorpExpression
	^true.!

isJoin
	^false.!

isMappable
	"Return true if we're something that can be returned in a select statement."
	^true.!

onlyJoinParts
	"Strip out any generic parts, leaving only the things that are actually joins"
	| new |
	new := self asGlorpExpressionOn: BaseExpression new.
	new do: [:each |
		each removeNonJoinParts].
	new := new condenseBooleanEquality.
	new isJoin ifFalse: [new do: [:each | each condenseBooleanEqualityExpressions]].
	^new.!

OR: anExpression
	"This method doesn't really have to exist, because it would be inferred using operationFor:, but it's included here for efficiency and to make it a little less confusing how relation expression get created.  Note that the two expression must already be  built on the same base!!"
	anExpression isNil ifTrue: [^self].	
	anExpression == true ifTrue: [^true].
	anExpression == false ifTrue: [^self].
	(anExpression isGlorpExpression and: [anExpression isEmptyExpression]) ifTrue: [^self].
	^RelationExpression named: #OR basedOn: self withArguments: (Array with: anExpression).!

parameter: aConstantExpression
	"Create a parameter expression with the given name. But note that the name doesn't have to be a string. Database fields, symbols, and integers are all plausible"
	| value |
	value := aConstantExpression class == ParameterExpression ifTrue: [aConstantExpression field] ifFalse: [aConstantExpression value].
	^ParameterExpression forField: value basedOn: self.!

prepareIn: aQuery
	"A little weird, because what we end up asking for additional expressions from, might not be us"

	aQuery adjustWhereClause.
	(aQuery whereClause additionalExpressionsIn: aQuery)
		do:
			[:each | 
			(aQuery shouldExpressionBeJoin: each)
				ifTrue: [aQuery addJoin: each]
				ifFalse: [aQuery privateAnd: each]].!

primaryKeyFromDictionary: aDictionary
	"Given a set of parameters, return a primary key suitable for retrieving our target. We can't do this for general expressions, so indicate failure by returning nil"
	^nil.!

printOn: aStream 
	self printTreeOn: aStream!

printOnlySelfOn: aStream
	self subclassResponsibility.!

printsTable

	^false.!

printTreeOn: aStream

	self subclassResponsibility.!

queryLevelBaseExpression
	^self ultimateBaseExpression!

rebuildOn: aBaseExpression
	^self rebuildOn: aBaseExpression startingFrom: nil.!

rebuildOn: aBaseExpression startingFrom: anExpression
	"Rebuild the expression on the new base. If we encounter anExpression, treat that as the base, and build only from that point up. e.g. if we have a.b.c.d and we rebuildOn: z startingFrom: b, then the result will be z.c.d"
	^self rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: nil.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	"Rebuild the expression on the new base. If we encounter anExpression, treat that as the base, and build only from that point up. e.g. if we have a.b.c.d and we rebuildOn: z startingFrom: b, then the result will be z.c.d. Pieces that aren't based on anExpression should be built onto ultimateBaseExpression instead of aBaseExpression. They represents parts of outer scope trees that are referenced within us.
  Note that anExpression can be nil, but if it is, then ultimateBaseExpression is effectively ignored."
	self subclassResponsibility.!

removeNonJoinParts
	"Remove anything that's not an actual join. Only useful if we have something that has mixed joins and general expressions, where we assume we don't want to use the general ones, because they're not field level."
	^self.!

replaceJoinsWithInverse
	"If we don't know specifically what to do with a kind of expression, assume it doesn't apply and we should be replacing it with nothing."
	^self.!

representsDerivedObject
	^false.!

requiresDistinct
	^false.!

returnsDictionary
	"Return true if we representa  ampping to a dictionary"
	^false.!

rewriteBooleanEquality: relation
	"Does not apply to general expressions"!

rewriteEquality
	^self.!

rewriteEqualityExpressions
	^self.!

rewriteFunctionArguments
	"If a function needs to adjust its arguments, do that here. The motivating example is one where a string argument is rewritten into a form that's of a different length, e.g. the Postgresql driver does that to strings in Blobs"
	^self.!

rewriteFunctionArgumentsWith: ourArgument
	"If a function needs to adjust its arguments, do that here. The motivating example is one where a string argument is rewritten into a form that's of a different length, e.g. the Postgresql driver does that to strings in Blobs"
	^self.!

select: aBlock

	| newCollection |
	newCollection := OrderedCollection new.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection!

sharedPiecesWith: anExpression
	"Return a set of the pieces we share in common with anExpression. Mostly useful for debugging unwanted sharing, or the lack of wanted sharing. Note that this won't dive down into subselects."
	| myPieces shared |
	myPieces := IdentitySet new.
	shared := IdentitySet new.
	self do: [:each | myPieces add: each].
	anExpression do: [:each | (myPieces includes: each) ifTrue: [shared add: each]].
	^shared.!

shortCircuitOnNullComparison: anObject
	"Return true if we represent an expression that compares null to a non-nullable value, so we don't ever need to really evaluate it"

	^false.!

sourceForTarget: aField

	^nil.!

tableForANSIJoin
	"Which table will we join to."
	^nil.!

tables

	^#().!

tablesContainingMe
	"Return a list of tables that contain this object, whether or not we control them. This is mostly the same as tables, but will differ for embedded mappings."
	^self tables.!

tablesToPrint

	^#().!

type
	^self field type.!

ultimateBaseExpression
	self subclassResponsibility.!

validate!

valueIn: aDictionary
	"Return the value associated with this expression given the parameters in aDictionary. Only meaningful for ParameterExpressions"

	^self.!

willPrintAsWhereClause
	^true.! !
!GlorpExpression categoriesFor: #,!api!private! !
!GlorpExpression categoriesFor: #addBoundExpressionsIn:to:!preparing!private! !
!GlorpExpression categoriesFor: #additionalExpressions!preparing!private! !
!GlorpExpression categoriesFor: #additionalExpressionsIn:!preparing!private! !
!GlorpExpression categoriesFor: #addToTargetFields:!preparing!private! !
!GlorpExpression categoriesFor: #allControlledTables!preparing!private! !
!GlorpExpression categoriesFor: #allRelationsFor:do:andBetweenDo:!preparing!private! !
!GlorpExpression categoriesFor: #allSatisfy:!iterating!private! !
!GlorpExpression categoriesFor: #allTables!preparing!private! !
!GlorpExpression categoriesFor: #allTablesToPrint!preparing!private! !
!GlorpExpression categoriesFor: #allTablesToPrintStoppingAt:!preparing!private! !
!GlorpExpression categoriesFor: #AND:!api!private! !
!GlorpExpression categoriesFor: #AND:AND:!api!private! !
!GlorpExpression categoriesFor: #AND:AND:AND:!api!private! !
!GlorpExpression categoriesFor: #AND:AND:AND:AND:!api!private! !
!GlorpExpression categoriesFor: #anySatisfy:!iterating!private! !
!GlorpExpression categoriesFor: #asDistinctFieldOn:!converting!private! !
!GlorpExpression categoriesFor: #asExpressionJoiningSource:toTarget:!preparing!private! !
!GlorpExpression categoriesFor: #asField!converting!private! !
!GlorpExpression categoriesFor: #asGeneralGlorpExpression!converting!private! !
!GlorpExpression categoriesFor: #asGeneralGlorpExpressionWithFields!converting!private! !
!GlorpExpression categoriesFor: #asGlorpExpression!api!private! !
!GlorpExpression categoriesFor: #asGlorpExpressionForDescriptor:!converting!private! !
!GlorpExpression categoriesFor: #asGlorpExpressionOn:!converting!private! !
!GlorpExpression categoriesFor: #asGlorpExpressionOn:basedOn:withUltimateBase:!converting!private! !
!GlorpExpression categoriesFor: #asGlorpExpressionOn:in:!converting!private! !
!GlorpExpression categoriesFor: #asGlorpExpressionOn:withUltimateBase:!converting!private! !
!GlorpExpression categoriesFor: #asIndependentJoins!converting!private! !
!GlorpExpression categoriesFor: #asJoin!converting!private! !
!GlorpExpression categoriesFor: #asNonDistinctField!converting!private! !
!GlorpExpression categoriesFor: #assignTableAliasesStartingAt:prefix:!preparing!private! !
!GlorpExpression categoriesFor: #base!api!private! !
!GlorpExpression categoriesFor: #beOuterJoin!accessing!private! !
!GlorpExpression categoriesFor: #bindingType!preparing!private! !
!GlorpExpression categoriesFor: #canBeUsedForRetrieve!private!testing! !
!GlorpExpression categoriesFor: #canBind!private!testing! !
!GlorpExpression categoriesFor: #canHaveBase!accessing!private! !
!GlorpExpression categoriesFor: #canKnit!private!testing! !
!GlorpExpression categoriesFor: #canPrint!private!testing! !
!GlorpExpression categoriesFor: #canTranslateFields!private!testing! !
!GlorpExpression categoriesFor: #className!printing!private! !
!GlorpExpression categoriesFor: #collect:!iterating!private! !
!GlorpExpression categoriesFor: #condenseBooleanEquality!preparing!private! !
!GlorpExpression categoriesFor: #condenseBooleanEqualityExpressions!preparing!private! !
!GlorpExpression categoriesFor: #condensePrimaryKeyComparisons!preparing!private! !
!GlorpExpression categoriesFor: #detect:!iterating!private! !
!GlorpExpression categoriesFor: #detect:ifNone:!iterating!private! !
!GlorpExpression categoriesFor: #displayString!printing!private! !
!GlorpExpression categoriesFor: #do:!iterating!public! !
!GlorpExpression categoriesFor: #do:skipping:!iterating!private! !
!GlorpExpression categoriesFor: #equals:!api!private! !
!GlorpExpression categoriesFor: #field!accessing!private! !
!GlorpExpression categoriesFor: #fieldFromMeOrSubclasses!accessing!private! !
!GlorpExpression categoriesFor: #generalExpressionPart!converting!private! !
!GlorpExpression categoriesFor: #get:withArguments:!api!private! !
!GlorpExpression categoriesFor: #getFunction:withArguments:!api!private! !
!GlorpExpression categoriesFor: #getFunction:withArguments:in:!api!private! !
!GlorpExpression categoriesFor: #hasBindableExpressionsIn:!preparing!private! !
!GlorpExpression categoriesFor: #hasDescriptor!accessing!private! !
!GlorpExpression categoriesFor: #hasImpliedClauses!private!testing! !
!GlorpExpression categoriesFor: #hasProvidedAdditionalExpressions!private!testing! !
!GlorpExpression categoriesFor: #hasTableAliases!private!testing! !
!GlorpExpression categoriesFor: #in:!initialize!private! !
!GlorpExpression categoriesFor: #initialize!initialize!private! !
!GlorpExpression categoriesFor: #inject:into:!iterating!private! !
!GlorpExpression categoriesFor: #inspectorHierarchies!inspecting!private! !
!GlorpExpression categoriesFor: #inverseJoin!converting!private! !
!GlorpExpression categoriesFor: #isConstantExpression!private!testing! !
!GlorpExpression categoriesFor: #isDistinct!private!testing! !
!GlorpExpression categoriesFor: #isEmptyExpression!private!testing! !
!GlorpExpression categoriesFor: #isGlorpExpression!private!testing! !
!GlorpExpression categoriesFor: #isJoin!private!testing! !
!GlorpExpression categoriesFor: #isMappable!private!testing! !
!GlorpExpression categoriesFor: #onlyJoinParts!converting!private! !
!GlorpExpression categoriesFor: #OR:!api!private! !
!GlorpExpression categoriesFor: #parameter:!api!private! !
!GlorpExpression categoriesFor: #prepareIn:!preparing!private! !
!GlorpExpression categoriesFor: #primaryKeyFromDictionary:!primary keys!private! !
!GlorpExpression categoriesFor: #printOn:!printing!private! !
!GlorpExpression categoriesFor: #printOnlySelfOn:!printing!private! !
!GlorpExpression categoriesFor: #printsTable!accessing!private! !
!GlorpExpression categoriesFor: #printTreeOn:!printing!private! !
!GlorpExpression categoriesFor: #queryLevelBaseExpression!navigating!private! !
!GlorpExpression categoriesFor: #rebuildOn:!converting!private! !
!GlorpExpression categoriesFor: #rebuildOn:startingFrom:!preparing!private! !
!GlorpExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!GlorpExpression categoriesFor: #removeNonJoinParts!preparing!private! !
!GlorpExpression categoriesFor: #replaceJoinsWithInverse!preparing!private! !
!GlorpExpression categoriesFor: #representsDerivedObject!private!testing! !
!GlorpExpression categoriesFor: #requiresDistinct!private!private/accessing! !
!GlorpExpression categoriesFor: #returnsDictionary!private!testing! !
!GlorpExpression categoriesFor: #rewriteBooleanEquality:!preparing!private! !
!GlorpExpression categoriesFor: #rewriteEquality!preparing!private! !
!GlorpExpression categoriesFor: #rewriteEqualityExpressions!preparing!private! !
!GlorpExpression categoriesFor: #rewriteFunctionArguments!preparing!private! !
!GlorpExpression categoriesFor: #rewriteFunctionArgumentsWith:!preparing!private! !
!GlorpExpression categoriesFor: #select:!iterating!private! !
!GlorpExpression categoriesFor: #sharedPiecesWith:!debugging!public! !
!GlorpExpression categoriesFor: #shortCircuitOnNullComparison:!private!testing! !
!GlorpExpression categoriesFor: #sourceForTarget:!converting!private! !
!GlorpExpression categoriesFor: #tableForANSIJoin!preparing!private! !
!GlorpExpression categoriesFor: #tables!preparing!private! !
!GlorpExpression categoriesFor: #tablesContainingMe!preparing!private! !
!GlorpExpression categoriesFor: #tablesToPrint!preparing!private! !
!GlorpExpression categoriesFor: #type!accessing!private! !
!GlorpExpression categoriesFor: #ultimateBaseExpression!navigating!private! !
!GlorpExpression categoriesFor: #validate!preparing!private! !
!GlorpExpression categoriesFor: #valueIn:!accessing!private! !
!GlorpExpression categoriesFor: #willPrintAsWhereClause!private!testing! !

!GlorpExpression class methodsFor!

new

	^super new initialize.! !
!GlorpExpression class categoriesFor: #new!instance creation!private! !

GlorpExpressionsPackage guid: (GUID fromString: '{C29FF0E7-B769-4A21-83D9-1C913EF5C78C}')!
GlorpExpressionsPackage comment: 'This class represents package information for the GlorpExpressions package, for systems that don''t have things like package properties to store things like copyright and license information.

LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you''ll need to release the
source of any modifications.

If you require any further clarification, we''d be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'!
!GlorpExpressionsPackage categoriesForClass!Unclassified! !
!GlorpExpressionsPackage class methodsFor!

LICENSE
"LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you'll need to release the
source of any modifications.

If you require any further clarification, we'd be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"! !
!GlorpExpressionsPackage class categoriesFor: #LICENSE!instance creation!public! !

Join guid: (GUID fromString: '{5C4A09B5-23D3-48EC-9BD2-E5B46FB348DA}')!
Join comment: 'This is a specialized variety of expression that is more constrained and is used for defining relationships. It has two main purposes
 - ease of construction: Relationships are normally defined by field to field equality expressions (my foreign key field = his primary key field). These are more tedious to create via block expressions, so this provides a simpler syntax.
 - constrained semantics. These define both read and write for the relationship, so fully general expressions won''t work (most notably, relations other than equality are hard to write). Using a primaryKeyExpression ensures that we satisfy these constraints.

I''m not completely sure this class is a good idea. It makes for an annoying assymetry between different kinds of expressions. This is especially notable now that we allow sources to be constants. It''s possible that all we need is an expression constructor that generates real expressions, but with more convenient syntax and ensuring that the constraints are met.

Note that although these are typically fk=pk, it''s allowed to be the other way around -- i.e. our object-level relationships can be the opposite of the way the fk''s "point" in the database.

Instance Variables:
	base	<BaseExpression>	The base on which we are built. Mostly used if we want to convert this into a real expression.
	sources	<SequenceableCollection of: (DatabaseField | ConstantExpression)> The source fields (typically the foreign keys)
	targets	<SequenceableCollection of: DatabaseField> The target fields (typically the targets of the foreign keys)

'!
!Join categoriesForClass!Unclassified! !
!Join methodsFor!

, aJoin
	| newJoin |
	aJoin isNil ifTrue: [^self].
	aJoin == self ifTrue: [^self].
	newJoin := (self class fromAll: (sources, aJoin allSourceFields) toAll: (targets, aJoin targetKeys)) removeDuplicates.
	"If either one of the contributors is an outer join, make the result be an outer join"
	newJoin outerJoin: (self outerJoin | aJoin outerJoin).
	^newJoin!

= aJoin
	aJoin class == self class ifFalse: [^false].
	aJoin allSourceFields = sources ifFalse: [^false].
	aJoin allTargetFields = targets ifFalse: [^false].
	^true.!

additionalExpressions
	^#()!

additionalExpressionsIn: aQuery 
	^#()!

addToTargetFields: aCollection
	"If we can provide target fields, add them to the collection"
	aCollection addAll: targets.!

allControlledTables

	^self allTables.!

allSourceFields

	^sources!

allTables

	^(targets collect: [:each | each table]) asSet.!

allTablesToPrint

	^targets inject: Set new into: [:sum :each | 
		sum add: each table. sum].!

allTargetFields

	^targets!

asExpressionJoiningSource: source toTarget: target
	"Create a general expression which represents this relationship where the values of the targets (which are normally parameters) are supplied out of the context provided by 'target' and the source fields are referencing things out of the context of source. Produces something suitable for ANDing into an expression when doing a join
   Example: If we had CUSTOMER.ADDRESS_ID = ADDRESS.ID as a parameter, and we want to AND this into an expression [:customer | customer address street = 'Main'] then we have customer as a base, and we get 
	(customer.ADDRESS.STREET = 'Main') AND (customer.CUSTOMER.ADDRESS_ID = customer.ADDRESS.ID)
	The primary key expression for the relationship has been translated into field references into the customer and address tables in a particular context."

	| sourceFieldExpression targetFieldExpression completeExpression relationExpression |
	completeExpression := EmptyExpression new base: base.
	sources with: targets
		do: 	[:sourceField :targetField | 
			sourceFieldExpression := source getFieldKnownNotToBeAName: sourceField.
			targetFieldExpression := target getFieldKnownNotToBeAName: targetField.
			relationExpression := sourceFieldExpression equals: targetFieldExpression.
			completeExpression := relationExpression AND: completeExpression].
	outerJoin ifTrue: [completeExpression beOuterJoin].
	^completeExpression!

asGeneralGlorpExpression
	"Convert this to a 'normal' expression representing the same information"

	| main clause |
	main := EmptyExpression new base: base.
	sources with: targets
		do: 
			[:eachSource :eachTarget | 
			| srcExp targetExp |
			srcExp := self sourceExpressionFor: eachSource.
			targetExp := self targetExpressionFor: eachTarget.
			"Reversing the order is important because the source is the parameter, and sql won't accept '27 = FOO' "
			clause := targetExp equals: srcExp.
			main := main AND: clause].
	outerJoin ifTrue: [main beOuterJoin].
	^main!

asGeneralGlorpExpressionWithFields
	"The normal conversion of a join is to an expression equating fields and parameters. Instead, generate one with field to field comparisons"

	| main clause |
	main := nil.
	sources with: targets
		do: 
			[:eachSource :eachTarget | 
			| srcExp targetExp |
			srcExp := self targetExpressionFor: eachSource.
			targetExp := self targetExpressionFor: eachTarget.
			clause := srcExp equals: targetExp.
			main := main == nil ifTrue: [clause] ifFalse: [main AND: clause]].
	outerJoin ifTrue: [main beOuterJoin].
	^main!

asGlorpExpression

	^self.!

asGlorpExpressionForDescriptor: aDescriptor

	base descriptor: aDescriptor.!

asGlorpExpressionOn: aBaseExpression
	| copy |
	copy := self copy.
	copy base: aBaseExpression.
	copy outerJoin: outerJoin.
	^copy.!

asOuterJoin
	^self copy beOuterJoin.!

base
	^base.!

base: aBaseExpression
	base := aBaseExpression.!

beOuterJoin
	outerJoin := true.!

do: aBlock skipping: aSet
	"Joins act as if they don't have children, and just evaluate for themselves"
	| |
	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	aBlock value: self.!

fieldsDo: aBlock

	sources with: targets do: aBlock.!

from: aField to: anotherField

	^self addSource: aField target: anotherField.!

generalExpressionPart
	^nil.!

hasDescriptor

	^false.!

initialize

	sources := OrderedCollection new: 2.
	targets := OrderedCollection new: 2.
	base := BaseExpression new.
	outerJoin := false.!

inverseJoin
	| inverse |
	inverse := self class new
		base: base;
		sourceFields: targets
		targetFields: sources.
	inverse owningMapping: self owningMapping.
	^inverse.!

isEmptyExpression
	^sources isEmpty.!

isGlorpExpression
	^true.!

isJoin
	^true.!

isOuterJoin
	^outerJoin.!

mappableFieldsDo: aBlock

	sources with: targets do: [:source :target |
		source isMappable ifTrue: [aBlock value: source value: target]].!

mappableSourceFieldsDo: aBlock

	sources do: [:source  |
		source isMappable ifTrue: [aBlock value: source]].!

numberOfParameters
	^sources size!

onlyJoinParts
	"Strip out any generic parts, leaving only the things that are actually joins"
	
	^self.!

outerJoin
	^outerJoin.!

outerJoin: aBoolean
	outerJoin := aBoolean.!

owningMapping
	"Return the mapping (if there is one) that is responsible for. Not needed for the code, but might be a useful debugging aid if trying to figure out where a @#%#@% join came from"
	^owningMapping.!

owningMapping: aMapping
	owningMapping := aMapping.!

prepareIn: aQuery 
	"Do nothing."
	aQuery whereClause: (self asGeneralGlorpExpression).
	aQuery whereClause prepareIn: aQuery.!

primaryKeyFromDictionary: aDictionary
	"Given a set of parameters, return a primary key suitable for retrieving our target. Return either a value for the key, nil for no key found, or an array for compound keys."
	
	sources size = 1 ifTrue: [^aDictionary at: sources first ifAbsent: [nil]].
	^sources collect: [:each | aDictionary at: each ifAbsent: [nil]].!

printOn: aStream

	sources with: targets do: [:source :target |
		aStream nextPut: $(.
		source printSQLOn: aStream withParameters: #().
		aStream nextPutAll: ' = '.
		target printSQLOn: aStream withParameters: #().
		aStream nextPutAll: ') ']!

printSQLOn: aStream withParameters: aDictionary 
	1 to: sources size
		do: 
			[:i | 
			| eachTarget eachSource sourceValue |
			eachTarget := targets at: i.
			eachSource := sources at: i.
			eachTarget printSQLOn: aStream withParameters: aDictionary.
			sourceValue := (self isConstant: eachSource) ifTrue: [eachSource value] ifFalse: [aDictionary at: eachSource].
			sourceValue isNil 
				ifTrue: [aStream nextPutAll: ' IS NULL ']
				ifFalse: 
					[aStream nextPutAll: ' = '.
					sourceValue printOn: aStream].
			i = targets size ifFalse: [aStream nextPutAll: ' AND ']]!

queryLevelBaseExpression
	^self ultimateBaseExpression.!

rebuildOn: aGlorpMappingExpression 
	^self asGlorpExpressionOn: aGlorpMappingExpression.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	^self asGlorpExpressionOn: aBaseExpression.!

removeDuplicates
	| existing newSources newTargets |
	existing := Set new.
	newSources := OrderedCollection new: sources size.
	newTargets := OrderedCollection new: targets size.
	sources
		with: targets
		do:
			[:eachSource :eachTarget | 
			| association |
			association := eachSource -> eachTarget.
			(existing includes: association)
				ifFalse:
					[existing add: association.
					newSources add: eachSource.
					newTargets add: eachTarget]].
	sources := newSources.
	targets := newTargets.!

removeNonJoinParts
	"Remove anything that's not an actual join. Only useful if we have something that has mixed joins and general expressions, where we assume we don't want to use the general ones, because they're not field level."
	^self.!

replaceJoinsWithInverse
	"Replace any actual Join objects we have with their inverse. Only useful if we have something that has mixed joins and general expressions, where we assume we don't want to mess with the general ones, because they're not field-level. As actual joins, we ignore this, because it will be done at the parent level"
	^self.!

replacing: aTable withEquivalenceFrom: aJoin
	"Create a new join in which references to fields in aTable have been replaced with the equivalent based on a Join (we assume that aTable references are in the sources of aJoin). If the field doesn't occur in the translation, just remove it"
	| newSources newTargets newSource |
	newSources := OrderedCollection new.
	newTargets := OrderedCollection new.
	self fieldsDo: [:eachSource :eachTarget |
		(eachSource isGlorpExpression not and: [eachSource table = aTable])
			ifTrue: [
				newSource := aJoin targetForSource: eachSource.
				newSource isNil ifFalse: [
					newSources add: newSource.
					newTargets add: eachTarget]]].
	^self class fromAll: newSources toAll: newTargets.!

shortCircuitOnNullComparison: parameters
	"Return true if we represent an expression that compares null to a non-nullable value (in any of our clauses), so we don't ever need to really evaluate it"

	self fieldsDo: [:source :target |
		(target isNullable not and: [(parameters at: source) isNil]) ifTrue: [^true]].
	^false.!

sourceExpressionFor: source
	
	^((self isConstant: source) or: [source isMappable not]) "This might be a subselect"
		ifTrue: [source]
		ifFalse: [base getParameter: source].!

sourceFields: sourceFields targetFields: targetFields
	sources := sourceFields.
	targets := targetFields.!

sourceForTarget: aField

	| index |
	index := targets indexOf: aField.
	index = 0 ifTrue: [^nil].
	^sources at: index.!

targetExpressionFor: eachTarget 
	^(self isConstant: eachTarget)
		ifTrue: [eachTarget]
		ifFalse: [
			eachTarget isGlorpExpression 
			ifTrue: [eachTarget] 
			ifFalse: [(base getTable: eachTarget table) getField: eachTarget]].!

targetForSource: aField

	| index |
	index := sources indexOf: aField.
	index = 0 ifTrue: [^nil].
	^targets at: index.!

targetKeys

	^targets.!

ultimateBaseExpression

	^base ultimateBaseExpression.! !
!Join categoriesFor: #,!converting!private! !
!Join categoriesFor: #=!comparing!private! !
!Join categoriesFor: #additionalExpressions!preparing!private! !
!Join categoriesFor: #additionalExpressionsIn:!preparing!private! !
!Join categoriesFor: #addToTargetFields:!preparing!private! !
!Join categoriesFor: #allControlledTables!accessing!private! !
!Join categoriesFor: #allSourceFields!accessing!private! !
!Join categoriesFor: #allTables!accessing!private! !
!Join categoriesFor: #allTablesToPrint!preparing!private! !
!Join categoriesFor: #allTargetFields!accessing!private! !
!Join categoriesFor: #asExpressionJoiningSource:toTarget:!converting!private! !
!Join categoriesFor: #asGeneralGlorpExpression!converting!private! !
!Join categoriesFor: #asGeneralGlorpExpressionWithFields!converting!private! !
!Join categoriesFor: #asGlorpExpression!api!private! !
!Join categoriesFor: #asGlorpExpressionForDescriptor:!api!private! !
!Join categoriesFor: #asGlorpExpressionOn:!api!private! !
!Join categoriesFor: #asOuterJoin!api!private! !
!Join categoriesFor: #base!accessing!private! !
!Join categoriesFor: #base:!accessing!private! !
!Join categoriesFor: #beOuterJoin!api!private! !
!Join categoriesFor: #do:skipping:!iterating!private! !
!Join categoriesFor: #fieldsDo:!iterating!private! !
!Join categoriesFor: #from:to:!accessing!private! !
!Join categoriesFor: #generalExpressionPart!converting!private! !
!Join categoriesFor: #hasDescriptor!accessing!private! !
!Join categoriesFor: #initialize!initialize!private! !
!Join categoriesFor: #inverseJoin!converting!private! !
!Join categoriesFor: #isEmptyExpression!private!testing! !
!Join categoriesFor: #isGlorpExpression!private!testing! !
!Join categoriesFor: #isJoin!private!testing! !
!Join categoriesFor: #isOuterJoin!private!testing! !
!Join categoriesFor: #mappableFieldsDo:!iterating!private! !
!Join categoriesFor: #mappableSourceFieldsDo:!iterating!private! !
!Join categoriesFor: #numberOfParameters!accessing!private! !
!Join categoriesFor: #onlyJoinParts!preparing!private! !
!Join categoriesFor: #outerJoin!accessing!private! !
!Join categoriesFor: #outerJoin:!accessing!private! !
!Join categoriesFor: #owningMapping!debugging!private! !
!Join categoriesFor: #owningMapping:!debugging!private! !
!Join categoriesFor: #prepareIn:!preparing!private! !
!Join categoriesFor: #primaryKeyFromDictionary:!primary keys!private! !
!Join categoriesFor: #printOn:!printing!private! !
!Join categoriesFor: #printSQLOn:withParameters:!printing!private! !
!Join categoriesFor: #queryLevelBaseExpression!accessing!private! !
!Join categoriesFor: #rebuildOn:!As yet unclassified!private! !
!Join categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!Join categoriesFor: #removeDuplicates!converting!private! !
!Join categoriesFor: #removeNonJoinParts!preparing!private! !
!Join categoriesFor: #replaceJoinsWithInverse!preparing!private! !
!Join categoriesFor: #replacing:withEquivalenceFrom:!converting!private! !
!Join categoriesFor: #shortCircuitOnNullComparison:!private!testing! !
!Join categoriesFor: #sourceExpressionFor:!converting!private! !
!Join categoriesFor: #sourceFields:targetFields:!initialize!private! !
!Join categoriesFor: #sourceForTarget:!preparing!private! !
!Join categoriesFor: #targetExpressionFor:!converting!private! !
!Join categoriesFor: #targetForSource:!preparing!private! !
!Join categoriesFor: #targetKeys!accessing!private! !
!Join categoriesFor: #ultimateBaseExpression!accessing!private! !

!Join class methodsFor!

from: aField to: anotherField

	^self new
		addSource: aField target: anotherField.!

from: from1Field to: to1Field
from: from2Field to: to2Field

	^self new
		addSource: from1Field target: to1Field;
		addSource: from2Field target: to2Field.!

from: from1Field to: to1Field
from: from2Field to: to2Field
from: from3Field to: to3Field

	^self new
		addSource: from1Field target: to1Field;
		addSource: from2Field target: to2Field;
		addSource: from3Field target: to3Field.!

from: from1Field to: to1Field
from: from2Field to: to2Field
from: from3Field to: to3Field
from: from4Field to: to4Field

	^self new
		addSource: from1Field target: to1Field;
		addSource: from2Field target: to2Field;
		addSource: from3Field target: to3Field;		
		addSource: from4Field target: to4Field!

from: from1Field to: to1Field
from: from2Field to: to2Field
from: from3Field to: to3Field
from: from4Field to: to4Field
from: from5Field to: to5Field

	^self new
		addSource: from1Field target: to1Field;
		addSource: from2Field target: to2Field;
		addSource: from3Field target: to3Field;		
		addSource: from4Field target: to4Field;
		addSource: from5Field target: to5Field.!

fromAll: sourceFields toAll: targetFields

	^self new
		sourceFields: sourceFields targetFields: targetFields.!

new

	^super new initialize.! !
!Join class categoriesFor: #from:to:!instance creation!private! !
!Join class categoriesFor: #from:to:from:to:!instance creation!private! !
!Join class categoriesFor: #from:to:from:to:from:to:!instance creation!private! !
!Join class categoriesFor: #from:to:from:to:from:to:from:to:!instance creation!private! !
!Join class categoriesFor: #from:to:from:to:from:to:from:to:from:to:!instance creation!private! !
!Join class categoriesFor: #fromAll:toAll:!instance creation!private! !
!Join class categoriesFor: #new!instance creation!private! !

VariableJoin guid: (GUID fromString: '{A2C711A1-67F7-436A-BBDB-C87952B2165E}')!
VariableJoin comment: 'This represents a join that could be to multiple different tables, e.g. when using horizontal inheritance.

Instance Variables:
	joins	<Dictionary from: Class to: Join>	description of joins

'!
!VariableJoin categoriesForClass!Unclassified! !
!VariableJoin methodsFor!

addJoinFor: aClass as: aJoin
	joins at: aClass put: aJoin.!

allSourceFields
	"We assume that variable joins vary in the targets, not the in sources."
	^self anyJoin allSourceFields!

allTargetFields
	^joins inject: OrderedCollection new into: [:sum :each | sum addAll: each allTargetFields. sum].!

anyJoin
	^joins detect: [:each | true].!

asGeneralGlorpExpression
	"We know that we represent querying for an abstract class, so we don't want to convert ourselves to a join form, but rather just to a source mapping form. There are some assumptions in here, but it should work for the basic cases anyway."
	| base expression anyJoin descriptor |
	anyJoin := self anyJoin.
	base := anyJoin base.
	descriptor := base system descriptorForTable: anyJoin allTargetFields first table.
	expression := EmptyExpression new base: base.
	anyJoin mappableFieldsDo: [:source :target |
		| mapping thingToCompare |
		mapping := descriptor mappingForField: target.
		thingToCompare := mapping isNil
			ifTrue: [base getField: target]
			ifFalse: [base get: mapping attributeName].
		expression := expression AND: (thingToCompare get: #= withArguments: (Array with: (source asGlorpExpressionOn: base)))].
	^expression.!

asGeneralGlorpExpressionWithFields
	"The normal conversion of a join is to an expression equating fields and parameters. Instead, generate one with field to field comparisons. "
	| base expression mappingName anyJoin descriptor |
	anyJoin := self anyJoin.
	base := anyJoin base.
	descriptor := base system descriptorForTable: anyJoin allTargetFields first table.
	expression := EmptyExpression new base: base.
	anyJoin mappableFieldsDo: [:source :target |
		mappingName := (descriptor mappingForField: target) attributeName.
		expression := expression AND: ((base get: mappingName) get: #= withArguments: (Array with: (self targetExpressionFor: source)))].
	^expression.!

asGlorpExpressionOn: aBaseExpression
	| copy |
	copy := self copy.
	copy joins: (copy joins collect: [:each | each asGlorpExpressionOn: aBaseExpression]).
	^copy.!

generalExpressionPart
	^nil.!

initialize
	joins := IdentityDictionary new.!

isConstant: aTarget
	"The target can be either a constant (which gets turned into a ConstantExpression) or (usually) a DatabaseField, representing a parameter to the query"

	aTarget isDatabaseField ifTrue: [^false].
	(aTarget isGlorpExpression and: [aTarget isConstantExpression not]) ifTrue: [^false].
	^true!

isGlorpExpression
	^true.!

isJoin
	^true.!

joins
	^joins.!

joins: aCollection
	joins := aCollection.!

mapFromSource: sourceObject andTarget: targetObject intoRowsIn: aRowMap
	(sourceObject isNil or: [targetObject isNil]) ifTrue: [^self].
	^(joins at: targetObject class)
		mapFromSource: sourceObject
		andTarget: targetObject
		intoRowsIn: aRowMap.!

mappableSourceFieldsDo: aBlock

	self anyJoin mappableSourceFieldsDo: aBlock.!

prepareIn: aQuery!

primaryKeyFromDictionary: anIdentityDictionary 
	^self anyJoin primaryKeyFromDictionary: anIdentityDictionary.!

printOn: aStream
	[aStream query] on: Error do: [:ex | ^super printOn: aStream].
	(joins at: aStream query resultClass) printOn: aStream.!

printSQLOn: aStream withParameters: aDictionary 
	[aStream query] on: Error do: [:ex | ^super printOn: aStream].
	(joins at: aStream query resultClass) printSQLOn: aStream withParameters: aDictionary.!

queryLevelBaseExpression
	^self ultimateBaseExpression.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	^(self joins at: aBaseExpression descriptor describedClass) 
		rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression!

shortCircuitOnNullComparison: anIdentityDictionary 
	joins do: [:each |
		(each shortCircuitOnNullComparison: anIdentityDictionary)
			ifFalse: [^false]].
	^true.!

targetExpressionFor: eachTarget 
	^(self isConstant: eachTarget)
		ifTrue: [eachTarget]
		ifFalse: [
			eachTarget isGlorpExpression 
			ifTrue: [eachTarget] 
			ifFalse: [(self anyJoin base getTable: eachTarget table) getField: eachTarget]].!

ultimateBaseExpression

	^self anyJoin base.! !
!VariableJoin categoriesFor: #addJoinFor:as:!accessing!private! !
!VariableJoin categoriesFor: #allSourceFields!accessing!private! !
!VariableJoin categoriesFor: #allTargetFields!accessing!private! !
!VariableJoin categoriesFor: #anyJoin!accessing!private! !
!VariableJoin categoriesFor: #asGeneralGlorpExpression!converting!private! !
!VariableJoin categoriesFor: #asGeneralGlorpExpressionWithFields!converting!private! !
!VariableJoin categoriesFor: #asGlorpExpressionOn:!converting!private! !
!VariableJoin categoriesFor: #generalExpressionPart!accessing!private! !
!VariableJoin categoriesFor: #initialize!initialize-release!private! !
!VariableJoin categoriesFor: #isConstant:!converting!public! !
!VariableJoin categoriesFor: #isGlorpExpression!private!testing! !
!VariableJoin categoriesFor: #isJoin!private!testing! !
!VariableJoin categoriesFor: #joins!accessing!private! !
!VariableJoin categoriesFor: #joins:!accessing!private! !
!VariableJoin categoriesFor: #mapFromSource:andTarget:intoRowsIn:!api!private! !
!VariableJoin categoriesFor: #mappableSourceFieldsDo:!accessing!private! !
!VariableJoin categoriesFor: #prepareIn:!preparing!private! !
!VariableJoin categoriesFor: #primaryKeyFromDictionary:!As yet unclassified!private! !
!VariableJoin categoriesFor: #printOn:!printing!private! !
!VariableJoin categoriesFor: #printSQLOn:withParameters:!printing!private! !
!VariableJoin categoriesFor: #queryLevelBaseExpression!accessing!private! !
!VariableJoin categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!VariableJoin categoriesFor: #shortCircuitOnNullComparison:!As yet unclassified!private! !
!VariableJoin categoriesFor: #targetExpressionFor:!converting!private! !
!VariableJoin categoriesFor: #ultimateBaseExpression!accessing!private! !

!VariableJoin class methodsFor!

new
	^super new initialize.! !
!VariableJoin class categoriesFor: #new!instance creation!private! !

ConstantExpression guid: (GUID fromString: '{A770BAD0-D311-4ADF-992F-6A60CA8DFCE3}')!
ConstantExpression comment: 'This represents a literal constant. So, if object field = 2, this would be the (2) part.

Instance Variables:
	alias	<String>	Sometimes in queries we want to retrieve something specific in a column value. So, e.g. "select name as one, 2 as two from ...." Where we get back columns named ''one'' and ''two'', where the value of ''two'' is always 2. The alias tells us what to alias the column for this as, if we''re using this as something to be selected.
	value	<Object>	The literal constant value.

'!
!ConstantExpression categoriesForClass!Unclassified! !
!ConstantExpression methodsFor!

alias
	^alias!

alias: anObject
	alias := anObject!

asExpressionJoiningSource: source toTarget: target
	"Create a general expression which represents this relationship where the values of the targets (which are normally parameters) are supplied out of the context provided by 'target' and the source fields are referencing things out of the context of source. Produces something suitable for ANDing into an expression when doing a join
   Example: If we had CUSTOMER.ADDRESS_ID = ADDRESS.ID as a parameter, and we want to AND this into an expression [:customer | customer address street = 'Main'] then we have customer as a base, and we get 
	(customer.ADDRESS.STREET = 'Main') AND (customer.CUSTOMER.ADDRESS_ID = customer.ADDRESS.ID)
	The primary key expression for the relationship has been translated into field references into the customer and address tables in a particular context."

	^self.!

asGlorpExpressionForDescriptor: aDescriptor
	"This should only get sent to us if we're the top level of an expression. And since we don't have children, we're also the bottom level. This is only useful for the case where the expression is [:each | true] or [:each | false]."

	^(EmptyExpression on: value)
		rebuildOn: (BaseExpression new descriptor: aDescriptor).!

asGlorpExpressionOn: aBaseExpression
	^self.!

canBind
	"Return true if this represents a value that can be bound into a prepared statement"
	^true.!

canHaveBase
	"Return true if this type of expression can have a base expression on which other things can be built. Doesn't say whether we actually have a valid one or not."
	^false.!

field
	^self.!

get: aSymbol withArguments: anArray
	| functionExpression |
	functionExpression := self getFunction: aSymbol withArguments: anArray.
	functionExpression isNil ifFalse: [^functionExpression].
	^RelationExpression
		named: aSymbol
		basedOn: self
		withArguments: anArray!

isConstantExpression
	^true.!

isSameAliasedFieldAs: aFieldOrFunction
	^self == aFieldOrFunction.!

mappedFields
	^Array with: self.!

printOnlySelfOn: aStream

	aStream print: value!

printSelectSQLOn: aStream withParameters: aDictionary
	self value glorpPrintSelectSQLOn: aStream.
	alias notNil ifTrue: [
		aStream 
			nextPutAll: ' AS ';
			nextPutAll: alias].!

printSQLOn: aStream withParameters: aDictionary
	self value glorpPrintSQLOn: aStream.!

printTreeOn: aStream 
	aStream print: value!

printUnqualifiedSQLOn: aStream withParameters: aDictionary
	self printSQLOn: aStream withParameters: aDictionary.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	^self.!

table
	^nil.!

ultimateBaseExpression
	^nil.!

value
	^value!

value: anObject
	value := anObject!

valueIn: aDictionary
	^value!

valueInBuilder: aBuilder
	^value.!

valueInBuilder: aBuilder as: anExpression
	^value.! !
!ConstantExpression categoriesFor: #alias!accessing!private! !
!ConstantExpression categoriesFor: #alias:!accessing!private! !
!ConstantExpression categoriesFor: #asExpressionJoiningSource:toTarget:!preparing!private! !
!ConstantExpression categoriesFor: #asGlorpExpressionForDescriptor:!converting!private! !
!ConstantExpression categoriesFor: #asGlorpExpressionOn:!converting!private! !
!ConstantExpression categoriesFor: #canBind!private!testing! !
!ConstantExpression categoriesFor: #canHaveBase!accessing!private! !
!ConstantExpression categoriesFor: #field!accessing!private! !
!ConstantExpression categoriesFor: #get:withArguments:!api!private! !
!ConstantExpression categoriesFor: #isConstantExpression!private!testing! !
!ConstantExpression categoriesFor: #isSameAliasedFieldAs:!accessing!public! !
!ConstantExpression categoriesFor: #mappedFields!As yet unclassified!private! !
!ConstantExpression categoriesFor: #printOnlySelfOn:!printing!private! !
!ConstantExpression categoriesFor: #printSelectSQLOn:withParameters:!printing!private! !
!ConstantExpression categoriesFor: #printSQLOn:withParameters:!printing!private! !
!ConstantExpression categoriesFor: #printTreeOn:!printing!private! !
!ConstantExpression categoriesFor: #printUnqualifiedSQLOn:withParameters:!printing!private! !
!ConstantExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!ConstantExpression categoriesFor: #table!As yet unclassified!private! !
!ConstantExpression categoriesFor: #ultimateBaseExpression!accessing!private! !
!ConstantExpression categoriesFor: #value!accessing!private! !
!ConstantExpression categoriesFor: #value:!accessing!private! !
!ConstantExpression categoriesFor: #valueIn:!accessing!private! !
!ConstantExpression categoriesFor: #valueInBuilder:!mapping!private! !
!ConstantExpression categoriesFor: #valueInBuilder:as:!As yet unclassified!private! !

!ConstantExpression class methodsFor!

for: anObject

	^self new value: anObject.! !
!ConstantExpression class categoriesFor: #for:!instance creation!private! !

EmptyExpression guid: (GUID fromString: '{F45CB52C-4FF4-4E94-A01F-ACDAECB11653}')!
EmptyExpression comment: 'This represents the null expression, but more polymorphically than just sticking nil in the where clause. We also use this as a short-circuiting mechanism if we''re given a where clause that is either just literal true or literal false. So if you end up creating a query with a literal false, we will never go to the database, we''ll just return an empty collection as the result. This is more useful than you might think.

Instance Variables:
	base	<GlorpExpression>	Our base expression, which we''ll use in case someone ANDs or ORs something onto us.
	value	<Boolean| nil > If we are true or false, then this result may end up being short-circuited. If it''s nil, then we''re just an empty where clause.

'!
!EmptyExpression categoriesForClass!Unclassified! !
!EmptyExpression methodsFor!

AND: anExpression

	anExpression isNil ifTrue: [^self].
	^anExpression asGlorpExpression.!

base
	^base.!

base: aBaseExpression
	base := aBaseExpression.!

canHaveBase
	^true.!

canPrint
	"Return true if we can print into a where clause"
	^false.!

do: aBlock skipping: aSet
	"Iterate over the expression tree"

	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	base do: aBlock skipping: aSet.
	aBlock value: self.!

initialize
	super initialize.
	value := true.!

isEmptyExpression
	^true.!

isFalse
	^value not!

isTrue
	^value!

OR: anExpression

	anExpression isNil ifTrue: [^self].
	^anExpression!

printSQLOn: aCommand withParameters: aDictionary
	^self.!

printTreeOn: aStream 
	aStream nextPutAll: 'empty expression'.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	| copy |
	self == anExpression ifTrue: [^aBaseExpression].
	self base == ultimateBaseExpression ifTrue: [^self].
	copy := self copy.
	copy base: aBaseExpression.
	^copy.!

tablesForANSIJoin
	^#().!

ultimateBaseExpression

	base isNil ifTrue: [base := BaseExpression new].
	^base ultimateBaseExpression.!

value: aValue
	"a value is expected to be nil, true, or false. we treat nil as true"
	value := aValue isNil ifTrue: [true] ifFalse: [aValue].!

willPrintAsWhereClause
	^false.! !
!EmptyExpression categoriesFor: #AND:!api!private! !
!EmptyExpression categoriesFor: #base!accessing!private! !
!EmptyExpression categoriesFor: #base:!accessing!private! !
!EmptyExpression categoriesFor: #canHaveBase!private!testing! !
!EmptyExpression categoriesFor: #canPrint!private!testing! !
!EmptyExpression categoriesFor: #do:skipping:!iterating!private! !
!EmptyExpression categoriesFor: #initialize!initialize!private! !
!EmptyExpression categoriesFor: #isEmptyExpression!private!testing! !
!EmptyExpression categoriesFor: #isFalse!accessing!private! !
!EmptyExpression categoriesFor: #isTrue!accessing!private! !
!EmptyExpression categoriesFor: #OR:!api!private! !
!EmptyExpression categoriesFor: #printSQLOn:withParameters:!As yet unclassified!private! !
!EmptyExpression categoriesFor: #printTreeOn:!printing!private! !
!EmptyExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!iterating!private! !
!EmptyExpression categoriesFor: #tablesForANSIJoin!As yet unclassified!private! !
!EmptyExpression categoriesFor: #ultimateBaseExpression!navigating!private! !
!EmptyExpression categoriesFor: #value:!accessing!private! !
!EmptyExpression categoriesFor: #willPrintAsWhereClause!private!testing! !

!EmptyExpression class methodsFor!

on: aValue
	^self new value: aValue.! !
!EmptyExpression class categoriesFor: #on:!instance creation!private! !

ExpressionGroup guid: (GUID fromString: '{C8CA8B43-5D00-49D1-A608-A2978F867C9B}')!
ExpressionGroup comment: 'This isn''t really an expression, in that it can never occur due to parsing. It''s a way of grouping several expressions together so that we can process them together, essentially making sure that the iteration methods will loop over all the expressions, but only do each node once, even if it occurs in multiple expressions.  This is used in processing order expressions to figure out what tables and join expressions we need.

Because it is only used in transient ways, it probably doesn''t implement all the required operations for normal expression usage.
'!
!ExpressionGroup categoriesForClass!Unclassified! !
!ExpressionGroup methodsFor!

add: anExpression
	anExpression isNil ifTrue: [^self].
	children add: anExpression.!

addAll: anExpressionCollection
	anExpressionCollection isNil ifTrue: [^self].
	children addAll: anExpressionCollection.!

children
	^children.!

do: aBlock skipping: aSet
	"Iterate over the expression tree. Keep track of who has already been visited, so we don't get trapped in cycles or visit nodes twice."

	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	children do: 	[:each | each do: aBlock skipping: aSet].
	aBlock value: self.!

initialize
	super initialize.
	children := OrderedCollection new.!

isEmpty
	^self size = 0.!

printTreeOn: aStream

	children do: [:each |
		aStream nextPut: $(.
		each printOn: aStream.
		aStream nextPut: $).
		aStream cr].!

queryLevelBaseExpression
	^nil.!

size
	^children size.! !
!ExpressionGroup categoriesFor: #add:!accessing!private! !
!ExpressionGroup categoriesFor: #addAll:!accessing!private! !
!ExpressionGroup categoriesFor: #children!accessing!private! !
!ExpressionGroup categoriesFor: #do:skipping:!iterating!private! !
!ExpressionGroup categoriesFor: #initialize!initialize!private! !
!ExpressionGroup categoriesFor: #isEmpty!accessing!private! !
!ExpressionGroup categoriesFor: #printTreeOn:!printing!private! !
!ExpressionGroup categoriesFor: #queryLevelBaseExpression!accessing!private! !
!ExpressionGroup categoriesFor: #size!accessing!private! !

!ExpressionGroup class methodsFor!

with: anExpression
	^self new add: anExpression.! !
!ExpressionGroup class categoriesFor: #with:!instance creation!private! !

FieldExpression guid: (GUID fromString: '{239A7EB9-AD2D-4447-8476-B5AE7CC7B6EB}')!
FieldExpression comment: 'This is an expression representing a field in a table. It could be used, for example, if we were writing a data level expression.
   getTable: ''foo'') getField: ''bar''

Instance Variables:
	alias	<Object>	Sometimes in queries we want to retrieve values in columns other than what they are normally named. So we can give the field an alias, and generate something like "select id, name as somethingElse"
	base	<GlorpExpression>	The expression this is based on, which ought to be something which is associated with the table that contains our field.
	field	<DatabaseField>	The field we represent in the expression.

'!
!FieldExpression categoriesForClass!Unclassified! !
!FieldExpression methodsFor!

alias
	^alias!

alias: aString
	"What column name, if anything, should we print for 'as X' when retrieving"
	alias := aString!

asExpressionJoiningSource: source toTarget: target
	"Create a general expression which represents this relationship where the values of the targets (which are normally parameters) are supplied out of the context provided by 'target' and the source fields are referencing things out of the context of source. Produces something suitable for ANDing into an expression when doing a join
   Example: If we had CUSTOMER.ADDRESS_ID = ADDRESS.ID as a parameter, and we want to AND this into an expression [:customer | customer address street = 'Main'] then we have customer as a base, and we get 
	(customer.ADDRESS.STREET = 'Main') AND (customer.CUSTOMER.ADDRESS_ID = customer.ADDRESS.ID)
	The primary key expression for the relationship has been translated into field references into the customer and address tables in a particular context."
	| newTarget |
	newTarget := (target allControlledTables includes: field table) 
		ifTrue: [target]
		ifFalse: [base asExpressionJoiningSource: source toTarget: target].
	^newTarget getField: field.!

base

	^base.!

basicField
	^field.!

canBeUsedForRetrieve
	"Return true if this is a valid argument for a retrieve: clause"
	^true.!

canHaveBase
	"Return true if this type of expression can have a base expression on which other things can be built. Doesn't say whether we actually have a valid one or not."
	^true.!

convertedDbValueOf: anObject
	"We don't do any conversion"
	^anObject!

converterForStType: aClass
	^self field converterForStType: aClass.!

do: aBlock skipping: aSet
	"Iterate over the expression tree"

	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	base do: aBlock skipping: aSet.
	aBlock value: self.!

field
	^base translateField: field!

field: aField base: anObjectExpression

	field := aField.
	base := anObjectExpression.!

fieldExpression
	^self.!

get: aSymbol withArguments: anArray

	| functionExpression |
	functionExpression := self getFunction: aSymbol withArguments: anArray.
	functionExpression isNil ifFalse: [^functionExpression].
	anArray isEmpty ifTrue: [self error: 'Field expressions do not have attributes'].
	^RelationExpression named: aSymbol basedOn: self withArguments: anArray.!

hasField
	^true.!

impliedSmalltalkType
	^self field impliedSmalltalkType.!

mappedFields
	^Array with: self field.!

name
	^field name.!

printOnlySelfOn: aStream 
	base printsTable
		ifTrue: [field printUnqualifiedSQLOn: aStream withParameters: #()]
		ifFalse: [field printSQLOn: aStream withParameters: #()]!

printSelectSQLOn: aStream withParameters: aDictionary
	self printSQLOn: aStream withParameters:aDictionary.
	alias notNil ifTrue: [aStream nextPutAll: ' AS '; nextPutAll: alias].!

printSQLOn: aStream withParameters: aDictionary
	self field printSQLOn: aStream withParameters:aDictionary.!

printTreeOn: aStream 
	base printOn: aStream.
	aStream nextPut: $..
	base printsTable 
		ifTrue: [field printUnqualifiedSQLOn: aStream withParameters: #()]
		ifFalse: [field printSQLOn: aStream withParameters: #()]!

printUnqualifiedSQLOn: aStream withParameters: aDictionary
	self field printUnqualifiedSQLOn: aStream withParameters:aDictionary.!

queryLevelBaseExpression
	^base queryLevelBaseExpression.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	| result |
	self == anExpression ifTrue: [^aBaseExpression].
	result := (base rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression) getField: field.
	result alias: self alias.
	^result.!

setTable: aTable
	"Modify (do not copy) ourselves to use aTable. Presumably aTable is an aliased version of our table"
	field := field withTable: aTable.!

table
	^self field table.!

tableForANSIJoin
	^self field table.!

tables

	^base tables.!

tablesToPrint

	^Array with: self table!

type
	^self field type.!

ultimateBaseExpression
	^base ultimateBaseExpression.!

valueInBuilder: anElementBuilder
	^self valueInBuilder: anElementBuilder as: self field.!

valueInBuilder: anElementBuilder as: anExpression
	^anElementBuilder valueOfField: anExpression.!

withTable: aTable
	"Modify (do not copy) ourselves to use aTable. Presumably aTable is an aliased version of our table"
	field := field withTable: aTable.! !
!FieldExpression categoriesFor: #alias!accessing!private! !
!FieldExpression categoriesFor: #alias:!accessing!private! !
!FieldExpression categoriesFor: #asExpressionJoiningSource:toTarget:!preparing!private! !
!FieldExpression categoriesFor: #base!accessing!private! !
!FieldExpression categoriesFor: #basicField!accessing!private! !
!FieldExpression categoriesFor: #canBeUsedForRetrieve!private!testing! !
!FieldExpression categoriesFor: #canHaveBase!accessing!private! !
!FieldExpression categoriesFor: #convertedDbValueOf:!As yet unclassified!private! !
!FieldExpression categoriesFor: #converterForStType:!accessing!private! !
!FieldExpression categoriesFor: #do:skipping:!iterating!private! !
!FieldExpression categoriesFor: #field!accessing!private! !
!FieldExpression categoriesFor: #field:base:!initializing!private! !
!FieldExpression categoriesFor: #fieldExpression!accessing!private! !
!FieldExpression categoriesFor: #get:withArguments:!api!private! !
!FieldExpression categoriesFor: #hasField!private!testing! !
!FieldExpression categoriesFor: #impliedSmalltalkType!accessing!private! !
!FieldExpression categoriesFor: #mappedFields!mapping!private! !
!FieldExpression categoriesFor: #name!accessing!private! !
!FieldExpression categoriesFor: #printOnlySelfOn:!printing!private! !
!FieldExpression categoriesFor: #printSelectSQLOn:withParameters:!printing SQL!private! !
!FieldExpression categoriesFor: #printSQLOn:withParameters:!printing SQL!private! !
!FieldExpression categoriesFor: #printTreeOn:!printing!private! !
!FieldExpression categoriesFor: #printUnqualifiedSQLOn:withParameters:!printing SQL!private! !
!FieldExpression categoriesFor: #queryLevelBaseExpression!navigating!private! !
!FieldExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!As yet unclassified!private! !
!FieldExpression categoriesFor: #setTable:!copying!private! !
!FieldExpression categoriesFor: #table!accessing!private! !
!FieldExpression categoriesFor: #tableForANSIJoin!As yet unclassified!private! !
!FieldExpression categoriesFor: #tables!preparing!private! !
!FieldExpression categoriesFor: #tablesToPrint!preparing!private! !
!FieldExpression categoriesFor: #type!accessing!private! !
!FieldExpression categoriesFor: #ultimateBaseExpression!navigating!private! !
!FieldExpression categoriesFor: #valueInBuilder:!mapping!private! !
!FieldExpression categoriesFor: #valueInBuilder:as:!mapping!private! !
!FieldExpression categoriesFor: #withTable:!copying!private! !

!FieldExpression class methodsFor!

forField: aField basedOn: anObjectExpression

	^self new field: aField base: anObjectExpression; yourself! !
!FieldExpression class categoriesFor: #forField:basedOn:!instance creation!private! !

FunctionExpression guid: (GUID fromString: '{1C58CBB6-6EE8-4836-A97E-8D82678CADFD}')!
FunctionExpression comment: 'This represents a database function or other modifier. For example, conversion to upper or lower case, or the ascending/descending modifier in order by clauses. At the moment it is hard-coded to to handle only the descending modifier and does not handle e.g. function arguments, functions that differ between databases, functional syntax ( as opposed to postfix). One would probably define subclasses to handle these cases, but this is the simplest thing that could possibly work for the current functionality.

Instance Variables:
	function	<String>	The string we print to the database
	base <GlorpExpression> The thing we''re a function of.
	alias <String> If we''re to be selected as a field, what should we be selcted as. Think SELECT t1.A + t1.B AS FRED.
	symbol <Symbol> The original symbol used to create us. Helpful if recreating onto a different platform where the DB string can be different.
	type <GlorpDatabaseType> Optional. If we have a type defined, then we can record it here. Otherwise, we will return the type of the field we are operating on.
	
'!
!FunctionExpression categoriesForClass!Unclassified! !
!FunctionExpression methodsFor!

alias
	^alias!

alias: aString
	alias := aString!

arguments
	^#().!

arguments: anArray
	^self.!

asDistinctFieldOn: anExpression
	self isDistinct ifTrue: [^self asGlorpExpressionOn: anExpression].
	^super asDistinctFieldOn: anExpression.!

asExpressionJoiningSource: source toTarget: target
	"Create a general expression which represents this relationship where the values of the targets (which are normally parameters) are supplied out of the context provided by 'target' and the source fields are referencing things out of the context of source. Produces something suitable for ANDing into an expression when doing a join
   Example: If we had CUSTOMER.ADDRESS_ID = ADDRESS.ID as a parameter, and we want to AND this into an expression [:customer | customer address street = 'Main'] then we have customer as a base, and we get 
	(customer.ADDRESS.STREET = 'Main') AND (customer.CUSTOMER.ADDRESS_ID = customer.ADDRESS.ID)
	The primary key expression for the relationship has been translated into field references into the customer and address tables in a particular context."

	| newBase |
	newBase := base asExpressionJoiningSource: source toTarget: target.
	^self copy function: function; base: newBase.!

asNonDistinctField
	^self isDistinct ifTrue: [base] ifFalse: [self].!

base
	^base.!

base: anExpression
	base := anExpression.!

canBeUsedForRetrieve
	"Return true if this is a valid argument for a retrieve: clause"
	^true.!

canHaveBase
	^true.!

convertedDbValueOf: anObject
	"Not clear what should happen here, but let's just pass it through for the moment"
	^(self converterForStType: anObject class) convert: anObject toDatabaseRepresentationAs: self type.!

converterForStType: aClass
	^self type notNil 
		ifTrue: [self type converterForStType: aClass]
		ifFalse: [self field converterForStType: aClass].!

convertValueOf: anObject in: aDictionary
	| translated |

	translated := anObject isGlorpExpression 
		ifTrue: [anObject valueIn: aDictionary]
		ifFalse: [anObject].
	translated isGlorpExpression ifTrue: [^translated].
	^self base convertedDbValueOf: translated.!

createFor: arguments
	| new |
	new := self copy.
	new arguments: arguments.
	new type: type.
	^new.!

createFor: arguments withBase: anExpression symbol: aSymbol
	| new |
	new := self copy.
	new base: anExpression.
	new symbol: aSymbol.
	new type: type.
	new arguments: arguments.
	^new.!

defaultType
	"We don't know our type. Return a basic numeric type as being as good a guess as any."
	^base system platform numeric!

do: aBlock skipping: aSet
	"Iterate over the expression tree. Keep track of who has already been visited, so we don't get trapped in cycles or visit nodes twice."

	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	base do: aBlock skipping: aSet.
	aBlock value: self.!

field

	^base field.!

fieldExpression

	^base fieldExpression.!

function: aString

	function := aString.!

function: aString arguments: anArray

	self function: aString.!

get: aSymbol withArguments: anArray
	| functionExpression |
	functionExpression := self getFunction: aSymbol withArguments: anArray.
	functionExpression isNil ifFalse: [^functionExpression].
	^RelationExpression
		named: aSymbol
		basedOn: self
		withArguments: anArray!

hasField
	"If we correspond to a single field, return it. This is a bit of a hack having this only here, because for some functions it doesn't work."
	^base hasField.!

impliedSmalltalkType
	type isNil ifFalse: [^type impliedSmalltalkType].
	^self field impliedSmalltalkType.!

isDistinct
	^function = 'DISTINCT'.!

isGenerated
	^false.!

isSameAliasedFieldAs: aFieldOrFunction
	^self == aFieldOrFunction.!

mappedFields
	^Array with: self.!

name
	^function.!

printOnlySelfOn: aStream
	aStream nextPutAll: function.!

printSelectSQLOn: aStream withParameters: aDictionary
	self printSQLOn: aStream withParameters: aDictionary.
	alias notNil ifTrue: [aStream nextPutAll: ' AS '; nextPutAll: alias].!

printsIntoJoins
	"Certain functions should be printed into joins as well as into select lists (e.g. UPPER). However, there are others that don't (at least I don't think so) make any sense in joins, e.g. DISTINCT. Differentiate the two. Right now the only one I can think of that doesn't make sense is distinct. It's not clear to me that I'm not just hacking my way through this"
	^self isDistinct not.!

printSQLOn: aStream withParameters: aDictionary
	
	self subclassResponsibility.!

printTreeOn: aStream 
	aStream 
		nextPutAll: function!

queryLevelBaseExpression

	^base queryLevelBaseExpression.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	| rebuilt |
	self == anExpression ifTrue: [^aBaseExpression].
	rebuilt := (base rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression) getFunction: self symbol withArguments: (self arguments collect: [:each | each rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression]) in: aBaseExpression system.
	rebuilt alias: self alias.
	^rebuilt.!

rewriteBooleanEquality: relation
	base := base rewriteBooleanEquality: relation.!

symbol
	^symbol!

symbol: aSymbol
	symbol := aSymbol!

table
	(self hasField and: [self field notNil]) ifTrue: [^self field table].
	"If we don't have a field, then maybe we have a relationship mapping or a base, so get the descriptor's primary table. Relevant if we have a function like EXISTS"
	^self base table.!

tablesToPrint
	^#().!

translateField: aField
	^base translateField: aField.!

type
	| field |
	type isNil ifFalse: [^type].
	field := self field.
	^field isNil ifTrue: [self defaultType] ifFalse: [field type].!

type: aGlorpDatabaseType
	type := aGlorpDatabaseType!

ultimateBaseExpression

	^base ultimateBaseExpression.!

valueInBuilder: anElementBuilder
	^self base valueInBuilder: anElementBuilder as: self.!

valueInBuilder: anElementBuilder as: anExpression
	^self base valueInBuilder: anElementBuilder as: anExpression.!

withTable: aTable
	"For a function expression, we shouldn't need to do anything here. It will have already been rebuilt on a base that has aliases"
	^self.

"	| copy newBase |
	newBase := BaseExpression new.
	newBase descriptor: base descriptor.
	copy := self rebuildOn: newBase.
	copy fieldExpression setTable: aTable.
	^copy."! !
!FunctionExpression categoriesFor: #alias!accessing!private! !
!FunctionExpression categoriesFor: #alias:!accessing!private! !
!FunctionExpression categoriesFor: #arguments!accessing!private! !
!FunctionExpression categoriesFor: #arguments:!accessing!private! !
!FunctionExpression categoriesFor: #asDistinctFieldOn:!converting!private! !
!FunctionExpression categoriesFor: #asExpressionJoiningSource:toTarget:!api!private! !
!FunctionExpression categoriesFor: #asNonDistinctField!converting!private! !
!FunctionExpression categoriesFor: #base!accessing!private! !
!FunctionExpression categoriesFor: #base:!accessing!private! !
!FunctionExpression categoriesFor: #canBeUsedForRetrieve!private!testing! !
!FunctionExpression categoriesFor: #canHaveBase!accessing!private! !
!FunctionExpression categoriesFor: #convertedDbValueOf:!accessing!private! !
!FunctionExpression categoriesFor: #converterForStType:!accessing!private! !
!FunctionExpression categoriesFor: #convertValueOf:in:!iterating!private! !
!FunctionExpression categoriesFor: #createFor:!copying!private! !
!FunctionExpression categoriesFor: #createFor:withBase:symbol:!copying!private! !
!FunctionExpression categoriesFor: #defaultType!accessing!private! !
!FunctionExpression categoriesFor: #do:skipping:!iterating!private! !
!FunctionExpression categoriesFor: #field!accessing!private! !
!FunctionExpression categoriesFor: #fieldExpression!accessing!private! !
!FunctionExpression categoriesFor: #function:!accessing!private! !
!FunctionExpression categoriesFor: #function:arguments:!accessing!private! !
!FunctionExpression categoriesFor: #get:withArguments:!api!private! !
!FunctionExpression categoriesFor: #hasField!converting!private! !
!FunctionExpression categoriesFor: #impliedSmalltalkType!accessing!private! !
!FunctionExpression categoriesFor: #isDistinct!private!testing! !
!FunctionExpression categoriesFor: #isGenerated!private!testing! !
!FunctionExpression categoriesFor: #isSameAliasedFieldAs:!private!testing! !
!FunctionExpression categoriesFor: #mappedFields!accessing!private! !
!FunctionExpression categoriesFor: #name!accessing!private! !
!FunctionExpression categoriesFor: #printOnlySelfOn:!printing!private! !
!FunctionExpression categoriesFor: #printSelectSQLOn:withParameters:!printing!private! !
!FunctionExpression categoriesFor: #printsIntoJoins!private!testing! !
!FunctionExpression categoriesFor: #printSQLOn:withParameters:!printing!private! !
!FunctionExpression categoriesFor: #printTreeOn:!printing!private! !
!FunctionExpression categoriesFor: #queryLevelBaseExpression!navigating!private! !
!FunctionExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!FunctionExpression categoriesFor: #rewriteBooleanEquality:!preparing!private! !
!FunctionExpression categoriesFor: #symbol!accessing!private! !
!FunctionExpression categoriesFor: #symbol:!accessing!private! !
!FunctionExpression categoriesFor: #table!accessing!private! !
!FunctionExpression categoriesFor: #tablesToPrint!accessing!private! !
!FunctionExpression categoriesFor: #translateField:!compatibility!private! !
!FunctionExpression categoriesFor: #type!accessing!private! !
!FunctionExpression categoriesFor: #type:!accessing!private! !
!FunctionExpression categoriesFor: #ultimateBaseExpression!navigating!private! !
!FunctionExpression categoriesFor: #valueInBuilder:!mapping!private! !
!FunctionExpression categoriesFor: #valueInBuilder:as:!As yet unclassified!private! !
!FunctionExpression categoriesFor: #withTable:!copying!private! !

!FunctionExpression class methodsFor!

basicFunctions
	functions isNil ifTrue: [functions := self createBasicFunctionsFor: nil].
	^functions.!

createBasicFunctionsFor: anObject
	| exists notExists |
	functions := IdentityDictionary new.
	functions
		at: #descending put: (PostfixFunction named: 'DESC');
		at: #distinct put: (PrefixFunction named: 'DISTINCT');
		at: #max put: (PrefixFunction named: 'MAX');
		at: #min put: (PrefixFunction named: 'MIN');
		at: #sum put: (PrefixFunction named: 'SUM');
		at: #avg put: (PrefixFunction named: 'AVG');
		at: #average put: (PrefixFunction named: 'AVG');
		at: #toChar: put: (PrefixFunction named: 'TO_CHAR');
		at: #not put: (PrefixFunction named: 'NOT');
		at: #, put: (InfixFunction named: '||');
		at: #countStar put: (StandaloneFunction named: 'COUNT(*)');
		at: #count put: (PrefixFunction named: 'COUNT');
		at: #between:and: put: (InfixFunction named: #('BETWEEN' 'AND'));
		at: #isNil
			put:
				((RelationExpression new)
						relation: #=;
						rightChild: nil asGlorpExpression);
		at: #notNil
			put:
				((RelationExpression new)
						relation: #<>;
						rightChild: nil asGlorpExpression);
		at: #isNIL
			put:
				((RelationExpression new)
						relation: #=;
						rightChild: nil asGlorpExpression);
		at: #notNIL
			put:
				((RelationExpression new)
						relation: #<>;
						rightChild: nil asGlorpExpression).
	exists := InfixFunction named: 'EXISTS'.
	anObject isNil ifFalse: [exists type: anObject boolean].
	functions at: #exists: put: exists.
	notExists := InfixFunction named: 'NOT EXISTS'.
	anObject isNil ifFalse: [notExists type: anObject boolean].
	functions at: #notExists: put: notExists.

	functions
		at: #asUppercase put: (PrefixFunction named: 'UPPER');
		at: #asLowercase put: (PrefixFunction named: 'LOWER');
		at: #replace:with: put: (PrefixFunction named: 'REPLACE');
		at: #cast: put: ((Cast named: 'CAST') separator: ' AS ');
		at: #copyFrom:to: put: (SubstringFunction named: 'SUBSTR').

	^functions.!

for: aSymbol withArguments: anArray basedOn: anExpression
	| base system |
	base := anExpression ultimateBaseExpression.
	system := base isNil ifTrue: [nil] ifFalse: [base system].	
	^self for: aSymbol withArguments: anArray basedOn: anExpression system: system.!

for: aSymbol withArguments: anArray basedOn: anExpression system: system
	| functionTemplate newFunction |
	functionTemplate := (system isNil
		ifTrue: [self basicFunctions]
		ifFalse: [system platform functions]) at: aSymbol ifAbsent: [^nil].
	newFunction := functionTemplate
		createFor: anArray
		withBase: anExpression
		symbol: aSymbol.
	^newFunction.!

initialize

	self resetFunctions.!

named: aString
	"Used for creating template instances only"

	^self new function: aString.!

resetFunctions
	"self resetFunctions"
	functions := nil.! !
!FunctionExpression class categoriesFor: #basicFunctions!private! !
!FunctionExpression class categoriesFor: #createBasicFunctionsFor:!private! !
!FunctionExpression class categoriesFor: #for:withArguments:basedOn:!instance creation!private! !
!FunctionExpression class categoriesFor: #for:withArguments:basedOn:system:!instance creation!private! !
!FunctionExpression class categoriesFor: #initialize!private! !
!FunctionExpression class categoriesFor: #named:!private! !
!FunctionExpression class categoriesFor: #resetFunctions!private! !

GeneralSubSelectExpression guid: (GUID fromString: '{4756FD62-0D64-4FB5-83B5-1E29F28FD76C}')!
GeneralSubSelectExpression comment: 'This represents an arbitrary sub-select. This would normally get created by embedding a query instance inside a query block. For example
   where: [:each | each id > 2 & (each something = aWholeOtherQuery)].
Warning: This can be get very complicated, especially if aWholeOtherQuery refers to variables inside the main query block, creating a correlated subselect.

Instance Variables:
	query	<Query>	The query that we subselect.

'!
!GeneralSubSelectExpression categoriesForClass!Unclassified! !
!GeneralSubSelectExpression methodsFor!

addBoundExpressionsIn: aCommand to: boundExpressions
	self query session: aCommand query session.
	self query prepare.
	self query addBoundExpressionsIn: aCommand to: boundExpressions.!

asExpressionJoiningSource: source toTarget: target
	" *** This method was defined by Glorp.GlorpExpression as a subclass responsibility.
	Replace its body with a proper implementation. *** "

	self error: 'Subclass responsibility stub not reimplemented'!

asJoin
	" *** This method was defined by Glorp.GlorpExpression as a subclass responsibility.
	Replace its body with a proper implementation. *** "

	self error: 'Subclass responsibility stub not reimplemented'!

base
	^base!

base: anExpression
	base := anExpression.!

canHaveBase
	"Return true if this type of expression can have a base expression on which other things can be built. Doesn't say whether we actually have a valid one or not."
	^true.!

convertedDbValueOf: anObject
	^anObject.!

descriptor
	^base system descriptorFor: query resultClass.!

field
	^nil.!

get: aSymbol withArguments: anArray 

	| functionExpression |
	functionExpression := self getFunction: aSymbol withArguments: anArray.
	functionExpression isNil ifFalse: [^functionExpression].
	^RelationExpression
		named: aSymbol
		basedOn: self
		withArguments: anArray!

getField: aField
	"This is rather a hack on the use of get:, but I think it should be all right because we should never run into one of these in normal expression generation. The issue is that if we do an expression of the form (x = aQuery) where the query returns an object of the same class as X. We want to rewrite that into a primary key comparison for the database, so we want to do a get: against aQuery. But the only thing that seems to sensibly translate into is a retrieve: clause and return the query. That will only work for a single level get:, but I think that a multi-level one, from converting a block, shouldn't ever get to a general sub-select."
	query retrieve: [:each | each getField: aField].!

getMapping: aMapping named: aSymbol
	"Suppose we do an expression of the form (x = aQuery) where the query returns an object of the same class as X. We want to rewrite that into a primary key comparison for the database, so we want to do a getMapping:named: against aQuery. But the only thing that seems to sensibly translate into is a retrieve: clause and return the query. That will only work for a single level get:, but I think that a multi-level one, from converting a block, shouldn't ever get to a general sub-select."
	query retrieve: aSymbol.!

isMappable
	"Return true if we're something that can be returned in a select statement."
	^false.!

mappedFields
	"Let's try this and see if it works returning empty"
	^#().!

printOnlySelfOn: aStream
	" *** This method was defined by Glorp.GlorpExpression as a subclass responsibility.
	Replace its body with a proper implementation. *** "

	self error: 'Subclass responsibility stub not reimplemented'!

printSelectSQLOn: aStream withParameters: aDictionary
	self printSQLOn: aStream withParameters: aDictionary.!

printSQLOn: aStream withParameters: aDictionary 
	| command |
	aStream nextPutAll: '('.
	self query session: aStream query session.
	command := self query sqlWith: aDictionary.
	aStream nextPutAll: command sqlString.
	aStream nextPutAll: ')'.!

printTreeOn: aStream
	aStream nextPutAll: 'subselect('.
	query printOn: aStream.
	aStream nextPutAll: ')'.!

query
	^query!

query: aQuery
	query := aQuery!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	| rebuiltBase rebuilt |
	self == anExpression ifTrue: [^aBaseExpression].
	rebuiltBase := base rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression.
	rebuilt := self copy.
	rebuilt base: rebuiltBase.
	rebuilt query: (query rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression).
	^rebuilt.
"	^query asGlorpExpressionOn: aBaseExpression."!

type
	^query resultType.!

ultimateBaseExpression
	^base ultimateBaseExpression.! !
!GeneralSubSelectExpression categoriesFor: #addBoundExpressionsIn:to:!preparing!private! !
!GeneralSubSelectExpression categoriesFor: #asExpressionJoiningSource:toTarget:!preparing!private! !
!GeneralSubSelectExpression categoriesFor: #asJoin!converting!private! !
!GeneralSubSelectExpression categoriesFor: #base!api!private! !
!GeneralSubSelectExpression categoriesFor: #base:!accessing!private! !
!GeneralSubSelectExpression categoriesFor: #canHaveBase!accessing!private! !
!GeneralSubSelectExpression categoriesFor: #convertedDbValueOf:!converting!private! !
!GeneralSubSelectExpression categoriesFor: #descriptor!accessing!private! !
!GeneralSubSelectExpression categoriesFor: #field!accessing!private! !
!GeneralSubSelectExpression categoriesFor: #get:withArguments:!api!private! !
!GeneralSubSelectExpression categoriesFor: #getField:!api!private! !
!GeneralSubSelectExpression categoriesFor: #getMapping:named:!api!private! !
!GeneralSubSelectExpression categoriesFor: #isMappable!private!testing! !
!GeneralSubSelectExpression categoriesFor: #mappedFields!accessing!private! !
!GeneralSubSelectExpression categoriesFor: #printOnlySelfOn:!printing!private! !
!GeneralSubSelectExpression categoriesFor: #printSelectSQLOn:withParameters:!printing!private! !
!GeneralSubSelectExpression categoriesFor: #printSQLOn:withParameters:!printing!private! !
!GeneralSubSelectExpression categoriesFor: #printTreeOn:!printing!private! !
!GeneralSubSelectExpression categoriesFor: #query!accessing!private! !
!GeneralSubSelectExpression categoriesFor: #query:!accessing!private! !
!GeneralSubSelectExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!GeneralSubSelectExpression categoriesFor: #type!accessing!private! !
!GeneralSubSelectExpression categoriesFor: #ultimateBaseExpression!navigating!private! !

!GeneralSubSelectExpression class methodsFor!

basedOn: anExpression
	"The defining characteristic of a general subselect is that it doesn't care what it's based on. The base is just a convenient place to hang an independent expression. So make sure we're built on a true base, which won't print confusing stuff for us"
	^self new base: anExpression ultimateBaseExpression.! !
!GeneralSubSelectExpression class categoriesFor: #basedOn:!instance creation!private! !

ObjectExpression guid: (GUID fromString: '{048E7787-C38B-458F-ABD5-469A073B4414}')!
ObjectExpression comment: 'This is a not-especially well-named superclass for expressions that end up mapping to rows in the database, more or less. That is, it''s more or less a superclass for things that have the capacity to alias tables, and to have mapping expressions derived from them. Since, depending on your point of view, everything is an object, the name isn''t very descriptive. Or if some things aren''t considered objects, TableExpression is a good candidate. But we have the common functionality for managing tables, and for keeping a dictionary of our sub-mapping expressions.

Subclasses must implement the following messages:
	accessing
		system
		table
	fields
		controlsTables

Instance Variables:
	fieldAliases	<Dictionary from: DatabaseField to: DatabaseField>	For each field, the corresponding aliased field for our query. So, e.g. PERSON.NAME will map to t1.NAME. These aren''t strings, though, these are fields derived from the aliased table.
	mappingExpressions	<Dictionary from: Symbol to: ( MappingExpression | TableExpression) >	Each attribute that''s derived from us will be maintained in this dictionary. This is very important, because Glorp relies critically on these expressions being identical. So "object field == object field".
	requiresDistinct	<Boolean>	Do the fields that we will cause to be added to the SELECT portion of the query need a DISTINCT wrapped around them?
	tableAliases	<Dictionary from: DatabaseTable to: DatabaseTable>	While the query is being prepared, tables will be assigned aliases. This keeps track of the aliases for the tables that we control. As with fieldAliases, note that this stores table copies with their names altered, not strings.

'!
!ObjectExpression categoriesForClass!Unclassified! !
!ObjectExpression methodsFor!

aggregate: anExpression as: aggregateFunctionName

	^self aggregate: anExpression as: aggregateFunctionName where: nil.!

aliasedTableFor: aDatabaseTable 
	tableAliases isNil ifTrue: [^aDatabaseTable].
	aDatabaseTable isAliased ifTrue: [^aDatabaseTable].
	^tableAliases 
		at: aDatabaseTable 
		ifAbsent: [
			(self tables includes: aDatabaseTable) 	
				ifTrue: [self error: 'Bug. Expression has only partially aliased tables']
				ifFalse: [
					| tableExpression |
					tableExpression := self mappingExpressions at: aDatabaseTable ifAbsent: [nil].
					tableExpression isNil 
						ifTrue: [aDatabaseTable]
						ifFalse: [tableExpression aliasedTableFor: aDatabaseTable]]].!

aliasedTableFor: aDatabaseTable  ifAbsent: aBlock
	tableAliases isNil ifTrue: [^aBlock value].
	aDatabaseTable isAliased ifTrue: [^aDatabaseTable].
	^tableAliases at: aDatabaseTable ifAbsent: [aBlock value].!

aliasTable: aDatabaseTable to: aString 
	| newTable |
	newTable := aDatabaseTable copy.
	newTable name: aString.
	newTable parent: aDatabaseTable.
	newTable schema: ''.
	self tableAliases at: aDatabaseTable put: newTable!

anySatisfyDefault: anExpression 
	^(self system isNil or: [self system useJoinsForAnySatisfy])
		ifTrue: [self anySatisfyJoin: anExpression]
		ifFalse: [self anySatisfyExists: anExpression].!

anySatisfyExists: anExpression 
	| newExpression |
	anExpression isConstantExpression ifTrue: [self error: 'The argument to anySatisfy: must be a block evaluating to a boolean condition.'].
	newExpression := SubSelectExpression 
		named: #anySatisfy:
		basedOn: self
		withArguments: (Array with: anExpression).
	^newExpression.!

anySatisfyJoin: anExpression 
	| newExpression |
	anExpression isConstantExpression ifTrue: [self error: 'The argument to anySatisfy: must be a block evaluating to a boolean condition.'].
	self base requiresDistinct: true.
	newExpression := CollectionExpression 
		named: #anySatisfy:
		basedOn: self
		withArguments: (Array with: anExpression).
	self base removeMappingExpression: self.
	^newExpression.!

asDate
	"Cast the receiver to be a date"
	^self getFunction: #cast: withArguments: (Array with: self system platform date asGlorpExpression).!

assignTableAliasesStartingAt: anInteger prefix: aString
	| tableNumber prefix |
	self controlsTables ifFalse: [^anInteger].
	self hasTableAliases ifTrue: [^anInteger].
	tableNumber := anInteger.
	prefix := aString isNil ifTrue: ['t'] ifFalse: [aString].
	self tables
		do:
			[:each | 
			self aliasTable: each to: prefix , tableNumber printString.
			tableNumber := tableNumber + 1].
	^tableNumber.!

asTimestamp
	"Cast the receiver to be a timestamp"
	^self getFunction: #cast: withArguments: (Array with: self system platform timestamp asGlorpExpression).!

average: anExpression
	^self aggregate: anExpression as: #average.!

canTranslateFields
	"Return true if we are a mapping expression and can thus translate from fields into their aliased version for a particular query. More generally, do we respond to translateField:"
	^true.!

controlsTables

	self subclassResponsibility.!

count: anExpression
	"Make a subselect of the expression that is our argument, returning a count(*). e.g.
session read: GlorpCustomer where: 	[:each |  (each count: [:eachCust | eachCust accounts]) = 1]."
	^self aggregate: anExpression as: #countStar.!

count: anExpression where: filterExpression
	"Make a subselect of the expression that is our argument, returning a count(*). e.g.
session read: GlorpCustomer where: 	[:each |  (each count: [:eachCust | eachCust accounts]) = 1]."
	^self aggregate: anExpression as: #countStar where: filterExpression.!

fieldAliases

	fieldAliases isNil ifTrue: [fieldAliases := IdentityDictionary new].
	^fieldAliases.!

findFieldNamed: aString
	| fields |
	fields := OrderedCollection new: 1.
	self tables do: [:each |
		| field |
		field := each fieldNamed: aString ifAbsent: [nil].
		field isNil ifFalse: [fields add: field]].
	fields isEmpty ifTrue: [self error: 'No field named ', aString, ' in ', self printString].
	fields size > 1 ifTrue: [self error: 'Ambiguous field ', aString, ' in ', self printString].
	^fields at: 1.!

get: aSymbol 
	"Return the mapping expression corresponding to the named attribute"

	| reallyASymbol functionExpression |
	reallyASymbol := aSymbol asSymbol.
	functionExpression := self getFunction: aSymbol withArguments: #().
	functionExpression isNil ifFalse: [^functionExpression].
	^self mappingExpressions at: reallyASymbol
		ifAbsentPut: [MappingExpression named: reallyASymbol basedOn: self]!

get: aSymbol withArguments: anArray 

	| specialExpression functionExpression |
	functionExpression := self getFunction: aSymbol withArguments: anArray.
	functionExpression isNil ifFalse: [^functionExpression].
	specialExpression := self performSpecialExpression: aSymbol withArguments: anArray.
	specialExpression isNil ifFalse: [^specialExpression].
	anArray isEmpty ifTrue: [^self get: aSymbol].
	^RelationExpression
		named: aSymbol
		basedOn: self
		withArguments: anArray!

getConstant: anObject
	"Allows us to refer to a constant object easily. This is most useful for subselects, where I can already write something like
   [:each | (each count: subQuery) = 5]
but since the subselect part might be very verbose, I might prefer to put the constant value first. I can't write
   [:each | 5 = (each count: subQuery)]
because then the left-hand side expression doesn't refer back to the block argument, and we can't build the expression correctly. So I can write
   [:each | (each getConstant: 5) = (each count: subQuery)]"
	^anObject asGlorpExpressionOn: self.!

getField: aField
	| realField |
	realField := aField isString
		ifTrue: [self findFieldNamed: aField]
		ifFalse: [aField].
	"This might be an expression, most notably a constant expression, in which case it either contains a string or a field. This is awfully ugly"
	realField isGlorpExpression
		ifTrue:
			[realField class == ConstantExpression
				ifTrue:
					[realField := realField value isString
						ifTrue: [realField := self findFieldNamed: realField value]
						ifFalse: [realField]]].
	^self getFieldKnownNotToBeAName: realField.!

getFieldKnownNotToBeAName: aField
	"The public getField method may, for convenience, be passed a string or a constant expression with a string that is a field name. This is a mess, and can be confused with a constant value. This method does not allow that."

	| realField |
	realField := aField.
	realField isGlorpExpression
		ifTrue:
			[realField class == ConstantExpression ifTrue: [^realField].
			realField class == ParameterExpression
				ifTrue: [realField := realField field]].
	^self getFieldThatsAnActualFieldObject: realField.!

getFieldThatsAnActualFieldObject: aField
	"If the field isn't from our table, do a getTable first. If we don't know, assume we can get it directly."

	self controlsTables ifFalse: [^self base getFieldThatsAnActualFieldObject: (self translateField: aField)].
	^((self hasDescriptor not) or: [self tables includes: aField table])
		ifTrue:
			[self mappingExpressions
				at: aField
				ifAbsentPut: [self newFieldExpressionFor: aField]]
		ifFalse: [(self getTable: aField table) getField: aField].!

getMapping: aMapping named: aString
	"Get a mapping expression given the actual mapping (this is most useful for an anonymous mapping that isn't named or in our descriptor). Only if you really know what you're doing!!. Short circuit looking up the mapping, checking for functions, and so on."

	^self mappingExpressions at: aString
		ifAbsentPut: [ | expression |
			expression := MappingExpression named: aString basedOn: self.
			expression mapping: aMapping.
			expression].!

getParameter: aDatabaseField 
	^ParameterExpression forField: aDatabaseField basedOn: self.!

getTable: aTable
	"This can take a string, a constantExpression containing a string, or a table object"

	| realTable |
	realTable := aTable isString
		ifTrue: [self system tableNamed: aTable]
		ifFalse: [aTable].	"This might be an expression, most notably a constant expression, in which case it either contains a string or a field"
	realTable isGlorpExpression
		ifTrue:
			[realTable value isString
				ifTrue: [realTable := self system tableNamed: realTable value]
				ifFalse: [realTable := realTable value]].
	^self mappingExpressions
		at: realTable
		ifAbsentPut: [TableExpression forTable: realTable basedOn: self].!

hasField
	^false.!

hasProvidedAdditionalExpressions
	"Return true if we have already provided additional expressions to some query. Only important when we're preparing a subselect and don't want to bring in joins that are part of the main query"
	^self hasTableAliases.!

hasTableAliases
	^tableAliases notNil!

includes: anObject
	"Allow us to specify includes: as a shortcut for (anySatisfy: [:each | each = anObject]). Rather than just call anySatisfy:, we need to go through the get: mechanism, both to avoid the anySatisfy: method on expressions that treats them like a collection, and to make sure we get the default mechanism for anySatisfy: (either joins or exists)"
	^self get: #anySatisfy: withArguments: (Array with: ([:each | each = anObject] asGlorpExpressionOn: self)).!

initialize

	super initialize.
	requiresDistinct := false.!

mappingExpressions
	mappingExpressions isNil ifTrue: [mappingExpressions := IdentityDictionary new].
	^mappingExpressions.!

mappingExpressions: anObject
	mappingExpressions := anObject!

max: anExpression
	^self aggregate: anExpression as: #max.!

min: anExpression
	^self aggregate: anExpression as: #min.!

newFieldExpressionFor: aField

	^FieldExpression forField: aField basedOn: self!

noneSatisfy: anExpression 
	| newExpression |
	newExpression := SubSelectExpression 
		named: #noneSatisfy:
		basedOn: self
		withArguments: (Array with: anExpression).
	^newExpression.!

noneSatisfyExists: anExpression 
	| newExpression |
	newExpression := SubSelectExpression 
		named: #noneSatisfy:
		basedOn: self
		withArguments: (Array with: anExpression).
	^newExpression.!

oneArgumentSpecialSelectors
	^#(#anySatisfyDefault: #anySatisfyJoin: #anySatisfyExists: #getTable: #getField: #fieldNamed: #parameter: #noneSatisfy: #noneSatisfyExists: #getConstant: #count: #sum: #min: #max: #average: #sqlSelect: #includes:)!

performSpecialExpression: aSymbol withArguments: anArray
	| symbolToPerform |
	symbolToPerform := self specialSymbolToPerformFor: aSymbol.
	(self zeroArgumentSpecialSelectors includes: symbolToPerform) ifTrue: [^self perform: symbolToPerform].
	(self oneArgumentSpecialSelectors includes: symbolToPerform) ifTrue: [^self perform: symbolToPerform with: anArray first ].
	(self twoArgumentSpecialSelectors includes: symbolToPerform) ifTrue: [^self perform: symbolToPerform with: (anArray at: 1) with: (anArray at: 2)].
	^nil.!

printTableAliasesOn: aStream 
	self hasTableAliases 
		ifTrue: 
			[aStream nextPutAll: ' '.
			tableAliases keysAndValuesDo: [:eachKey :eachValue | 
				aStream nextPutAll: eachKey name, '->', eachValue name , ' ']]!

referenceClass
	"Return the class that our mapping refers to, if we have a mapping. If we're a base expression, just return our class, and if we're a table expression, just return nil."
	^self subclassResponsibility.!

removeMappingExpression: anExpression
	"Private. Normally you would never do this, but in the case of an anySatisfy: or allSatisfy: we want to have each of them as distinct joins, so we will remove the entry from the mappingExpression of the base, making sure that relationship will not be used for anything else. Since any/allSatisfy: is the only valid use of a collection relationship, we don't have to worry about whether it was used for something else earlier."

	self mappingExpressions removeKey: anExpression name.!

requiresDistinct
	^requiresDistinct!

requiresDistinct: aBoolean 
	requiresDistinct := aBoolean!

specialSymbolToPerformFor: aSymbol
	"Avoid polymorphism between things you can send to an expression inside a query block and things you can do to an expression to iterate over an expression true"
	aSymbol == #anySatisfy: ifTrue: [^#anySatisfyDefault:].
	aSymbol == #select: ifTrue: [^#sqlSelect:].
	^aSymbol.!

sqlAverage
	"Make a subselect of the expression that is our argument, returning an avg(). e.g.
session read: GlorpCustomer where: 	[:each |  each accounts balance sqlAverage > 100]."
	^self queryLevelBaseExpression average: self.!

sqlAvg
	"Make a subselect of the expression that is our argument, returning an avg(). e.g.
session read: GlorpCustomer where: 	[:each |  each accounts balance sqlAvg > 100]."
	^self queryLevelBaseExpression average: self.!

sqlCount
	"Make a subselect of the expression that is our argument, returning a count(). e.g.
session read: GlorpCustomer where: 	[:each |  each accounts sqlCount = 1]."
	^self queryLevelBaseExpression count: self.!

sqlCountWhere: filterExpression
	"Make a subselect of the expression that is our argument, returning a count(). e.g.
session read: GlorpCustomer where: 	[:each |  each accounts sqlCount = 1]."
	^self queryLevelBaseExpression count: self where: filterExpression.!

sqlMax
	"Make a subselect of the expression that is our argument, returning a max(). e.g.
session read: GlorpCustomer where: 	[:each |  each accounts balance sqlMax = 1]."
	^self queryLevelBaseExpression max: self.!

sqlMin
	"Make a subselect of the expression that is our argument, returning a minimum. e.g.
session read: GlorpCustomer where: 	[:each |  each accounts balance sqlMin = 1]."
	^self queryLevelBaseExpression min: self.!

sqlSum
	"Make a subselect of the expression that is our argument, returning a count(*). e.g.
session read: GlorpCustomer where: 	[:each |  each accounts balance sqlSum = 1]."
	^self queryLevelBaseExpression sum: self.!

sum: anExpression
	"Make a subselect of the expression that is our argument, returning a sum. e.g.
session read: GlorpCustomer where: 	[:each |  (each sum: [:eachCust | eachCust accounts id]) > 5]."
	^self aggregate: anExpression as: #sum.!

system
	self subclassResponsibility.!

table
	self subclassResponsibility.!

tableAliases
	tableAliases isNil ifTrue: [
		tableAliases := IdentityDictionary new: 3].
	^tableAliases!

translateField: aDatabaseField
	| newTable rebuilt |
	rebuilt := aDatabaseField isGlorpExpression
		ifTrue: [aDatabaseField asGlorpExpressionOn: self withUltimateBase: self ultimateBaseExpression]
		ifFalse: [aDatabaseField].
	newTable := self aliasedTableFor: rebuilt table.
	newTable == rebuilt table ifTrue: [^rebuilt].
	^self fieldAliases at: aDatabaseField ifAbsentPut: [rebuilt withTable: newTable].!

translateFields: anOrderedCollection 
	^anOrderedCollection collect: [:each | self translateField: each]!

twoArgumentSpecialSelectors
	^#(#aggregate:as:)!

zeroArgumentSpecialSelectors
	^#(#asOuterJoin #sqlCount #sqlSum #sqlMin #sqlMax #sqlAverage #sqlAvg #isEmpty #notEmpty #asDate #asTimestamp #bePhantom).! !
!ObjectExpression categoriesFor: #aggregate:as:!api-aggregates!private! !
!ObjectExpression categoriesFor: #aliasedTableFor:!fields!private! !
!ObjectExpression categoriesFor: #aliasedTableFor:ifAbsent:!fields!public! !
!ObjectExpression categoriesFor: #aliasTable:to:!fields!private! !
!ObjectExpression categoriesFor: #anySatisfyDefault:!internal!private! !
!ObjectExpression categoriesFor: #anySatisfyExists:!internal!private! !
!ObjectExpression categoriesFor: #anySatisfyJoin:!internal!private! !
!ObjectExpression categoriesFor: #asDate!api-aggregates!private! !
!ObjectExpression categoriesFor: #assignTableAliasesStartingAt:prefix:!preparing!private! !
!ObjectExpression categoriesFor: #asTimestamp!api-aggregates!private! !
!ObjectExpression categoriesFor: #average:!api-aggregates!private! !
!ObjectExpression categoriesFor: #canTranslateFields!private!testing! !
!ObjectExpression categoriesFor: #controlsTables!fields!private! !
!ObjectExpression categoriesFor: #count:!api-aggregates!private! !
!ObjectExpression categoriesFor: #count:where:!api-aggregates!private! !
!ObjectExpression categoriesFor: #fieldAliases!accessing!private! !
!ObjectExpression categoriesFor: #findFieldNamed:!fields!private! !
!ObjectExpression categoriesFor: #get:!api!private! !
!ObjectExpression categoriesFor: #get:withArguments:!api!private! !
!ObjectExpression categoriesFor: #getConstant:!api!private! !
!ObjectExpression categoriesFor: #getField:!api!private! !
!ObjectExpression categoriesFor: #getFieldKnownNotToBeAName:!api!private! !
!ObjectExpression categoriesFor: #getFieldThatsAnActualFieldObject:!api!private! !
!ObjectExpression categoriesFor: #getMapping:named:!api!private! !
!ObjectExpression categoriesFor: #getParameter:!api!private! !
!ObjectExpression categoriesFor: #getTable:!api!private! !
!ObjectExpression categoriesFor: #hasField!private!testing! !
!ObjectExpression categoriesFor: #hasProvidedAdditionalExpressions!private!testing! !
!ObjectExpression categoriesFor: #hasTableAliases!private!testing! !
!ObjectExpression categoriesFor: #includes:!internal!private! !
!ObjectExpression categoriesFor: #initialize!initialize!private! !
!ObjectExpression categoriesFor: #mappingExpressions!accessing!private! !
!ObjectExpression categoriesFor: #mappingExpressions:!accessing!private! !
!ObjectExpression categoriesFor: #max:!api-aggregates!private! !
!ObjectExpression categoriesFor: #min:!api-aggregates!private! !
!ObjectExpression categoriesFor: #newFieldExpressionFor:!fields!private! !
!ObjectExpression categoriesFor: #noneSatisfy:!internal!private! !
!ObjectExpression categoriesFor: #noneSatisfyExists:!internal!private! !
!ObjectExpression categoriesFor: #oneArgumentSpecialSelectors!internal!private! !
!ObjectExpression categoriesFor: #performSpecialExpression:withArguments:!internal!private! !
!ObjectExpression categoriesFor: #printTableAliasesOn:!printing!private! !
!ObjectExpression categoriesFor: #referenceClass!api!private! !
!ObjectExpression categoriesFor: #removeMappingExpression:!private!private/accessing! !
!ObjectExpression categoriesFor: #requiresDistinct!private!private/accessing! !
!ObjectExpression categoriesFor: #requiresDistinct:!private!private/accessing! !
!ObjectExpression categoriesFor: #specialSymbolToPerformFor:!internal!private! !
!ObjectExpression categoriesFor: #sqlAverage!api-aggregates!private! !
!ObjectExpression categoriesFor: #sqlAvg!api-aggregates!private! !
!ObjectExpression categoriesFor: #sqlCount!api-aggregates!private! !
!ObjectExpression categoriesFor: #sqlCountWhere:!api-aggregates!private! !
!ObjectExpression categoriesFor: #sqlMax!api-aggregates!private! !
!ObjectExpression categoriesFor: #sqlMin!api-aggregates!private! !
!ObjectExpression categoriesFor: #sqlSum!api-aggregates!private! !
!ObjectExpression categoriesFor: #sum:!api-aggregates!private! !
!ObjectExpression categoriesFor: #system!accessing!private! !
!ObjectExpression categoriesFor: #table!accessing!private! !
!ObjectExpression categoriesFor: #tableAliases!accessing!private! !
!ObjectExpression categoriesFor: #translateField:!fields!private! !
!ObjectExpression categoriesFor: #translateFields:!fields!private! !
!ObjectExpression categoriesFor: #twoArgumentSpecialSelectors!internal!private! !
!ObjectExpression categoriesFor: #zeroArgumentSpecialSelectors!internal!private! !

ParameterExpression guid: (GUID fromString: '{42DEA07F-9D73-4502-BA12-D4ECBCE2B971}')!
ParameterExpression comment: 'This is an expression representing a placeholder for a parameter value. So, e.g. object attribute = <parameter for field OWNER_ID>. This is most frequently used for the queries in proxies, although it can be used anywhere. The parameter can be identified by either a field, a name, or an index, which can get fairly ugly.

Instance Variables:
	base	<GlorpExpression>	Our base expression.
	lookupKey	<DatabaseField | SomethingElse>	The thing based on which we look up our parameter value in the array or dictionary of parameters that''s passed to the query. So it can be number (for positional usage), a field, or something else.

. '!
!ParameterExpression categoriesForClass!Unclassified! !
!ParameterExpression methodsFor!

addToTargetFields: aCollection
	"If we can provide target fields, add them to the collection"

	lookupKey isDatabaseField ifTrue: [aCollection add: lookupKey]!

asExpressionJoiningSource: source toTarget: target
	"Create a general expression which represents this relationship where the values of the targets (which are normally parameters) are supplied out of the context provided by 'target' and the source fields are referencing things out of the context of source. Produces something suitable for ANDing into an expression when doing a join
   Example: If we had CUSTOMER.ADDRESS_ID = ADDRESS.ID as a parameter, and we want to AND this into an expression [:customer | customer address street = 'Main'] then we have customer as a base, and we get 
	(customer.ADDRESS.STREET = 'Main') AND (customer.CUSTOMER.ADDRESS_ID = customer.ADDRESS.ID)
	The primary key expression for the relationship has been translated into field references into the customer and address tables in a particular context."

	^source getField: lookupKey.!

base

	^base!

canBind
	"Return true if this represents a value that can be bound into a prepared statement"
	^true.!

canHaveBase
	"Return true if this type of expression can have a base expression on which other things can be built. Doesn't say whether we actually have a valid one or not."
	^true.!

convertedDbValueOf: anObject
	"We don't do any conversion"
	^anObject!

do: aBlock skipping: aSet

	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	base do: aBlock skipping: aSet.
	aBlock value: self.!

field
	^lookupKey!

field: aDatabaseField base: aBaseExpression 
	lookupKey := aDatabaseField.
	base := aBaseExpression!

get: aSelector withArguments: anArray
	| functionExpression |
	functionExpression := self getFunction: aSelector withArguments: anArray.
	functionExpression isNil ifFalse: [^functionExpression].
	^RelationExpression
		named: aSelector
		basedOn: self
		withArguments: anArray!

getMapping: aMapping named: aSymbol
	"Get an expression given the actual mapping. Only if you really know what you're doing!! In this case, what we're probably doing is rewriting a parameter that's a mapped object into a set of parameters, one for each of its primary keys."
	| expression |
	expression := nil.
	aMapping mappedFields do: [:each |
		expression := (each asGlorpExpressionOn: self) AND: expression].
	^expression.!

printOn: aStream 
	aStream nextPutAll: 'Parameter('.
	self printTreeOn: aStream.
	aStream nextPut: $)!

printOnlySelfOn: aStream

	lookupKey printSQLOn: aStream withParameters: #()!

printSQLOn: aStream withParameters: aDictionary
	self field type print: (self valueIn: aDictionary) on: aStream.!

printTreeOn: aStream 
	[lookupKey printSQLOn: aStream withParameters: #()] on: Dialect error do: [:ex | lookupKey printOn: aStream].!

queryLevelBaseExpression
	^base queryLevelBaseExpression.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	self == anExpression ifTrue: [^aBaseExpression].
	self base == ultimateBaseExpression ifTrue: [^self].
	^aBaseExpression getParameter: lookupKey.!

ultimateBaseExpression
	^base ultimateBaseExpression.!

valueIn: aDictionary 
	^aDictionary at: lookupKey.! !
!ParameterExpression categoriesFor: #addToTargetFields:!preparing!public! !
!ParameterExpression categoriesFor: #asExpressionJoiningSource:toTarget:!preparing!private! !
!ParameterExpression categoriesFor: #base!accessing!private! !
!ParameterExpression categoriesFor: #canBind!private!testing! !
!ParameterExpression categoriesFor: #canHaveBase!accessing!private! !
!ParameterExpression categoriesFor: #convertedDbValueOf:!printing!private! !
!ParameterExpression categoriesFor: #do:skipping:!iterating!private! !
!ParameterExpression categoriesFor: #field!accessing!private! !
!ParameterExpression categoriesFor: #field:base:!initialize/release!private! !
!ParameterExpression categoriesFor: #get:withArguments:!api!private! !
!ParameterExpression categoriesFor: #getMapping:named:!api!private! !
!ParameterExpression categoriesFor: #printOn:!printing!private! !
!ParameterExpression categoriesFor: #printOnlySelfOn:!printing!private! !
!ParameterExpression categoriesFor: #printSQLOn:withParameters:!printing!private! !
!ParameterExpression categoriesFor: #printTreeOn:!printing!private! !
!ParameterExpression categoriesFor: #queryLevelBaseExpression!navigating!private! !
!ParameterExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!ParameterExpression categoriesFor: #ultimateBaseExpression!navigating!private! !
!ParameterExpression categoriesFor: #valueIn:!printing!private! !

!ParameterExpression class methodsFor!

forField: aField basedOn: anObjectExpression

	^self new field: aField base: anObjectExpression; yourself! !
!ParameterExpression class categoriesFor: #forField:basedOn:!instance creation!private! !

RelationExpression guid: (GUID fromString: '{9AA20D49-8B5E-48C2-BC25-CC7FCF746A1D}')!
RelationExpression comment: 'This represents a relationship between two sub-expressions, that is something like = or AND. So in object attribute = field, we''re the equals node. We have exactly two children, and mostly just print ourselves in between them. However there is some other interesting logic in there about splitting up comparisons between objects into comparisons between keys, and even just printing can get fairly complicated.

Instance Variables:
	leftChild	<GlorpExpression>	The left child.
	rightChild	<GlorpExpression>	The right child.
	outerJoin	<Boolean>	Is this an outer join (only makes sense if we are an equality comparison.
	relation	<String>	The string or symbol that we print for our relationship.

'!
!RelationExpression categoriesForClass!Unclassified! !
!RelationExpression methodsFor!

addBoundExpressionsIn: aCommand to: boundExpressions
	"If our right-child can be used for binding, add it to the list. We need to do this at this level because the expressions themselves don't know what type they'll be matched against"

	| translated |
	rightChild canBind ifFalse: [^self].
	(boundExpressions includes: self) ifTrue: [^self].
	translated := self convertValueOf: rightChild in: aCommand parameters.
	(self useBindingFor: translated to: leftChild type in: aCommand) ifTrue: [boundExpressions add: self].!

additionalExpressions

	^#().!

allSourceFields
	"If we are sending this, then we're treating the expression as a join, for a complex (and probably read-only) relationship. So in that case we want to treat the source fields as the parameters that this expression takes, and specifically the parameters that are based on fields."
	^self inject: OrderedCollection new into: [:sum :each |
		each addToTargetFields: sum.
		sum].!

allTargetFields
	"If we are sending this, then we're treating the expression as a join, for a complex (and probably read-only) relationship. So in that case we want to treat the target fields as being the source fields of the bottom-most mapping. That is, the fields we'll use to connect to the thing we want are the things that our expression's base (which represents the thing we want) would use to connect to the first level mapping arising from it. If we have a relation, that's a bit of a mess, but guess that we want the left child's information."
	^self leftChild allTargetFields.!

asExpressionJoiningSource: source toTarget: target
	"Create a general expression which represents this relationship where the values of the targets (which are normally parameters) are supplied out of the context provided by 'target' and the source fields are referencing things out of the context of source. Produces something suitable for ANDing into an expression when doing a join
   Example: If we had CUSTOMER.ADDRESS_ID = ADDRESS.ID as a parameter, and we want to AND this into an expression [:customer | customer address street = 'Main'] then we have customer as a base, and we get 
	(customer.ADDRESS.STREET = 'Main') AND (customer.CUSTOMER.ADDRESS_ID = customer.ADDRESS.ID)
	The primary key expression for the relationship has been translated into field references into the customer and address tables in a particular context."

	| left right |
	left := leftChild asExpressionJoiningSource: source toTarget: target.
	right := rightChild asExpressionJoiningSource: source toTarget: target.
	^self class new 
		relation: relation;
		leftChild: left;
		rightChild: right.!

asGeneralGlorpExpression
	"Convert the result to a general (tree-format) expression, if it's the more limited join expression."
	| result |
	result := self copy.
	result leftChild: leftChild asGeneralGlorpExpression.
	result rightChild: rightChild asGeneralGlorpExpression.
	^result.!

asGeneralGlorpExpressionWithFields
	"Convert the result to a general (tree-format) expression, if it's the more limited join expression."
	| result |
	result := self copy.
	result leftChild: leftChild asGeneralGlorpExpressionWithFields.
	result rightChild: rightChild asGeneralGlorpExpressionWithFields.
	^result.!

asIndependentJoins
	| |
	"If this is an ANDed clause, referring to two different tables split it into independent joins"
	relation == #AND ifFalse: [^Array with: self].
	leftChild tablesForANSIJoin asSortedCollection = rightChild tablesForANSIJoin asSortedCollection
		ifTrue: [^Array with: self].
	^(Array with: leftChild with: rightChild) inject: OrderedCollection new into: [:sum :each |
		sum addAll: each asIndependentJoins. sum].!

asJoin
	| leftField rightField |
	leftField := self leftChild field.
	rightField := self rightChild field.
	(leftField notNil and: [rightField notNil]) ifTrue: [^Join from: leftField to: rightField].
	^leftChild asJoin, rightChild asJoin.!

beOuterJoin
	outerJoin := true.
	leftChild beOuterJoin.
	rightChild beOuterJoin.!

bindingIn: aCommand

	^self convertValueOf: rightChild in: aCommand parameters.!

bindingType
	"If we're to be used for binding, return the field type to be bound to"

	^self leftChild bindingType.!

canHaveBase
	"Return true if this type of expression can have a base expression on which other things can be built. Doesn't say whether we actually have a valid one or not."
	^true.!

canUseBinding
	"Return true if we can use binding for our right child's value"
	^self expectsCollectionArgument not.!

condenseBooleanEquality
	(relation = #AND | (relation = #OR)) ifFalse: [^self].
	(leftChild isGlorpExpression and: [leftChild isConstantExpression])
		ifTrue: [
			(relation = #AND and: [leftChild value = true]) ifTrue: [^rightChild].
			(relation = #AND and: [leftChild value = false]) ifTrue: [^leftChild].
			(relation = #OR and: [leftChild value = true]) ifTrue: [^leftChild].
			(relation = #OR and: [leftChild value = false]) ifTrue: [^rightChild]].
	(rightChild isGlorpExpression and: [rightChild isConstantExpression])
		ifTrue: [
			(relation = #AND and: [rightChild value = true]) ifTrue: [^leftChild].
			(relation = #AND and: [rightChild value = false]) ifTrue: [^rightChild].
			(relation = #OR and: [rightChild value = true]) ifTrue: [^rightChild].
			(relation = #OR and: [rightChild value = false]) ifTrue: [^leftChild]].

	^self.!

condenseBooleanEqualityExpressions
	leftChild := leftChild condenseBooleanEquality.
	rightChild := rightChild condenseBooleanEquality.!

condensePrimaryKeyComparisons
	"Because we're replacing the expression, we need to do it at the parent and replace the previous child"
	leftChild := leftChild condensePrimaryKeyComparison.
	rightChild := rightChild condensePrimaryKeyComparison.!

convertValueOf: anObject in: aDictionary
	| translated convertedValue |

	translated := anObject isGlorpExpression 
		ifTrue: [anObject valueIn: aDictionary]
		ifFalse: [anObject].
	translated isGlorpExpression ifTrue: [^translated].
	convertedValue := self expectsCollectionArgument 
		ifTrue: [translated collect: [:each | self leftChild convertedDbValueOf: each]]
		ifFalse: [self leftChild convertedDbValueOf: translated].
	^convertedValue.!

createFor: arguments withBase: anExpression symbol: aSymbol
	"Create a copy of our expression with the given parameters. Used in function creation, for 'functions' like isNil that really just turn into relations."

	^self class
		named: relation
		basedOn: anExpression
		withArguments: (Array with: rightChild).!

do: aBlock skipping: aSet
	| clauses |
	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	leftChild hasImpliedClauses
		ifTrue:
			[clauses := leftChild allRelationsFor: self.
			clauses do: [:each | each do: aBlock skipping: aSet]]
		ifFalse:
			[leftChild do: aBlock skipping: aSet.
			rightChild do: aBlock skipping: aSet.
			aBlock value: self.].!

expectsCollectionArgument
	^self relationsWithCollectionArguments includes: relation.!

get: aSymbol withArguments: anArray
	"We treat NOT as a function, so we have to check for functions here"
	| functionExpression |
	functionExpression := self getFunction: aSymbol withArguments: anArray.
	functionExpression isNil ifFalse: [^functionExpression].
	^anArray size = 1
		ifTrue: [RelationExpression named: aSymbol basedOn: self withArguments: anArray]
		ifFalse: ["This is either an error, or something defined as a selector on relation expressions"
			self perform: aSymbol withArguments: anArray.].!

hasBindableExpressionsIn: aCommand
	"Return true if our right-child can be used for binding. We need to do this at this level because the expressions themselves don't know what type they'll be matched against"

	| translated |
	rightChild canBind ifFalse: [^false].
	translated := self convertValueOf: rightChild in: aCommand parameters.
	^self useBindingFor: translated to: leftChild field type in: aCommand.!

isOuterJoin
	outerJoin isNil ifTrue: [outerJoin := false].
	^outerJoin.!

leftChild
	^leftChild!

leftChild: anExpression 
	leftChild := anExpression!

mappableSourceFieldsDo: aBlock
	"Used when we are emulating a Join"
	self allSourceFields do: [:source |
		source isMappable ifTrue: [aBlock value: source]].!

named: aSymbol basedOn: anExpression withArguments: anArray

	| base right rightBase |
	outerJoin := false.
	relation := self operationFor: aSymbol.
	leftChild := anExpression.

	"The only time we don't expect anExpression to have a base is if it's a constant, in which case the other side should be a variable expression and thus have a base."
	base := anExpression canHaveBase ifTrue: [anExpression ultimateBaseExpression] ifFalse: [anArray first ultimateBaseExpression].
	right := anArray first.
	right isGlorpExpression ifFalse: [rightChild := right asGlorpExpressionOn: base. ^self].
	rightBase := right ultimateBaseExpression.
	rightChild := rightBase ~= base
		ifTrue: [
			right asGlorpExpressionOn: ((rightBase notNil and: [rightBase hasDescriptor]) ifTrue: ["Correlated subselect" rightBase] ifFalse: [base])]
		ifFalse: [right].!

operationFor: aSymbol
	"Simple translation of operators"

	aSymbol == #AND: ifTrue: [^#AND].
	aSymbol == #& ifTrue: [^#AND].
	aSymbol == #OR: ifTrue: [^#OR].
	aSymbol == #| ifTrue: [^#OR].
	aSymbol == #~= ifTrue: [^#<>].
	 aSymbol == #like: ifTrue: [^#LIKE].
	 aSymbol == #ilike: ifTrue: [^#ILIKE].		"Case-insensitive variant of LIKE. Only supported on PostgreSQL at the moment"
	 aSymbol == #in: ifTrue: [^#IN].
	 aSymbol == #notIn: ifTrue: [^#'NOT IN'].

	^aSymbol.!

outerJoin
	outerJoin isNil ifTrue: [outerJoin := false].
	^outerJoin.!

outerJoin: aBoolean
	outerJoin := aBoolean.!

primaryKeyFromDictionary: aDictionary
	"Given a set of parameters, return a primary key suitable for retrieving our target. Do this only if the expression is for a primary key, and has no other conditions than the primary key one"

	| left right field |
	relation = #AND ifTrue: [
		left := leftChild primaryKeyFromDictionary: aDictionary.
		right := rightChild primaryKeyFromDictionary: aDictionary.
		^(left notNil and: [right notNil]) ifTrue: [Array with: left with: right] ifFalse: [nil]].
	relation = #= ifFalse: [^nil].
	field := leftChild fieldFromMeOrSubclasses.
	field isNil ifTrue: [^nil].
	field isGlorpExpression ifTrue: [^nil].
	^(field isPrimaryKey)
		ifTrue: [rightChild valueIn: aDictionary]
		ifFalse: [nil].!

printBasicSQLOn: aCommand withParameters: aDictionary 
	aCommand platform parenthesizeCommandsInCompoundQuery ifTrue: [aCommand nextPut: $(].
	leftChild printSQLOn: aCommand withParameters: aDictionary.
	self 
		printComparisonTo: rightChild
		withParameters: aDictionary
		on: aCommand.
	self printOracleOuterJoinOn: aCommand.
	aCommand platform parenthesizeCommandsInCompoundQuery ifTrue: [aCommand nextPut: $)]!

printComparisonTo: value withParameters: aDictionary on: aStream
	"Horribly convoluted logic to handle the cases where the value might be a constant, an expression that results in a value (constant or parameter) or a regular expression, with the caveat that any value that turns out to be null has to be printed with IS NULL rather than = NULL."

	| translated |
	translated := self convertValueOf: value in: aDictionary.
	translated isGlorpExpression
		ifTrue:
			[
			translated canPrint ifTrue: [
				self printRelationOn: aStream.
				translated
					printSQLOn: aStream
					withParameters: aDictionary]]
		ifFalse:
			[self
				printSimpleValueComparisonTo: translated
				on: aStream].!

printForANSIJoinTo: table on: aCommand
	"Print ourselves as table JOIN otherTable USING (criteria). Return the table we joined"

	self outerJoin
		ifTrue: [aCommand nextPutAll: ' LEFT OUTER JOIN ']
		ifFalse: [aCommand nextPutAll: ' INNER JOIN '].
	aCommand nextPutAll: table sqlTableName.
	aCommand nextPutAll: ' ON '.
	self printSQLOn: aCommand withParameters: aCommand parameters.
	^table.!

printMicrosoftOuterJoinOn: aCommand
	self isOuterJoin ifFalse: [^self].
	aCommand platform useMicrosoftOuterJoins ifTrue: [
		aCommand nextPutAll: '*'].!

printOnlySelfOn: aStream

	aStream nextPutAll: relation.!

printOracleOuterJoinOn: aCommand
	self isOuterJoin ifFalse: [^self].
	(self leftChild class == self class and: [self leftChild isOuterJoin]) ifTrue: [^self].
	(self rightChild class == self class and: [self rightChild isOuterJoin]) ifTrue: [^self].
	aCommand platform useOracleOuterJoins ifTrue: [
		aCommand nextPutAll: ' (+) '].!

printRelationOn: aStream
	aStream space.
	self printMicrosoftOuterJoinOn: aStream.
	aStream 
		nextPutAll: self relation;
		space.!

printSimpleValueComparisonTo: value on: aStream
	value isNil
		ifTrue: [self printWithNullOn: aStream]
		ifFalse:
			[self printRelationOn: aStream.
			self printValue: value on: aStream].!

printSQLOn: aStream withParameters: aDictionary
	self leftChild hasImpliedClauses
		ifTrue:
			[| impliedClauses |
			impliedClauses := self leftChild allRelationsFor: self.
			impliedClauses outerJoin: self outerJoin.
			impliedClauses
				printSQLOn: aStream
				withParameters: aDictionary]
		ifFalse:
			[self
				printBasicSQLOn: aStream
				withParameters: aDictionary].!

printTreeOn: aStream 
	aStream
		print: leftChild;
		space;
		nextPutAll: relation;
		space;
		print: rightChild!

printValue: value on: aCommand
	| type |
	type := [self leftChild type] on: Dialect error do: [:ex | self error: 'Invalid comparison operation: ', self printString].
	(self useBindingFor: value to: type in: aCommand) ifTrue: [^aCommand nextPutAll: '?'].
	self expectsCollectionArgument
		ifTrue:
			[type
				printCollection: value
				on: aCommand]
		ifFalse:
			[type
				print: value
				on: aCommand].!

printWithNullOn: aStream
	aStream nextPutAll: ' IS '.
	self relation = #<> ifTrue: [
		aStream nextPutAll: 'NOT '].
	aStream nextPutAll: 'NULL'.!

queryLevelBaseExpression

	^leftChild canHaveBase ifTrue: [leftChild queryLevelBaseExpression] ifFalse: [rightChild queryLevelBaseExpression].!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	| expression |
	self == anExpression ifTrue: [^aBaseExpression].
	expression := (leftChild rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression)
		get: relation
		withArguments:
			(Array
				with:
					(self rightChildToRebuild rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression)).
	self isOuterJoin ifTrue: [expression beOuterJoin].
	^expression.!

relation

	^relation.!

relation: aSymbol

	relation := aSymbol.!

relationsWithCollectionArguments
	^#(#IN #'NOT IN')!

removeNonJoinParts
	"Remove anything that's not an actual join. Only useful if we have something that has mixed joins and general expressions, where we assume we don't want to use the general ones, because they're not field level. Also only meaningful to remove this for ANDs and ORs, not sub-components."
	(relation = #AND or: [relation = #OR]) ifFalse: [^self].
	leftChild := leftChild isJoin ifTrue: [leftChild] ifFalse: [true asGlorpExpression].
	rightChild := rightChild isJoin ifTrue: [rightChild] ifFalse: [true asGlorpExpression].!

replaceJoinsWithInverse
	"Replace any actual Join objects we have with their inverse. Only useful if we have something that has mixed joins and general expressions, where we assume we don't want to mess with the general ones, because they're not field-level"
	leftChild isJoin ifTrue: [leftChild := leftChild inverseJoin].
	rightChild isJoin ifTrue: [rightChild := rightChild inverseJoin].!

rewriteEquality
	| keyEquality descriptor describedClass |
	leftChild := leftChild rewriteBooleanEquality: relation.
	leftChild hasDescriptor ifFalse: [^self].
	"A slightly convoluted way of checking if this is a pseudo-descriptor for a primitive type used in something like a DirectToManyMapping, in which case we can't rewrite. But if it's a pseudo-descriptor for a dictionary mapping where we actually use the mapping as the key rather than a class, then we're ok. It'd be nice if the code for this were more expressive."
	descriptor := leftChild descriptor.
	describedClass := descriptor describedClass.
	(describedClass ~~ Association and: [(descriptor session descriptorFor: describedClass) isNil]) ifTrue: [^self].

	(relation = #= | (relation = #<>) | (relation = #IN)) ifFalse: [^self].
	(relation = #IN and: [leftChild descriptor primaryTable primaryKeyFields size > 1]) ifTrue: [
		(GlorpInvalidExpressionError signal: 'Cannot convert an object comparison to an IN comparison when the table uses a composite primary key')].
	keyEquality := leftChild descriptor
		primaryKeyExpressionFor: rightChild
		basedOn: leftChild
		relation: relation.
	^keyEquality.!

rewriteEqualityExpressions
	leftChild := leftChild rewriteEquality.
	rightChild := rightChild rewriteEquality.!

rewriteFunctionArguments
	"If a function needs to adjust its arguments, do that here. The motivating example is one where a string argument is rewritten into a form that's of a different length, e.g. the Postgresql driver does that to strings in Blobs."
	leftChild rewriteFunctionArgumentsWith: rightChild.!

rightChild
	^rightChild!

rightChild: anExpression
	rightChild := anExpression!

rightChildToRebuild
	^rightChild.!

shortCircuitOnNullComparison: parameters
	"Return true if we represent an expression that compares null to a non-nullable value, so we don't ever need to really evaluate it.This could be more sophisticated and test if any part of an ANDed and not NOTed clause does such a comparison. But this will do for the most important cases"

	| value |
	value := rightChild valueIn: parameters.
	^(relation == #=
		and: [value isNil and: [leftChild field isNullable not]])!

sourceForTarget: aField

	| left |
	relation = #= ifFalse: [
		left := leftChild sourceForTarget: aField.
		left isNil ifFalse: [^left].
		^rightChild sourceForTarget: aField].
	rightChild field == aField ifTrue: [^leftChild field].
	leftChild field == aField ifTrue: [^rightChild field].
	^nil.!

tablesForANSIJoin
	"Which tables will we join. Assumes this is a single-level join"
	^self inject: Set new into: [:sum :each |
		each tableForANSIJoin isNil ifFalse: [sum add: each tableForANSIJoin].
		sum].!

tableToJoinFrom: aTableCollection
	"Return a table we could legitimately use at this point to write as an ANSI join - meaning that all but one must be  already used and thus available, and one that isn't. aTableCollection lists the used ones"
	| possibleTables |
	possibleTables := self tablesForANSIJoin asArray
		select: [:each | (aTableCollection includes: each) not].
	^possibleTables size = 1 ifTrue: [possibleTables first] ifFalse: [nil].!

targetKeys
	"Assume that part of us is a join, and the rest doesn't count"
	^self inject: OrderedCollection new into: [:sum :each |
		each isJoin ifTrue: [sum addAll: each targetKeys].
		sum].!

ultimateBaseExpression

	^leftChild canHaveBase ifTrue: [leftChild ultimateBaseExpression] ifFalse: [rightChild ultimateBaseExpression].!

useBindingFor: aValue to: aType in: aCommand
	"Return true if we can use binding for our right child's value, in the context of this command"
	aCommand useBinding ifFalse: [^false].
	self expectsCollectionArgument ifTrue: [^false].
	^aCommand canBind: aValue to: aType.! !
!RelationExpression categoriesFor: #addBoundExpressionsIn:to:!preparing!private! !
!RelationExpression categoriesFor: #additionalExpressions!preparing!private! !
!RelationExpression categoriesFor: #allSourceFields!As yet unclassified!private! !
!RelationExpression categoriesFor: #allTargetFields!As yet unclassified!private! !
!RelationExpression categoriesFor: #asExpressionJoiningSource:toTarget:!preparing!private! !
!RelationExpression categoriesFor: #asGeneralGlorpExpression!converting!private! !
!RelationExpression categoriesFor: #asGeneralGlorpExpressionWithFields!converting!private! !
!RelationExpression categoriesFor: #asIndependentJoins!converting!private! !
!RelationExpression categoriesFor: #asJoin!converting!private! !
!RelationExpression categoriesFor: #beOuterJoin!accessing!private! !
!RelationExpression categoriesFor: #bindingIn:!preparing!private! !
!RelationExpression categoriesFor: #bindingType!preparing!private! !
!RelationExpression categoriesFor: #canHaveBase!accessing!private! !
!RelationExpression categoriesFor: #canUseBinding!As yet unclassified!private! !
!RelationExpression categoriesFor: #condenseBooleanEquality!preparing!private! !
!RelationExpression categoriesFor: #condenseBooleanEqualityExpressions!preparing!private! !
!RelationExpression categoriesFor: #condensePrimaryKeyComparisons!preparing!private! !
!RelationExpression categoriesFor: #convertValueOf:in:!iterating!private! !
!RelationExpression categoriesFor: #createFor:withBase:symbol:!copying!private! !
!RelationExpression categoriesFor: #do:skipping:!iterating!private! !
!RelationExpression categoriesFor: #expectsCollectionArgument!As yet unclassified!private! !
!RelationExpression categoriesFor: #get:withArguments:!api!private! !
!RelationExpression categoriesFor: #hasBindableExpressionsIn:!preparing!private! !
!RelationExpression categoriesFor: #isOuterJoin!accessing!private! !
!RelationExpression categoriesFor: #leftChild!accessing!private! !
!RelationExpression categoriesFor: #leftChild:!accessing!private! !
!RelationExpression categoriesFor: #mappableSourceFieldsDo:!iterating!private! !
!RelationExpression categoriesFor: #named:basedOn:withArguments:!private!private/initializing! !
!RelationExpression categoriesFor: #operationFor:!private!private/initializing! !
!RelationExpression categoriesFor: #outerJoin!accessing!private! !
!RelationExpression categoriesFor: #outerJoin:!accessing!private! !
!RelationExpression categoriesFor: #primaryKeyFromDictionary:!As yet unclassified!private! !
!RelationExpression categoriesFor: #printBasicSQLOn:withParameters:!printing SQL!private! !
!RelationExpression categoriesFor: #printComparisonTo:withParameters:on:!printing SQL!private! !
!RelationExpression categoriesFor: #printForANSIJoinTo:on:!As yet unclassified!private! !
!RelationExpression categoriesFor: #printMicrosoftOuterJoinOn:!printing SQL!private! !
!RelationExpression categoriesFor: #printOnlySelfOn:!printing!private! !
!RelationExpression categoriesFor: #printOracleOuterJoinOn:!printing SQL!private! !
!RelationExpression categoriesFor: #printRelationOn:!printing SQL!private! !
!RelationExpression categoriesFor: #printSimpleValueComparisonTo:on:!printing SQL!private! !
!RelationExpression categoriesFor: #printSQLOn:withParameters:!printing SQL!private! !
!RelationExpression categoriesFor: #printTreeOn:!printing!private! !
!RelationExpression categoriesFor: #printValue:on:!printing SQL!private! !
!RelationExpression categoriesFor: #printWithNullOn:!printing SQL!private! !
!RelationExpression categoriesFor: #queryLevelBaseExpression!navigating!private! !
!RelationExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!RelationExpression categoriesFor: #relation!accessing!private! !
!RelationExpression categoriesFor: #relation:!accessing!private! !
!RelationExpression categoriesFor: #relationsWithCollectionArguments!As yet unclassified!private! !
!RelationExpression categoriesFor: #removeNonJoinParts!preparing!private! !
!RelationExpression categoriesFor: #replaceJoinsWithInverse!preparing!private! !
!RelationExpression categoriesFor: #rewriteEquality!preparing!private! !
!RelationExpression categoriesFor: #rewriteEqualityExpressions!preparing!private! !
!RelationExpression categoriesFor: #rewriteFunctionArguments!preparing!private! !
!RelationExpression categoriesFor: #rightChild!accessing!private! !
!RelationExpression categoriesFor: #rightChild:!accessing!private! !
!RelationExpression categoriesFor: #rightChildToRebuild!preparing!private! !
!RelationExpression categoriesFor: #shortCircuitOnNullComparison:!private!testing! !
!RelationExpression categoriesFor: #sourceForTarget:!converting!private! !
!RelationExpression categoriesFor: #tablesForANSIJoin!As yet unclassified!private! !
!RelationExpression categoriesFor: #tableToJoinFrom:!As yet unclassified!private! !
!RelationExpression categoriesFor: #targetKeys!As yet unclassified!private! !
!RelationExpression categoriesFor: #ultimateBaseExpression!navigating!private! !
!RelationExpression categoriesFor: #useBindingFor:to:in:!As yet unclassified!private! !

!RelationExpression class methodsFor!

named: aSymbol basedOn: anExpression withArguments: anArray

	^self new
		named: aSymbol
		basedOn: anExpression
		withArguments: anArray.! !
!RelationExpression class categoriesFor: #named:basedOn:withArguments:!instance creation!private! !

DualRoleFunction guid: (GUID fromString: '{9D819B75-34FE-47D6-AD19-DD7C3C94FA78}')!
DualRoleFunction comment: 'This is a function that prints in different ways in a field list than it does in a where clause, typically because use of the where clause version isn''t supported in field lists.'!
!DualRoleFunction categoriesForClass!Unclassified! !
!DualRoleFunction methodsFor!

arguments
	^arguments.!

arguments: anArray
	arguments := anArray.
	whereClauseVersion arguments: anArray.
	selectListVersion arguments: anArray.!

asField
	^self.!

base: anExpression
	base := anExpression.
	"whereClauseVersion base: anExpression."
	selectListVersion base: anExpression.!

basicArguments: anArray
	arguments := anArray.!

basicBase: anExpression
	base := anExpression.!

copy
	| new |
	new := super copy.
	"We need to make sure we copy these before the base gets set. This is horribly ugly."
	new selectListVersion: selectListVersion copy.
	new whereClauseVersion: whereClauseVersion copy.
	^new.!

createFor: argumentList withBase: anExpression symbol: aSymbol
	| new newBase newArgument newFunction |
	new := super createFor: argumentList withBase: anExpression symbol: aSymbol.
	"For the where clause version, we've got a dualRoleFunction. We can't just rebuild the whole thing, so rebuild the children, and then re-assemble it recreating from the template."
	newBase := new whereClauseVersion base isNil ifTrue: [anExpression] ifFalse: [new whereClauseVersion base rebuildOn: anExpression].
	newArgument := new whereClauseVersion argument rebuildOn: anExpression.
	newFunction := self whereClauseVersion copy.
	newFunction symbol: aSymbol.
	newFunction base: newBase.
	newFunction argument: newArgument.
	new whereClauseVersion: newFunction.
	"Don't try to rebuild the selectListVersion at all, because at least for the motivating case we have, it's just a shell, not a full blown expression, and it will already have been copied."
	^new.!

do: aBlock skipping: aSet
	"Iterate over the expression tree. Keep track of who has already been visited, so we don't get trapped in cycles or visit nodes twice."

	(aSet includes: self) ifTrue: [^self].
	super do: aBlock skipping: aSet.
	arguments do: [:each |
		each do: aBlock skipping: aSet].!

field
	^whereClauseVersion field.!

printSelectSQLOn: aStream withParameters: aDictionary
	selectListVersion printSelectSQLOn: aStream withParameters: aDictionary.!

printSQLOn: aStream withParameters: aDictionary
	whereClauseVersion printSQLOn: aStream withParameters: aDictionary.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	| rebuilt |
	self == anExpression ifTrue: [^aBaseExpression].
	"Rebuilding just one of them will rebuild our whole structure, since it all comes from the same definition."
	rebuilt := whereClauseVersion rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression.
	rebuilt == whereClauseVersion ifTrue: [^self].

	rebuilt arguments: (self arguments collect: [:each | each rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression]).
	^rebuilt.!

selectListVersion
	^selectListVersion.!

selectListVersion: aFunctionExpression
	selectListVersion := aFunctionExpression.!

symbol: aSymbol
	symbol := aSymbol.
	whereClauseVersion symbol: aSymbol.
	selectListVersion symbol: aSymbol.!

type: aSymbol
	super type: aSymbol.
	whereClauseVersion type: aSymbol.
	selectListVersion type: aSymbol.!

whereClauseVersion
	^whereClauseVersion.!

whereClauseVersion: aFunctionExpression
	whereClauseVersion := aFunctionExpression.! !
!DualRoleFunction categoriesFor: #arguments!accessing!private! !
!DualRoleFunction categoriesFor: #arguments:!accessing!private! !
!DualRoleFunction categoriesFor: #asField!converting!private! !
!DualRoleFunction categoriesFor: #base:!accessing!private! !
!DualRoleFunction categoriesFor: #basicArguments:!accessing!private! !
!DualRoleFunction categoriesFor: #basicBase:!accessing!private! !
!DualRoleFunction categoriesFor: #copy!copying!private! !
!DualRoleFunction categoriesFor: #createFor:withBase:symbol:!copying!private! !
!DualRoleFunction categoriesFor: #do:skipping:!iterating!private! !
!DualRoleFunction categoriesFor: #field!accessing!private! !
!DualRoleFunction categoriesFor: #printSelectSQLOn:withParameters:!printing!private! !
!DualRoleFunction categoriesFor: #printSQLOn:withParameters:!printing!private! !
!DualRoleFunction categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!DualRoleFunction categoriesFor: #selectListVersion!accessing!private! !
!DualRoleFunction categoriesFor: #selectListVersion:!accessing!private! !
!DualRoleFunction categoriesFor: #symbol:!accessing!private! !
!DualRoleFunction categoriesFor: #type:!accessing!private! !
!DualRoleFunction categoriesFor: #whereClauseVersion!accessing!private! !
!DualRoleFunction categoriesFor: #whereClauseVersion:!accessing!private! !

InfixFunction guid: (GUID fromString: '{403AE2B8-AE8E-4858-8243-636800D4CA75}')!
InfixFunction comment: 'This is a function that is infix. That is, it prints its name in between its arguments. For example, + for string concatenation, || for logical OR. 

Instance Variables:
	arguments	<Collection of GlorpExpression>	Our post-arguments (the first one being the base).
	functionParts <Array of: String> The parts of our name. For a two-argument function, this is just the same as an array containing the name, but for one with more (e.g. BETWEEN AND) it contains the different portions of the name.
'!
!InfixFunction categoriesForClass!Unclassified! !
!InfixFunction methodsFor!

argument
	^arguments first.!

argument: anObject
	arguments := Array with: anObject.!

arguments
	^arguments.!

arguments: anArray
	arguments := anArray.!

asExpressionJoiningSource: source toTarget: target
	"Create a general expression which represents this relationship where the values of the targets (which are normally parameters) are supplied out of the context provided by 'target' and the source fields are referencing things out of the context of source. Produces something suitable for ANDing into an expression when doing a join
   Example: If we had CUSTOMER.ADDRESS_ID = ADDRESS.ID as a parameter, and we want to AND this into an expression [:customer | customer address street = 'Main'] then we have customer as a base, and we get 
	(customer.ADDRESS.STREET = 'Main') AND (customer.CUSTOMER.ADDRESS_ID = customer.ADDRESS.ID)
	The primary key expression for the relationship has been translated into field references into the customer and address tables in a particular context."
	
	| newArguments |
	newArguments := arguments collect: [:each | each asExpressionJoiningSource: source toTarget: target].
	^(super asExpressionJoiningSource: source toTarget: target) arguments: newArguments.!

asField
	"If we correspond to a single field, return it. This is a bit of a hack having this only here, because for some functions it doesn't work."
	^self.!

do: aBlock skipping: aSet
	"Iterate over the expression tree. Keep track of who has already been visited, so we don't get trapped in cycles or visit nodes twice."

	(aSet includes: self) ifTrue: [^self].
	super do: aBlock skipping: aSet.
	arguments do: [:each | each do: aBlock skipping: aSet].!

functionParts
	functionParts isNil ifTrue: [functionParts := Array with: function].
	^functionParts.!

functionParts: anArray
	functionParts := anArray.!

printSQLOn: aStream withParameters: aDictionary
	| translated |
	base printSQLOn: aStream withParameters: aDictionary.
	self printsIntoJoins ifFalse: [^self].
	1 to: self functionParts size do: [:i |
		aStream 
			nextPut: $ ;
			nextPutAll: (self functionParts at: i);
			nextPut: $ .
		i > arguments size ifFalse: [ 
			translated := self convertValueOf: (arguments at: i) in: aDictionary.
			translated isGlorpExpression
				ifTrue: [translated printSQLOn: aStream withParameters: aDictionary]
				ifFalse: [self type print: translated on: aStream]]].!

printTreeOn: aStream 
	base printOn: aStream.
	aStream
		nextPutAll: ' ', function, ' '.
	arguments printOn: aStream.!

printUnqualifiedSQLOn: aStream withParameters: aDictionary
	base printUnqualifiedSQLOn: aStream withParameters: aDictionary.
	self functionParts with: arguments do: [:functionPart :arg |
		aStream 
			nextPut: $ ;
			nextPutAll: functionPart;
			nextPut: $ .
		arg printUnqualifiedSQLOn: aStream withParameters: aDictionary].!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	| rebuilt newArgs |
	self == anExpression ifTrue: [^aBaseExpression].
	base == aBaseExpression ifTrue: [^self].
	newArgs := arguments collect: [:each | each rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression].
	rebuilt := (base rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression) get: self symbol withArguments: newArgs.
	rebuilt alias: self alias.
	^rebuilt.! !
!InfixFunction categoriesFor: #argument!accessing!private! !
!InfixFunction categoriesFor: #argument:!accessing!private! !
!InfixFunction categoriesFor: #arguments!accessing!private! !
!InfixFunction categoriesFor: #arguments:!accessing!private! !
!InfixFunction categoriesFor: #asExpressionJoiningSource:toTarget:!preparing!private! !
!InfixFunction categoriesFor: #asField!converting!private! !
!InfixFunction categoriesFor: #do:skipping:!iterating!private! !
!InfixFunction categoriesFor: #functionParts!accessing!private! !
!InfixFunction categoriesFor: #functionParts:!accessing!private! !
!InfixFunction categoriesFor: #printSQLOn:withParameters:!printing!private! !
!InfixFunction categoriesFor: #printTreeOn:!printing!private! !
!InfixFunction categoriesFor: #printUnqualifiedSQLOn:withParameters:!printing!private! !
!InfixFunction categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !

!InfixFunction class methodsFor!

named: aStringOrArray
	| instance trimmedName |
	instance := self new.
	aStringOrArray isString
		ifTrue: [instance function: aStringOrArray]
		ifFalse: [
			instance functionParts: aStringOrArray.
			trimmedName := aStringOrArray copyFrom: 2 to: aStringOrArray size.
			instance function: (trimmedName inject: aStringOrArray first into: [:sum :each | sum, ' ', each])].
	^instance.! !
!InfixFunction class categoriesFor: #named:!instance creation!private! !

PostfixFunction guid: (GUID fromString: '{79CBFFE2-29BD-49CD-B136-C6E06BD26158}')!
PostfixFunction comment: 'This represents a function that prints postfix, meaning its name comes after its argument. For example, DESC for a descending sort. That''s maybe stretching the definition of a function, but that''s how it''s implemented for purposes of Glorp SQL definition.
'!
!PostfixFunction categoriesForClass!Unclassified! !
!PostfixFunction methodsFor!

printSQLOn: aStream withParameters: aDictionary
	
	base printSQLOn: aStream withParameters: aDictionary.
	self printsIntoJoins ifFalse: [^self].
	aStream nextPutAll: ' '; nextPutAll: function.!

printUnqualifiedSQLOn: aStream withParameters: aDictionary
	
	base printUnqualifiedSQLOn: aStream withParameters: aDictionary.
	aStream nextPutAll: ' '; nextPutAll: function.! !
!PostfixFunction categoriesFor: #printSQLOn:withParameters:!printing!private! !
!PostfixFunction categoriesFor: #printUnqualifiedSQLOn:withParameters:!printing!private! !

PrefixFunction guid: (GUID fromString: '{4C20B809-3571-4496-922F-54A25BB059BC}')!
PrefixFunction comment: 'This represents a function which prints prefix, printing its name, followed by the arguments in parentheses. This is the most common sort of function, e.g. MIN(), MAX(), DISTINCT, TO_CHAR 

Instance Variables:
	arguments	<(SequenceableCollection of: GlorpExpression)>	Our arguments (in addition to our base).
	separator	<String>	What we will use to separate the arguments. By default, a comma.

'!
!PrefixFunction categoriesForClass!Unclassified! !
!PrefixFunction methodsFor!

argumentModifierBlock
	^argumentModifierBlock!

argumentModifierBlock: aBlock
	argumentModifierBlock := aBlock!

arguments
	^arguments.!

arguments: aCollection
	"Our arguments may have already been set to a block, in which case we evaluate it with the incoming collection."
	argumentModifierBlock notNil ifTrue: [^arguments := argumentModifierBlock value: self value: aCollection].
	arguments := aCollection.!

convertedStValueOf: anObject
	"This assumes that functions that do conversions have already had their effect in the database, and all we're concerned with is the fundamental data type conversion"
	^base convertedStValueOf: anObject.!

do: aBlock skipping: aSet
	"Iterate over the expression tree. Keep track of who has already been visited, so we don't get trapped in cycles or visit nodes twice."

	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	base do: aBlock skipping: aSet.
	arguments do: [:each | each do: aBlock skipping: aSet].
	aBlock value: self.!

initialize
	super initialize.
	arguments := #().
	separator := ','.!

printBasicSQLOn: aStream withParameters: aDictionary forSelect: aBoolean
	aStream
		nextPutAll: function;
		nextPut: $(.
	aBoolean
		ifTrue: [base printSelectSQLOn: aStream withParameters: aDictionary]
		ifFalse: [base printSQLOn: aStream withParameters: aDictionary].
	arguments
		do:
			[:each | 
			"It's possible there needs to be type conversion here similar to InfixFunction>>printSQLOn:withParameters:, but it's not clear how common that case is, or how best to do it, so leaving it until it becomes a problem."
			aStream nextPutAll: separator.
			aBoolean 
				ifTrue: [each printSelectSQLOn: aStream withParameters: aDictionary]
				ifFalse: [each printSQLOn: aStream withParameters: aDictionary]].
	aStream nextPut: $).
	alias notNil
		ifTrue:
			[aStream
				nextPutAll: ' AS ';
				nextPutAll: alias].!

printSelectSQLOn: aStream withParameters: aDictionary
	self printBasicSQLOn: aStream withParameters: aDictionary forSelect: true.!

printSQLOn: aStream withParameters: aDictionary
	self printsIntoJoins
		ifTrue: [self printBasicSQLOn: aStream withParameters: aDictionary forSelect: false]
		ifFalse: [base printSQLOn: aStream withParameters: aDictionary].!

printTreeOn: aStream 
	aStream
		nextPutAll: function, '('.
	base printOn: aStream.
	aStream nextPutAll: ')'.!

separator
	^separator!

separator: aString
	separator := aString! !
!PrefixFunction categoriesFor: #argumentModifierBlock!accessing!private! !
!PrefixFunction categoriesFor: #argumentModifierBlock:!accessing!private! !
!PrefixFunction categoriesFor: #arguments!accessing!private! !
!PrefixFunction categoriesFor: #arguments:!accessing!private! !
!PrefixFunction categoriesFor: #convertedStValueOf:!converting!private! !
!PrefixFunction categoriesFor: #do:skipping:!iterating!private! !
!PrefixFunction categoriesFor: #initialize!initializing!private! !
!PrefixFunction categoriesFor: #printBasicSQLOn:withParameters:forSelect:!printing!private! !
!PrefixFunction categoriesFor: #printSelectSQLOn:withParameters:!printing!private! !
!PrefixFunction categoriesFor: #printSQLOn:withParameters:!printing!private! !
!PrefixFunction categoriesFor: #printTreeOn:!printing!private! !
!PrefixFunction categoriesFor: #separator!accessing!private! !
!PrefixFunction categoriesFor: #separator:!accessing!private! !

StandaloneFunction guid: (GUID fromString: '{AFA95B83-A40E-41E6-A169-976039C9DF1F}')!
StandaloneFunction comment: 'This represents a function that takes no arguments and is complete in itself. The obvious example is COUNT(*). Making a special ''*'' pseudo-field seems even more of a hack than just hard-coding it into a function like this. It''s possible that things like nextval(sequence) might be able to fall in this category too.'!
!StandaloneFunction categoriesForClass!Unclassified! !
!StandaloneFunction methodsFor!

field
	^nil.!

mappedFields
	^Array with: self.!

printSQLOn: aStream withParameters: aDictionary
	aStream nextPutAll: ' '; nextPutAll: function.!

type
	type isNil ifFalse: [^type].
	^self defaultType.!

valueInBuilder: anElementBuilder
	^anElementBuilder valueOfField: self!

valueInBuilder: anElementBuilder as: anExpression
	^anElementBuilder valueOfField: anExpression.! !
!StandaloneFunction categoriesFor: #field!accessing!public! !
!StandaloneFunction categoriesFor: #mappedFields!mapping!private! !
!StandaloneFunction categoriesFor: #printSQLOn:withParameters:!printing!private! !
!StandaloneFunction categoriesFor: #type!accessing!private! !
!StandaloneFunction categoriesFor: #valueInBuilder:!mapping!private! !
!StandaloneFunction categoriesFor: #valueInBuilder:as:!mapping!private! !

Case guid: (GUID fromString: '{ADBB3AE2-9CA0-4EE7-B7F1-1CF64AB11B8F}')!
Case comment: 'This represents a function which prints prefix, printing CASE, followed by the argument in parentheses, and then the rest of the MS SQL Server CASE statement, with a single test condition (WHEN) and a default value (ELSE):

CASE (arg1)
	WHEN arg2 THEN arg3 
	ELSE arg4
END AS arg5

For example:

CASE (''SELECT count(*) FROM aTable'')
	WHEN ''0'' THEN 0 
	ELSE 1 
END AS arg3
'!
!Case categoriesForClass!Unclassified! !
!Case methodsFor!

argumentTypes: anArray 
	argumentTypes := anArray.!

initialize
	super initialize.
	function := 'CASE'.
	separator := ' '.
	argumentTypes := OrderedCollection new: 3.!

printBasicSQLOn: aStream withParameters: aDictionary forSelect: aBoolean
	"Example: CASE (base?)
		WHEN arg1 THEN arg2 
		 ELSE arg3
	END AS alias"
	
	aStream
		nextPutAll: function;
		nextPut: $(.
	aBoolean
		ifTrue: [base printSelectSQLOn: aStream withParameters: aDictionary]
		ifFalse: [base printSQLOn: aStream withParameters: aDictionary].
	aStream nextPutAll: ')'.
	1 to: arguments size do: [:i |
		| keyword argument argumentType |
		keyword := #(' WHEN ' ' THEN ' ' ELSE ') at: i.
		argument := arguments at: i.
		argumentType := argumentTypes at: i.
		aStream nextPutAll: keyword.
		"Our printing of constants with types is unfortunately tied up with relation expressions, so we shortcircuit some of the logic and just have the types print directly. This will not let us e.g. bind parameters to this function, but we don't expect to be doing that right now."
		argumentType print: argument on: aStream].

	aStream nextPutAll: ' END '.
	alias notNil
		ifTrue: [aStream
				nextPutAll: ' AS ';
				nextPutAll: alias]! !
!Case categoriesFor: #argumentTypes:!As yet unclassified!private! !
!Case categoriesFor: #initialize!initializing!private! !
!Case categoriesFor: #printBasicSQLOn:withParameters:forSelect:!printing!private! !

Cast guid: (GUID fromString: '{C2464926-D05C-4628-82B5-74BF58E4382A}')!
Cast comment: 'This is an attempt to allow a cast to be used on constants, as e.g.
   CAST value: ''1-2-3'' as: platform date
It doesn''t work yet, since printing of constants doesn''t like having functions in the way - it conflicts with type conversion, and looks like it''ll take a bit of work to fix.'!
!Cast categoriesForClass!Unclassified! !
!Cast methodsFor!

initialize
	super initialize.
	function := 'CAST'.
	separator := ' AS '.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	^super rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression.
"	| rebuilt |
	self == anExpression ifTrue: [^aBaseExpression].
	rebuilt := (base rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression).
	rebuilt := self class value: base as: arguments first.
	rebuilt alias: self alias.
	^rebuilt."!

type
	^arguments last value.! !
!Cast categoriesFor: #initialize!initialize-release!private! !
!Cast categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!Cast categoriesFor: #type!accessing!private! !

!Cast class methodsFor!

value: anObject as: aDatabaseType
	self error: 'this is work in progress, you probably shouldn''t use it yet'.
	(anObject isNil or: [anObject isGlorpExpression and: [anObject isConstantExpression and: [anObject value isNil]]])
		ifTrue: [^anObject].
	^self new base: anObject asGlorpExpression; arguments: (Array with: aDatabaseType asGlorpExpression).! !
!Cast class categoriesFor: #value:as:!instance creation!private! !

SubstringFunction guid: (GUID fromString: '{65EB2A4E-6DCD-4C7C-9F36-D9636D8295B5}')!
SubstringFunction comment: 'This is a function subclass specifically for substring functions. It needs its own separate subclass because it has to be written out differently for different databases, particularly if applied to LOB types.'!
!SubstringFunction categoriesForClass!Unclassified! !
!SubstringFunction methodsFor!

rewriteForOracleBlobsWith: mainArgument
	"For Oracle blobs, we can't query with a normal substring function, but rather have to use the DBMS_LOB function, whose arguments are backwards. Further, we don't seem to be able to compare to byte-arrays, so turn it into a string."
	| oldBase template startPosition endPosition length |
	(mainArgument isGlorpExpression and: [mainArgument isConstantExpression]) ifFalse: [^self].
	function := 'UTL_RAW.CAST_TO_VARCHAR2'.
	startPosition := arguments first value.
	endPosition := arguments last value.
	length := arguments last value.
	arguments := #().
	oldBase := base.
	template := PrefixFunction named: 'DBMS_LOB.SUBSTR'.
	base := template createFor: (Array with: length asGlorpExpression with: startPosition asGlorpExpression) withBase: oldBase symbol: #dbmsLobSubstr.!

rewriteForPostgresqlBase64BlobsWith: mainArgument
	"This is pretty awful. We expect our main argument to be a string, and we're a substring function, but we know that for some types, the string representation comes out differently in the database. In particular, the Postgresql driver stores strings into lobs in Base64. So, if our previous argument = the string size, rewrite it to the database size. This makes it work if we do
    (someObject blob copyFrom: 1 to: 3) = 'abc'
when in fact, the length of that string in the blob will be 4."
	| stream actualArgument base64Length base64Start |
	(mainArgument isGlorpExpression and: [mainArgument isConstantExpression]) ifFalse: [^self].
	self field type = self field platform blob ifFalse: [^self].
	(mainArgument value size \\ 3) = 0 ifFalse: [self error: 'Sorry, but you will need to use a number of characters that base64 encodes exactly'].
	base64Length := (mainArgument value size // 3) * 4.
	arguments at: 2 put: base64Length asGlorpExpression.
	base64Start := ((arguments first value // 3) * 4) + 1.
	arguments at: 1 put: base64Start asGlorpExpression.
	stream := WriteStream on: String new.
	self field type print: mainArgument value on: stream.
	actualArgument := (ReadStream on: stream contents) skip: 1; upTo: $'.
	mainArgument value: actualArgument.!

rewriteFunctionArguments
	"For Postgres, MySQL, SQL Server and DB2, it wants position, length rather than startPosition, endPosition."

	| platform |
	platform := base ultimateBaseExpression system platform.
	(#(#PostgreSQLPlatform #MySQLPlatform #SQLServerPlatform #DB2Platform #OraclePlatform)
		includes: platform class name)
			ifTrue: [arguments last value: arguments last value - arguments first value + 1]!

rewriteFunctionArgumentsWith: mainArgument
	"This is pretty awful. We expect our main argument to be a string, and we're a substring function, but we know that for some types, the string representation comes out differently in the database. In particular, the Postgresql driver stores strings into lobs in Base64. So, if our previous argument = the string size, rewrite it to the database size. This makes it work if we do
    (someObject blob copyFrom: 1 to: 3) = 'abc'
when in fact, the length of that string in the blob will be 4."

	| platform |
	platform := base ultimateBaseExpression system platform.
	(platform isPostgreSQLPlatform and: [self field type = platform blob])
		ifTrue: [^self rewriteForPostgresqlBase64BlobsWith: mainArgument].
	(platform isOraclePlatform and: [self field type = platform blob])
		ifTrue: [^self rewriteForOracleBlobsWith: mainArgument]!

type

	| aPlatform |
	^(aPlatform := self ultimateBaseExpression system platform) isDB2Platform
		ifTrue: [super type]
		ifFalse: [aPlatform varchar: 255]! !
!SubstringFunction categoriesFor: #rewriteForOracleBlobsWith:!public!rewriting! !
!SubstringFunction categoriesFor: #rewriteForPostgresqlBase64BlobsWith:!private!rewriting! !
!SubstringFunction categoriesFor: #rewriteFunctionArguments!preparing!public! !
!SubstringFunction categoriesFor: #rewriteFunctionArgumentsWith:!public!rewriting! !
!SubstringFunction categoriesFor: #type!accessing!public! !

BaseExpression guid: (GUID fromString: '{8AF900A2-1CC5-440D-A309-73468A14FAE4}')!
BaseExpression comment: 'This represents the base object that we''re looking for in a query. So if we ask to read: Person, then we will have a base expression corresponding to Person. Even if what we end up retrieving is not part of the Person object, it remains the base, because it''s what defines our point of view.

Instance Variables:
	availableSubSelectNumber	<Integer>	As the base of the query, we keep track of how many subselects there are. New subselects will need to have a unique number so they can prefix their tables as e.g. s1t1 when aliasing them, and the number comes from this counter.
	descriptor	<Descriptor>	The descriptor for the class we''re looking for.

'!
!BaseExpression categoriesForClass!Unclassified! !
!BaseExpression methodsFor!

additionalExpressions
	| expressions |
	expressions := OrderedCollection new.
	self descriptor typeMapping addTypeMappingCriteriaTo: expressions in: self.
	expressions addAll: self multipleTableExpressions.
	^expressions!

additionalExpressionsOn: anExpression
	^#().!

asExpressionJoiningSource: source toTarget: target
	"Create a general expression which represents this relationship where the values of the targets (which are normally parameters) are supplied out of the context provided by 'target' and the source fields are referencing things out of the context of source. Produces something suitable for ANDing into an expression when doing a join
   Example: If we had CUSTOMER.ADDRESS_ID = ADDRESS.ID as a parameter, and we want to AND this into an expression [:customer | customer address street = 'Main'] then we have customer as a base, and we get 
	(customer.ADDRESS.STREET = 'Main') AND (customer.CUSTOMER.ADDRESS_ID = customer.ADDRESS.ID)
	The primary key expression for the relationship has been translated into field references into the customer and address tables in a particular context."

	^source.!

availableSubSelectNumber
	availableSubSelectNumber := availableSubSelectNumber isNil ifTrue: [1] ifFalse: [availableSubSelectNumber + 1].
	^availableSubSelectNumber.!

base

	^nil.!

canBeUsedForRetrieve
	"Return true if this is a valid argument for a retrieve: clause"
	^true.!

canHaveBase
	"Return true if this type of expression can have a base expression on which other things can be built. We don't have a base, but we *are* a base, so return true"
	^true.!

canPrint
	"Return true if we can print into a where clause"
	^false.!

className

	^'Base'.!

controlsTables

	^true.!

descriptor

	^descriptor!

descriptor: aDescriptor
	descriptor := aDescriptor!

fieldsForSelectStatement
	^self descriptor mappedFields.!

getParameter: aDatabaseField 
	^ParameterExpression forField: aDatabaseField basedOn: self.!

hasDescriptor

	^self descriptor notNil.!

mappedFields
	^self descriptor mappedFields collect: [:each | self translateField: each].!

mapsSimpleObject
	"Try to do a fast test for this, to look for the pseudo-descriptors that direct to-many mappings use."
	^self descriptor mappings size = 1 and: [(self descriptor mappingForAttributeNamed: #myValue) notNil].!

multipleTableExpressions
	^self descriptor multipleTableJoin 
		collect: [:each | each asExpressionJoiningSource: self toTarget: self]!

printOn: aStream 
	aStream
		nextPutAll: self className;
		nextPut: $(.
	self printTreeOn: aStream.
	aStream nextPut: $)!

printOnlySelfOn: aStream 
	self descriptor isNil ifTrue: [aStream nextPutAll: 'Empty Base'. ^self].
	aStream print: self descriptor describedClass.
	self printTableAliasesOn: aStream!

printSelectSQLOn: aStream withParameters: aDictionary 
	"Normally, we're not printable, but we might be if we're inverting a direct to-many mapping. In that case, there should only be one mapped field"
	self descriptor mappedFields do: [:each | (self translateField: each) printSQLOn: aStream withParameters: aDictionary].!

printSQLOn: aStream withParameters: aDictionary 
	"Do nothing. We're not printable"!

printTreeOn: aStream 
	aStream 
		print: (self descriptor isNil ifTrue: [nil] ifFalse: [self descriptor describedClass])!

queryLevelBaseExpression

	^self!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	anExpression isNil ifTrue: [^aBaseExpression].
	anExpression == self ifTrue: [^aBaseExpression].
	^ultimateBaseExpression isNil ifTrue: [self] ifFalse: [ultimateBaseExpression].!

referenceClass
	"Return the class that our mapping refers to, if we have a mapping. If we're a base expression, just return our class, and if we're a table expression, just return nil."
	^self descriptor describedClass.!

system
	self descriptor isNil ifTrue: [^nil].
	^self descriptor system.!

table

	^self descriptor primaryTable.!

tables

	^self descriptor isNil ifTrue: [#()] ifFalse: [self descriptor tables].!

tablesToPrint
	"We derive the base's tables from the fields that are being selected, but make sure that at least the primary table is listed."
	self descriptor tables isEmpty ifTrue: [^#()].
	^Array with: (self aliasedTableFor: self descriptor primaryTable).!

targetDescriptor
	self halt!

trueBase
	^self.!

ultimateBaseExpression

	^self!

valueInBuilder: anElementBuilder
	"If we ever get here, this is because we're being used as the reverse of a direct to-many mapping, so we expect to have a descriptor with only one mapping, named #myValue"
	| mapping |
	mapping := self descriptor mappingForAttributeNamed: #myValue.
	^mapping valueInBuilder: anElementBuilder as: (self get: #myValue) field.! !
!BaseExpression categoriesFor: #additionalExpressions!accessing!private! !
!BaseExpression categoriesFor: #additionalExpressionsOn:!preparing!private! !
!BaseExpression categoriesFor: #asExpressionJoiningSource:toTarget:!preparing!private! !
!BaseExpression categoriesFor: #availableSubSelectNumber!preparing!private! !
!BaseExpression categoriesFor: #base!api!private! !
!BaseExpression categoriesFor: #canBeUsedForRetrieve!private!testing! !
!BaseExpression categoriesFor: #canHaveBase!accessing!private! !
!BaseExpression categoriesFor: #canPrint!private!testing! !
!BaseExpression categoriesFor: #className!printing!private! !
!BaseExpression categoriesFor: #controlsTables!preparing!private! !
!BaseExpression categoriesFor: #descriptor!accessing!private! !
!BaseExpression categoriesFor: #descriptor:!accessing!private! !
!BaseExpression categoriesFor: #fieldsForSelectStatement!preparing!private! !
!BaseExpression categoriesFor: #getParameter:!api!private! !
!BaseExpression categoriesFor: #hasDescriptor!accessing!private! !
!BaseExpression categoriesFor: #mappedFields!accessing!private! !
!BaseExpression categoriesFor: #mapsSimpleObject!private!testing! !
!BaseExpression categoriesFor: #multipleTableExpressions!accessing!private! !
!BaseExpression categoriesFor: #printOn:!printing!private! !
!BaseExpression categoriesFor: #printOnlySelfOn:!printing!private! !
!BaseExpression categoriesFor: #printSelectSQLOn:withParameters:!printing!private! !
!BaseExpression categoriesFor: #printSQLOn:withParameters:!printing!private! !
!BaseExpression categoriesFor: #printTreeOn:!printing!private! !
!BaseExpression categoriesFor: #queryLevelBaseExpression!navigating!private! !
!BaseExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!BaseExpression categoriesFor: #referenceClass!api!private! !
!BaseExpression categoriesFor: #system!accessing!private! !
!BaseExpression categoriesFor: #table!accessing!private! !
!BaseExpression categoriesFor: #tables!accessing!private! !
!BaseExpression categoriesFor: #tablesToPrint!preparing!private! !
!BaseExpression categoriesFor: #targetDescriptor!accessing!private! !
!BaseExpression categoriesFor: #trueBase!accessing!private! !
!BaseExpression categoriesFor: #ultimateBaseExpression!navigating!private! !
!BaseExpression categoriesFor: #valueInBuilder:!mapping!private! !

MappingExpression guid: (GUID fromString: '{FA4EFC49-5681-4A23-8E7D-46208533E6F3}')!
MappingExpression comment: 'This represents an attribute of some other object. It''s called a mapping expression because each attribute has a mapping, and when we come to prepare the query, we''ll be using that mapping''s information to deduce joins, and to print properly.

Instance Variables:
	base	<BaseExpression | MappingExpression>	The expression we are built on, which is to say the expression describing the object of which we are an attribute.
	mapping	<Mapping>	The mapping we correspond to in the base. So if the base was [:each | each owner city] and we are #name, then we the mapping is for the attribute #name in the descriptor for City.
	name	<Symbol>	The name of our attribute. We will use this to determine the mapping.
	outerJoin	<Boolean>	Are we to interpret the join to our parent object''s table as being an outer join or not?
	phantom <Boolean> Is this a phantom mapping - one which is not defined in the descriptor explicitly, but is temporarily created to define a reverse relationship, an alsoFetch of subclasses, or some other transient usage.

'!
!MappingExpression categoriesForClass!Unclassified! !
!MappingExpression methodsFor!

additionalExpressions
	^self additionalExpressionsOn: self.!

additionalExpressionsOn: anExpression
	"We can get hijacked, so pass in the expression to use rather than just using self"
	| exp |
	self mapping isNil ifTrue: [^#()].
	exp := self mapping joinExpressionFor: anExpression.
	outerJoin ifTrue: [exp beOuterJoin].
	^(self multipleTableExpressionsOn: anExpression), (exp isNil ifTrue: [#()] ifFalse: [Array with: exp]).!

aliasedTableFor: aDatabaseTable 
	^self controlsTables 
		ifTrue: [super aliasedTableFor: aDatabaseTable]
		ifFalse: [base aliasedTableFor: (self mapping translateTable: aDatabaseTable)]!

aliasedTableFor: aDatabaseTable ifAbsent: aBlock
	^self controlsTables 
		ifTrue: [super aliasedTableFor: aDatabaseTable ifAbsent: aBlock]
		ifFalse: [base aliasedTableFor: aDatabaseTable ifAbsent: aBlock]!

allControlledTables
	"Return all the tables that we control, directly or indirectly. Basically, if we are a mapping expression with a link table, return the link table as well as any tables of ours."
	| all join |
	self controlsTables ifFalse: [^#()].
	all := Set new.
	all addAll: self tables.
	mapping := self mapping.
	mapping isNil 
		ifFalse: [
			join := mapping join.
			join isNil ifFalse: [all addAll: join allControlledTables]].
	^all.!

allRelationsFor: rootExpression
	^self mapping allRelationsFor: rootExpression.!

allRelationsFor: rootExpression do: aBlock andBetweenDo: anotherBlock
	"We might have multiple clauses to print, depending on our mapping"
	self mapping 
		allRelationsFor: rootExpression
		do: aBlock
		andBetweenDo: anotherBlock.!

allSourceFields
	"If we are sending this, then we're treating the expression as a join, for a complex (and probably read-only) relationship. So in that case we want to treat the source fields as the parameters that this expression takes, and specifically the parameters that are based on fields."
	^self inject: OrderedCollection new into: [:sum :each |
		each addToTargetFields: sum.
		sum].!

allTargetFields
	"If we are sending this, then we're treating the expression as a join, for a complex (and probably read-only) relationship. So in that case we want to treat the target fields as being the source fields of the bottom-most mapping. That is, the fields we'll use to connect to the thing we want are the things that our expression's base (which represents the thing we want) would use to connect to the first level mapping arising from it."
	^self penultimateBaseExpression join allSourceFields.!

asExpressionJoiningSource: source toTarget: target
	"Create a general expression which represents this relationship where the values of the targets (which are normally parameters) are supplied out of the context provided by 'target' and the source fields are referencing things out of the context of source. Produces something suitable for ANDing into an expression when doing a join
   Example: If we had CUSTOMER.ADDRESS_ID = ADDRESS.ID as a parameter, and we want to AND this into an expression [:customer | customer address street = 'Main'] then we have customer as a base, and we get 
	(customer.ADDRESS.STREET = 'Main') AND (customer.CUSTOMER.ADDRESS_ID = customer.ADDRESS.ID)
	The primary key expression for the relationship has been translated into field references into the customer and address tables in a particular context."

	| newBase |
	newBase := base asExpressionJoiningSource: source toTarget: target.
	^newBase getMapping: self mapping named: name.!

asOuterJoin
	outerJoin := true.!

base

	^base.!

bePhantom
	phantom := true.!

canBeUsedForRetrieve
	"Return true if this is a valid argument for a retrieve: clause"
	^self mapping canBeUsedForRetrieve.!

canHaveBase
	"Return true if this type of expression can have a base expression on which other things can be built. Doesn't say whether we actually have a valid one or not."
	^true.!

canKnit
	"Return true if, when building objects, we can knit the object corresponding to this expression to a related object. Roughly speaking, is this a mapping expression"
	^true.!

canPrint
	"Return true if we can print into a where clause"
	^self hasField.!

controlsTables
	| theMapping |
	theMapping := self mappingFromMeOrSubclasses.
	theMapping isNil ifTrue: [^true].
	^theMapping controlsTables!

convertedDbValueOf: anObject

	^self mapping convertedDbValueOf: anObject.!

convertedStValueOf: anObject

	^self mapping convertedStValueOf: anObject.!

descriptor
	| system theMapping |
	system := self system.
	system isNil ifTrue: [^nil].
	theMapping := self mappingFromMeOrSubclasses.
	theMapping isNil ifTrue: [^nil].
	^system descriptorFor: theMapping referenceClass.!

do: aBlock skipping: aSet
	"Iterate over the expression tree"

	| myField |
	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	base do: aBlock skipping: aSet.
	aBlock value: self.
	(self hasField and: [(myField := self field) isGlorpExpression])
		ifTrue: [myField do: aBlock skipping: aSet].!

field

	self mapping isNil ifTrue: [self error: '"', name, '" is not a mapped property name in ', base descriptor describedClass name].
	self hasDescriptor ifTrue: [
		"If we have a descriptor, then either we're a mapping to a full object, in which case we can't answer this properly, or we're a direct to-many mapping, in which case we can."
		self mapping mapsSimpleObject
			ifTrue: [^self translateField: self mapping field]
			ifFalse: [self error: '"',name, 
				'" is not an attribute that resolves to a field in the mapped tables for ', 
					base descriptor describedClass name]].
	^base translateField: self mapping field.!

fieldFromMeOrSubclasses
	"Return the field for this mapping, but if the field is not mapped here, and the class uses inheritance, check for subclasses, and use a random one of the subclass mappings."
	| subMapping |
	subMapping := self mappingFromMeOrSubclasses.
	^subMapping isNil ifTrue: [self field] ifFalse: [subMapping field].!

fieldsForSelectStatement
	
	^self mapping fieldsForSelectStatement.!

hasDescriptor
	"Does the object that we describe have its own descriptor"
	| myMapping |
	myMapping := self mapping.
	^myMapping notNil and: [myMapping isRelationship]!

hasField

	self mapping isNil ifTrue: [^false].
"If we have a descriptor, then either we're a mapping to a full object, in which case we can't answer this properly, or we're a direct to-many mapping, in which case we can."
	self hasDescriptor ifTrue: [
		^self mapping mapsSimpleObject].
	^true.!

hasImpliedClauses
	^self mapping notNil and: [self mapping hasImpliedClauses].!

initialize
	super initialize.
	phantom := false.!

isEmpty
	"Only useful for mappings that represent collections. This checks to see if the collection has elements by building a not exists subselect."
	
	^self base existenceCheck: self as: #notExists:!

join
	self mapping isNil ifTrue: [^nil].
	^self mapping join.!

mappableFieldsDo: aBlock
	"Used when we are emulating a Join"
	self allSourceFields with: self allTargetFields do: [:source :target |
		source isMappable ifTrue: [aBlock value: source value: target]].!

mappableSourceFieldsDo: aBlock
	"Used when we are emulating a Join"
	self allSourceFields do: [:source |
		source isMappable ifTrue: [aBlock value: source]].!

mappedFields
	
	self mapping isNil ifTrue: [^#()].
	self mapping isRelationship ifTrue: [self error: '"',name, '" is not an attribute that resolves to a field in the mapped tables for ', base descriptor describedClass name].
	^self mapping mappedFields collect: [:each | base translateField: each].!

mapping
	mapping isNil ifTrue: [
		| descriptor |
		descriptor := self sourceDescriptor.
		descriptor isNil ifTrue: [^nil].
		mapping := descriptor mappingForAttributeNamed: name].
	^mapping.!

mapping: aMapping
	mapping := aMapping.!

mappingFromMeOrSubclasses
	"Return the mapping for me, but if the field is not mapped here, and the class uses inheritance, check for subclasses, and use a random one of the subclass mappings."

	| subclassDescriptors |
	self mapping isNil ifFalse: [^self mapping].
	self sourceDescriptor isNil ifTrue: [^self mapping].
	subclassDescriptors := (self sourceDescriptor typeResolver descriptorsRequiringIndependentQueriesFor: self sourceDescriptor describedClass).
	subclassDescriptors do: [:each | 
		| subMapping |
		subMapping := each mappingForAttributeNamed: name.
		subMapping isNil ifFalse: [^subMapping]].
	"If subclasses didn't work, just fall through to the normal error processing."
	^self mapping.!

mapsSimpleObject
	^self mapping mapsSimpleObject.!

multipleTableExpressions
	^self multipleTableExpressionsOn: self.!

multipleTableExpressionsOn: anExpression
	^self mapping multipleTableExpressionsFor: anExpression.!

mustReGetMappingIfRebuildingOn: newBase
	"Return true if we need to do a full get: when rebuilding, rather than being able to preserve the mapping that we had before."

	"If we didn't have a mapping yet, then just do a get"
	mapping isNil ifTrue: [^true].
	"If this is a phantom mapping, we must not try to re-get it."
	self phantom ifTrue: [^false].
	"Otherwise, we're a normal mapping, and we don't need to re-get the mapping unless the class is different, probably because of inheritance. But note that in some cases we may not know our descriptor yet."
	self base hasDescriptor ifFalse: [^false].
	self base descriptor isNil ifTrue: [^false].
	^self base descriptor ~= newBase descriptor.!

name

	^name.!

named: aSymbol basedOn: anExpression

	name := aSymbol.
	base := anExpression.
	outerJoin := false.!

notEmpty
	"Only useful for mappings that represent collections. This checks to see if the collection has elements by building a not exists subselect."
	
	^self base existenceCheck: self as: #exists:!

penultimateBaseExpression
	"Return the one from the last base expression in our tree. Useful if we want to find the first mapping involved in the expression"
	self base base isNil ifTrue: [^self].
	^self base penultimateBaseExpression.!

phantom
	^phantom!

phantom: aBoolean
	phantom := aBoolean!

printOnlySelfOn: aStream

	aStream nextPutAll: name.
	self printTableAliasesOn: aStream.!

printSelectSQLOn: aStream withParameters: aDictionary 
	self hasField ifFalse: [^self].
	self field asField printSelectSQLOn: aStream withParameters: aDictionary.!

printSQLOn: aStream withParameters: aDictionary 
	self hasField ifFalse: [^self].
	self field asField printSQLOn: aStream withParameters: aDictionary.!

printTreeOn: aStream 
	aStream
		print: base;
		nextPut: $.;
		nextPutAll: (name isString ifTrue: [name] ifFalse: [name printString])!

printUnqualifiedSQLOn: aStream withParameters: aDictionary 
	self field asField printUnqualifiedSQLOn: aStream withParameters: aDictionary.!

queryLevelBaseExpression

	^base queryLevelBaseExpression.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	
	| expression newBase |
	self == anExpression ifTrue: [^aBaseExpression].
	newBase := base rebuildOn: aBaseExpression startingFrom: anExpression
		withOuterScopeBase: ultimateBaseExpression.	
	"For phantom mappings we have to pass through our mapping since they can't compute their own. For the normal case, if we have a mapping, and our base class hasn't changed, then just re-use the same mapping as an optimization."
	expression := (mapping isNil or: [self mustReGetMappingIfRebuildingOn: newBase])
		ifTrue: [newBase get: name]
		ifFalse: [newBase getMapping: self mapping named: name].
	outerJoin ifTrue: [expression asOuterJoin].
	expression phantom: self phantom.
	^expression.!

referenceClass
	"Return the class that our mapping refers to, if we have a mapping. If we're a base expression, just return our class, and if we're a table expression, just return nil."
	^self mapping referenceClass.!

representsDerivedObject
	^self mapping isRelationship.!

requiresDistinct: aBoolean
	super requiresDistinct: aBoolean.
	base requiresDistinct: aBoolean.!

returnsDictionary
	"Return true if we representa  ampping to a dictionary"
	^self mapping isToManyRelationship and: [self mapping collectionType == Dictionary].!

rewriteBooleanEquality: relation
	"If we are a boolean that doesn't have a comparison relation on top of us, replace us with an ' = true'"

	"Only rewrite booleans"
	(self mapping notNil and: [self mapping attribute type = Boolean]) ifFalse: [^self].

	"See if we're already part of an equality comparison, don't rewrite twice"
	(relation = #= | (relation = #<>) | (relation = #IN)) ifTrue: [^self].
	"If we're a boolean function, we don't need or want the comparison. e.g. EXISTS. This is a bit hard to test for."
	(self mapping field isGlorpExpression and: [self mapping field field isNil]) ifTrue: [^self].

	^self get: #= withArguments: (Array with: true asGlorpExpression).!

sourceDescriptor
	^base descriptor.!

sqlSelect: anExpression
	"Only useful for mappings that represent collections. This restricts the range of values in a variable. Most useful as part of an aggregation. e.g. 
    read: SomeClass where: [:each | (each collection select: [:eachItem | eachItem attribute = someValue]) sqlCount > 10]"

	"We may be passed an expression corresponding to either a field, or to a full object, depending on the aggregate function. In either case, build backwards from the first full object"
	| objectExpression newMapping previousJoin |
	objectExpression := self mapping isRelationship 
		ifTrue: [self] ifFalse: [self base].
	newMapping := self mapping class new.
	newMapping attributeName: #temporaryAttributeFromSubselect.
	newMapping referenceClass: self mapping referenceClass.
	newMapping descriptor: self mapping descriptor.
	newMapping linkFields: self mapping linkFields.
	newMapping usesLinkTable: self mapping usesLinkTable.
	previousJoin := self mapping join.
	newMapping join: ((anExpression rebuildOn: previousJoin ultimateBaseExpression startingFrom: self) AND: previousJoin asGlorpExpression).

	^objectExpression base getMapping: newMapping named: ( 'a temporary restricted mapping for #select: based on ', self mapping attributeName).!

system
	^base system.!

table
	self hasDescriptor ifTrue: [^self descriptor primaryTable].
	^self field table.!

tables

	self controlsTables ifFalse: [^#()].
	^self tablesContainingMe.!

tablesContainingMe
	"Return a list of tables that contain this object, whether or not we control them. This is mostly the same as tables, but will differ for embedded mappings."
	| set |
	self descriptor isNil ifTrue: [^#()].
	set := self descriptor tables asSet.
	^set.!

tablesToPrint

	self hasDescriptor ifFalse: [^#()].
	^self tables collect: [:each |
		self aliasedTableFor: each].!

translateField: aDatabaseField
	| translatedField |
	translatedField := (self mapping translateFields: (Array with: aDatabaseField)) first.
	^super translateField: (translatedField isNil ifTrue: [aDatabaseField] ifFalse: [translatedField]).!

translateFields: anOrderedCollection 
	"Ugh. Unify these mechnisms"
	^super translateFields: (self mapping translateFields: anOrderedCollection).!

ultimateBaseExpression

	^base ultimateBaseExpression.!

validate
	self mappingFromMeOrSubclasses isNil ifTrue: [self error: 'no mapping for ', self printString].!

valueInBuilder: anElementBuilder
	^self valueInBuilder: anElementBuilder as: self base.!

valueInBuilder: anElementBuilder as: anExpression
	^self mapping valueIn: anElementBuilder as: anExpression.!

willPrintAsWhereClause
	^self hasField.! !
!MappingExpression categoriesFor: #additionalExpressions!preparing!private! !
!MappingExpression categoriesFor: #additionalExpressionsOn:!preparing!private! !
!MappingExpression categoriesFor: #aliasedTableFor:!fields!private! !
!MappingExpression categoriesFor: #aliasedTableFor:ifAbsent:!fields!private! !
!MappingExpression categoriesFor: #allControlledTables!preparing!private! !
!MappingExpression categoriesFor: #allRelationsFor:!internal!private! !
!MappingExpression categoriesFor: #allRelationsFor:do:andBetweenDo:!preparing!private! !
!MappingExpression categoriesFor: #allSourceFields!accessing!private! !
!MappingExpression categoriesFor: #allTargetFields!accessing!private! !
!MappingExpression categoriesFor: #asExpressionJoiningSource:toTarget:!preparing!private! !
!MappingExpression categoriesFor: #asOuterJoin!api!private! !
!MappingExpression categoriesFor: #base!api!private! !
!MappingExpression categoriesFor: #bePhantom!accessing!private! !
!MappingExpression categoriesFor: #canBeUsedForRetrieve!private!testing! !
!MappingExpression categoriesFor: #canHaveBase!accessing!private! !
!MappingExpression categoriesFor: #canKnit!private!testing! !
!MappingExpression categoriesFor: #canPrint!private!testing! !
!MappingExpression categoriesFor: #controlsTables!fields!private! !
!MappingExpression categoriesFor: #convertedDbValueOf:!converting!private! !
!MappingExpression categoriesFor: #convertedStValueOf:!converting!private! !
!MappingExpression categoriesFor: #descriptor!accessing!private! !
!MappingExpression categoriesFor: #do:skipping:!iterating!private! !
!MappingExpression categoriesFor: #field!accessing!private! !
!MappingExpression categoriesFor: #fieldFromMeOrSubclasses!accessing!private! !
!MappingExpression categoriesFor: #fieldsForSelectStatement!preparing!private! !
!MappingExpression categoriesFor: #hasDescriptor!accessing!private! !
!MappingExpression categoriesFor: #hasField!accessing!private! !
!MappingExpression categoriesFor: #hasImpliedClauses!private!testing! !
!MappingExpression categoriesFor: #initialize!initialize!private! !
!MappingExpression categoriesFor: #isEmpty!api!private! !
!MappingExpression categoriesFor: #join!accessing!private! !
!MappingExpression categoriesFor: #mappableFieldsDo:!iterating!private! !
!MappingExpression categoriesFor: #mappableSourceFieldsDo:!iterating!private! !
!MappingExpression categoriesFor: #mappedFields!accessing!private! !
!MappingExpression categoriesFor: #mapping!internal!private! !
!MappingExpression categoriesFor: #mapping:!private!private/initialization! !
!MappingExpression categoriesFor: #mappingFromMeOrSubclasses!accessing!private! !
!MappingExpression categoriesFor: #mapsSimpleObject!private!testing! !
!MappingExpression categoriesFor: #multipleTableExpressions!accessing!private! !
!MappingExpression categoriesFor: #multipleTableExpressionsOn:!accessing!private! !
!MappingExpression categoriesFor: #mustReGetMappingIfRebuildingOn:!preparing!private! !
!MappingExpression categoriesFor: #name!accessing!private! !
!MappingExpression categoriesFor: #named:basedOn:!private!private/initialization! !
!MappingExpression categoriesFor: #notEmpty!api!private! !
!MappingExpression categoriesFor: #penultimateBaseExpression!navigating!private! !
!MappingExpression categoriesFor: #phantom!accessing!private! !
!MappingExpression categoriesFor: #phantom:!accessing!private! !
!MappingExpression categoriesFor: #printOnlySelfOn:!printing!private! !
!MappingExpression categoriesFor: #printSelectSQLOn:withParameters:!printing SQL!private! !
!MappingExpression categoriesFor: #printSQLOn:withParameters:!printing SQL!private! !
!MappingExpression categoriesFor: #printTreeOn:!printing!private! !
!MappingExpression categoriesFor: #printUnqualifiedSQLOn:withParameters:!printing SQL!private! !
!MappingExpression categoriesFor: #queryLevelBaseExpression!navigating!private! !
!MappingExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!MappingExpression categoriesFor: #referenceClass!api!private! !
!MappingExpression categoriesFor: #representsDerivedObject!private!testing! !
!MappingExpression categoriesFor: #requiresDistinct:!private!private/accessing! !
!MappingExpression categoriesFor: #returnsDictionary!private!testing! !
!MappingExpression categoriesFor: #rewriteBooleanEquality:!preparing!private! !
!MappingExpression categoriesFor: #sourceDescriptor!accessing!private! !
!MappingExpression categoriesFor: #sqlSelect:!api!private! !
!MappingExpression categoriesFor: #system!accessing!private! !
!MappingExpression categoriesFor: #table!accessing!private! !
!MappingExpression categoriesFor: #tables!accessing!private! !
!MappingExpression categoriesFor: #tablesContainingMe!accessing!private! !
!MappingExpression categoriesFor: #tablesToPrint!preparing!private! !
!MappingExpression categoriesFor: #translateField:!preparing!private! !
!MappingExpression categoriesFor: #translateFields:!preparing!private! !
!MappingExpression categoriesFor: #ultimateBaseExpression!navigating!private! !
!MappingExpression categoriesFor: #validate!preparing!private! !
!MappingExpression categoriesFor: #valueInBuilder:!converting!private! !
!MappingExpression categoriesFor: #valueInBuilder:as:!converting!private! !
!MappingExpression categoriesFor: #willPrintAsWhereClause!private!testing! !

!MappingExpression class methodsFor!

named: aSymbol basedOn: anExpression

	^self new
		named: aSymbol
		basedOn: anExpression.! !
!MappingExpression class categoriesFor: #named:basedOn:!instance creation!private! !

TableExpression guid: (GUID fromString: '{C7849E83-657F-4391-AE78-BA2AFD0408AE}')!
TableExpression comment: 'This is an expression representing a table. Typically we refer to things in terms of objects which control tables, but sometimes you want to refer directly to a table that''s not mapped, either in the process of building up a more OO representing (e.g. referring to a link table) or because we just want to do something more complicated that''s not mapped, or incompletely mapped.

Instance Variables:
	base	<BaseExpression | MappingExpression>	The expression on which we are built.
	table	<DatabaseTable>	The table that we represent.

'!
!TableExpression categoriesForClass!Unclassified! !
!TableExpression methodsFor!

aliasedTableFor: aDatabaseTable 
	^self controlsTables 
		ifTrue: [super aliasedTableFor: aDatabaseTable]
		ifFalse: [base aliasedTableFor: aDatabaseTable]!

aliasedTableFor: aDatabaseTable ifAbsent: aBlock
	^self controlsTables 
		ifTrue: [super aliasedTableFor: aDatabaseTable ifAbsent: aBlock]
		ifFalse: [base aliasedTableFor: aDatabaseTable ifAbsent: aBlock]!

asExpressionJoiningSource: source toTarget: target
	"Create a general expression which represents this relationship where the values of the targets (which are normally parameters) are supplied out of the context provided by 'target' and the source fields are referencing things out of the context of source. Produces something suitable for ANDing into an expression when doing a join
   Example: If we had CUSTOMER.ADDRESS_ID = ADDRESS.ID as a parameter, and we want to AND this into an expression [:customer | customer address street = 'Main'] then we have customer as a base, and we get 
	(customer.ADDRESS.STREET = 'Main') AND (customer.CUSTOMER.ADDRESS_ID = customer.ADDRESS.ID)
	The primary key expression for the relationship has been translated into field references into the customer and address tables in a particular context."

	^(source tablesContainingMe includes: table) ifTrue: [source] ifFalse: [target getTable: table].!

base

	^base.!

canHaveBase
	"Return true if this type of expression can have a base expression on which other things can be built. Doesn't say whether we actually have a valid one or not."
	^true.!

canPrint
	"Return true if we can print into a where clause"
	^false.!

controlsTables
	"We can end up with a table expression built on top of a base that has the same table. If so, we don't count as controlling that table"

	base isNil ifTrue: [^true].
	base hasDescriptor ifFalse: [^true].
	^(base descriptor tables includes: table) not.!

do: aBlock skipping: aSet
	"Iterate over the expression tree"

	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	base do: aBlock skipping: aSet.
	aBlock value: self.!

getFieldThatsAnActualFieldObject: aField

	^self mappingExpressions at: aField ifAbsentPut: [self newFieldExpressionFor: aField].!

getTable: aTable
	self error: 'getting a table from a table expression doesn''t make sense'.!

printOnlySelfOn: aStream

	table printSQLOn: aStream withParameters: #().
	self printTableAliasesOn: aStream.!

printsTable

	^true.!

printTreeOn: aStream 
	base printOn: aStream.
	aStream nextPut: $..
	table printSQLOn: aStream withParameters: #()!

queryLevelBaseExpression
	^base queryLevelBaseExpression.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	self == anExpression ifTrue: [^aBaseExpression].
	^(base rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression) getTable: table.!

referenceClass
	"Return the class that our mapping refers to, if we have a mapping. If we're a base expression, just return our class, and if we're a table expression, just return nil."
	^nil.!

table

	^table.!

table: aDatabaseTable base: aBaseExpression

	table := aDatabaseTable.
	base := aBaseExpression.!

tables

	^Array with: table.!

tablesToPrint

	self controlsTables ifFalse: [^#()].
	^Array with: (self aliasedTableFor: table).!

ultimateBaseExpression
	^base ultimateBaseExpression.! !
!TableExpression categoriesFor: #aliasedTableFor:!preparing!private! !
!TableExpression categoriesFor: #aliasedTableFor:ifAbsent:!preparing!private! !
!TableExpression categoriesFor: #asExpressionJoiningSource:toTarget:!preparing!private! !
!TableExpression categoriesFor: #base!accessing!private! !
!TableExpression categoriesFor: #canHaveBase!accessing!private! !
!TableExpression categoriesFor: #canPrint!private!testing! !
!TableExpression categoriesFor: #controlsTables!preparing!private! !
!TableExpression categoriesFor: #do:skipping:!iterating!private! !
!TableExpression categoriesFor: #getFieldThatsAnActualFieldObject:!api!private! !
!TableExpression categoriesFor: #getTable:!api!private! !
!TableExpression categoriesFor: #printOnlySelfOn:!printing!private! !
!TableExpression categoriesFor: #printsTable!accessing!private! !
!TableExpression categoriesFor: #printTreeOn:!printing!private! !
!TableExpression categoriesFor: #queryLevelBaseExpression!accessing!private! !
!TableExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!TableExpression categoriesFor: #referenceClass!api!private! !
!TableExpression categoriesFor: #table!accessing!private! !
!TableExpression categoriesFor: #table:base:!initialize/release!private! !
!TableExpression categoriesFor: #tables!accessing!private! !
!TableExpression categoriesFor: #tablesToPrint!preparing!private! !
!TableExpression categoriesFor: #ultimateBaseExpression!accessing!private! !

!TableExpression class methodsFor!

forTable: aDatabaseTable basedOn: aBaseExpression

	^self new table: aDatabaseTable base: aBaseExpression; yourself! !
!TableExpression class categoriesFor: #forTable:basedOn:!instance creation!private! !

JoinBaseExpression guid: (GUID fromString: '{CCAA7E64-9473-4CCF-A480-0901D9501677}')!
JoinBaseExpression comment: 'When we use an expression as a join, we tend to write it backwards. We use expressions when the relationship is more complicated than we can express as a single join. And we describe it by giving the target and describing how to use relationships to get from the target object to the source object. We can''t do it forwards, because the forward relationship is exactly what we''re trying to describe with this join. For example, for a (rather contrived) Address to Job relationship, we might write it as
  [:eachJob | eachJob worker address]
However, this means that when we''re trying to rebuild this expression and fit it into a query, it''s backwards from most expressions. We know that, so we give it a special kind of base that makes it rebuild itself slightly different, by preferring the target rather than the source.  '!
!JoinBaseExpression categoriesForClass!Unclassified! !
!JoinBaseExpression methodsFor!

asExpressionJoiningSource: source toTarget: target
	"Create a general expression which represents this relationship where the values of the targets (which are normally parameters) are supplied out of the context provided by 'target' and the source fields are referencing things out of the context of source. Produces something suitable for ANDing into an expression when doing a join
   Example: If we had CUSTOMER.ADDRESS_ID = ADDRESS.ID as a parameter, and we want to AND this into an expression [:customer | customer address street = 'Main'] then we have customer as a base, and we get 
	(customer.ADDRESS.STREET = 'Main') AND (customer.CUSTOMER.ADDRESS_ID = customer.ADDRESS.ID)
	The primary key expression for the relationship has been translated into field references into the customer and address tables in a particular context."

	^target.! !
!JoinBaseExpression categoriesFor: #asExpressionJoiningSource:toTarget:!preparing!private! !

SubSelectBaseExpression guid: (GUID fromString: '{C22C6607-9515-4E5F-B909-6481ABA9C792}')!
SubSelectBaseExpression comment: 'This is a special variation of a base expression which is used when we know we are a subselect. In some circumstances we''ll need to operate with respect to the subselect base, as if we were a standalone query. But sometimes we''ll need to know the broader context in which we''re living. Having a separate subclass helps us distinguish.

Instance Variables:
	trueBase	<MappingExpression>	The base on which we are built. Note that this doesn''t mean this is the overall base expression, in fact it''s probably a mapping expression, it''s just the thing from which this subselect was built. Presumably the ultimate base expression can be found by following that outer context down, but there could be multiple levels of subselects involved.

'!
!SubSelectBaseExpression categoriesForClass!Unclassified! !
!SubSelectBaseExpression methodsFor!

additionalExpressions
	"We effectively take over the join for the thing we're based on, because we want it to happen in the subselect, not in the main one."

	^trueBase additionalExpressionsOn: self.!

additionalExpressionsOn: anExpression
	^trueBase additionalExpressionsOn: anExpression.!

base
	^trueBase base.!

className

	^'SubSelectBase'.!

convertedDbValueOf: anObject

	^self trueBase mapping convertedDbValueOf: anObject.!

descriptor
	^trueBase descriptor.!

field
	^self trueBase mapping field.!

join
	^self trueBase join.!

printSQLOn: aStream withParameters: aDictionary
	"If I'm ever going to print this directly, it's because I'm participating in a direct to-many relationship, so I do have a valid field"
	(self translateField: self field) printSQLOn: aStream withParameters: aDictionary.!

queryLevelBaseExpression

	^self!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	anExpression isNil ifTrue: [^aBaseExpression].
	anExpression == self ifTrue: [^aBaseExpression].
	trueBase := trueBase rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression.
	^self.!

representsDerivedObject
	^self trueBase representsDerivedObject!

table
	^self trueBase table.!

trueBase
	^trueBase!

trueBase: aBaseExpression
	trueBase := aBaseExpression.!

ultimateBaseExpression

	^trueBase ultimateBaseExpression!

validate
	super validate.
	trueBase validate.! !
!SubSelectBaseExpression categoriesFor: #additionalExpressions!accessing!private! !
!SubSelectBaseExpression categoriesFor: #additionalExpressionsOn:!preparing!private! !
!SubSelectBaseExpression categoriesFor: #base!accessing!private! !
!SubSelectBaseExpression categoriesFor: #className!printing!private! !
!SubSelectBaseExpression categoriesFor: #convertedDbValueOf:!converting!private! !
!SubSelectBaseExpression categoriesFor: #descriptor!accessing!private! !
!SubSelectBaseExpression categoriesFor: #field!accessing!private! !
!SubSelectBaseExpression categoriesFor: #join!accessing!private! !
!SubSelectBaseExpression categoriesFor: #printSQLOn:withParameters:!printing!private! !
!SubSelectBaseExpression categoriesFor: #queryLevelBaseExpression!navigating!private! !
!SubSelectBaseExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !
!SubSelectBaseExpression categoriesFor: #representsDerivedObject!private!testing! !
!SubSelectBaseExpression categoriesFor: #table!accessing!private! !
!SubSelectBaseExpression categoriesFor: #trueBase!accessing!private! !
!SubSelectBaseExpression categoriesFor: #trueBase:!accessing!private! !
!SubSelectBaseExpression categoriesFor: #ultimateBaseExpression!navigating!private! !
!SubSelectBaseExpression categoriesFor: #validate!preparing!private! !

!SubSelectBaseExpression class methodsFor!

on: aBaseExpression
	^self new trueBase: aBaseExpression.! !
!SubSelectBaseExpression class categoriesFor: #on:!instance creation!private! !

CollectionExpression guid: (GUID fromString: '{9627D574-1CD2-4CCC-B877-F691E5C5F33B}')!
CollectionExpression comment: 'This represents expressions on collection objects taking a block, which at the moment means just anySatisfy:

We treat this as a relation, but with the special properties that when we convert the right hand side into an expression we assume it''s a block and give it a base which is the left-hand side. Also, we don''t print this relation when printing SQL, we just print the right hand side.'!
!CollectionExpression categoriesForClass!Unclassified! !
!CollectionExpression methodsFor!

do: aBlock skipping: aSet
	"Because our argument is a block, and the thing passed to it is our left child, we can assume that our left child will be referenced via that block. So we'll ignore it. This will help when condensing out primary key expressions, because otherwise us iterating over them forces them to stay around."
	| |
	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	rightChild do: aBlock skipping: aSet.
	aBlock value: self.!

printSQLOn: aStream withParameters: aDictionary 
	"Don't print the left child or ourselves, just the expression that is the right side.
e.g. aPerson addresses anySatisfy: [:each | each city='Ottawa'] prints as
where (address.city = 'Ottawa')
The relation 'aPerson addresses' will ensure that the join gets printed"
	rightChild printSQLOn: aStream withParameters: aDictionary.! !
!CollectionExpression categoriesFor: #do:skipping:!iterating!private! !
!CollectionExpression categoriesFor: #printSQLOn:withParameters:!printing SQL!private! !

SubSelectExpression guid: (GUID fromString: '{465064B6-35DF-41AD-AB30-A3338EB44E74}')!
SubSelectExpression comment: 'This is a special sort of relation expression used when printing subselects that are generated out of anySatisfy: or noneSatisfy: using an EXISTS/NOT EXISTS clause.

Instance Variables:
	localBase	<SubSelectBaseExpression>	The base expression that our sub-query is built on, as opposed to the overall base expression of query.
	query	<SimpleQuery>	The sub-query we are responsible for.

'!
!SubSelectExpression categoriesForClass!Unclassified! !
!SubSelectExpression methodsFor!

addBoundExpressionsIn: aCommand to: boundExpressions
	self query prepare.
	self query addBoundExpressionsIn: aCommand to: boundExpressions.!

descriptor
	^self leftChild descriptor.!

named: aSymbol basedOn: anExpression withArguments: anArray

	| right |
	outerJoin := false.
	relation := self operationFor: aSymbol.
	leftChild := anExpression base.

	localBase := SubSelectBaseExpression on: anExpression.
	right := anArray first.
	rightChild := right rebuildOn: localBase startingFrom: anExpression.!

printSQLOn: aStream withParameters: aDictionary 
	| command toPrint |
	toPrint := relation = #noneSatisfy: ifTrue: ['NOT EXISTS ('] ifFalse: [' EXISTS ('].
	aStream nextPutAll: toPrint.
	command := self query sqlWith: aDictionary.
	aStream nextPutAll: command sqlString.
	aStream nextPutAll: ')'.!

query
	query isNil ifTrue: [self initializeQuery].
	^query.!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	| expression left |
	self == anExpression ifTrue: [^aBaseExpression].
	"We've swallowed our left child, so we have to unswallow it before rebuilding"
	left := localBase trueBase rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression.
	expression := left 
		get: relation
		withArguments:
			(Array
				with:
					(self rightChildToRebuild rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression)).
	self isOuterJoin ifTrue: [expression beOuterJoin].
	^expression.! !
!SubSelectExpression categoriesFor: #addBoundExpressionsIn:to:!preparing!private! !
!SubSelectExpression categoriesFor: #descriptor!accessing!private! !
!SubSelectExpression categoriesFor: #named:basedOn:withArguments:!internal!private! !
!SubSelectExpression categoriesFor: #printSQLOn:withParameters:!printing SQL!private! !
!SubSelectExpression categoriesFor: #query!accessing!private! !
!SubSelectExpression categoriesFor: #rebuildOn:startingFrom:withOuterScopeBase:!preparing!private! !

"Binary Globals"!

