| package |
package := Package name: 'GlorpTestModels'.
package paxVersion: 1;
	basicComment: 'This is part of the GLORP system, an open-source library (LGPL(S)) for persisting Smalltalk objects in relational databases. For more information see the #notice property, the accompanying files and/or the web sites http://www.glorp.org or http://www.sourceforge.net/projects/glorp '.

package basicPackageVersion: 'image'.


package classNames
	add: #DefaultableThing;
	add: #GlorpAddress;
	add: #GlorpAirline;
	add: #GlorpAirlineMeal;
	add: #GlorpAttachment;
	add: #GlorpAttachmentBytes;
	add: #GlorpBankAccount;
	add: #GlorpBankAccountNumber;
	add: #GlorpBankBranch;
	add: #GlorpBankExampleSystem;
	add: #GlorpBankTransaction;
	add: #GlorpBasicTax;
	add: #GlorpBook;
	add: #GlorpBookstoreCustomer;
	add: #GlorpCompositeKeyDescriptorSystem;
	add: #GlorpCompressedMoney;
	add: #GlorpCustomer;
	add: #GlorpDemoDescriptorSystem;
	add: #GlorpDescriptorSystemWithNamespacePoolDictionaryDeclarer;
	add: #GlorpDescriptorSystemWithNamespaces;
	add: #GlorpDocument;
	add: #GlorpDocumentDescriptorSystem;
	add: #GlorpEmailAddress;
	add: #GlorpEmployee;
	add: #GlorpEncyclopedia;
	add: #GlorpEncyclopediaBioEntry;
	add: #GlorpEncyclopediaDescriptorSystem;
	add: #GlorpEncyclopediaEntry;
	add: #GlorpExampleSystem;
	add: #GlorpFolder;
	add: #GlorpGallery;
	add: #GlorpImage;
	add: #GlorpImageFile;
	add: #GlorpImageLink;
	add: #GlorpInheritanceDescriptorSystem;
	add: #GlorpInventoryItem;
	add: #GlorpItinerary;
	add: #GlorpJob;
	add: #GlorpLineWorker;
	add: #GlorpLinkTableAnywhereDescriptorSystem;
	add: #GlorpLockingDescriptorSystem;
	add: #GlorpManager;
	add: #GlorpMediaType;
	add: #GlorpMessage;
	add: #GlorpMoney;
	add: #GlorpNonperishableItem;
	add: #GlorpObjectWithNoAccessors;
	add: #GlorpOffice;
	add: #GlorpOwner;
	add: #GlorpPassenger;
	add: #GlorpPerishableItem;
	add: #GlorpPerson;
	add: #GlorpPoultry;
	add: #GlorpProxyEqualityTest;
	add: #GlorpPublisher;
	add: #GlorpPublisherEmployee;
	add: #GlorpRecordWithUpdateTime;
	add: #GlorpRegionalManager;
	add: #GlorpReservation;
	add: #GlorpRowMapForMementosCollectionTest;
	add: #GlorpServiceCharge;
	add: #GlorpSlave;
	add: #GlorpSurcharge;
	add: #GlorpTag;
	add: #GlorpTaggableObject;
	add: #GlorpTax;
	add: #GlorpTestCase;
	add: #GlorpTestClassInNamespace;
	add: #GlorpTestDescriptorSystem;
	add: #GlorpTestModelClass;
	add: #GlorpTestModelsPackage;
	add: #GlorpTransformedTime;
	add: #GlorpTransientEmployee;
	add: #GlorpTravelAgency;
	add: #GlorpTravelAgent;
	add: #GlorpTreeNode;
	add: #GlorpUnassembledItem;
	add: #GlorpUser;
	add: #GlorpVariableTypeTestSystem;
	add: #GlorpVideoCreditStatus;
	add: #GlorpVideoCustomer;
	add: #GlorpVideoDescriptorSystem;
	add: #GlorpVideoPurchase;
	add: #GlorpVideoRental;
	add: #GlorpVideoStore;
	add: #GlorpWarehouse;
	add: #GlorpWorker;
	add: #GlorpWorkerDescriptorSystem;
	add: #GlorpWorkingStiff;
	yourself.

package methodNames
	add: #Collection -> #assertEqual:;
	add: #UndefinedObject -> #assertEqual:;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: 'GlorpDatabase';
	add: 'GlorpExpressions';
	add: 'GlorpMappings';
	add: 'GlorpMisc';
	add: 'GlorpQueries';
	add: 'GlorpUnitOfWork';
	add: '..\..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

Object subclass: #DefaultableThing
	instanceVariableNames: 'id boolean integer'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpAddress
	instanceVariableNames: 'id street number'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpAirline
	instanceVariableNames: 'id name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpAirlineMeal
	instanceVariableNames: 'id description ingredients'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpAttachment
	instanceVariableNames: 'index mimeType attachmentBytes'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpAttachmentBytes
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpBankAccount
	instanceVariableNames: 'id accountNumber accountHolders eventsReceived'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpBankAccountNumber
	instanceVariableNames: 'bankCode branchNumber accountNumber'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpBankBranch
	instanceVariableNames: 'accounts branchNumber'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpBankTransaction
	instanceVariableNames: 'id owner amount serviceCharge'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpBook
	instanceVariableNames: 'id description copiesInStock version title author'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpBookstoreCustomer
	instanceVariableNames: 'name accountNumber booksOnOrder'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpCompressedMoney
	instanceVariableNames: 'id array'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpCustomer
	instanceVariableNames: 'id name transactions accounts accountsSortedById accountsSortedByIdDescending eventsReceived seenPostFetch seenPreWrite seenPostWrite seenExpiry'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpDescriptorSystemWithNamespacePoolDictionaryDeclarer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpDocument
	instanceVariableNames: 'id whatever attachments'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpEmailAddress
	instanceVariableNames: 'id user host'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpEncyclopedia
	instanceVariableNames: 'id name entries biographicalEntries'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpEncyclopediaBioEntry
	instanceVariableNames: 'owner title text'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpEncyclopediaEntry
	instanceVariableNames: 'id text title mediaType'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpExampleSystem
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpFolder
	instanceVariableNames: 'user name messages'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpGallery
	instanceVariableNames: 'id name images'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpImageFile
	instanceVariableNames: 'id title bits thumbnailBits'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpImageLink
	instanceVariableNames: 'id title thumbnailBits fullImage'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpInventoryItem
	instanceVariableNames: 'id name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpItinerary
	instanceVariableNames: 'id reservation'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpJob
	instanceVariableNames: 'id description'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpMediaType
	instanceVariableNames: 'name mimeType'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpMessage
	instanceVariableNames: 'folder user subject contents'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpMoney
	instanceVariableNames: 'currency amount'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpObjectWithNoAccessors
	instanceVariableNames: 'alue'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpOffice
	instanceVariableNames: 'id employees street employeeOfMonth'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpOwner
	instanceVariableNames: 'id slave slaves'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpPassenger
	instanceVariableNames: 'id name frequentFlyerMiles airline'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpPerson
	instanceVariableNames: 'id name address emailAddresses hasEmail'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpPublisher
	instanceVariableNames: 'id name titles titlesWithNumberInStock titlesWithNumberInStockLink employees differentBunchOfEmployeesById'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpPublisherEmployee
	instanceVariableNames: 'id name jobTitle'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpRecordWithUpdateTime
	instanceVariableNames: 'id name updateTime updateSomeOtherThing'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpReservation
	instanceVariableNames: 'id passenger passengers'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpServiceCharge
	instanceVariableNames: 'description amount'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpSlave
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpTag
	instanceVariableNames: 'id key label'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpTaggableObject
	instanceVariableNames: 'tags'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpTax
	instanceVariableNames: 'id name taxes supertax'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpTestClassInNamespace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpTestModelClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpTestModelsPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpTransformedTime
	instanceVariableNames: 'id time'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpTravelAgency
	instanceVariableNames: 'name agents'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpTravelAgent
	instanceVariableNames: 'id name agency'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpTreeNode
	instanceVariableNames: 'id children'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpUser
	instanceVariableNames: 'id name folders'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpWarehouse
	instanceVariableNames: 'id address currentItem items'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpWorker
	instanceVariableNames: 'id name pendingJobs finishedJobs priorityJobs'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpWorkingStiff
	instanceVariableNames: 'id name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
DescriptorSystem subclass: #GlorpTestDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestDescriptorSystem subclass: #GlorpCompositeKeyDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestDescriptorSystem subclass: #GlorpDemoDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: 'Default'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestDescriptorSystem subclass: #GlorpDescriptorSystemWithNamespaces
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestDescriptorSystem subclass: #GlorpDocumentDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestDescriptorSystem subclass: #GlorpEncyclopediaDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestDescriptorSystem subclass: #GlorpInheritanceDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestDescriptorSystem subclass: #GlorpLockingDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestDescriptorSystem subclass: #GlorpVariableTypeTestSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestDescriptorSystem subclass: #GlorpVideoDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestDescriptorSystem subclass: #GlorpWorkerDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDemoDescriptorSystem subclass: #GlorpLinkTableAnywhereDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpExampleSystem subclass: #GlorpBankExampleSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpInventoryItem subclass: #GlorpNonperishableItem
	instanceVariableNames: 'serialNumber'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpInventoryItem subclass: #GlorpPerishableItem
	instanceVariableNames: 'age'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpNonperishableItem subclass: #GlorpUnassembledItem
	instanceVariableNames: 'assemblyCost'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpPerishableItem subclass: #GlorpPoultry
	instanceVariableNames: 'featherColor'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTaggableObject subclass: #GlorpImage
	instanceVariableNames: 'id location'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTax subclass: #GlorpBasicTax
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTax subclass: #GlorpSurcharge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestModelClass subclass: #GlorpVideoCreditStatus
	instanceVariableNames: 'customer balanceOwing dateOwing comments'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestModelClass subclass: #GlorpVideoCustomer
	instanceVariableNames: 'name dateOfBirth onlinePurchases inStorePurchases inStoreRentals store creditStatus'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestModelClass subclass: #GlorpVideoPurchase
	instanceVariableNames: 'id title price inStore customer store'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestModelClass subclass: #GlorpVideoRental
	instanceVariableNames: 'id title dueDate price customer store'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestModelClass subclass: #GlorpVideoStore
	instanceVariableNames: 'id name customers purchases rentals'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpWorkingStiff subclass: #GlorpEmployee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpEmployee subclass: #GlorpLineWorker
	instanceVariableNames: 'productionLine'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpEmployee subclass: #GlorpManager
	instanceVariableNames: 'branch'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpEmployee subclass: #GlorpTransientEmployee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpManager subclass: #GlorpRegionalManager
	instanceVariableNames: 'region'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #GlorpTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpProxyEqualityTest
	instanceVariableNames: 'session proxy proxy2 stub2 stub'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpRowMapForMementosCollectionTest
	instanceVariableNames: 'transaction rowMap collection newCollection copy'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!Collection methodsFor!

assertEqual: aCollection
	"A convenience method for testing"
	self asSortedCollection with: aCollection asSortedCollection do: [:a :b |
		a assertEqual: b].! !
!Collection categoriesFor: #assertEqual:!glorp!private! !

!UndefinedObject methodsFor!

assertEqual: anObject
	GlorpTestModelClass new assert: anObject = nil.! !
!UndefinedObject categoriesFor: #assertEqual:!glorp!private! !

"End of package definition"!

"Source Globals"!

"Classes"!

DefaultableThing guid: (GUID fromString: '{D1AABC01-3290-4C4D-B2E5-2462C806B361}')!
DefaultableThing comment: ''!
!DefaultableThing categoriesForClass!Unclassified! !
GlorpAddress guid: (GUID fromString: '{F85F81C1-2AAF-4BC5-81B7-B30CE44D4669}')!
GlorpAddress comment: ''!
!GlorpAddress categoriesForClass!Unclassified! !
!GlorpAddress methodsFor!

glorpNoticeOfExpiryIn: aSession!

id
	"Private - Answer the value of the receiver's ''id'' instance variable."

	^id!

id: anObject
	"Private - Set the value of the receiver's ''id'' instance variable to the argument, anObject."

	id := anObject!

number
	"Private - Answer the value of the receiver's ''number'' instance variable."

	^number!

number: anObject
	"Private - Set the value of the receiver's ''number'' instance variable to the argument, anObject."

	number := anObject!

printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '(', id printString, ',', street printString, ',' , number printString, ')'.!

street
	"Private - Answer the value of the receiver's ''street'' instance variable."

	^street!

street: anObject
	"Private - Set the value of the receiver's ''street'' instance variable to the argument, anObject."

	street := anObject! !
!GlorpAddress categoriesFor: #glorpNoticeOfExpiryIn:!notification!private! !
!GlorpAddress categoriesFor: #id!accessing!private! !
!GlorpAddress categoriesFor: #id:!accessing!private! !
!GlorpAddress categoriesFor: #number!accessing!private! !
!GlorpAddress categoriesFor: #number:!accessing!private! !
!GlorpAddress categoriesFor: #printOn:!printing!private! !
!GlorpAddress categoriesFor: #street!accessing!private! !
!GlorpAddress categoriesFor: #street:!accessing!private! !

!GlorpAddress class methodsFor!

example1

	^self new
		id: 1;
		street: 'West 47th Ave';
		number: '2042'.!

example1WithChangedAddress

	^self new
		id: 1;
		street: 'Garden of the Gods';
		number: '99999'.!

example2

	^self new
		id: 2;
		street: 'Nowhere';
		number: '1000'.!

glorpSetupClassModel: aClassModel forSystem: aDescriptorSystem 
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #street.
	aClassModel newAttributeNamed: #number.!

glorpSetupDescriptor: aDescriptor forSystem: aDescriptorSystem 
	| table |
	table := aDescriptorSystem tableNamed: 'GR_ADDRESS'.
	aDescriptor table: table.
	aDescriptor
		addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID'));
		addMapping: (DirectMapping from: #street to: (table fieldNamed: 'STREET'));
		addMapping: (DirectMapping from: #number to: (table fieldNamed: 'HOUSE_NUM'))! !
!GlorpAddress class categoriesFor: #example1!examples!private! !
!GlorpAddress class categoriesFor: #example1WithChangedAddress!examples!private! !
!GlorpAddress class categoriesFor: #example2!examples!private! !
!GlorpAddress class categoriesFor: #glorpSetupClassModel:forSystem:!glorp setup!private! !
!GlorpAddress class categoriesFor: #glorpSetupDescriptor:forSystem:!glorp setup!private! !

GlorpAirline guid: (GUID fromString: '{4D5FFE74-1657-4347-89AE-7EAD1607FB4C}')!
GlorpAirline comment: ''!
!GlorpAirline categoriesForClass!Unclassified! !
!GlorpAirline methodsFor!

id
	^id!

id: anInteger
	id := anInteger!

name
	^name!

name: aString
	name := aString! !
!GlorpAirline categoriesFor: #id!accessing!private! !
!GlorpAirline categoriesFor: #id:!accessing!private! !
!GlorpAirline categoriesFor: #name!accessing!private! !
!GlorpAirline categoriesFor: #name:!accessing!private! !

!GlorpAirline class methodsFor!

example1
	^self new
		id: 73;
		name: 'Air Canada'.!

example2
	^self new
		id: 74;
		name: 'Lufthansa'.! !
!GlorpAirline class categoriesFor: #example1!examples!private! !
!GlorpAirline class categoriesFor: #example2!examples!private! !

GlorpAirlineMeal guid: (GUID fromString: '{2A9CCB92-2CB8-4F75-A78C-2B4F6902816E}')!
GlorpAirlineMeal comment: ''!
!GlorpAirlineMeal categoriesForClass!Unclassified! !
GlorpAttachment guid: (GUID fromString: '{A33F1F8A-BBFC-4361-B479-8E97D20E28F3}')!
GlorpAttachment comment: ''!
!GlorpAttachment categoriesForClass!Unclassified! !
!GlorpAttachment methodsFor!

attachmentBytes
	^attachmentBytes!

attachmentBytes: anObject
	attachmentBytes := anObject!

index
	^index!

index: anObject
	index := anObject!

mimeType
	^mimeType!

mimeType: anObject
	mimeType := anObject! !
!GlorpAttachment categoriesFor: #attachmentBytes!accessing!private! !
!GlorpAttachment categoriesFor: #attachmentBytes:!accessing!private! !
!GlorpAttachment categoriesFor: #index!accessing!private! !
!GlorpAttachment categoriesFor: #index:!accessing!private! !
!GlorpAttachment categoriesFor: #mimeType!accessing!private! !
!GlorpAttachment categoriesFor: #mimeType:!accessing!private! !

!GlorpAttachment class methodsFor!

glorpSetupClassModel: model forSystem: system 
	model
		newAttributeNamed: #index;
		newAttributeNamed: #mimeType;
		newAttributeNamed: #attachmentBytes type: GlorpAttachmentBytes!

glorpSetupDescriptor: aDesc forSystem: system 
	| t |
	t := system tableNamed: 'attachment'.
	aDesc table: t.
	(aDesc newMapping: DirectMapping) from: #index
		to: (t fieldNamed: 'indexInDocument').
	(aDesc newMapping: DirectMapping) from: #mimeType
		to: (t fieldNamed: 'mimetype').
	(aDesc newMapping: OneToOneMapping) attributeName: #attachmentBytes! !
!GlorpAttachment class categoriesFor: #glorpSetupClassModel:forSystem:!glorp!private! !
!GlorpAttachment class categoriesFor: #glorpSetupDescriptor:forSystem:!glorp!private! !

GlorpAttachmentBytes guid: (GUID fromString: '{FA2D4654-7901-4DD6-9FD9-947F37142918}')!
GlorpAttachmentBytes comment: ''!
!GlorpAttachmentBytes categoriesForClass!Unclassified! !
!GlorpAttachmentBytes methodsFor!

content
	^content!

content: anObject
	content := anObject! !
!GlorpAttachmentBytes categoriesFor: #content!accessing!private! !
!GlorpAttachmentBytes categoriesFor: #content:!accessing!private! !

!GlorpAttachmentBytes class methodsFor!

glorpSetupClassModel: model forSystem: system 
	model newAttributeNamed: #content!

glorpSetupDescriptor: aDesc forSystem: system 
	| t |
	t := system tableNamed: 'attachmentbytes'.
	aDesc table: t.
	(aDesc newMapping: DirectMapping) from: #content
		to: (t fieldNamed: 'content')! !
!GlorpAttachmentBytes class categoriesFor: #glorpSetupClassModel:forSystem:!glorp!private! !
!GlorpAttachmentBytes class categoriesFor: #glorpSetupDescriptor:forSystem:!glorp!private! !

GlorpBankAccount guid: (GUID fromString: '{2E5A87B9-67E9-46C8-90CB-C974A0A4AABF}')!
GlorpBankAccount comment: ''!
!GlorpBankAccount categoriesForClass!Unclassified! !
!GlorpBankAccount methodsFor!

<= anAccount
	^self accountNumber accountNumber <= anAccount accountNumber accountNumber.!

accountHolders
	^accountHolders.!

accountNumber
	^accountNumber!

accountNumber: anAccountNumber 
	accountNumber := anAccountNumber!

basicAddHolder: aCustomer

	accountHolders add: aCustomer.!

basicRemoveHolder: aCustomer

	accountHolders remove: aCustomer.!

id
	^id!

id: anObject
	id := anObject!

initialize

	accountHolders := OrderedCollection new.!

printOn: aStream

	super printOn: aStream.
	aStream 
		nextPutAll: '(id=';
		print: id;
		nextPut: $).! !
!GlorpBankAccount categoriesFor: #<=!comparing!private! !
!GlorpBankAccount categoriesFor: #accountHolders!accessing!private! !
!GlorpBankAccount categoriesFor: #accountNumber!accessing!private! !
!GlorpBankAccount categoriesFor: #accountNumber:!accessing!private! !
!GlorpBankAccount categoriesFor: #basicAddHolder:!accessing!private! !
!GlorpBankAccount categoriesFor: #basicRemoveHolder:!accessing!private! !
!GlorpBankAccount categoriesFor: #id!accessing!private! !
!GlorpBankAccount categoriesFor: #id:!accessing!private! !
!GlorpBankAccount categoriesFor: #initialize!initialize!private! !
!GlorpBankAccount categoriesFor: #printOn:!printing!private! !

!GlorpBankAccount class methodsFor!

example1

	^self new 
		id: 123;
		accountNumber: GlorpBankAccountNumber example12345.!

new

	^super new initialize.! !
!GlorpBankAccount class categoriesFor: #example1!examples!private! !
!GlorpBankAccount class categoriesFor: #new!instance creation!private! !

GlorpBankAccountNumber guid: (GUID fromString: '{D76F7ACD-96AF-417A-A749-55594ABEAC4B}')!
GlorpBankAccountNumber comment: ''!
!GlorpBankAccountNumber categoriesForClass!Unclassified! !
!GlorpBankAccountNumber methodsFor!

accountNumber
	^accountNumber!

accountNumber: anObject
	accountNumber := anObject!

bankCode
	^bankCode!

bankCode: anObject
	bankCode := anObject!

branchNumber
	^branchNumber!

branchNumber: anObject
	branchNumber := anObject! !
!GlorpBankAccountNumber categoriesFor: #accountNumber!accessing!private! !
!GlorpBankAccountNumber categoriesFor: #accountNumber:!accessing!private! !
!GlorpBankAccountNumber categoriesFor: #bankCode!accessing!private! !
!GlorpBankAccountNumber categoriesFor: #bankCode:!accessing!private! !
!GlorpBankAccountNumber categoriesFor: #branchNumber!accessing!private! !
!GlorpBankAccountNumber categoriesFor: #branchNumber:!accessing!private! !

!GlorpBankAccountNumber class methodsFor!

example12345

	^self new
		accountNumber: 12345;
		bankCode: 4;
		branchNumber: 777.! !
!GlorpBankAccountNumber class categoriesFor: #example12345!examples!private! !

GlorpBankBranch guid: (GUID fromString: '{A039705B-7048-48F7-9A0F-6EE5AAB750ED}')!
GlorpBankBranch comment: ''!
!GlorpBankBranch categoriesForClass!Unclassified! !
!GlorpBankBranch methodsFor!

accounts
	^accounts!

accounts: anObject
	accounts := anObject!

branchNumber
	^branchNumber.!

branchNumber: aString
	branchNumber := aString!

printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self branchNumber printString, ')'.! !
!GlorpBankBranch categoriesFor: #accounts!accessing!private! !
!GlorpBankBranch categoriesFor: #accounts:!accessing!private! !
!GlorpBankBranch categoriesFor: #branchNumber!accessing!private! !
!GlorpBankBranch categoriesFor: #branchNumber:!accessing!private! !
!GlorpBankBranch categoriesFor: #printOn:!printing!private! !

GlorpBankTransaction guid: (GUID fromString: '{4DE42ADB-F407-4B32-9DCD-BF9267BB6FAA}')!
GlorpBankTransaction comment: ''!
!GlorpBankTransaction categoriesForClass!Unclassified! !
!GlorpBankTransaction methodsFor!

amount
	^amount!

amount: aGlorpMoney 
	amount := aGlorpMoney!

id
	"Private - Answer the value of the receiver's ''id'' instance variable."

	^id!

id: anObject
	"Private - Set the value of the receiver's ''id'' instance variable to the argument, anObject."

	id := anObject!

initialize

	amount := GlorpMoney forAmount: 0.
	serviceCharge := GlorpServiceCharge default.!

owner
	"Private - Answer the value of the receiver's ''owner'' instance variable."

	^owner!

owner: aCustomer 
	owner := aCustomer!

serviceCharge
	^serviceCharge!

serviceCharge: aServiceCharge 
	serviceCharge := aServiceCharge! !
!GlorpBankTransaction categoriesFor: #amount!accessing!private! !
!GlorpBankTransaction categoriesFor: #amount:!accessing!private! !
!GlorpBankTransaction categoriesFor: #id!accessing!private! !
!GlorpBankTransaction categoriesFor: #id:!accessing!private! !
!GlorpBankTransaction categoriesFor: #initialize!initialize!private! !
!GlorpBankTransaction categoriesFor: #owner!accessing!private! !
!GlorpBankTransaction categoriesFor: #owner:!accessing!private! !
!GlorpBankTransaction categoriesFor: #serviceCharge!accessing!private! !
!GlorpBankTransaction categoriesFor: #serviceCharge:!accessing!private! !

!GlorpBankTransaction class methodsFor!

example1

	^self new!

example2

	^self new!

new

	^super new initialize.! !
!GlorpBankTransaction class categoriesFor: #example1!examples!private! !
!GlorpBankTransaction class categoriesFor: #example2!examples!private! !
!GlorpBankTransaction class categoriesFor: #new!instance creation!private! !

GlorpBook guid: (GUID fromString: '{82F97073-74C9-413E-BC26-DD99B82E14B8}')!
GlorpBook comment: ''!
!GlorpBook categoriesForClass!Unclassified! !
!GlorpBook methodsFor!

author
	^author!

author: aString
	author := aString!

copiesInStock
	^copiesInStock!

copiesInStock: anInteger
	copiesInStock := anInteger!

description
	^description!

description: aString
	description := aString!

id
	^id!

id: anInteger
	id := anInteger!

title
	^title!

title: aString
	title := aString.!

version
	^version!

version: anInteger
	version := anInteger! !
!GlorpBook categoriesFor: #author!accessing!private! !
!GlorpBook categoriesFor: #author:!accessing!private! !
!GlorpBook categoriesFor: #copiesInStock!accessing!private! !
!GlorpBook categoriesFor: #copiesInStock:!accessing!private! !
!GlorpBook categoriesFor: #description!accessing!private! !
!GlorpBook categoriesFor: #description:!accessing!private! !
!GlorpBook categoriesFor: #id!accessing!private! !
!GlorpBook categoriesFor: #id:!accessing!private! !
!GlorpBook categoriesFor: #title!accessing!private! !
!GlorpBook categoriesFor: #title:!accessing!private! !
!GlorpBook categoriesFor: #version!accessing!private! !
!GlorpBook categoriesFor: #version:!accessing!private! !

GlorpBookstoreCustomer guid: (GUID fromString: '{2CC906D2-DA69-4CD4-BB55-1EF86F0DE678}')!
GlorpBookstoreCustomer comment: ''!
!GlorpBookstoreCustomer categoriesForClass!Unclassified! !
!GlorpBookstoreCustomer methodsFor!

accountNumber
	^accountNumber!

accountNumber: anObject
	accountNumber := anObject!

initialize
	booksOnOrder := OrderedCollection new.!

name
	^name!

name: anObject
	name := anObject! !
!GlorpBookstoreCustomer categoriesFor: #accountNumber!accessing!private! !
!GlorpBookstoreCustomer categoriesFor: #accountNumber:!accessing!private! !
!GlorpBookstoreCustomer categoriesFor: #initialize!initialize-release!private! !
!GlorpBookstoreCustomer categoriesFor: #name!accessing!private! !
!GlorpBookstoreCustomer categoriesFor: #name:!accessing!private! !

!GlorpBookstoreCustomer class methodsFor!

new
	^super new initialize.! !
!GlorpBookstoreCustomer class categoriesFor: #new!instance creation!private! !

GlorpCompressedMoney guid: (GUID fromString: '{9C11BDBD-B3EF-47BF-93E0-FEEAC5E49171}')!
GlorpCompressedMoney comment: ''!
!GlorpCompressedMoney categoriesForClass!Unclassified! !
!GlorpCompressedMoney methodsFor!

amount
	^array at: 2!

amount: anObject
	array at: 2 put: anObject!

currency
	^array at: 1!

currency: anObject
	array at: 1 put: anObject!

id
	^id!

id: anObject
	id := anObject!

initialize

	array := Array new: 2.!

printOn: aStream

	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self amount;
		space;
		nextPutAll: self currency;
		nextPut: $).! !
!GlorpCompressedMoney categoriesFor: #amount!accessing!private! !
!GlorpCompressedMoney categoriesFor: #amount:!accessing!private! !
!GlorpCompressedMoney categoriesFor: #currency!accessing!private! !
!GlorpCompressedMoney categoriesFor: #currency:!accessing!private! !
!GlorpCompressedMoney categoriesFor: #id!accessing!private! !
!GlorpCompressedMoney categoriesFor: #id:!accessing!private! !
!GlorpCompressedMoney categoriesFor: #initialize!initialize!private! !
!GlorpCompressedMoney categoriesFor: #printOn:!printing!private! !

!GlorpCompressedMoney class methodsFor!

currency: aSymbol amount: aNumber

	^super new initialize
		currency: aSymbol;
		amount: aNumber.!

defaultCurrency

	^#CDN.!

forAmount: aNumber

	^self currency: self defaultCurrency amount: aNumber.!

new
	^super new initialize.! !
!GlorpCompressedMoney class categoriesFor: #currency:amount:!instance creation!private! !
!GlorpCompressedMoney class categoriesFor: #defaultCurrency!instance creation!private! !
!GlorpCompressedMoney class categoriesFor: #forAmount:!instance creation!private! !
!GlorpCompressedMoney class categoriesFor: #new!instance creation!private! !

GlorpCustomer guid: (GUID fromString: '{73BB5DFB-BE21-43C5-BD4D-1EC6B84FFD41}')!
GlorpCustomer comment: ''!
!GlorpCustomer categoriesForClass!Unclassified! !
!GlorpCustomer methodsFor!

accounts

	^accounts.!

accounts: aCollection

	accounts := aCollection.!

accountsSortedById
	^accountsSortedById.!

accountsSortedByIdDescending
	^accountsSortedByIdDescending.!

addAccount: aBankAccount

	accounts add: aBankAccount.
	aBankAccount basicAddHolder: self.!

addTransaction: aTransaction

	transactions add: aTransaction.
	aTransaction owner: self.!

glorpNoticeOfExpiryIn: aSession
	seenExpiry := true.!

glorpPostFetch: aSession
	seenPostFetch := true!

glorpPostWrite: aSession
	seenPostWrite := true!

glorpPreWrite: aSession
	seenPreWrite := true!

id
	"Private - Answer the value of the receiver's ''id'' instance variable."

	^id!

id: anObject
	"Private - Set the value of the receiver's ''id'' instance variable to the argument, anObject."

	id := anObject!

initialize

	transactions := OrderedCollection new.
	accounts := OrderedCollection new.
	seenExpiry := false.
	seenPostFetch := false.
	seenPreWrite:= false.
	seenPostWrite := false.!

name
	"Private - Answer the value of the receiver's ''name'' instance variable."

	^name!

name: anObject
	"Private - Set the value of the receiver's ''name'' instance variable to the argument, anObject."

	name := anObject!

printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: id;
		nextPut: $,;
		nextPutAll: (name ifNil: ['']);
		nextPutAll: ')'!

removeAccount: aBankAccount

	accounts remove: aBankAccount.
	aBankAccount basicRemoveHolder: self.!

seenExpiry
	^seenExpiry!

seenPostFetch
	^seenPostFetch!

seenPostWrite
	^seenPostWrite!

seenPreWrite
	^seenPreWrite!

transactions
	"Private - Answer the value of the receiver's ''transactions'' instance variable."

	^transactions!

transactions: anObject
	"Private - Set the value of the receiver's ''transactions'' instance variable to the argument, anObject."

	transactions := anObject! !
!GlorpCustomer categoriesFor: #accounts!accessing!private! !
!GlorpCustomer categoriesFor: #accounts:!accessing!private! !
!GlorpCustomer categoriesFor: #accountsSortedById!As yet unclassified!private! !
!GlorpCustomer categoriesFor: #accountsSortedByIdDescending!As yet unclassified!private! !
!GlorpCustomer categoriesFor: #addAccount:!accessing!private! !
!GlorpCustomer categoriesFor: #addTransaction:!accessing!private! !
!GlorpCustomer categoriesFor: #glorpNoticeOfExpiryIn:!glorp/events!private! !
!GlorpCustomer categoriesFor: #glorpPostFetch:!glorp/events!private! !
!GlorpCustomer categoriesFor: #glorpPostWrite:!glorp/events!private! !
!GlorpCustomer categoriesFor: #glorpPreWrite:!glorp/events!private! !
!GlorpCustomer categoriesFor: #id!accessing!private! !
!GlorpCustomer categoriesFor: #id:!accessing!private! !
!GlorpCustomer categoriesFor: #initialize!initialize/release!private! !
!GlorpCustomer categoriesFor: #name!accessing!private! !
!GlorpCustomer categoriesFor: #name:!accessing!private! !
!GlorpCustomer categoriesFor: #printOn:!printing!private! !
!GlorpCustomer categoriesFor: #removeAccount:!accessing!private! !
!GlorpCustomer categoriesFor: #seenExpiry!glorp/events!private! !
!GlorpCustomer categoriesFor: #seenPostFetch!accessing!private! !
!GlorpCustomer categoriesFor: #seenPostWrite!accessing!private! !
!GlorpCustomer categoriesFor: #seenPreWrite!accessing!private! !
!GlorpCustomer categoriesFor: #transactions!accessing!private! !
!GlorpCustomer categoriesFor: #transactions:!accessing!private! !

!GlorpCustomer class methodsFor!

example1

	^self new
		name: 'Fred Flintstone';
		addTransaction: GlorpBankTransaction example1;
		addTransaction: GlorpBankTransaction example2.!

example2

	^self new
          id: 123;
		name: 'Fred Flintstone';
		addTransaction: GlorpBankTransaction example1;
		addTransaction: GlorpBankTransaction example2.!

exampleD1

	^self new
		name: 'Fred Flintstone'!

exampleD2

	^self new
		name: 'Wilma Flintstone'!

exampleD3

	^self new
		name: 'Pebbles Flintstone'!

new

	^super new initialize.! !
!GlorpCustomer class categoriesFor: #example1!examples!private! !
!GlorpCustomer class categoriesFor: #example2!examples!private! !
!GlorpCustomer class categoriesFor: #exampleD1!examples!public! !
!GlorpCustomer class categoriesFor: #exampleD2!examples!public! !
!GlorpCustomer class categoriesFor: #exampleD3!examples!public! !
!GlorpCustomer class categoriesFor: #new!instance creation!private! !

GlorpDescriptorSystemWithNamespacePoolDictionaryDeclarer guid: (GUID fromString: '{C8D1FF92-B2F5-4401-BA23-4DB677AB401C}')!
GlorpDescriptorSystemWithNamespacePoolDictionaryDeclarer comment: ''!
!GlorpDescriptorSystemWithNamespacePoolDictionaryDeclarer categoriesForClass!Unclassified! !
!GlorpDescriptorSystemWithNamespacePoolDictionaryDeclarer class methodsFor!

_PRAGMA_GlorpTestNamespace
	"%%PRAGMA DECLARE
	(name: GlorpTestNamespace isPool: true isConstant: true)
	(pool: GlorpTestNamespace declarations: (
		))"! !
!GlorpDescriptorSystemWithNamespacePoolDictionaryDeclarer class categoriesFor: #_PRAGMA_GlorpTestNamespace!private!VA compatibility! !

GlorpDocument guid: (GUID fromString: '{8EBB9AAC-72E4-4596-8B5A-6C408E27402E}')!
GlorpDocument comment: ''!
!GlorpDocument categoriesForClass!Unclassified! !
!GlorpDocument methodsFor!

attachments
	^attachments!

attachments: anObject
	attachments := anObject!

id
	^id!

id: anObject
	id := anObject!

initialize
	attachments := OrderedCollection new.
	whatever := 3.! !
!GlorpDocument categoriesFor: #attachments!accessing!private! !
!GlorpDocument categoriesFor: #attachments:!accessing!private! !
!GlorpDocument categoriesFor: #id!accessing!private! !
!GlorpDocument categoriesFor: #id:!accessing!private! !
!GlorpDocument categoriesFor: #initialize!initialize-release!private! !

!GlorpDocument class methodsFor!

glorpSetupClassModel: model forSystem: system 
	model
		newAttributeNamed: #id;
		newAttributeNamed: #whatever;
		newAttributeNamed: #attachments
			collection: OrderedCollection
			of: GlorpAttachment!

glorpSetupDescriptor: aDesc forSystem: system 
	| t |
	t := system tableNamed: 'document'.
	aDesc table: t.
	(aDesc newMapping: DirectMapping) from: #id to: (t fieldNamed: 'id').
	(aDesc newMapping: DirectMapping) from: #whatever to: (t fieldNamed: 'whatever').
	(aDesc newMapping: OneToManyMapping)
		attributeName: #attachments;
		orderBy: [:ea | ea index]! !
!GlorpDocument class categoriesFor: #glorpSetupClassModel:forSystem:!glorp!private! !
!GlorpDocument class categoriesFor: #glorpSetupDescriptor:forSystem:!glorp!private! !

GlorpEmailAddress guid: (GUID fromString: '{682F2093-C52B-4996-886F-309C4FA6B62A}')!
GlorpEmailAddress comment: ''!
!GlorpEmailAddress categoriesForClass!Unclassified! !
!GlorpEmailAddress methodsFor!

host
	^host!

host: anObject
	host := anObject!

id
	^ id!

id: anInteger
	 id := anInteger.!

printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: id printString.
	aStream nextPut: $).!

user
	^user!

user: anObject
	user := anObject! !
!GlorpEmailAddress categoriesFor: #host!accessing!private! !
!GlorpEmailAddress categoriesFor: #host:!accessing!private! !
!GlorpEmailAddress categoriesFor: #id!accessing!private! !
!GlorpEmailAddress categoriesFor: #id:!accessing!private! !
!GlorpEmailAddress categoriesFor: #printOn:!printing!private! !
!GlorpEmailAddress categoriesFor: #user!accessing!private! !
!GlorpEmailAddress categoriesFor: #user:!accessing!private! !

GlorpEncyclopedia guid: (GUID fromString: '{5C1E6453-023F-48CB-BB42-1E73C40DDB15}')!
GlorpEncyclopedia comment: ''!
!GlorpEncyclopedia categoriesForClass!Unclassified! !
!GlorpEncyclopedia methodsFor!

articleAt: aString put: anEntry
	entries at: aString put: anEntry.!

biographicalEntries
	^biographicalEntries!

biographicalEntries: aDictionary
	biographicalEntries := aDictionary!

entries
	^entries.!

entries: aDictionary
	entries := aDictionary!

id
	^id!

id: anInteger
	id := anInteger!

initialize

	entries := Dictionary new.
	biographicalEntries := Dictionary new.!

name
	^name!

name: aString
	name := aString!

printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	name isNil ifFalse: [aStream nextPutAll: name].
	aStream nextPut: $).! !
!GlorpEncyclopedia categoriesFor: #articleAt:put:!accessing!private! !
!GlorpEncyclopedia categoriesFor: #biographicalEntries!accessing!private! !
!GlorpEncyclopedia categoriesFor: #biographicalEntries:!accessing!private! !
!GlorpEncyclopedia categoriesFor: #entries!accessing!private! !
!GlorpEncyclopedia categoriesFor: #entries:!accessing!private! !
!GlorpEncyclopedia categoriesFor: #id!accessing!private! !
!GlorpEncyclopedia categoriesFor: #id:!accessing!private! !
!GlorpEncyclopedia categoriesFor: #initialize!initialize!private! !
!GlorpEncyclopedia categoriesFor: #name!accessing!private! !
!GlorpEncyclopedia categoriesFor: #name:!accessing!private! !
!GlorpEncyclopedia categoriesFor: #printOn:!accessing!private! !

!GlorpEncyclopedia class methodsFor!

example1
	| result |
	result := GlorpEncyclopedia new.
	result entries at: 'one' put: GlorpEncyclopediaEntry example1.
	result entries at: 'two' put: GlorpEncyclopediaEntry example2.
	^result.!

new

	^super new initialize.! !
!GlorpEncyclopedia class categoriesFor: #example1!examples!private! !
!GlorpEncyclopedia class categoriesFor: #new!instance creation!private! !

GlorpEncyclopediaBioEntry guid: (GUID fromString: '{43A6B52B-4DE5-4A3F-BDCE-2790EC2A23BF}')!
GlorpEncyclopediaBioEntry comment: ''!
!GlorpEncyclopediaBioEntry categoriesForClass!Unclassified! !
!GlorpEncyclopediaBioEntry methodsFor!

initialize!

text
	^text!

text: anObject
	text := anObject!

title
	^title!

title: anObject
	title := anObject! !
!GlorpEncyclopediaBioEntry categoriesFor: #initialize!initialize-release!private! !
!GlorpEncyclopediaBioEntry categoriesFor: #text!accessing!private! !
!GlorpEncyclopediaBioEntry categoriesFor: #text:!accessing!private! !
!GlorpEncyclopediaBioEntry categoriesFor: #title!accessing!private! !
!GlorpEncyclopediaBioEntry categoriesFor: #title:!accessing!private! !

!GlorpEncyclopediaBioEntry class methodsFor!

new
	^super new initialize.! !
!GlorpEncyclopediaBioEntry class categoriesFor: #new!instance creation!private! !

GlorpEncyclopediaEntry guid: (GUID fromString: '{B2E2FE76-BE13-4333-A68A-8331D5D17375}')!
GlorpEncyclopediaEntry comment: ''!
!GlorpEncyclopediaEntry categoriesForClass!Unclassified! !
!GlorpEncyclopediaEntry methodsFor!

id
	^id!

id: aSmallInteger 
	id := aSmallInteger.!

initialize
	mediaType := GlorpMediaType text!

mediaType
	^mediaType!

mediaType: anObject
	mediaType := anObject!

printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	title isNil ifFalse: [aStream nextPutAll: title].
	aStream nextPut: $).!

text
	^text!

text: aString 
	text := aString.!

title
	^title!

title: aString 
	title := aString! !
!GlorpEncyclopediaEntry categoriesFor: #id!accessing!private! !
!GlorpEncyclopediaEntry categoriesFor: #id:!accessing!private! !
!GlorpEncyclopediaEntry categoriesFor: #initialize!initialize-release!private! !
!GlorpEncyclopediaEntry categoriesFor: #mediaType!accessing!private! !
!GlorpEncyclopediaEntry categoriesFor: #mediaType:!accessing!private! !
!GlorpEncyclopediaEntry categoriesFor: #printOn:!printing!private! !
!GlorpEncyclopediaEntry categoriesFor: #text!accessing!private! !
!GlorpEncyclopediaEntry categoriesFor: #text:!accessing!private! !
!GlorpEncyclopediaEntry categoriesFor: #title!accessing!private! !
!GlorpEncyclopediaEntry categoriesFor: #title:!accessing!private! !

!GlorpEncyclopediaEntry class methodsFor!

example1
	^self new
		id: 1;
		name: 'One';
		text: 'The first number (not counting zero)'.!

example2
	^self new
		id: 2;
		name: 'Two';
		text: 'The second number (comes after 1)'.!

new
	^super new initialize! !
!GlorpEncyclopediaEntry class categoriesFor: #example1!examples!private! !
!GlorpEncyclopediaEntry class categoriesFor: #example2!examples!private! !
!GlorpEncyclopediaEntry class categoriesFor: #new!As yet unclassified!private! !

GlorpExampleSystem guid: (GUID fromString: '{C62CAA5A-640D-42BA-9CE2-A22B967643D0}')!
GlorpExampleSystem comment: ''!
!GlorpExampleSystem categoriesForClass!Unclassified! !
!GlorpExampleSystem methodsFor!

initialize

	objects := Dictionary new.!

lookupObject: aNumber ofClass: aClass ifAbsentPut: absentBlock

	^(objects at: aClass ifAbsentPut: [Dictionary new]) at: aNumber ifAbsentPut: absentBlock.!

objectNumber: aNumber ofClass: aClass

	| symbol instance|
	instance := self lookupObject: aNumber ofClass: aClass ifAbsentPut: [aClass new].
	symbol := ('example', aClass name, 'Number', aNumber printString, ':') asSymbol.
	self perform: symbol with: instance.
	^instance.! !
!GlorpExampleSystem categoriesFor: #initialize!initialize!private! !
!GlorpExampleSystem categoriesFor: #lookupObject:ofClass:ifAbsentPut:!misc!private! !
!GlorpExampleSystem categoriesFor: #objectNumber:ofClass:!api!private! !

!GlorpExampleSystem class methodsFor!

new

	^super new initialize! !
!GlorpExampleSystem class categoriesFor: #new!instance creation!private! !

GlorpFolder guid: (GUID fromString: '{63B3A283-2872-4605-B3BF-6ADCC351B0FA}')!
GlorpFolder comment: ''!
!GlorpFolder categoriesForClass!Unclassified! !
!GlorpFolder methodsFor!

initialize
	user := nil.
	messages := OrderedCollection new.!

messages
	^messages!

messages: aCollection
	messages := aCollection!

name
	^name.!

name: aString
	name := aString.!

user
	^user!

user: aGlorpUser
	user := aGlorpUser!

userId
	^self user id.! !
!GlorpFolder categoriesFor: #initialize!initialize-release!private! !
!GlorpFolder categoriesFor: #messages!accessing!private! !
!GlorpFolder categoriesFor: #messages:!accessing!private! !
!GlorpFolder categoriesFor: #name!accessing!private! !
!GlorpFolder categoriesFor: #name:!accessing!private! !
!GlorpFolder categoriesFor: #user!accessing!private! !
!GlorpFolder categoriesFor: #user:!accessing!private! !
!GlorpFolder categoriesFor: #userId!accessing!private! !

!GlorpFolder class methodsFor!

new
	"Answer a newly created and initialized instance."

	^super new initialize! !
!GlorpFolder class categoriesFor: #new!instance creation!private! !

GlorpGallery guid: (GUID fromString: '{5FEBD2E6-3365-4296-ADD4-3150E676907E}')!
GlorpGallery comment: ''!
!GlorpGallery categoriesForClass!Unclassified! !
!GlorpGallery methodsFor!

id
	^id!

id: anObject
	id := anObject!

images
	^images!

images: anObject
	images := anObject!

initialize
	images := OrderedCollection new.!

name
	^name!

name: anObject
	name := anObject! !
!GlorpGallery categoriesFor: #id!accessing!private! !
!GlorpGallery categoriesFor: #id:!accessing!private! !
!GlorpGallery categoriesFor: #images!accessing!private! !
!GlorpGallery categoriesFor: #images:!accessing!private! !
!GlorpGallery categoriesFor: #initialize!initialize-release!private! !
!GlorpGallery categoriesFor: #name!accessing!private! !
!GlorpGallery categoriesFor: #name:!accessing!private! !

!GlorpGallery class methodsFor!

new
	^super new initialize.! !
!GlorpGallery class categoriesFor: #new!instance creation!private! !

GlorpImageFile guid: (GUID fromString: '{51FDF27B-23A9-4026-9B59-DD0F1F4658F8}')!
GlorpImageFile comment: ''!
!GlorpImageFile categoriesForClass!Unclassified! !
!GlorpImageFile methodsFor!

bits
	^bits!

bits: anObject
	bits := anObject!

id
	^id!

id: anObject
	id := anObject!

isLarge
	^bits size > 10.!

thumbnailBits
	thumbnailBits isNil ifTrue: [thumbnailBits := bits copyFrom: 1 to: 5].
	^thumbnailBits.!

thumbnailBits: aByteArray
	thumbnailBits := aByteArray!

title
	^title!

title: anObject
	title := anObject! !
!GlorpImageFile categoriesFor: #bits!accessing!private! !
!GlorpImageFile categoriesFor: #bits:!accessing!private! !
!GlorpImageFile categoriesFor: #id!accessing!private! !
!GlorpImageFile categoriesFor: #id:!accessing!private! !
!GlorpImageFile categoriesFor: #isLarge!private!testing! !
!GlorpImageFile categoriesFor: #thumbnailBits!private!testing! !
!GlorpImageFile categoriesFor: #thumbnailBits:!accessing!private! !
!GlorpImageFile categoriesFor: #title!accessing!private! !
!GlorpImageFile categoriesFor: #title:!accessing!private! !

!GlorpImageFile class methodsFor!

example1
	^self new
		title: 'example1';
		bits: #[1 2 3 4 5].!

example2
	^self new
		title: 'example2';
		bits: #[1 2 3 4 5 6 7 8 9 10 11 12 13 14 15].! !
!GlorpImageFile class categoriesFor: #example1!examples!private! !
!GlorpImageFile class categoriesFor: #example2!examples!private! !

GlorpImageLink guid: (GUID fromString: '{F3D09C04-1D2D-4BDE-B4E6-8566726C11C7}')!
GlorpImageLink comment: ''!
!GlorpImageLink categoriesForClass!Unclassified! !
!GlorpImageLink methodsFor!

id
	^id!

id: anObject
	id := anObject!

image
	^fullImage!

image: anObject
	fullImage := anObject!

thumbnailBits
	^thumbnailBits!

thumbnailBits: anObject
	thumbnailBits := anObject!

title
	^title!

title: anObject
	title := anObject! !
!GlorpImageLink categoriesFor: #id!accessing!private! !
!GlorpImageLink categoriesFor: #id:!accessing!private! !
!GlorpImageLink categoriesFor: #image!accessing!private! !
!GlorpImageLink categoriesFor: #image:!accessing!private! !
!GlorpImageLink categoriesFor: #thumbnailBits!accessing!private! !
!GlorpImageLink categoriesFor: #thumbnailBits:!accessing!private! !
!GlorpImageLink categoriesFor: #title!accessing!private! !
!GlorpImageLink categoriesFor: #title:!accessing!private! !

GlorpInventoryItem guid: (GUID fromString: '{57245ED0-1155-4AF7-9261-059583EA6691}')!
GlorpInventoryItem comment: ''!
!GlorpInventoryItem categoriesForClass!Unclassified! !
!GlorpInventoryItem methodsFor!

id
	^id!

id: anObject
	id := anObject!

name
	^name!

name: anObject
	name := anObject!

printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: id printString.
	aStream nextPut: $,.
	aStream nextPutAll: name printString.
	aStream nextPut: $).! !
!GlorpInventoryItem categoriesFor: #id!accessing!private! !
!GlorpInventoryItem categoriesFor: #id:!accessing!private! !
!GlorpInventoryItem categoriesFor: #name!accessing!private! !
!GlorpInventoryItem categoriesFor: #name:!accessing!private! !
!GlorpInventoryItem categoriesFor: #printOn:!printing!private! !

GlorpItinerary guid: (GUID fromString: '{63B0BF7E-7C8C-456F-9A64-B3F5D5F2555B}')!
GlorpItinerary comment: 'An itinerary holds onto a single reservation. It may not make much sense, but we need to test another layer of indirection.
'!
!GlorpItinerary categoriesForClass!Unclassified! !
!GlorpItinerary methodsFor!

id
	^id!

id: anObject
	id := anObject!

reservation
	^reservation!

reservation: anObject
	reservation := anObject! !
!GlorpItinerary categoriesFor: #id!accessing!private! !
!GlorpItinerary categoriesFor: #id:!accessing!private! !
!GlorpItinerary categoriesFor: #reservation!accessing!private! !
!GlorpItinerary categoriesFor: #reservation:!accessing!private! !

!GlorpItinerary class methodsFor!

example1
	^self new
		reservation: GlorpReservation example1.!

example2
	^self new
		reservation: GlorpReservation example2.! !
!GlorpItinerary class categoriesFor: #example1!examples!private! !
!GlorpItinerary class categoriesFor: #example2!examples!private! !

GlorpJob guid: (GUID fromString: '{A94C98F6-C851-4DE0-86C4-CCE4083F9B49}')!
GlorpJob comment: ''!
!GlorpJob categoriesForClass!Unclassified! !
!GlorpJob methodsFor!

description
	^description!

description: anObject
	description := anObject!

id
	^id!

id: anObject
	id := anObject! !
!GlorpJob categoriesFor: #description!accessing!private! !
!GlorpJob categoriesFor: #description:!accessing!private! !
!GlorpJob categoriesFor: #id!accessing!private! !
!GlorpJob categoriesFor: #id:!accessing!private! !

GlorpMediaType guid: (GUID fromString: '{5AA9FD87-27A5-4783-8364-15466A1C87C1}')!
GlorpMediaType comment: ''!
!GlorpMediaType categoriesForClass!Unclassified! !
!GlorpMediaType methodsFor!

mimeType
	^mimeType!

mimeType: anObject
	mimeType := anObject!

name 
	^name!

name: anObject
	name := anObject! !
!GlorpMediaType categoriesFor: #mimeType!accessing!private! !
!GlorpMediaType categoriesFor: #mimeType:!accessing!private! !
!GlorpMediaType categoriesFor: #name!accessing!private! !
!GlorpMediaType categoriesFor: #name:!accessing!private! !

!GlorpMediaType class methodsFor!

text
	^self new name: 'text'; mimeType: 'text/plain'! !
!GlorpMediaType class categoriesFor: #text!instance creation!private! !

GlorpMessage guid: (GUID fromString: '{EACCE6BA-EE0B-4081-9B29-F044730F9E7C}')!
GlorpMessage comment: ''!
!GlorpMessage categoriesForClass!Unclassified! !
!GlorpMessage methodsFor!

contents
	^contents!

contents: aString
	contents := aString!

folder
	^folder!

folder: aGlorpFolder
	folder := aGlorpFolder!

folderName
	^self folder name.!

initialize
	folder := nil.
	user := nil.
	subject := ''.
	contents := ''.!

subject
	^subject!

subject: aString
	subject := aString!

user
	^user!

user: aGlorpUser
	user := aGlorpUser!

userId
	^self user id.! !
!GlorpMessage categoriesFor: #contents!accessing!private! !
!GlorpMessage categoriesFor: #contents:!accessing!private! !
!GlorpMessage categoriesFor: #folder!accessing!private! !
!GlorpMessage categoriesFor: #folder:!accessing!private! !
!GlorpMessage categoriesFor: #folderName!accessing!private! !
!GlorpMessage categoriesFor: #initialize!initialize-release!private! !
!GlorpMessage categoriesFor: #subject!accessing!private! !
!GlorpMessage categoriesFor: #subject:!accessing!private! !
!GlorpMessage categoriesFor: #user!accessing!private! !
!GlorpMessage categoriesFor: #user:!accessing!private! !
!GlorpMessage categoriesFor: #userId!accessing!private! !

!GlorpMessage class methodsFor!

new
	"Answer a newly created and initialized instance."

	^super new initialize! !
!GlorpMessage class categoriesFor: #new!instance creation!private! !

GlorpMoney guid: (GUID fromString: '{EC5157B0-BB3A-41C9-BA89-3B756FAF72FE}')!
GlorpMoney comment: ''!
!GlorpMoney categoriesForClass!Unclassified! !
!GlorpMoney methodsFor!

amount
	^amount!

amount: anInteger
	amount := anInteger!

currency
	^currency!

currency: aSymbol
	currency := aSymbol! !
!GlorpMoney categoriesFor: #amount!accessing!private! !
!GlorpMoney categoriesFor: #amount:!accessing!private! !
!GlorpMoney categoriesFor: #currency!accessing!private! !
!GlorpMoney categoriesFor: #currency:!accessing!private! !

!GlorpMoney class methodsFor!

currency: aSymbol amount: aNumber

	^self new
		currency: aSymbol;
		amount: aNumber.!

defaultCurrency

	^#CDN.!

forAmount: anAmount

	^self currency: self defaultCurrency amount: anAmount.! !
!GlorpMoney class categoriesFor: #currency:amount:!instance creation!private! !
!GlorpMoney class categoriesFor: #defaultCurrency!instance creation!private! !
!GlorpMoney class categoriesFor: #forAmount:!instance creation!private! !

GlorpObjectWithNoAccessors guid: (GUID fromString: '{EE333779-A2F4-43A2-9C1E-08CB1D3BC65D}')!
GlorpObjectWithNoAccessors comment: ''!
!GlorpObjectWithNoAccessors categoriesForClass!Unclassified! !
!GlorpObjectWithNoAccessors methodsFor!

extremelyPrivateValue: aString
	alue := aString! !
!GlorpObjectWithNoAccessors categoriesFor: #extremelyPrivateValue:!accessing!private! !

GlorpOffice guid: (GUID fromString: '{4646C773-29C0-4926-AD2F-FC96581E8158}')!
GlorpOffice comment: ''!
!GlorpOffice categoriesForClass!Unclassified! !
!GlorpOffice methodsFor!

addEmployee: anEmployee
	self employees add: anEmployee.!

employeeOfMonth
	^employeeOfMonth!

employeeOfMonth: anObject
	employeeOfMonth := anObject!

employees
	employees isNil ifTrue: [ employees := OrderedCollection new ].
	^employees!

employees: anObject
	employees := anObject!

id
	^id!

id: anObject
	id := anObject!

street
	^street!

street: aString
	street := aString! !
!GlorpOffice categoriesFor: #addEmployee:!accessing!private! !
!GlorpOffice categoriesFor: #employeeOfMonth!accessing!private! !
!GlorpOffice categoriesFor: #employeeOfMonth:!accessing!private! !
!GlorpOffice categoriesFor: #employees!accessing!private! !
!GlorpOffice categoriesFor: #employees:!accessing!private! !
!GlorpOffice categoriesFor: #id!accessing!private! !
!GlorpOffice categoriesFor: #id:!accessing!private! !
!GlorpOffice categoriesFor: #street!accessing!private! !
!GlorpOffice categoriesFor: #street:!accessing!private! !

GlorpOwner guid: (GUID fromString: '{3B61AB1C-615D-4B20-A8E0-F90604006A58}')!
GlorpOwner comment: ''!
!GlorpOwner categoriesForClass!Unclassified! !
!GlorpOwner methodsFor!

id
	^id.!

id: anObject
	id := anObject.!

slave
	^slave.!

slave: anObject
	slave := anObject.!

slaves
	^slaves.!

slaves: anObject
	slaves := anObject.! !
!GlorpOwner categoriesFor: #id!accessing!private! !
!GlorpOwner categoriesFor: #id:!accessing!private! !
!GlorpOwner categoriesFor: #slave!accessing!private! !
!GlorpOwner categoriesFor: #slave:!accessing!private! !
!GlorpOwner categoriesFor: #slaves!accessing!private! !
!GlorpOwner categoriesFor: #slaves:!accessing!private! !

GlorpPassenger guid: (GUID fromString: '{F7C6273C-6308-4AC5-A35B-95B26750044D}')!
GlorpPassenger comment: ''!
!GlorpPassenger categoriesForClass!Unclassified! !
!GlorpPassenger methodsFor!

airline
	^airline.!

airline: anAirline
	airline := anAirline.!

frequentFlyerPoints
	^frequentFlyerMiles.!

frequentFlyerPoints: aSmallInteger 
	frequentFlyerMiles := aSmallInteger.!

id
	^id!

id: aSmallInteger 
	id := aSmallInteger.!

name
	^name.!

name: aString 
	name := aString.! !
!GlorpPassenger categoriesFor: #airline!accessing!private! !
!GlorpPassenger categoriesFor: #airline:!accessing!private! !
!GlorpPassenger categoriesFor: #frequentFlyerPoints!accessing!private! !
!GlorpPassenger categoriesFor: #frequentFlyerPoints:!accessing!private! !
!GlorpPassenger categoriesFor: #id!accessing!private! !
!GlorpPassenger categoriesFor: #id:!accessing!private! !
!GlorpPassenger categoriesFor: #name!accessing!private! !
!GlorpPassenger categoriesFor: #name:!accessing!private! !

!GlorpPassenger class methodsFor!

example1

	^self new
		id: 3;
		name: 'Some Passenger';
		frequentFlyerPoints: 10000;
		airline: GlorpAirline example1.!

example2

	^self new
		id: 39;
		name: 'Some Other Passenger';
		frequentFlyerPoints: 7;
		airline: GlorpAirline example2.! !
!GlorpPassenger class categoriesFor: #example1!examples!private! !
!GlorpPassenger class categoriesFor: #example2!examples!private! !

GlorpPerson guid: (GUID fromString: '{51233A3F-304C-44E3-A37D-AEDBF1C187D4}')!
GlorpPerson comment: ''!
!GlorpPerson categoriesForClass!Unclassified! !
!GlorpPerson methodsFor!

address
	"Private - Answer the value of the receiver's ''address'' instance variable."

	^address!

address: anObject
	"Private - Set the value of the receiver's ''address'' instance variable to the argument, anObject."

	address := anObject!

emailAddresses
	^emailAddresses!

emailAddresses: aCollection
	emailAddresses := aCollection!

hasEmail
	^hasEmail!

hasEmail: aBoolean
	hasEmail := aBoolean!

id
	"Private - Answer the value of the receiver's ''id'' instance variable."

	^id!

id: anObject
	"Private - Set the value of the receiver's ''id'' instance variable to the argument, anObject."

	id := anObject!

name
	"Private - Answer the value of the receiver's ''name'' instance variable."

	^name!

name: anObject
	"Private - Set the value of the receiver's ''name'' instance variable to the argument, anObject."

	name := anObject!

printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '('.
	aStream nextPutAll: id printString, ',', (name ifNil: ['']).
	aStream nextPutAll: ')'.! !
!GlorpPerson categoriesFor: #address!accessing!private! !
!GlorpPerson categoriesFor: #address:!accessing!private! !
!GlorpPerson categoriesFor: #emailAddresses!accessing!private! !
!GlorpPerson categoriesFor: #emailAddresses:!accessing!private! !
!GlorpPerson categoriesFor: #hasEmail!accessing!private! !
!GlorpPerson categoriesFor: #hasEmail:!accessing!private! !
!GlorpPerson categoriesFor: #id!accessing!private! !
!GlorpPerson categoriesFor: #id:!accessing!private! !
!GlorpPerson categoriesFor: #name!accessing!private! !
!GlorpPerson categoriesFor: #name:!accessing!private! !
!GlorpPerson categoriesFor: #printOn:!printing!private! !

!GlorpPerson class methodsFor!

example1

	^self new
		id: 1;
		name: 'Zaphod Beeblebrox';
		address: GlorpAddress example1.!

example1WithChangedAddress

	^self new
		id: 1;
		name: 'Zaphod Beeblebrox';
		address: GlorpAddress example1WithChangedAddress.!

example1WithDifferentAddress

	^self new
		id: 1;
		name: 'Zaphod Beeblebrox';
		address: GlorpAddress example2.!

example1WithDifferentName

	^self new
		id: 1; 
		name: 'John Doe';
		address: GlorpAddress example1.!

example1WithNoAddress

	^self new
		id: 1;
		name: 'Zaphod Beeblebrox';
		address: nil.!

example2

	^self new
		id: 2;
		name: 'John Doe';
		address: GlorpAddress example2.! !
!GlorpPerson class categoriesFor: #example1!examples!private! !
!GlorpPerson class categoriesFor: #example1WithChangedAddress!examples!private! !
!GlorpPerson class categoriesFor: #example1WithDifferentAddress!examples!private! !
!GlorpPerson class categoriesFor: #example1WithDifferentName!examples!private! !
!GlorpPerson class categoriesFor: #example1WithNoAddress!examples!private! !
!GlorpPerson class categoriesFor: #example2!examples!private! !

GlorpPublisher guid: (GUID fromString: '{A19446BA-084F-4A93-BCBA-CB6633A42995}')!
GlorpPublisher comment: ''!
!GlorpPublisher categoriesForClass!Unclassified! !
!GlorpPublisher methodsFor!

differentBunchOfEmployeesById
	^differentBunchOfEmployeesById!

differentBunchOfEmployeesById: aDictionary
	differentBunchOfEmployeesById := aDictionary!

employees
	^employees.!

employees: aDictionary
	employees := aDictionary.!

id
	^id!

id: anObject
	id := anObject!

name
	^name!

name: anObject
	name := anObject!

titles
	^titles!

titles: aCollectionOfStrings
	titles := aCollectionOfStrings!

titlesWithNumberInStock
	^titlesWithNumberInStock!

titlesWithNumberInStock: aDictionary
	titlesWithNumberInStock := aDictionary.
	self titlesWithNumberInStockLink: (Dictionary new addAll: (aDictionary associations collect: [:each | each copy]); yourself).!

titlesWithNumberInStockLink
	^titlesWithNumberInStockLink!

titlesWithNumberInStockLink: aDictionary
	titlesWithNumberInStockLink := aDictionary! !
!GlorpPublisher categoriesFor: #differentBunchOfEmployeesById!accessing!private! !
!GlorpPublisher categoriesFor: #differentBunchOfEmployeesById:!accessing!private! !
!GlorpPublisher categoriesFor: #employees!accessing!private! !
!GlorpPublisher categoriesFor: #employees:!accessing!private! !
!GlorpPublisher categoriesFor: #id!accessing!private! !
!GlorpPublisher categoriesFor: #id:!accessing!private! !
!GlorpPublisher categoriesFor: #name!accessing!private! !
!GlorpPublisher categoriesFor: #name:!accessing!private! !
!GlorpPublisher categoriesFor: #titles!accessing!private! !
!GlorpPublisher categoriesFor: #titles:!accessing!private! !
!GlorpPublisher categoriesFor: #titlesWithNumberInStock!accessing!private! !
!GlorpPublisher categoriesFor: #titlesWithNumberInStock:!accessing!private! !
!GlorpPublisher categoriesFor: #titlesWithNumberInStockLink!accessing!private! !
!GlorpPublisher categoriesFor: #titlesWithNumberInStockLink:!accessing!private! !

GlorpPublisherEmployee guid: (GUID fromString: '{A439E78A-5120-40B4-B9C0-1BFE051BFAA0}')!
GlorpPublisherEmployee comment: ''!
!GlorpPublisherEmployee categoriesForClass!Unclassified! !
!GlorpPublisherEmployee methodsFor!

id
	^id!

id: anObject
	id := anObject!

initialize
	"Initialize a newly created instance. This method must answer the receiver."

	" *** Edit the following to properly initialize instance variables ***"
	id := nil.
	name := nil.
	jobTitle := nil.
	" *** And replace this comment with additional initialization code *** "
	^self!

jobTitle
	^jobTitle!

jobTitle: aString
	jobTitle := aString!

name
	^name!

name: anObject
	name := anObject! !
!GlorpPublisherEmployee categoriesFor: #id!accessing!private! !
!GlorpPublisherEmployee categoriesFor: #id:!accessing!private! !
!GlorpPublisherEmployee categoriesFor: #initialize!initialize-release!private! !
!GlorpPublisherEmployee categoriesFor: #jobTitle!accessing!private! !
!GlorpPublisherEmployee categoriesFor: #jobTitle:!accessing!private! !
!GlorpPublisherEmployee categoriesFor: #name!accessing!private! !
!GlorpPublisherEmployee categoriesFor: #name:!accessing!private! !

!GlorpPublisherEmployee class methodsFor!

new
	"Answer a newly created and initialized instance."

	^super new initialize! !
!GlorpPublisherEmployee class categoriesFor: #new!instance creation!private! !

GlorpRecordWithUpdateTime guid: (GUID fromString: '{68E0CCAF-46A5-44D1-97A3-3F428BE49490}')!
GlorpRecordWithUpdateTime comment: 'This is a model class that has a timestamp which is updated each time it is written.

Instance Variables:
	id	<Integer>	The primary key
	name	<String>	a name
	updateTime	<Timestamp>	When we were last updated.

'!
!GlorpRecordWithUpdateTime categoriesForClass!Unclassified! !
!GlorpRecordWithUpdateTime methodsFor!

id
	^id.!

id: anInteger
	id := anInteger.!

name
	^name.!

name: aString
	name := aString.!

updateSomeOtherThing
	^updateSomeOtherThing!

updateSomeOtherThing: aString
	updateSomeOtherThing := aString!

updateTime
	^updateTime.! !
!GlorpRecordWithUpdateTime categoriesFor: #id!accessing!private! !
!GlorpRecordWithUpdateTime categoriesFor: #id:!accessing!private! !
!GlorpRecordWithUpdateTime categoriesFor: #name!accessing!private! !
!GlorpRecordWithUpdateTime categoriesFor: #name:!accessing!private! !
!GlorpRecordWithUpdateTime categoriesFor: #updateSomeOtherThing!accessing!private! !
!GlorpRecordWithUpdateTime categoriesFor: #updateSomeOtherThing:!accessing!private! !
!GlorpRecordWithUpdateTime categoriesFor: #updateTime!accessing!private! !

GlorpReservation guid: (GUID fromString: '{CF0F81FD-C91D-467C-9B3F-8E6E7D1E2A2B}')!
GlorpReservation comment: ''!
!GlorpReservation categoriesForClass!Unclassified! !
!GlorpReservation methodsFor!

id
	^id!

id: anInteger
	id := anInteger!

initialize
	passengers := OrderedCollection new.!

passenger
	^passenger!

passenger: aPassenger
	passenger := aPassenger.
	passengers add: aPassenger.!

passengers
	^passengers!

passengers: aCollection
	passengers := aCollection.! !
!GlorpReservation categoriesFor: #id!accessing!private! !
!GlorpReservation categoriesFor: #id:!accessing!private! !
!GlorpReservation categoriesFor: #initialize!initialize/release!private! !
!GlorpReservation categoriesFor: #passenger!accessing!private! !
!GlorpReservation categoriesFor: #passenger:!accessing!private! !
!GlorpReservation categoriesFor: #passengers!accessing!private! !
!GlorpReservation categoriesFor: #passengers:!accessing!private! !

!GlorpReservation class methodsFor!

example1

	^self new
		id: 2;
		passenger: GlorpPassenger example1.!

example2

	^self new
		id: 7;
		passenger: GlorpPassenger example2.!

new
	^super new initialize.! !
!GlorpReservation class categoriesFor: #example1!examples!private! !
!GlorpReservation class categoriesFor: #example2!examples!private! !
!GlorpReservation class categoriesFor: #new!instance creation!private! !

GlorpServiceCharge guid: (GUID fromString: '{9FA1B1F2-DCBB-4518-9FD4-E90F46080751}')!
GlorpServiceCharge comment: ''!
!GlorpServiceCharge categoriesForClass!Unclassified! !
!GlorpServiceCharge methodsFor!

amount
	^amount!

amount: anObject
	amount := anObject!

description
	^description!

description: anObject
	description := anObject!

initialize! !
!GlorpServiceCharge categoriesFor: #amount!accessing!private! !
!GlorpServiceCharge categoriesFor: #amount:!accessing!private! !
!GlorpServiceCharge categoriesFor: #description!accessing!private! !
!GlorpServiceCharge categoriesFor: #description:!accessing!private! !
!GlorpServiceCharge categoriesFor: #initialize!initialize!private! !

!GlorpServiceCharge class methodsFor!

default

	^self new
		amount: (GlorpMoney forAmount: 3);
		description: 'additional overcharge'.!

new

	^super new initialize.! !
!GlorpServiceCharge class categoriesFor: #default!instance creation!private! !
!GlorpServiceCharge class categoriesFor: #new!instance creation!private! !

GlorpSlave guid: (GUID fromString: '{1D7B090D-8C22-4F62-A047-78BA28ACBA3A}')!
GlorpSlave comment: ''!
!GlorpSlave categoriesForClass!Unclassified! !
!GlorpSlave methodsFor!

id
	^id.!

id: anObject
	id := anObject.! !
!GlorpSlave categoriesFor: #id!accessing!private! !
!GlorpSlave categoriesFor: #id:!accessing!private! !

GlorpTag guid: (GUID fromString: '{3B9059BF-C249-4FD1-89C0-A2857535CF57}')!
GlorpTag comment: ''!
!GlorpTag categoriesForClass!Unclassified! !
!GlorpTag methodsFor!

generateKeyFromLabel
	key := label asLowercase!

key
	^ key!

key: aKey
	key := aKey!

label
	^ label!

label: aLabel
	label := aLabel! !
!GlorpTag categoriesFor: #generateKeyFromLabel!private! !
!GlorpTag categoriesFor: #key!private! !
!GlorpTag categoriesFor: #key:!private! !
!GlorpTag categoriesFor: #label!private! !
!GlorpTag categoriesFor: #label:!private! !

GlorpTaggableObject guid: (GUID fromString: '{49A0217D-5394-4B4A-8B22-5457ED709ED4}')!
GlorpTaggableObject comment: ''!
!GlorpTaggableObject categoriesForClass!Unclassified! !
!GlorpTaggableObject methodsFor!

initialize
	tags := OrderedCollection new.!

tags
	^ tags!

tags: someTags
	tags := someTags! !
!GlorpTaggableObject categoriesFor: #initialize!private! !
!GlorpTaggableObject categoriesFor: #tags!private! !
!GlorpTaggableObject categoriesFor: #tags:!private! !

!GlorpTaggableObject class methodsFor!

new
	^super new initialize.! !
!GlorpTaggableObject class categoriesFor: #new!instance creation!private! !

GlorpTax guid: (GUID fromString: '{31095983-6FF2-4166-8286-C8DF46652CEE}')!
GlorpTax comment: ''!
!GlorpTax categoriesForClass!Unclassified! !
!GlorpTax methodsFor!

addTax: aTax
	self taxes add: aTax.
	aTax supertax: self.!

id
	^id!

id: anObject
	id := anObject.!

name
	^name!

name: anObject
	name := anObject.!

supertax
	^supertax!

supertax: anObject
	supertax := anObject.!

taxes
	taxes ifNil: [taxes := IdentitySet new].
	^taxes.! !
!GlorpTax categoriesFor: #addTax:!add/remove!private! !
!GlorpTax categoriesFor: #id!accessing!private! !
!GlorpTax categoriesFor: #id:!private! !
!GlorpTax categoriesFor: #name!accessing!private! !
!GlorpTax categoriesFor: #name:!accessing!private! !
!GlorpTax categoriesFor: #supertax!accessing!private! !
!GlorpTax categoriesFor: #supertax:!private! !
!GlorpTax categoriesFor: #taxes!accessing!private! !

!GlorpTax class methodsFor!

glorpCommonSetupDescriptor: aDescriptor forSystem: aSystem
	| table |
	table := aSystem tableNamed: 'TAX'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	aDescriptor addMapping:
			((OneToManyMapping new)
				attributeName: #taxes;
				referenceClass: GlorpTax;
				join: (Join from: (table fieldNamed: 'ID') to: (table fieldNamed: 'TAX_ID'))).
	aDescriptor addMapping:
			((OneToOneMapping new)
				attributeName: #supertax;
				referenceClass: GlorpTax;
				join: (Join from: (table fieldNamed: 'TAX_ID') to: (table fieldNamed: 'ID'))).!

glorpSetupDescriptor: aDescriptor forSystem: aSystem
	| table |
	table := aSystem tableNamed: 'TAX'.
	aDescriptor table: table.

	"(aSystem typeResolverFor: GlorpTax)
		register: aDescriptor
		keyedBy: 'XXX'
		field: (table fieldNamed: 'TYPE')."

	(aSystem typeResolverFor: GlorpTax)
		register: aDescriptor
		abstract: true!

glorpTypeResolver
	^FilteredTypeResolver forRootClass: GlorpTax.! !
!GlorpTax class categoriesFor: #glorpCommonSetupDescriptor:forSystem:!glorp!private! !
!GlorpTax class categoriesFor: #glorpSetupDescriptor:forSystem:!glorp!private! !
!GlorpTax class categoriesFor: #glorpTypeResolver!glorp!private! !

GlorpTestClassInNamespace guid: (GUID fromString: '{ACC729BF-DB49-463F-85D2-02F3487A11BE}')!
GlorpTestClassInNamespace comment: ''!
!GlorpTestClassInNamespace categoriesForClass!Unclassified! !
GlorpTestModelClass guid: (GUID fromString: '{05E031FA-E387-4BDA-8971-12A5A62F0EFE}')!
GlorpTestModelClass comment: 'An abstract superclass providing convenience methods for domain objects to facilitate testing.'!
!GlorpTestModelClass categoriesForClass!Unclassified! !
!GlorpTestModelClass methodsFor!

assert: aBoolean
	aBoolean ifFalse: [TestResult failure sunitSignalWith: 'Assertion failed']! !
!GlorpTestModelClass categoriesFor: #assert:!As yet unclassified!private! !

GlorpTestModelsPackage guid: (GUID fromString: '{B8CD72B0-F9B3-46F5-9958-F7AC3BA5A23C}')!
GlorpTestModelsPackage comment: 'This class represents package information for the GlorpTestModels package, for systems that don''t have things like package properties to store things like copyright and license information.

LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you''ll need to release the
source of any modifications.

If you require any further clarification, we''d be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'!
!GlorpTestModelsPackage categoriesForClass!Unclassified! !
!GlorpTestModelsPackage class methodsFor!

LICENSE
"LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you'll need to release the
source of any modifications.

If you require any further clarification, we'd be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"! !
!GlorpTestModelsPackage class categoriesFor: #LICENSE!instance creation!public! !

GlorpTransformedTime guid: (GUID fromString: '{9E42EBA3-F8D7-4800-B1BD-28C4D31B2680}')!
GlorpTransformedTime comment: 'This class just holds a time, but that time is transformed into a representation in seconds in the database.

Instance Variables:
	id	<Integer>	The primary key
	time	<Time>	The time

'!
!GlorpTransformedTime categoriesForClass!Unclassified! !
!GlorpTransformedTime methodsFor!

id
	^id!

id: anObject
	id := anObject!

initialize
	time := Time now.!

time
	^time!

time: anObject
	time := anObject! !
!GlorpTransformedTime categoriesFor: #id!accessing!private! !
!GlorpTransformedTime categoriesFor: #id:!accessing!private! !
!GlorpTransformedTime categoriesFor: #initialize!initialize!private! !
!GlorpTransformedTime categoriesFor: #time!accessing!private! !
!GlorpTransformedTime categoriesFor: #time:!accessing!private! !

!GlorpTransformedTime class methodsFor!

new
	^super new initialize.! !
!GlorpTransformedTime class categoriesFor: #new!instance creation!private! !

GlorpTravelAgency guid: (GUID fromString: '{9423DC26-B0B9-4B48-A966-5FE4B1666A6C}')!
GlorpTravelAgency comment: 'This represents a travel agency. The interesting persistence feature of these is that they are embedded in the agent table, but also treated as unique objects with their own relationships.

Instance Variables:
	agents	<Collection of: GlorpTravelAgent>	description of agents
	name	<String>	description of name

'!
!GlorpTravelAgency categoriesForClass!Unclassified! !
!GlorpTravelAgency methodsFor!

= aGlorpTravelAgency
	^self name = aGlorpTravelAgency name.!

agents
	^agents!

agents: anObject
	agents := anObject!

name
	^name!

name: anObject
	name := anObject! !
!GlorpTravelAgency categoriesFor: #=!comparing!private! !
!GlorpTravelAgency categoriesFor: #agents!accessing!private! !
!GlorpTravelAgency categoriesFor: #agents:!accessing!private! !
!GlorpTravelAgency categoriesFor: #name!accessing!private! !
!GlorpTravelAgency categoriesFor: #name:!accessing!private! !

GlorpTravelAgent guid: (GUID fromString: '{0238320E-6329-45AC-A35C-531D10C86020}')!
GlorpTravelAgent comment: 'This represents a travel agent. Travel agents are very simple, but have their agency embedded in their table, even though we expect the agencies to be unique instances, and to have multiple agents.

Instance Variables:
	agency	<GlorpTravelAgency>	description of agency
	id	<Integer>	description of id
	name	<String>	description of name

'!
!GlorpTravelAgent categoriesForClass!Unclassified! !
!GlorpTravelAgent methodsFor!

agency
	^agency!

agency: anObject
	agency := anObject!

id
	^id!

id: anObject
	id := anObject!

name
	^name!

name: anObject
	name := anObject! !
!GlorpTravelAgent categoriesFor: #agency!accessing!private! !
!GlorpTravelAgent categoriesFor: #agency:!accessing!private! !
!GlorpTravelAgent categoriesFor: #id!accessing!private! !
!GlorpTravelAgent categoriesFor: #id:!accessing!private! !
!GlorpTravelAgent categoriesFor: #name!accessing!private! !
!GlorpTravelAgent categoriesFor: #name:!accessing!private! !

GlorpTreeNode guid: (GUID fromString: '{766306C1-AAF9-4C36-AE45-B07E399E8AB9}')!
GlorpTreeNode comment: ''!
!GlorpTreeNode categoriesForClass!Unclassified! !
!GlorpTreeNode methodsFor!

children
	^children.!

children: aCollection
	children := aCollection.!

id
	^id.!

id: anInteger
	id := anInteger.!

initialize
	children := OrderedCollection new.!

printOn: aStream
	aStream nextPutAll: 'Node('.
	id printOn: aStream.
	aStream nextPut: $).! !
!GlorpTreeNode categoriesFor: #children!As yet unclassified!private! !
!GlorpTreeNode categoriesFor: #children:!As yet unclassified!private! !
!GlorpTreeNode categoriesFor: #id!As yet unclassified!private! !
!GlorpTreeNode categoriesFor: #id:!As yet unclassified!private! !
!GlorpTreeNode categoriesFor: #initialize!As yet unclassified!private! !
!GlorpTreeNode categoriesFor: #printOn:!printing!private! !

!GlorpTreeNode class methodsFor!

new
	^super new initialize.! !
!GlorpTreeNode class categoriesFor: #new!instance creation!private! !

GlorpUser guid: (GUID fromString: '{4E24581E-B5C2-4108-B37C-733F8CE8FE37}')!
GlorpUser comment: ''!
!GlorpUser categoriesForClass!Unclassified! !
!GlorpUser methodsFor!

folders
	^folders!

folders: aCollection
	folders := aCollection!

id
	^id!

id: anInteger
	id := anInteger!

initialize

	id := nil.
	folders := OrderedCollection new.!

name
	^name.!

name: aString
	name := aString.! !
!GlorpUser categoriesFor: #folders!accessing!private! !
!GlorpUser categoriesFor: #folders:!accessing!private! !
!GlorpUser categoriesFor: #id!accessing!private! !
!GlorpUser categoriesFor: #id:!accessing!private! !
!GlorpUser categoriesFor: #initialize!initialize-release!private! !
!GlorpUser categoriesFor: #name!accessing!private! !
!GlorpUser categoriesFor: #name:!accessing!private! !

!GlorpUser class methodsFor!

new
	"Answer a newly created and initialized instance."

	^super new initialize! !
!GlorpUser class categoriesFor: #new!instance creation!private! !

GlorpWarehouse guid: (GUID fromString: '{7644E1C5-F921-4329-A1E4-8A2B46A1FEFE}')!
GlorpWarehouse comment: ''!
!GlorpWarehouse categoriesForClass!Unclassified! !
!GlorpWarehouse methodsFor!

address
	^address!

address: anObject
	address := anObject!

currentItem
	^currentItem!

currentItem: anInventoryItem
	currentItem := anInventoryItem!

id
	^id!

id: anObject
	id := anObject!

items
	^items!

items: aCollection
	items := aCollection! !
!GlorpWarehouse categoriesFor: #address!accessing!private! !
!GlorpWarehouse categoriesFor: #address:!accessing!private! !
!GlorpWarehouse categoriesFor: #currentItem!accessing!private! !
!GlorpWarehouse categoriesFor: #currentItem:!accessing!private! !
!GlorpWarehouse categoriesFor: #id!accessing!private! !
!GlorpWarehouse categoriesFor: #id:!accessing!private! !
!GlorpWarehouse categoriesFor: #items!accessing!private! !
!GlorpWarehouse categoriesFor: #items:!accessing!private! !

GlorpWorker guid: (GUID fromString: '{98F5D74C-51C2-4EFB-825B-EB10B8333838}')!
GlorpWorker comment: ''!
!GlorpWorker categoriesForClass!Unclassified! !
!GlorpWorker methodsFor!

finishedJobs
	^finishedJobs!

finishedJobs: anObject
	finishedJobs := anObject!

id
	^id!

id: anObject
	id := anObject!

initialize

	pendingJobs := OrderedCollection new.
	finishedJobs := OrderedCollection new.
	priorityJobs := OrderedCollection new.!

name
	^name!

name: anObject
	name := anObject!

pendingJobs
	^pendingJobs!

pendingJobs: anObject
	pendingJobs := anObject!

priorityJobs
	^priorityJobs!

priorityJobs: anObject
	priorityJobs := anObject! !
!GlorpWorker categoriesFor: #finishedJobs!accessing!private! !
!GlorpWorker categoriesFor: #finishedJobs:!accessing!private! !
!GlorpWorker categoriesFor: #id!accessing!private! !
!GlorpWorker categoriesFor: #id:!accessing!private! !
!GlorpWorker categoriesFor: #initialize!initialize/release!private! !
!GlorpWorker categoriesFor: #name!accessing!private! !
!GlorpWorker categoriesFor: #name:!accessing!private! !
!GlorpWorker categoriesFor: #pendingJobs!accessing!private! !
!GlorpWorker categoriesFor: #pendingJobs:!accessing!private! !
!GlorpWorker categoriesFor: #priorityJobs!accessing!private! !
!GlorpWorker categoriesFor: #priorityJobs:!accessing!private! !

!GlorpWorker class methodsFor!

new

	^super new initialize.! !
!GlorpWorker class categoriesFor: #new!instance creation!private! !

GlorpWorkingStiff guid: (GUID fromString: '{50BAD323-0AC0-432A-8702-733CDCB0CF8D}')!
GlorpWorkingStiff comment: ''!
!GlorpWorkingStiff categoriesForClass!Unclassified! !
!GlorpWorkingStiff methodsFor!

= aWorkingStiff
	^self class = aWorkingStiff class and: [id = aWorkingStiff id and: [name = aWorkingStiff name]].!

id
	^id!

id: anObject
	id := anObject!

name
	^name!

name: anObject
	name := anObject! !
!GlorpWorkingStiff categoriesFor: #=!comparing!private! !
!GlorpWorkingStiff categoriesFor: #id!accessing!private! !
!GlorpWorkingStiff categoriesFor: #id:!accessing!private! !
!GlorpWorkingStiff categoriesFor: #name!accessing!private! !
!GlorpWorkingStiff categoriesFor: #name:!accessing!private! !

GlorpTestDescriptorSystem guid: (GUID fromString: '{8C8DA5FA-A9CD-466E-A99D-75723ED0C99B}')!
GlorpTestDescriptorSystem comment: 'This is an abstract superclass for all descriptor systems whose tables should be set up as part of the standard GLORP testing process. See GlorpDemoTablePopulatorResource.'!
!GlorpTestDescriptorSystem categoriesForClass!Unclassified! !
GlorpCompositeKeyDescriptorSystem guid: (GUID fromString: '{1ECBC6A0-6860-4708-A65B-221182371F1A}')!
GlorpCompositeKeyDescriptorSystem comment: 'This is a system designed to test the use of composite keys. Its model is an email message system, where we have users, folders, keyed by name and owning user, and messages, keyed by a message id, folder name, and owning user.'!
!GlorpCompositeKeyDescriptorSystem categoriesForClass!Unclassified! !
!GlorpCompositeKeyDescriptorSystem methodsFor!

allTableNames
	^#('GR_USER' 'GR_FOLDER' 'GR_MESSAGE').!

constructAllClasses
	^(super constructAllClasses)
		add: GlorpUser;
		add: GlorpFolder;
		add: GlorpMessage;
		yourself!

descriptorForGlorpFolder: aDescriptor

	| table userMapping messageMapping |
	table := self tableNamed: 'GR_FOLDER'.
	aDescriptor table: table.

	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).

	userMapping := OneToOneMapping new
		attributeName: #user;
		referenceClass: GlorpUser.
"		join: (Join from: (table fieldNamed: 'USER_ID') to: (userTable fieldNamed: 'ID'))."
	aDescriptor addMapping: userMapping.
	messageMapping := OneToManyMapping new
		attributeName: #messages;
		referenceClass: GlorpMessage.
"		join: (Join 
			from: (table fieldNamed: 'USER_ID')
			to: (messageTable fieldNamed: 'USER_ID') 	
			from: (table fieldNamed: 'NAME')
			to: (messageTable fieldNamed: 'FOLDER_NAME'))."
	messageMapping beExclusive.
	aDescriptor addMapping: messageMapping.!

descriptorForGlorpMessage: aDescriptor

	| table userMapping folderMapping |
	table := self tableNamed: 'GR_MESSAGE'.
	aDescriptor table: table.
	self tableNamed: 'GR_USER'.
	self tableNamed: 'GR_FOLDER'.

	aDescriptor addMapping: (DirectMapping from: #subject to: (table fieldNamed: 'SUBJECT')).
	aDescriptor addMapping: (DirectMapping from: #contents to: (table fieldNamed: 'CONTENTS')).

	userMapping := OneToOneMapping new
		attributeName: #user;
		referenceClass: GlorpUser.
"		mappingCriteria: (Join from: (table fieldNamed: 'USER_ID') to: (userTable fieldNamed: 'ID'))."
	aDescriptor addMapping: userMapping.
	folderMapping := OneToOneMapping new
		attributeName: #folder;
		referenceClass: GlorpFolder.
	"Let it figure this out for itself"
"		mappingCriteria: (Join 
			from: (table fieldNamed: 'USER_ID')
			to: (userTable fieldNamed: 'ID') 	
			from: (table fieldNamed: 'NAME')
			to: (folderTable fieldNamed: 'FOLDER_NAME'))."
	aDescriptor addMapping: folderMapping.!

descriptorForGlorpUser: aDescriptor

	| table folderMapping |
	table := self tableNamed: 'GR_USER'.
	aDescriptor table: table.

	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).

	folderMapping := OneToManyMapping new
		attributeName: #folders;
		referenceClass: GlorpFolder.
"		mappingCriteria: 
						(Join
								from: (table fieldNamed: 'ID')
								to: (folderTable fieldNamed: 'USER_ID'))."
	folderMapping beExclusive.
	aDescriptor addMapping: folderMapping.!

example1
	| user1 user2 folder1 folder1a folder2 message1 message2 message3 |
	user1 := GlorpUser new id: 1; name: 'User One'.
	user2 := GlorpUser new id: 2; name: 'User Two'.
	folder1 := GlorpFolder new name: 'One'; user: user1.
	user1 folders add: folder1.
	folder1a := GlorpFolder new name: 'One-A'; user: user1.
	user1 folders add: folder1a.
	folder2 := GlorpFolder new name: 'Two'; user: user2.
	user2 folders add: folder2.
	
	message1 := GlorpMessage new subject: 'goes in folder 1'; user: user1; folder: folder1.
	folder1 messages add: message1.
	message2 := GlorpMessage new subject: 'also goes in folder 1'; user: user1; folder: folder1.
	folder1 messages add: message2.
	message3 := GlorpMessage new subject: 'goes in folder 2'; user: user2; folder: folder2.
	folder2 messages add: message3.
	^Array with: user1 with: user2.!

tableForGR_FOLDER: aTable 
	| userId |
	userId := aTable createFieldNamed: 'USER_ID' type: platform integer.
	userId bePrimaryKey.
	aTable addForeignKeyFrom: userId
		to: ((self tableNamed: 'GR_USER') fieldNamed: 'ID').
	(aTable createFieldNamed: 'NAME' type: (platform varChar: 50)) bePrimaryKey.!

tableForGR_MESSAGE: aTable 
	| userId folderName |
	userId := aTable createFieldNamed: 'USER_ID' type: platform integer.
	userId bePrimaryKey.
	folderName := aTable createFieldNamed: 'FOLDER_NAME' type: (platform varChar: 50).
	folderName bePrimaryKey.
	aTable addForeignKeyFrom: userId
		to: ((self tableNamed: 'GR_USER') fieldNamed: 'ID').

	aTable addForeignKeyFrom: userId
		to: ((self tableNamed: 'GR_FOLDER') fieldNamed: 'USER_ID')
		from: folderName
		to: ((self tableNamed: 'GR_FOLDER') fieldNamed: 'NAME').


	(aTable createFieldNamed: 'SUBJECT' type: (platform varChar: 50)) bePrimaryKey.
	aTable createFieldNamed: 'CONTENTS' type: (platform varChar: 100).!

tableForGR_USER: aTable 
	| |
	(aTable createFieldNamed: 'ID' type: platform integer)
		bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 50).! !
!GlorpCompositeKeyDescriptorSystem categoriesFor: #allTableNames!accessing!private! !
!GlorpCompositeKeyDescriptorSystem categoriesFor: #constructAllClasses!accessing!private! !
!GlorpCompositeKeyDescriptorSystem categoriesFor: #descriptorForGlorpFolder:!descriptors!private! !
!GlorpCompositeKeyDescriptorSystem categoriesFor: #descriptorForGlorpMessage:!descriptors!private! !
!GlorpCompositeKeyDescriptorSystem categoriesFor: #descriptorForGlorpUser:!descriptors!private! !
!GlorpCompositeKeyDescriptorSystem categoriesFor: #example1!examples!private! !
!GlorpCompositeKeyDescriptorSystem categoriesFor: #tableForGR_FOLDER:!private!tables! !
!GlorpCompositeKeyDescriptorSystem categoriesFor: #tableForGR_MESSAGE:!private!tables! !
!GlorpCompositeKeyDescriptorSystem categoriesFor: #tableForGR_USER:!private!tables! !

GlorpDemoDescriptorSystem guid: (GUID fromString: '{97816F86-0D90-4838-8606-401815A14BFA}')!
GlorpDemoDescriptorSystem comment: ''!
!GlorpDemoDescriptorSystem categoriesForClass!Unclassified! !
!GlorpDemoDescriptorSystem methodsFor!

allTableNames
	^#('GR_ADDRESS' 'PERSON' 'GR_CUSTOMER' 'BANK_TRANS' 'BANK_ACCT' 'CUSTOMER_ACCT_LINK' 'EMAIL_ADDRESS' 'STUFF' 'PASSENGER' 'AIRLINE' 'FREQUENT_FLYER' 'COMPRESSED_MONEY_TABLE' 'RESERVATION' 'ITINERARY' 'TRANSFORMED_TIME' 'FKCONTACT' 'FKADDRESS' 'GLORP_OWNER' 'GLORP_SLAVE' 'TREE_NODE' 'TREE_NODE_LINK' 'RECORD_WITH_UPDATE' 'GR_TRAVEL_AGENT').!

classModelForDefaultableThing: aClassModel

	aClassModel newAttributeNamed: #id type: Integer.
	aClassModel newAttributeNamed: #boolean type: Boolean.
	aClassModel newAttributeNamed: #integer type: Integer.!

classModelForGlorpAirline: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name.!

classModelForGlorpBankAccount: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #accountNumber type: GlorpBankAccountNumber.
	aClassModel newAttributeNamed: #accountHolders collectionOf: GlorpCustomer.!

classModelForGlorpBankAccountNumber: aClassModel

	aClassModel newAttributeNamed: #bankCode.
	aClassModel newAttributeNamed: #branchNumber.
	aClassModel newAttributeNamed: #accountNumber.!

classModelForGlorpBankBranch: aClassModel
	aClassModel newAttributeNamed: #branchNumber.
	aClassModel newAttributeNamed: #accounts collectionOf: GlorpBankAccount.!

classModelForGlorpBankTransaction: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #owner type: GlorpCustomer.
	aClassModel newAttributeNamed: #amount type: GlorpMoney.
	aClassModel newAttributeNamed: #serviceCharge type: GlorpServiceCharge.!

classModelForGlorpCustomer: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name.
	aClassModel newAttributeNamed: #transactions collectionOf: GlorpBankTransaction.
	aClassModel newAttributeNamed: #accounts collectionOf: GlorpBankAccount.
	aClassModel newAttributeNamed: #accountsSortedById collectionOf: GlorpBankAccount.
	aClassModel newAttributeNamed: #accountsSortedByIdDescending collectionOf: GlorpBankAccount.!

classModelForGlorpEmailAddress: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #user.
	aClassModel newAttributeNamed: #host.!

classModelForGlorpItinerary: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #reservation type: GlorpReservation.!

classModelForGlorpMoney: aClassModel

	aClassModel newAttributeNamed: #currency.
	aClassModel newAttributeNamed: #amount.!

classModelForGlorpPassenger: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name.
	aClassModel newAttributeNamed: #frequentFlyerMiles.
	aClassModel newAttributeNamed: #airline type: GlorpAirline.!

classModelForGlorpPerson: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name.
	aClassModel newAttributeNamed: #address type: GlorpAddress.
	aClassModel newAttributeNamed: #emailAddresses collectionOf: GlorpEmailAddress.!

classModelForGlorpRecordWithUpdateTime: aClassModel

	aClassModel newAttributeNamed: #id type: Integer.
	aClassModel newAttributeNamed: #name type: String.
	aClassModel newAttributeNamed: #updateTime type: TimeStamp.
	aClassModel newAttributeNamed: #updateSomeOtherThing type: String.!

classModelForGlorpReservation: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #passengers collectionOf: GlorpPassenger.
	aClassModel newAttributeNamed: #passenger type: GlorpPassenger.!

classModelForGlorpServiceCharge: aClassModel

	aClassModel newAttributeNamed: #description.
	aClassModel newAttributeNamed: #amount type: GlorpMoney.!

classModelForGlorpTravelAgency: aClassModel
	aClassModel newAttributeNamed: #name.
	aClassModel newAttributeNamed: #agents collectionOf: GlorpTravelAgent.!

classModelForGlorpTravelAgent: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name.
	aClassModel newAttributeNamed: #agency type: GlorpTravelAgency.!

classModelForGlorpTreeNode: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #children collectionOf: GlorpTreeNode.!

constructAllClasses
	"This includes a list of classes as an example, but we don't actually use most of them, because the superclass method will figure it out if the descriptor methods are written in this class."
	^(super constructAllClasses) 
		add: GlorpAddress;
		yourself.
"	^(super constructAllClasses)
		add: GlorpPerson;
		add: GlorpAddress;
		add: GlorpCustomer;
		add: GlorpBankTransaction;
		add: GlorpBankAccount;
		add: GlorpMoney;
		add: GlorpCompressedMoney;
		add: GlorpServiceCharge;
		add: GlorpBankAccountNumber;
		add: GlorpEmailAddress;
		add: GlorpPassenger;
		add: GlorpAirline;
		add: GlorpReservation;
		add: GlorpItinerary;
		add: GlorpTransformedTime;
		add: GlorpBankBranch;
		add: GlorpOwner;
		add: GlorpSlave;
		add: GlorpTreeNode;
		add: GlorpRecordWithUpdateTime;
		add: GlorpTravelAgent;
		add: GlorpTravelAgency;
		yourself."!

descriptorForDefaultableThing: aDescriptor
	| table |
	table := self tableNamed: 'DEFAULTABLE_THING'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping)
		from: #id
		to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping)
		from: #boolean
		to: (table fieldNamed: 'MY_BOOL').
	(aDescriptor newMapping: DirectMapping)
		from: #integer
		to: (table fieldNamed: 'MY_INT').!

descriptorForGlorpAirline: aDescriptor 
	aDescriptor table: (self tableNamed: 'AIRLINE').
	aDescriptor directMappingFor: #id.
	aDescriptor directMappingFor: #name.!

descriptorForGlorpBankAccount: aDescriptor 

	| table |
	table := self tableNamed: 'BANK_ACCT'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id
				to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: ToManyMapping)
				attributeName: #accountHolders;
				useLinkTable.
	(aDescriptor newMapping: EmbeddedValueOneToOneMapping)
				attributeName: #accountNumber.!

descriptorForGlorpBankAccountNumber: aDescriptor

	| table |
	table := self tableNamed: 'BANK_ACCT'.
	aDescriptor table: table.
"	aDescriptor addMapping: ((DirectMapping from: #bankCode to: (table fieldNamed: 'BANK_CODE')) type: Integer)."
	(aDescriptor newMapping: DirectMapping) from: #bankCode to: (table fieldNamed: 'BANK_CODE').
	(aDescriptor newMapping: DirectMapping) from: #branchNumber to: (table fieldNamed: 'BRANCH_NO').
	(aDescriptor newMapping: DirectMapping) from: #accountNumber to: (table fieldNamed: 'ACCT_NO').!

descriptorForGlorpBankBranch: aDescriptor

	| table distinctBranchNumber mapping |
	table := self tableNamed: 'BANK_ACCT'.
	aDescriptor table: table.
	distinctBranchNumber := [:each | ((each getTable: table) getField: (table fieldNamed: 'BRANCH_NO')) distinct] asGlorpExpression.
	mapping := aDescriptor newMapping: DirectMapping.
	mapping from: #branchNumber to: distinctBranchNumber.
	mapping readOnly: true.

	aDescriptor keyFields: (Array with: distinctBranchNumber).

	(aDescriptor newMapping: ToManyMapping)
		attributeName: #accounts;
		readOnly: true;
		join: 
						(Join
								from: distinctBranchNumber
								to: (table fieldNamed: 'BRANCH_NO')).!

descriptorForGlorpBankTransaction: aDescriptor
	| table | 
	table := self tableNamed: 'BANK_TRANS'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id
				to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: OneToOneMapping)
				attributeName: #owner.
	(aDescriptor newMapping: EmbeddedValueOneToOneMapping)
				attributeName: #amount;
				fieldTranslation: ((Join new)
							addSource: (table fieldNamed: 'AMT_AMT')
								target: ((self tableNamed: 'MONEY_IMAGINARY_TABLE') fieldNamed: 'AMOUNT');
							addSource: (table fieldNamed: 'AMT_CURR')
								target: ((self tableNamed: 'MONEY_IMAGINARY_TABLE') fieldNamed: 'CURRENCY');
							yourself).
	(aDescriptor newMapping: EmbeddedValueOneToOneMapping)
				attributeName: #serviceCharge.!

descriptorForGlorpCompressedMoney: aDescriptor 
	| table currencyField amountField |
	table := self tableNamed: 'COMPRESSED_MONEY_TABLE'.
	aDescriptor 
		addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	currencyField := table fieldNamed: 'CURRENCY_NAME'.
	amountField := table fieldNamed: 'AMOUNT'.
	aDescriptor table: table.
	aDescriptor addMapping: (AdHocMapping 
				forAttribute: #array
				fromDb: 
					[:row :elementBuilder :context| 
					Array with: (elementBuilder valueOfField: (context translateField: currencyField) in: row)
						with: (elementBuilder valueOfField: (context translateField: amountField) in: row)]
				toDb: 
					[:rows :attribute :attributeRows | 
					(rows at: table) at: currencyField put: (attribute at: 1).
					(rows at: table) at: amountField put: (attribute at: 2)]
				mappingFields: (Array with: currencyField with: amountField)).
	"Note that position won't work if we have a join. We need to take the elementbuilder into account"
	^aDescriptor!

descriptorForGlorpCustomer: aDescriptor

	| table |
	table := self tableNamed: 'GR_CUSTOMER'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #name to: (table fieldNamed: 'NAME'); shouldProxy: true.
	(aDescriptor newMapping: ToManyMapping)
			attributeName: #transactions.
	(aDescriptor newMapping: ToManyMapping)
			attributeName: #accounts;
			useLinkTable.

	"Two additional relationships, there to test ordering within a mapping, where the order is determined by a field in the link table"
	(aDescriptor newMapping: ToManyMapping)
			attributeName: #accountsSortedById;
			readOnly: true;
			useLinkTable;
			orderBy: [:each | (each getTable: 'CUSTOMER_ACCT_LINK') getField: 'ACCT_ID'].
	(aDescriptor newMapping: ManyToManyMapping)
			attributeName: #accountsSortedByIdDescending;
			readOnly: true;
			useLinkTable;
			orderBy: [:each | ((each getTable: 'CUSTOMER_ACCT_LINK') getField: 'ACCT_ID') descending].!

descriptorForGlorpEmailAddress: aDescriptor

	| table |
	table := self tableNamed: 'EMAIL_ADDRESS'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #user to: (table fieldNamed: 'USER_NAME').
	(aDescriptor newMapping: DirectMapping) from: #host to: (table fieldNamed: 'HOST_NAME').!

descriptorForGlorpItinerary: aDescriptor 
	aDescriptor table: (self tableNamed: 'ITINERARY').
	aDescriptor directMappingFor: #id.
	(aDescriptor newMapping: OneToOneMapping)
			attributeName: #reservation.!

descriptorForGlorpMoney: aDescriptor

	| table |
	table := self tableNamed: 'MONEY_IMAGINARY_TABLE'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #currency type: Symbol to: (table fieldNamed: 'CURRENCY').
	(aDescriptor newMapping: DirectMapping) from: #amount to: (table fieldNamed: 'AMOUNT').
	^aDescriptor.!

descriptorForGlorpOwner: aDescriptor
	| table slaveTable |
	table := self tableNamed: 'GLORP_OWNER'.
	slaveTable := self tableNamed: 'GLORP_SLAVE'.
	aDescriptor table: table.
	aDescriptor
		addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID'));
		addMapping:
				((OneToManyMapping new)
						attributeName: #slaves;
						referenceClass: GlorpSlave;
						collectionType: OrderedCollection;
						orderBy:
								[:each | (each getTable: 'GLORP_SLAVE') getField: 'POSITION_IN_OWNER'];
						writeTheOrderField;
						mappingCriteria:
								(Join
										from: (table fieldNamed: 'ID')
										to: (slaveTable fieldNamed: 'OWNER_ID')));
		addMapping:
				((OneToOneMapping new)
						attributeName: #slave;
						referenceClass: GlorpSlave;
						mappingCriteria:
								(Join
										from: (table fieldNamed: 'SLAVE_ID')
										to: (slaveTable fieldNamed: 'ID'))).!

descriptorForGlorpPassenger: aDescriptor 
	| passTable ffTable ffMiles airlineMapping |
	passTable := self tableNamed: 'PASSENGER'.
	ffTable := self tableNamed: 'FREQUENT_FLYER'.
	aDescriptor table: passTable.
	aDescriptor addTable: ffTable.
	aDescriptor addMultipleTableJoin: (	
		Join 
			from: (passTable fieldNamed: 'ID')
			to: (ffTable fieldNamed: 'ID')) beOuterJoin.
	(aDescriptor newMapping: DirectMapping) from: #id to: (passTable fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #name to: (passTable fieldNamed: 'NAME').

	ffMiles := aDescriptor newMapping: ConditionalMapping.
	ffMiles 
		forField: (ffTable fieldNamed: 'POINTS')
		attribute: [:object | object frequentFlyerPoints]
		if: [:x | x notNil]
		useMapping: ((ffMiles newMapping: DirectMapping) from: #frequentFlyerMiles to: (ffTable fieldNamed: 'POINTS')).
	ffMiles otherwise: (ffMiles newMapping: ConstantMapping).
	
	airlineMapping := aDescriptor newMapping: ConditionalMapping.
	airlineMapping
		forField: (ffTable fieldNamed: 'AIRLINE_ID')
		attribute: [:object | object airline]
		if: [:x | x notNil]
		useMapping: ((airlineMapping newMapping: OneToOneMapping) attributeName: #airline).
	airlineMapping otherwise: (airlineMapping newMapping: ConstantMapping).!

descriptorForGlorpPerson: aDescriptor

	| table |
	table := self tableNamed: 'PERSON'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #name to: (table fieldNamed: 'NAME').
	(aDescriptor newMapping: DirectMapping) fromPseudoVariable: #addressId to: (table fieldNamed: 'ADDRESS_ID').
	(aDescriptor newMapping: OneToOneMapping)
			attributeName: #address.
	(aDescriptor newMapping: ToManyMapping)
			attributeName: #emailAddresses;
			orderBy: #id.!

descriptorForGlorpRecordWithUpdateTime: aDescriptor
	| table |
	table := self tableNamed: 'RECORD_WITH_UPDATE'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping)
		from: #id
		to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping)
		from: #name
		to: (table fieldNamed: 'NAME').
	(aDescriptor newMapping: DirectMapping)
		from: #updateTime
		to: (table fieldNamed: 'UPDATE_TIME').
	(aDescriptor newMapping: DirectMapping)
		from: #updateSomeOtherThing
		to: (table fieldNamed: 'UPDATE_OTHER_THING').!

descriptorForGlorpReservation: aDescriptor 
	| table |
	table := self tableNamed: 'RESERVATION'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	"The res->passenger relationship is actually 1-1, but map it as both 1-1 and 1-many so that we can more easily verify that only one object comes back, i.e. that joins are being done correctly"
	(aDescriptor newMapping: OneToManyMapping)
			attributeName: #passengers.
	(aDescriptor newMapping: OneToOneMapping)
			attributeName: #passenger.!

descriptorForGlorpServiceCharge: aDescriptor 
	
	| table |
	table := self tableNamed: 'BANK_TRANS'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #description
				to: (table fieldNamed: 'SRVC_DESC').
	(aDescriptor newMapping: EmbeddedValueOneToOneMapping)
				attributeName: #amount;
				fieldTranslation: ((Join new)
							addSource: (table fieldNamed: 'SRVC_AMT_AMT')
								target: ((self tableNamed: 'MONEY_IMAGINARY_TABLE') fieldNamed: 'AMOUNT');
							addSource: (table fieldNamed: 'SRVC_AMT_CURR')
								target: ((self tableNamed: 'MONEY_IMAGINARY_TABLE') fieldNamed: 'CURRENCY');
							yourself).!

descriptorForGlorpSlave: aDescriptor
	| table |
	table := self tableNamed: 'GLORP_SLAVE'.
	aDescriptor table: table.
	aDescriptor
		addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).!

descriptorForGlorpTransformedTime: aDescriptor 
	| table timeField |
	table := self tableNamed: 'TRANSFORMED_TIME'.
	aDescriptor 
		addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	timeField := table fieldNamed: 'TIMEFIELD'.
	aDescriptor table: table.
	aDescriptor addMapping: (AdHocMapping 
				forAttribute: #time
				fromDb: 
					[:row :elementBuilder :context| 
					Time fromSeconds: (elementBuilder valueOfField: (context translateField: timeField) in: row) ]
				toDb: 
					[:rows :attribute :attributeRows | 
					(rows at: table) at: timeField put: attribute asSeconds]
				mappingFields: (Array with: timeField)).
	"Note that position won't work if we have a join. We need to take the elementbuilder into account"
	^aDescriptor!

descriptorForGlorpTravelAgency: aDescriptor
	| table |
	table := self tableNamed: 'GR_TRAVEL_AGENT'.
	aDescriptor table: table.
	aDescriptor directMapping from: #name to: (table fieldNamed: 'AGENCY_NAME').
	aDescriptor toManyMapping
			attributeName: #agents;
			join: (Join from: (table fieldNamed: 'AGENCY_NAME') to: (table fieldNamed: 'AGENCY_NAME')).!

descriptorForGlorpTravelAgent: aDescriptor
	| table |
	table := self tableNamed: 'GR_TRAVEL_AGENT'.
	aDescriptor table: table.
	aDescriptor directMapping from: #id to: (table fieldNamed: 'ID').
	aDescriptor directMapping from: #name to: (table fieldNamed: 'AGENT_NAME').
	(aDescriptor newMapping: EmbeddedValueOneToOneMapping)
			attributeName: #agency.!

descriptorForGlorpTreeNode: aDescriptor
	| table |
	table := self tableNamed: 'TREE_NODE'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping)
		from: #id
		to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: ToManyMapping)
		attributeName: #children;
		useLinkTable;
		join:
				(Join
						from: (table fieldNamed: 'ID')
						to: ((self tableNamed: 'TREE_NODE_LINK') fieldNamed: 'PARENT')).!

exampleAccountRow1

	| accountTable row |
	accountTable := self tableNamed: 'BANK_ACCT'.
	row := DatabaseRow newForTable: accountTable.
	row at: (accountTable fieldNamed: 'ID') put: 9874.
	row at: (accountTable fieldNamed: 'BANK_CODE') put: '1'.
	row at: (accountTable fieldNamed: 'BRANCH_NO') put: 2.
	row at: (accountTable fieldNamed: 'ACCT_NO') put: '3'.
	^row.!

exampleAccountRow2

	| accountTable row |
	accountTable := self tableNamed: 'BANK_ACCT'.
	row := DatabaseRow newForTable: accountTable.
	row at: (accountTable fieldNamed: 'ID') put: 6.
	row at: (accountTable fieldNamed: 'BANK_CODE') put: '2'.
	row at: (accountTable fieldNamed: 'BRANCH_NO') put: 3.
	row at: (accountTable fieldNamed: 'ACCT_NO') put: '4'.
	^row.!

exampleAccountRow3

	| accountTable row |
	accountTable := self tableNamed: 'BANK_ACCT'.
	row := DatabaseRow newForTable: accountTable.
	row at: (accountTable fieldNamed: 'ID') put: 22.
	row at: (accountTable fieldNamed: 'BANK_CODE') put: '2'.
	row at: (accountTable fieldNamed: 'BRANCH_NO') put: 712.
	row at: (accountTable fieldNamed: 'ACCT_NO') put: '5551212'.
	^row.!

exampleAddressRow
	| addressTable row |
	addressTable := self  tableNamed: 'GR_ADDRESS'.
	row := DatabaseRow newForTable: addressTable.
	row at: (addressTable fieldNamed: 'ID') put: 123.
	row at: (addressTable fieldNamed: 'STREET') put: 'Paseo Montril'.
	row at: (addressTable fieldNamed: 'HOUSE_NUM') put: '10185'.
	^row!

exampleAddressRowForOrdering1
	| addressTable row |
	addressTable := self  tableNamed: 'GR_ADDRESS'.
	row := DatabaseRow newForTable: addressTable.
	row at: (addressTable fieldNamed: 'ID') put: 1.
	row at: (addressTable fieldNamed: 'STREET') put: 'Alpha'.
	row at: (addressTable fieldNamed: 'HOUSE_NUM') put: '300'.
	^row!

exampleAddressRowForOrdering2
	| addressTable row |
	addressTable := self  tableNamed: 'GR_ADDRESS'.
	row := DatabaseRow newForTable: addressTable.
	row at: (addressTable fieldNamed: 'ID') put: 2.
	row at: (addressTable fieldNamed: 'STREET') put: 'Beta'.
	row at: (addressTable fieldNamed: 'HOUSE_NUM') put: '200'.
	^row!

exampleAddressRowForOrdering3
	| addressTable row |
	addressTable := self  tableNamed: 'GR_ADDRESS'.
	row := DatabaseRow newForTable: addressTable.
	row at: (addressTable fieldNamed: 'ID') put: 3.
	row at: (addressTable fieldNamed: 'STREET') put: 'Gamma'.
	row at: (addressTable fieldNamed: 'HOUSE_NUM') put: '100'.
	^row!

exampleAddressRowForOrdering4
	| addressTable row |
	addressTable := self  tableNamed: 'GR_ADDRESS'.
	row := DatabaseRow newForTable: addressTable.
	row at: (addressTable fieldNamed: 'ID') put: 6.
	row at: (addressTable fieldNamed: 'STREET') put: 'Beta'.
	row at: (addressTable fieldNamed: 'HOUSE_NUM') put: '120'.
	^row!

exampleAddressRowForOrdering5
	| addressTable row |
	addressTable := self  tableNamed: 'GR_ADDRESS'.
	row := DatabaseRow newForTable: addressTable.
	row at: (addressTable fieldNamed: 'ID') put: 4.
	row at: (addressTable fieldNamed: 'STREET') put: 'Beta'.
	row at: (addressTable fieldNamed: 'HOUSE_NUM') put: '130'.
	^row!

exampleAddressRowWithDifferentStreet
	| addressTable row |
	addressTable := self  tableNamed: 'GR_ADDRESS'.
	row := DatabaseRow newForTable: addressTable.
	row at: (addressTable fieldNamed: 'ID') put: 123.
	row at: (addressTable fieldNamed: 'STREET') put: 'Garden of the Gods'.
	row at: (addressTable fieldNamed: 'HOUSE_NUM') put: '10185'.
	^row!

exampleBankTransactionRow
	| table row |
	table := self tableNamed: 'BANK_TRANS'.
	row := DatabaseRow newForTable: table.

	row atFieldNamed: 'ID' put: nil.
	row atFieldNamed: 'OWNER_ID' put: nil.
	row atFieldNamed: 'AMT_CURR' put: 'CDN'.
	row atFieldNamed: 'AMT_AMT' put: 7.
	row atFieldNamed: 'SRVC_DESC' put: 'additional overcharge'.
	row atFieldNamed: 'SRVC_AMT_CURR' put: 'USD'.
	row atFieldNamed: 'SRVC_AMT_AMT' put: 2.

	^row!

exampleBankTransactionRow2
	| table row |
	table := self tableNamed: 'BANK_TRANS'.
	row := DatabaseRow newForTable: table.

	row atFieldNamed: 'ID' put: nil.
	row atFieldNamed: 'OWNER_ID' put: nil.
	row atFieldNamed: 'AMT_CURR' put: 'EUR'.
	row atFieldNamed: 'AMT_AMT' put: 45.
	row atFieldNamed: 'SRVC_DESC' put: 'deposit'.
	row atFieldNamed: 'SRVC_AMT_CURR' put: 'EUR'.
	row atFieldNamed: 'SRVC_AMT_AMT' put: 1.

	^row!

exampleCALinkRow1

	| linkTable row |
	linkTable := self tableNamed: 'CUSTOMER_ACCT_LINK'.
	row := DatabaseRow newForTable: linkTable.
	row at: (linkTable fieldNamed: 'ACCT_ID') put: 9874.
	row at: (linkTable fieldNamed: 'CUSTOMER_ID') put: 27.
	^row.!

exampleCALinkRow2

	| linkTable row |
	linkTable := self tableNamed: 'CUSTOMER_ACCT_LINK'.
	row := DatabaseRow newForTable: linkTable.
	row at: (linkTable fieldNamed: 'ACCT_ID') put: 6.
	row at: (linkTable fieldNamed: 'CUSTOMER_ID') put: 27.
	^row.!

exampleCALinkRow3

	| linkTable row |
	linkTable := self tableNamed: 'CUSTOMER_ACCT_LINK'.
	row := DatabaseRow newForTable: linkTable.
	row at: (linkTable fieldNamed: 'ACCT_ID') put: 22.
	row at: (linkTable fieldNamed: 'CUSTOMER_ID') put: 28.
	^row.!

exampleCALinkRow4

	| linkTable row |
	linkTable := self tableNamed: 'CUSTOMER_ACCT_LINK'.
	row := DatabaseRow newForTable: linkTable.
	row at: (linkTable fieldNamed: 'ACCT_ID') put: 6.
	row at: (linkTable fieldNamed: 'CUSTOMER_ID') put: 28.
	^row.!

exampleCompressedMoneyRow
	| table row |
	table := self  tableNamed: 'COMPRESSED_MONEY_TABLE'.
	row := DatabaseRow newForTable: table.
	row at: (table fieldNamed: 'ID') put: 123.
	row at: (table fieldNamed: 'AMOUNT') put: 12.
	row at: (table fieldNamed: 'CURRENCY_NAME') put: 'CDN'.
	^row!

exampleCompressedMoneyRow2
	| table row |
	table := self  tableNamed: 'COMPRESSED_MONEY_TABLE'.
	row := DatabaseRow newForTable: table.
	row at: (table fieldNamed: 'ID') put: 124.
	row at: (table fieldNamed: 'AMOUNT') put: 15.
	row at: (table fieldNamed: 'CURRENCY_NAME') put: 'CDN'.
	^row!

exampleCustomerRow1

	| customerTable row |
	customerTable := self tableNamed: 'GR_CUSTOMER'.
	row := DatabaseRow newForTable: customerTable.
	row at: (customerTable fieldNamed: 'ID') put: 27.
	row at: (customerTable fieldNamed: 'NAME') put: 'aCustomer'.
	^row.!

exampleCustomerRow2

	| customerTable row |
	customerTable := self tableNamed: 'GR_CUSTOMER'.
	row := DatabaseRow newForTable: customerTable.
	row at: (customerTable fieldNamed: 'ID') put: 28.
	row at: (customerTable fieldNamed: 'NAME') put: 'anotherCustomer'.
	^row.!

exampleEmailAddressRow1

	| personTable row |
	personTable := self tableNamed: 'EMAIL_ADDRESS'.
	row := DatabaseRow newForTable: personTable.
	row at: (personTable fieldNamed: 'ID') put: 42.
	row at: (personTable fieldNamed: 'USER_NAME') put: 'alan'.
	row at: (personTable fieldNamed: 'HOST_NAME') put: 'objectpeople.com'.
	row at: (personTable fieldNamed: 'PERSON_ID') put: 3.

	^row.!

exampleEmailAddressRow2

	| personTable row |
	personTable := self tableNamed: 'EMAIL_ADDRESS'.
	row := DatabaseRow newForTable: personTable.
	row at: (personTable fieldNamed: 'ID') put: 54321.
	row at: (personTable fieldNamed: 'USER_NAME') put: 'johnson'.
	row at: (personTable fieldNamed: 'HOST_NAME') put: 'cs.uiuc.edu'.
	row at: (personTable fieldNamed: 'PERSON_ID') put: 3.
	^row.!

exampleFrequentFlyerRow
	| ffTable row |
	ffTable := self tableNamed: 'FREQUENT_FLYER'.
	row := DatabaseRow newForTable: ffTable.
	row at: (ffTable fieldNamed: 'ID') put: 1.
	row at: (ffTable fieldNamed: 'POINTS') put: 10000.
	row at: (ffTable fieldNamed: 'AIRLINE_ID') put: nil.
	^row.!

exampleFrequentFlyerRow2
	| ffTable row |
	ffTable := self tableNamed: 'FREQUENT_FLYER'.
	row := DatabaseRow newForTable: ffTable.
	row at: (ffTable fieldNamed: 'ID') put: 2.
	row at: (ffTable fieldNamed: 'POINTS') put: 7.
	row at: (ffTable fieldNamed: 'AIRLINE_ID') put: nil.
	^row.!

exampleModifiedAddressRow
	| addressTable row |
	addressTable := self  tableNamed: 'GR_ADDRESS'.
	row := DatabaseRow newForTable: addressTable.
	row at: (addressTable fieldNamed: 'ID') put: 123.
	row at: (addressTable fieldNamed: 'STREET') put: 'Something Else'.
	row at: (addressTable fieldNamed: 'HOUSE_NUM') put: '10185'.
	^row!

examplePassengerRow
	| passengerTable row |
	passengerTable := self tableNamed: 'PASSENGER'.
	row := DatabaseRow newForTable: passengerTable.
	row at: (passengerTable fieldNamed: 'ID') put: 1.
	row at: (passengerTable fieldNamed: 'NAME') put: 'Some Passenger'.
	^row.!

examplePassengerRow2
	| passengerTable row |
	passengerTable := self tableNamed: 'PASSENGER'.
	row := DatabaseRow newForTable: passengerTable.
	row at: (passengerTable fieldNamed: 'ID') put: 2.
	row at: (passengerTable fieldNamed: 'NAME') put: 'Another Passenger'.
	^row.!

examplePersonRow1

	| personTable row |
	personTable := self tableNamed: 'PERSON'.
	row := DatabaseRow newForTable: personTable.
	row at: (personTable fieldNamed: 'ID') put: 3.
	row at: (personTable fieldNamed: 'NAME') put: 'aPerson'.
	row at: (personTable fieldNamed: 'ADDRESS_ID') put: 123.
	^row.!

examplePersonRow2

	| personTable row |
	personTable := self tableNamed: 'PERSON'.
	row := DatabaseRow newForTable: personTable.
	row at: (personTable fieldNamed: 'ID') put: 4.
	row at: (personTable fieldNamed: 'NAME') put: 'aPerson'.
	row at: (personTable fieldNamed: 'ADDRESS_ID') put: nil.
	^row.!

examplePersonRowForOrdering1

	| personTable row |
	personTable := self tableNamed: 'PERSON'.
	row := DatabaseRow newForTable: personTable.
	row at: (personTable fieldNamed: 'ID') put: 86.
	row at: (personTable fieldNamed: 'NAME') put: 'person1'.
	row at: (personTable fieldNamed: 'ADDRESS_ID') put: 2.
	^row.!

examplePersonRowForOrdering2

	| personTable row |
	personTable := self tableNamed: 'PERSON'.
	row := DatabaseRow newForTable: personTable.
	row at: (personTable fieldNamed: 'ID') put: 87.
	row at: (personTable fieldNamed: 'NAME') put: 'person2'.
	row at: (personTable fieldNamed: 'ADDRESS_ID') put: 3.
	^row.!

examplePersonRowForOrdering3

	| personTable row |
	personTable := self tableNamed: 'PERSON'.
	row := DatabaseRow newForTable: personTable.
	row at: (personTable fieldNamed: 'ID') put: 88.
	row at: (personTable fieldNamed: 'NAME') put: 'person3'.
	row at: (personTable fieldNamed: 'ADDRESS_ID') put: 1.
	^row.!

tableForAIRLINE: aTable

	(aTable createFieldNamed: 'ID' type: platform inMemorySequence) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20)!

tableForAIRLINE_MEAL: aTable

	aTable createFieldNamed: 'ID' type: platform int4.
	aTable createFieldNamed: 'DESCR' type: (platform varChar: 20).
	aTable createFieldNamed: 'FLIGHT_ID' type: platform int4!

tableForBANK_ACCT: aTable

	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'BANK_CODE' type: (platform varChar: 10).
	aTable createFieldNamed: 'BRANCH_NO' type: (platform int4).
	aTable createFieldNamed: 'ACCT_NO' type: (platform varChar: 10).!

tableForBANK_TRANS: aTable 
	| ownerId |
	(aTable createFieldNamed: 'ID' type: platform serial)
		bePrimaryKey.
	ownerId := aTable createFieldNamed: 'OWNER_ID' type: platform int4.
	aTable addForeignKeyFrom: ownerId
		to: ((self tableNamed: 'GR_CUSTOMER') fieldNamed: 'ID').
	aTable createFieldNamed: 'AMT_CURR' type: (platform varChar: 5).
	aTable createFieldNamed: 'AMT_AMT' type: platform int4.
	aTable createFieldNamed: 'SRVC_DESC' type: (platform varChar: 30).
	aTable createFieldNamed: 'SRVC_AMT_CURR' type: (platform varChar: 5).
	aTable createFieldNamed: 'SRVC_AMT_AMT' type: platform int4.!

tableForCOMPRESSED_MONEY_TABLE: aTable
	(aTable createFieldNamed: 'ID' type: platform int4)
		bePrimaryKey.
	aTable createFieldNamed: 'CURRENCY_NAME' type: (platform varChar: 20).
	aTable createFieldNamed: 'AMOUNT' type: platform int4.!

tableForCUSTOMER_ACCT_LINK: aTable

	| customerId accountId |
	customerId := (aTable createFieldNamed: 'CUSTOMER_ID' type: platform int4).
	aTable addForeignKeyFrom: customerId to: ((self tableNamed: 'GR_CUSTOMER') fieldNamed: 'ID').
	accountId := aTable createFieldNamed: 'ACCT_ID' type: platform int4.
	aTable addForeignKeyFrom: accountId to: ((self tableNamed: 'BANK_ACCT') fieldNamed: 'ID').
	aTable addIndexForFields: (Array with: customerId with: accountId).!

tableForDEFAULTABLE_THING: aTable 
	| boolean converter |
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	boolean := aTable createFieldNamed: 'MY_BOOL' type: (platform boolean).
	"We want a default value for this field, but we can't just use a boolean, because in some database we can represent that directly, but in others it will need to be converted to an integer. And likewise we can't just use an integer, so we need to do an explicit conversion."
	converter := boolean converterForStType: Boolean.
	boolean defaultValue: (converter convert: false toDatabaseRepresentationAs: boolean type).
	(aTable createFieldNamed: 'MY_INT' type: (platform int4)) defaultValue: 4.!

tableForEMAIL_ADDRESS: aTable

	| personId |
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	(aTable createFieldNamed: 'USER_NAME' type: (platform varChar: 20)) beIndexed.
	aTable createFieldNamed: 'HOST_NAME' type: (platform varChar: 20).
	personId := aTable createFieldNamed: 'PERSON_ID' type: platform int4.
	personId beIndexed.
	(aTable addForeignKeyFrom: personId to: ((self tableNamed: 'PERSON') fieldNamed: 'ID')).!

tableForFKADDRESS: aTable 
	| contact |
	(aTable createFieldNamed: 'ID' type: platform serial) bePrimaryKey.
	contact := aTable createFieldNamed: 'CONTACT_ID' type: platform int4.
	aTable addForeignKeyFrom: contact
		to: ((self tableNamed: 'FKCONTACT') fieldNamed: 'ID')!

tableForFKCONTACT: aTable 
	| address |
	(aTable createFieldNamed: 'ID' type: platform serial) bePrimaryKey.
	address := aTable createFieldNamed: 'ADDRESS_ID' type: platform int4.
	aTable addForeignKeyFrom: address
		to: ((self tableNamed: 'FKADDRESS') fieldNamed: 'ID')!

tableForFLIGHT: aTable

	aTable name: 'FLIGHT'.
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'FLIGHT_NUM' type: platform int4!

tableForFLIGHT_PASS: aTable

	| flight pass airline |
	aTable name: 'FLIGHT_PASS'.
	flight := aTable createFieldNamed: 'FLIGHT_ID' type: platform int4.
	aTable addForeignKeyFrom: flight
		to: ((self tableNamed: 'FLIGHT') fieldNamed: 'ID').
	pass := aTable createFieldNamed: 'PASS_ID' type: platform int4.
	aTable addForeignKeyFrom: pass
		to: ((self tableNamed: 'PASSENGER') fieldNamed: 'ID').
	airline := aTable createFieldNamed: 'AIRLINE_ID' type: platform int4.
	aTable addForeignKeyFrom: airline
		to: ((self tableNamed: 'AIRLINE') fieldNamed: 'ID').!

tableForFREQUENT_FLYER: aTable 
	| airlineId |
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'POINTS' type: platform int4.
	airlineId := aTable createFieldNamed: 'AIRLINE_ID' type: platform int4.
	aTable addForeignKeyFrom: airlineId to: ((self tableNamed: 'AIRLINE') fieldNamed: 'ID').!

tableForGLORP_OWNER: aTable
	| field |
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	field := aTable createFieldNamed: 'SLAVE_ID' type: platform int4.
	aTable
		addForeignKeyFrom: field
		to: ((self tableNamed: 'GLORP_SLAVE') fieldNamed: 'ID').!

tableForGLORP_SLAVE: aTable
	| field constraint |
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'POSITION_IN_OWNER' type: platform int4.
	field := aTable createFieldNamed: 'OWNER_ID' type: platform int4.
	"Don't actually create this constraint because it causes a cycle that can confuse our sorting mechanism."
	"constraint := aTable
		addForeignKeyFrom: field
		to: ((self tableNamed: 'GLORP_OWNER') fieldNamed: 'ID').
	constraint shouldCreateInDatabase: false."!

tableForGR_ADDRESS: aTable 

	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'STREET' type: (platform varChar: 20).
	aTable createFieldNamed: 'HOUSE_NUM' type: (platform varChar: 20)!

tableForGR_CUSTOMER: aTable 
	(aTable createFieldNamed: 'ID' type: platform int4)
		bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20)!

tableForGR_TRAVEL_AGENT: aTable 

	(aTable createFieldNamed: 'ID' type: platform int4)
		bePrimaryKey.
	aTable createFieldNamed: 'AGENT_NAME' type: (platform varchar: 50).
	aTable createFieldNamed: 'AGENCY_NAME' type: (platform varchar: 50).!

tableForITINERARY: aTable 

	| res |
	(aTable createFieldNamed: 'ID' type: platform serial)
		bePrimaryKey.
	res := aTable createFieldNamed: 'RES_ID' type: (platform int4).
	aTable addForeignKeyFrom: res
		to: ((self tableNamed: 'RESERVATION') fieldNamed: 'ID').!

tableForMONEY_IMAGINARY_TABLE: aTable

	aTable isImaginary: true.
	aTable createFieldNamed: 'CURRENCY' type: (platform varChar: 5).
	aTable createFieldNamed: 'AMOUNT' type: platform int4!

tableForPASSENGER: aTable
	| |
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20)!

tableForPERSON: aTable
	| addrId|
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20).
	addrId := aTable createFieldNamed: 'ADDRESS_ID' type: platform int4.
	aTable addForeignKeyFrom: addrId to: ((self tableNamed: 'GR_ADDRESS') fieldNamed: 'ID').!

tableForRECORD_WITH_UPDATE: aTable 
	| |
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	(aTable createFieldNamed: 'NAME' type: (platform varchar: 20)).
	aTable createFieldNamed: 'UPDATE_TIME' type: (platform versionFieldFor: platform timestamp) generateOverExistingValues.
	"OK, it's not much of a comment, we just print the current time. Note that this field is completely unmapped"
	aTable createFieldNamed: 'UPDATE_COMMENT' type: (platform generatorFor: (platform varchar: 20) withBlock: [Time now printString]) generateOverExistingValues.
	"But this one *is* mapped"
	aTable createFieldNamed: 'UPDATE_OTHER_THING' type: (platform generatorFor: (platform varchar: 20) withBlock: [Time now printString]) generateOverExistingValues.!

tableForRESERVATION: aTable 

	| pass |
	(aTable createFieldNamed: 'ID' type: platform int4)
		bePrimaryKey.
	pass := aTable createFieldNamed: 'PASS_ID' type: (platform int4).
	aTable addForeignKeyFrom: pass
		to: ((self tableNamed: 'PASSENGER') fieldNamed: 'ID').!

tableForSTUFF: aTable 

	(aTable createFieldNamed: 'ID' type: platform inMemorySequence)
		bePrimaryKey.
	aTable createFieldNamed: 'THING' type: (platform varChar: 20)!

tableForTRANSFORMED_TIME: aTable
	(aTable createFieldNamed: 'ID' type: platform int4)
		bePrimaryKey.
	aTable createFieldNamed: 'TIMEFIELD' type: platform int4.!

tableForTREE_NODE: aTable

	| |
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.!

tableForTREE_NODE_LINK: aTable

	| parent child |
	parent := (aTable createFieldNamed: 'PARENT' type: platform int4) bePrimaryKey.
	(aTable addForeignKeyFrom: parent
		to: ((self tableNamed: 'TREE_NODE') fieldNamed: 'ID')) "shouldCreateInDatabase: false"  .
	child := (aTable createFieldNamed: 'CHILD' type: platform int4) bePrimaryKey.
	(aTable addForeignKeyFrom: child
		to: ((self tableNamed: 'TREE_NODE') fieldNamed: 'ID')) "shouldCreateInDatabase: false".! !
!GlorpDemoDescriptorSystem categoriesFor: #allTableNames!other!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForDefaultableThing:!descriptors/other!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpAirline:!class models/airline!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpBankAccount:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpBankAccountNumber:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpBankBranch:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpBankTransaction:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpCustomer:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpEmailAddress:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpItinerary:!class models/airline!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpMoney:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpPassenger:!class models/airline!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpPerson:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpRecordWithUpdateTime:!descriptors/other!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpReservation:!class models/airline!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpServiceCharge:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpTravelAgency:!class models/airline!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpTravelAgent:!class models/airline!private! !
!GlorpDemoDescriptorSystem categoriesFor: #classModelForGlorpTreeNode:!descriptors/tree nodes!private! !
!GlorpDemoDescriptorSystem categoriesFor: #constructAllClasses!other!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForDefaultableThing:!descriptors/other!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpAirline:!descriptors/airline!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpBankAccount:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpBankAccountNumber:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpBankBranch:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpBankTransaction:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpCompressedMoney:!descriptors/other!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpCustomer:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpEmailAddress:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpItinerary:!descriptors/airline!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpMoney:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpOwner:!owner!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpPassenger:!descriptors/airline!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpPerson:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpRecordWithUpdateTime:!descriptors/other!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpReservation:!descriptors/airline!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpServiceCharge:!descriptors/bank!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpSlave:!owner!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpTransformedTime:!descriptors/other!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpTravelAgency:!descriptors/airline!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpTravelAgent:!descriptors/airline!private! !
!GlorpDemoDescriptorSystem categoriesFor: #descriptorForGlorpTreeNode:!descriptors/tree nodes!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleAccountRow1!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleAccountRow2!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleAccountRow3!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleAddressRow!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleAddressRowForOrdering1!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleAddressRowForOrdering2!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleAddressRowForOrdering3!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleAddressRowForOrdering4!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleAddressRowForOrdering5!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleAddressRowWithDifferentStreet!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleBankTransactionRow!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleBankTransactionRow2!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleCALinkRow1!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleCALinkRow2!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleCALinkRow3!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleCALinkRow4!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleCompressedMoneyRow!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleCompressedMoneyRow2!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleCustomerRow1!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleCustomerRow2!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleEmailAddressRow1!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleEmailAddressRow2!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleFrequentFlyerRow!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleFrequentFlyerRow2!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #exampleModifiedAddressRow!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #examplePassengerRow!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #examplePassengerRow2!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #examplePersonRow1!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #examplePersonRow2!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #examplePersonRowForOrdering1!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #examplePersonRowForOrdering2!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #examplePersonRowForOrdering3!examples!private! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForAIRLINE:!private!tables/airline! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForAIRLINE_MEAL:!private!tables/airline! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForBANK_ACCT:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForBANK_TRANS:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForCOMPRESSED_MONEY_TABLE:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForCUSTOMER_ACCT_LINK:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForDEFAULTABLE_THING:!descriptors/other!private! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForEMAIL_ADDRESS:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForFKADDRESS:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForFKCONTACT:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForFLIGHT:!private!tables/airline! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForFLIGHT_PASS:!private!tables/airline! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForFREQUENT_FLYER:!private!tables/airline! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForGLORP_OWNER:!owner!private! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForGLORP_SLAVE:!owner!private! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForGR_ADDRESS:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForGR_CUSTOMER:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForGR_TRAVEL_AGENT:!private!tables/airline! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForITINERARY:!private!tables/airline! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForMONEY_IMAGINARY_TABLE:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForPASSENGER:!private!tables/airline! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForPERSON:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForRECORD_WITH_UPDATE:!descriptors/other!private! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForRESERVATION:!private!tables/airline! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForSTUFF:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForTRANSFORMED_TIME:!private!tables! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForTREE_NODE:!descriptors/tree nodes!private! !
!GlorpDemoDescriptorSystem categoriesFor: #tableForTREE_NODE_LINK:!descriptors/tree nodes!private! !

!GlorpDemoDescriptorSystem class methodsFor!

default
	Default isNil ifTrue: [Default := self new].
	^Default! !
!GlorpDemoDescriptorSystem class categoriesFor: #default!accessing!private! !

GlorpDescriptorSystemWithNamespaces guid: (GUID fromString: '{D6E40CBD-1A11-43AD-9A1B-DB8B9FE91573}')!
GlorpDescriptorSystemWithNamespaces comment: ''!
!GlorpDescriptorSystemWithNamespaces categoriesForClass!Unclassified! !
!GlorpDescriptorSystemWithNamespaces methodsFor!

allTableNames
	^#()!

constructAllClasses
	^(super constructAllClasses)
		add: GlorpTestClassInNamespace;
		yourself!

descriptorForGlorpTestClassInNamespace: aDescriptor 
	^aDescriptor! !
!GlorpDescriptorSystemWithNamespaces categoriesFor: #allTableNames!accessing!private! !
!GlorpDescriptorSystemWithNamespaces categoriesFor: #constructAllClasses!accessing!private! !
!GlorpDescriptorSystemWithNamespaces categoriesFor: #descriptorForGlorpTestClassInNamespace:!accessing!private! !

GlorpDocumentDescriptorSystem guid: (GUID fromString: '{D2F4B36A-B3C7-41DE-8697-87223D618C60}')!
GlorpDocumentDescriptorSystem comment: 'This is a test descriptor system for documents with attachments that have their attachment bytes in a separate table, so reading them can be deferred. Neither attachments nor attachmentBytes have references to their containing document, but do have primary keys as foreign keys to it. When writing, this exhibited a problem that if you didn''t read the bytes, then the attachment was written properly, because it could get its documentId primary key component from the proxy to the attachmentBytes. But if you had read the attachmentBytes, then it tried to get the value from the attachmentBytes object, which didn''t know about that value. So it couldn''t find the primary key of the attachment, and therefore assumed it was new.'!
!GlorpDocumentDescriptorSystem categoriesForClass!Unclassified! !
!GlorpDocumentDescriptorSystem methodsFor!

allTableNames
	^#('document' 'attachment' 'attachmentbytes')!

constructAllClasses
	^(super constructAllClasses)
		add: GlorpDocument;
		add: GlorpAttachment;
		add: GlorpAttachmentBytes;
		yourself!

tableForATTACHMENT: aTable 
	| d |
	d := (aTable createFieldNamed: 'document_id' type: platform int4) 
				bePrimaryKey.
	(aTable createFieldNamed: 'indexInDocument' type: platform int) bePrimaryKey.
	aTable createFieldNamed: 'mimetype' type: (platform varchar: 32).

	"FK Constraints"
	aTable addForeignKeyFrom: d
		to: ((self tableNamed: 'document') fieldNamed: 'id')!

tableForATTACHMENTBYTES: aTable 
	| d i |
	d := (aTable createFieldNamed: 'attachment_document_id'
				type: platform int4) bePrimaryKey.
	i := (aTable createFieldNamed: 'attachment_index' type: platform int) 
				bePrimaryKey.
	aTable createFieldNamed: 'content' type: platform text.

	"FK"
	aTable 
		addForeignKeyFrom: d
		to: ((self tableNamed: 'attachment') fieldNamed: 'document_id')
		from: i
		to: ((self tableNamed: 'attachment') fieldNamed: 'indexInDocument')!

tableForDOCUMENT: aTable 
	(aTable createFieldNamed: 'id' type: platform sequence) bePrimaryKey.
	aTable createFieldNamed: 'whatever' type: (platform integer).! !
!GlorpDocumentDescriptorSystem categoriesFor: #allTableNames!glorp!private! !
!GlorpDocumentDescriptorSystem categoriesFor: #constructAllClasses!glorp!private! !
!GlorpDocumentDescriptorSystem categoriesFor: #tableForATTACHMENT:!glorp!private! !
!GlorpDocumentDescriptorSystem categoriesFor: #tableForATTACHMENTBYTES:!glorp!private! !
!GlorpDocumentDescriptorSystem categoriesFor: #tableForDOCUMENT:!glorp!private! !

!GlorpDocumentDescriptorSystem class methodsFor!

doTest
	"   AADescriptor doTest    "

	| glorpSession doc |
	glorpSession := self connectToDatabase.

	"Try #1 -- this works as advertized"
	doc := self readDocumentAndAttachmentsFrom: glorpSession.
	"Something changed? Should not."
	glorpSession modify: doc in: [].
	doc := nil.
	glorpSession accessor logout.
	glorpSession := self connectToDatabase.

	"Try #2 -- this makes Glorp believe the attachment was changed"
	doc := self readDocumentAndAttachmentsFrom: glorpSession.
	doc attachments do: 
			[:ea | 
			"Force attachmentBytes to be instanciated"
			Transcript nextPutAll: '----> ', ea attachmentBytes content; cr].
	"Something changed? Should not, but does."
	"Glorp now tries to update the attachment AND save the attachmentBytes again. Boom"
	glorpSession modify: doc in: [].
	glorpSession accessor logout!

readDocumentAndAttachmentsFrom: glorpSession 
	| doc |
	doc := glorpSession readOneOf: GlorpDocument.
	Transcript
		cr;
		nextPutAll: '---> Read document ' , doc id printString;
		cr.
	doc attachments do: 
			[:att | 
			Transcript
				cr;
				nextPutAll: '------> Attachment ' , att index printString , ' ' 
							, att mimeType;
				cr].
	^doc! !
!GlorpDocumentDescriptorSystem class categoriesFor: #doTest!none!private! !
!GlorpDocumentDescriptorSystem class categoriesFor: #readDocumentAndAttachmentsFrom:!none!private! !

GlorpEncyclopediaDescriptorSystem guid: (GUID fromString: '{2772D6A9-38C7-42E0-BE87-E2C585B623C4}')!
GlorpEncyclopediaDescriptorSystem comment: 'This is a set of test descriptors for dealing with different variations of dictionary mappings.'!
!GlorpEncyclopediaDescriptorSystem categoriesForClass!Unclassified! !
!GlorpEncyclopediaDescriptorSystem methodsFor!

allTableNames
	^#('ENCYC' 'ENCYC_ENTRY' 'ENCYC_ENTRY_LINK' 'IMAGINARY_MEDIA_TYPE' 'GR_PUBLISHER' 'PUBLISHER_TITLE' 'PUB_TITLES_STOCK' 'PUB_TITLE_LINK' 'PUBLISHER_TITLE2' 'PUB_EMP_LINK' 'PUBLISHER_EMP').!

classModelForGlorpEncyclopedia: aClassModel 
 
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name. 
	aClassModel newAttributeNamed: #entries dictionaryFrom: String to: GlorpEncyclopediaEntry.
	"A slightly contrived way of having a mapping to a type of entries that don't use a link table."
	aClassModel newAttributeNamed: #biographicalEntries dictionaryFrom: String to: GlorpEncyclopediaBioEntry.!

classModelForGlorpEncyclopediaBioEntry: aClassModel 
	aClassModel newAttributeNamed: #owner type: GlorpEncyclopedia.
	aClassModel newAttributeNamed: #title.
	aClassModel newAttributeNamed: #text.!

classModelForGlorpEncyclopediaEntry: aClassModel 
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #title.
	aClassModel newAttributeNamed: #text.
	aClassModel newAttributeNamed: #mediaType type: GlorpMediaType!

classModelForGlorpMediaType: aClassModel 
	aClassModel newAttributeNamed: #name.
	aClassModel newAttributeNamed: #mimeType!

classModelForGlorpPublisher: aClassModel 
 
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name. 
	aClassModel newAttributeNamed: #titles collection: Array of: String.
	aClassModel newAttributeNamed: #titlesWithNumberInStock dictionaryFrom: String to: Integer.
	aClassModel newAttributeNamed: #employees dictionaryFrom: String to: GlorpPublisherEmployee.
	aClassModel newAttributeNamed: #differentBunchOfEmployeesById dictionaryFrom: Integer to: GlorpPublisherEmployee.

"	aClassModel newAttributeNamed: #titlesWithNumberInStockLink collection: Dictionary of: Integer."!

classModelForGlorpPublisherEmployee: aClassModel 
 
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name. 
	aClassModel newAttributeNamed: #position.!

constructAllClasses
	^(super constructAllClasses)
		add: GlorpEncyclopedia;
		add: GlorpMediaType;
		add: GlorpEncyclopediaEntry;
		add: GlorpPublisher;
		add: GlorpPublisherEmployee;
		yourself!

descriptorForGlorpEncyclopedia: aDescriptor 
	| table linkTable |
	table := self tableNamed: 'ENCYC'.
	linkTable := self tableNamed: 'ENCYC_ENTRY_LINK'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id
		to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #name
		to: (table fieldNamed: 'NAME').
	(aDescriptor newMapping: BasicDictionaryMapping)
		attributeName: #entries;
		referenceClass: GlorpEncyclopediaEntry;
		keyField: (linkTable fieldNamed: 'REFERENCE_NO');
		linkFields: (Array 
					with: (linkTable fieldNamed: 'ENCYC_ENTRY_ID')).
	(aDescriptor newMapping: DictionaryMapping)
		attributeName: #biographicalEntries;
		referenceClass: GlorpEncyclopediaBioEntry;
		usesLinkTable: false;
		beExclusive;
		keyField: ((self tableNamed: 'ENCYC_BIO') fieldNamed: 'TITLE').!

descriptorForGlorpEncyclopediaBioEntry: aDescriptor 
	| entryTable |
	entryTable := self tableNamed: 'ENCYC_BIO'.
	aDescriptor table: entryTable.
	"It's important that we have a mapping for the owner here, because we're expecting these entries to be deleted, and we can't delete them without knowing the primary keys."
	(aDescriptor newMapping: OneToOneMapping)
		attributeName: #owner;
		beReadOnly.
	(aDescriptor newMapping: DirectMapping) from: #title
		to: (entryTable fieldNamed: 'TITLE').
	(aDescriptor newMapping: DirectMapping) from: #text
		to: (entryTable fieldNamed: 'ENTRY_TEXT').!

descriptorForGlorpEncyclopediaEntry: aDescriptor 
	| entryTable |
	entryTable := self tableNamed: 'ENCYC_ENTRY'.
	aDescriptor table: entryTable.
	(aDescriptor newMapping: DirectMapping) from: #id
		to: (entryTable fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #title
		to: (entryTable fieldNamed: 'TITLE').
	(aDescriptor newMapping: DirectMapping) from: #text
		to: (entryTable fieldNamed: 'ENTRY_TEXT').
	(aDescriptor newMapping: EmbeddedValueOneToOneMapping)
		attributeName: #mediaType;
		referenceClass: GlorpMediaType;
		fieldTranslation: ((Join new)
					addSource: (entryTable fieldNamed: 'MEDIA_TYPE_NAME')
						target: ((self tableNamed: 'IMAGINARY_MEDIA_TYPE') 
								fieldNamed: 'MEDIA_TYPE_NAME');
					addSource: (entryTable fieldNamed: 'MEDIA_TYPE_MIME')
						target: ((self tableNamed: 'IMAGINARY_MEDIA_TYPE') 
								fieldNamed: 'MEDIA_TYPE_MIME');
					yourself).
	^aDescriptor!

descriptorForGlorpMediaType: aDescriptor 
	| table |
	table := self tableNamed: 'IMAGINARY_MEDIA_TYPE'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #name
		to: (table fieldNamed: 'MEDIA_TYPE_NAME').
	(aDescriptor newMapping: DirectMapping) from: #mimeType
		to: (table fieldNamed: 'MEDIA_TYPE_MIME')!

descriptorForGlorpPublisher: aDescriptor 
	| table titleTable titleStockTable linkTable |
	table := self tableNamed: 'GR_PUBLISHER'.
	titleTable := self tableNamed: 'PUBLISHER_TITLE'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id
		to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #name
		to: (table fieldNamed: 'NAME').
	(aDescriptor newMapping: DirectToManyMapping)
		attributeName: #titles;
		resultField: (titleTable fieldNamed: 'TITLE');
		writeTheOrderField;
		orderBy: [:each | (each getTable: titleTable) getField: 'POSITION'];
		join: (Join from: (table fieldNamed: 'ID') to: (titleTable fieldNamed: 'PUBLISHER_ID')).
	titleStockTable := self tableNamed: 'PUB_TITLES_STOCK'.
	(aDescriptor newMapping: DictionaryMapping)
		attributeName: #titlesWithNumberInStock;
		usesLinkTable: false;
		keyField: (titleStockTable fieldNamed: 'TITLE');
		valueField: (titleStockTable fieldNamed: 'STOCK');
		join: (Join from: (table fieldNamed: 'ID') to: (titleStockTable fieldNamed: 'PUBLISHER_ID')).
	linkTable := self tableNamed: 'PUB_EMP_LINK'.
	(aDescriptor newMapping: DictionaryMapping)
		attributeName: #employees;
		usesLinkTable: true;
		keyField: ((self tableNamed: 'PUBLISHER_EMP' ) fieldNamed: 'JOBTITLE');
		join: (Join 
			from: (table fieldNamed: 'ID')
			to: (linkTable fieldNamed: 'PUBLISHER_ID')
			from: 'A'
			to: (linkTable fieldNamed: 'FOO')).
	(aDescriptor newMapping: DictionaryMapping)
		attributeName: #differentBunchOfEmployeesById;
		usesLinkTable: true;
		join: (Join 
			from: (table fieldNamed: 'ID')
			to: (linkTable fieldNamed: 'PUBLISHER_ID')
			from: 'B'
			to: (linkTable fieldNamed: 'FOO'));
		keyField: ((self tableNamed: 'PUB_EMP_LINK') fieldNamed: 'EMP_ID').
		
"	titleStockLinkTable := self tableNamed: 'PUB_TITLE_LINK'.
	titleTable2 := self tableNamed: 'PUBLISHER_TITLE2'.
	(aDescriptor newMapping: DictionaryMapping)
		attributeName: #titlesWithNumberInStockLink;
		usesLinkTable: true;
		keyField: (titleTable2 fieldNamed: 'TITLE');
		valueField: (titleStockLinkTable fieldNamed: 'STOCK');
		linkTableJoin: (Join from: (table fieldNamed: 'ID') to: (titleStockLinkTable fieldNamed: 'PUBLISHER_ID'))."!

descriptorForGlorpPublisherEmployee: aDescriptor 
	| table |
	table := self tableNamed: 'PUBLISHER_EMP'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id
		to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #name
		to: (table fieldNamed: 'NAME').
	(aDescriptor newMapping: DirectMapping) from: #jobTitle
		to: (table fieldNamed: 'JOBTITLE').!

exampleEncyclopedias
	"self new exampleEncyclopedias"
	| encyc1 entry1 entry2 entry3 encyc2 encyc3 |
	encyc1 := GlorpEncyclopedia new id: 3; name: 'The Canadian Encyclopedia'.
	entry1 := self exampleEntry1.
	entry2 := self exampleEntry2.
	entry3 := self exampleEntry3.
	encyc1 articleAt: '12345' put: entry1.
	encyc1 articleAt: 'abcde' put: entry2.
	encyc1 articleAt: 'unique' put: entry3.
	encyc2 := GlorpEncyclopedia new id: 4; name: 'The Plagiarists Compendium'.
	encyc2 articleAt: '54321' put: entry1.
	encyc2 articleAt: 'edcba' put: entry2.
	encyc3 := GlorpEncyclopedia new id: 5; name: 'The Very Frugal Dictionary'.
	^Array with: encyc1 with: encyc2 with: encyc3.!

exampleEntry1
	^GlorpEncyclopediaEntry new 
		id: 'one';
		title: 'All About Ants';
		text: 'Ants are, like, these little tiny creatures. Gross.'.!

exampleEntry2
	^GlorpEncyclopediaEntry new 
		id: 'two';
		title: 'Computer Programming Languages';
		text: 'There are many different computer programming languages. The best one is Smalltalk.'.!

exampleEntry3
	^GlorpEncyclopediaEntry new 
		id: 'three';
		title: 'Vehicular Fish Decay';
		text: 'Do you know what happens if you leave a fish too long in an elevator? Well heres a clue. Fish is biodegradable. That means it rots.'.!

examplePublisher1
	"Put in the copies to avoid an issue with reverting immutable objects."
	^GlorpPublisher new 
		id: 1;
		name: 'Cambridge';
		titles: (Array with: 'Mastering ENVY/Developer' copy with: 'Principia Mathematica' copy with:  'Metadata-Based Persistence for Dummies' copy);
		titlesWithNumberInStock: (Dictionary new
			at:  'Mastering ENVY/Developer' put: 2;
			at: 'Principia Mathematica' put: 2;
			at: 'Metadata-Based Persistence for Dummies' put: 2;
			yourself);
		employees: (Dictionary new
			at: 'CEO' put: (GlorpPublisherEmployee new id: 1; name: 'The Boss'; jobTitle: 'CEO');
			at: 'Editor' put: (GlorpPublisherEmployee new id: 2; name: 'Somebody'; jobTitle: 'Editor');
			yourself);
		differentBunchOfEmployeesById: (Dictionary new
			at: 3 put: (GlorpPublisherEmployee new id: 3; name: 'Contractor 1'; jobTitle: 'Contractor');
			at: 4 put: (GlorpPublisherEmployee new id: 4; name: 'Contractor 2'; jobTitle: 'Contractor');
			yourself);
		yourself.!

examplePublisher2
	^GlorpPublisher new 
		id: 2;
		name: 'Harper Collins';
		titles: (Array with: 'A book' copy);
		titlesWithNumberInStock: (Dictionary new
			at:  'A book' copy put: 200;
			yourself).!

examplePublisher3
	^GlorpPublisher new 
		id: 3;
		name: 'A New Publishing company';
		titles: #().!

examplePublishers
	^Array with: self examplePublisher1 with: self examplePublisher2 with: self examplePublisher3.!

tableForENCYC: aTable 

	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 50).!

tableForENCYC_BIO: aTable 

	| encycId |
	(aTable createFieldNamed: 'TITLE' type: (platform varChar: 50)) bePrimaryKey.
	encycId := aTable createFieldNamed: 'ENCYC_ID' type: platform integer.
	encycId bePrimaryKey.
	aTable addForeignKeyFrom: encycId to: ((self tableNamed: 'ENCYC') fieldNamed: 'ID').
	aTable createFieldNamed: 'ENTRY_TEXT' type: (platform varChar: 50).!

tableForENCYC_ENTRY: aTable 

	(aTable createFieldNamed: 'ID' type: (platform varChar: 50)) bePrimaryKey.
	aTable createFieldNamed: 'TITLE' type: (platform varChar: 50).
	aTable createFieldNamed: 'ENTRY_TEXT' type: (platform varChar: 200).
	aTable createFieldNamed: 'MEDIA_TYPE_NAME' type: (platform varChar: 100).
	aTable createFieldNamed: 'MEDIA_TYPE_MIME' type: (platform varChar: 100).!

tableForENCYC_ENTRY_LINK: aTable 

	| encycId entryId |
	encycId := aTable createFieldNamed: 'ENCYC_ID' type: platform int4.
	encycId bePrimaryKey.
	aTable addForeignKeyFrom: encycId to: ((self tableNamed: 'ENCYC') fieldNamed: 'ID').

	entryId := aTable createFieldNamed: 'ENCYC_ENTRY_ID' type: (platform varChar: 50).
	aTable addForeignKeyFrom: entryId to: ((self tableNamed: 'ENCYC_ENTRY') fieldNamed: 'ID').
	(aTable createFieldNamed: 'REFERENCE_NO' type: (platform varChar: 10)) bePrimaryKey.!

tableForGR_PUBLISHER: aTable 

	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 50).!

tableForIMAGINARY_MEDIA_TYPE: aTable 
	aTable isImaginary: true.
  
	aTable createFieldNamed: 'MEDIA_TYPE_NAME' type: (platform varChar: 100).
	aTable createFieldNamed: 'MEDIA_TYPE_MIME' type: (platform varChar: 100).!

tableForPUB_EMP_LINK: aTable 

	| pubId titleId |
	pubId := aTable createFieldNamed: 'PUBLISHER_ID' type: platform int4.
	aTable addForeignKeyFrom: pubId  to: ((self tableNamed: 'GR_PUBLISHER') fieldNamed: 'ID').
	titleId := aTable createFieldNamed: 'EMP_ID' type: platform int4.
	aTable addForeignKeyFrom: titleId  to: ((self tableNamed: 'PUBLISHER_EMP') fieldNamed: 'ID').
	aTable createFieldNamed: 'FOO' type: (platform varchar: 5).!

tableForPUB_TITLE_LINK: aTable 

	| pubId titleId |
	pubId := aTable createFieldNamed: 'PUBLISHER_ID' type: platform int4.
	aTable addForeignKeyFrom: pubId  to: ((self tableNamed: 'GR_PUBLISHER') fieldNamed: 'ID').
	titleId := aTable createFieldNamed: 'TITLE_ID' type: platform int4.
	aTable addForeignKeyFrom: titleId  to: ((self tableNamed: 'PUBLISHER_TITLE2') fieldNamed: 'ID').
	aTable createFieldNamed: 'STOCK' type: platform int4.!

tableForPUB_TITLES_STOCK: aTable 

	| pubId |
	pubId := aTable createFieldNamed: 'PUBLISHER_ID' type: platform int4.
	aTable addForeignKeyFrom: pubId  to: ((self tableNamed: 'GR_PUBLISHER') fieldNamed: 'ID').
	aTable createFieldNamed: 'TITLE' type: (platform varChar: 50).
	aTable createFieldNamed: 'STOCK' type: platform int4.!

tableForPUBLISHER_EMP: aTable 

	| |
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 50).	
	aTable createFieldNamed: 'JOBTITLE' type: (platform varChar: 50).!

tableForPUBLISHER_TITLE: aTable 

	| pubId |
	pubId := aTable createFieldNamed: 'PUBLISHER_ID' type: platform int4.
	aTable addForeignKeyFrom: pubId  to: ((self tableNamed: 'GR_PUBLISHER') fieldNamed: 'ID').
	aTable createFieldNamed: 'POSITION' type: (platform int4).	
	aTable createFieldNamed: 'TITLE' type: (platform varChar: 50).!

tableForPUBLISHER_TITLE2: aTable 

	| |
	(aTable createFieldNamed: 'ID' type: platform serial) bePrimaryKey.
	aTable createFieldNamed: 'TITLE' type: (platform varChar: 50).! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #allTableNames!other!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #classModelForGlorpEncyclopedia:!descriptors!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #classModelForGlorpEncyclopediaBioEntry:!descriptors!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #classModelForGlorpEncyclopediaEntry:!descriptors!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #classModelForGlorpMediaType:!descriptors!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #classModelForGlorpPublisher:!descriptors!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #classModelForGlorpPublisherEmployee:!descriptors!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #constructAllClasses!other!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #descriptorForGlorpEncyclopedia:!descriptors!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #descriptorForGlorpEncyclopediaBioEntry:!descriptors!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #descriptorForGlorpEncyclopediaEntry:!descriptors!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #descriptorForGlorpMediaType:!descriptors!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #descriptorForGlorpPublisher:!descriptors!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #descriptorForGlorpPublisherEmployee:!descriptors!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #exampleEncyclopedias!examples!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #exampleEntry1!examples!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #exampleEntry2!examples!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #exampleEntry3!examples!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #examplePublisher1!examples!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #examplePublisher2!examples!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #examplePublisher3!examples!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #examplePublishers!examples!private! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #tableForENCYC:!private!tables! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #tableForENCYC_BIO:!private!tables! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #tableForENCYC_ENTRY:!private!tables! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #tableForENCYC_ENTRY_LINK:!private!tables! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #tableForGR_PUBLISHER:!private!tables! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #tableForIMAGINARY_MEDIA_TYPE:!private!tables! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #tableForPUB_EMP_LINK:!private!tables! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #tableForPUB_TITLE_LINK:!private!tables! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #tableForPUB_TITLES_STOCK:!private!tables! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #tableForPUBLISHER_EMP:!private!tables! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #tableForPUBLISHER_TITLE:!private!tables! !
!GlorpEncyclopediaDescriptorSystem categoriesFor: #tableForPUBLISHER_TITLE2:!private!tables! !

GlorpInheritanceDescriptorSystem guid: (GUID fromString: '{C017BCDD-587E-4097-B9E2-577591E58037}')!
GlorpInheritanceDescriptorSystem comment: ''!
!GlorpInheritanceDescriptorSystem categoriesForClass!Unclassified! !
!GlorpInheritanceDescriptorSystem methodsFor!

allTableNames

	^#('EMPLOYEE' 'OFFICE' 'PERISHABLE_ITEM' 'NONPERISHABLE_ITEM' 'UNASSEMBLED_ITEM' 'WORKING_STIFF' 'POULTRY' 'TAX' 'WAREHOUSE' 'WAREHOUSE_ITEM_LINK'  'GLORP_IMAGE' 'GLORP_TAG' 'GLORP_TAGS').!

classModelForGlorpImage: aClassModel 
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #location.
	aClassModel newAttributeNamed: #tags collectionOf: GlorpTag.!

classModelForGlorpTag: aClassModel 
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #key.
	aClassModel newAttributeNamed: #label!

classModelForGlorpTaggableObject: aClassModel!

classModelForGlorpWarehouse: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #address.
	aClassModel newAttributeNamed: #currentItem type: GlorpInventoryItem.
	aClassModel newAttributeNamed: #items collectionOf: GlorpInventoryItem.!

constructAllClasses
	^(super constructAllClasses)
		add: GlorpOffice;
		add: GlorpEmployee;
		add: GlorpManager;
		add: GlorpRegionalManager;
		add: GlorpLineWorker;
		add: GlorpInventoryItem;
		add: GlorpPerishableItem;
		add: GlorpNonperishableItem;
		add: GlorpUnassembledItem;
		add: GlorpWorkingStiff;
		add: GlorpPoultry;
		add: GlorpTax;
		add: GlorpBasicTax;
		add: GlorpSurcharge;
		add: GlorpWarehouse;
		add: GlorpTag;
		add: GlorpTaggableObject;
		add: GlorpImage;
		yourself!

descriptorForGlorpEmployee: aDescriptor
	| table |
	table := self tableNamed: 'EMPLOYEE'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	(self typeResolverFor: GlorpEmployee) register: aDescriptor keyedBy: 'E' field: (table fieldNamed: 'EMPLOYEE_TYPE').
	^aDescriptor!

descriptorForGlorpImage: aDescriptor 
	| table |
	table := self tableNamed: 'GLORP_IMAGE'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping)
		from: #id
		to: (table fieldNamed: 'id').
	(aDescriptor newMapping: DirectMapping)
		from: #location
		to: (table fieldNamed: 'location').
	(aDescriptor newMapping: ManyToManyMapping) attributeName: #tags;
		 referenceClass: GlorpTag;
		
		join: (Join
				from: (table fieldNamed: 'id')
				to: ((self tableNamed: 'IMAGETAGS')
						fieldNamed: 'obj_id')).
	(self typeResolverFor: GlorpTaggableObject)
		register: aDescriptor!

descriptorForGlorpInventoryItem: aDescriptor

	(self typeResolverFor: GlorpInventoryItem) register: aDescriptor abstract: true.
	^aDescriptor!

descriptorForGlorpLineWorker: aDescriptor
	| table |
	table := self tableNamed: 'EMPLOYEE'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	(self typeResolverFor: GlorpEmployee) register: aDescriptor keyedBy: 'W' field: (table fieldNamed: 'EMPLOYEE_TYPE').
	aDescriptor addMapping: (DirectMapping from: #productionLine to: (table fieldNamed: 'PRODUCTION_LINE')).
	^aDescriptor!

descriptorForGlorpManager: aDescriptor
	| table |
	table := self tableNamed: 'EMPLOYEE'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	aDescriptor addMapping: (DirectMapping from: #branch to: (table fieldNamed: 'BRANCH')).
	(self typeResolverFor: GlorpEmployee) register: aDescriptor keyedBy: 'M' field: (table fieldNamed: 'EMPLOYEE_TYPE').
	^aDescriptor!

descriptorForGlorpNonperishableItem: aDescriptor

	| table |
	table := self tableNamed: 'NONPERISHABLE_ITEM'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	aDescriptor addMapping: (DirectMapping from: #serialNumber to: (table fieldNamed: 'SERIAL_NUMBER')).
	(self typeResolverFor: GlorpInventoryItem) register: aDescriptor.
	^aDescriptor!

descriptorForGlorpOffice: aDescriptor
	| table |
	table := self tableNamed: 'OFFICE'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (OneToManyMapping new
			attributeName: #employees;
			referenceClass: GlorpEmployee;
			join: (Join 
				from: (table fieldNamed: 'ID')
				to: ((self tableNamed: 'EMPLOYEE') fieldNamed: 'OFFICE_ID'))).
	aDescriptor addMapping: (OneToOneMapping new
		attributeName: #employeeOfMonth;
		referenceClass: GlorpEmployee;
		join: (Join
				from: (table fieldNamed: 'EMPLOYEE_OF_MONTH')
				to: ((self tableNamed: 'EMPLOYEE') fieldNamed: 'ID'))).
	^aDescriptor!

descriptorForGlorpPerishableItem: aDescriptor

	| table |
	table := self tableNamed: 'PERISHABLE_ITEM'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	aDescriptor addMapping: (DirectMapping from: #age to: (table fieldNamed: 'AGE')).
	(self typeResolverFor: GlorpInventoryItem) register: aDescriptor.
	^aDescriptor!

descriptorForGlorpPoultry: aDescriptor
	"Poultry does not participate in the InventoryItem heirarchy (ie it will not be retrieved when asking for an InventoryItem)"
	| table |
	table := self tableNamed: 'POULTRY'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	aDescriptor addMapping: (DirectMapping from: #age to: (table fieldNamed: 'AGE')).
	aDescriptor addMapping: (DirectMapping from: #featherColor to: (table fieldNamed: 'FEATHER_COLOR')).
	^aDescriptor!

descriptorForGlorpRegionalManager: aDescriptor
	| table |
	table := self tableNamed: 'EMPLOYEE'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	aDescriptor addMapping: (DirectMapping from: #branch to: (table fieldNamed: 'BRANCH')).
	aDescriptor addMapping: (DirectMapping from: #region to: (table fieldNamed: 'REGION')).
	(self typeResolverFor: GlorpEmployee) register: aDescriptor keyedBy: 'R' field: (table fieldNamed: 'EMPLOYEE_TYPE').
	^aDescriptor!

descriptorForGlorpTag: aDescriptor 
	| table |
	table := self tableNamed: 'GLORP_TAG'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping)
		from: #id
		to: (table fieldNamed: 'id').
	(aDescriptor newMapping: DirectMapping)
		from: #key
		to: (table fieldNamed: 'key').
	(aDescriptor newMapping: DirectMapping)
		from: #label
		to: (table fieldNamed: 'label').!

descriptorForGlorpTaggableObject: aDescriptor 
	(self typeResolverFor: GlorpTaggableObject)
		register: aDescriptor
		abstract: true!

descriptorForGlorpUnassembledItem: aDescriptor

	| table |
	table := self tableNamed: 'UNASSEMBLED_ITEM'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	aDescriptor addMapping: (DirectMapping from: #serialNumber to: (table fieldNamed: 'SERIAL_NUMBER')).
	aDescriptor addMapping: (DirectMapping from: #assemblyCost to: (table fieldNamed: 'ASSEM_COST')).
	(self typeResolverFor: GlorpInventoryItem) register: aDescriptor.
	^aDescriptor!

descriptorForGlorpWarehouse: aDescriptor
	| table linkTable |
	table := self tableNamed: 'WAREHOUSE'.
	aDescriptor table: table.
	aDescriptor
		addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor
		addMapping:
			(DirectMapping from: #address to: (table fieldNamed: 'ADDRESS')).
	(aDescriptor newMapping: OneToOneMapping) 
		attributeName: #currentItem;
		join: (self polymorphicJoinToItemFromField: (table fieldNamed: 'CURRENT_ITEM_ID')).
		
	linkTable := self tableNamed: 'WAREHOUSE_ITEM_LINK'.
	(aDescriptor newMapping: ManyToManyMapping)
		attributeName: #items;
		join:
				(Join
						from: (table fieldNamed: 'ID')
						to: (linkTable fieldNamed: 'WAREHOUSE_ID'));
		reverseJoin: (self polymorphicJoinToItemFromField: (linkTable fieldNamed: 'ITEM_ID')).
	^aDescriptor.!

descriptorForGlorpWorkingStiff: aDescriptor
	"Working stiff does not participate in the Employee type mapping scheme (it uses its own table)"
	| table |
	table := self tableNamed: 'WORKING_STIFF'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	^aDescriptor!

polymorphicJoinToItemFromField: aField
	"Return a polymorphic join to the GlorpInventoryItem subclasses from the given field."
	| polymorphicJoin |
	polymorphicJoin := VariableJoin new.
	(Array with: GlorpNonperishableItem with: GlorpPerishableItem with: GlorpUnassembledItem)
		do:
			[:eachClass | 
			polymorphicJoin
				addJoinFor: eachClass
				as:
					(Join
						from: aField
						to: ((self descriptorFor: eachClass) primaryTable fieldNamed: 'ID'))].
	^polymorphicJoin!

tableForEMPLOYEE: aTable
	| officeId |
	aTable name: 'EMPLOYEE'.
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20).
	officeId := aTable createFieldNamed: 'OFFICE_ID' type: platform int4.
	aTable addForeignKeyFrom: officeId
		to: ((self tableNamed: 'OFFICE') fieldNamed: 'ID').
	aTable createFieldNamed: 'EMPLOYEE_TYPE' type: (platform varChar: 20).
	aTable createFieldNamed: 'BRANCH' type: (platform varChar: 20).
	aTable createFieldNamed: 'REGION' type: (platform varChar: 20).
	aTable createFieldNamed: 'PRODUCTION_LINE' type: (platform varChar: 20).!

tableForGLORP_IMAGE: aTable 
	(aTable createFieldNamed: 'id' type: platform sequence) bePrimaryKey.
	aTable
		createFieldNamed: 'location'
		type: (platform varChar: 250).!

tableForGLORP_TAG: aTable 
	(aTable createFieldNamed: 'id' type: platform sequence) bePrimaryKey.
	aTable
		createFieldNamed: 'key'
		type: (platform varChar: 200).
	aTable
		createFieldNamed: 'label'
		type: (platform varChar: 200).!

tableForGLORP_TAGS: aTable 
	| tagKey tagObjKey |
	tagKey := aTable createFieldNamed: 'tag_id' type: platform int4.
	aTable
		addForeignKeyFrom: tagKey
		to: ((self tableNamed: 'GLORP_TAG')
				fieldNamed: 'id').
	tagObjKey := aTable createFieldNamed: 'obj_id' type: platform int4.
	aTable
		addForeignKeyFrom: tagObjKey
		to: ((self tableNamed: 'GLORP_IMAGE')
				fieldNamed: 'id')!

tableForIMAGETAGS: aTable 
	| tagKey tagObjKey |
	tagKey := aTable createFieldNamed: 'tag_id' type: platform int4.
	aTable
		addForeignKeyFrom: tagKey
		to: ((self tableNamed: 'GLORP_TAG')
				fieldNamed: 'id').
	tagObjKey := aTable createFieldNamed: 'obj_id' type: platform int4.
	aTable
		addForeignKeyFrom: tagObjKey
		to: ((self tableNamed: 'GLORP_IMAGE')
				fieldNamed: 'id')!

tableForNONPERISHABLE_ITEM: aTable
	aTable name: 'NONPERISHABLE_ITEM'.
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20).
	aTable createFieldNamed: 'SERIAL_NUMBER' type: platform int4.!

tableForOFFICE: aTable
	| empOfMonth |
	aTable name: 'OFFICE'.
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	empOfMonth := aTable createFieldNamed: 'EMPLOYEE_OF_MONTH' type: platform int4.
	"Cheat by removing this, because it makes a cycle that we can't really handle yet"
	"aTable addForeignKeyFrom: empOfMonth
		to: ((self tableNamed: 'EMPLOYEE') fieldNamed: 'ID')."!

tableForPERISHABLE_ITEM: aTable
	aTable name: 'PERISHABLE_ITEM'.
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20).
	aTable createFieldNamed: 'AGE' type: platform int4.!

tableForPOULTRY: aTable
	aTable name: 'POULTRY'.
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20).
	aTable createFieldNamed: 'AGE' type: platform int4.
	aTable createFieldNamed: 'FEATHER_COLOR' type: (platform varChar: 20).!

tableForTAX: aTable
	| superTaxId |
	(aTable createFieldNamed: 'ID' type: platform serial) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: platform text.
	aTable createFieldNamed: 'TYPE' type: (platform varchar: 16).
	superTaxId := aTable createFieldNamed: 'TAX_ID' type: platform int4.
	aTable addForeignKeyFrom: superTaxId to: ((self tableNamed: 'TAX') fieldNamed: 'ID').!

tableForUNASSEMBLED_ITEM: aTable

	aTable name: 'UNASSEMBLED_ITEM'.
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20).
	aTable createFieldNamed: 'SERIAL_NUMBER' type: platform int4.
	aTable createFieldNamed: 'ASSEM_COST' type: platform int4.!

tableForWAREHOUSE: aTable

	(aTable createFieldNamed: 'ID' type: platform serial) bePrimaryKey.
	aTable createFieldNamed: 'ADDRESS' type: (platform varChar: 50).
	aTable createFieldNamed: 'CURRENT_ITEM_ID' type: platform int4.!

tableForWAREHOUSE_ITEM_LINK: aTable

	| warehouseId |
	warehouseId := aTable createFieldNamed: 'WAREHOUSE_ID' type: platform int4.
	aTable addForeignKeyFrom: warehouseId to: ((self tableNamed: 'WAREHOUSE') fieldNamed: 'ID').
	aTable createFieldNamed: 'ITEM_ID' type: platform int4.!

tableForWORKING_STIFF: aTable
	aTable name: 'WORKING_STIFF'.
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20).!

typeResolverForGlorpInventoryItem
	^HorizontalTypeResolver forRootClass: GlorpInventoryItem.!

typeResolverForGlorpTaggableObject
   ^(HorizontalTypeResolver forRootClass: GlorpTaggableObject).! !
!GlorpInheritanceDescriptorSystem categoriesFor: #allTableNames!misc!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #classModelForGlorpImage:!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #classModelForGlorpTag:!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #classModelForGlorpTaggableObject:!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #classModelForGlorpWarehouse:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #constructAllClasses!misc!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpEmployee:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpImage:!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpInventoryItem:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpLineWorker:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpManager:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpNonperishableItem:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpOffice:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpPerishableItem:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpPoultry:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpRegionalManager:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpTag:!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpTaggableObject:!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpUnassembledItem:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpWarehouse:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #descriptorForGlorpWorkingStiff:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #polymorphicJoinToItemFromField:!descriptors/employees!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForEMPLOYEE:!private!tables! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForGLORP_IMAGE:!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForGLORP_TAG:!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForGLORP_TAGS:!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForIMAGETAGS:!private! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForNONPERISHABLE_ITEM:!private!tables! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForOFFICE:!private!tables! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForPERISHABLE_ITEM:!private!tables! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForPOULTRY:!private!tables! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForTAX:!private!tables! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForUNASSEMBLED_ITEM:!private!tables! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForWAREHOUSE:!private!tables! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForWAREHOUSE_ITEM_LINK:!private!tables! !
!GlorpInheritanceDescriptorSystem categoriesFor: #tableForWORKING_STIFF:!private!tables! !
!GlorpInheritanceDescriptorSystem categoriesFor: #typeResolverForGlorpInventoryItem!private!type resolvers! !
!GlorpInheritanceDescriptorSystem categoriesFor: #typeResolverForGlorpTaggableObject!private! !

GlorpLockingDescriptorSystem guid: (GUID fromString: '{11FBC83B-4678-42A1-9CA3-F2F07247F61F}')!
GlorpLockingDescriptorSystem comment: ''!
!GlorpLockingDescriptorSystem categoriesForClass!Unclassified! !
!GlorpLockingDescriptorSystem methodsFor!

allTableNames

	^#('BOOK' 'BOOK_CUSTOMER' 'CUSTOMER_BOOK_LINK').!

bookExample1
	^(GlorpBook new)
		title: 'Mastering ENVY/Developer';
		author: 'Knight/Pelrine/Cho';
		description:
				'Absolutely the best book written on ENVY/Developer by a set of authors all living on different continents';
		copiesInStock: 2000;
		version: 1.!

bookExample2
	^(GlorpBook new)
		title: 'The Bad Beginning';
		author: 'Lemony Snicket';
		description: 'Very fine description of the EJB standards process';
		copiesInStock: 3;
		version: 5.!

constructAllClasses
	^(super constructAllClasses) 
		add: GlorpBook;
		add: GlorpBookstoreCustomer;
		yourself.!

customerExample1
	^(GlorpBookstoreCustomer new)
		accountNumber: '123456789ABCDEF';
		name: 'Aunt Colof'.!

customerExample2
	^(GlorpBookstoreCustomer new)
		accountNumber: '7';
		name: 'Veronica Filbert Davidson'.!

descriptorForGlorpBook: aDescriptor

	| table |
	table := self tableNamed: 'BOOK'.
	aDescriptor table: table.
	aDescriptor addMapping: (	
		DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (	
		DirectMapping from: #title to: (table fieldNamed: 'TITLE')).
	aDescriptor addMapping: (	
		DirectMapping from: #copiesInStock to: (table fieldNamed: 'COPIES_IN_STOCK')).
	aDescriptor addMapping: (	
		DirectMapping from: #version to: (table fieldNamed: 'VERSION')).!

descriptorForGlorpBookstoreCustomer: aDescriptor

	| table |
	table := self tableNamed: 'BOOK_CUSTOMER'.
	aDescriptor table: table.
	aDescriptor addMapping: (	
		DirectMapping from: #accountNumber to: (table fieldNamed: 'ACCOUNT_NUMBER')).
	aDescriptor addMapping: (	
		DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	aDescriptor addMapping: (	
		ManyToManyMapping new
			attributeName: #booksOnOrder;
			referenceClass: GlorpBook).!

example1
	"Return an example start set of books, customers and orders."

	| cust1 cust2 book1 book2 |
	cust1 := self customerExample1.
	cust2 := self customerExample2.
	book1 := self bookExample1.
	book2 := self bookExample2.
	^Array
		with: book1
		with: book2
		with: cust1
		with: cust2.!

tableForBOOK: aTable

	(aTable createFieldNamed: 'ID' type: platform serial) bePrimaryKey.
	aTable createFieldNamed: 'TITLE' type: (platform varChar: 100).
	aTable createFieldNamed: 'DESCRIPTION' type: (platform varChar: 255).
	aTable createFieldNamed: 'COPIES_IN_STOCK' type: (platform int4).
	(aTable createFieldNamed: 'VERSION' type: (platform versionFieldFor: platform int4)) beLockKey.!

tableForBOOK_CUSTOMER: aTable

	(aTable createFieldNamed: 'ACCOUNT_NUMBER' type: (platform varChar: 15)) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 100).!

tableForCUSTOMER_BOOK_LINK: aTable

	| custKey bookKey |
	custKey := aTable createFieldNamed: 'CUSTOMER_ACCT_NUM' type: (platform varChar: 15).
	aTable addForeignKeyFrom: custKey
		to: ((self tableNamed: 'BOOK_CUSTOMER') fieldNamed: 'ACCOUNT_NUMBER').
	bookKey := aTable createFieldNamed: 'BOOK_ID' type: (platform int4).
		aTable addForeignKeyFrom: bookKey
		to: ((self tableNamed: 'BOOK') fieldNamed: 'ID').! !
!GlorpLockingDescriptorSystem categoriesFor: #allTableNames!other!private! !
!GlorpLockingDescriptorSystem categoriesFor: #bookExample1!examples!private! !
!GlorpLockingDescriptorSystem categoriesFor: #bookExample2!examples!private! !
!GlorpLockingDescriptorSystem categoriesFor: #constructAllClasses!other!private! !
!GlorpLockingDescriptorSystem categoriesFor: #customerExample1!examples!private! !
!GlorpLockingDescriptorSystem categoriesFor: #customerExample2!examples!private! !
!GlorpLockingDescriptorSystem categoriesFor: #descriptorForGlorpBook:!descriptors!private! !
!GlorpLockingDescriptorSystem categoriesFor: #descriptorForGlorpBookstoreCustomer:!descriptors!private! !
!GlorpLockingDescriptorSystem categoriesFor: #example1!examples!private! !
!GlorpLockingDescriptorSystem categoriesFor: #tableForBOOK:!private!tables! !
!GlorpLockingDescriptorSystem categoriesFor: #tableForBOOK_CUSTOMER:!private!tables! !
!GlorpLockingDescriptorSystem categoriesFor: #tableForCUSTOMER_BOOK_LINK:!private!tables! !

GlorpVariableTypeTestSystem guid: (GUID fromString: '{06AD90F6-BA38-494F-B0D2-62B32A49DE0E}')!
GlorpVariableTypeTestSystem comment: 'This is a system for testing variable relationships. That is, where we have a relationship that might be one type of object, or might be another, depending on some criteria. The objects are not related by inheritance. Our example is a relationship to images, where if the images are small we retrieve them directly, but if they are larger we only retrieve minimal information about them.3'!
!GlorpVariableTypeTestSystem categoriesForClass!Unclassified! !
!GlorpVariableTypeTestSystem methodsFor!

classModelForGlorpGallery: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name.
	aClassModel newAttributeNamed: #images collectionOf: GlorpImageFile.
	"Not a real attribute, but used in our conditional mapping."
	aClassModel newAttributeNamed: #imagesLink collectionOf: GlorpImageLink.!

classModelForGlorpImageFile: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #title.
	aClassModel newAttributeNamed: #bits type: ByteArray.
	(aClassModel newAttributeNamed: #thumbnailBits type: ByteArray) useDirectAccess: false.!

classModelForGlorpImageLink: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #title.
	aClassModel newAttributeNamed: #thumbnailBits type: ByteArray.
	aClassModel newAttributeNamed: #fullImage type: GlorpImageFile.!

descriptorForGlorpGallery: aDescriptor
	
	| table linkTable imagesConditional |
	table := self tableNamed: 'GALLERY'.
	linkTable := self tableNamed: 'GALLERY_LINK'.
	aDescriptor table: table.
	aDescriptor directMappingFor: #id.
	aDescriptor directMappingFor: #name.
	imagesConditional := (aDescriptor newMapping: ConditionalToManyMapping)
		attributeName: #images;
		join: Join new.
	imagesConditional
		forField: (linkTable fieldNamed: 'LARGE')
		attribute: [:object | object isLarge]
		if: [:x | x = true]
		useMapping:
			((imagesConditional newMapping: ToManyMapping)
				attributeName: #imagesLink;
				useLinkTable;
				join:
						(Join
								from: (table fieldNamed: 'ID')
								to: (linkTable fieldNamed: 'GALLERY_ID')
								from: 'T'
								to: (linkTable fieldNamed: 'LARGE'))).
	imagesConditional
		otherwise:
			((imagesConditional newMapping: ToManyMapping)
				attributeName: #images;
				useLinkTable;
				join:
						(Join
								from: (table fieldNamed: 'ID')
								to: (linkTable fieldNamed: 'GALLERY_ID')
								from: 'F'
								to: (linkTable fieldNamed: 'LARGE'))).!

descriptorForGlorpImageFile: aDescriptor
	
	aDescriptor table: 'GLORP_IMAGE_FILE'.
	aDescriptor directMappingFor: #id.
	aDescriptor directMappingFor: #title.
	aDescriptor directMappingFor: #bits.
	aDescriptor directMapping from: #thumbnailBits to: 'THUMBNAIL_BITS'.!

descriptorForGlorpImageLink: aDescriptor
	
	aDescriptor table: 'GLORP_IMAGE_FILE'.
	aDescriptor directMappingFor: #id.
	aDescriptor directMappingFor: #title.
	aDescriptor directMapping from: #thumbnailBits to: 'THUMBNAIL_BITS'.
	"This is really joining to our own table to get the full version of ourselves"
	aDescriptor oneToOneMapping 
		attributeName: #fullImage;
		join: (Join from: (aDescriptor table fieldNamed: 'ID') to: (aDescriptor table fieldNamed: 'ID')).!

tableForGALLERY: aTable
	aTable createFieldNamed: 'ID' type: platform serial.
	aTable createFieldNamed: 'NAME' type: platform text.!

tableForGALLERY_LINK: aTable
	| galleryId imageId |
	galleryId := aTable createFieldNamed: 'GALLERY_ID' type: platform integer.
	aTable addForeignKeyFrom: galleryId to: ((self tableNamed: 'GALLERY') fieldNamed: 'ID').
	imageId := aTable createFieldNamed: 'IMAGE_ID' type: platform integer.
	aTable addForeignKeyFrom: imageId to: ((self tableNamed: 'GLORP_IMAGE_FILE') fieldNamed: 'ID').
	"Avoid booleans here because they aren't portable"
	aTable createFieldNamed: 'LARGE' type: (platform char: 1).!

tableForGLORP_IMAGE_FILE: aTable
	aTable createFieldNamed: 'ID' type: platform serial.
	aTable createFieldNamed: 'TITLE' type: platform text.
	aTable createFieldNamed: 'BITS' type: platform blob.
	aTable createFieldNamed: 'THUMBNAIL_BITS' type: platform blob.! !
!GlorpVariableTypeTestSystem categoriesFor: #classModelForGlorpGallery:!classes!private! !
!GlorpVariableTypeTestSystem categoriesFor: #classModelForGlorpImageFile:!classes!private! !
!GlorpVariableTypeTestSystem categoriesFor: #classModelForGlorpImageLink:!classes!private! !
!GlorpVariableTypeTestSystem categoriesFor: #descriptorForGlorpGallery:!classes!private! !
!GlorpVariableTypeTestSystem categoriesFor: #descriptorForGlorpImageFile:!classes!private! !
!GlorpVariableTypeTestSystem categoriesFor: #descriptorForGlorpImageLink:!classes!private! !
!GlorpVariableTypeTestSystem categoriesFor: #tableForGALLERY:!classes!private! !
!GlorpVariableTypeTestSystem categoriesFor: #tableForGALLERY_LINK:!classes!private! !
!GlorpVariableTypeTestSystem categoriesFor: #tableForGLORP_IMAGE_FILE:!classes!private! !

GlorpVideoDescriptorSystem guid: (GUID fromString: '{818E3ECE-BA65-4A7F-9B9A-48362C9205BE}')!
GlorpVideoDescriptorSystem comment: 'This descriptor system represents a video rental/sales store which sells both online and in a physical store. The interesting bit is that there is no customer table, but there is a customer object. In the database, orders and credit status are linked directly to the store. We synthesize a customer object out of those relationships.'!
!GlorpVideoDescriptorSystem categoriesForClass!Unclassified! !
!GlorpVideoDescriptorSystem methodsFor!

allTableNames
	^#('VIDEO_STORE' 'VIDEO_PURCHASE' 'VIDEO_RENTAL' 'VIDEO_PURCHASE_LINK' 'VIDEO_CUSTOMER' 'VIDEO_CREDIT_STATUS').!

classModelForGlorpVideoCreditStatus: aClassModel
	aClassModel newAttributeNamed: #customer type: GlorpVideoCustomer.
	aClassModel newAttributeNamed: #store type: GlorpVideoStore.
	aClassModel newAttributeNamed: #balanceOwing type: Number.
	aClassModel newAttributeNamed: #dateOwing type: Date.
	aClassModel newAttributeNamed: #comments type: String.!

classModelForGlorpVideoCustomer: aClassModel
	aClassModel newAttributeNamed: #name type: String.
	aClassModel newAttributeNamed: #dateOfBirth type: Date.
	aClassModel newAttributeNamed: #onlinePurchases collectionOf: GlorpVideoPurchase.
	aClassModel newAttributeNamed: #inStorePurchases collectionOf: GlorpVideoPurchase.
	aClassModel newAttributeNamed: #inStoreRentals collectionOf: GlorpVideoRental.	
	aClassModel newAttributeNamed: #store type: GlorpVideoStore.
	aClassModel newAttributeNamed: #creditStatus type: GlorpVideoCreditStatus.!

classModelForGlorpVideoPurchase: aClassModel
	aClassModel newAttributeNamed: #id type: Integer.
	aClassModel newAttributeNamed: #title type: String.
	aClassModel newAttributeNamed: #price type: Number.
	aClassModel newAttributeNamed: #inStore type: Boolean.
	aClassModel newAttributeNamed: #customer type: GlorpVideoCustomer.	
	aClassModel newAttributeNamed: #store type: GlorpVideoStore.!

classModelForGlorpVideoRental: aClassModel
	aClassModel newAttributeNamed: #id type: Integer.
	aClassModel newAttributeNamed: #title type: String.
	aClassModel newAttributeNamed: #price type: Number.
	aClassModel newAttributeNamed: #dueDate type: Date.
	aClassModel newAttributeNamed: #customer type: GlorpVideoCustomer.
	aClassModel newAttributeNamed: #store type: GlorpVideoStore.!

classModelForGlorpVideoStore: aClassModel
	aClassModel newAttributeNamed: #name type: String.
	aClassModel newAttributeNamed: #purchases collectionOf: GlorpVideoPurchase.
	aClassModel newAttributeNamed: #customers collectionOf: GlorpVideoCustomer.!

constructAllClasses
	^(super constructAllClasses)
		add: GlorpVideoStore;
		add: GlorpVideoCreditStatus;
		add: GlorpVideoCustomer;
		add: GlorpVideoPurchase;
		add: GlorpVideoRental;
		yourself!

descriptorForGlorpVideoCreditStatus: aDescriptor

	| table |
	table := self tableNamed: 'VIDEO_CREDIT_STATUS'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #balanceOwing to: (table fieldNamed: 'BALANCE').
	(aDescriptor newMapping: DirectMapping) from: #dateOwing to: (table fieldNamed: 'DATE_OWING').
	(aDescriptor newMapping: DirectMapping) from: #comments to: (table fieldNamed: 'COMMENTS').

	(aDescriptor newMapping: OneToOneMapping)
			attributeName: #customer.!

descriptorForGlorpVideoCustomer: aDescriptor

	| table linkTable purchaseTable |
	table := self tableNamed: 'VIDEO_CUSTOMER'.
	linkTable := self tableNamed: 'VIDEO_PURCHASE_LINK'.
	purchaseTable := self tableNamed: 'VIDEO_PURCHASE'.

	aDescriptor table: table.

	(aDescriptor newMapping: DirectMapping) from: #name to: (table fieldNamed: 'CUSTOMERNAME').
	(aDescriptor newMapping: DirectMapping) from: #dateOfBirth to: (table fieldNamed: 'BIRTHDATE').

	(aDescriptor newMapping: OneToOneMapping)
			attributeName: #store.
	(aDescriptor newMapping: OneToOneMapping)
			attributeName: #creditStatus.
	(aDescriptor newMapping: ToManyMapping)
		attributeName: #inStoreRentals.
	(aDescriptor newMapping: ToManyMapping)
		useLinkTable;
		attributeName: #inStorePurchases;
		linkTableJoin: (Join 
			from: (table fieldNamed: 'STORE_ID')
			to: (linkTable fieldNamed: 'STORE_ID'));
		targetTableJoin: (Join
			from: (table fieldNamed: 'CUSTOMERNAME')
			to: (purchaseTable fieldNamed: 'CUSTOMERNAME')
			from: (table fieldNamed: 'BIRTHDATE')
			to: (purchaseTable fieldNamed: 'CUSTOMERBIRTHDATE')
			from: 'T'
			to: (purchaseTable fieldNamed: 'IN_STORE'));
			constructRowMapKeyAs: [:customer :purchase | 
					MultipleRowMapKey with: customer with: purchase with: customer videoStore yourSelf].

	(aDescriptor newMapping: ToManyMapping)
		useLinkTable;
		attributeName: #onlinePurchases;
		linkTableJoin: (Join 
			from: (table fieldNamed: 'STORE_ID')
			to: (linkTable fieldNamed: 'STORE_ID'));
		targetTableJoin: (Join 	
			from: (table fieldNamed: 'CUSTOMERNAME')
			to: (purchaseTable fieldNamed: 'CUSTOMERNAME')
			from: (table fieldNamed: 'BIRTHDATE')
			to: (purchaseTable fieldNamed: 'CUSTOMERBIRTHDATE')
			from: 'F'
			to: (purchaseTable fieldNamed: 'IN_STORE'));
			constructRowMapKeyAs: [:customer :purchase | 
					MultipleRowMapKey with: customer with: purchase with: customer videoStore yourSelf].

	"A complicated way of saying that the Store plus one other attribute has to be there"
	aDescriptor imaginaryTableIsDefinedByRelationFrom: #store to: #inStorePurchases.
	aDescriptor imaginaryTableIsDefinedByRelationFrom: #store to: #inStoreRentals.
	aDescriptor imaginaryTableIsDefinedByRelationFrom: #store to: #onlinePurchases.
	aDescriptor imaginaryTableIsDefinedByRelationFrom: #store to: #creditStatus.
	aDescriptor buildReplacementTableSelect.!

descriptorForGlorpVideoPurchase: aDescriptor

	| table |
	table := self tableNamed: 'VIDEO_PURCHASE'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #title to: (table fieldNamed: 'TITLE').
	(aDescriptor newMapping: DirectMapping) from: #price to: (table fieldNamed: 'PRICE').
	(aDescriptor newMapping: DirectMapping) from: #inStore to: (table fieldNamed: 'IN_STORE').

	(aDescriptor newMapping: OneToOneMapping)
			useLinkTable;
			attributeName: #store;
			constructRowMapKeyAs: [:purchase :store | 
					MultipleRowMapKey with: purchase with: store with: purchase customer yourSelf].

	(aDescriptor newMapping: OneToOneMapping)
		attributeName: #customer.!

descriptorForGlorpVideoRental: aDescriptor

	| table |
	table := self tableNamed: 'VIDEO_RENTAL'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #title to: (table fieldNamed: 'TITLE').
	(aDescriptor newMapping: DirectMapping) from: #dueDate to: (table fieldNamed: 'DUE_DATE').
	(aDescriptor newMapping: DirectMapping) from: #price to: (table fieldNamed: 'PRICE').
	(aDescriptor newMapping: DirectMapping) fromPseudoVariable: #customerName to: (table fieldNamed: 'CUSTOMERNAME').

	(aDescriptor newMapping: OneToOneMapping)
		attributeName: #customer.
	(aDescriptor newMapping: OneToOneMapping)
			attributeName: #store.!

descriptorForGlorpVideoStore: aDescriptor

	| table |
	table := self tableNamed: 'VIDEO_STORE'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #name to: (table fieldNamed: 'NAME').
	(aDescriptor newMapping: ToManyMapping)
			attributeName: #customers;
			join: (Join
				from: (table fieldNamed: 'ID')
				to: ((self tableNamed: 'VIDEO_CUSTOMER') fieldNamed: 'STORE_ID')).
	"The relationship to purchases is different from the one in customer, which distinguishes online from inStore"
	(aDescriptor newMapping: ToManyMapping)
		useLinkTable;
		attributeName: #purchases;
		constructRowMapKeyAs: [:store :purchase | 
					MultipleRowMapKey with: store with: purchase with: purchase customer yourSelf].
	"No relationship to rentals at all"!

exampleCreditStatus1
	| example |
	example := GlorpVideoCreditStatus new.	
	example balanceOwing: 12.00.
	example dateOwing: (Date today addDays: -1).
	example comments: 'One'.
	^example.!

exampleCreditStatus2
	| example |
	example := GlorpVideoCreditStatus new.	
	example balanceOwing: 22.00.
	example dateOwing: (Date today addDays: -1).
	example comments: 'Two'.
	^example.!

exampleCreditStatus3
	| example |
	example := GlorpVideoCreditStatus new.	
	example balanceOwing: 33.00.
	example dateOwing: (Date today addDays: -1).
	example comments: 'Three'.
	^example.!

exampleCustomer1
	"A customer with only online purchases"
	| customer |
	customer := GlorpVideoCustomer new.
	customer name: 'Adrian'.
	customer dateOfBirth: (Date today subtractDays: (10 * 365)).
	customer addOnlinePurchase: self exampleOnlinePurchase1.
	customer addOnlinePurchase: self exampleOnlinePurchase2.
	^customer.!

exampleCustomer2
	"A customer with only inStore purchases"
	| customer |
	customer := GlorpVideoCustomer new.
	customer name: 'Bob'.
	customer dateOfBirth: (Date today subtractDays: (20 * 365)).
	customer addInStorePurchase: self exampleInStorePurchase1.
	^customer.!

exampleCustomer3
	"A customer with only rentals"
	| customer |
	customer := GlorpVideoCustomer new.
	customer name: 'Carol'.
	customer dateOfBirth: (Date today subtractDays: (30 * 365)).
	customer addRental: self exampleInStoreRental1.
	^customer.!

exampleCustomer4
	"A customer with only credit"
	| customer |
	customer := GlorpVideoCustomer new.
	customer name: 'David'.
	customer dateOfBirth: (Date today subtractDays: (40 * 365)).
	customer creditStatus: self exampleCreditStatus1.
	^customer.!

exampleCustomer5
	"A customer with purchases and rentals"

	| customer |
	customer := GlorpVideoCustomer new.
	customer name: 'Eleanor'.
	customer dateOfBirth: (Date today subtractDays: 50 * 365).
	customer addInStorePurchase: self exampleInStorePurchase2.
	customer addInStorePurchase: self exampleInStorePurchase3.
	customer addRental: self exampleInStoreRental2.
	^customer.!

exampleCustomer6
	"A customer with purchases and credit"

	| customer |
	customer := GlorpVideoCustomer new.
	customer name: 'Francois'.
	customer dateOfBirth: (Date today subtractDays: 60 * 365).
	customer addInStorePurchase: self exampleInStorePurchase4.
	customer addInStorePurchase: self exampleInStorePurchase5.
	customer creditStatus: self exampleCreditStatus2.
	^customer.!

exampleCustomer7
	"A customer with everything"

	| customer |
	customer := GlorpVideoCustomer new.
	customer name: 'George'.
	customer dateOfBirth: (Date today subtractDays: 70 * 365).
	customer addInStorePurchase: self exampleInStorePurchase6.
	customer addOnlinePurchase: self exampleOnlinePurchase3.
	customer addRental: self exampleInStoreRental3.
	customer addRental: self exampleInStoreRental4.
	customer creditStatus: self exampleCreditStatus3.
	^customer.!

exampleCustomer8
	"A customer with just a single purchase"

	| customer |
	customer := GlorpVideoCustomer new.
	customer name: 'Hieronymous'.
	customer dateOfBirth: (Date today subtractDays: 80 * 365).
	customer addInStorePurchase: self exampleInStorePurchase7.
	^customer.!

exampleInStorePurchase1
	| purchase |
	purchase := GlorpVideoPurchase new.
	purchase id: 101.
	purchase title: 'An American in Paris'.
	purchase price: 1.00.
	purchase inStore: true.
	^purchase.!

exampleInStorePurchase2
	| purchase |
	purchase := GlorpVideoPurchase new.
	purchase id: 102.
	purchase title: 'Brazil'.
	purchase price: 2.00.
	purchase inStore: true.
	^purchase.!

exampleInStorePurchase3
	| purchase |
	purchase := GlorpVideoPurchase new.
	purchase id: 103.
	purchase title: 'Cambodia, Swimming To'.
	purchase price: 3.00.
	purchase inStore: true.
	^purchase.!

exampleInStorePurchase4
	| purchase |
	purchase := GlorpVideoPurchase new.
	purchase id: 104.
	purchase title: 'Dogma'.
	purchase price: 4.00.
	purchase inStore: true.
	^purchase.!

exampleInStorePurchase5
	| purchase |
	purchase := GlorpVideoPurchase new.
	purchase id: 105.
	purchase title: 'ET'.
	purchase price: 5.00.
	purchase inStore: true.
	^purchase.!

exampleInStorePurchase6
	| purchase |
	purchase := GlorpVideoPurchase new.
	purchase id: 106.
	purchase title: 'Fargo'.
	purchase price: 6.00.
	purchase inStore: true.
	^purchase.!

exampleInStorePurchase7
	| purchase |
	purchase := GlorpVideoPurchase new.
	purchase id: 107.
	purchase title: 'Glengarry GlenRoss'.
	purchase price: 7.00.
	purchase inStore: true.
	^purchase.!

exampleInStoreRental1
	| rental |
	rental := GlorpVideoRental new.
	rental id: 1001.
	rental title: 'Amelie'.
	rental price: 21.00.
	rental dueDate: Date today.
	^rental.!

exampleInStoreRental2
	| rental |
	rental := GlorpVideoRental new.
	rental id: 1002.
	rental title: 'Best in Show'.
	rental price: 22.00.
	rental dueDate: Date today.
	^rental.!

exampleInStoreRental3
	| rental |
	rental := GlorpVideoRental new.
	rental id: 1003.
	rental title: 'Charlie Brown Christmas'.
	rental price: 23.00.
	rental dueDate: Date today.
	^rental.!

exampleInStoreRental4
	| rental |
	rental := GlorpVideoRental new.
	rental id: 1004.
	rental title: 'Down By Law'.
	rental price: 24.00.
	rental dueDate: Date today.
	^rental.!

exampleOnlinePurchase1
	| purchase |
	purchase := GlorpVideoPurchase new.
	purchase id: 1.
	purchase title: 'All About Eve'.
	purchase price: 1.11.
	purchase inStore: false.
	^purchase.!

exampleOnlinePurchase2
	| purchase |
	purchase := GlorpVideoPurchase new.
	purchase id: 2.
	purchase title: 'Butch Cassidy and the Sundance Kid'.
	purchase price: 2.22.
	purchase inStore: false.
	^purchase.!

exampleOnlinePurchase3
	| purchase |
	purchase := GlorpVideoPurchase new.
	purchase id: 3.
	purchase title: 'Cabaret'.
	purchase price: 3.33.
	purchase inStore: false.
	^purchase.!

exampleStore1
	"self new exampleStore1"
	| example |
	example := GlorpVideoStore new.
	example name: 'Als Video'.
	example id: 1.
	example customers: (Array with: self exampleCustomer1 with: self exampleCustomer2 with: self exampleCustomer3 with: self exampleCustomer4), (Array with: self exampleCustomer5 with: self exampleCustomer6 with: self exampleCustomer7).
	example computeCollections.
	^example.!

exampleStore2
	"self new exampleStore2"
	| example |
	example := GlorpVideoStore new.
	example name: 'Bonzai Video'.
	example id: 2.
	example customers: (Array with: self exampleCustomer8).
	example computeCollections.
	^example.!

tableForVIDEO_CREDIT_STATUS: aTable
	| customerTable custName custDate storeId |
	customerTable := self tableNamed: 'VIDEO_CUSTOMER'.
	custName := (aTable createFieldNamed: 'CUSTOMERNAME' type: (platform varchar: 50))
		bePrimaryKey.
	custDate := (aTable createFieldNamed: 'CUSTOMERBIRTHDATE' type: platform date) bePrimaryKey.
	storeId := (aTable createFieldNamed: 'STORE_ID' type: platform int4) bePrimaryKey.
	aTable addForeignKeyFrom: custName
		to: (customerTable fieldNamed: 'CUSTOMERNAME')
		from: custDate
		to: (customerTable fieldNamed: 'BIRTHDATE')
		from: storeId
		to: (customerTable fieldNamed: 'STORE_ID') .
	aTable addForeignKeyFrom: storeId to: ((self tableNamed: 'VIDEO_STORE') fieldNamed: 'ID').

	aTable createFieldNamed: 'BALANCE' type: (platform double).
	aTable createFieldNamed: 'DATE_OWING' type: platform date.
	aTable createFieldNamed: 'COMMENTS' type: (platform varchar: 50).!

tableForVIDEO_CUSTOMER: aTable
	"Note: This table is imaginary"
	| storeId |
	aTable isImaginary: true.
	(aTable createFieldNamed: 'CUSTOMERNAME' type: (platform varchar: 50))
		bePrimaryKey.
	(aTable createFieldNamed: 'BIRTHDATE' type: platform date) bePrimaryKey.
	storeId := (aTable createFieldNamed: 'STORE_ID' type: (platform int4)) bePrimaryKey.
	aTable addForeignKeyFrom: storeId
		to: ((self tableNamed: 'VIDEO_STORE') fieldNamed: 'ID')!

tableForVIDEO_PURCHASE: aTable
	| custName custDate customerTable |
	(aTable createFieldNamed: 'ID' type: (platform int4)) bePrimaryKey.
	customerTable := self tableNamed: 'VIDEO_CUSTOMER'.
	custName := aTable createFieldNamed: 'CUSTOMERNAME' type: (platform varchar: 50).
	custDate := aTable createFieldNamed: 'CUSTOMERBIRTHDATE' type: platform date.
	aTable addForeignKeyFrom: custName
		to: (customerTable fieldNamed: 'CUSTOMERNAME')
		from: custDate
		to: (customerTable fieldNamed: 'BIRTHDATE').

	aTable createFieldNamed: 'TITLE' type: (platform varchar: 50).	
	aTable createFieldNamed: 'PRICE' type: (platform double).
	aTable createFieldNamed: 'IN_STORE' type: (platform char: 1).!

tableForVIDEO_PURCHASE_LINK: aTable
	| storeId purchaseId |
	purchaseId := aTable createFieldNamed: 'PURCHASE_ID' type: platform int4.
	storeId := aTable createFieldNamed: 'STORE_ID' type: (platform int4).
	aTable addForeignKeyFrom: storeId
		to: ((self tableNamed: 'VIDEO_STORE') fieldNamed: 'ID').
	aTable addForeignKeyFrom: purchaseId
		to: ((self tableNamed: 'VIDEO_PURCHASE') fieldNamed: 'ID').!

tableForVIDEO_RENTAL: aTable
	| custName custDate storeId customerTable |
	(aTable createFieldNamed: 'ID' type: (platform int4)) bePrimaryKey.
	customerTable := self tableNamed: 'VIDEO_CUSTOMER'.
	custName := aTable createFieldNamed: 'CUSTOMERNAME' type: (platform varchar: 50).
	custDate := aTable createFieldNamed: 'CUSTOMERBIRTHDATE' type: platform date.
	storeId := aTable createFieldNamed: 'STORE_ID' type: (platform int4).
	aTable addForeignKeyFrom: custName
		to: (customerTable fieldNamed: 'CUSTOMERNAME')
		from: custDate
		to: (customerTable fieldNamed: 'BIRTHDATE')
		from: storeId
		to: (customerTable fieldNamed: 'STORE_ID').
	aTable addForeignKeyFrom: storeId to: ((self tableNamed: 'VIDEO_STORE') fieldNamed: 'ID').

	aTable createFieldNamed: 'TITLE' type: (platform varchar: 50).	
	aTable createFieldNamed: 'DUE_DATE' type: platform date.
	aTable createFieldNamed: 'PRICE' type: (platform double).!

tableForVIDEO_STORE: aTable
	(aTable createFieldNamed: 'ID' type: (platform int4)) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varchar: 20).! !
!GlorpVideoDescriptorSystem categoriesFor: #allTableNames!accessing!private! !
!GlorpVideoDescriptorSystem categoriesFor: #classModelForGlorpVideoCreditStatus:!class models!private! !
!GlorpVideoDescriptorSystem categoriesFor: #classModelForGlorpVideoCustomer:!class models!private! !
!GlorpVideoDescriptorSystem categoriesFor: #classModelForGlorpVideoPurchase:!class models!private! !
!GlorpVideoDescriptorSystem categoriesFor: #classModelForGlorpVideoRental:!class models!private! !
!GlorpVideoDescriptorSystem categoriesFor: #classModelForGlorpVideoStore:!class models!private! !
!GlorpVideoDescriptorSystem categoriesFor: #constructAllClasses!accessing!private! !
!GlorpVideoDescriptorSystem categoriesFor: #descriptorForGlorpVideoCreditStatus:!descriptors!private! !
!GlorpVideoDescriptorSystem categoriesFor: #descriptorForGlorpVideoCustomer:!descriptors!public! !
!GlorpVideoDescriptorSystem categoriesFor: #descriptorForGlorpVideoPurchase:!descriptors!public! !
!GlorpVideoDescriptorSystem categoriesFor: #descriptorForGlorpVideoRental:!descriptors!private! !
!GlorpVideoDescriptorSystem categoriesFor: #descriptorForGlorpVideoStore:!descriptors!public! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleCreditStatus1!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleCreditStatus2!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleCreditStatus3!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleCustomer1!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleCustomer2!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleCustomer3!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleCustomer4!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleCustomer5!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleCustomer6!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleCustomer7!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleCustomer8!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleInStorePurchase1!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleInStorePurchase2!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleInStorePurchase3!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleInStorePurchase4!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleInStorePurchase5!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleInStorePurchase6!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleInStorePurchase7!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleInStoreRental1!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleInStoreRental2!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleInStoreRental3!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleInStoreRental4!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleOnlinePurchase1!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleOnlinePurchase2!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleOnlinePurchase3!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleStore1!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #exampleStore2!examples!private! !
!GlorpVideoDescriptorSystem categoriesFor: #tableForVIDEO_CREDIT_STATUS:!private!tables! !
!GlorpVideoDescriptorSystem categoriesFor: #tableForVIDEO_CUSTOMER:!private!tables! !
!GlorpVideoDescriptorSystem categoriesFor: #tableForVIDEO_PURCHASE:!private!tables! !
!GlorpVideoDescriptorSystem categoriesFor: #tableForVIDEO_PURCHASE_LINK:!private!tables! !
!GlorpVideoDescriptorSystem categoriesFor: #tableForVIDEO_RENTAL:!private!tables! !
!GlorpVideoDescriptorSystem categoriesFor: #tableForVIDEO_STORE:!private!tables! !

GlorpWorkerDescriptorSystem guid: (GUID fromString: '{3B6350A4-C8B0-4E45-B286-0D4734010006}')!
GlorpWorkerDescriptorSystem comment: ''!
!GlorpWorkerDescriptorSystem categoriesForClass!Unclassified! !
!GlorpWorkerDescriptorSystem methodsFor!

allTableNames

	^#('GLORP_WORKER' 'GLORP_JOB' 'GLORP_WORKER_JOB_LINK').!

constructAllClasses
	^(super constructAllClasses)
		add: GlorpJob;
		add: GlorpWorker;
		yourself!

descriptorForGlorpJob: aDescriptor 
	"Note that the job table contains a FINISHED field, but the GlorpJob object doesn't. This field is determined only by membership in the finished or pending collections. In this particular case it's not very useful from a domain perspective, but it's interesting to be able to map. Similarly, whether a job is priority or not is not in the domain object, and is stored in the link table defining the relationship"

	| table |
	table := self tableNamed: 'GLORP_JOB'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id
				to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #description
				to: (table fieldNamed: 'DESCRIPTION')).!

descriptorForGlorpWorker: aDescriptor 
	| table linkTable |
	table := self tableNamed: 'GLORP_WORKER'.
	aDescriptor table: table.
	aDescriptor 
		addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor 
		addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	aDescriptor addMapping: ((OneToManyMapping new)
				attributeName: #pendingJobs;
				referenceClass: GlorpJob;
				join: (self workerCriteriaWithConstant: 'N' in: table)).
	aDescriptor addMapping: ((OneToManyMapping new)
				attributeName: #finishedJobs;
				referenceClass: GlorpJob;
				join: (self workerCriteriaWithConstant: 'Y' in: table)).
	linkTable := self tableNamed: 'GLORP_WORKER_JOB_LINK'.

	"Note that priorityJobs may include finished jobs as well, and instances may occur in both this collection and the other two"
	aDescriptor addMapping: ((ManyToManyMapping new)
				attributeName: #priorityJobs;
				referenceClass: GlorpJob;
				join: (Join 
							from: (table fieldNamed: 'ID')
							to: (linkTable fieldNamed: 'WORKER_ID')
							from: 'Y'
							to: (linkTable fieldNamed: 'PRIORITY'))).!

exampleJobRow: anInteger finished: aBoolean

	| table row |
	table := self tableNamed: 'GLORP_JOB'.
	row := DatabaseRow newForTable: table.
	row at: (table fieldNamed: 'ID') put: anInteger.
	row at: (table fieldNamed: 'DESCRIPTION') put: 'Job ', anInteger printString.
	row at: (table fieldNamed: 'FINISHED') put: (aBoolean ifTrue: ['Y'] ifFalse: ['N']).
	row at: (table fieldNamed: 'OWNER_ID') put: 1234.

	^row.!

exampleLinkRow1

	| table row |
	table := self tableNamed: 'GLORP_WORKER_JOB_LINK'.
	row := DatabaseRow newForTable: table.
	row at: (table fieldNamed: 'WORKER_ID') put: 1234.
	row at: (table fieldNamed: 'JOB_ID') put: 2.
	row at: (table fieldNamed: 'PRIORITY') put: 'N'.
	^row.!

exampleLinkRow2

	| table row |
	table := self tableNamed: 'GLORP_WORKER_JOB_LINK'.
	row := DatabaseRow newForTable: table.
	row at: (table fieldNamed: 'WORKER_ID') put: 1234.
	row at: (table fieldNamed: 'JOB_ID') put: 3.
	row at: (table fieldNamed: 'PRIORITY') put: 'Y'.
	^row.!

exampleWorkerRow

	| table row |
	table := self tableNamed: 'GLORP_WORKER'.
	row := DatabaseRow newForTable: table.
	row at: (table fieldNamed: 'ID') put: 1234.
	row at: (table fieldNamed: 'NAME') put: 'John Worker'.
	^row.!

tableForGLORP_JOB: aTable

	| ownerId |
	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'DESCRIPTION' type: (platform varChar: 40).
	aTable createFieldNamed: 'FINISHED' type: (platform varChar: 1).
	ownerId := aTable createFieldNamed: 'OWNER_ID' type: platform int4.
	aTable addForeignKeyFrom: ownerId
		to: ((self tableNamed: 'GLORP_WORKER') fieldNamed: 'ID').!

tableForGLORP_WORKER: aTable

	(aTable createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	aTable createFieldNamed: 'NAME' type: (platform varChar: 20).!

tableForGLORP_WORKER_JOB_LINK: aTable

	| workerId jobId |
	workerId := aTable createFieldNamed: 'WORKER_ID' type: platform int4.
	aTable addForeignKeyFrom: workerId
		to: ((self tableNamed: 'GLORP_WORKER') fieldNamed: 'ID').
	jobId := aTable createFieldNamed: 'JOB_ID' type: platform int4.
	aTable addForeignKeyFrom: jobId
		to: ((self tableNamed: 'GLORP_JOB') fieldNamed: 'ID').
	aTable createFieldNamed: 'PRIORITY' type: (platform varChar: 1).!

workerCriteriaWithConstant: aString in: table 
	^Join 
		from: (table fieldNamed: 'ID')
		to: ((self tableNamed: 'GLORP_JOB') fieldNamed: 'OWNER_ID')
		from: aString
		to: ((self tableNamed: 'GLORP_JOB') fieldNamed: 'FINISHED').! !
!GlorpWorkerDescriptorSystem categoriesFor: #allTableNames!other!private! !
!GlorpWorkerDescriptorSystem categoriesFor: #constructAllClasses!other!private! !
!GlorpWorkerDescriptorSystem categoriesFor: #descriptorForGlorpJob:!descriptors!private! !
!GlorpWorkerDescriptorSystem categoriesFor: #descriptorForGlorpWorker:!descriptors!private! !
!GlorpWorkerDescriptorSystem categoriesFor: #exampleJobRow:finished:!examples!private! !
!GlorpWorkerDescriptorSystem categoriesFor: #exampleLinkRow1!examples!private! !
!GlorpWorkerDescriptorSystem categoriesFor: #exampleLinkRow2!examples!private! !
!GlorpWorkerDescriptorSystem categoriesFor: #exampleWorkerRow!examples!private! !
!GlorpWorkerDescriptorSystem categoriesFor: #tableForGLORP_JOB:!private!tables! !
!GlorpWorkerDescriptorSystem categoriesFor: #tableForGLORP_WORKER:!private!tables! !
!GlorpWorkerDescriptorSystem categoriesFor: #tableForGLORP_WORKER_JOB_LINK:!private!tables! !
!GlorpWorkerDescriptorSystem categoriesFor: #workerCriteriaWithConstant:in:!descriptors!private! !

GlorpLinkTableAnywhereDescriptorSystem guid: (GUID fromString: '{D64F2C90-0D74-4B9D-B170-C83828B0862E}')!
GlorpLinkTableAnywhereDescriptorSystem comment: 'This is the same as the demo descriptor system, but with small modifications to use link tables in different places.

'!
!GlorpLinkTableAnywhereDescriptorSystem categoriesForClass!Unclassified! !
!GlorpLinkTableAnywhereDescriptorSystem methodsFor!

classModelForGlorpCustomer: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name.
	aClassModel newAttributeNamed: #transactions collectionOf: GlorpBankTransaction.
	"Note: accounts is a 1-1 in this model"
	aClassModel newAttributeNamed: #accounts type: GlorpBankAccount.
	aClassModel newAttributeNamed: #accountsSortedById collectionOf: GlorpBankAccount.
	aClassModel newAttributeNamed: #accountsSortedByIdDescending collectionOf: GlorpBankAccount.!

descriptorForGlorpCustomer: aDescriptor

	| table |
	table := self tableNamed: 'GR_CUSTOMER'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #name to: (table fieldNamed: 'NAME').
	(aDescriptor newMapping: OneToManyMapping)
			attributeName: #transactions;
			referenceClass: GlorpBankTransaction.
	(aDescriptor newMapping: OneToOneMapping)
			attributeName: #accounts;
			referenceClass: GlorpBankAccount;
			usesLinkTable: true.! !
!GlorpLinkTableAnywhereDescriptorSystem categoriesFor: #classModelForGlorpCustomer:!descriptors/bank!private! !
!GlorpLinkTableAnywhereDescriptorSystem categoriesFor: #descriptorForGlorpCustomer:!descriptors/bank!private! !

GlorpBankExampleSystem guid: (GUID fromString: '{804A2E7B-5B56-4E41-827C-9B643D89C18D}')!
GlorpBankExampleSystem comment: ''!
!GlorpBankExampleSystem categoriesForClass!Unclassified! !
!GlorpBankExampleSystem methodsFor!

exampleGlorpAddressNumber1: anAddress
	anAddress id: 12.
	anAddress street: 'Paseo Montril'.
	anAddress number: '10185'.!

exampleGlorpBankAccountNumber1: anAccount

	anAccount id: 1.
	anAccount accountNumber: (self objectNumber: 1 ofClass: GlorpBankAccountNumber).!

exampleGlorpBankAccountNumber2: anAccount

	anAccount id: 2.
	anAccount accountNumber: (self objectNumber: 2 ofClass: GlorpBankAccountNumber).!

exampleGlorpBankAccountNumberNumber1: aBankAccountNumber

	aBankAccountNumber bankCode: '004'.
	aBankAccountNumber branchNumber: 0342.
	aBankAccountNumber accountNumber: '12345'.!

exampleGlorpBankAccountNumberNumber2: aBankAccountNumber

	aBankAccountNumber bankCode: '004'.
	aBankAccountNumber branchNumber: 0342.
	aBankAccountNumber accountNumber: '01010'.!

exampleGlorpBankTransactionNumber1: aTrans

	"Nothing to initialize"!

exampleGlorpBankTransactionNumber2: aTrans

	"Nothing to initialize"!

exampleGlorpCustomerNumber1: aCustomer

	aCustomer id: 1.
	aCustomer name: 'Fred Flintstone'.
	aCustomer addTransaction: (self objectNumber: 1 ofClass: GlorpBankTransaction).
	aCustomer addTransaction: (self objectNumber: 2 ofClass: GlorpBankTransaction).
	aCustomer addAccount: (self objectNumber: 1 ofClass: GlorpBankAccount).
	aCustomer addAccount: (self objectNumber: 2 ofClass: GlorpBankAccount).!

exampleGlorpEmailAddressNumber1: anEmailAddress 
	anEmailAddress id: 2.
	anEmailAddress user: 'foo'.
	anEmailAddress host: 'bar.com'!

exampleGlorpPersonNumber1: aPerson 
	aPerson id: 1.
	aPerson name: 'Barney Rubble'.
	aPerson address: (self objectNumber: 1 ofClass: GlorpAddress).	
	aPerson emailAddress: (self objectNumber: 1 ofClass: GlorpEmailAddress).! !
!GlorpBankExampleSystem categoriesFor: #exampleGlorpAddressNumber1:!examples!private! !
!GlorpBankExampleSystem categoriesFor: #exampleGlorpBankAccountNumber1:!examples!private! !
!GlorpBankExampleSystem categoriesFor: #exampleGlorpBankAccountNumber2:!examples!private! !
!GlorpBankExampleSystem categoriesFor: #exampleGlorpBankAccountNumberNumber1:!examples!private! !
!GlorpBankExampleSystem categoriesFor: #exampleGlorpBankAccountNumberNumber2:!examples!private! !
!GlorpBankExampleSystem categoriesFor: #exampleGlorpBankTransactionNumber1:!examples!private! !
!GlorpBankExampleSystem categoriesFor: #exampleGlorpBankTransactionNumber2:!examples!private! !
!GlorpBankExampleSystem categoriesFor: #exampleGlorpCustomerNumber1:!examples!private! !
!GlorpBankExampleSystem categoriesFor: #exampleGlorpEmailAddressNumber1:!examples!private! !
!GlorpBankExampleSystem categoriesFor: #exampleGlorpPersonNumber1:!examples!private! !

GlorpNonperishableItem guid: (GUID fromString: '{CD70E55C-9A22-4D9B-BA90-FD64F17F1B40}')!
GlorpNonperishableItem comment: ''!
!GlorpNonperishableItem categoriesForClass!Unclassified! !
!GlorpNonperishableItem methodsFor!

serialNumber
	^serialNumber!

serialNumber: anObject
	serialNumber := anObject! !
!GlorpNonperishableItem categoriesFor: #serialNumber!accessing!private! !
!GlorpNonperishableItem categoriesFor: #serialNumber:!accessing!private! !

GlorpPerishableItem guid: (GUID fromString: '{F165A918-AFED-4A8D-8730-7065D668A17B}')!
GlorpPerishableItem comment: ''!
!GlorpPerishableItem categoriesForClass!Unclassified! !
!GlorpPerishableItem methodsFor!

age
	^age!

age: anObject
	age := anObject! !
!GlorpPerishableItem categoriesFor: #age!accessing!private! !
!GlorpPerishableItem categoriesFor: #age:!accessing!private! !

GlorpUnassembledItem guid: (GUID fromString: '{7A26C47C-515A-4D43-B0AC-C3CFC30CD960}')!
GlorpUnassembledItem comment: ''!
!GlorpUnassembledItem categoriesForClass!Unclassified! !
!GlorpUnassembledItem methodsFor!

assemblyCost
	^assemblyCost!

assemblyCost: anObject
	assemblyCost := anObject! !
!GlorpUnassembledItem categoriesFor: #assemblyCost!accessing!private! !
!GlorpUnassembledItem categoriesFor: #assemblyCost:!accessing!private! !

GlorpPoultry guid: (GUID fromString: '{F5511C01-17CE-4693-9DE6-E6DE97924BB8}')!
GlorpPoultry comment: ''!
!GlorpPoultry categoriesForClass!Unclassified! !
!GlorpPoultry methodsFor!

featherColor
	^featherColor!

featherColor: anObject
	featherColor := anObject! !
!GlorpPoultry categoriesFor: #featherColor!accessing!private! !
!GlorpPoultry categoriesFor: #featherColor:!accessing!private! !

GlorpImage guid: (GUID fromString: '{1E53B497-773C-4043-88CE-9EC10144A1D9}')!
GlorpImage comment: ''!
!GlorpImage categoriesForClass!Unclassified! !
!GlorpImage methodsFor!

location
	^ location!

location: aLocation
	location := aLocation! !
!GlorpImage categoriesFor: #location!private! !
!GlorpImage categoriesFor: #location:!private! !

!GlorpImage class methodsFor!

fromStream: aStream
	^ self new image: aStream! !
!GlorpImage class categoriesFor: #fromStream:!private! !

GlorpBasicTax guid: (GUID fromString: '{6B59CE57-7452-44A2-9619-02A212E40C4A}')!
GlorpBasicTax comment: ''!
!GlorpBasicTax categoriesForClass!Unclassified! !
!GlorpBasicTax class methodsFor!

glorpSetupDescriptor: aDescriptor forSystem: aSystem
	| table |
	table := aSystem tableNamed: 'TAX'.
	self glorpCommonSetupDescriptor: aDescriptor forSystem: aSystem.
	(aSystem typeResolverFor: GlorpTax)
		register: aDescriptor
		keyedBy: 'T'
		field: (table fieldNamed: 'TYPE').! !
!GlorpBasicTax class categoriesFor: #glorpSetupDescriptor:forSystem:!glorp!private! !

GlorpSurcharge guid: (GUID fromString: '{935F1FBE-7B14-428F-83F5-7674ACEFB9B4}')!
GlorpSurcharge comment: ''!
!GlorpSurcharge categoriesForClass!Unclassified! !
!GlorpSurcharge class methodsFor!

glorpSetupDescriptor: aDescriptor forSystem: aSystem
	| table |
	table := aSystem tableNamed: 'TAX'.
	self glorpCommonSetupDescriptor: aDescriptor forSystem: aSystem.
	(aSystem typeResolverFor: GlorpTax)
		register: aDescriptor
		keyedBy: 'S'
		field: (table fieldNamed: 'TYPE').! !
!GlorpSurcharge class categoriesFor: #glorpSetupDescriptor:forSystem:!glorp!private! !

GlorpVideoCreditStatus guid: (GUID fromString: '{D47C919D-C438-4E01-8313-E4D674F48EB1}')!
GlorpVideoCreditStatus comment: 'There is a possibility of one of these for each customer in a Store. If there is no credit owing or owed, then there is no record. Otherwise the record exists and records the total amount. This is pretty unlikely as a model of credit, but suits our purposes by providing a 1-1 relationship that may or may not exist.

Instance Variables:
	balanceOwing	<Number>	
	comments	<String>	
	customer	<Customer>
	dateOwing	<Date>

'!
!GlorpVideoCreditStatus categoriesForClass!Unclassified! !
!GlorpVideoCreditStatus methodsFor!

assertEqual: aCreditStatus

	self assert: customer name = aCreditStatus customer name.
	self assert: customer dateOfBirth = aCreditStatus customer dateOfBirth.
	self assert: balanceOwing = aCreditStatus balanceOwing.
	self assert: dateOwing = aCreditStatus dateOwing.
	self assert: comments = aCreditStatus comments.!

balanceOwing
	^balanceOwing.!

balanceOwing: aNumber
	balanceOwing := aNumber.!

comments
	^comments.!

comments: aString
	comments := aString.!

customer
	^customer.!

customer: aCustomer
	customer := aCustomer.!

dateOwing
	^dateOwing.!

dateOwing: aDate
	dateOwing := aDate.! !
!GlorpVideoCreditStatus categoriesFor: #assertEqual:!private!testing! !
!GlorpVideoCreditStatus categoriesFor: #balanceOwing!As yet unclassified!private! !
!GlorpVideoCreditStatus categoriesFor: #balanceOwing:!As yet unclassified!private! !
!GlorpVideoCreditStatus categoriesFor: #comments!As yet unclassified!private! !
!GlorpVideoCreditStatus categoriesFor: #comments:!As yet unclassified!private! !
!GlorpVideoCreditStatus categoriesFor: #customer!As yet unclassified!private! !
!GlorpVideoCreditStatus categoriesFor: #customer:!As yet unclassified!private! !
!GlorpVideoCreditStatus categoriesFor: #dateOwing!As yet unclassified!private! !
!GlorpVideoCreditStatus categoriesFor: #dateOwing:!As yet unclassified!private! !

GlorpVideoCustomer guid: (GUID fromString: '{6E5AB46A-CA3E-47C4-AFFA-26C7770D8C2E}')!
GlorpVideoCustomer comment: ''!
!GlorpVideoCustomer categoriesForClass!Unclassified! !
!GlorpVideoCustomer methodsFor!

<= aVideoCustomer
	^self name < aVideoCustomer name
	or: [self name = aVideoCustomer name
		and: [self dateOfBirth <= aVideoCustomer dateOfBirth]]!

addInStorePurchase: aPurchase
	inStorePurchases add: aPurchase.
	aPurchase customer: self.!

addOnlinePurchase: aPurchase
	onlinePurchases add: aPurchase.
	aPurchase customer: self.!

addRental: aRental
	inStoreRentals add: aRental.
	aRental customer: self.!

assertEqual: aCustomer

	onlinePurchases assertEqual: aCustomer onlinePurchases.
	inStorePurchases assertEqual: aCustomer inStorePurchases.
	inStoreRentals assertEqual: aCustomer inStoreRentals.
	creditStatus assertEqual: aCustomer creditStatus.
	self assert: store id = aCustomer videoStore id.
	self assert: name = aCustomer name.
	self assert: dateOfBirth = aCustomer dateOfBirth.!

creditStatus
	^creditStatus!

creditStatus: aCreditStatus
	creditStatus := aCreditStatus.
	creditStatus isNil ifFalse: [creditStatus customer: self].!

dateOfBirth
	^dateOfBirth.!

dateOfBirth: aDate
	dateOfBirth := aDate.!

initialize
	onlinePurchases := OrderedCollection new.
	inStorePurchases :=OrderedCollection new.
	inStoreRentals := OrderedCollection new.!

inStorePurchases
	^inStorePurchases!

inStorePurchases: anObject
	inStorePurchases := anObject!

inStoreRentals
	^inStoreRentals.!

name
	^name.!

name: aString
	name := aString.!

onlinePurchases
	^onlinePurchases!

onlinePurchases: anObject
	onlinePurchases := anObject!

printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: (name isNil ifTrue: [''] ifFalse: [name]).
	aStream nextPut: $).!

purchases
	^inStorePurchases, onlinePurchases.!

store: anObject
	store := anObject!

videoStore
	^store! !
!GlorpVideoCustomer categoriesFor: #<=!comparing!private! !
!GlorpVideoCustomer categoriesFor: #addInStorePurchase:!As yet unclassified!private! !
!GlorpVideoCustomer categoriesFor: #addOnlinePurchase:!As yet unclassified!private! !
!GlorpVideoCustomer categoriesFor: #addRental:!As yet unclassified!private! !
!GlorpVideoCustomer categoriesFor: #assertEqual:!private!testing! !
!GlorpVideoCustomer categoriesFor: #creditStatus!accessing!private! !
!GlorpVideoCustomer categoriesFor: #creditStatus:!accessing!private! !
!GlorpVideoCustomer categoriesFor: #dateOfBirth!As yet unclassified!private! !
!GlorpVideoCustomer categoriesFor: #dateOfBirth:!As yet unclassified!private! !
!GlorpVideoCustomer categoriesFor: #initialize!initialize-release!private! !
!GlorpVideoCustomer categoriesFor: #inStorePurchases!accessing!private! !
!GlorpVideoCustomer categoriesFor: #inStorePurchases:!accessing!private! !
!GlorpVideoCustomer categoriesFor: #inStoreRentals!accessing!private! !
!GlorpVideoCustomer categoriesFor: #name!As yet unclassified!private! !
!GlorpVideoCustomer categoriesFor: #name:!As yet unclassified!private! !
!GlorpVideoCustomer categoriesFor: #onlinePurchases!accessing!private! !
!GlorpVideoCustomer categoriesFor: #onlinePurchases:!accessing!private! !
!GlorpVideoCustomer categoriesFor: #printOn:!printing!private! !
!GlorpVideoCustomer categoriesFor: #purchases!As yet unclassified!private! !
!GlorpVideoCustomer categoriesFor: #store:!accessing!private! !
!GlorpVideoCustomer categoriesFor: #videoStore!accessing!private! !

!GlorpVideoCustomer class methodsFor!

new
	"Answer a newly created and initialized instance."

	^super new initialize! !
!GlorpVideoCustomer class categoriesFor: #new!instance creation!private! !

GlorpVideoPurchase guid: (GUID fromString: '{B150F9BD-92B9-480A-BE72-2B52CB254646}')!
GlorpVideoPurchase comment: ''!
!GlorpVideoPurchase categoriesForClass!Unclassified! !
!GlorpVideoPurchase methodsFor!

<= aVideoPurchase
	^self title <= aVideoPurchase title.!

assertEqual: aPurchase

	self assert: customer name = aPurchase customer name.
	self assert: customer dateOfBirth = aPurchase customer dateOfBirth.
	self assert: store id = aPurchase videoStore id.
	self assert: id = aPurchase id.
	self assert: title = aPurchase title.
	self assert: (price * 1000) rounded = (aPurchase price * 1000) rounded.
	self assert: inStore = aPurchase inStore.!

customer
	^customer!

customer: aCustomer
	customer := aCustomer.!

id
	^id!

id: anObject
	id := anObject!

initialize!

inStore
	^inStore!

inStore: anObject
	inStore := anObject!

price
	^price!

price: anObject
	price := anObject!

printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self title.
	aStream nextPut: $).!

store: aGlorpVideoStore
	store := aGlorpVideoStore.!

title
	^title!

title: aString
	title := aString!

videoStore
	^store.! !
!GlorpVideoPurchase categoriesFor: #<=!comparing!private! !
!GlorpVideoPurchase categoriesFor: #assertEqual:!private!testing! !
!GlorpVideoPurchase categoriesFor: #customer!As yet unclassified!private! !
!GlorpVideoPurchase categoriesFor: #customer:!As yet unclassified!private! !
!GlorpVideoPurchase categoriesFor: #id!accessing!private! !
!GlorpVideoPurchase categoriesFor: #id:!accessing!private! !
!GlorpVideoPurchase categoriesFor: #initialize!initialize-release!private! !
!GlorpVideoPurchase categoriesFor: #inStore!accessing!private! !
!GlorpVideoPurchase categoriesFor: #inStore:!accessing!private! !
!GlorpVideoPurchase categoriesFor: #price!accessing!private! !
!GlorpVideoPurchase categoriesFor: #price:!accessing!private! !
!GlorpVideoPurchase categoriesFor: #printOn:!printing!private! !
!GlorpVideoPurchase categoriesFor: #store:!As yet unclassified!private! !
!GlorpVideoPurchase categoriesFor: #title!accessing!private! !
!GlorpVideoPurchase categoriesFor: #title:!accessing!private! !
!GlorpVideoPurchase categoriesFor: #videoStore!As yet unclassified!private! !

!GlorpVideoPurchase class methodsFor!

new
	"Answer a newly created and initialized instance."

	^super new initialize! !
!GlorpVideoPurchase class categoriesFor: #new!instance creation!private! !

GlorpVideoRental guid: (GUID fromString: '{9537500C-929C-4BD9-AE3C-F2FCAD085932}')!
GlorpVideoRental comment: ''!
!GlorpVideoRental categoriesForClass!Unclassified! !
!GlorpVideoRental methodsFor!

<= aVideoRental
	^self title <= aVideoRental title.!

assertEqual: aRental

	self assert: customer name = aRental customer name.
	self assert: customer dateOfBirth = aRental customer dateOfBirth.
	self assert: id = aRental id.
	self assert: title = aRental title.
	self assert: price = aRental price.
	self assert: dueDate = aRental dueDate.!

customer
	^customer.!

customer: aCustomer
	customer := aCustomer.!

dueDate
	^dueDate!

dueDate: anObject
	dueDate := anObject!

id
	^id!

id: anObject
	id := anObject!

initialize
	"Initialize a newly created instance. This method must answer the receiver."

	" *** Edit the following to properly initialize instance variables ***"
	id := nil.
	title := nil.
	dueDate := nil.
	price := nil.
	" *** And replace this comment with additional initialization code *** "
	^self!

price
	^price!

price: anObject
	price := anObject!

printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self title.
	aStream nextPut: $).!

store: aGlorpVideoStore
	store := aGlorpVideoStore.!

title
	^title!

title: anObject
	title := anObject! !
!GlorpVideoRental categoriesFor: #<=!comparing!private! !
!GlorpVideoRental categoriesFor: #assertEqual:!private!testing! !
!GlorpVideoRental categoriesFor: #customer!As yet unclassified!private! !
!GlorpVideoRental categoriesFor: #customer:!As yet unclassified!private! !
!GlorpVideoRental categoriesFor: #dueDate!accessing!private! !
!GlorpVideoRental categoriesFor: #dueDate:!accessing!private! !
!GlorpVideoRental categoriesFor: #id!accessing!private! !
!GlorpVideoRental categoriesFor: #id:!accessing!private! !
!GlorpVideoRental categoriesFor: #initialize!initialize-release!private! !
!GlorpVideoRental categoriesFor: #price!accessing!private! !
!GlorpVideoRental categoriesFor: #price:!accessing!private! !
!GlorpVideoRental categoriesFor: #printOn:!printing!private! !
!GlorpVideoRental categoriesFor: #store:!As yet unclassified!private! !
!GlorpVideoRental categoriesFor: #title!accessing!private! !
!GlorpVideoRental categoriesFor: #title:!accessing!private! !

!GlorpVideoRental class methodsFor!

new
	"Answer a newly created and initialized instance."

	^super new initialize! !
!GlorpVideoRental class categoriesFor: #new!instance creation!private! !

GlorpVideoStore guid: (GUID fromString: '{E557A68D-0AC4-4A17-909C-05B7A4C118A0}')!
GlorpVideoStore comment: ''!
!GlorpVideoStore categoriesForClass!Unclassified! !
!GlorpVideoStore methodsFor!

assertEqual: aStore
	self assert: id = aStore id.
	self assert: name = aStore name.

	customers assertEqual: aStore customers.
	purchases assertEqual: aStore purchases.!

computeCollections
	customers do: [:each | each store: self].
	purchases := customers inject: #() into: [:sum :each | sum, each purchases].
	purchases do: [:each | each store: self].!

customers
	^customers!

customers: anObject
	customers := anObject!

id
	^id.!

id: anInteger
	id := anInteger.!

initialize
	customers := OrderedCollection new.
	purchases := OrderedCollection new.!

name
	^name.!

name: aString
	name := aString.!

purchases
	^purchases!

purchases: aCollection
	purchases := aCollection! !
!GlorpVideoStore categoriesFor: #assertEqual:!private!testing! !
!GlorpVideoStore categoriesFor: #computeCollections!private! !
!GlorpVideoStore categoriesFor: #customers!accessing!private! !
!GlorpVideoStore categoriesFor: #customers:!accessing!private! !
!GlorpVideoStore categoriesFor: #id!As yet unclassified!private! !
!GlorpVideoStore categoriesFor: #id:!As yet unclassified!private! !
!GlorpVideoStore categoriesFor: #initialize!initialize-release!private! !
!GlorpVideoStore categoriesFor: #name!As yet unclassified!private! !
!GlorpVideoStore categoriesFor: #name:!As yet unclassified!private! !
!GlorpVideoStore categoriesFor: #purchases!accessing!private! !
!GlorpVideoStore categoriesFor: #purchases:!accessing!private! !

!GlorpVideoStore class methodsFor!

new
	"Answer a newly created and initialized instance."

	^super new initialize! !
!GlorpVideoStore class categoriesFor: #new!instance creation!private! !

GlorpEmployee guid: (GUID fromString: '{77F5AEB3-892C-4F5A-A3E6-FD2C2C3F3B62}')!
GlorpEmployee comment: ''!
!GlorpEmployee categoriesForClass!Unclassified! !
!GlorpEmployee class methodsFor!

glorpTypeResolver
	^FilteredTypeResolver forRootClass: GlorpEmployee! !
!GlorpEmployee class categoriesFor: #glorpTypeResolver!glorp setup!private! !

GlorpLineWorker guid: (GUID fromString: '{C005F4A5-9230-4A4A-980E-7686DBF092A6}')!
GlorpLineWorker comment: ''!
!GlorpLineWorker categoriesForClass!Unclassified! !
!GlorpLineWorker methodsFor!

= aLineWorker
	^super = aLineWorker and: [productionLine = aLineWorker productionLine].!

productionLine
	^productionLine!

productionLine: anObject
	productionLine := anObject! !
!GlorpLineWorker categoriesFor: #=!comparing!private! !
!GlorpLineWorker categoriesFor: #productionLine!accessing!private! !
!GlorpLineWorker categoriesFor: #productionLine:!accessing!private! !

GlorpManager guid: (GUID fromString: '{760A30B7-CC41-478E-8B4B-AA8B5B219EEB}')!
GlorpManager comment: ''!
!GlorpManager categoriesForClass!Unclassified! !
!GlorpManager methodsFor!

= aManager
	^super = aManager and: [branch = aManager branch].!

branch
	^branch!

branch: anObject
	branch := anObject! !
!GlorpManager categoriesFor: #=!comparing!private! !
!GlorpManager categoriesFor: #branch!accessing!private! !
!GlorpManager categoriesFor: #branch:!accessing!private! !

GlorpTransientEmployee guid: (GUID fromString: '{2F981E89-7E5A-4268-B514-166280DEA9BD}')!
GlorpTransientEmployee comment: 'GlorpTransientEmployee is used to test that not all subclasses need to be persistent in inheritance mapping.'!
!GlorpTransientEmployee categoriesForClass!Unclassified! !
GlorpRegionalManager guid: (GUID fromString: '{85856F33-C9E9-4B23-8208-32A30083E9CD}')!
GlorpRegionalManager comment: ''!
!GlorpRegionalManager categoriesForClass!Unclassified! !
!GlorpRegionalManager methodsFor!

= aRegionalManager
	^super = aRegionalManager and: [region = aRegionalManager region].!

region
	^region!

region: anObject
	region := anObject! !
!GlorpRegionalManager categoriesFor: #=!comparing!private! !
!GlorpRegionalManager categoriesFor: #region!accessing!private! !
!GlorpRegionalManager categoriesFor: #region:!accessing!private! !

GlorpTestCase guid: (GUID fromString: '{7D530AD8-AB56-44A6-90EE-60012679DCC1}')!
GlorpTestCase comment: ''!
!GlorpTestCase categoriesForClass!Unclassified! !
!GlorpTestCase methodsFor!

knownFailure
	"This does nothing, but makes it easier to search for known failures."
	^self.!

unfinished! !
!GlorpTestCase categoriesFor: #knownFailure!hacks!private! !
!GlorpTestCase categoriesFor: #unfinished!hacks!private! !

!GlorpTestCase class methodsFor!

isAbstract
	^self sunitName = #GlorpTestCase! !
!GlorpTestCase class categoriesFor: #isAbstract!private!testing! !

GlorpProxyEqualityTest guid: (GUID fromString: '{868AD8A3-ADC8-4B26-B60E-96E6FAE08160}')!
GlorpProxyEqualityTest comment: ''!
!GlorpProxyEqualityTest categoriesForClass!Unclassified! !
!GlorpProxyEqualityTest methodsFor!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	proxy := Proxy new.
	proxy session: session.
	stub := (Smalltalk at: #GlorpQueryStub) returningOneOf: GlorpAddress where: [:address | address id = 1].
	stub result: 'abc'.
	proxy query: stub.
	proxy parameters: #().
	proxy2 := Proxy new.
	proxy2 session: session.
	stub2 := (Smalltalk at: #GlorpQueryStub) returningOneOf: GlorpAddress where: [:address | address id = 1].
	stub2 result: 'abc'.
	proxy2 query: stub2.
	proxy2 parameters: #()!

setUp2
	proxy query result: 'def'!

testEquality
	self assert: proxy = proxy2.!

testEquality2
	self assert: proxy2 = proxy.!

testEqualityFailing
	self setUp2.
	self deny: proxy = proxy2.!

testEqualityFailing2
	self setUp2.
	self deny: proxy2 = proxy.!

testInequality
	self setUp2.
	self deny: proxy = proxy2.!

testInequality2
	self setUp2.
	self deny: proxy2 = proxy.!

testInequalityFailing
	self deny: proxy ~= proxy2.!

testInequalityFailing2
	self deny: proxy2 ~= proxy.! !
!GlorpProxyEqualityTest categoriesFor: #setUp!initialize-release!public! !
!GlorpProxyEqualityTest categoriesFor: #setUp2!initialize-release!private! !
!GlorpProxyEqualityTest categoriesFor: #testEquality!initialize-release!private! !
!GlorpProxyEqualityTest categoriesFor: #testEquality2!initialize-release!private! !
!GlorpProxyEqualityTest categoriesFor: #testEqualityFailing!initialize-release!private! !
!GlorpProxyEqualityTest categoriesFor: #testEqualityFailing2!initialize-release!private! !
!GlorpProxyEqualityTest categoriesFor: #testInequality!initialize-release!private! !
!GlorpProxyEqualityTest categoriesFor: #testInequality2!initialize-release!private! !
!GlorpProxyEqualityTest categoriesFor: #testInequalityFailing!initialize-release!private! !
!GlorpProxyEqualityTest categoriesFor: #testInequalityFailing2!initialize-release!private! !

!GlorpProxyEqualityTest class methodsFor!

resources
	^Array with: (Smalltalk at: #GlorpSessionResource)! !
!GlorpProxyEqualityTest class categoriesFor: #resources!Accessing!private! !

GlorpRowMapForMementosCollectionTest guid: (GUID fromString: '{73A47D8B-711E-46DE-B7AB-DB8CF62AD41E}')!
GlorpRowMapForMementosCollectionTest comment: ''!
!GlorpRowMapForMementosCollectionTest categoriesForClass!Unclassified! !
!GlorpRowMapForMementosCollectionTest methodsFor!

createRowMap
	rowMap := RowMapForMementos withCorrespondenceMap: transaction undoMap.
	rowMap collectionMementos: transaction collectionMementos.
	newCollection := rowMap collectionMementoFor: collection.!

setUp
	transaction := ObjectTransaction new.
	rowMap := nil.!

testArray
	collection := Array with: 1 with: 2 with: 3 with: 4.
	copy := collection copy.
	transaction register: collection.
	collection at: 3 put: 'hello'.
	self createRowMap.
	self assert: newCollection = copy.
	self deny: newCollection = collection
		description: 'Copying is too shallow both here and in registerTransientInternalsOfCollection:'.!

testDictionary
	collection := Dictionary new.
	1 to: 50 do: [:i | collection at: i put: i printString].
	copy := collection collect: [:each | each].
	transaction register: collection.
	#(1 2 7 43 15 9 10 17 18 19 33 23) do: [:i | collection removeKey: i].
	collection at: 3 put: 'hello'.
	self createRowMap.
	self assert: newCollection size = copy size.
	self assert: newCollection keys asSortedCollection = copy keys asSortedCollection.
	self assert: newCollection values asSortedCollection = copy values asSortedCollection.
	self
		deny: newCollection values asSortedCollection = collection values asSortedCollection
		description: 'Copying is too shallow both here and in registerTransientInternalsOfCollection:'!

testIdentityDictionary
	collection := IdentityDictionary new.
	1 to: 50 do: [:i | collection at: i put: i printString].
	copy := collection copy.
	transaction register: collection.
	#( 1 2 7 43 15 9 10 17 18 19 33 23) do: [:i | collection removeKey: i].
	collection at: 3 put: 'hello'.
	self createRowMap.
	self assert: newCollection size = copy size.
	self assert: newCollection keys asSortedCollection = copy keys asSortedCollection.
	self assert: newCollection values asSortedCollection = copy values asSortedCollection.
	self deny: newCollection values asSortedCollection = collection values asSortedCollection
		description: 'Copying is too shallow both here and in registerTransientInternalsOfCollection:'.!

testOrderedCollection
	collection := (1 to: 50) asOrderedCollection.
	copy := collection copy.
	transaction register: collection.
	12 timesRepeat: [collection removeLast].
	collection at: 3 put: 'hello'.
	self createRowMap.
	self assert: newCollection = copy.
	self deny: newCollection = collection
		description: 'Copying is too shallow both here and in registerTransientInternalsOfCollection:'.!

testOrderedSet
	collection := (Dialect smalltalkAt: #OrderedSet ifAbsent: [^self]) new.
	1 to: 50 do: [:i | collection add: i].
	copy := collection copy.
	transaction register: collection.
	#( 1 2 7 43 15 9 10 17 18 19 33 23) do: [:i | collection remove: i].
	collection add: 999.
	self createRowMap.
	self assert: newCollection asSortedCollection = copy asSortedCollection.
	self deny: newCollection asSortedCollection = collection asSortedCollection
		description: 'Copying is too shallow both here and in registerTransientInternalsOfCollection:'.!

testRBSmallDictionary
	collection := (Dialect smalltalkAt: #RBSmallDictionary ifAbsent: [^self]) new.
	1 to: 50 do: [:i | collection at: i put: i printString].
	copy := collection copy.
	transaction register: collection.
	#( 1 2 7 43 15 9 10 17 18 19 33 23) do: [:i | collection removeKey: i].
	collection at: 3 put: 'hello'.
	self createRowMap.
	self assert: newCollection size = copy size.
	self assert: newCollection keys asSortedCollection = copy keys asSortedCollection.
	self assert: newCollection values asSortedCollection = copy values asSortedCollection.
	self deny: newCollection values asSortedCollection = collection values asSortedCollection
		description: 'Copying is too shallow both here and in registerTransientInternalsOfCollection:'.!

testSet
	collection := (1 to: 50) asSet.
	copy := collection copy.
	transaction register: collection.
	1 to: 12 do: [:i | collection remove: i].
	collection add: 'hello'.
	self createRowMap.
	self assert: newCollection asSortedCollection = copy asSortedCollection.
	self deny: newCollection size = collection size
		description: 'Copying is too shallow both here and in registerTransientInternalsOfCollection:'.! !
!GlorpRowMapForMementosCollectionTest categoriesFor: #createRowMap!private!tests! !
!GlorpRowMapForMementosCollectionTest categoriesFor: #setUp!private!support! !
!GlorpRowMapForMementosCollectionTest categoriesFor: #testArray!private!tests! !
!GlorpRowMapForMementosCollectionTest categoriesFor: #testDictionary!public!tests! !
!GlorpRowMapForMementosCollectionTest categoriesFor: #testIdentityDictionary!private!tests! !
!GlorpRowMapForMementosCollectionTest categoriesFor: #testOrderedCollection!private!tests! !
!GlorpRowMapForMementosCollectionTest categoriesFor: #testOrderedSet!private!tests! !
!GlorpRowMapForMementosCollectionTest categoriesFor: #testRBSmallDictionary!private!tests! !
!GlorpRowMapForMementosCollectionTest categoriesFor: #testSet!private!tests! !

"Binary Globals"!

