| package |
package := Package name: 'GlorpTests'.
package paxVersion: 1;
	basicComment: 'This is part of the GLORP system, an open-source library (LGPL(S)) for persisting Smalltalk objects in relational databases. For more information see the #notice property, the accompanying files and/or the web sites http://www.glorp.org or http://www.sourceforge.net/projects/glorp '.

package basicPackageVersion: 'image'.


package classNames
	add: #GlorpAdHocMappingTest;
	add: #GlorpAttributeModelTest;
	add: #GlorpBasicMappingTest;
	add: #GlorpBreadthFirstTopologicalSortItem;
	add: #GlorpBreadthFirstTopologicalSortTest;
	add: #GlorpCacheTest;
	add: #GlorpCommandTest;
	add: #GlorpCommitOrderTest;
	add: #GlorpConditionalMappingTest;
	add: #GlorpConstantMappingTest;
	add: #GlorpCoreExtensionsTest;
	add: #GlorpCursoredCollectionTest;
	add: #GlorpDatabaseAccessorTest;
	add: #GlorpDatabasePlatformTest;
	add: #GlorpDeleteInUnitOfWorkTest;
	add: #GlorpDescriptorTest;
	add: #GlorpDescriptorValidationTest;
	add: #GlorpDialectTest;
	add: #GlorpDictionaryMappingTest;
	add: #GlorpDirectMappingTest;
	add: #GlorpErrorTest;
	add: #GlorpExpressionBasicPropertiesTest;
	add: #GlorpExpressionIterationTest;
	add: #GlorpExpressionJoiningTest;
	add: #GlorpExpressionRebuildingTest;
	add: #GlorpExpressionTableAliasingTest;
	add: #GlorpExpressionTest;
	add: #GlorpFakeElementBuilder;
	add: #GlorpFilteredInheritanceTest;
	add: #GlorpFilteringQueryTest;
	add: #GlorpHorizontalInheritanceTest;
	add: #GlorpJoinTest;
	add: #GlorpMappingFromClassModelTests;
	add: #GlorpMappingTest;
	add: #GlorpMessageCollectorTest;
	add: #GlorpNoProxyCollectionReadTest;
	add: #GlorpNullCommand;
	add: #GlorpObjectTransactionTest;
	add: #GlorpPrimaryKeyExpressionWithConstantTest;
	add: #GlorpQueryCopyingTest;
	add: #GlorpQueryTableAliasingTest;
	add: #GlorpRowMapForMementosTest;
	add: #GlorpRowMapTest;
	add: #GlorpRowMapUnificationTest;
	add: #GlorpSessionTest;
	add: #GlorpSortedCollectionTest;
	add: #GlorpSQLPrintingTest;
	add: #GlorpStringTest;
	add: #GlorpTableTest;
	add: #GlorpTestsPackage;
	add: #GlorpTimedExpiryCacheTest;
	add: #GlorpTimedStrongCacheTest;
	add: #GlorpTracingTest;
	add: #GlorpTransformedFieldValueWrapperTest;
	add: #GlorpWeakCacheTest;
	add: #IdentityHashPrintingObject;
	yourself.

package methodNames
	add: #GlorpDatabaseBasedTest -> #assert:equalsIgnoringOuterBrackets:;
	add: #GlorpDemoDescriptorSystem -> #testIDLessThan5:;
	add: #GlorpDemoDescriptorSystem -> #testIDMoreThan5:;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\Object Arts\Dolphin\Base\Dolphin';
	add: 'GlorpCore';
	add: 'GlorpDatabase';
	add: 'GlorpDatabaseTypes';
	add: 'GlorpDBTests';
	add: 'GlorpExpressions';
	add: 'GlorpMappings';
	add: 'GlorpMisc';
	add: 'GlorpQueries';
	add: 'GlorpTestModels';
	add: 'GlorpUnitOfWork';
	add: '..\..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

Object subclass: #GlorpBreadthFirstTopologicalSortItem
	instanceVariableNames: 'parent id relatedItems status'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpFakeElementBuilder
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #GlorpTestsPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #IdentityHashPrintingObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
DatabaseCommand subclass: #GlorpNullCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #GlorpBreadthFirstTopologicalSortTest
	instanceVariableNames: 'unsorted sorted groupA groupB groupC'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #GlorpCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #GlorpCursoredCollectionTest
	instanceVariableNames: 'session stream'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #GlorpDescriptorValidationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #GlorpFilteringQueryTest
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #GlorpNoProxyCollectionReadTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #GlorpTransformedFieldValueWrapperTest
	instanceVariableNames: 'inner outer'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpAttributeModelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpBasicMappingTest
	instanceVariableNames: 'mapping person'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpConstantMappingTest
	instanceVariableNames: 'mappingToClass mappingToRow mappingToSession slot'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpCoreExtensionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpDatabaseAccessorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpDatabasePlatformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpDeleteInUnitOfWorkTest
	instanceVariableNames: 'unitOfWork'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpDialectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpErrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpExpressionBasicPropertiesTest
	instanceVariableNames: 'base'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpExpressionIterationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpExpressionRebuildingTest
	instanceVariableNames: 'original newBase rebuilt'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpFilteredInheritanceTest
	instanceVariableNames: 'session allEmployees'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpHorizontalInheritanceTest
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpMappingFromClassModelTests
	instanceVariableNames: 'system platform'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpMessageCollectorTest
	instanceVariableNames: 'collector'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpObjectTransactionTest
	instanceVariableNames: 'transaction objects'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpRowMapForMementosTest
	instanceVariableNames: 'rowMap a1 a2 b1 b2 table1 row1 row2 transaction c1 c2'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpRowMapTest
	instanceVariableNames: 'rowMap a1 b1 table1 row2 platform'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpRowMapUnificationTest
	instanceVariableNames: 't1 t2 t3 f1 f2 f3 o1 o2 o3 rowMap platform'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpSortedCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpSQLPrintingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpTestCase subclass: #GlorpTracingTest
	instanceVariableNames: 'tracing'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpAdHocMappingTest
	instanceVariableNames: 'mapping person descriptor table money rowMap'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpCacheTest
	instanceVariableNames: 'cache session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpCommitOrderTest
	instanceVariableNames: 't1 t2 t3 t1id t2id t3id platform'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpDescriptorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpExpressionJoiningTest
	instanceVariableNames: 'source target base'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpExpressionTableAliasingTest
	instanceVariableNames: 'exp'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpExpressionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpJoinTest
	instanceVariableNames: 'expression compoundExpression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpMappingTest
	instanceVariableNames: 'rowMap'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpPrimaryKeyExpressionWithConstantTest
	instanceVariableNames: 'expression compoundExpression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpQueryCopyingTest
	instanceVariableNames: 'query expression elementBuilder session newQuery'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpQueryTableAliasingTest
	instanceVariableNames: 'query expression elementBuilder session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpSessionTest
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpDatabaseBasedTest subclass: #GlorpTableTest
	instanceVariableNames: 'descriptors dbPlatform'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpCacheTest subclass: #GlorpTimedExpiryCacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpCacheTest subclass: #GlorpTimedStrongCacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpCacheTest subclass: #GlorpWeakCacheTest
	instanceVariableNames: 'mourned'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpConditionalMappingTest
	instanceVariableNames: 'mapping descriptor mapping1 mapping2 mapping3 newMapping'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpDictionaryMappingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
GlorpSessionBasedTest subclass: #GlorpDirectMappingTest
	instanceVariableNames: 'mapping'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!GlorpDatabaseBasedTest methodsFor!

assert: aBrackettedString equalsIgnoringOuterBrackets: anotherString
	self assert: aBrackettedString =
		(anotherString first = $(
			ifTrue: [anotherString]
			ifFalse: ['(', anotherString, ')'])! !
!GlorpDatabaseBasedTest categoriesFor: #assert:equalsIgnoringOuterBrackets:!private!support! !

!GlorpDemoDescriptorSystem methodsFor!

testIDLessThan5: aValue
	"A test method, used for conditional mapping tests"
	^aValue < 5.!

testIDMoreThan5: aValue
	"A test method, used for conditional mapping tests"
	^aValue > 5.! !
!GlorpDemoDescriptorSystem categoriesFor: #testIDLessThan5:!private!test support! !
!GlorpDemoDescriptorSystem categoriesFor: #testIDMoreThan5:!private!test support! !

"End of package definition"!

"Source Globals"!

"Classes"!

GlorpBreadthFirstTopologicalSortItem guid: (GUID fromString: '{92426736-302C-4FC6-B77F-A64C67809B29}')!
GlorpBreadthFirstTopologicalSortItem comment: ''!
!GlorpBreadthFirstTopologicalSortItem categoriesForClass!Unclassified! !
!GlorpBreadthFirstTopologicalSortItem methodsFor!

id
	^id!

id: anObject
	id := anObject!

initialize
	relatedItems := OrderedCollection new.!

parent
	^parent!

parent: anObject
	parent := anObject!

printOn: aStream
	aStream nextPut: $(.
	id printOn: aStream.
	aStream nextPut: $).!

relatedItems
	^relatedItems!

relatedItems: aCollection
	relatedItems := aCollection!

relateTo: anItem
	relatedItems add: anItem.!

status
	^status!

status: aSymbol
	status := aSymbol! !
!GlorpBreadthFirstTopologicalSortItem categoriesFor: #id!accessing!private! !
!GlorpBreadthFirstTopologicalSortItem categoriesFor: #id:!accessing!private! !
!GlorpBreadthFirstTopologicalSortItem categoriesFor: #initialize!initialize-release!private! !
!GlorpBreadthFirstTopologicalSortItem categoriesFor: #parent!accessing!private! !
!GlorpBreadthFirstTopologicalSortItem categoriesFor: #parent:!accessing!private! !
!GlorpBreadthFirstTopologicalSortItem categoriesFor: #printOn:!printing!private! !
!GlorpBreadthFirstTopologicalSortItem categoriesFor: #relatedItems!accessing!private! !
!GlorpBreadthFirstTopologicalSortItem categoriesFor: #relatedItems:!accessing!private! !
!GlorpBreadthFirstTopologicalSortItem categoriesFor: #relateTo:!private!relationships! !
!GlorpBreadthFirstTopologicalSortItem categoriesFor: #status!accessing!private! !
!GlorpBreadthFirstTopologicalSortItem categoriesFor: #status:!accessing!private! !

!GlorpBreadthFirstTopologicalSortItem class methodsFor!

new
	"Answer a newly created and initialized instance."

	^super new initialize! !
!GlorpBreadthFirstTopologicalSortItem class categoriesFor: #new!instance creation!private! !

GlorpFakeElementBuilder guid: (GUID fromString: '{7E1B3D33-C2A5-4C30-A584-D7BFFE9F64D3}')!
GlorpFakeElementBuilder comment: ''!
!GlorpFakeElementBuilder categoriesForClass!Unclassified! !
!GlorpFakeElementBuilder methodsFor!

value: anObject
	value := anObject.!

valueOf: aField
	^value.!

valueOfField: aField in: anArray

	^value.! !
!GlorpFakeElementBuilder categoriesFor: #value:!accessing!private! !
!GlorpFakeElementBuilder categoriesFor: #valueOf:!element builder protocol!private! !
!GlorpFakeElementBuilder categoriesFor: #valueOfField:in:!element builder protocol!private! !

GlorpTestsPackage guid: (GUID fromString: '{8AED7308-CD52-4C9C-AF0D-8A98722E284E}')!
GlorpTestsPackage comment: 'This class represents package information for the GlorpTests package, for systems that don''t have things like package properties to store things like copyright and license information.

LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you''ll need to release the
source of any modifications.

If you require any further clarification, we''d be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'!
!GlorpTestsPackage categoriesForClass!Unclassified! !
!GlorpTestsPackage class methodsFor!

LICENSE
"LGPL(S)

The code is Copyright (C) 2000-2010  Alan Knight

This is a Smalltalk library, licensed under the LGPL, and distributed WITHOUT
ANY WARRANTY (see below).  However, it is not obvious how some of
the terms and concepts in the license should be sensibly applied to Smalltalk
The various Smalltalk image models often do not directly correspond to 
the ideas of programs and libraries that are linked to form executables. 
We, the authors, would like to clarify our interpretation of the LGPL as it
applies to Smalltalk, and what we permit you to do with this code. We
will sometimes use the term LGPL(S) to distinguish the use of the LGPL 
with these clarifications.

This code is intended to be usable as a library, without the intention to 
restrict the license of the program that uses it. Thus, you may use this library
the same way you would normally use any other Smalltalk library. That is, 
you may load it into an image or otherwise make it available for use in whatever
ways are appropriate to the Smalltalk implementation you are using (including,
but not limited to file-in, linking a shared library, or loading a binary 
representation such as a parcel,  BOSS file, image segment or image component).
You may write code that uses the library, including subclassing library classes
and having the library call back to your code using blocks, the #perform: 
mechanism, or similar mechanisms. You may use this code,  including creating
and distributing packaged images, libraries, development images and executables
that include the library code. We do not consider these activities sufficient
to make the entire program/image/executable or any portion of it beyond the
library itself be considered a derivative work, and in any case we place no
restrictions on what licenses you may use for code that uses this library in
these or similar manners.

If, however, you modify the class definitions or methods of the library, we do
consider those modified sections a derivative work, and as such they are fully subject
to the restrictions described in the LGPL. Basically, you'll need to release the
source of any modifications.

If you require any further clarification, we'd be happy to provide it. You can contact
the authors c/o Alan Knight, knight@acm.org.

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"! !
!GlorpTestsPackage class categoriesFor: #LICENSE!instance creation!public! !

IdentityHashPrintingObject guid: (GUID fromString: '{00D70816-EE30-465F-9D8E-43CB33402AA7}')!
IdentityHashPrintingObject comment: 'This is just an object we can easily identify by identity, used for transaction test debugging. We can put these into a transaction and easily distinguish them from their copies.
'!
!IdentityHashPrintingObject categoriesForClass!Unclassified! !
!IdentityHashPrintingObject methodsFor!

printOn: aStream
	aStream nextPutAll: 'thing with hash '.
	self identityHash printOn: aStream.! !
!IdentityHashPrintingObject categoriesFor: #printOn:!printing!private! !

GlorpNullCommand guid: (GUID fromString: '{99B671B8-D2D6-4F11-802F-2661088BD3F9}')!
GlorpNullCommand comment: 'This represents a command with no additional syntax, basically just a stream. Useful for testing the generation of chunks of SQL.'!
!GlorpNullCommand categoriesForClass!Unclassified! !
!GlorpNullCommand methodsFor!

sqlString
	^stream contents.!

succeeded
	^true.! !
!GlorpNullCommand categoriesFor: #sqlString!accessing!private! !
!GlorpNullCommand categoriesFor: #succeeded!private!testing! !

!GlorpNullCommand class methodsFor!

useBinding: aBoolean session: aSession
	^(self new)
		useBinding: aBoolean;
		session: aSession;
		yourself.! !
!GlorpNullCommand class categoriesFor: #useBinding:session:!As yet unclassified!public! !

GlorpBreadthFirstTopologicalSortTest guid: (GUID fromString: '{65126B1C-493C-43CC-803E-07479106DEA0}')!
GlorpBreadthFirstTopologicalSortTest comment: ''!
!GlorpBreadthFirstTopologicalSortTest categoriesForClass!Unclassified! !
!GlorpBreadthFirstTopologicalSortTest methodsFor!

assertSortOrder: aCollection
	| ids |
	ids := (sorted collect: [:each | each id]) asArray.
	self assert: ids = aCollection asArray.!

data1
	| one two three |
	one := GlorpBreadthFirstTopologicalSortItem new id: 1.
	two := GlorpBreadthFirstTopologicalSortItem new id: 2.
	three := GlorpBreadthFirstTopologicalSortItem new id: 3.
	one relateTo: two.
	two relateTo: three.
	^Array with: one with: two with: three.!

dataForGroupNamed: aString
	| one two three four |
	one := GlorpBreadthFirstTopologicalSortItem new id: aString, '1'.
	two := GlorpBreadthFirstTopologicalSortItem new id: aString, '2'.
	three := GlorpBreadthFirstTopologicalSortItem new id: aString, '3'.
	four := GlorpBreadthFirstTopologicalSortItem new id: aString, '4'.
	^Array with: one with: two with: three with: four.!

dataForMedium
	"Data to ensure that things tend to stay together.  This is a simple grouping a1->b, b->c, b->a2, repeated, with some extra floating b's and c's."
	groupA := self dataForGroupNamed: 'a'.
	groupB := self dataForGroupNamed: 'b'.
	groupC := self dataForGroupNamed: 'c'.
	groupA first relateTo: groupB first.
	(groupA at: 3) relateTo: (groupB at: 3).
	groupB first relateTo: groupC first.
	(groupB at: 3) relateTo: (groupC at: 3).
	groupB first relateTo: (groupA at: 2).
	(groupB at: 3) relateTo: (groupA at: 4).
	^groupA, groupB, groupC.!

dataForNoCyclesMedium
	"Data to ensure that things tend to stay together.  This is a simple grouping a->b, b->c repeated"
	groupA := self dataForGroupNamed: 'a'.
	groupB := self dataForGroupNamed: 'b'.
	groupC := self dataForGroupNamed: 'c'.
	1 to: 4 do: [:i |
		(groupA at: i) relateTo: (groupB at: i).
		(groupB at: i) relateTo: (groupC at: i)].
	^groupC, groupB, groupA.!

dataForNoCyclesMediumPermuted
	"Data to ensure that things tend to stay together.  This is a simple grouping a->b, b->c repeated"
	groupA := self dataForGroupNamed: 'a'.
	groupB := self dataForGroupNamed: 'b'.
	groupC := self dataForGroupNamed: 'c'.
	1 to: 4 do: [:i |
		(groupA at: i) relateTo: (groupB at: i).
		(groupB at: i) relateTo: (groupC at: i)].
	^groupB, groupA, groupC.!

sort
	| sorter |
	sorter := GlorpRowSorter new getChildrenVia: #relatedItems.
	sorted := sorter sort: unsorted.!

sort: aCollection
	unsorted := aCollection.
	self sort.!

testBasicSort1
	self sort: self data1.
	self assertSortOrder: #(3 2 1).!

testBasicSort2
	"Try it with a different initial order. The sort is a convoluted way of writing the questionably-portable reverse"
	self sort: (self data1 asSortedCollection: [:a :b | a id >= b id]).
	self assertSortOrder: #(3 2 1).!

testBasicSortCompleteGraph
	| one two three |
	one := GlorpBreadthFirstTopologicalSortItem new id: 1.
	two := GlorpBreadthFirstTopologicalSortItem new id: 2.
	three := GlorpBreadthFirstTopologicalSortItem new id: 3.
	one relateTo: two.
	one relateTo: three.
	three relateTo: two.
	three relateTo: one.
	two relateTo: three.
	two relateTo: one.
	self sort: (Array with: one with: two with: three).
	self assert: sorted size = 3.!

testMedium1
	self sort: self dataForMedium.
	self assertSortOrder: #('c1' 'a2' 'b1' 'a1' 'c3' 'a4' 'b3' 'a3' 'b2' 'b4' 'c2' 'c4').!

testNoCyclesMedium
	self sort: self dataForNoCyclesMedium.
	self assertSortOrder: #('c1' 'c2' 'c3' 'c4' 'b1' 'b2' 'b3' 'b4' 'a1' 'a2' 'a3' 'a4').!

testNoCyclesMediumPermuted
	self sort: self dataForNoCyclesMediumPermuted.
	self assertSortOrder: #('c1' 'b1' 'c2' 'b2' 'c3' 'b3' 'c4' 'b4' 'a1' 'a2' 'a3' 'a4').! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #assertSortOrder:!private!support! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #data1!data!private! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #dataForGroupNamed:!data!private! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #dataForMedium!data!private! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #dataForNoCyclesMedium!data!private! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #dataForNoCyclesMediumPermuted!data!private! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #sort!private!support! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #sort:!private!support! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #testBasicSort1!private!tests! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #testBasicSort2!private!tests! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #testBasicSortCompleteGraph!private!tests! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #testMedium1!private!tests! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #testNoCyclesMedium!private!tests! !
!GlorpBreadthFirstTopologicalSortTest categoriesFor: #testNoCyclesMediumPermuted!private!tests! !

GlorpCommandTest guid: (GUID fromString: '{A83F067D-6504-4C79-8AF8-960D894715F5}')!
GlorpCommandTest comment: ''!
!GlorpCommandTest categoriesForClass!Unclassified! !
!GlorpCommandTest methodsFor!

testFieldsToUpdate

	| command system row old bookTable session |
	session := GlorpLockingDescriptorSystem sessionForLogin: (Login new database: OraclePlatform new).
	system := session system.
	bookTable := system tableNamed: 'BOOK'.
	row := DatabaseRow newForTable: bookTable.
	old := DatabaseRow newForTable: bookTable.
	old at: (bookTable fieldNamed: 'ID') put: 6.
	old at: (bookTable fieldNamed: 'TITLE') put: 'ABook'.
	old at: (bookTable fieldNamed: 'DESCRIPTION') put: 'Stuff'.
	old at: (bookTable fieldNamed: 'COPIES_IN_STOCK') put: 3.
	old at: (bookTable fieldNamed: 'VERSION') put: 2.

	row at: (bookTable fieldNamed: 'ID') put: 6.
	row at: (bookTable fieldNamed: 'TITLE') put: 'ABook'.
	row at: (bookTable fieldNamed: 'DESCRIPTION') put: 'Stuff'.
	row at: (bookTable fieldNamed: 'COPIES_IN_STOCK') put: 4.
	row at: (bookTable fieldNamed: 'VERSION') put: 2.
	row withAllFieldsIn: old.
	command := UpdateCommand forRows: (Array with: row) useBinding: false session: session.
	self assert: command shouldUpdateOnlyChangedFields.
	self assert: command singleRowBoundFields size = 2.
	self assert: command singleRowBindings isEmpty. 
	command useBinding: true.
	self deny: command shouldUpdateOnlyChangedFields.
	self assert: command singleRowBoundFields size = 5.
	"The lock field is bound at the end"
	self assert: command singleRowBindings size = 6.!

testSplittingInserts1
	| rows command subCommands |
	rows := Array with: DatabaseRow new.
	command := InsertCommand forRows: rows useBinding: false session: nil.
	subCommands := command subCommands.
	self assert: subCommands size = 1.
	self assert: subCommands first allRows size = 1.
	self assert: subCommands first allRows first == rows first.!

testSplittingInserts1000
	| rows command subCommands |
	rows := (Array new: 1000) atAllPut: DatabaseRow new.
	command := InsertCommand forRows: rows useBinding: false session: nil.
	subCommands := command subCommands.
	self assert: subCommands size = 1.
	self assert: subCommands first allRows size = 1000.
	self assert: subCommands first allRows first == rows first.!

testSplittingInserts1001
	| rows command subCommands |
	rows := (Array new: 1001) atAllPut: DatabaseRow new.
	rows at: rows size put: DatabaseRow new.
	command := InsertCommand forRows: rows useBinding: false session: nil.
	subCommands := command subCommands.
	self assert: subCommands size = 2.
	self assert: subCommands first allRows size = 1000.
	self assert: subCommands first allRows first == rows first.
	self assert: subCommands last allRows size = 1.
	self assert:subCommands last allRows first == rows last.!

testSplittingInserts1003
	| rows command subCommands |
	rows := (Array new: 1003) atAllPut: DatabaseRow new.
	rows at: rows size put: DatabaseRow new.
	command := InsertCommand forRows: rows useBinding: false session: nil.
	subCommands := command subCommands.
	self assert: subCommands size = 2.
	self assert: subCommands first allRows size = 1000.
	self assert: subCommands first allRows first == rows first.
	self assert: subCommands last allRows size = 3.
	self assert:subCommands last allRows last == rows last.
	self assert: subCommands last allRows first == rows first.!

testSplittingInserts2
	| rows command subCommands |
	rows := Array with: DatabaseRow new with: DatabaseRow new.
	command := InsertCommand forRows: rows useBinding: false session: nil.
	subCommands := command subCommands.
	self assert: subCommands size = 1.
	self assert: subCommands first allRows size = 2.
	self assert: subCommands first allRows first == rows first.
	self assert: subCommands first allRows last == rows last.! !
!GlorpCommandTest categoriesFor: #testFieldsToUpdate!As yet unclassified!private! !
!GlorpCommandTest categoriesFor: #testSplittingInserts1!public!tests! !
!GlorpCommandTest categoriesFor: #testSplittingInserts1000!public!tests! !
!GlorpCommandTest categoriesFor: #testSplittingInserts1001!public!tests! !
!GlorpCommandTest categoriesFor: #testSplittingInserts1003!public!tests! !
!GlorpCommandTest categoriesFor: #testSplittingInserts2!public!tests! !

GlorpCursoredCollectionTest guid: (GUID fromString: '{67C5D12A-7370-43F9-9855-00731A84BB88}')!
GlorpCursoredCollectionTest comment: ''!
!GlorpCursoredCollectionTest categoriesForClass!Unclassified! !
!GlorpCursoredCollectionTest methodsFor!

customerStream
	| rows |
	rows := #( ( 1 'Alan' ) (2 'Bob')).
	^ReadStream on: rows.!

joinedStream
	| rows |
	rows := #( ( 1 'Alan' 101 101 '1st Avenue' 111) (2 'Bob' 102 102 '2nd Avenue' 222) ).
	^ReadStream on: rows.!

joinedStream2
	| rows |
	rows := #( (1 'Alan' 101 101 '1st Avenue' 111  ) (2 'Bob' 102 102 '2nd Avenue' 222  ) ).
	^ReadStream on: rows.!

joinedStreamToMany
	| rows |
	rows := #( (1 'Alan' 101  7 'root' 'foo.com' )  (1 'Alan' 101  8 'root' 'bar.com' )  ).
	^ReadStream on: rows.!

joinedStreamToMany3
	| rows |
	rows := #( 
			(1 'Alan' 1 '001' '001'  '123' 1 1 #CDN 1.5 'stuff' #CDN 1)  
			(1 'Alan' 1 '001' '001'  '123' 2 1  #USD 1.5 'stuff' #USD 1)
 			(1 'Alan' 2 '002' '002'  '234' 3 1  #CHF 1.5 'stuff' #CHF 1)
			(1 'Alan' 2 '002' '002'  '234' 4 1  #EUR 1.5 'stuff' #EUR 1)
 ).
	^ReadStream on: rows.!

mockStream
	| rows |
	rows := #( ( 1 'Alan' 101) (2 'Bob' 102) (3 'Carol' 103)).
	^ReadStream on: rows.!

mockStream2
	| rows |
	rows := #( ( 4 'David' 104) (5 'Evan' 105)).
	^ReadStream on: rows.!

setUp
	| query |
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	((session descriptorFor: GlorpCustomer) mappingForAttributeNamed: #name) shouldProxy: false.
	query := Query readManyOf: GlorpPerson.
	query session: session.
	query prepare.
	stream := GlorpCursoredStream on: self mockStream for: (query sqlWith: nil) accessor: nil.!

testBuilderIsolation
	"Make sure that we can have multiple streams open simultaneously against the same query"
	| stream2 person1 stream3 person4 person4a |
	stream2 := GlorpCursoredStream on: self mockStream2 for: stream command.
	stream3 := GlorpCursoredStream on: self mockStream2 for: stream command.
	person1 := stream next.
	person4 := stream2 next.
	person4a := stream3 next.
	self assert: person4 == person4a.
	self assert: person4 id = 4.
	self assert: person1 id = 1.
	self assert: stream next id = 2.
	self assert: person4a id = 4.!

testCollect
	self assert: (stream collect: [:each | each name]) = #('Alan' 'Bob' 'Carol').!

testKnittingWithAlsoFetch
	| query person1 person2 |
	query := Query readManyOf: GlorpPerson.
	query session: session.
	query alsoFetch: [:each | each address].
	query prepare.
	stream := GlorpCursoredStream on: self joinedStream2 for: (query sqlWith: nil).
	person1 := stream next.
	self assert: session privateGetCache numberOfElements = 2.
	self assert: person1 address street = '1st Avenue'.
	person2 := stream next.
	self assert: session privateGetCache numberOfElements = 4.
	self assert: stream atEnd.
	self assert: person2 id = 2.
	self assert: person2 address street = '2nd Avenue'.
	self assert: session privateGetCache numberOfElements = 4.!

testKnittingWithAlsoFetchDoubleToMany
	| query customer1 |
	query := Query readManyOf: GlorpCustomer.
	query session: session.
	query alsoFetch: [:each | each accounts].
	query alsoFetch: [:each | each transactions].
	query prepare.
	stream := GlorpCursoredStream on: self joinedStreamToMany3 for: (query sqlWith: #()).
	customer1 := stream next.
	self assert: session privateGetCache numberOfElements = 7.
	self assert: stream atEnd.
	self assert: customer1 id = 1.
	self assert: customer1 accounts size = 2.
	self assert: customer1 accounts first accountNumber accountNumber = '123'.
	self assert: customer1 accounts last accountNumber accountNumber = '234'.!

testKnittingWithAlsoFetchToManyInSingleGroup
	| query person1 |
	query := Query readManyOf: GlorpPerson.
	query session: session.
	query alsoFetch: [:each | each emailAddresses].
	query prepare.
	stream := GlorpCursoredStream on: self joinedStreamToMany for: (query sqlWith: #()).
	person1 := stream next.
	self assert: session privateGetCache numberOfElements = 3.
	self assert: (person1 emailAddresses allSatisfy: [:each | each user = 'root']).
	self assert: person1 emailAddresses first ~= person1 emailAddresses last.
	self assert: stream atEnd.!

testKnittingWithRetrieve
	| query tuple person1 address1 person2 address2 |
	query := Query readManyOf: GlorpPerson.
	query session: session.
	query retrieve: [:each | each].
	query retrieve: [:each | each address].
	query prepare.
	stream := GlorpCursoredStream on: self joinedStream for: (query sqlWith: nil).
	tuple := stream next.
	self assert: session privateGetCache numberOfElements = 2.
	person1 := tuple first.
	address1 := tuple last.
	self assert: address1 street = '1st Avenue'.
	self assert: person1 address == address1.
	tuple := stream next.
	self assert: stream atEnd.
	person2 := tuple first.
	address2 := tuple last.
	self assert: person2 id = 2.
	self assert: address2 street = '2nd Avenue'.
	self assert: person2 address == address2.!

testNext
	| person |
	person := stream next.
	self assert: person class == GlorpPerson.
	self assert: person id = 1.
	self assert: person name = 'Alan'.
	self assert: session privateGetCache numberOfElements = 1.
	person := stream next.
	self assert: person id = 2.
	self assert: person name = 'Bob'.
	self assert: session privateGetCache numberOfElements = 2.
	stream next.
	self assert: stream atEnd.
	self assert: stream next = nil.!

testNextColon
	| people |
	people := stream next: 2.
	self assert: people size = 2.
	self assert: people first id = 1.
	self assert: people first name = 'Alan'.
	self assert: session privateGetCache numberOfElements = 2.
	self assert: people last id = 2.!

testPostFetchEvents
	| query customer |
	query := Query readManyOf: GlorpCustomer.
	query session: session.
	query prepare.
	stream := GlorpCursoredStream on: self customerStream for: (query sqlWith: #()).
	customer := stream next.
	self assert: customer seenPostFetch.!

testReadEmpty
	stream := GlorpCursoredStream on: (ReadStream on: #()) for: (stream query sqlWith: #()).
	self assert: stream atEnd.
	self assert: stream next isNil.!

testRegistration
	| person |
	session beginUnitOfWork.
	person := stream next.
	self assert: (session isRegistered: person).!

testRelease
	| person |
	stream next.
	stream release.
	self assert: stream atEnd.
	self assert: stream next isNil.!

testUpToEnd
	| people |
	people := stream upToEnd.
	self assert: people size = 3.
	self assert: people first name = 'Alan'.
	self assert: people last name = 'Carol'.! !
!GlorpCursoredCollectionTest categoriesFor: #customerStream!private!support! !
!GlorpCursoredCollectionTest categoriesFor: #joinedStream!private!support! !
!GlorpCursoredCollectionTest categoriesFor: #joinedStream2!private!support! !
!GlorpCursoredCollectionTest categoriesFor: #joinedStreamToMany!private!support! !
!GlorpCursoredCollectionTest categoriesFor: #joinedStreamToMany3!private!support! !
!GlorpCursoredCollectionTest categoriesFor: #mockStream!private!support! !
!GlorpCursoredCollectionTest categoriesFor: #mockStream2!private!support! !
!GlorpCursoredCollectionTest categoriesFor: #setUp!private!support! !
!GlorpCursoredCollectionTest categoriesFor: #testBuilderIsolation!private!tests! !
!GlorpCursoredCollectionTest categoriesFor: #testCollect!private!tests! !
!GlorpCursoredCollectionTest categoriesFor: #testKnittingWithAlsoFetch!private!tests! !
!GlorpCursoredCollectionTest categoriesFor: #testKnittingWithAlsoFetchDoubleToMany!private!tests! !
!GlorpCursoredCollectionTest categoriesFor: #testKnittingWithAlsoFetchToManyInSingleGroup!private!tests! !
!GlorpCursoredCollectionTest categoriesFor: #testKnittingWithRetrieve!private!tests! !
!GlorpCursoredCollectionTest categoriesFor: #testNext!private!tests! !
!GlorpCursoredCollectionTest categoriesFor: #testNextColon!private!tests! !
!GlorpCursoredCollectionTest categoriesFor: #testPostFetchEvents!private!tests! !
!GlorpCursoredCollectionTest categoriesFor: #testReadEmpty!private!tests! !
!GlorpCursoredCollectionTest categoriesFor: #testRegistration!private!tests! !
!GlorpCursoredCollectionTest categoriesFor: #testRelease!private!tests! !
!GlorpCursoredCollectionTest categoriesFor: #testUpToEnd!private!tests! !

!GlorpCursoredCollectionTest class methodsFor!

resources
	^Array with: (Smalltalk at: #GlorpSessionResource).! !
!GlorpCursoredCollectionTest class categoriesFor: #resources!private!resources! !

GlorpDescriptorValidationTest guid: (GUID fromString: '{7FD7D1E9-BEAA-482D-810C-FFCE58B63721}')!
GlorpDescriptorValidationTest comment: ''!
!GlorpDescriptorValidationTest categoriesForClass!Unclassified! !
!GlorpDescriptorValidationTest methodsFor!

testJoinDirection
	| descriptor table1 table2 mapping system descriptor2 |
	system := DynamicDescriptorSystem new.
	descriptor := system addEmptyDescriptorFor: GlorpCustomer.
	descriptor2 := system addEmptyDescriptorFor: GlorpVideoStore.
	table1 := DatabaseTable named: 'Table1'.
	table1 createFieldNamed: 'one' type: nil.
	table2 := DatabaseTable named: 'Table2'.
	table2 createFieldNamed: 'two' type: nil.
	descriptor addTable: table1.
	descriptor2  addTable: table2.
	mapping := descriptor newMapping: OneToOneMapping.
	mapping attributeName: #accounts.
	mapping referenceClass: GlorpVideoStore.
	mapping join: (Join from: (table1 fieldNamed: 'one') to: (table2 fieldNamed: 'two')).
	mapping validate.

	mapping := descriptor newMapping: OneToOneMapping.
	mapping attributeName: #bar.
	mapping referenceClass: GlorpVideoStore.
	mapping join: (Join from: (table2 fieldNamed: 'two') to: (table1 fieldNamed: 'one')).
	self should: [mapping validate] raise: Dialect error.!

testValidateDirectInstvarAccessExisting
	| descriptor table mapping system field |
	system := DynamicDescriptorSystem new.
	descriptor := system addEmptyDescriptorFor: GlorpCustomer.
	table := DatabaseTable named: 'Table1'.
	field := table createFieldNamed: 'one' type: OraclePlatform new integer.
	descriptor addTable: table.
	mapping := descriptor newMapping: DirectMapping.
	mapping from: #id to: field.
	mapping validate!

testValidateDirectInstvarAccessNonExisting
	| descriptor table mapping system field |
	system := DynamicDescriptorSystem new.
	descriptor := system addEmptyDescriptorFor: GlorpCustomer.
	table := DatabaseTable named: 'Table1'.
	field := table createFieldNamed: 'one' type: OraclePlatform new integer.
	descriptor addTable: table.
	mapping := descriptor newMapping: DirectMapping.
	mapping from: #bar to: field.
	self should: [mapping validate] raise: Dialect error!

testValidateSelectorAccessExisting
	| descriptor table mapping system field |
	system := DynamicDescriptorSystem new.
	descriptor := system addEmptyDescriptorFor: GlorpCustomer.
	table := DatabaseTable named: 'Table1'.
	field := table createFieldNamed: 'one' type: OraclePlatform new integer.
	descriptor addTable: table.
	mapping := descriptor newMapping: DirectMapping.
	mapping from: #id to: field.
	mapping attribute useDirectAccess: false.
	mapping validate!

testValidateSelectorAccessNonExisting
	| descriptor table mapping system field |
	system := DynamicDescriptorSystem new.
	descriptor := system addEmptyDescriptorFor: GlorpCustomer.
	table := DatabaseTable named: 'Table1'.
	field := table createFieldNamed: 'one' type: OraclePlatform new integer.
	descriptor addTable: table.
	mapping := descriptor newMapping: DirectMapping.
	mapping from: #foo to: field.
	mapping attribute useDirectAccess: false.
	self should: [mapping validate] raise: Dialect error!

testValidatingExistingDescriptors
	| session |
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	GlorpTestDescriptorSystem glorpAllSubclasses do: [:each |
		session system: (each forPlatform: (OraclePlatform new)).
		session system validate].! !
!GlorpDescriptorValidationTest categoriesFor: #testJoinDirection!private!testing! !
!GlorpDescriptorValidationTest categoriesFor: #testValidateDirectInstvarAccessExisting!private!testing! !
!GlorpDescriptorValidationTest categoriesFor: #testValidateDirectInstvarAccessNonExisting!private!testing! !
!GlorpDescriptorValidationTest categoriesFor: #testValidateSelectorAccessExisting!private!testing! !
!GlorpDescriptorValidationTest categoriesFor: #testValidateSelectorAccessNonExisting!private!testing! !
!GlorpDescriptorValidationTest categoriesFor: #testValidatingExistingDescriptors!private!testing! !

GlorpFilteringQueryTest guid: (GUID fromString: '{FE381706-E899-417D-ABFC-78B914887C9D}')!
GlorpFilteringQueryTest comment: ''!
!GlorpFilteringQueryTest categoriesForClass!Unclassified! !
!GlorpFilteringQueryTest methodsFor!

setUp!

testSimple
	| query result |
	query := FilteringQuery on: #( 1 2 3 4 5 6 7 8) filter: [:each :parameters | each odd].
	result := GlorpSession new execute: query.
	self assert: result = #(1 3 5 7).! !
!GlorpFilteringQueryTest categoriesFor: #setUp!private!support! !
!GlorpFilteringQueryTest categoriesFor: #testSimple!private!tests! !

GlorpNoProxyCollectionReadTest guid: (GUID fromString: '{D5E671BF-E6A3-4091-B934-CC9A72500AC9}')!
GlorpNoProxyCollectionReadTest comment: ''!
!GlorpNoProxyCollectionReadTest categoriesForClass!Unclassified! !
!GlorpNoProxyCollectionReadTest methodsFor!

testReadCollectionWithoutProxies
	"before running this test change RelationshipMapping>>initialize shouldProxy := false"

	| persons session |
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	session platform supportsMultipleOpenCursors ifFalse: [^self].
	(session system descriptorFor: GlorpPerson) mappings do: [:each | (each respondsTo: #shouldProxy: ) 
		ifTrue: [each shouldProxy: false]].
	session beginTransaction.
	[session beginUnitOfWork.
	session register: GlorpPerson example1.
	session register: GlorpPerson example2.
	session commitUnitOfWork.
	session reset.
	persons := session readManyOf: GlorpPerson.
	self assert: persons size = 2] ensure: [session rollbackTransaction].! !
!GlorpNoProxyCollectionReadTest categoriesFor: #testReadCollectionWithoutProxies!private!tests! !

GlorpTransformedFieldValueWrapperTest guid: (GUID fromString: '{4479817A-CF96-48BF-B26C-089289C9A413}')!
GlorpTransformedFieldValueWrapperTest comment: ''!
!GlorpTransformedFieldValueWrapperTest categoriesForClass!Unclassified! !
!GlorpTransformedFieldValueWrapperTest methodsFor!

inner
	^inner!

inner: aFieldValueWrapper
	inner := aFieldValueWrapper!

outer
	^outer!

outer: aTransformingFieldValueWrapper
	outer := aTransformingFieldValueWrapper!

setUp
	super setUp.
	inner := FieldValueWrapper new.
	outer := TransformingFieldValueWrapper new innerWrapper: inner; forwardTransformation: [:a | a * 2]; inverseTransformation: [:a | a / 2].!

testPrivateSetOuter
	self deny: inner hasValue.
	self deny: outer hasValue.
	outer privateSetContents: 8.
	self assert: outer contents = 8.
	self assert: inner contents = 4.
	self assert: inner hasValue.
	self assert: outer hasValue.!

testSetInner
	self deny: inner hasValue.
	self deny: outer hasValue.
	inner contents: 3.
	self assert: outer contents = 6.
	self assert: inner contents = 3.
	self assert: inner hasValue.
	self assert: outer hasValue.!

testSetOuter
	self deny: inner hasValue.
	self deny: outer hasValue.
	outer contents: 8.
	self assert: outer contents = 8.
	self assert: inner contents = 4.
	self assert: inner hasValue.
	self assert: outer hasValue.!

testSetOuterFails
	self deny: inner hasValue.
	self deny: outer hasValue.
	outer contents: 8.
	self should: [outer contents: 9] raise: Dialect error.
	self assert: outer contents = 8.
	self assert: inner contents = 4.
	self assert: inner hasValue.
	self assert: outer hasValue.! !
!GlorpTransformedFieldValueWrapperTest categoriesFor: #inner!accessing!private! !
!GlorpTransformedFieldValueWrapperTest categoriesFor: #inner:!accessing!private! !
!GlorpTransformedFieldValueWrapperTest categoriesFor: #outer!accessing!private! !
!GlorpTransformedFieldValueWrapperTest categoriesFor: #outer:!accessing!private! !
!GlorpTransformedFieldValueWrapperTest categoriesFor: #setUp!private!support! !
!GlorpTransformedFieldValueWrapperTest categoriesFor: #testPrivateSetOuter!private!tests! !
!GlorpTransformedFieldValueWrapperTest categoriesFor: #testSetInner!private!tests! !
!GlorpTransformedFieldValueWrapperTest categoriesFor: #testSetOuter!private!tests! !
!GlorpTransformedFieldValueWrapperTest categoriesFor: #testSetOuterFails!private!tests! !

GlorpAttributeModelTest guid: (GUID fromString: '{F7B55F16-77E7-4A0E-B9C3-9A98036B6F45}')!
GlorpAttributeModelTest comment: ''!
!GlorpAttributeModelTest categoriesForClass!Unclassified! !
!GlorpAttributeModelTest methodsFor!

testDictionaryTypes
	| attributeModel obj classModel dict model |
	dict := Dictionary new at: #one put: 'two'; yourself.
	obj := 1@dict.

	classModel := GlorpClassModel for: Point.
	attributeModel := classModel newAttributeNamed: #y dictionaryFrom: Symbol to: String.
	model := classModel attributeNamed: #y.
	self assert: model == attributeModel.
	self assert: model keyType == Symbol.
	self assert: model type == String.

	self assert: dict == (attributeModel getValueFrom: obj).
	attributeModel setValueIn: obj to: nil.
	self assert: nil == (attributeModel getValueFrom: obj).!

testGetSetAssociation
	| attributeModel obj classModel |
	obj := nil->2.

	classModel := GlorpClassModel for: Association.
	attributeModel := classModel newAttributeNamed: #value.

	attributeModel useDirectAccess: true.
	self assert: 2 == (attributeModel getValueFrom: obj).
	attributeModel setValueIn: obj to: 3.
	self assert: 3 == (attributeModel getValueFrom: obj).

	attributeModel useDirectAccess: false.
	self assert: 3 == (attributeModel getValueFrom: obj).
	attributeModel setValueIn: obj to: 2.
	self assert: 2 == (attributeModel getValueFrom: obj).!

testGetSetObject
	| attributeModel obj classModel |
	obj := (GlorpObjectWithNoAccessors new)
								extremelyPrivateValue: 'Glorp';
								yourself.

	classModel := GlorpClassModel for: GlorpObjectWithNoAccessors.
	attributeModel := classModel newAttributeNamed: #alue.

	attributeModel useDirectAccess: true.
	self assert: 'Glorp' = (attributeModel getValueFrom: obj).
	attributeModel setValueIn: obj to: 'GLORP'.
	self assert: 'GLORP' = (attributeModel getValueFrom: obj).

	attributeModel useDirectAccess: false.
	self should: [attributeModel getValueFrom: obj] raise: Dialect error.
	self should: [attributeModel setValueIn: obj to: 'Glorp'] raise: Dialect error.!

testPreserveAttributes
	| attributeModel classModel descriptor mapping table field system |
	system := DynamicDescriptorSystem new.
	classModel := system addClassModelFor: Association.
	attributeModel := classModel newAttributeNamed: #key.
	descriptor := Descriptor new.
	descriptor classModel: classModel.
	table := DatabaseTable named: 'FRED'.
	field := table createFieldNamed: 'BARNEY' type: OraclePlatform new int4.
	mapping := DirectMapping from: #key type: Object to: field.
	self assert: mapping attributeAccessor useDirectAccess.
	self assert: attributeModel useDirectAccess.

	mapping attributeAccessor useDirectAccess: false.
	self assert: mapping attribute type == Object.
	descriptor addMapping: mapping.
	self assert: mapping attribute == attributeModel.
	self assert: mapping attribute == mapping attributeAccessor.
	self assert: attributeModel type == Object.
	self deny: attributeModel useDirectAccess.! !
!GlorpAttributeModelTest categoriesFor: #testDictionaryTypes!private!tests! !
!GlorpAttributeModelTest categoriesFor: #testGetSetAssociation!private!tests! !
!GlorpAttributeModelTest categoriesFor: #testGetSetObject!private!tests! !
!GlorpAttributeModelTest categoriesFor: #testPreserveAttributes!private!tests! !

GlorpBasicMappingTest guid: (GUID fromString: '{1B95A8BB-AEC9-4D6A-A627-2FE31E25C88A}')!
GlorpBasicMappingTest comment: ''!
!GlorpBasicMappingTest categoriesForClass!Unclassified! !
!GlorpBasicMappingTest methodsFor!

setUp

	super setUp.
	mapping := DirectMapping new.
	mapping attributeName: #id.
	mapping attribute classModel describedClass: GlorpPerson.
	person := GlorpPerson example1.!

testGet
	
	self assert: (mapping getValueFrom: person) = 1!

testSet
	
	mapping setValueIn: person to: 2.
	self assert: person id = 2.
	self assert: (mapping getValueFrom: person) = 2.! !
!GlorpBasicMappingTest categoriesFor: #setUp!private!support! !
!GlorpBasicMappingTest categoriesFor: #testGet!private!tests! !
!GlorpBasicMappingTest categoriesFor: #testSet!private!tests! !

GlorpConstantMappingTest guid: (GUID fromString: '{D4D88765-1F08-4B75-9719-86BFAC47DE61}')!
GlorpConstantMappingTest comment: ''!
!GlorpConstantMappingTest categoriesForClass!Unclassified! !
!GlorpConstantMappingTest methodsFor!

setUp
	| descriptor |
	super setUp.
	mappingToClass := ConstantMapping new
		attributeName: #slot;
		constantValue: 34.
	descriptor := Descriptor new.
	descriptor classModel: (GlorpClassModel for: self class).
	descriptor addMapping: mappingToClass.
	mappingToRow := ConstantMapping new.
	mappingToSession := ConstantMapping new!

testConstantInClass
	slot := nil.
	mappingToClass mapObject: self inElementBuilder: nil.
	self assert: slot = 34.!

testConstantInClassDoesNotWriteToRow

	"Would raise an exception if it tried to write into nil"
	mappingToClass mapFromObject: self intoRowsIn: nil.!

testGetValue

	slot := nil.
	self assert: (mappingToClass getValueFrom: self) = 34.!

testSessionValue
	mappingToClass constantValueIsSession.
	self assert: (mappingToClass constantValueIn: 38)== 38.! !
!GlorpConstantMappingTest categoriesFor: #setUp!private!support! !
!GlorpConstantMappingTest categoriesFor: #testConstantInClass!private!tests! !
!GlorpConstantMappingTest categoriesFor: #testConstantInClassDoesNotWriteToRow!private!tests! !
!GlorpConstantMappingTest categoriesFor: #testGetValue!private!tests! !
!GlorpConstantMappingTest categoriesFor: #testSessionValue!private!tests! !

GlorpCoreExtensionsTest guid: (GUID fromString: '{44FC3B37-3A16-4FBC-AEAA-F35A4BA8BF1F}')!
GlorpCoreExtensionsTest comment: ''!
!GlorpCoreExtensionsTest categoriesForClass!Unclassified! !
!GlorpCoreExtensionsTest methodsFor!

testGlorpIsCollection
	self deny: Object new glorpIsCollection.
	self assert: Collection new glorpIsCollection! !
!GlorpCoreExtensionsTest categoriesFor: #testGlorpIsCollection!private!tests! !

GlorpDatabaseAccessorTest guid: (GUID fromString: '{16DB3436-A531-41E7-A447-E480C1F02D32}')!
GlorpDatabaseAccessorTest comment: ''!
!GlorpDatabaseAccessorTest categoriesForClass!Unclassified! !
!GlorpDatabaseAccessorTest methodsFor!

testLoggingSwitch
	| currentSetting accessor |
	currentSetting := DatabaseAccessor loggingEnabled.
	accessor := DatabaseAccessor new.
	[DatabaseAccessor loggingEnabled: true.
	self assert: accessor logging.
	DatabaseAccessor loggingEnabled: false.
	self deny: accessor logging.
	accessor logging: true.
	self assert: accessor logging.
	accessor logging: false.
	self deny: accessor logging.
	DatabaseAccessor loggingEnabled: true.
	self deny: accessor logging] ensure: [DatabaseAccessor loggingEnabled: currentSetting].! !
!GlorpDatabaseAccessorTest categoriesFor: #testLoggingSwitch!private!tests! !

GlorpDatabasePlatformTest guid: (GUID fromString: '{9D5C5783-3646-4A50-9FFC-323CB4919E8D}')!
GlorpDatabasePlatformTest comment: ''!
!GlorpDatabasePlatformTest categoriesForClass!Unclassified! !
!GlorpDatabasePlatformTest methodsFor!

addToString: aString
	"Append a couple of special characters. The result will utf-8 encode to be 3 characters longer than its number of characters"
	^aString, (String with: (Character value: 16r2022) "bullet point" with: (Character value: 16r0131) "Turkish i with no dot")

"If PostgreSQL, or another DB returning true to measuresStringFieldWidthsInBytes, is provided in VA, this test must alter to
handle incompatible protocol between VW, which lacks Character>>asString and VA, in which String>>with:with: will not handle
double-byte entries.  The VA could be implemented as
	^aString, (Character value: 16r2022) asString, (Character value: 16r0131) asString
"!

helpTestPrintTimestamp: aTimestampString

	| aStream ts timestamp |
	ts := DatabasePlatform new readTimestamp: aTimestampString for: nil.
	aStream := WriteStream on: String new.
	DatabasePlatform new printDate: ts isoFormatOn: aStream.
	aStream nextPut: Character space.
	DatabasePlatform new printTime: ts isoFormatOn: aStream milliseconds: true.
	timestamp := aStream contents.
	self assert: timestamp = aTimestampString.!

string20
	| platform |
	platform := Dialect isVisualAge
		ifTrue:
			[Transcript cr; show: self class name, '>>string20: testing Oracle, not PostgreSQL'.
			OraclePlatform new]
		ifFalse: [PostgreSQLPlatform new].
	platform characterEncoding: #'utf-8'.
	^platform varchar: 20.!

testNumericCoercion

	| type platform num |
	type := GlorpNumericType new scale: 5; precision: 2.
	platform := DatabasePlatform new.
	num := Dialect coerceToDoublePrecisionFloat: (123456 / 100).
	self assert: (platform convertToNumber: num for: type) = num.
	num := Dialect coerceToDoublePrecisionFloat: (123450 / 100).
	self assert: (platform convertToNumber: num for: type) = num.
	num := Dialect coerceToDoublePrecisionFloat: (123450 / 1000).
	self assert: (platform convertToNumber: num for: type) = num.
	num := Dialect coerceToDoublePrecisionFloat: (123456 / 1000).
	self deny: (platform convertToNumber: num for: type) = num.!

testPrintTimestamp

	| strings |
	strings := #( '2005-01-01 21:29:28.337'  '2005-01-01 01:02:00.037'  '2005-01-01 21:29:28.002'  '2005-01-01 21:29:28.001').
	strings do: [:each |
		self helpTestPrintTimestamp: each].!

testReadTimestamp

	| ts |
	ts := DatabasePlatform new readTimestamp: '2003-03-03 15:29:28.337-05' for: nil.
	self assert: ts asSeconds = 3224158168.
	self assert: ([ts asMilliseconds = 3224158168337 ]
		on: MessageNotUnderstood
		do: [ :mnu | mnu return: mnu message selector = #asMilliseconds ]).

	ts := DatabasePlatform new readTimestamp: '2003-03-13 15:29:28.337-05' for: nil.
	self assert: ts asSeconds = 3225022168.
	self assert: ([ts asMilliseconds = 3225022168337]
		on: MessageNotUnderstood
		do: [ :mnu | mnu return: mnu message selector = #asMilliseconds ])!

testReadTimestampNoMS

	| ts |
	ts := DatabasePlatform new readTimestamp: '2003-03-03 15:29:28-05' for: nil.
	self assert: ts year = 2003.
	self assert: ts monthIndex = 3.
	self assert: ts dayOfMonth = 3.
	self assert: ts hour = 15.
	self assert: ts minute = 29.
	self assert: ts second truncated = 28.
	self assert: ([ ts milliseconds = 0 ]
		on: MessageNotUnderstood
		do: [ :mnu | mnu return: mnu message selector = #milliseconds ])!

testReadTimestampNoMSNoTZ

	| ts |
	ts := DatabasePlatform new readTimestamp: '2003-03-03 15:29:28' for: nil.
	self assert: ts year = 2003.
	self assert: ts monthIndex = 3.
	self assert: ts dayOfMonth = 3.
	self assert: ts hour = 15.
	self assert: ts minute = 29.
	self assert: ts second truncated = 28.
	self assert: ([ ts milliseconds = 0 ]
		on: MessageNotUnderstood
		do: [ :mnu | mnu return: mnu message selector = #milliseconds ])!

testReadTimestampNoTZ

	| ts |
	ts := DatabasePlatform new readTimestamp: '1975-08-13 21:29:28.337' for: nil.
	self assert: ts year = 1975.
	self assert: ts monthIndex = 8.
	self assert: ts dayOfMonth = 13.
	self assert: ts hour = 21.
	self assert: ts minute = 29.
	self assert: ts second truncated = 28.
	self assert: ([ ts milliseconds =  337]
		on: MessageNotUnderstood
		do: [ :mnu | mnu return: mnu message selector = #milliseconds ])!

testReadTimestampOverflowDays

	| ts |
	ts := DatabasePlatform new readTimestamp: '1975-08-13 21:29:28.337-05' for: nil.
	self assert: ts year = 1975.
	self assert: ts monthIndex = 8.
	self assert: ts dayOfMonth = 13.
	self assert: ts hour = 21.
	self assert: ts minute = 29.
	self assert: ts second truncated = 28.
	self assert: ([ ts milliseconds = 337 ]
		on: MessageNotUnderstood
		do: [ :mnu | mnu return: mnu message selector = #milliseconds ])!

testTrimString1
	"Normal ascii"
	| type plat |
	type := self string20.
	plat := type platform.
	self assert: (plat trimString: 'abcdefghi' for: type) = 'abcdefghi'.
	self assert: (plat trimString: 'abcdefghijklmnopqrst' for: type) = 'abcdefghijklmnopqrst'.
	self assert: (plat trimString: 'abcdefghijklmnopqrstu' for: type) = 'abcdefghijklmnopqrst'.
	self assert: (plat trimString: 'abcdefghijklmnopqrstuvwxy' for: type) = 'abcdefghijklmnopqrst'.!

testTrimString2
	"Some special characters"

	| type plat string |
	type := self string20.
	plat := type platform.

	string := self addToString: 'abcdefghi'.
	self assert: (plat trimString: string for: type) = string.
	string := self addToString: 'abcdefghijklmno'.
	self assert: (plat trimString: string for: type) = string.
	string := self addToString: 'abcdefghijklmnop'.
	self assert: (plat trimString: string for: type) = (string copyFrom: 1 to: string size - 1).
	string := self addToString: 'abcdefghijklmnopq'.
	self assert: (plat trimString: string for: type) = (string copyFrom: 1 to: string size - 1).
	string := (String new: 100000) atAllPut: $a.
	self assert: (plat trimString: string for: type) = 'aaaaaaaaaaaaaaaaaaaa'! !
!GlorpDatabasePlatformTest categoriesFor: #addToString:!private!tests! !
!GlorpDatabasePlatformTest categoriesFor: #helpTestPrintTimestamp:!private!tests! !
!GlorpDatabasePlatformTest categoriesFor: #string20!private!tests! !
!GlorpDatabasePlatformTest categoriesFor: #testNumericCoercion!private!tests! !
!GlorpDatabasePlatformTest categoriesFor: #testPrintTimestamp!private!tests! !
!GlorpDatabasePlatformTest categoriesFor: #testReadTimestamp!private!tests! !
!GlorpDatabasePlatformTest categoriesFor: #testReadTimestampNoMS!private!tests! !
!GlorpDatabasePlatformTest categoriesFor: #testReadTimestampNoMSNoTZ!private!tests! !
!GlorpDatabasePlatformTest categoriesFor: #testReadTimestampNoTZ!private!tests! !
!GlorpDatabasePlatformTest categoriesFor: #testReadTimestampOverflowDays!private!tests! !
!GlorpDatabasePlatformTest categoriesFor: #testTrimString1!private!tests! !
!GlorpDatabasePlatformTest categoriesFor: #testTrimString2!public!tests! !

GlorpDeleteInUnitOfWorkTest guid: (GUID fromString: '{9AAC425B-0CC8-46CC-A64D-C7002E613E16}')!
GlorpDeleteInUnitOfWorkTest comment: ''!
!GlorpDeleteInUnitOfWorkTest categoriesForClass!Unclassified! !
!GlorpDeleteInUnitOfWorkTest methodsFor!

setUp
	| session |
	session := GlorpMockSession new.
	session beginUnitOfWork.
	unitOfWork := session privateGetCurrentUnitOfWork.
	session system: (GlorpDemoDescriptorSystem forPlatform: GlorpDatabaseLoginResource defaultLogin database)!

system
	^unitOfWork session system.!

tableNamed: aString 
	^self system tableNamed: aString.!

tearDown

	unitOfWork := nil.!

testCommit

	unitOfWork delete: GlorpAddress example1.
	unitOfWork commit.
	self assert: (unitOfWork numberOfRows) = 1.!

testDeleteRegistration
	| obj |
	obj := Object new.
	unitOfWork delete: obj.
	self assert: (unitOfWork willDelete: obj).
	self deny: (unitOfWork willDelete: 3).!

testDeletesComeAfterUpdates
	unitOfWork delete: GlorpAddress example1.
	unitOfWork register: GlorpCustomer example1.
	unitOfWork commit.
	self assert: unitOfWork session rows last table == (self tableNamed: 'GR_ADDRESS').!

testDeletesInReverseOrder
	"Not that good a test, because it could be luck with only two tables. Should test this at a lower level"
	| cust trans |
	cust := GlorpCustomer example2.
	trans := cust transactions first.
	"We need to give it a primary key or else the delete logic fails"
	trans id: 42.
	unitOfWork delete: cust.
	unitOfWork delete: trans.
	unitOfWork commit.
	self assert: unitOfWork session rows last owner == cust.
	self assert: (unitOfWork session rows reverse at: 2) owner == trans.!

testGeneratingDeleteRows
	unitOfWork delete: GlorpAddress example1.
	unitOfWork createRows.
	self assert: unitOfWork privateGetRowMap numberOfEntries = 1.
	unitOfWork rowsForTable: (self tableNamed: 'GR_ADDRESS')
		do: [:each | self assert: each forDeletion]! !
!GlorpDeleteInUnitOfWorkTest categoriesFor: #setUp!private!support! !
!GlorpDeleteInUnitOfWorkTest categoriesFor: #system!As yet unclassified!private! !
!GlorpDeleteInUnitOfWorkTest categoriesFor: #tableNamed:!As yet unclassified!private! !
!GlorpDeleteInUnitOfWorkTest categoriesFor: #tearDown!private!support! !
!GlorpDeleteInUnitOfWorkTest categoriesFor: #testCommit!private!tests! !
!GlorpDeleteInUnitOfWorkTest categoriesFor: #testDeleteRegistration!private!tests! !
!GlorpDeleteInUnitOfWorkTest categoriesFor: #testDeletesComeAfterUpdates!private!tests! !
!GlorpDeleteInUnitOfWorkTest categoriesFor: #testDeletesInReverseOrder!private!tests! !
!GlorpDeleteInUnitOfWorkTest categoriesFor: #testGeneratingDeleteRows!private!tests! !

GlorpDialectTest guid: (GUID fromString: '{A41BC0AB-44F9-4DEE-9898-06AF42342BE8}')!
GlorpDialectTest comment: 'Tests the portability methods in the Dialect class.'!
!GlorpDialectTest categoriesForClass!Unclassified! !
!GlorpDialectTest methodsFor!

testBlockArgumentCount
	self assert: (Dialect argumentCountFor: [3]) = 0.
	self assert: (Dialect argumentCountFor: [:a | 3]) = 1.
	self assert: (Dialect argumentCountFor: [:a :b | a <= b]) = 2.!

testTimeSetMillisecond
	| time oldMs oldSec oldMin newMs |
	Dialect supportsMillisecondsInTimes ifFalse: [^self].
	time := Time now.
	oldMs := time milliseconds.
	oldSec := time seconds truncated.
	oldMin := time minutes.
	newMs := oldMs > 989 ifTrue: [3] ifFalse: [oldMs + 10].
	time millisecond: newMs.
	self assert: time milliseconds = newMs.
	self assert: time seconds truncated = oldSec.
	self assert: time minutes = oldMin.!

testTokensBasedOn
	self assert: (Dialect tokensBasedOn: '.' in: 'abc.def.ghi') asArray = #('abc' 'def' 'ghi').! !
!GlorpDialectTest categoriesFor: #testBlockArgumentCount!private!tests! !
!GlorpDialectTest categoriesFor: #testTimeSetMillisecond!private!tests! !
!GlorpDialectTest categoriesFor: #testTokensBasedOn!private!tests! !

GlorpErrorTest guid: (GUID fromString: '{F14AA800-7852-4234-B7CE-53C3EAEA9AA2}')!
GlorpErrorTest comment: ''!
!GlorpErrorTest categoriesForClass!Unclassified! !
!GlorpErrorTest methodsFor!

testMessageTextVW
	| innerException text outerException error |
	Dialect isVisualWorks ifFalse: [^self].
	text := 'Something is horribly wrong'.
	error := (Dialect smalltalkAt: #ExternalDatabaseError) new dbmsErrorString: text.
	outerException := GlorpDatabaseReadError new databaseError: (Array with: error).
	[outerException signal] on: GlorpError do: [:ex |	
		self assert: ex messageText = text].
	
	innerException := (Dialect smalltalkAt: #ExternalDatabaseException) new.
	innerException parameter: (Array with: error).
	[DatabaseAccessor new handleError: innerException for: InsertCommand new ] on: GlorpError do: [:ex |	
		self assert: ex messageText = text.
		ex return: nil].! !
!GlorpErrorTest categoriesFor: #testMessageTextVW!private!tests! !

GlorpExpressionBasicPropertiesTest guid: (GUID fromString: '{25D24B51-EB9E-4ADF-B866-9D510C028944}')!
GlorpExpressionBasicPropertiesTest comment: ''!
!GlorpExpressionBasicPropertiesTest categoriesForClass!Unclassified! !
!GlorpExpressionBasicPropertiesTest methodsFor!

setUp

	base := BaseExpression new descriptor: (
		(GlorpDemoDescriptorSystem forPlatform: GlorpDatabaseLoginResource defaultLogin database)
			descriptorFor: GlorpPerson)!

testHasDescriptorForBase

	| exp |
	self assert: base hasDescriptor.
	exp := [:a | a ] asGlorpExpressionOn: base.
	self assert: exp hasDescriptor.!

testHasDescriptorForDirect

	| exp |
	exp := [:a | a id ] asGlorpExpressionOn: base.
	self deny: exp hasDescriptor.!

testHasDescriptorForOneToMany

	| exp |
	exp := [:a | a emailAddresses ] asGlorpExpressionOn: base.
	self assert: exp hasDescriptor.!

testHasDescriptorForOneToOne

	| exp |
	exp := [:a | a address ] asGlorpExpressionOn: base.
	self assert: exp hasDescriptor.!

testHasDescriptorForPrimaryKeyExpression

	| exp |
	exp := Join new.
	self deny: exp hasDescriptor.!

testHasDescriptorForRelation

	| exp |
	exp := [:a | a = 3] asGlorpExpressionOn: base.
	self deny: exp hasDescriptor.!

testHasDescriptorForTwoLevelDirect

	| exp |
	exp := [:a | a address street] asGlorpExpressionOn: base.
	self deny: exp hasDescriptor.
	self assert: exp base hasDescriptor.!

testHasDescriptorForUninitializedBase

	self deny: BaseExpression new hasDescriptor.! !
!GlorpExpressionBasicPropertiesTest categoriesFor: #setUp!private!support! !
!GlorpExpressionBasicPropertiesTest categoriesFor: #testHasDescriptorForBase!private!tests! !
!GlorpExpressionBasicPropertiesTest categoriesFor: #testHasDescriptorForDirect!private!tests! !
!GlorpExpressionBasicPropertiesTest categoriesFor: #testHasDescriptorForOneToMany!private!tests! !
!GlorpExpressionBasicPropertiesTest categoriesFor: #testHasDescriptorForOneToOne!private!tests! !
!GlorpExpressionBasicPropertiesTest categoriesFor: #testHasDescriptorForPrimaryKeyExpression!private!tests! !
!GlorpExpressionBasicPropertiesTest categoriesFor: #testHasDescriptorForRelation!private!tests! !
!GlorpExpressionBasicPropertiesTest categoriesFor: #testHasDescriptorForTwoLevelDirect!private!tests! !
!GlorpExpressionBasicPropertiesTest categoriesFor: #testHasDescriptorForUninitializedBase!private!tests! !

GlorpExpressionIterationTest guid: (GUID fromString: '{18913A7C-84FF-4A4F-BBF4-04351F8BDEE2}')!
GlorpExpressionIterationTest comment: ''!
!GlorpExpressionIterationTest categoriesForClass!Unclassified! !
!GlorpExpressionIterationTest methodsFor!

helpTestSingleNodeDo: exp 
	self assert: (exp collect: [:each | each]) = (OrderedCollection with: exp)!

testDoBase
	self helpTestSingleNodeDo:BaseExpression new!

testDoCollection

	| exp l r |
	exp := CollectionExpression new.
	l := BaseExpression new.
	r := BaseExpression new.
	exp leftChild: l; rightChild: r.
	self assert: ((exp collect: [:each | each]) = (OrderedCollection with: r with: exp)).!

testDoConstant
	self helpTestSingleNodeDo: ConstantExpression new!

testDoField

	| exp |
	exp := FieldExpression new.
	exp field: nil base: BaseExpression new.
	self assert: ((exp collect: [:each | each]) = (OrderedCollection with: exp base with: exp)).!

testDoMapping

	| exp |
	exp := MappingExpression new.
	exp named: 'foo' basedOn: BaseExpression new.
	self assert: ((exp collect: [:each | each]) = (OrderedCollection with: exp base with: exp)).!

testDoParameter

	| exp |
	exp := ParameterExpression new.
	exp field: nil base: BaseExpression new.
	self assert: ((exp collect: [:each | each]) = (OrderedCollection with: exp base with: exp)).!

testDoRelation

	| exp l r |
	exp := RelationExpression new.
	l := BaseExpression new.
	r := BaseExpression new.
	exp leftChild: l; rightChild: r.
	self assert: ((exp collect: [:each | each]) = (OrderedCollection with: l with: r with: exp)).!

testDoTable

	| exp |
	exp := TableExpression new.
	exp table: nil base: BaseExpression new.
	self assert: ((exp collect: [:each | each]) = (OrderedCollection with: exp base with: exp)).!

testDoWithCommonBase

	| exp l r base |
	exp := RelationExpression new.
	base := BaseExpression new.
	l := MappingExpression new.
	l named: nil basedOn: base.
	r := MappingExpression new.
	r named: nil basedOn: base.
	exp leftChild: l; rightChild: r.	
	self assert: ((exp collect: [:each | each]) = (OrderedCollection with: base with: l with: r with: exp)).! !
!GlorpExpressionIterationTest categoriesFor: #helpTestSingleNodeDo:!private!tests! !
!GlorpExpressionIterationTest categoriesFor: #testDoBase!private!tests! !
!GlorpExpressionIterationTest categoriesFor: #testDoCollection!private!tests! !
!GlorpExpressionIterationTest categoriesFor: #testDoConstant!private!tests! !
!GlorpExpressionIterationTest categoriesFor: #testDoField!private!tests! !
!GlorpExpressionIterationTest categoriesFor: #testDoMapping!private!tests! !
!GlorpExpressionIterationTest categoriesFor: #testDoParameter!private!tests! !
!GlorpExpressionIterationTest categoriesFor: #testDoRelation!private!tests! !
!GlorpExpressionIterationTest categoriesFor: #testDoTable!private!tests! !
!GlorpExpressionIterationTest categoriesFor: #testDoWithCommonBase!private!tests! !

GlorpExpressionRebuildingTest guid: (GUID fromString: '{5156DEDC-46C1-4949-A682-8F9FED86A138}')!
GlorpExpressionRebuildingTest comment: ''!
!GlorpExpressionRebuildingTest categoriesForClass!Unclassified! !
!GlorpExpressionRebuildingTest methodsFor!

setUp
	super setUp.
	newBase := BaseExpression new.!

testLoneBase
	original := BaseExpression new.
	rebuilt := original rebuildOn: newBase.
	self assert: rebuilt == newBase.!

testMapping
	original := [:each | each foo] asGlorpExpression.
	rebuilt := original rebuildOn: newBase.
	self assert: rebuilt base == newBase.!

testRebuildDoubleInnerScopeNormallyWithExists
	original := [:each | 
	each foo
		anySatisfyExists:
			[:eachFoo | eachFoo things anySatisfyExists: [:eachThing | eachThing stuff = each fooThing]]]
		asGlorpExpression.
	rebuilt := original rebuildOn: newBase.
	rebuilt do: [:each | self assert: each ultimateBaseExpression == newBase].!

testRebuildDoubleInnerScopeNormallyWithJoins
	original := [:each | 
	each foo
		anySatisfyJoin:
			[:eachFoo | eachFoo things anySatisfyJoin: [:eachThing | eachThing stuff = each fooThing]]]
		asGlorpExpression.
	rebuilt := original rebuildOn: newBase.
	rebuilt do: [:each | self assert: each ultimateBaseExpression == newBase].!

testRebuildInnerScopeForSubquery

	| foo |
	original := [:each | each foo anySatisfyJoin: [:eachFoo | eachFoo thing = each fooThing]] asGlorpExpression.
	"Just so that it prints distinctively"
	original ultimateBaseExpression descriptor: (Descriptor new classModel: (GlorpClassModel for: Object)).
	foo := original leftChild.
	newBase := SubSelectBaseExpression on: foo.
	rebuilt := original rightChild rebuildOn: newBase startingFrom: foo.
	self assert: rebuilt leftChild base == newBase.
	self assert: rebuilt leftChild ultimateBaseExpression == original ultimateBaseExpression.
	self assert: rebuilt rightChild base == original ultimateBaseExpression.!

testRebuildInnerScopeNormally
	original := [:each | each foo anySatisfy: [:eachFoo | eachFoo thing = each fooThing]]
		asGlorpExpression.
	rebuilt := original rebuildOn: newBase.
	rebuilt do: [:each | self assert: each ultimateBaseExpression == newBase].!

testRebuildMappingWithStart

	original := [:each | each foo bar] asGlorpExpression.
	rebuilt := original rebuildOn: newBase startingFrom: original base.
	self assert: rebuilt base == newBase.!

testRelation
	original := [:each | each foo bar = each foo bletch] asGlorpExpression.
	rebuilt := original rebuildOn: newBase.
	self assert: rebuilt ultimateBaseExpression == newBase.
	self assert: rebuilt leftChild ultimateBaseExpression == newBase.
	self assert: rebuilt rightChild ultimateBaseExpression == newBase.
	self assert: rebuilt leftChild base base == newBase.! !
!GlorpExpressionRebuildingTest categoriesFor: #setUp!private!support! !
!GlorpExpressionRebuildingTest categoriesFor: #testLoneBase!private!tests! !
!GlorpExpressionRebuildingTest categoriesFor: #testMapping!private!tests! !
!GlorpExpressionRebuildingTest categoriesFor: #testRebuildDoubleInnerScopeNormallyWithExists!private!tests-outer scope references! !
!GlorpExpressionRebuildingTest categoriesFor: #testRebuildDoubleInnerScopeNormallyWithJoins!private!tests-outer scope references! !
!GlorpExpressionRebuildingTest categoriesFor: #testRebuildInnerScopeForSubquery!private!tests-outer scope references! !
!GlorpExpressionRebuildingTest categoriesFor: #testRebuildInnerScopeNormally!private!tests-outer scope references! !
!GlorpExpressionRebuildingTest categoriesFor: #testRebuildMappingWithStart!private!tests-outer scope references! !
!GlorpExpressionRebuildingTest categoriesFor: #testRelation!private!tests! !

GlorpFilteredInheritanceTest guid: (GUID fromString: '{E2D21422-1FE0-4CFE-AB22-E00BF2C07CF6}')!
GlorpFilteredInheritanceTest comment: ''!
!GlorpFilteredInheritanceTest categoriesForClass!Unclassified! !
!GlorpFilteredInheritanceTest methodsFor!

compareEmployees: employees

	employees do: [:each |
		| corresponding |
		corresponding := allEmployees detect: [:eachOriginal | each id = eachOriginal id].
		self assert: corresponding = each].!

makeSupertaxIn: aCollection
	| previous newTax |
	previous := aCollection last.
	newTax := (GlorpBasicTax new)
		name: (String with: (Character value: previous name first asInteger + 1));
		yourself.
	previous addTax: newTax.
	aCollection add: newTax.!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	session system: (GlorpInheritanceDescriptorSystem forPlatform: GlorpDatabaseLoginResource defaultLogin database).!

tearDown
	super tearDown.
	session reset.
	session := nil.!

testCacheLookup
	"Ask for an Employee which should be from the cache and which should return a Manager."

	| manager employee |
	session beginTransaction.
	
	[session beginUnitOfWork.
	self writeTestHarness.
	session commitUnitOfWork.
	session initializeCache.
	manager := session readOneOf: GlorpManager
				where: [:each | each id = 3 ].
	self assert: (session cacheLookupForClass: GlorpEmployee key: 3) == manager.
	employee := session readOneOf: GlorpEmployee
				where: [:each | each id = 3 ].
	self assert: employee == manager.

	manager := session readOneOf: GlorpRegionalManager
				where: [:each | each id = 12 ].
	employee := session readOneOf: GlorpEmployee
				where: [:each | each id = 12 ].
	self assert: employee == manager.

	employee := session readOneOf: GlorpManager
				where: [:each | each id = 11 ].
	manager := session readOneOf: GlorpEmployee
				where: [:each | each id = 11 ].
	self assert: employee == manager.

	"Test that the cache refuses to return an object which is not of the proper class or subclass."
	employee := session readOneOf: GlorpEmployee
				where: [:each | each id = 4 ].
	self assert: (session privateGetCache lookupClass: GlorpRegionalManager key: 4 ifAbsent: []) isNil.
	manager := session readOneOf: GlorpRegionalManager
				where: [:each | each id = 4 ].
	self assert: manager isNil.

	"Proxys seem to try a cache lookup before they execute their query...can we write a test which fails due to this?"] 
			ensure: [session rollbackTransaction]!

testDirectQuery
	"Ask for all Employees, see if we get subclasses too"

	| employees offices |
	session beginTransaction.
	
	[session beginUnitOfWork.
	self writeTestHarness.
	session commitUnitOfWork.
	session initializeCache.
	employees := true 
				ifTrue: [session readManyOf: GlorpEmployee where: [:each | each name = 'Bob']]
				ifFalse: [session halt readManyOf: GlorpEmployee].
	self assert: employees size = 8.
	self 
		assert: (employees select: [:emp | emp isMemberOf: GlorpEmployee]) size = 1.
	self assert: (employees select: [:emp | emp isMemberOf: GlorpManager]) size = 2.
	self 
		assert: (employees select: [:emp | emp isMemberOf: GlorpLineWorker]) size = 4.
	self 
		assert: (employees select: [:emp | emp isMemberOf: GlorpRegionalManager]) size 
				= 1.
	self compareEmployees: employees.
	session initializeCache.
	offices := session readOneOf: GlorpOffice
				where: [:each | each employeeOfMonth name = 'Bob'].	"There is no regional manager with id = 4 but we can ensure that the type info is getting into the query's key by asking for one and seeing that it doesn't exist"
	session initializeCache.
	self 
		assert: (session readOneOf: GlorpRegionalManager where: [:each | each id = 4]) 
				== nil] 
			ensure: [session rollbackTransaction]!

testDirectQuery2
	"Ask for all Employees, see if we get subclasses too"

	| employees |
	session beginTransaction.
	
	[session beginUnitOfWork.
	self writeTestHarness.
	session commitUnitOfWork.
	session initializeCache.
	employees := session readManyOf: GlorpEmployee.
	self assert: employees size = 12.
	self 
		assert: (employees select: [:emp | emp isMemberOf: GlorpEmployee]) size = 2.
	self assert: (employees select: [:emp | emp isMemberOf: GlorpManager]) size = 3.
	self 
		assert: (employees select: [:emp | emp isMemberOf: GlorpLineWorker]) size = 5.
	self 
		assert: (employees select: [:emp | emp isMemberOf: GlorpRegionalManager]) size 
				= 2.
] 
			ensure: [session rollbackTransaction]!

testDirectQueryWithAbstractClass
	| fromdb |
	session beginTransaction.
	[session inUnitOfWorkDo: [	session register: (GlorpBasicTax new name: 'Tax'; yourself).
								session register: (GlorpSurcharge new name: 'Surcharge'; yourself)].
	session reset.
	fromdb := session readManyOf: GlorpTax.
	self assert: fromdb size = 2.
	self assert: (fromdb select: [:emp | emp isMemberOf: GlorpTax]) isEmpty.
	self assert: (fromdb select: [:emp | emp isMemberOf: GlorpBasicTax]) size = 1.
	self assert: (fromdb select: [:emp | emp isMemberOf: GlorpSurcharge]) size = 1] 
			ensure: [session rollbackTransaction]!

testNotInSelect
	"Ask for an Employee which should be from the cache and which should return a Manager."

	| testEmployees |
	session beginTransaction.
	
	[session beginUnitOfWork.
	self writeTestHarness.
	session commitUnitOfWork.
	testEmployees := session readManyOf: GlorpManager
				where: [:each | each id notIn: #(1 2 3)].
	self assert: testEmployees notEmpty

	"Proxys seem to try a cache lookup before they execute their query...can we write a test which fails due to this?"] 
			ensure: [session rollbackTransaction]!

testOrderBy
	| employees query |
	session beginTransaction.
	
	[session beginUnitOfWork.
	self writeTestHarness.
	session commitUnitOfWork.
	query := Query returningManyOf: GlorpEmployee
				where: [:each | each id <= 4].
	query orderBy: #name.
	query orderBy: #id.
	employees := session execute: query.
	self assert: (employees asSortedCollection: [:a :b | a name = b name ifTrue: [
		a id <= b id] ifFalse: [a name < b name]]) asArray = employees]
			ensure: [session rollbackTransaction]!

testRelationshipQuery
	"Ask for all Employees in a given office and test that the return types are correct."

	| employees office |
	session beginTransaction.
	
	[session beginUnitOfWork.
	self writeTestHarness.
	session commitUnitOfWork.
	session initializeCache.
	office := session readOneOf: GlorpOffice
				where: [:each | each id = 1 ].
	employees := office employees.
	self assert: employees size = 6.
	self assert: (employees select: [:emp | emp isMemberOf: GlorpEmployee]) size = 2.
	self assert: (employees select: [:emp | emp isMemberOf: GlorpManager]) size = 1.
	self assert: (employees select: [:emp | emp isMemberOf: GlorpLineWorker]) size = 2.
	self assert: (employees select: [:emp | emp isMemberOf: GlorpRegionalManager]) size = 1] 
			ensure: [session rollbackTransaction]!

testTaxInsertOrdering
	| taxes first |
	taxes := OrderedCollection new.
	first := (GlorpBasicTax new)
		name: 'A';
		yourself.
	taxes add: first.
	10 timesRepeat: [self makeSupertaxIn: taxes].
	[session beginTransaction.
	session inUnitOfWorkDo: [session registerAll: taxes]]
		ensure: [session rollbackTransaction].!

writeTestHarness
	| office1 office2  eom1 eom2 jim bob |
	session register: (office1 := GlorpOffice new id: 1; yourself).
	session register: (office2 := GlorpOffice new id: 2; yourself).
	office1 addEmployee: (eom1 := GlorpEmployee new id: 1; name: 'Bob'; yourself).
	office1 addEmployee: (GlorpEmployee new id: 2; name: 'Jim'; yourself).
	office1 addEmployee: (GlorpManager new id: 3; name: 'Bob'; branch: 'West'; yourself).
	office2 addEmployee: (eom2 := GlorpManager new id: 4; name: 'Steve'; branch: 'East'; yourself).
	office2 addEmployee: (GlorpManager new id: 5; name: 'Bob'; branch: 'South'; yourself).
	office1 addEmployee: (GlorpLineWorker new id: 6; name: 'Wally'; productionLine: 'Gold'; yourself).
	office1 addEmployee: (GlorpLineWorker new id: 7; name: 'Bob'; productionLine: 'Silver'; yourself).
	office2 addEmployee: (GlorpLineWorker new id: 8; name: 'Bob'; productionLine: 'Tin'; yourself).
	office2 addEmployee: (GlorpLineWorker new id: 9; name: 'Bob'; productionLine: 'Copper'; yourself).
	office2 addEmployee: (GlorpLineWorker new id: 10; name: 'Bob'; productionLine: 'Steel'; yourself).
	office1 addEmployee: (GlorpRegionalManager new id: 11; name: 'Bob'; branch: 'South'; region: 'MidWest'; yourself).
	office2 addEmployee: (GlorpRegionalManager new id: 12; name: 'Mike'; branch: 'North'; region: 'NorthEast'; yourself).
	office1 employeeOfMonth: eom1.
	office2 employeeOfMonth: eom2.

	session register: (jim := GlorpWorkingStiff new id: 13; name: 'Jim'; yourself).
	session register: (bob := GlorpWorkingStiff new id: 14; name: 'Bob'; yourself).

	allEmployees := (Array with: jim with: bob), office1 employees, office2 employees.! !
!GlorpFilteredInheritanceTest categoriesFor: #compareEmployees:!private!tests! !
!GlorpFilteredInheritanceTest categoriesFor: #makeSupertaxIn:!private!tests! !
!GlorpFilteredInheritanceTest categoriesFor: #setUp!private!support! !
!GlorpFilteredInheritanceTest categoriesFor: #tearDown!private!support! !
!GlorpFilteredInheritanceTest categoriesFor: #testCacheLookup!private!tests! !
!GlorpFilteredInheritanceTest categoriesFor: #testDirectQuery!private!tests! !
!GlorpFilteredInheritanceTest categoriesFor: #testDirectQuery2!private!tests! !
!GlorpFilteredInheritanceTest categoriesFor: #testDirectQueryWithAbstractClass!private!tests! !
!GlorpFilteredInheritanceTest categoriesFor: #testNotInSelect!private!tests! !
!GlorpFilteredInheritanceTest categoriesFor: #testOrderBy!private!tests! !
!GlorpFilteredInheritanceTest categoriesFor: #testRelationshipQuery!private!tests! !
!GlorpFilteredInheritanceTest categoriesFor: #testTaxInsertOrdering!private!tests! !
!GlorpFilteredInheritanceTest categoriesFor: #writeTestHarness!private!support! !

!GlorpFilteredInheritanceTest class methodsFor!

resources
	^Array with: GlorpDatabaseLoginResource with: GlorpDemoTablePopulatorResource with: (Smalltalk at: #GlorpSessionResource)! !
!GlorpFilteredInheritanceTest class categoriesFor: #resources!private!resources! !

GlorpHorizontalInheritanceTest guid: (GUID fromString: '{945E679C-5F98-4F20-8194-09C70C5175FE}')!
GlorpHorizontalInheritanceTest comment: ''!
!GlorpHorizontalInheritanceTest categoriesForClass!Unclassified! !
!GlorpHorizontalInheritanceTest methodsFor!

setUp
	super setUp.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	session system: (GlorpInheritanceDescriptorSystem forPlatform: GlorpDatabaseLoginResource defaultLogin database).
	session beginTransaction.!

tearDown
	session rollbackTransaction.
	super tearDown.
	session reset.!

testClassSelection

	| classes |
	classes := (session system descriptorFor: GlorpInventoryItem) classesRequiringIndependentQueries collect: [:each | each name ].
	self assert: classes size = 3.
	#(#GlorpNonperishableItem #GlorpPerishableItem #GlorpUnassembledItem) do: [:name |
		self assert: (classes includes: name) ].

	classes := (session system descriptorFor: GlorpPerishableItem) classesRequiringIndependentQueries collect: [:each | each name ].
	self assert: classes size = 1.
	#(#GlorpPerishableItem) do: [:name |
		self assert: (classes includes: name) ].

	classes := (session system descriptorFor: GlorpNonperishableItem) classesRequiringIndependentQueries collect: [:each | each name ].
	self assert: classes size = 2.
	#(#GlorpNonperishableItem #GlorpUnassembledItem) do: [:name |
		self assert: (classes includes: name)].!

testDirectQuery

	| items query |
	self writeTestHarness.
	query := Query readManyOf: GlorpInventoryItem
				where: [:each | each name = 'TV'].
	items := session execute: query.
	self assert: items size = 1.
	self assert: (items select: [:emp | emp isMemberOf: GlorpNonperishableItem]) size = 1.

	session reset.
	items := session readManyOf: GlorpInventoryItem
				where: [:each | each name = 'bicycle'].
	self assert: items size = 1.
	self assert: (items select: [:emp | emp isMemberOf: GlorpUnassembledItem]) size = 1.

	session reset.
	items := session readManyOf: GlorpPerishableItem
				where: [:each | each name = 'bicycle'].
	self assert: items size = 0.!

testDirectSingleQueryForSubclasses

	| items query |
	self writeTestHarness.
	(session system descriptorFor: GlorpInventoryItem) typeResolver useSingleQuery: true.
	query := Query readManyOf: GlorpInventoryItem
				where: [:each | each name = 'TV'].
	items := session execute: query.
	self assert: items size = 1.
	self assert: (items select: [:emp | emp isMemberOf: GlorpNonperishableItem]) size = 1.

	session reset.
	items := session readManyOf: GlorpInventoryItem
				where: [:each | each name = 'bicycle'].
	self assert: items size = 1.
	self assert: (items select: [:emp | emp isMemberOf: GlorpUnassembledItem]) size = 1.

	session reset.
	items := session readManyOf: GlorpPerishableItem
				where: [:each | each name = 'bicycle'].
	self assert: items size = 0.!

testDirectSingleQueryForSubclassesNoWhereClause

	| items query normalResult filtered |
	self writeTestHarness.
	(session system descriptorFor: GlorpInventoryItem) typeResolver useSingleQuery: true.
	query := Query readManyOf: GlorpInventoryItem.
	items := session execute: query.
	self assert: items size = 7.
	GlorpInventoryItem allSubclasses do: [:each |
		normalResult := session read: each.
		filtered := items select: [:other | other isKindOf: each].
		self assert: normalResult size = filtered size].!

testForwardLookup
	| image |
	self writeTestHarnessForTags.
	image := session
				readOneOf: GlorpImage
				where: [:each | each location = 'testlocation'].
	self assert: image tags size = 2.
	self assert: (image tags anySatisfy: [:tag| tag key = 'first']).
	self assert: (image tags anySatisfy: [:tag| tag key = 'second']).!

testNilVariableJoin
	| warehouse |
	self writeTestHarness.
	warehouse := session readOneOf: GlorpWarehouse
				where: [:each | each address = '123 Some Ave.'].
	session beginUnitOfWork.
	session register: warehouse.
	warehouse currentItem: nil.
	session commitUnitOfWork.
	session reset.
	warehouse := session readOneOf: GlorpWarehouse
				where: [:each | each address = '123 Some Ave.'].
	self assert: warehouse currentItem isNil!

testOrderBy
	"We can't use database-level ordering in horizontal inheritance because it does multiple queries. We could, I suppose, sort after the fact, but we don't right now"

	| items query |
	query := Query returningManyOf: GlorpInventoryItem
				where: [:each | each id <= 4].
	query orderBy: #name.
	self should: [items := session execute: query] raise: Dialect error.!

testReadNonAbstractPolymorphic
	"This test excercises a problem that existed with MappingExpression caching its mapping
	and which was then copied to the newly created MappingExpressions for subclasses.
	This isn't a problem when reading from an abstract class since there are no mappings to cache."

	| wagon |
	
	self writeTestHarness.
	wagon := session readOneOf: GlorpNonperishableItem where: [:each | each name = 'wagon'].
	self should: [wagon serialNumber = 99958]!

testReadRelationship
	| warehouse |
	
	self writeTestHarness.
	warehouse := session readOneOf: GlorpWarehouse
				where: [:each | each address = '123 Some Ave.'].
	self assert: warehouse address = '123 Some Ave.'.
	self assert: warehouse currentItem name = 'squash'.
	self assert: (warehouse items collect: [:each | each name]) asSortedCollection asArray = #('apples' 'bicycle' 'fridge').!

testReadRelationshipSingleQuery
	| warehouse |

	(session system descriptorFor: GlorpInventoryItem) typeResolver useSingleQuery: true.	
	self writeTestHarness.
	warehouse := session readOneOf: GlorpWarehouse
				where: [:each | each address = '123 Some Ave.'].
	self assert: warehouse address = '123 Some Ave.'.
	self assert: warehouse currentItem name = 'squash'.
	self assert: (warehouse items collect: [:each | each name]) asSortedCollection asArray = #('apples' 'bicycle' 'fridge').!

testReverseLookup
	| image |
	self writeTestHarnessForTags.
	image := session
				readOneOf: GlorpImage
				where: [:each | each tags anySatisfy: [:tag| tag key = 'third']].
	self assert: image tags size = 2.
	self assert: (image tags anySatisfy: [:tag| tag key = 'first'])not.
	self assert: (image tags anySatisfy: [:tag| tag key = 'second']).!

testTagObjectLookup
	| image |
	self writeTestHarnessForTags.
	image := session
				readOneOf: GlorpTaggableObject
				where: [:each | each tags
						anySatisfy: [:tag | tag key = 'third']].
	self assert: image tags size = 2.
	self assert: (image tags
			anySatisfy: [:tag | tag key = 'first']) not.
	self
		assert: (image tags
				anySatisfy: [:tag | tag key = 'second'])!

writeTestHarness

	| squash apples fridge bicycle warehouse |
	session inUnitOfWorkDo: [
	session register: (squash := GlorpPerishableItem new id: 1; name: 'squash'; age: 10; yourself).
	session register: (GlorpPerishableItem new id: 2; name: 'zucchini'; age: 14; yourself).
	session register: (apples := GlorpPerishableItem new id: 3; name: 'apples'; age: 4; yourself).
	session register: (GlorpNonperishableItem new id: 4; name: 'TV'; serialNumber: 56893; yourself).
	session register: (fridge := GlorpNonperishableItem new id: 5; name: 'fridge'; serialNumber: 12345; yourself).
	session register: (bicycle := GlorpUnassembledItem new id: 6; name: 'bicycle'; serialNumber: 83754; assemblyCost: 100; yourself).
	session register: (GlorpUnassembledItem new id: 7; name: 'wagon'; serialNumber: 99958; assemblyCost: 20; yourself).
	warehouse := GlorpWarehouse new.
	warehouse address: '123 Some Ave.'.
	warehouse currentItem: squash.
	warehouse items: (Array with: apples with: fridge with: bicycle).
	session register: warehouse].
	session reset.!

writeTestHarnessForTags

	| tag1 tag2 tag3 image1 image2 |
	session inUnitOfWorkDo: [
		tag1 := GlorpTag new label: 'First'; generateKeyFromLabel.
		tag2 := GlorpTag new label: 'Second'; generateKeyFromLabel.
		tag3 := GlorpTag new label: 'Third'; generateKeyFromLabel.

		image1 := GlorpImage new location: 'testlocation'.
		session register: image1.
	
		image1 tags add: tag1.
		image1 tags add: tag2.
	
		image2 := GlorpImage new location: 'testlocation2'.
		session register: image2.
	
		image2 tags add: tag2.
		image2 tags add: tag3].
	session reset.! !
!GlorpHorizontalInheritanceTest categoriesFor: #setUp!private!support! !
!GlorpHorizontalInheritanceTest categoriesFor: #tearDown!private!support! !
!GlorpHorizontalInheritanceTest categoriesFor: #testClassSelection!private!tests! !
!GlorpHorizontalInheritanceTest categoriesFor: #testDirectQuery!private!tests! !
!GlorpHorizontalInheritanceTest categoriesFor: #testDirectSingleQueryForSubclasses!public!tests! !
!GlorpHorizontalInheritanceTest categoriesFor: #testDirectSingleQueryForSubclassesNoWhereClause!public!tests! !
!GlorpHorizontalInheritanceTest categoriesFor: #testForwardLookup!private!tests - tags! !
!GlorpHorizontalInheritanceTest categoriesFor: #testNilVariableJoin!private!tests! !
!GlorpHorizontalInheritanceTest categoriesFor: #testOrderBy!private!tests! !
!GlorpHorizontalInheritanceTest categoriesFor: #testReadNonAbstractPolymorphic!private!tests! !
!GlorpHorizontalInheritanceTest categoriesFor: #testReadRelationship!private!tests! !
!GlorpHorizontalInheritanceTest categoriesFor: #testReadRelationshipSingleQuery!public!tests! !
!GlorpHorizontalInheritanceTest categoriesFor: #testReverseLookup!private!tests - tags! !
!GlorpHorizontalInheritanceTest categoriesFor: #testTagObjectLookup!private!tests - tags! !
!GlorpHorizontalInheritanceTest categoriesFor: #writeTestHarness!private!support! !
!GlorpHorizontalInheritanceTest categoriesFor: #writeTestHarnessForTags!private!support! !

!GlorpHorizontalInheritanceTest class methodsFor!

resources
	^Array with: GlorpDatabaseLoginResource with: GlorpDemoTablePopulatorResource with: (Smalltalk at: #GlorpSessionResource)! !
!GlorpHorizontalInheritanceTest class categoriesFor: #resources!private!resources! !

GlorpMappingFromClassModelTests guid: (GUID fromString: '{8D55AA1A-A878-45B5-A088-1722D665DA8A}')!
GlorpMappingFromClassModelTests comment: ''!
!GlorpMappingFromClassModelTests categoriesForClass!Unclassified! !
!GlorpMappingFromClassModelTests methodsFor!

setUp
	platform := PostgreSQLPlatform new.
	system := DynamicDescriptorSystem forPlatform: platform!

someCode
	| model descriptor mapping table |
	table := DatabaseTable named: 'TYPETESTS'.
	table createFieldNamed: 'test' type: system platform boolean.
	model := system addClassModelFor: GlorpTypeTestsModelClass.
	model newAttributeNamed: #test type: Boolean.
	system privateTableAt: table name put: table.
	descriptor := Descriptor new.
	descriptor system: system.
	descriptor classModel: model.
	descriptor table: table.
	descriptor 
		addMapping: (DirectMapping from: #id to: (table fieldNamed: 'id')).
	Boolean isNil 
		ifTrue: [mapping := DirectMapping from: #test to: (table fieldNamed: 'test')]
		ifFalse: 
			[mapping := DirectMapping 
						from: #test
						type: Boolean
						to: (table fieldNamed: 'test')].
	descriptor addMapping: mapping.
	system privateDescriptorAt: GlorpTypeTestsModelClass put: descriptor.
	^system!

testAllAttributes
	| bankTransTable customerTable ownerId btOwnerId customerModel customerDescriptor attributes |
	bankTransTable := system addEmptyTableNamed: 'BANK_TRANS'.
	customerTable := system addEmptyTableNamed: 'GR_CUSTOMER'.
	ownerId := customerTable createFieldNamed: 'ID' type: platform int4.
	btOwnerId := bankTransTable createFieldNamed: 'OWNER_ID'
				type: platform int4.
	bankTransTable addForeignKeyFrom: btOwnerId to: ownerId.
	customerModel := system addClassModelFor: GlorpCustomer.
	customerModel newAttributeNamed: #id type: Integer.
	customerModel newAttributeNamed: #transactions
		collectionOf: GlorpBankTransaction.
	system addClassModelFor: GlorpBankTransaction.
	system addEmptyDescriptorFor: GlorpBankTransaction.
	(system descriptorFor: GlorpBankTransaction) table: (system tableNamed: 'BANK_TRANS').
	customerDescriptor := system addEmptyDescriptorFor: GlorpCustomer.
	customerDescriptor table: customerTable.
	system createMappingsFromClassModelIn: customerDescriptor.
	self assert: (customerDescriptor mappingForAttributeNamed: #id) notNil.
	self 
		assert: (customerDescriptor mappingForAttributeNamed: #transactions) notNil.
	system validate.
	attributes := OrderedCollection new.
	customerDescriptor classModel attributesDo: [:each | attributes add: each].
	self assert: attributes size = 2.!

testAllAttributesSkipDefined
	| bankTransTable customerTable ownerId btOwnerId customerModel customerDescriptor ownerId2 |
	bankTransTable := system addEmptyTableNamed: 'BANK_TRANS'.
	customerTable := system addEmptyTableNamed: 'GR_CUSTOMER'.
	ownerId := customerTable createFieldNamed: 'ID' type: platform int4.
	ownerId2 := customerTable createFieldNamed: 'ID2' type: platform int4.
	btOwnerId := bankTransTable createFieldNamed: 'OWNER_ID'
				type: platform int4.
	bankTransTable addForeignKeyFrom: btOwnerId to: ownerId.
	customerModel := system addClassModelFor: GlorpCustomer.
	customerModel newAttributeNamed: #id type: Integer.
	customerModel newAttributeNamed: #transactions
		collectionOf: GlorpBankTransaction.
	system addClassModelFor: GlorpBankTransaction.
	system addEmptyDescriptorFor: GlorpBankTransaction.
	customerDescriptor := system addEmptyDescriptorFor: GlorpCustomer.
	customerDescriptor table: customerTable.
	(customerDescriptor newMapping: DirectMapping) from: #id to: ownerId2.
	system createMappingsFromClassModelIn: customerDescriptor.
	self assert: customerDescriptor mappings size = 2.
	self 
		assert: (customerDescriptor mappingForAttributeNamed: #id) field = ownerId2!

testDirectMapping
	| customerTable ownerId descriptor mapping customerModel |
	customerTable := system addEmptyTableNamed: 'GR_CUSTOMER'.
	ownerId := customerTable createFieldNamed: 'ID' type: platform int4.
	customerModel := system addClassModelFor: GlorpCustomer.
	customerModel newAttributeNamed: #id type: Integer.
	descriptor := system addEmptyDescriptorFor: GlorpCustomer.
	descriptor table: customerTable.
	system createMappingIn: descriptor fromClassModelForAttributeNamed: #id.
	mapping := descriptor mappingForAttributeNamed: #id.
	self assert: mapping class = DirectMapping.
	self assert: mapping field = ownerId!

testDirectMappingNameFieldNameComputation
	| customerTable ownerId descriptor mapping customerModel |
	customerTable := system addEmptyTableNamed: 'GR_CUSTOMER'.
	ownerId := customerTable createFieldNamed: 'OWNER_ID' type: platform int4.
	customerModel := system addClassModelFor: GlorpCustomer.
	customerModel newAttributeNamed: #id type: Integer.
	descriptor := system addEmptyDescriptorFor: GlorpCustomer.
	descriptor table: customerTable.
	system attributeNameToFieldNameBlock: [:symbol | 'OWNER_ID'].
	system createMappingIn: descriptor fromClassModelForAttributeNamed: #id.
	mapping := descriptor mappingForAttributeNamed: #id.
	self assert: mapping class = DirectMapping.
	self assert: mapping field = ownerId!

testOneToOneRelation
	| bankTransTable customerTable ownerId btOwnerId bankTransModel descriptor mapping |
	bankTransTable := system addEmptyTableNamed: 'BANK_TRANS'.
	customerTable := system addEmptyTableNamed: 'GR_CUSTOMER'.
	ownerId := customerTable createFieldNamed: 'ID' type: platform int4.
	btOwnerId := bankTransTable createFieldNamed: 'OWNER_ID'
				type: platform int4.
	bankTransTable addForeignKeyFrom: btOwnerId to: ownerId.
	system
		addClassModelFor: GlorpCustomer;
		addEmptyDescriptorFor: GlorpCustomer.
	bankTransModel := system addClassModelFor: GlorpBankTransaction.
	bankTransModel newAttributeNamed: #owner type: GlorpCustomer.
	descriptor := system addEmptyDescriptorFor: GlorpBankTransaction.
	descriptor table: bankTransTable.
	system createMappingIn: descriptor fromClassModelForAttributeNamed: #owner.
	mapping := descriptor mappingForAttributeNamed: #owner.
	self assert: mapping class = OneToOneMapping!

testToManyRelation
	| bankTransTable customerTable ownerId btOwnerId mapping customerModel customerDescriptor |
	bankTransTable := system addEmptyTableNamed: 'BANK_TRANS'.
	customerTable := system addEmptyTableNamed: 'GR_CUSTOMER'.
	ownerId := customerTable createFieldNamed: 'ID' type: platform int4.
	btOwnerId := bankTransTable createFieldNamed: 'OWNER_ID'
				type: platform int4.
	bankTransTable addForeignKeyFrom: btOwnerId to: ownerId.
	customerModel := system addClassModelFor: GlorpCustomer.
	customerModel newAttributeNamed: #transactions
		collectionOf: GlorpBankTransaction.
	system addClassModelFor: GlorpBankTransaction.
	system addEmptyDescriptorFor: GlorpBankTransaction.
	customerDescriptor := system addEmptyDescriptorFor: GlorpCustomer.
	customerDescriptor table: customerTable.
	system createMappingIn: customerDescriptor
		fromClassModelForAttributeNamed: #transactions.
	mapping := customerDescriptor mappingForAttributeNamed: #transactions.
	self assert: mapping class = ToManyMapping.
	self assert: mapping referenceClass = GlorpBankTransaction! !
!GlorpMappingFromClassModelTests categoriesFor: #setUp!private!running! !
!GlorpMappingFromClassModelTests categoriesFor: #someCode!private!Tests! !
!GlorpMappingFromClassModelTests categoriesFor: #testAllAttributes!private!Tests! !
!GlorpMappingFromClassModelTests categoriesFor: #testAllAttributesSkipDefined!private!Tests! !
!GlorpMappingFromClassModelTests categoriesFor: #testDirectMapping!private!Tests! !
!GlorpMappingFromClassModelTests categoriesFor: #testDirectMappingNameFieldNameComputation!private!Tests! !
!GlorpMappingFromClassModelTests categoriesFor: #testOneToOneRelation!private!Tests! !
!GlorpMappingFromClassModelTests categoriesFor: #testToManyRelation!private!Tests! !

GlorpMessageCollectorTest guid: (GUID fromString: '{FC4744B5-05F6-4B73-A6DC-C7651514C536}')!
GlorpMessageCollectorTest comment: ''!
!GlorpMessageCollectorTest categoriesForClass!Unclassified! !
!GlorpMessageCollectorTest methodsFor!

messageCollectorDNUObjectStudio
	| caught |
	caught := false.
	[collector basicDoesNotUnderstand: #foo args: #()] on: MessageNotUnderstood
		do: [:signal | caught := true. signal sunitExitWith: nil].
	self assert: caught!

setUp
	super setUp.
	collector := MessageArchiver new!

testExpressionCreation
	| exp |
	exp := collector foo asGlorpExpression.
	self assert: exp name == #foo.
	self assert: exp base class == BaseExpression!

testMessageCollectorDNU
	| message caught |
	message := Message selector: #foo arguments: #().
	caught := false.
	[collector basicDoesNotUnderstand: message]
		on: MessageNotUnderstood
		do:
			[:signal | 
			caught := true.
			signal sunitExitWith: nil].
	self assert: caught!

testMessageIntercept

	| foo |
	foo := collector foo.
	self assert: foo privateGlorpSelector == #foo.
	self assert: foo privateGlorpReceiver == collector.! !
!GlorpMessageCollectorTest categoriesFor: #messageCollectorDNUObjectStudio!private!tests! !
!GlorpMessageCollectorTest categoriesFor: #setUp!private!support! !
!GlorpMessageCollectorTest categoriesFor: #testExpressionCreation!private!tests! !
!GlorpMessageCollectorTest categoriesFor: #testMessageCollectorDNU!public!tests! !
!GlorpMessageCollectorTest categoriesFor: #testMessageIntercept!private!tests! !

GlorpObjectTransactionTest guid: (GUID fromString: '{19953095-12AB-46F0-8C16-AB668B263BA2}')!
GlorpObjectTransactionTest comment: ''!
!GlorpObjectTransactionTest categoriesForClass!Unclassified! !
!GlorpObjectTransactionTest methodsFor!

setUp

	transaction := ObjectTransaction new!

testArray
	| object |
	object := #(1 2 3 4 5) copy.
	transaction begin.
	transaction register: object.
	object
		at: 1 put: #one;
		at: 2 put: object.
	transaction abort.
	self
		assert: (object at: 1) == 1;
		assert: (object at: 2) == 2!

testBecome
	| object |
	object := 'hello' copy.
	transaction begin.
	transaction register: object.
	object become: Set new.
	transaction abort.
	self 
		assert: object class == '' class;
		assert: object = 'hello'.!

testCommit
	| array |
	array := #(1 2 3 4 5) copy.
	transaction begin.
	transaction register: array.
	array
		at: 1 put: #one;
		at: 2 put: array.
	transaction commit.
	self
		assert: (array at: 1) == #one;
		assert: (array at: 2) == array!

testHashedCollection
	| object originalMembers |
	object := Set new.
	originalMembers := #(#one #two #three 'four' 5 'vi' (1 2 3 4 5 6 7)) collect: [:each | each copy].
	object addAll: originalMembers.
	transaction begin.
	transaction register: object.
	object remove: #one; remove: (originalMembers at: 4).
	object add: 1.
	originalMembers last at: 7 put: 'seven'.
	transaction abort.
	self
		assert: object size = originalMembers size;
		assert: (object includes: originalMembers first);
		assert: (object includes: (originalMembers at: 4));
		assert: object size = (object rehash; size).
	originalMembers do: [:each | self assert: (object includes: each)]!

testRegisteredObjectsDoRecursively

	| link |
	link := 1 -> (2 -> (3 -> (4 ->5))).
	transaction register: link.
	self assert: transaction undoMap size = 1.
	transaction registeredObjectsDo: [:each |
		transaction register: each value].
	self assert: transaction undoMap size = 4.!

testString
	| object |
	object := 'Hello, World!!' copy.
	transaction begin.
	transaction register: object.
	object
		at: 1 put: $h;
		at: 2 put: $E.
	transaction abort.
	self
		assert: object first  == $H;
		assert: (object at: 2) == $e! !
!GlorpObjectTransactionTest categoriesFor: #setUp!private!support! !
!GlorpObjectTransactionTest categoriesFor: #testArray!private!tests! !
!GlorpObjectTransactionTest categoriesFor: #testBecome!private!tests! !
!GlorpObjectTransactionTest categoriesFor: #testCommit!private!tests! !
!GlorpObjectTransactionTest categoriesFor: #testHashedCollection!private!tests! !
!GlorpObjectTransactionTest categoriesFor: #testRegisteredObjectsDoRecursively!private!tests! !
!GlorpObjectTransactionTest categoriesFor: #testString!private!tests! !

GlorpRowMapForMementosTest guid: (GUID fromString: '{5BD4C75E-D913-4587-9E39-1018089A251D}')!
GlorpRowMapForMementosTest comment: ''!
!GlorpRowMapForMementosTest categoriesForClass!Unclassified! !
!GlorpRowMapForMementosTest methodsFor!

setUp
	super setUp.
	a1 := IdentityHashPrintingObject new.
	b1 := IdentityHashPrintingObject new.
	c1 := IdentityHashPrintingObject new.
	transaction := ObjectTransaction new.
	transaction register: a1.
	transaction register: b1.
	transaction register: c1.
	a2 := transaction undoMap at: a1.
	b2 := transaction undoMap at: b1.
	c2 := transaction undoMap at: c1.
	rowMap := RowMapForMementos withCorrespondenceMap: transaction undoMap.
	table1 := DatabaseTable new.
	row1 := 'row1'.
	row2 := 'row2'.!

testAdjustMultipleRowMapKey
	| rowMapKey adjustedKey  |
	rowMapKey := MultipleRowMapKey with: a1 with: b1 with: c1.
	adjustedKey := rowMapKey adjustIn: rowMap correspondenceMap.
	self assert: (adjustedKey keys includes: a2).
	self assert: (adjustedKey keys includes: b2).
	self assert: (adjustedKey keys includes: c2).!

testAdjustRowMapKey
	| rowMapKey adjustedKey  |
	rowMapKey := RowMapKey new.
	rowMapKey key1: a1; key2: b1.
	adjustedKey := rowMapKey adjustIn: rowMap correspondenceMap.
	self assert: (adjustedKey key1 == a2).
	self assert: (adjustedKey key2 == b2).!

testReverseAdjustMultipleRowMapKey
	| rowMapKey adjustedKey  |
	rowMapKey := MultipleRowMapKey with: a2 with: b2 with: c2.
	adjustedKey := rowMapKey reverseAdjustIn: rowMap.
	self assert: (adjustedKey keys includes: a1).
	self assert: (adjustedKey keys includes: b1).
	self assert: (adjustedKey keys includes: c1).!

testReverseAdjustRowMapKey
	| rowMapKey adjustedKey  |
	rowMapKey := RowMapKey new.
	rowMapKey key1: a2; key2: b2.
	adjustedKey := rowMapKey reverseAdjustIn: rowMap.
	self assert: (adjustedKey key1 == a1).
	self assert: (adjustedKey key2 == b1).!

testRowForTableMultiple
	| rowMapKey row |
	rowMapKey := MultipleRowMapKey with: a1 with: b1 with: c1.
	row := rowMap findOrAddRowForTable: table1 withKey: rowMapKey.
	row1 := rowMap findOrAddRowForTable: table1 withKey: rowMapKey.
	row2 := rowMap rowForTable: table1 withKey: rowMapKey.
	self assert: row == row1.
	self assert: row == row2.!

testRowForTableSingle
	| rowMapKey row |
	rowMapKey := RowMapKey new.
	rowMapKey key1: a1; key2: b1.
	row := rowMap findOrAddRowForTable: table1 withKey: rowMapKey.
	row1 := rowMap findOrAddRowForTable: table1 withKey: rowMapKey.
	row2 := rowMap rowForTable: table1 withKey: rowMapKey.
	self assert: row == row1.
	self assert: row == row2.! !
!GlorpRowMapForMementosTest categoriesFor: #setUp!private!support! !
!GlorpRowMapForMementosTest categoriesFor: #testAdjustMultipleRowMapKey!private!tests! !
!GlorpRowMapForMementosTest categoriesFor: #testAdjustRowMapKey!private!tests! !
!GlorpRowMapForMementosTest categoriesFor: #testReverseAdjustMultipleRowMapKey!private!tests! !
!GlorpRowMapForMementosTest categoriesFor: #testReverseAdjustRowMapKey!private!tests! !
!GlorpRowMapForMementosTest categoriesFor: #testRowForTableMultiple!private!tests! !
!GlorpRowMapForMementosTest categoriesFor: #testRowForTableSingle!private!tests! !

GlorpRowMapTest guid: (GUID fromString: '{91D821C1-FC5D-4DF3-8D30-44265276C2C2}')!
GlorpRowMapTest comment: ''!
!GlorpRowMapTest categoriesForClass!Unclassified! !
!GlorpRowMapTest methodsFor!

setUp
	super setUp.
	a1 := IdentityHashPrintingObject new.
	b1 := IdentityHashPrintingObject new.
	rowMap := RowMap new.
	table1 := DatabaseTable new name: 'SomeTable'.
	platform := OraclePlatform new.
	table1 addField: (DatabaseField named: 'ONE_ID' type: platform integer) bePrimaryKey.
	table1 addField: (DatabaseField named: 'OTHER_ID' type: platform integer).
	table1 addField: (DatabaseField named: 'KEY' type: platform integer) bePrimaryKey.
	row2 := 'row2'.!

testCollapseMatchingInsertsAndDeletes
	| c1 key1 key2 row1 remainingRow updates |
	c1 := Object new.
	key1 := RowMapKey new key1: a1; key2: b1.
	key2 := RowMapKey new key1: a1; key2: c1.
	row1 := rowMap findOrAddRowForTable: table1 withKey: key1.
	row1 atFieldNamed: 'ONE_ID' put: 99.
	row1 atFieldNamed: 'OTHER_ID' put: 98.
	row1 atFieldNamed: 'KEY' put: 5.
	row2 := rowMap findOrAddRowForTable: table1 withKey: key2.
	row2 atFieldNamed: 'ONE_ID' put: 99.
	row2 atFieldNamed: 'OTHER_ID' put: 14.
	row2 atFieldNamed: 'KEY' put: 5.
	row1 forDeletion: true.
	updates := rowMap collapseMatchingInsertsAndDeletes.
	self assert: rowMap numberOfEntries = 1.
	self assert: updates size = 1.
	self assert: updates asArray first = row2.
	remainingRow := rowMap rowForTable: table1 withKey: key2 ifAbsent: [self assert: false].
	rowMap rowForTable: table1 withKey: key1 ifPresent: [:shouldntBeThereAnyMore | self assert: false].
	self assert: (remainingRow atFieldNamed: 'ONE_ID') = 99.
	self assert: (remainingRow atFieldNamed: 'OTHER_ID') = 14.
	self assert: (remainingRow atFieldNamed: 'KEY') = 5.
	self assert: remainingRow owner = key2.!

testCollapseMatchingInsertsAndDeletesWithUnknownFields
	"Check that we throw an error for unknown values in the update row"
	| c1 key1 key2 row1 |
	c1 := Object new.
	key1 := RowMapKey new key1: a1; key2: b1.
	key2 := RowMapKey new key1: a1; key2: c1.
	row1 := rowMap findOrAddRowForTable: table1 withKey: key1.
	row1 atFieldNamed: 'ONE_ID' put: 99.
	row1 atFieldNamed: 'OTHER_ID' put: 98.
	row1 atFieldNamed: 'KEY' put: 5.
	row2 := rowMap findOrAddRowForTable: table1 withKey: key2.
	row2 atFieldNamed: 'ONE_ID' put: 99.
	row2 atFieldNamed: 'KEY' put: 5.
	row1 forDeletion: true.
	self should: [rowMap collapseMatchingInsertsAndDeletes] raise: Dialect error.!

testRowForTableSingle
	| rowMapKey row |
	rowMapKey := RowMapKey new.
	rowMapKey key1: a1; key2: b1.
	row := rowMap findOrAddRowForTable: table1 withKey: rowMapKey.
	row2 := rowMap rowForTable: table1 withKey: rowMapKey.
	self assert: row == row2.! !
!GlorpRowMapTest categoriesFor: #setUp!private!support! !
!GlorpRowMapTest categoriesFor: #testCollapseMatchingInsertsAndDeletes!private!tests! !
!GlorpRowMapTest categoriesFor: #testCollapseMatchingInsertsAndDeletesWithUnknownFields!private!tests! !
!GlorpRowMapTest categoriesFor: #testRowForTableSingle!private!tests! !

GlorpRowMapUnificationTest guid: (GUID fromString: '{D086BF1E-9DFA-4C12-BBAE-74AD5D814470}')!
GlorpRowMapUnificationTest comment: ''!
!GlorpRowMapUnificationTest categoriesForClass!Unclassified! !
!GlorpRowMapUnificationTest methodsFor!

setUp

	super setUp.
	platform := GlorpDatabaseLoginResource defaultPlatform.
	t1 := DatabaseTable named: 'T1'.
	t2 := DatabaseTable named: 'T2'.
	t3 := DatabaseTable named: 'T3'.
	f1 := t1 createFieldNamed: 'f1' type: (platform varChar: 10).
	f2 := t2 createFieldNamed: 'f2' type: (platform varChar: 10).
	f3 := t3 createFieldNamed: 'f3'  type: (platform varChar: 10).
	rowMap := RowMap new.
	o1 := 'one'.
	o2 := 'two'.
	o3 := 'three'.!

testDoubleRowUnificationDifferentRows
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2.
	rowMap
		unifyField: f3
		key: o3
		withField: f2
		key: o2.
	(rowMap rowForTable: t1 withKey: o1) at: f1 put: 42.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 42.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 42.
	self assert: ((rowMap rowForTable: t3 withKey: o3) at: f3) = 42.!

testDoubleRowUnificationDifferentRows2
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2.
	rowMap
		unifyField: f2
		key: o2
		withField: f3
		key: o3.
	(rowMap rowForTable: t1 withKey: o1) at: f1 put: 42.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 42.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 42.
	self assert: ((rowMap rowForTable: t3 withKey: o3) at: f3) = 42.!

testDoubleRowUnificationDifferentRows3
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2.
	rowMap
		unifyField: f2
		key: o2
		withField: f3
		key: o3.
	(rowMap rowForTable: t3 withKey: o3) at: f3 put: 42.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 42.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 42.
	self assert: ((rowMap rowForTable: t3 withKey: o3) at: f3) = 42.!

testDoubleRowUnificationDifferentRows4
	| t4 f4 o4 |
	t4 := DatabaseTable named: 'T4'.
	f4 := t4 createFieldNamed: 'f4' type: (platform varChar: 10).
	o4 := 'four'.
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2.
	rowMap
		unifyField: f3
		key: o3
		withField: f4
		key: o4.
	rowMap
		unifyField: f2
		key: o2
		withField: f3
		key: o3.
	(rowMap rowForTable: t1 withKey: o1) at: f1 put: 42.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 42.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 42.
	self assert: ((rowMap rowForTable: t3 withKey: o3) at: f3) = 42.
	self assert: ((rowMap rowForTable: t4 withKey: o4) at: f4) = 42.!

testDoubleRowUnificationSameRow
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2.
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2.
	(rowMap rowForTable: t1 withKey: o1) at: f1 put: 42.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 42.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 42.!

testDoubleRowUnificationSameRow2
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2.
	rowMap
		unifyField: f2
		key: o2
		withField: f1
		key: o1.
	(rowMap rowForTable: t1 withKey: o1) at: f1 put: 42.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 42.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 42.!

testIteration

	| rows r1 r2 r3 count |
	r1 := rowMap findOrAddRowForTable: t1 withKey: o1.
	r2 := rowMap findOrAddRowForTable: t1 withKey: o2.
	r3 := rowMap findOrAddRowForTable: t2 withKey: o2.
	rows := IdentitySet new.
	count := 0.
	rowMap rowsDo: [:each | 
		count := count + 1.
		rows add: each].
	self assert: count = 3.
	self assert: (rows includes: r1).
	self assert: (rows includes: r3).
	self assert: (rows includes: r2).!

testRelatedRowInternal
	| cf1 r1 r2 r3 |
	cf1 := t1 createFieldNamed: 'cf1' type: (platform varChar: 10).
	t1 addForeignKeyFrom: cf1 to: f1.
	rowMap
		unifyField: f1
		key: o1
		withField: cf1
		key: o2.
	rowMap
		unifyField: f1
		key: o1
		withField: cf1
		key: o3.
	r1 := rowMap rowForTable: t1 withKey: o1.
	r1 at: f1 put: o1.
	r2 := rowMap rowForTable: t1 withKey: o2.
	r2 at: f1 put: o2.
	r3 := rowMap rowForTable: t1 withKey: o3.
	r3 at: f1 put: o3.
	self assert: (r1 relatedRowsIn: rowMap) isEmpty.
	self assert: (r2 relatedRowsIn: rowMap) asArray = (Array with: r1).
	self assert: (r3 relatedRowsIn: rowMap) asArray = (Array with: r1).!

testStoreThenUnify
	rowMap at: f1 key: o1 put: 12.
	rowMap
		unifyField: f2
		key: o2
		withField: f3
		key: o3.
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 12.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 12.
	self assert: ((rowMap rowForTable: t3 withKey: o3) at: f3) = 12.!

testStoreWithRowMapKey

	| a b key1 key2 key3 table r1 r2 r3 |
	a := Object new.
	b := Object new.
	key1 := RowMapKey new key1: a; key2: b.
	key2 := RowMapKey new key1: a; key2: b.
	key3 := RowMapKey new key1: b; key2: a.
	table := DatabaseTable new.

	r1 := rowMap findOrAddRowForTable: table withKey: key1.
	r2 := rowMap findOrAddRowForTable: table withKey: key2.
	r3 := rowMap findOrAddRowForTable: table withKey: key3.

	self assert: r1 == r2.
	self assert: r2 == r3.
	self assert: r1 owner == key1.!

testUnifyExtraOnSourceSideWithTransformationBeforeStoreForward
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2
		transformationForward: [:value | value * 2]
		inverse: [:value | value / 2].
	rowMap
		unifyField: f1
		key: o1
		withField: f3
		key: o3.
	(rowMap findOrAddRowForTable: t1 withKey: o1) at: f1 put: 12.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 12.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 24.
	self assert: ((rowMap rowForTable: t3 withKey: o3) at: f3) = 12.!

testUnifyExtraOnSourceSideWithTransformationBeforeStoreInverse
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2
		transformationForward: [:value | value * 2]
		inverse: [:value | value / 2].
	rowMap
		unifyField: f1
		key: o1
		withField: f3
		key: o3.
	(rowMap findOrAddRowForTable: t2 withKey: o2) at: f2 put: 24.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 12.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 24.
	self assert: ((rowMap rowForTable: t3 withKey: o3) at: f3) = 12.!

testUnifyExtraOnTargetSideWithTransformationBeforeStoreForward
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2
		transformationForward: [:value | value * 2]
		inverse: [:value | value / 2].
	rowMap
		unifyField: f2
		key: o2
		withField: f3
		key: o3.
	(rowMap findOrAddRowForTable: t1 withKey: o1) at: f1 put: 12.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 12.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 24.
	self assert: ((rowMap rowForTable: t3 withKey: o3) at: f3) = 24.!

testUnifyExtraOnTargetSideWithTransformationBeforeStoreInverse
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2
		transformationForward: [:value | value * 2]
		inverse: [:value | value / 2].
	rowMap
		unifyField: f2
		key: o2
		withField: f3
		key: o3.
	(rowMap findOrAddRowForTable: t2 withKey: o2) at: f2 put: 24.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 12.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 24.
	self assert: ((rowMap rowForTable: t3 withKey: o3) at: f3) = 24.!

testUnifyWithTransformationAfterStoreForward
	(rowMap findOrAddRowForTable: t1 withKey: o1) at: f1 put: 12.
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2
		transformationForward: [:value | value * 2]
		inverse: [:value | value / 2].
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 12.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 24.!

testUnifyWithTransformationAfterStoreInverse
	"This is a little tricky. If we set the value first, then impose the constraint, then we're effectively doubling what was set. I think this is actually right, but also a very weird case on top of weird scenarios to begin with"

	(rowMap findOrAddRowForTable: t2 withKey: o2) at: f2 put: 12.
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2
		transformationForward: [:value | value * 2]
		inverse: [:value | value / 2].	"Note: vs. the 6 and 12 you might otherwise expect"
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 12.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 24.!

testUnifyWithTransformationBeforeStoreForward
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2
		transformationForward: [:value | value * 2]
		inverse: [:value | value / 2].
	(rowMap findOrAddRowForTable: t1 withKey: o1) at: f1 put: 12.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 12.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 24.!

testUnifyWithTransformationBeforeStoreInverse
	rowMap
		unifyField: f1
		key: o1
		withField: f2
		key: o2
		transformationForward: [:value | value * 2]
		inverse: [:value | value / 2].
	rowMap at: f2 key: o2 put: 12.
	self assert: ((rowMap rowForTable: t1 withKey: o1) at: f1) = 6.
	self assert: ((rowMap rowForTable: t2 withKey: o2) at: f2) = 12.! !
!GlorpRowMapUnificationTest categoriesFor: #setUp!private!support! !
!GlorpRowMapUnificationTest categoriesFor: #testDoubleRowUnificationDifferentRows!private!tests! !
!GlorpRowMapUnificationTest categoriesFor: #testDoubleRowUnificationDifferentRows2!private!tests! !
!GlorpRowMapUnificationTest categoriesFor: #testDoubleRowUnificationDifferentRows3!private!tests! !
!GlorpRowMapUnificationTest categoriesFor: #testDoubleRowUnificationDifferentRows4!private!tests! !
!GlorpRowMapUnificationTest categoriesFor: #testDoubleRowUnificationSameRow!private!tests! !
!GlorpRowMapUnificationTest categoriesFor: #testDoubleRowUnificationSameRow2!private!tests! !
!GlorpRowMapUnificationTest categoriesFor: #testIteration!private!tests! !
!GlorpRowMapUnificationTest categoriesFor: #testRelatedRowInternal!private!tests-relatedrows! !
!GlorpRowMapUnificationTest categoriesFor: #testStoreThenUnify!private!tests! !
!GlorpRowMapUnificationTest categoriesFor: #testStoreWithRowMapKey!private!tests! !
!GlorpRowMapUnificationTest categoriesFor: #testUnifyExtraOnSourceSideWithTransformationBeforeStoreForward!private!tests-transformation! !
!GlorpRowMapUnificationTest categoriesFor: #testUnifyExtraOnSourceSideWithTransformationBeforeStoreInverse!private!tests-transformation! !
!GlorpRowMapUnificationTest categoriesFor: #testUnifyExtraOnTargetSideWithTransformationBeforeStoreForward!private!tests-transformation! !
!GlorpRowMapUnificationTest categoriesFor: #testUnifyExtraOnTargetSideWithTransformationBeforeStoreInverse!private!tests-transformation! !
!GlorpRowMapUnificationTest categoriesFor: #testUnifyWithTransformationAfterStoreForward!private!tests-transformation! !
!GlorpRowMapUnificationTest categoriesFor: #testUnifyWithTransformationAfterStoreInverse!private!tests-transformation! !
!GlorpRowMapUnificationTest categoriesFor: #testUnifyWithTransformationBeforeStoreForward!private!tests-transformation! !
!GlorpRowMapUnificationTest categoriesFor: #testUnifyWithTransformationBeforeStoreInverse!private!tests-transformation! !

GlorpSortedCollectionTest guid: (GUID fromString: '{DC01FA91-7410-4B72-8CF0-9CDB53464522}')!
GlorpSortedCollectionTest comment: ''!
!GlorpSortedCollectionTest categoriesForClass!Unclassified! !
GlorpSQLPrintingTest guid: (GUID fromString: '{95F22298-8188-4889-BD6E-C7502D990449}')!
GlorpSQLPrintingTest comment: ''!
!GlorpSQLPrintingTest categoriesForClass!Unclassified! !
!GlorpSQLPrintingTest methodsFor!

testDatePrinting
	| date stream |
	date := Dialect newDateWithYears: 1997 months: 11 days: 14.
	stream := WriteStream on: String new.
	date glorpPrintSQLOn: stream.
	self assert: stream contents = '''1997-11-14'''.

	date := Dialect newDateWithYears: 2002 months: 5 days: 2.
	stream := WriteStream on: String new.
	date glorpPrintSQLOn: stream.
	self assert: stream contents = '''2002-05-02'''.!

testGroupWriting
	| system platform row1 row2 command string session |
	platform := PostgreSQLPlatform new.
	session := GlorpDemoDescriptorSystem sessionForLogin: (Login new database: platform).
	system := session system.
	platform useBinding: false.
	row1 := DatabaseRow newForTable: (system tableNamed: 'GR_ADDRESS').
	row1 atFieldNamed: 'ID' put: 1.
	row2 := DatabaseRow newForTable: (system tableNamed: 'GR_ADDRESS').
	row2 atFieldNamed: 'ID' put: 2.
	command := InsertCommand forRows: (Array with: row1 with: row2) useBinding: false session: session.
	string := command sqlString.
	self assert: (string includes: $;).
	self assert: string = 'INSERT INTO GR_ADDRESS (ID,STREET,HOUSE_NUM)  VALUES (1,NULL,NULL); INSERT INTO GR_ADDRESS (ID,STREET,HOUSE_NUM)  VALUES (2,NULL,NULL)'.! !
!GlorpSQLPrintingTest categoriesFor: #testDatePrinting!private!tests! !
!GlorpSQLPrintingTest categoriesFor: #testGroupWriting!As yet unclassified!private! !

GlorpStringTest guid: (GUID fromString: '{A582420D-37B7-40C8-BD87-9C704FC0493B}')!
GlorpStringTest comment: 'Test string extensions in Glorp.'!
!GlorpStringTest categoriesForClass!Unclassified! !
!GlorpStringTest methodsFor!

testGlorpIsCollection
	self deny: 'abc' glorpIsCollection.
	self deny: Object new glorpIsCollection.
	self deny: $a glorpIsCollection.
	self assert: #() glorpIsCollection.!

testLikePercent
	self deny: ('abc' like: 'def').
	self assert: ('' like: '%').
	self assert: ('abc' like: '%').
	self assert: ('abc' like: '%bc').
	self deny: ('abc' like: 'a%ac').
	self assert: ('aaababc' like: '%bc').
	self assert: ('abcd' like: 'ab%cd').
	self assert: ('abcdef' like: 'ab%ef').
	self assert: ('abcdef' like: 'ab%ef%').
	self assert: ('abcdefg' like: 'ab%ef%').!

testLikeUnderscore
	self deny: ('' like: '_').
	self assert: ('a' like: '_').
	self assert: ('abc' like: '_bc').
	self deny: ('aaababc' like: '_bc').
	self deny: ('abcd' like: 'ab_cd').
	self assert: ('abcd' like: 'a_cd').
	self assert: ('abcdef' like: 'ab__ef').
	self assert: ('abcdef' like: 'ab__ef%').
	self assert: ('abcdefg' like: 'ab%ef_').
	self deny: ('abcdefgh' like: 'ab%ef_').! !
!GlorpStringTest categoriesFor: #testGlorpIsCollection!private!tests! !
!GlorpStringTest categoriesFor: #testLikePercent!private!tests! !
!GlorpStringTest categoriesFor: #testLikeUnderscore!private!tests! !

GlorpTracingTest guid: (GUID fromString: '{6980269A-7FF5-4DC8-A0B4-B56B7B6DB869}')!
GlorpTracingTest comment: ''!
!GlorpTracingTest categoriesForClass!Unclassified! !
!GlorpTracingTest methodsFor!

setUp

	tracing := Tracing new.
	tracing setup.!

testAddDuplicateTracings

	| all |
	tracing addExpression: (tracing base get: #foo).
	tracing addExpression: (tracing base get: #foo).
	all := tracing allTracings.
	self assert: all size = 2.
	self assert: all first == tracing base.!

testAddRecursiveTracings

	| all |
	tracing addExpression: (tracing base get: #foo).
	tracing addExpression: ((tracing base get: #foo) get: #bar).
	all := tracing allTracings.
	self assert: all size = 3.
	self assert: all first == tracing base.
	self assert: all last base == (all at: 2).!

testAddTracing

	| all |
	tracing addExpression: (tracing base get: #foo).
	all := tracing allTracings.
	self assert: all size = 2.
	self assert: all first == tracing base.
	self assert: all last == (tracing base get: #foo).!

testAddTwoTracings

	tracing addExpression: (tracing base get: #foo).
	tracing addExpression: (tracing base get: #bar).
	self assert: tracing allTracings size = 3.
	self assert: tracing allTracings first == tracing base.! !
!GlorpTracingTest categoriesFor: #setUp!private!support! !
!GlorpTracingTest categoriesFor: #testAddDuplicateTracings!private!tests! !
!GlorpTracingTest categoriesFor: #testAddRecursiveTracings!private!tests! !
!GlorpTracingTest categoriesFor: #testAddTracing!private!tests! !
!GlorpTracingTest categoriesFor: #testAddTwoTracings!private!tests! !

GlorpAdHocMappingTest guid: (GUID fromString: '{F1CA8514-7AD2-4402-95D0-6442F8A5E109}')!
GlorpAdHocMappingTest comment: ''!
!GlorpAdHocMappingTest categoriesForClass!Unclassified! !
!GlorpAdHocMappingTest methodsFor!

moneyNegatingMappingTo: amountField in: aDescriptor 
	mapping := aDescriptor newMapping: AdHocMapping.
	mapping
		forAttribute: #amount
		fromDb: [:row :elementBuilder :context | (elementBuilder valueOfField: (context translateField: amountField) in: row) negated]
		toDb: [:rows :attribute :attributeRows | (rows at: table) at: amountField put: attribute negated]
		mappingFields: (Array with: amountField).
	^mapping.!

testNegateMappingRead
	| amountField inputRow builder |
	descriptor := system descriptorFor: GlorpMoney.
	table := system tableNamed: 'MONEY_IMAGINARY_TABLE'.
	amountField := table fieldNamed: 'AMOUNT'.
	mapping := self moneyNegatingMappingTo: amountField in: descriptor.
	descriptor addMapping: mapping.
	money := GlorpMoney basicNew.
	inputRow := #('US' 1).
	builder := ElementBuilder new.
	builder row: inputRow.
	mapping mapObject: money inElementBuilder: builder.
	self assert: money amount = -1.!

testNegateMappingWrite
	| amountField outputRow |
	descriptor := system descriptorFor: GlorpMoney.
	table := system tableNamed: 'MONEY_IMAGINARY_TABLE'.
	amountField := table fieldNamed: 'AMOUNT'.
	mapping := self moneyNegatingMappingTo: amountField in: descriptor.
	descriptor table: table.
	descriptor addMapping: mapping.
	money := GlorpMoney forAmount: 3.
	rowMap := RowMap new.
	mapping mapFromObject: money intoRowsIn: rowMap.
	outputRow := rowMap rowForTable: table withKey: money.
	self assert: (outputRow at: (table fieldNamed: 'AMOUNT')) = -3!

testSplitMappingRead
	| inputRow builder |
	money := GlorpCompressedMoney basicNew.
	mapping := (system descriptorFor: GlorpCompressedMoney)
		mappingForAttributeNamed: #array.
	inputRow := #(432 'US' 1).
	builder := ElementBuilder new.
	builder row: inputRow.
	mapping mapObject: money inElementBuilder: builder.
	self assert: money amount = 1.
	self assert: money currency = 'US'.!

testSplitMappingWrite
	| outputRow |
	money := GlorpCompressedMoney currency: 'DM' amount: 99.
	mapping := (system descriptorFor: GlorpCompressedMoney) 
				mappingForAttributeNamed: #array.
	rowMap := RowMap new.
	mapping mapFromObject: money intoRowsIn: rowMap.
	table := mapping descriptor primaryTable.
	outputRow := rowMap rowForTable: table withKey: money.
	self assert: (outputRow at: (table fieldNamed: 'AMOUNT')) = 99.
	self assert: (outputRow at: (table fieldNamed: 'CURRENCY_NAME')) = 'DM'! !
!GlorpAdHocMappingTest categoriesFor: #moneyNegatingMappingTo:in:!private!tests! !
!GlorpAdHocMappingTest categoriesFor: #testNegateMappingRead!private!tests! !
!GlorpAdHocMappingTest categoriesFor: #testNegateMappingWrite!private!tests! !
!GlorpAdHocMappingTest categoriesFor: #testSplitMappingRead!private!tests! !
!GlorpAdHocMappingTest categoriesFor: #testSplitMappingWrite!private!tests! !

GlorpCacheTest guid: (GUID fromString: '{52CA777C-6CEA-452A-804B-BD973B891A0C}')!
GlorpCacheTest comment: ''!
!GlorpCacheTest categoriesForClass!Unclassified! !
!GlorpCacheTest methodsFor!

setUp
	super setUp.
	system cachePolicy: CachePolicy new.
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	session system: system.
	cache := session privateGetCache.!

tearDown
	super tearDown.
	session reset.
	session := nil.!

testDuplicates 
	| c1 c2 |
	c1 := GlorpCustomer example1.
	c2 := GlorpCustomer example1.
	cache at: 3 insert: c1.
	cache at: 3 insert: c2.
	self assert: (cache lookupClass: GlorpCustomer key: 3) = c1.!

testDuplicatesDifferentClasses

	| cust trans |
	cust := GlorpCustomer example1.
	trans := GlorpBankTransaction example1.
	cache at: 3 insert: cust.
	cache at: 3 insert: trans.
	self assert: (cache lookupClass: GlorpCustomer key: 3) = cust.
	self assert: (cache lookupClass: GlorpBankTransaction key: 3) = trans.!

testInsert
	| customer |
	customer := GlorpCustomer example1.
	cache at: 3 insert: customer.
	self assert: (cache lookupClass: GlorpCustomer key: 3) == customer!

testManualExpireAll
	| customer customer2 readBackCustomer |
	system cachePolicy: TimedExpiryCachePolicy new.
	customer := GlorpCustomer example1.
	cache at: 3 insert: customer.
	self deny: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == nil.
	cache expireAll.
	readBackCustomer := session readOneOf: GlorpCustomer where: [:each | each id = 3].
	self assert: readBackCustomer isNil.
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == nil.
	customer2 := GlorpCustomer new.
	cache at: 3 insert: customer2.
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == customer2.!

testManualExpiry
	| customer customer2 readBackCustomer |
	system cachePolicy: TimedExpiryCachePolicy new.
	customer := GlorpCustomer example1.
	cache at: 3 insert: customer.
	self deny: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == nil.
	cache expireClass: GlorpCustomer key: 3 ifAbsent: [self error: 'wrong'].
	readBackCustomer := session readOneOf: GlorpCustomer where: [:each | each id = 3].
	self assert: readBackCustomer isNil.
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == nil.
	customer2 := GlorpCustomer new.
	cache at: 3 insert: customer2.
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == customer2.!

testRemove
	| customer |
	customer := GlorpCustomer example1.
	cache at: 3 insert: customer.
	self assert: (cache lookupClass: GlorpCustomer key: 3) == customer.
	cache removeClass: GlorpCustomer key: 3 ifAbsent: [ self signalFailure: 'Item was not in cache.' ].
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: []) == nil.! !
!GlorpCacheTest categoriesFor: #setUp!private!support! !
!GlorpCacheTest categoriesFor: #tearDown!private!support! !
!GlorpCacheTest categoriesFor: #testDuplicates!private!tests! !
!GlorpCacheTest categoriesFor: #testDuplicatesDifferentClasses!private!tests! !
!GlorpCacheTest categoriesFor: #testInsert!private!tests! !
!GlorpCacheTest categoriesFor: #testManualExpireAll!private!tests! !
!GlorpCacheTest categoriesFor: #testManualExpiry!private!tests! !
!GlorpCacheTest categoriesFor: #testRemove!private!tests! !

!GlorpCacheTest class methodsFor!

resources
	^Array with: (Smalltalk at: #GlorpSessionResource)! !
!GlorpCacheTest class categoriesFor: #resources!Accessing!private! !

GlorpCommitOrderTest guid: (GUID fromString: '{4189F838-D3F3-4D76-BA16-F0917DEC6A9E}')!
GlorpCommitOrderTest comment: ''!
!GlorpCommitOrderTest categoriesForClass!Unclassified! !
!GlorpCommitOrderTest methodsFor!

setUp

	super setUp.
	platform := system platform.
	t1 := DatabaseTable new name: 'T1'.
	t1id := (t1 createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	t2 := DatabaseTable new name: 'T2'.
	t2id := (t2 createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	t3 := DatabaseTable new name: 'T3'.
	t3id := (t3 createFieldNamed: 'ID' type: platform int4) bePrimaryKey.!

testCommitOrder

	| sorter |
	sorter := TableSorter for: (Array with: (system tableNamed: 'BANK_TRANS') with: (system tableNamed: 'GR_CUSTOMER')).
	self assert: sorter sort first name = 'GR_CUSTOMER'.!

testCommitOrder2
	"Test for a cycle between t1 and t2 with t3 also pointing to both. Order of t1, t2 is indeterminate, but t3 should be last"

	| table1 table1id table2 table2id t2fk t3fk t3fk2 sorter t1fk |
	table1 := DatabaseTable new name: 'T1'.
	table1id := (table1 createFieldNamed: 'ID' type: platform inMemorySequence) bePrimaryKey.
	table2 := DatabaseTable new name: 'T2'.
	table2id := (table2 createFieldNamed: 'ID' type: platform inMemorySequence) bePrimaryKey.

	t1fk := table1 createFieldNamed: 'T2_ID' type: platform int4.
	table1 addForeignKeyFrom: t1fk to: table2id.
	t2fk := table2 createFieldNamed: 'T1_ID' type: platform int4.
	table2 addForeignKeyFrom: t2fk to: table1id.

	t3 := DatabaseTable new name: 'T3'.
	t3fk := t3 createFieldNamed: 'T2_ID' type: platform int4.
	t3 addForeignKeyFrom: t3fk to: table2id.
	t3fk2 := t3 createFieldNamed: 'T1_ID' type: platform int4.
	t3 addForeignKeyFrom: t3fk2 to: table1id.

	sorter := TableSorter for: (Array with: t3 with: table2 with: table1).
	self assert: sorter sort last name = 'T3'.!

testCommitOrderNonSequencedFieldsDontCount

	"Test for a cycle between t1 and t2 with t3 also pointing to both, but with nothing sequenced. Order should be completely indeterminate. We rely on the topological sort being predictable and depending on the insert order so that if we feed objects with no dependencies in in different orders we should get different results."

	| t1fk t2fk t3fk t3fk2 sorter sorter2 |
	t1fk := t1 createFieldNamed: 'T2_ID' type: platform int4.
	t1 addForeignKeyFrom: t1fk to: (t2id).
	t2fk := t2 createFieldNamed: 'T1_ID' type: platform int4.
	t2 addForeignKeyFrom: t2fk to: (t1id).

	t3 := DatabaseTable new name: 'T3'.
	t3fk := t3 createFieldNamed: 'T2_ID' type: platform int4.
	t3 addForeignKeyFrom: t3fk to: (t2id).
	t3fk2 := t3 createFieldNamed: 'T1_ID' type: platform int4.
	t3 addForeignKeyFrom: t3fk2 to: (t1id).

	sorter := TableSorter for: (Array with: t3 with: t2 with: t1).
	sorter2 := TableSorter for: (Array with: t1 with: t2 with: t3).
	self assert: sorter sort first ~= sorter2 sort first.! !
!GlorpCommitOrderTest categoriesFor: #setUp!private!support! !
!GlorpCommitOrderTest categoriesFor: #testCommitOrder!private!tests! !
!GlorpCommitOrderTest categoriesFor: #testCommitOrder2!private!tests! !
!GlorpCommitOrderTest categoriesFor: #testCommitOrderNonSequencedFieldsDontCount!private!tests! !

GlorpDescriptorTest guid: (GUID fromString: '{4942B58B-1E88-4FF6-8987-34F58B3A9ACF}')!
GlorpDescriptorTest comment: ''!
!GlorpDescriptorTest categoriesForClass!Unclassified! !
!GlorpDescriptorTest methodsFor!

errorSignal

	^Dialect error.!

testAllClassesAndNames
	| identity1 identity2 identity3 |
	system flushAllClasses.
	identity1 := system allClasses.
	identity2 := system allClasses.
	system flushAllClasses.
	identity3 := system allClasses.
	self assert: identity1 == identity2.
	self assert: identity1 ~~ identity3.
	self should: [system allClassNames] raise: Dialect error.!

testAllMappingsForField
	| descriptor mappings |
	descriptor := system descriptorFor: GlorpCustomer.
	mappings := descriptor 
				allMappingsForField: ((system tableNamed: 'GR_CUSTOMER') fieldNamed: 'ID').
	self assert: mappings first attributeName = #id!

testBuildBankTransactionAndDependentsFromRow
	| transactionDescriptor object row moneyDescriptor money1 table translations session builder |
	session := GlorpMockSession new.
	session system: system.
	transactionDescriptor := system descriptorFor: GlorpBankTransaction.
	object := GlorpBankTransaction new.
	row := #(99 nil 'CDN' 98 'service charge' 'USD' 97).
	builder := ObjectBuilder new.
	builder row: row.
	transactionDescriptor populateObject: object inBuilder: builder.
	self assert: object id = 99.
	moneyDescriptor := system descriptorFor: GlorpMoney.
	money1 := GlorpMoney new.
	table := system tableNamed: 'MONEY_IMAGINARY_TABLE'.
	translations := IdentityDictionary new.
	translations at: (table fieldNamed: 'CURRENCY') put: 3.
	translations at: (table fieldNamed: 'AMOUNT') put: 4.
	builder := ElementBuilder new fieldTranslations: translations; row: row.
	moneyDescriptor
		populateObject: money1
		inBuilder: builder.
	self assert: money1 amount = 98.
	self assert: money1 currency = #CDN.!

testBuildPersonFromRow
	| descriptor object address session builder |
	session := GlorpMockSession new.
	session system: system.
	address := GlorpAddress new.
	session cacheAt: 127 put: address.
	descriptor := system descriptorFor: GlorpPerson.
	system tableNamed: 'PERSON'.
	object := GlorpPerson new.
	builder := ObjectBuilder new.
	builder row: #(456 'Ralph' 127).
	descriptor populateObject: object inBuilder: builder.
	self assert: object class = GlorpPerson.
	self assert: object id = 456.
	self assert: object name = 'Ralph'.
	self assert: object address getValue == address.!

testClassLookup

	self assert: (Dialect smalltalkAt: 'Object') == Object.

	Dialect isVWWithNameSpaces ifTrue: [
		"Sneaky meta-tricks to avoid things that won't compile in non-VW dialects"
		self assert: (Dialect smalltalkAt: 'GlorpTestNamespace.GlorpTestClassInNamespace') == (Compiler evaluate: 'GlorpTestNamespace.GlorpTestClassInNamespace').
		self assert: (Dialect smalltalkAt: 'GlorpTestNamespace.GlorpTestClassInNamespace') notNil].!

testDescriptorIdentity

	| descriptor |
	descriptor := system descriptorFor: GlorpCustomer.
	self assert: descriptor == (system descriptorFor: GlorpCustomer).!

testDescriptorWithNamespace

	| descriptor testCaseClass |
	Dialect isVWWithNameSpaces ifFalse: [^self].
	system := GlorpDescriptorSystemWithNamespaces new.
	testCaseClass := 'GlorpTestNamespace.GlorpTestClassInNamespace' asQualifiedReference value.
	descriptor := system descriptorFor: testCaseClass.
	self assert: descriptor describedClass == testCaseClass.!

testMappedFields

	| descriptor |
	descriptor := system descriptorFor: GlorpBankTransaction.
	self assert: (descriptor mappedFields) = (descriptor table fields).!

testMappingForField
	| descriptor mapping |
	descriptor := system descriptorFor: GlorpCustomer.
	mapping := descriptor 
				directMappingForField: ((system tableNamed: 'GR_CUSTOMER') fieldNamed: 'ID').
	self assert: mapping attributeName = #id!

testPrimaryKeyExpressionFor
	| descriptor trans exp |
	descriptor := system descriptorFor: GlorpBankTransaction.
	trans := GlorpBankTransaction new.
	trans id: 42.
	exp := descriptor
		primaryKeyExpressionFor: trans
		basedOn: BaseExpression new
		relation: #=.
	self assert: exp relation = #=.
	self assert: exp rightChild value = 42.!

testPrimaryKeyExpressionForFailing
	| descriptor trans |
	descriptor := system descriptorFor: GlorpBankTransaction.
	trans := GlorpCustomer new.
	self
		should:
			[descriptor
				primaryKeyExpressionFor: trans
				basedOn: BaseExpression new
				relation: #=]
		raise: self errorSignal.!

testPrimaryKeyExpressionForWithCompositeKey

	self unfinished.! !
!GlorpDescriptorTest categoriesFor: #errorSignal!private!support! !
!GlorpDescriptorTest categoriesFor: #testAllClassesAndNames!private!tests! !
!GlorpDescriptorTest categoriesFor: #testAllMappingsForField!private!tests! !
!GlorpDescriptorTest categoriesFor: #testBuildBankTransactionAndDependentsFromRow!private!tests! !
!GlorpDescriptorTest categoriesFor: #testBuildPersonFromRow!private!tests! !
!GlorpDescriptorTest categoriesFor: #testClassLookup!private!tests! !
!GlorpDescriptorTest categoriesFor: #testDescriptorIdentity!private!tests! !
!GlorpDescriptorTest categoriesFor: #testDescriptorWithNamespace!private!tests! !
!GlorpDescriptorTest categoriesFor: #testMappedFields!private!tests! !
!GlorpDescriptorTest categoriesFor: #testMappingForField!private!tests! !
!GlorpDescriptorTest categoriesFor: #testPrimaryKeyExpressionFor!private!tests! !
!GlorpDescriptorTest categoriesFor: #testPrimaryKeyExpressionForFailing!private!tests! !
!GlorpDescriptorTest categoriesFor: #testPrimaryKeyExpressionForWithCompositeKey!private!tests! !

GlorpExpressionJoiningTest guid: (GUID fromString: '{1010358E-7290-4F45-8014-14733687D501}')!
GlorpExpressionJoiningTest comment: ''!
!GlorpExpressionJoiningTest categoriesForClass!Unclassified! !
!GlorpExpressionJoiningTest methodsFor!

join: exp 
	^exp asExpressionJoiningSource: source toTarget: target!

resultOfJoiningFieldFor: aTable toExpressionBuiltOn: anotherTable
	| exp table |
	base descriptor: (system descriptorFor: GlorpCustomer).
	exp := FieldExpression forField: (aTable fieldNamed: 'ID')
				basedOn: BaseExpression new.
	table := base getTable: anotherTable.

	^exp asExpressionJoiningSource: base toTarget: table.!

setUp
	super setUp.
	source := BaseExpression new.
	target := source get: #relation.
	base := BaseExpression new.!

tearDown

	source := nil.
	target := nil.
	base := nil.
	system := nil.!

testBase
	| result |
	result := self join: base. 
	self assert: result == source.!

testConstant
	| exp |
	exp := ConstantExpression for: 42.
	self assert: (self join: exp) == exp!

testField
	| exp  result |
	exp := FieldExpression forField: (DatabaseField named: 'test' type: system platform int4)
				basedOn: base.
	result := self join: exp.
	self assert: result base == source.
	self assert: result field == exp field!

testFieldBuiltOnDifferentTable
	| result custTable |
	custTable := system tableNamed: 'GR_CUSTOMER'.
	result := self 
		resultOfJoiningFieldFor: custTable
		toExpressionBuiltOn: custTable.
	self assert: result base == (base getTable: custTable).
	self assert: result field == ((system tableNamed: 'GR_CUSTOMER') fieldNamed: 'ID').!

testFieldBuiltOnSameTable
	| exp result base2 table custTable |
	custTable := system tableNamed: 'GR_CUSTOMER'.
	base2 := BaseExpression new.
	base2 descriptor: (system descriptorFor: GlorpCustomer).
	table := base2 getTable: custTable.
	exp := FieldExpression forField: (custTable fieldNamed: 'ID')
				basedOn: base.
	result := exp asExpressionJoiningSource: base2 toTarget: table.
	self assert: result base == table.
	self assert: result field == exp field.!

testMapping
	| result exp |
	exp := base get: #foo.
	result := self join: exp. 
	self assert: result base == source.
	self assert: result name = #foo.!

testParameter
	| result exp table field |
	table := DatabaseTable named: 'T'.	
	field := DatabaseField named: 'F' type: system platform int4.
	table addField: field.
	exp := base getParameter: field.
	result := self join: exp.
	self assert: result base == source.
	self assert: result class == FieldExpression.
	self assert: result field == field.!

testRelation
	| result exp |
	exp := [:a | a foo = 3] asGlorpExpressionOn: base.
	result := self join: exp. 

	self assert: result class == RelationExpression.
	self assert: result rightChild == exp rightChild.
	self assert: result leftChild base == source.!

testRelation2
	| result exp field | 
	field := DatabaseField named: 'fred' type: system platform int4.
	exp := [:a | a foo = field] asGlorpExpressionOn: base.
	result := self join: exp. 
	self assert: result class == RelationExpression.
	self assert: result rightChild class == FieldExpression.
	self assert: result rightChild field == field.
	self assert: result leftChild base == source.!

testSelfJoinWithPrimaryKeyExpression
	"This tests a join of a class to itself, in this case customers who have other customers associated with them. Useful for hierarchies"
	| pkExpression field result |
	field := (system tableNamed: 'GR_CUSTOMER') fieldNamed: 'ID'.
	pkExpression := Join 
		from: field
		to: field.
	result := self join: pkExpression.
	self assert: result leftChild basicField == field.
	self assert: result rightChild basicField == field.
	self assert: result rightChild base name = #relation.!

testTable
	| result exp table |
	table := DatabaseTable named: 'T'.
	exp := base getTable: table.
	result := self join: exp. 
	self assert: result base == target.
	self assert: result table == table.! !
!GlorpExpressionJoiningTest categoriesFor: #join:!private!tests! !
!GlorpExpressionJoiningTest categoriesFor: #resultOfJoiningFieldFor:toExpressionBuiltOn:!private!tests! !
!GlorpExpressionJoiningTest categoriesFor: #setUp!private!support! !
!GlorpExpressionJoiningTest categoriesFor: #tearDown!private!support! !
!GlorpExpressionJoiningTest categoriesFor: #testBase!private!tests! !
!GlorpExpressionJoiningTest categoriesFor: #testConstant!private!tests! !
!GlorpExpressionJoiningTest categoriesFor: #testField!private!tests! !
!GlorpExpressionJoiningTest categoriesFor: #testFieldBuiltOnDifferentTable!private!tests! !
!GlorpExpressionJoiningTest categoriesFor: #testFieldBuiltOnSameTable!private!tests! !
!GlorpExpressionJoiningTest categoriesFor: #testMapping!private!tests! !
!GlorpExpressionJoiningTest categoriesFor: #testParameter!private!tests! !
!GlorpExpressionJoiningTest categoriesFor: #testRelation!private!tests! !
!GlorpExpressionJoiningTest categoriesFor: #testRelation2!private!tests! !
!GlorpExpressionJoiningTest categoriesFor: #testSelfJoinWithPrimaryKeyExpression!private!tests! !
!GlorpExpressionJoiningTest categoriesFor: #testTable!private!tests! !

GlorpExpressionTableAliasingTest guid: (GUID fromString: '{D97EC2A8-80AF-42A9-B412-B6A4030B0398}')!
GlorpExpressionTableAliasingTest comment: ''!
!GlorpExpressionTableAliasingTest categoriesForClass!Unclassified! !
!GlorpExpressionTableAliasingTest methodsFor!

helpTestBasicAliasing: aTable
	self deny: exp hasTableAliases.
	exp assignTableAliasesStartingAt: 1 prefix: 's1t'.
	self assert: exp hasTableAliases.
	self assert: exp tableAliases size = 1.
	self assert: (exp tableAliases at: aTable) name = 's1t1'.!

testBase
	exp := BaseExpression new.
	exp descriptor: (system descriptorFor: GlorpCustomer).
	self helpTestBasicAliasing: (system tableNamed: 'GR_CUSTOMER').!

testMapping
	| base |
	base := BaseExpression new.
	base descriptor: (system descriptorFor: GlorpCustomer).
	exp := base get: 'transactions'.
	self helpTestBasicAliasing: (system tableNamed: 'BANK_TRANS').!

testTable
	| base transTable |
	base := BaseExpression new.
	base descriptor: (system descriptorFor: GlorpCustomer).
	transTable := system tableNamed: 'BANK_TRANS'.
	exp := base getTable: transTable.
	self helpTestBasicAliasing: transTable!

testTableSameAsBase
	| base custTable |
	base := BaseExpression new.
	base descriptor: (system descriptorFor: GlorpCustomer).
	custTable := system tableNamed: 'GR_CUSTOMER'.
	exp := base getTable: custTable.
	self deny: exp hasTableAliases.
	exp assignTableAliasesStartingAt: 1 prefix: ''.
	base assignTableAliasesStartingAt: 42 prefix: nil.
	self deny: exp hasTableAliases.
	self assert: (exp aliasedTableFor: custTable) name = 't42'.! !
!GlorpExpressionTableAliasingTest categoriesFor: #helpTestBasicAliasing:!private!support! !
!GlorpExpressionTableAliasingTest categoriesFor: #testBase!private!tests! !
!GlorpExpressionTableAliasingTest categoriesFor: #testMapping!private!tests! !
!GlorpExpressionTableAliasingTest categoriesFor: #testTable!private!tests! !
!GlorpExpressionTableAliasingTest categoriesFor: #testTableSameAsBase!private!tests! !

GlorpExpressionTest guid: (GUID fromString: '{DA3532C8-9135-457C-967E-875CD8E110B5}')!
GlorpExpressionTest comment: ''!
!GlorpExpressionTest categoriesForClass!Unclassified! !
!GlorpExpressionTest methodsFor!

assertIdentityOf: aBlock and: anotherBlock
	
 	| base |
	base := BaseExpression new.
	self assert: (aBlock asGlorpExpressionOn: base) == (anotherBlock asGlorpExpressionOn: base)!

denyIdentityOf: aBlock and: anotherBlock
 
	| base |
	base := BaseExpression new.
	self deny: (aBlock asGlorpExpressionOn: base) == (anotherBlock asGlorpExpressionOn: base)!

testAndOperation
	| expression fred base |
	fred := 'Fred'.
	base := BaseExpression new.
	expression := [:a | (a firstName = fred) & (a firstName ~= fred)] asGlorpExpressionOn: base.
	self assert: expression class == RelationExpression.
	self assert: expression relation = #AND.!

testAndOperation2
	| expression fred base |
	fred := 'Fred'.
	base := BaseExpression new.
	expression := [:a | (a firstName = fred) AND: (a firstName ~= fred)] asGlorpExpressionOn: base.
	self assert: expression class == RelationExpression.
	self assert: expression relation = #AND.!

testAnySatisfyExists

	| expression base |
	system useJoinsForAnySatisfy: false.
	base := BaseExpression new.
	base descriptor: (system descriptorFor: GlorpCustomer).
	expression := [:a | a items anySatisfy: [:each | each id = 7]] asGlorpExpressionOn: base.
	self assert: expression class == SubSelectExpression.!

testAnySatisfyJoin

	| expression base |
	system useJoinsForAnySatisfy: true.
	base := BaseExpression new.
	base descriptor: (system descriptorFor: GlorpCustomer).
	expression := [:a | a items anySatisfy: [:each | each id = 7]] asGlorpExpressionOn: base.
	self assert: expression class == CollectionExpression.
	self assert: expression leftChild == expression rightChild leftChild base.!

testAnySatisfyPrintExists
	| expression |
	system useJoinsForAnySatisfy: false.
	expression := [:cust | cust transactions anySatisfy: [:each | each id = 7]] 
				asGlorpExpressionForDescriptor: (system descriptorFor: GlorpCustomer).
	self assert: (' EXISTS (SELECT s1t1.ID<n> FROM BANK_TRANS s1t1<n> WHERE *s1t1.ID = ?* AND *s1t2.ID = s1t1.OWNER_ID)*' expandMacros match: expression sqlString).!

testAnySatisfyPrintJoin
	| expression |
	system useJoinsForAnySatisfy: true.
	expression := [:cust | cust transactions anySatisfy: [:each | each id = 7]] 
				asGlorpExpressionForDescriptor: (system descriptorFor: GlorpCustomer).
	self assert: '(BANK_TRANS.ID = 7)' equalsIgnoringOuterBrackets: expression sqlString.!

testBetweenAnd
	| expression base |
	base := BaseExpression new.
	expression := [:a | a between: 3 and: 4] asGlorpExpressionOn: base.
	self assert: expression class == InfixFunction.
	self assert: expression name = 'BETWEEN AND'.
	self assert: (expression arguments collect: [:each | each value]) = (Array with: 3 with: 4).!

testEqualityOperation
	| expression fred base |
	fred := 'Fred'.
	base := BaseExpression new.
	expression := [:a | a firstName = fred] asGlorpExpressionOn: base.
	self assert: expression leftChild == (base get: #firstName).
	self assert: expression rightChild class == ConstantExpression.
	self assert: expression rightChild value == fred.
	self assert: expression relation == #=!

testFindingMapping
	| base baseDescriptor |
	baseDescriptor := system descriptorFor: GlorpBankTransaction.
	base := BaseExpression new descriptor: baseDescriptor.
	self assert: (base get: #serviceCharge) mapping == (baseDescriptor mappingForAttributeNamed: #serviceCharge).
	self assert: (base get: #serviceCharge) sourceDescriptor == (system descriptorFor: GlorpBankTransaction).
	self assert: (base get: #serviceCharge) descriptor == (system descriptorFor: GlorpServiceCharge)!

testGetField
	| expression |
	expression := [:cust | cust getField: 'ID'] asGlorpExpressionForDescriptor: (system descriptorFor: GlorpCustomer).
	self assert: expression sqlString = 'GR_CUSTOMER.ID'.
	self assert: expression class = FieldExpression.
	self assert: expression field table = (system tableNamed: 'GR_CUSTOMER').!

testGetFieldAmbiguous
	| |
	self 
		should: [[:pass | pass getField: 'ID']
			asGlorpExpressionForDescriptor: (system descriptorFor: GlorpPassenger)]
		raise: Dialect error.!

testGetFieldFromSecondaryTable
	| expression |
	expression := [:pass | pass getField: 'POINTS']
		asGlorpExpressionForDescriptor: (system descriptorFor: GlorpPassenger).
	self assert: expression sqlString = 'FREQUENT_FLYER.POINTS'.
	self assert: expression class = FieldExpression.
	self assert: expression field table = (system tableNamed: 'FREQUENT_FLYER').!

testIsNullPrint

	| expression stream |
	expression := [:cust | cust id = nil]
		asGlorpExpressionForDescriptor: (system descriptorFor: GlorpCustomer).
	stream := DatabaseCommand new session: system session.
	expression printSQLOn: stream withParameters: Dictionary new.
	self assert: '(GR_CUSTOMER.ID IS NULL)' equalsIgnoringOuterBrackets: expression sqlString.!

testJoinOperation
	| userExpression base expression addressTable personTable query field1 field2 join |
	addressTable := system tableNamed: 'GR_ADDRESS'.
	personTable := system tableNamed: 'PERSON'.
	base := BaseExpression new.
	base descriptor: (system descriptorFor: GlorpPerson).
	userExpression := [:aPerson | aPerson address number = 12] 
				asGlorpExpressionOn: base.
	query := SimpleQuery returningOneOf: GlorpPerson where: userExpression.
	query session: (GlorpSession new system: system).
	self assert: (userExpression additionalExpressionsIn: query) size = 1.
	query prepare.
	expression := query whereClause.
	self assert: query joins size = 1.
	join := query joins first.
	self
		assert: expression == userExpression;
		assert: expression relation == #=.
	field1 := join leftChild field.
	self assert: field1 table parent == personTable.
	self assert: field1 name = 'ADDRESS_ID'.
	field2 := join rightChild field.
	self assert: field2 table parent == addressTable.
	self assert: field2 name = 'ID'.!

testMappingBase

	| base |
	base := BaseExpression new.
	self assert: (base get: #someAttribute) base == base!

testMappingExpressionIdentity
 
	self assertIdentityOf: [:a | a someAttribute] and: [:a | a someAttribute].!

testMappingExpressionIdentity2

	self assertIdentityOf: [:a | a perform: #someAttribute] and: [:a | a someAttribute].!

testMappingExpressionIdentity3

	self assertIdentityOf: [:a | a get: #someAttribute] and: [:a | a someAttribute].!

testMappingExpressionIdentity4

	self denyIdentityOf: [:a | a get: #someAttribute] and: [:a | a someOtherAttribute].!

testNotNullPrint

	| expression stream |
	expression := [:cust | cust id ~= nil]
		asGlorpExpressionForDescriptor: (system descriptorFor: GlorpCustomer).
	stream := DatabaseCommand new session: system session.
	expression printSQLOn: stream withParameters: Dictionary new.
	self assert: '(GR_CUSTOMER.ID IS NOT NULL)' equalsIgnoringOuterBrackets: stream contents.!

testOrOperation
	| expression fred base |
	fred := 'Fred'.
	base := BaseExpression new.
	expression := [:a | (a firstName = fred) | (a firstName ~= fred)] asGlorpExpressionOn: base.
	self assert: expression class == RelationExpression.
	self assert: expression relation = #OR.!

testOrOperation2
	| expression fred base |
	fred := 'Fred'.
	base := BaseExpression new.
	expression := [:a | (a firstName = fred) OR: (a firstName ~= fred)] asGlorpExpressionOn: base.
	self assert: expression class == RelationExpression.
	self assert: expression relation = #OR.!

testTwoLevelMappingExpressionIdentity

	self assertIdentityOf: [:a | a someAttribute someAttribute] and: [:a | a someAttribute someAttribute].
	self denyIdentityOf: [:a | a someAttribute someAttribute] and: [:a | a someAttribute].! !
!GlorpExpressionTest categoriesFor: #assertIdentityOf:and:!private!support! !
!GlorpExpressionTest categoriesFor: #denyIdentityOf:and:!private!support! !
!GlorpExpressionTest categoriesFor: #testAndOperation!private!tests! !
!GlorpExpressionTest categoriesFor: #testAndOperation2!private!tests! !
!GlorpExpressionTest categoriesFor: #testAnySatisfyExists!private!tests! !
!GlorpExpressionTest categoriesFor: #testAnySatisfyJoin!private!tests! !
!GlorpExpressionTest categoriesFor: #testAnySatisfyPrintExists!private!tests! !
!GlorpExpressionTest categoriesFor: #testAnySatisfyPrintJoin!private!tests! !
!GlorpExpressionTest categoriesFor: #testBetweenAnd!private!tests! !
!GlorpExpressionTest categoriesFor: #testEqualityOperation!private!tests! !
!GlorpExpressionTest categoriesFor: #testFindingMapping!private!tests! !
!GlorpExpressionTest categoriesFor: #testGetField!private!tests! !
!GlorpExpressionTest categoriesFor: #testGetFieldAmbiguous!private!tests! !
!GlorpExpressionTest categoriesFor: #testGetFieldFromSecondaryTable!private!tests! !
!GlorpExpressionTest categoriesFor: #testIsNullPrint!As yet unclassified!private! !
!GlorpExpressionTest categoriesFor: #testJoinOperation!private!tests! !
!GlorpExpressionTest categoriesFor: #testMappingBase!private!tests! !
!GlorpExpressionTest categoriesFor: #testMappingExpressionIdentity!private!tests! !
!GlorpExpressionTest categoriesFor: #testMappingExpressionIdentity2!private!tests! !
!GlorpExpressionTest categoriesFor: #testMappingExpressionIdentity3!private!tests! !
!GlorpExpressionTest categoriesFor: #testMappingExpressionIdentity4!private!tests! !
!GlorpExpressionTest categoriesFor: #testNotNullPrint!As yet unclassified!private! !
!GlorpExpressionTest categoriesFor: #testOrOperation!private!tests! !
!GlorpExpressionTest categoriesFor: #testOrOperation2!private!tests! !
!GlorpExpressionTest categoriesFor: #testTwoLevelMappingExpressionIdentity!private!tests! !

GlorpJoinTest guid: (GUID fromString: '{A1F6B3E7-558D-4884-857B-1F4A9E26BDD4}')!
GlorpJoinTest comment: ''!
!GlorpJoinTest categoriesForClass!Unclassified! !
!GlorpJoinTest methodsFor!

setUp
	super setUp.
	expression := Join 
		from: ((system tableNamed: 'BANK_ACCT') fieldNamed: 'ID')
		to: ((system tableNamed: 'CUSTOMER_ACCT_LINK') fieldNamed: 'ACCT_ID').

	compoundExpression := Join
		from: ((system tableNamed: 'BANK_ACCT') fieldNamed: 'ID')
		to: ((system tableNamed: 'PERSON') fieldNamed: 'NAME').
	compoundExpression
		addSource: ((system tableNamed: 'BANK_ACCT') fieldNamed: 'BANK_CODE')
		target: ((system tableNamed: 'PERSON') fieldNamed: 'ADDRESS_ID').!

testAsExpressionCompound
	
	| e personTable accountTable |
	personTable := system tableNamed: 'PERSON'.
	accountTable := system tableNamed: 'BANK_ACCT'.

	e := compoundExpression asGeneralGlorpExpression.
	self assert: (e isKindOf: RelationExpression).
	self assert: e relation == #AND.
	self assert: (e leftChild isKindOf: RelationExpression).
	self assert: (e leftChild relation == #=).
	self assert: (e leftChild leftChild isKindOf: FieldExpression).
	self assert: e leftChild leftChild field == (personTable fieldNamed: 'NAME').
	self assert: (e leftChild rightChild isKindOf: ParameterExpression).
	self assert: e leftChild rightChild field == (accountTable fieldNamed: 'ID').


	self assert: (e rightChild isKindOf: RelationExpression).
	self assert: (e rightChild relation == #=).
	self assert: (e rightChild leftChild isKindOf: FieldExpression).
	self assert: e rightChild leftChild field == (personTable fieldNamed: 'ADDRESS_ID').
	self assert: (e rightChild rightChild isKindOf: ParameterExpression).
	self assert: e rightChild rightChild field = (accountTable fieldNamed: 'BANK_CODE').!

testAsExpressionSingle
	
	| e field param |
	e := expression asGeneralGlorpExpression.
	self assert: (e isKindOf: RelationExpression).
	self assert: e relation == #=.
	field := e leftChild.
	self assert: (field isKindOf: FieldExpression).
	self assert: field field == ((system tableNamed: 'CUSTOMER_ACCT_LINK') fieldNamed: 'ACCT_ID').
	param := e rightChild.
	self assert: (param isKindOf: ParameterExpression).
	self assert: param field == ((system tableNamed: 'BANK_ACCT') fieldNamed: 'ID').!

testCompoundSQLPrinting
	| stream params|
	stream := WriteStream on: (String new: 100).
	params := Dictionary new.
	params at: ((system tableNamed: 'BANK_ACCT') fieldNamed: 'ID') put: 1.
	params at: ((system tableNamed: 'BANK_ACCT') fieldNamed: 'BANK_CODE') put: 3.
	compoundExpression printSQLOn: stream withParameters: params.
	self assert: stream contents = 'PERSON.NAME = 1 AND PERSON.ADDRESS_ID = 3'.!

testCreation

	self assert: expression allSourceFields size = 1.
	self assert: expression allSourceFields first == ((system tableNamed: 'BANK_ACCT') fieldNamed: 'ID').!

testParameterCount

	self assert: expression numberOfParameters = 1.
	self assert: compoundExpression numberOfParameters = 2.!

testSQLPrinting
	| stream params |
	stream := WriteStream on: (String new: 100).
	params := Dictionary new.
	params at: ((system tableNamed: 'BANK_ACCT') fieldNamed: 'ID') put: 'abc'.
	expression printSQLOn: stream withParameters: params.
	self assert: stream contents = 'CUSTOMER_ACCT_LINK.ACCT_ID = ''abc'''! !
!GlorpJoinTest categoriesFor: #setUp!private!support! !
!GlorpJoinTest categoriesFor: #testAsExpressionCompound!private!tests! !
!GlorpJoinTest categoriesFor: #testAsExpressionSingle!private!tests! !
!GlorpJoinTest categoriesFor: #testCompoundSQLPrinting!private!tests! !
!GlorpJoinTest categoriesFor: #testCreation!private!tests! !
!GlorpJoinTest categoriesFor: #testParameterCount!private!tests! !
!GlorpJoinTest categoriesFor: #testSQLPrinting!private!tests! !

GlorpMappingTest guid: (GUID fromString: '{6A1B5A86-5F7E-4AA1-8CE0-1760517EB9C6}')!
GlorpMappingTest comment: ''!
!GlorpMappingTest categoriesForClass!Unclassified! !
!GlorpMappingTest methodsFor!

helperForMergedOneToOneReversingWriteOrder: aBoolean 
	| account accountTable row |
	account := GlorpBankExampleSystem new objectNumber: 1 ofClass: GlorpBankAccount.
	accountTable := system tableNamed: 'BANK_ACCT'.
	aBoolean 
		ifTrue: 
			[self write: account.
			self write: account accountNumber]
		ifFalse: 
			[self write: account accountNumber.
			self write: account].
	self assert: (rowMap includesRowForTable: accountTable withKey: account).
	self assert: (rowMap includesRowForTable: accountTable
				withKey: account accountNumber).
	row := self rowFor: account.
	self assert: (row at: (accountTable fieldNamed: 'ID')) = account id.
	(Array with: row with: (self rowFor: account accountNumber)) do: 
			[:each | 
			self assert: (each at: (accountTable fieldNamed: 'BANK_CODE')) 
						= account accountNumber bankCode.
			self assert: (each at: (accountTable fieldNamed: 'BRANCH_NO')) 
						= account accountNumber branchNumber.
			self assert: (each at: (accountTable fieldNamed: 'ACCT_NO')) 
						= account accountNumber accountNumber].
	self assert: (rowMap numberOfEntriesForTable: accountTable) = 2!

helperForNestedMergedOneToOneReversingWriteOrder: aBoolean 
	| trans transTable moneyTable row fieldNames fieldValues |
	trans := GlorpBankExampleSystem new objectNumber: 1
				ofClass: GlorpBankTransaction.
	transTable := system tableNamed: 'BANK_TRANS'.
	moneyTable := system tableNamed: 'MONEY_IMAGINARY_TABLE'.
	aBoolean 
		ifTrue: 
			[self write: trans.
			self write: trans amount.
			self write: trans serviceCharge.
			self write: trans serviceCharge amount]
		ifFalse: 
			[self write: trans serviceCharge amount.
			self write: trans serviceCharge.
			self write: trans amount.
			self write: trans].
	self 
		assert: (rowMap rowForTable: transTable withKey: trans) shouldBeWritten.
	self 
		assert: (rowMap rowForTable: transTable withKey: trans serviceCharge) 
				shouldBeWritten not.
	self 
		assert: (rowMap rowForTable: moneyTable withKey: trans amount) 
				shouldBeWritten not.
	self 
		assert: (rowMap rowForTable: moneyTable withKey: trans serviceCharge amount) 
				shouldBeWritten not.
	row := self rowFor: trans.
	self assert: (row at: (transTable fieldNamed: 'ID')) = trans id.
	fieldNames := #('AMT_CURR' 'AMT_AMT' 'SRVC_DESC' 'SRVC_AMT_CURR' 'SRVC_AMT_AMT').
	fieldValues := (Array 
				with: trans amount currency asString
				with: trans amount amount
				with: trans serviceCharge description) 
					, (Array with: trans serviceCharge amount currency asString
							with: trans serviceCharge amount amount).
	fieldNames with: fieldValues
		do: [:fieldName :value | self assert: (row at: (transTable fieldNamed: fieldName)) = value].
	self assert: (rowMap numberOfEntriesForTable: transTable) = 2.
	self assert: (rowMap numberOfEntriesForTable: moneyTable) = 2!

rowFor: anObject
	| descriptor |
	descriptor := system descriptorFor: anObject.
	descriptor isNil ifTrue: [^nil].

	^rowMap rowForTable: descriptor table withKey: anObject.!

setUp
	super setUp.
	rowMap := RowMap new.!

testManyToMany

	| customer customerTable accountTable linkTable linkRow |
	customer := GlorpBankExampleSystem new objectNumber: 1 ofClass: GlorpCustomer.
	rowMap := RowMap new.
	customerTable := system tableNamed: 'GR_CUSTOMER'.
	accountTable := system tableNamed: 'BANK_ACCT'.
	linkTable := system tableNamed: 'CUSTOMER_ACCT_LINK'.

	self write: customer.
	customer accounts do: [:each | 
		self write: each].

	self assert: (rowMap includesRowForTable: customerTable withKey: customer).
	customer accounts do: [:each |
		self assert: (rowMap includesRowForTable: accountTable withKey: each).
		self assert: (rowMap includesRowForTable: linkTable withKey: (RowMapKey new key1: customer; key2: each))].

	customer accounts do: [:each | | rowMapKey |
		self assert: ((self rowFor: each) at: (accountTable fieldNamed: 'ID')) = each id.
		rowMapKey := RowMapKey new key1: customer; key2: each.
		linkRow := rowMap rowForTable: linkTable withKey: rowMapKey.
		self assert: (linkRow at: (linkTable fieldNamed: 'ACCT_ID')) = each id.
		self assert: (linkRow at: (linkTable fieldNamed: 'CUSTOMER_ID')) = customer id.
		].
	self assert: ((self rowFor: customer) at: (customerTable fieldNamed: 'ID')) = customer id.
	self assert: ((rowMap numberOfEntriesForTable: linkTable) = 2).
	self assert: ((rowMap numberOfEntriesForTable: customerTable) = 1).!

testMergedOneToOne
	self helperForMergedOneToOneReversingWriteOrder: false!

testMergedOneToOneReversingWrites
	self helperForMergedOneToOneReversingWriteOrder: true!

testMissingDescriptor
	self assert: (system descriptorFor: nil) isNil.
	self assert: (system descriptorFor: UndefinedObject) isNil.
	self assert: (system descriptorFor: 3) isNil!

testMultipleTableCreation
	
	| descriptor table passenger table2 row1 row2 |
	descriptor := system descriptorFor: GlorpPassenger.
	passenger := GlorpPassenger example1.
	rowMap := RowMap new.
	table := system existingTableNamed: 'PASSENGER'.
	table2 := system existingTableNamed: 'FREQUENT_FLYER'.
	descriptor createRowsFor: passenger in: rowMap.
	self assert: (rowMap includesRowForTable: table withKey: passenger).
	self assert: (rowMap includesRowForTable: table2 withKey: passenger).
	row1 := rowMap rowForTable: table withKey: passenger.
	self assert: (row1 at: (table fieldNamed: 'ID'))
			= passenger id.
	self assert: (row1 at: (table fieldNamed: 'NAME'))
			= passenger name.
	row2 := rowMap rowForTable: table2 withKey: passenger.
	self assert: (row2 at: (table2 fieldNamed: 'ID'))
			= passenger id.
	self assert: (row2 at: (table2 fieldNamed: 'POINTS')) = passenger frequentFlyerPoints.
	self assert: rowMap numberOfEntries = 3!

testMultipleTableCreationWithOneMissing
	
	| descriptor table passenger table2 row1 |
	descriptor := system descriptorFor: GlorpPassenger.
	passenger := GlorpPassenger example1.
	passenger frequentFlyerPoints: nil.
	passenger airline: nil.
	rowMap := RowMap new.
	table := system existingTableNamed: 'PASSENGER'.
	table2 := system existingTableNamed: 'FREQUENT_FLYER'.
	descriptor createRowsFor: passenger in: rowMap.
	self assert: (rowMap includesRowForTable: table withKey: passenger).
	self deny: (rowMap includesRowForTable: table2 withKey: passenger).
	row1 := rowMap rowForTable: table withKey: passenger.
	self assert: (row1 at: (table fieldNamed: 'ID'))
			= passenger id.
	self assert: (row1 at: (table fieldNamed: 'NAME'))
			= passenger name.
	self assert: rowMap numberOfEntries = 1.!

testNestedMergedOneToOne
	self helperForNestedMergedOneToOneReversingWriteOrder: false!

testNestedMergedOneToOneReversingWriteOrder
	self helperForNestedMergedOneToOneReversingWriteOrder: true.!

testNilOneToOne
	
	| person  personTable addressTable |
	person := GlorpPerson example1.
	person address: nil.
	self write: person.
	self write: person address.
	personTable := system existingTableNamed: 'PERSON'.
	addressTable := system existingTableNamed: 'GR_ADDRESS'.

	self assert: (rowMap includesRowForTable: personTable withKey: person).
	self deny: (rowMap includesRowForTable: addressTable withKey: person address).

	self assert: rowMap numberOfEntries = 1.!

testOneToMany

	| customer customerTable transactionTable |
	customer := GlorpCustomer example1.
	rowMap := RowMap new.
	customerTable := system tableNamed: 'GR_CUSTOMER'.
	transactionTable := system tableNamed: 'BANK_TRANS'.
	self write: customer.
	customer transactions do: [:each |
		self write: each].

	self assert: (rowMap includesRowForTable: customerTable withKey: customer).
	customer transactions do: [:each |
		self assert: (rowMap includesRowForTable: transactionTable withKey: each)].

	customer transactions do: [:each |
		self assert: ((self rowFor: each) at: (transactionTable fieldNamed: 'OWNER_ID')) = customer id].
	self assert: ((self rowFor: customer) at: (customerTable fieldNamed: 'ID')) = customer id.!

testOneToOne
	
	| person  personTable addressTable |
	person := GlorpPerson example1.
	self write: person.
	self write: person address.
	personTable := system existingTableNamed: 'PERSON'.
	addressTable := system existingTableNamed: 'GR_ADDRESS'.

	self assert: (rowMap includesRowForTable: personTable withKey: person).
	self assert: (rowMap includesRowForTable: addressTable withKey: person address).

	self assert: ((self rowFor: person address) at: (addressTable fieldNamed: 'ID')) = person address id.
	self assert: ((self rowFor: person) at: (personTable fieldNamed: 'ADDRESS_ID')) = person address id.
	self assert: rowMap numberOfEntries = 2.!

testOneToOneWithProxy
	| person personTable addressTable proxy stub |
	person := GlorpPerson example1.
	proxy := Proxy new.
	proxy session: GlorpSession new.
	stub := (Smalltalk at: #GlorpQueryStub) returningOneOf: GlorpAddress where: [:address | address id = 1].
	stub result: person address.
	proxy query: stub.
	person address: proxy.
	self deny: person address isInstantiated.

	self write: person.

	personTable := system existingTableNamed: 'PERSON'.
	addressTable := system existingTableNamed: 'GR_ADDRESS'.

	self assert: (rowMap includesRowForTable: personTable withKey: person).
	self deny: (rowMap includesRowForTable: addressTable withKey: person address).

	self deny: ((self rowFor: person) hasValueFor: (personTable fieldNamed: 'ADDRESS_ID')).
	self assert: rowMap numberOfEntries = 1!

testRowCreation

	| descriptor person row table  |
	descriptor := system descriptorFor: GlorpPerson.
	person := GlorpPerson example1.
	rowMap := RowMap new.
	table := system existingTableNamed: 'PERSON'.
	descriptor createRowsFor: person in: rowMap.
	self assert: (rowMap includesRowForTable: table withKey: person).
	row := rowMap rowForTable: table withKey: person.
	self assert: (row at: (table fieldNamed: 'ID')) = person id.
	self assert: (row at: (table fieldNamed: 'NAME')) = person name.
	self assert: rowMap numberOfEntries = 2.!

write: anObject

	| descriptor |
	descriptor := system descriptorFor: anObject. 
	descriptor isNil ifTrue: [^self].
	descriptor createRowsFor: anObject in: rowMap.! !
!GlorpMappingTest categoriesFor: #helperForMergedOneToOneReversingWriteOrder:!private!tests! !
!GlorpMappingTest categoriesFor: #helperForNestedMergedOneToOneReversingWriteOrder:!private!tests! !
!GlorpMappingTest categoriesFor: #rowFor:!private!support! !
!GlorpMappingTest categoriesFor: #setUp!private!support! !
!GlorpMappingTest categoriesFor: #testManyToMany!private!tests! !
!GlorpMappingTest categoriesFor: #testMergedOneToOne!private!tests! !
!GlorpMappingTest categoriesFor: #testMergedOneToOneReversingWrites!private!tests! !
!GlorpMappingTest categoriesFor: #testMissingDescriptor!private!tests! !
!GlorpMappingTest categoriesFor: #testMultipleTableCreation!private!tests! !
!GlorpMappingTest categoriesFor: #testMultipleTableCreationWithOneMissing!private!tests! !
!GlorpMappingTest categoriesFor: #testNestedMergedOneToOne!private!tests! !
!GlorpMappingTest categoriesFor: #testNestedMergedOneToOneReversingWriteOrder!private!tests! !
!GlorpMappingTest categoriesFor: #testNilOneToOne!private!tests! !
!GlorpMappingTest categoriesFor: #testOneToMany!private!tests! !
!GlorpMappingTest categoriesFor: #testOneToOne!private!tests! !
!GlorpMappingTest categoriesFor: #testOneToOneWithProxy!public!tests! !
!GlorpMappingTest categoriesFor: #testRowCreation!private!tests! !
!GlorpMappingTest categoriesFor: #write:!private!support! !

GlorpPrimaryKeyExpressionWithConstantTest guid: (GUID fromString: '{965DD1E3-1FBA-4D25-BF6D-F4B94619F52B}')!
GlorpPrimaryKeyExpressionWithConstantTest comment: ''!
!GlorpPrimaryKeyExpressionWithConstantTest categoriesForClass!Unclassified! !
!GlorpPrimaryKeyExpressionWithConstantTest methodsFor!

setUp
	super setUp.
	expression := Join 
		from: 7
		to: ((system tableNamed: 'CUSTOMER_ACCT_LINK') fieldNamed: 'ACCT_ID').

	compoundExpression := Join
		from: ((system tableNamed: 'BANK_ACCT') fieldNamed: 'ID')
		to: ((system tableNamed: 'PERSON') fieldNamed: 'NAME').
	compoundExpression
		addSource: 'B'
		target: ((system tableNamed: 'PERSON') fieldNamed: 'ADDRESS_ID').!

testAsExpressionCompound
	
	| e personTable |
	personTable := system tableNamed: 'PERSON'.

	e := compoundExpression asGeneralGlorpExpression.
	self assert: (e rightChild isKindOf: RelationExpression).
	self assert: (e rightChild relation == #=).
	self assert: (e rightChild leftChild isKindOf: FieldExpression).
	self assert: e rightChild leftChild field == (personTable fieldNamed: 'ADDRESS_ID').
	self assert: (e rightChild rightChild isKindOf: ConstantExpression).
	self assert: e rightChild rightChild value = 'B'.!

testAsExpressionSingle
	
	| e field param |
	e := expression asGeneralGlorpExpression.
	self assert: (e isKindOf: RelationExpression).
	self assert: e relation == #=.
	field := e leftChild.
	self assert: (field isKindOf: FieldExpression).
	self assert: field field == ((system tableNamed: 'CUSTOMER_ACCT_LINK') fieldNamed: 'ACCT_ID').
	param := e rightChild.
	self assert: (param isKindOf: ConstantExpression).
	self assert: param value = 7.!

testCompoundSQLPrinting
	| stream params|
	stream := WriteStream on: (String new: 100).
	params := Dictionary new.
	params at: ((system tableNamed: 'BANK_ACCT') fieldNamed: 'ID') put: 1.
	compoundExpression printSQLOn: stream withParameters: params.
	self assert: stream contents = 'PERSON.NAME = 1 AND PERSON.ADDRESS_ID = ''B'''.!

testParameterCount

	self assert: expression numberOfParameters = 1.
	self assert: compoundExpression numberOfParameters = 2.!

testSQLPrinting
	| stream params |
	stream := WriteStream on: (String new: 100).
	params := Dictionary new.
	expression printSQLOn: stream withParameters: params.
	self assert: stream contents = 'CUSTOMER_ACCT_LINK.ACCT_ID = 7'! !
!GlorpPrimaryKeyExpressionWithConstantTest categoriesFor: #setUp!private!support! !
!GlorpPrimaryKeyExpressionWithConstantTest categoriesFor: #testAsExpressionCompound!private!tests! !
!GlorpPrimaryKeyExpressionWithConstantTest categoriesFor: #testAsExpressionSingle!private!tests! !
!GlorpPrimaryKeyExpressionWithConstantTest categoriesFor: #testCompoundSQLPrinting!private!tests! !
!GlorpPrimaryKeyExpressionWithConstantTest categoriesFor: #testParameterCount!private!tests! !
!GlorpPrimaryKeyExpressionWithConstantTest categoriesFor: #testSQLPrinting!private!tests! !

GlorpQueryCopyingTest guid: (GUID fromString: '{3BA13E27-663A-431D-A003-C4DB94B4B384}')!
GlorpQueryCopyingTest comment: ''!
!GlorpQueryCopyingTest categoriesForClass!Unclassified! !
!GlorpQueryCopyingTest methodsFor!

setUp
	super setUp.
	query := Query returningManyOf: GlorpCustomer.
	query whereClause: [:each | each accounts anySatisfy: [:foo | foo id = 12]].
	session := (Smalltalk at: #GlorpSessionResource) current newSession.
	query session: session.!

tableAliasesPresentFor: aQuery
	aQuery whereClause detect: [:each | each hasTableAliases] ifNone: [^false].
	^true.!

testExpressionTableAliases
	query prepare.
	newQuery := query copy.
	self assert: (self tableAliasesPresentFor: query).
	self deny: (self tableAliasesPresentFor: newQuery).!

testPreparedness
	self deny: query isPrepared.
	query prepare.
	newQuery := query copy.
	self assert: query isPrepared.
	self deny: newQuery isPrepared.! !
!GlorpQueryCopyingTest categoriesFor: #setUp!private!support! !
!GlorpQueryCopyingTest categoriesFor: #tableAliasesPresentFor:!As yet unclassified!private! !
!GlorpQueryCopyingTest categoriesFor: #testExpressionTableAliases!private!tests! !
!GlorpQueryCopyingTest categoriesFor: #testPreparedness!private!tests! !

!GlorpQueryCopyingTest class methodsFor!

resources
	^Array with: (Smalltalk at: #GlorpSessionResource).! !
!GlorpQueryCopyingTest class categoriesFor: #resources!private!resources! !

GlorpQueryTableAliasingTest guid: (GUID fromString: '{24E3E59A-9C3F-4646-9253-28D1E2C4C5B2}')!
GlorpQueryTableAliasingTest comment: ''!
!GlorpQueryTableAliasingTest categoriesForClass!Unclassified! !
!GlorpQueryTableAliasingTest methodsFor!

helpTestPrintingWhereClause: anExpression
	| command |
	query 
		initResultClass: GlorpCustomer
		whereClause: expression
		singleObject: true.
	query setupTracing.
	query computeFields.
	command := GlorpNullCommand useBinding: false session: session.
	anExpression	
		printSQLOn: command
		withParameters: Dictionary new.
	^command sqlString.!

setUp
	super setUp.
	query := SimpleQuery new.
	expression := BaseExpression new.
	expression descriptor: (system descriptorFor: GlorpCustomer).
	(expression descriptor mappingForAttributeNamed: #name) shouldProxy: false.
	elementBuilder := ObjectBuilder for: expression in: query.
	expression aliasTable: (system tableNamed: 'GR_CUSTOMER') to: 't1'.
	session := GlorpSession new.
	session system: system.
	query session: system session.!

testAliasWithEmbeddedMapping

	self unfinished.!

testBuildingObject

	| customer |
	elementBuilder instance: GlorpCustomer new.
	elementBuilder requiresPopulating: true.
	elementBuilder buildObjectFrom: #(12 'Name').
	customer := elementBuilder instance.
	self assert: customer class == GlorpCustomer.
	self assert: customer id = 12.
	self assert: customer name = 'Name'.!

testElementBuilderFields
	elementBuilder fieldsForSelectStatement 
		do: [:each | self assert: each table name = 't1']!

testExpressionTableAlias
	| fields |
	fields := expression translateFields: expression descriptor mappedFields.
	fields do: [:each | self assert: each table name = 't1']!

testQueryPrintingFields
	| stream |
	query 
		initResultClass: GlorpCustomer
		whereClause: expression
		singleObject: true.
	query limit: nil.
	query setupTracing.
	query computeFields.
	stream := String new writeStream.
	query printSelectFieldsOn: stream.
	self assert: stream contents = 't1.ID, t1.NAME'!

testQueryPrintingSimpleWhereClause
	| string |
	string := self helpTestPrintingWhereClause: ((expression get: #name) get: #= withArguments: #('Fred')).
	self assert: '(t1.NAME = ''Fred'')' equalsIgnoringOuterBrackets: string.!

testQueryPrintingTables
	| stream string |
	query 
		initResultClass: GlorpCustomer
		whereClause: expression
		singleObject: true.
	query setupTracing.
	query computeFields.
	stream := String new writeStream.
	query printTablesOn: stream.
	string := stream contents.
	self assert: string = '<n> FROM GR_CUSTOMER t1' expandMacros.! !
!GlorpQueryTableAliasingTest categoriesFor: #helpTestPrintingWhereClause:!As yet unclassified!private! !
!GlorpQueryTableAliasingTest categoriesFor: #setUp!private!support! !
!GlorpQueryTableAliasingTest categoriesFor: #testAliasWithEmbeddedMapping!private!tests! !
!GlorpQueryTableAliasingTest categoriesFor: #testBuildingObject!private!tests! !
!GlorpQueryTableAliasingTest categoriesFor: #testElementBuilderFields!private!tests! !
!GlorpQueryTableAliasingTest categoriesFor: #testExpressionTableAlias!private!tests! !
!GlorpQueryTableAliasingTest categoriesFor: #testQueryPrintingFields!private!tests! !
!GlorpQueryTableAliasingTest categoriesFor: #testQueryPrintingSimpleWhereClause!private!tests! !
!GlorpQueryTableAliasingTest categoriesFor: #testQueryPrintingTables!private!tests! !

GlorpSessionTest guid: (GUID fromString: '{0CE2F54A-0AB5-4CB3-9236-C719EE673F02}')!
GlorpSessionTest comment: ''!
!GlorpSessionTest categoriesForClass!Unclassified! !
!GlorpSessionTest methodsFor!

addCustomerToCache
	| customer |
	customer := GlorpCustomer example1.
	customer id: 3.
	session cacheAt: 3 put: customer.
	^customer!

helpTestUpdateWithExpiredExistingEntry: aCachePolicy
	| customer customer2 row table unitOfWork |
	(session system descriptorFor: GlorpCustomer) 
		cachePolicy: aCachePolicy.
	customer := self addCustomerToCache.
	customer2 := GlorpCustomer new.
	customer2 id: customer id.
	customer2 name: 'Barney Rubble'.
	row := DatabaseRow newForTable: (table := system tableNamed: 'GR_CUSTOMER').
	row at: (table fieldNamed: 'ID') put: customer id.
	unitOfWork := UnitOfWork new.
	unitOfWork session: session.
	"Since there's already an object there, this shouldn't do anything"
	unitOfWork updateSessionCacheFor: customer2 withRow: row.
	self assert: (session expiredInstanceOf: GlorpCustomer key: 3) == customer.!

helpTestUpdateWithoutExpiredExistingEntry: aCachePolicy
	| customer2 row table unitOfWork |
	(session system descriptorFor: GlorpCustomer) 
		cachePolicy: (TimedExpiryCachePolicy new timeout: 0).
	customer2 := GlorpCustomer new.
	customer2 id: 3.
	customer2 name: 'Barney Rubble'.
	row := DatabaseRow newForTable: (table := system tableNamed: 'GR_CUSTOMER').
	row at: (table fieldNamed: 'ID') put: 3.
	unitOfWork := UnitOfWork new.
	unitOfWork session: session.
	unitOfWork updateSessionCacheFor: customer2 withRow: row.
	self assert: (session expiredInstanceOf: GlorpCustomer key: 3) == customer2.!

setUp
	super setUp.
	session := GlorpSession new.
	session system: system!

testAddingDescriptors

	self assert: session system == system.
	self assert: system session == session.
	(session descriptorFor: GlorpAddress) session == session.!

testDuplicateDetection
	| customer customer2 |
	session beginUnitOfWork.
	customer := self addCustomerToCache.
	customer2 := customer copy.
	self should: [session register: customer2] raise: Dialect error.
	session rollbackUnitOfWork.!

testExecuteQuery
	| q result |
	q := GlorpQueryStub new result: 3.
	result := session execute: q.
	self assert: result = 3!

testHasExpired1
	| customer |
	customer := self addCustomerToCache.
	self deny: (session hasExpired: customer)!

testHasExpired2
	| customer |
	(session system descriptorFor: GlorpCustomer) 
		cachePolicy: (TimedExpiryCachePolicy new timeout: 0).
	customer := self addCustomerToCache.
	self assert: (session hasExpired: customer)!

testHasExpired3
	| customer |
	(session system descriptorFor: GlorpCustomer) 
		cachePolicy: (TimedExpiryCachePolicy new timeout: 0).
	customer := self addCustomerToCache.
	self assert: (session hasExpired: customer)!

testHasObjectOfClassExpired1

	self addCustomerToCache.
	self deny: (session hasObjectExpiredOfClass: GlorpCustomer withKey: 3).!

testHasObjectOfClassExpired2

	(session system descriptorFor: GlorpCustomer) 
		cachePolicy: (TimedExpiryCachePolicy new timeout: 0).
	self addCustomerToCache.
	self assert: (session hasObjectExpiredOfClass: GlorpCustomer withKey: 3).!

testSQLDeleteStringFor
	| row table string |
	table := session system tableNamed: 'GR_ADDRESS'.
	row := DatabaseRow newForTable: table.
	row at: (table fieldNamed: 'ID') put: 12.
	row at: (table fieldNamed: 'STREET') put: 'some street'.
	string := (DeleteCommand forRow: row useBinding: true session: session) sqlString.
	self assert: string = 'DELETE FROM GR_ADDRESS WHERE ID = ?'.
	string := (DeleteCommand forRow: row useBinding: false session: session) sqlString.
	self assert: string = 'DELETE FROM GR_ADDRESS WHERE ID = 12'.!

testUpdateWithExpiredExistingEntry
	self helpTestUpdateWithExpiredExistingEntry: (TimedExpiryCachePolicy new timeout: 0; expiryAction: #refresh).!

testUpdateWithExpiredExistingEntry2
	self helpTestUpdateWithExpiredExistingEntry: (TimedStrongCachePolicy new timeout: 0; expiryAction: #refresh).!

testUpdateWithoutExpiredExistingEntry
	self helpTestUpdateWithoutExpiredExistingEntry: (TimedExpiryCachePolicy new timeout: 0).!

testUpdateWithoutExpiredExistingEntry2
	self helpTestUpdateWithoutExpiredExistingEntry: (TimedStrongCachePolicy new timeout: 0).! !
!GlorpSessionTest categoriesFor: #addCustomerToCache!private!support! !
!GlorpSessionTest categoriesFor: #helpTestUpdateWithExpiredExistingEntry:!private!tests! !
!GlorpSessionTest categoriesFor: #helpTestUpdateWithoutExpiredExistingEntry:!private!tests! !
!GlorpSessionTest categoriesFor: #setUp!private!support! !
!GlorpSessionTest categoriesFor: #testAddingDescriptors!private!tests! !
!GlorpSessionTest categoriesFor: #testDuplicateDetection!private!tests! !
!GlorpSessionTest categoriesFor: #testExecuteQuery!private!tests! !
!GlorpSessionTest categoriesFor: #testHasExpired1!private!tests! !
!GlorpSessionTest categoriesFor: #testHasExpired2!private!tests! !
!GlorpSessionTest categoriesFor: #testHasExpired3!private!tests! !
!GlorpSessionTest categoriesFor: #testHasObjectOfClassExpired1!private!tests! !
!GlorpSessionTest categoriesFor: #testHasObjectOfClassExpired2!private!tests! !
!GlorpSessionTest categoriesFor: #testSQLDeleteStringFor!public!tests! !
!GlorpSessionTest categoriesFor: #testUpdateWithExpiredExistingEntry!private!tests! !
!GlorpSessionTest categoriesFor: #testUpdateWithExpiredExistingEntry2!private!tests! !
!GlorpSessionTest categoriesFor: #testUpdateWithoutExpiredExistingEntry!private!tests! !
!GlorpSessionTest categoriesFor: #testUpdateWithoutExpiredExistingEntry2!private!tests! !

GlorpTableTest guid: (GUID fromString: '{3B2AEC19-9ABD-46E8-A193-7AFB02F4DF91}')!
GlorpTableTest comment: ''!
!GlorpTableTest categoriesForClass!Unclassified! !
!GlorpTableTest methodsFor!

keywordForConstraintsWhenDropping: aConstraint onPlatform: aDatabasePlatform
	"This method returns the term to test against independently of #writeConstraintToDrop:onStream:.  The logic is that ANSI uses 'DROP CONSTRAINT but MySQL uses
		'DROP PRIMARY KEY' for primary key constraints (and then says don't name the constraint name in the drop statement!!)
		'DROP FOREIGN KEY'  for foreign key constraints
		'DROP KEY' for unique constraints (it also supports DROP INDEX for this)"

	(aDatabasePlatform isKindOf: MySQLPlatform) ifFalse: [^'CONSTRAINT'].
	aConstraint isForeignKeyConstraint ifTrue: [^'FOREIGN KEY'].
	aConstraint isPrimaryKeyConstraint ifTrue: [^'PRIMARY KEY'].
	^'KEY'!

setUp
	super setUp.
	descriptors := system allDescriptors.
	dbPlatform := system platform.
	GlorpInMemorySequenceDatabaseType reset!

testBasicSequencing
	| row |
	row := DatabaseRow newForTable: (system tableNamed: 'STUFF').
	row preWriteAssignSequencesUsing: nil.
	row postWriteAssignSequencesUsing: nil.
	self assert: (row at: ((system tableNamed: 'STUFF') fieldNamed: 'ID')) = 1.!

testCircularFieldRefs

	| field table1 table2 |
	table1 := DatabaseTable named: 'BAR'.
	field := table1 createFieldNamed: 'FOO' type: dbPlatform int4.
	table2 := DatabaseTable named: 'BLETCH'.
	table1 addForeignKeyFrom: field to: (table2 createFieldNamed: 'FLIRP' type: dbPlatform int4).
	self assert: (table2 fieldNamed: 'FLIRP') = table1 foreignKeyConstraints first targetFields first.!

testConstraintCreation
	| constraint dropWord |
	constraint := ForeignKeyConstraint
		sourceField: ((system tableNamed: 'BANK_ACCT') fieldNamed: 'BANK_CODE')
		targetField: ((system tableNamed: 'PERSON') fieldNamed: 'ID').
	self assert: constraint creationString =
		( 'CONSTRAINT ', constraint name, ' FOREIGN KEY (BANK_CODE) REFERENCES PERSON (ID)').
	dropWord := self keywordForConstraintsWhenDropping: constraint onPlatform: dbPlatform.	
	dbPlatform supportsAlterTableForConstraints ifTrue:
		[self assert: constraint dropString =
			( 'ALTER TABLE BANK_ACCT DROP ', dropWord, ' ', constraint name)].
	constraint := ForeignKeyConstraint
		sourceField: ((system tableNamed: 'BANK_ACCT') fieldNamed: 'BANK_CODE')
		targetField: ((system tableNamed: 'PERSON') fieldNamed: 'ID')
		suffixExpression: 'ON DELETE CASCADE'.
	self assert: constraint creationString = ('CONSTRAINT ', constraint name, ' FOREIGN KEY (BANK_CODE) REFERENCES PERSON (ID) ON DELETE CASCADE').
	dbPlatform supportsAlterTableForConstraints ifTrue:
		[self assert: constraint dropString = ('ALTER TABLE BANK_ACCT DROP ', dropWord, ' ',  constraint name)].!

testConstraintNonCreation

	| constraint |
	constraint := ForeignKeyConstraint 
		sourceField: ((system tableNamed: 'BANK_ACCT') fieldNamed: 'BANK_CODE')
		targetField: ((system tableNamed: 'PERSON') fieldNamed: 'ID').
	constraint shouldCreateInDatabase: false.
	self assert: constraint creationString = ''.
	self assert: constraint dropString = ''.!

testFieldTable

	| field table |
	field := DatabaseField named: 'FOO' type: dbPlatform int4.
	table := DatabaseTable named: 'BAR'.
	table addField: field.
	self assert: (table fieldNamed: 'FOO') = field.!

testForeignKeyFieldAPI
	"SQLite does not support foreign keys but it will parse them;  this test passes on SQLite."

	| table1 table2 fieldCustAddr fieldAddrId constraint |
	table1 := DatabaseTable named: 'Customer'.
	(table1 createFieldNamed: 'ID' type: dbPlatform int4) bePrimaryKey.
	fieldCustAddr := table1 createFieldNamed: 'ADDRESS' type: dbPlatform int4.
	table2 := DatabaseTable named: 'Address'.
	fieldAddrId := (table2 createFieldNamed: 'ID' type: dbPlatform int4) bePrimaryKey.
	table2 createFieldNamed: 'Street' type: dbPlatform varChar.

	constraint := table1 addForeignKeyFrom: fieldCustAddr toTable: table2.
	self assert: (table2 fieldNamed: 'ID') = table1 foreignKeyConstraints first targetFields first.
	self assert: constraint name =  'Customer_A_TO_Address_ID_REF1'.

	table1 := DatabaseTable named: 'Customer'.
	(table1 createFieldNamed: 'ID' type: dbPlatform int4) bePrimaryKey.
	fieldCustAddr := table1 createFieldNamed: 'ADDRESS' type: dbPlatform int4.
	table2 := DatabaseTable named: 'Address'.
	fieldAddrId := (table2 createFieldNamed: 'ID' type: dbPlatform int4) bePrimaryKey.
	table2 createFieldNamed: 'Street' type: dbPlatform varChar.

	table1 addForeignKeyFrom: fieldCustAddr toField: fieldAddrId.
	self assert: (table2 fieldNamed: 'ID') = table1 foreignKeyConstraints first targetFields first.!

testPrimaryKeyFields

	| pkFields table |
	table := system tableNamed: 'BANK_TRANS'.
	pkFields := table primaryKeyFields.
	self assert: pkFields size = 1.
	self assert: (pkFields at: 1) == (table fieldNamed: 'ID').!

testPrimaryKeyFields2

	| table field |
	table := DatabaseTable new.
	field := (DatabaseField named: 'FRED' type: (dbPlatform varChar: 10))
		bePrimaryKey.
	table addField: field.
	self assert: table primaryKeyFields size = 1.
	self assert: (table primaryKeyFields at: 1) == field.!

testPrimaryKeyFieldsNoPK

	| pkFields table |
	table := system tableNamed: 'CUSTOMER_ACCT_LINK'.
	pkFields := table primaryKeyFields.
	self assert: pkFields size = 0.!

testPrintingWithoutParent

	| t t1 |
	t := system tableNamed: 'GR_CUSTOMER'.
	self assert: t sqlTableName = 'GR_CUSTOMER'.!

testPrintingWithParent

	| t t1 |
	t := system tableNamed: 'GR_CUSTOMER'.
	t1 := t copy.
	t1 parent: t.
	t1 name: 'foo'.
	self assert: t1 sqlTableName = 'GR_CUSTOMER foo'.!

testRowCreation

	| row |
	row := system examplePersonRow1.
	self assert: (row at: (row table fieldNamed: 'ID')) = 3.!

testTwoSequences
	| row1 row2 table idField |
	table := system tableNamed: 'STUFF'.
	row1 := DatabaseRow newForTable: table.
	row2 := DatabaseRow newForTable: table.
	row1 preWriteAssignSequencesUsing: nil.
	row1 postWriteAssignSequencesUsing: nil.
	row2 preWriteAssignSequencesUsing: nil.
	row2 postWriteAssignSequencesUsing: nil.
	idField := table fieldNamed: 'ID'.
	self assert: (row1 at: idField) = 1.
	self assert: (row2 at: idField) = 2.! !
!GlorpTableTest categoriesFor: #keywordForConstraintsWhenDropping:onPlatform:!public!support! !
!GlorpTableTest categoriesFor: #setUp!private!support! !
!GlorpTableTest categoriesFor: #testBasicSequencing!private!tests! !
!GlorpTableTest categoriesFor: #testCircularFieldRefs!private!tests! !
!GlorpTableTest categoriesFor: #testConstraintCreation!public!tests! !
!GlorpTableTest categoriesFor: #testConstraintNonCreation!private!tests! !
!GlorpTableTest categoriesFor: #testFieldTable!private!tests! !
!GlorpTableTest categoriesFor: #testForeignKeyFieldAPI!private!tests! !
!GlorpTableTest categoriesFor: #testPrimaryKeyFields!private!tests! !
!GlorpTableTest categoriesFor: #testPrimaryKeyFields2!private!tests! !
!GlorpTableTest categoriesFor: #testPrimaryKeyFieldsNoPK!private!tests! !
!GlorpTableTest categoriesFor: #testPrintingWithoutParent!private!tests! !
!GlorpTableTest categoriesFor: #testPrintingWithParent!private!tests! !
!GlorpTableTest categoriesFor: #testRowCreation!private!tests! !
!GlorpTableTest categoriesFor: #testTwoSequences!private!tests! !

GlorpTimedExpiryCacheTest guid: (GUID fromString: '{F004D203-89D9-4FB1-8A43-8C189E5B2D71}')!
GlorpTimedExpiryCacheTest comment: ''!
!GlorpTimedExpiryCacheTest categoriesForClass!Unclassified! !
!GlorpTimedExpiryCacheTest methodsFor!

setUp
	super setUp.
	self setUpExpiryWithRealDelay.!

setUpExpiryWithRealDelay
	(cache session descriptorFor: GlorpCustomer) cachePolicy: (TimedExpiryCachePolicy new timeout: 1).
	(cache session descriptorFor: GlorpBankTransaction) cachePolicy: (TimedExpiryCachePolicy new timeout: 1).!

setUpExpiryWithZeroDelay
	(cache session descriptorFor: GlorpCustomer) cachePolicy: (TimedExpiryCachePolicy new timeout: 0).
	(cache session descriptorFor: GlorpBankTransaction) cachePolicy: (TimedExpiryCachePolicy new timeout: 0).!

setUpForExpiryActionOf: aSymbol
	(cache session descriptorFor: GlorpCustomer) cachePolicy expiryAction: aSymbol.
	(cache session descriptorFor: GlorpBankTransaction) cachePolicy expiryAction: aSymbol.!

setUpForNotify
	self setUpForExpiryActionOf: #notify.!

setUpForNotifyAndRemove
	self setUpForExpiryActionOf: #notifyAndRemove.!

setUpForRefresh
	self setUpForExpiryActionOf: #refresh.!

testExpiryReturningNilWithRealDelay
	"test that objects expire with a non-zero delay time."
	| customer customer2 |
	customer := GlorpCustomer example1.
	cache at: 3 insert: customer.
	self deny: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == nil.
	(Delay forSeconds: 2) wait.
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == nil.
	customer2 := GlorpCustomer new.
	cache at: 3 insert: customer2.
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == customer2.!

testNotExpiredAfterRefresh
	| customer |
	self setUpForRefresh.
	session accessor beginTransaction.
	[session accessor executeSQLStringNoResult: 'INSERT INTO GR_CUSTOMER VALUES (3,''Fred Flintstone'')'.
	customer := session execute: (Query returningOneOf: GlorpCustomer where: [:each | each id = 3]).
	(Delay forSeconds: 2) wait.
	self assert: (cache hasExpired: customer).
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == customer.
	self deny: (cache hasExpired: customer)]
		ensure: [session accessor rollbackTransaction].!

testNotify
	| customer |
	self setUpExpiryWithZeroDelay.
	self setUpForNotify.
	customer := GlorpCustomer example1.
	cache at: 3 insert: customer.
	self deny: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == nil.
	self assert: customer seenExpiry.!

testNotifyAndRemove
	| customer |
	self setUpExpiryWithZeroDelay.
	self setUpForNotifyAndRemove.
	customer := GlorpCustomer example1.
	cache at: 3 insert: customer.
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == nil.
	self assert: customer seenExpiry = true.!

testRegisteredObjectsDoNotExpire
	| customer |
	self setUpExpiryWithZeroDelay.
	self setUpForNotifyAndRemove.
	customer := GlorpCustomer example1.
	customer id: 3.
	cache at: 3 insert: customer.
	session beginUnitOfWork.
	session register: customer.
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == customer.
	self deny: customer seenExpiry.! !
!GlorpTimedExpiryCacheTest categoriesFor: #setUp!private!support! !
!GlorpTimedExpiryCacheTest categoriesFor: #setUpExpiryWithRealDelay!private!support! !
!GlorpTimedExpiryCacheTest categoriesFor: #setUpExpiryWithZeroDelay!private!support! !
!GlorpTimedExpiryCacheTest categoriesFor: #setUpForExpiryActionOf:!private!support! !
!GlorpTimedExpiryCacheTest categoriesFor: #setUpForNotify!private!support! !
!GlorpTimedExpiryCacheTest categoriesFor: #setUpForNotifyAndRemove!private!support! !
!GlorpTimedExpiryCacheTest categoriesFor: #setUpForRefresh!private!support! !
!GlorpTimedExpiryCacheTest categoriesFor: #testExpiryReturningNilWithRealDelay!private!tests! !
!GlorpTimedExpiryCacheTest categoriesFor: #testNotExpiredAfterRefresh!private!tests! !
!GlorpTimedExpiryCacheTest categoriesFor: #testNotify!private!tests! !
!GlorpTimedExpiryCacheTest categoriesFor: #testNotifyAndRemove!private!tests! !
!GlorpTimedExpiryCacheTest categoriesFor: #testRegisteredObjectsDoNotExpire!private!tests! !

GlorpTimedStrongCacheTest guid: (GUID fromString: '{2F45F430-0CDD-47D1-BF98-2F8D9C60BD3B}')!
GlorpTimedStrongCacheTest comment: ''!
!GlorpTimedStrongCacheTest categoriesForClass!Unclassified! !
!GlorpTimedStrongCacheTest methodsFor!

setUp
	super setUp.
	self setUpExpiryWithRealDelay.!

setUpExpiryWithRealDelay
	(cache session descriptorFor: GlorpCustomer) cachePolicy: (TimedStrongCachePolicy new timeout: 1).
	(cache session descriptorFor: GlorpBankTransaction) cachePolicy: (TimedStrongCachePolicy new timeout: 1).!

setUpExpiryWithZeroDelay
	(cache session descriptorFor: GlorpCustomer) cachePolicy: (TimedStrongCachePolicy new timeout: 0).
	(cache session descriptorFor: GlorpBankTransaction) cachePolicy: (TimedStrongCachePolicy new timeout: 0).!

setUpForExpiryActionOf: aSymbol
	(cache session descriptorFor: GlorpCustomer) cachePolicy expiryAction: aSymbol.
	(cache session descriptorFor: GlorpBankTransaction) cachePolicy expiryAction: aSymbol.!

setUpForNotify
	self setUpForExpiryActionOf: #notify.!

setUpForNotifyAndRemove
	self setUpForExpiryActionOf: #notifyAndRemove.!

setUpForRefresh
	self setUpForExpiryActionOf: #refresh.!

testExpiryReturningNilWithRealDelay
	"test that objects expire with a non-zero delay time."
	| customer customer2 |
	customer := GlorpCustomer example1.
	cache at: 3 insert: customer.
	self deny: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == nil.
	(Delay forSeconds: 2) wait.
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == nil.
	customer2 := GlorpCustomer new.
	cache at: 3 insert: customer2.
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == customer2.!

testNotExpiredAfterRefresh
	| customer |
	self setUpForRefresh.
	session accessor beginTransaction.
	[session accessor executeSQLStringNoResult: 'INSERT INTO GR_CUSTOMER VALUES (3,''Fred Flintstone'')'.
	customer := session execute: (Query returningOneOf: GlorpCustomer where: [:each | each id = 3]).
	(Delay forSeconds: 2) wait.
	self assert: (cache hasExpired: customer).
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == customer.
	self deny: (cache hasExpired: customer)]
		ensure: [session accessor rollbackTransaction].!

testNotify
	| customer |
	self setUpExpiryWithZeroDelay.
	self setUpForNotify.
	customer := GlorpCustomer example1.
	cache at: 3 insert: customer.
	self deny: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == nil.
	self assert: customer seenExpiry.!

testNotifyAndRemove
	| customer |
	self setUpExpiryWithZeroDelay.
	self setUpForNotifyAndRemove.
	customer := GlorpCustomer example1.
	cache at: 3 insert: customer.
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == nil.
	self assert: customer seenExpiry = true.!

testRegisteredObjectsDoNotExpire
	| customer |
	self setUpExpiryWithZeroDelay.
	self setUpForNotifyAndRemove.
	customer := GlorpCustomer example1.
	customer id: 3.
	cache at: 3 insert: customer.
	session beginUnitOfWork.
	session register: customer.
	self assert: (cache lookupClass: GlorpCustomer key: 3 ifAbsent: [nil]) == customer.
	self deny: customer seenExpiry.! !
!GlorpTimedStrongCacheTest categoriesFor: #setUp!private!tests! !
!GlorpTimedStrongCacheTest categoriesFor: #setUpExpiryWithRealDelay!private!tests! !
!GlorpTimedStrongCacheTest categoriesFor: #setUpExpiryWithZeroDelay!private!tests! !
!GlorpTimedStrongCacheTest categoriesFor: #setUpForExpiryActionOf:!private!tests! !
!GlorpTimedStrongCacheTest categoriesFor: #setUpForNotify!private!support! !
!GlorpTimedStrongCacheTest categoriesFor: #setUpForNotifyAndRemove!private!tests! !
!GlorpTimedStrongCacheTest categoriesFor: #setUpForRefresh!private!tests! !
!GlorpTimedStrongCacheTest categoriesFor: #testExpiryReturningNilWithRealDelay!private!tests! !
!GlorpTimedStrongCacheTest categoriesFor: #testNotExpiredAfterRefresh!private!tests! !
!GlorpTimedStrongCacheTest categoriesFor: #testNotify!private!tests! !
!GlorpTimedStrongCacheTest categoriesFor: #testNotifyAndRemove!private!tests! !
!GlorpTimedStrongCacheTest categoriesFor: #testRegisteredObjectsDoNotExpire!private!tests! !

GlorpWeakCacheTest guid: (GUID fromString: '{9766E6C1-2825-4B01-9B09-3CB46D835ED2}')!
GlorpWeakCacheTest comment: ''!
!GlorpWeakCacheTest categoriesForClass!Unclassified! !
!GlorpWeakCacheTest methodsFor!

checkCacheExhaustivelyFor: aBlock
	"Check to make sure the cache satisfies the criteria. Since this relies on unpredictable finalization, do a full 10 garbage collect then wait iterations. Don't return early, because we're checking to see that finalization *doesn't* happen"
	self assert: (self doesCacheExhaustivelySatisfy: aBlock).!

checkCacheFor: aBlock
	"Check to make sure the cache satisfies the criteria. Since this relies on unpredictable finalization, do up to 10 garbage collect then wait iterations. If it's true before that, return early, but if it's not true at the end, fail"
	self assert: (self doesCacheSatisfy: aBlock).!

doesCacheExhaustivelySatisfy: aBlock
	| result |
	result := false.
	10
		timesRepeat:
			[Dialect garbageCollect.
			(Delay forMilliseconds: 100) wait.
			result := aBlock value].
	^result.!

doesCacheSatisfy: aBlock
	10
		timesRepeat:
			[Dialect garbageCollect.
			(Delay forMilliseconds: 100) wait.
			aBlock value ifTrue: [^true]].
	^false.!

initialize!

mournKeyOf: anEphemeron
	mourned := true.!

setUp
	super setUp.
	system cachePolicy: WeakVWCachePolicy new.
	mourned := false.!

testEphemeralValue
	| value ephemeron |
	Dialect isVWWithNameSpaces ifFalse: [ ^self ].
	value := Object new.
	ephemeron := (Dialect smalltalkAt: #EphemeralValue) key: 'abc' value: value.
	ephemeron manager: self.
	Dialect garbageCollect.
	value := nil.
	self should: [10 timesRepeat: [
		mourned ifFalse: [Dialect garbageCollect.
		(Delay forMilliseconds: 100) wait]].
		mourned].!

testEphemeralValueDictionary
	| value dict done |
	Dialect isVWWithNameSpaces ifFalse: [ ^self ].
	value := Object new.
	dict := WeakVWCachePolicy new dictionaryClass new.
	dict at: 'abc' put: value.
	Dialect garbageCollect.
	value := nil.
	done := false.
	self should:
		[10	timesRepeat:
			[done ifFalse: [
				Dialect garbageCollect.
				(Delay forMilliseconds: 100) wait.
				done := dict size = 0]].
			 done].!

testEphemeron
	| value ephemeron |
	Dialect isVWWithNameSpaces ifFalse: [ ^self ].
	value := Object new.
	ephemeron := (Dialect smalltalkAt: #Ephemeron) key: value value: 'abc'.
	ephemeron manager: self.
	Dialect garbageCollect.
	value := nil.
	self should: [10 timesRepeat: [
		mourned ifFalse: [Dialect garbageCollect.
		(Delay forMilliseconds: 100) wait]].
		mourned].!

testEphemeronDictionary
	| value dict done |
	Dialect isVWWithNameSpaces ifFalse: [ ^self ].
	value := Object new.
	dict := (Dialect smalltalkAt: #EphemeronDictionary) new.
	dict at: value put: 'abc'.
	Dialect garbageCollect.
	value := nil.
	done := false.
	self should:
		[10	timesRepeat:
			[done ifFalse: [
				Dialect garbageCollect.
				(Delay forMilliseconds: 100) wait.
				done := dict size = 0]].
			 done].!

testLargeWeakDictionary
	| elements size customers newElements |
	Dialect isVWWithNameSpaces ifFalse: [ ^self ].
	system cachePolicy numberOfElements: 1.
	size := 2 raisedTo: 14.
	customers := OrderedCollection new: size.
	1 to: size do: [:i | | cust |
		cust := GlorpCustomer new.
		customers add: cust.
		cache at: i insert: cust].
	elements := cache numberOfElements.
	self assert: elements = (2 raisedTo: 14).
	customers := nil.
	Dialect garbageCollect.
	(Delay forSeconds: 2) wait.
	Dialect garbageCollect.
	(Delay forSeconds: 1) wait.
	newElements := cache numberOfElements.
	self assert: newElements = 1.!

testUnreferencedExcessObjectsAreRemoved
	Dialect isVWWithNameSpaces ifFalse: [ ^self ].
	system cachePolicy numberOfElements: 1.
	cache at: 3 insert: GlorpCustomer new.
	cache at: 4 insert: GlorpCustomer new.
	self checkCacheFor: [(cache containsObjectForClass: GlorpCustomer key: 3) not].
	self assert: (cache containsObjectForClass: GlorpCustomer key: 4).!

testUnreferencedObjectsAreRemoved

	Dialect isVWWithNameSpaces ifFalse: [ ^self ].
	system cachePolicy numberOfElements: 0.
	cache at: 3 insert: GlorpCustomer new.
	self
		checkCacheFor: [(cache containsObjectForClass: GlorpCustomer key: 3) not].!

testUnreferencedObjectsAreRemovedInTheRightOrder
	| customer |
	Dialect isVWWithNameSpaces ifFalse: [ ^self ].
	system cachePolicy numberOfElements: 1.
	cache at: 3 insert: GlorpCustomer new.
	cache at: 4 insert: GlorpCustomer new.
	customer := cache lookupClass: GlorpCustomer key: 3.
	self deny: customer isNil.
	cache at: 3 insert: customer.
	self checkCacheFor: [(cache containsObjectForClass: GlorpCustomer key: 4) not].
	self assert: (cache containsObjectForClass: GlorpCustomer key: 3).!

testUnreferencedObjectsNotRemovedDueToExtraReferences
	Dialect isVWWithNameSpaces ifFalse: [ ^self ].
	cache at: 3 insert: GlorpCustomer new.
	self checkCacheExhaustivelyFor: [(cache containsObjectForClass: GlorpCustomer key: 3)].! !
!GlorpWeakCacheTest categoriesFor: #checkCacheExhaustivelyFor:!private!support! !
!GlorpWeakCacheTest categoriesFor: #checkCacheFor:!private!support! !
!GlorpWeakCacheTest categoriesFor: #doesCacheExhaustivelySatisfy:!private!support! !
!GlorpWeakCacheTest categoriesFor: #doesCacheSatisfy:!private!support! !
!GlorpWeakCacheTest categoriesFor: #initialize!initializing!private! !
!GlorpWeakCacheTest categoriesFor: #mournKeyOf:!private!support! !
!GlorpWeakCacheTest categoriesFor: #setUp!private!support! !
!GlorpWeakCacheTest categoriesFor: #testEphemeralValue!private!tests! !
!GlorpWeakCacheTest categoriesFor: #testEphemeralValueDictionary!private!tests! !
!GlorpWeakCacheTest categoriesFor: #testEphemeron!private!tests! !
!GlorpWeakCacheTest categoriesFor: #testEphemeronDictionary!private!tests! !
!GlorpWeakCacheTest categoriesFor: #testLargeWeakDictionary!private!tests! !
!GlorpWeakCacheTest categoriesFor: #testUnreferencedExcessObjectsAreRemoved!private!tests! !
!GlorpWeakCacheTest categoriesFor: #testUnreferencedObjectsAreRemoved!private!tests! !
!GlorpWeakCacheTest categoriesFor: #testUnreferencedObjectsAreRemovedInTheRightOrder!private!tests! !
!GlorpWeakCacheTest categoriesFor: #testUnreferencedObjectsNotRemovedDueToExtraReferences!private!tests! !

!GlorpWeakCacheTest class methodsFor!

new
	"Answer a newly created and initialized instance."

	^super new initialize! !
!GlorpWeakCacheTest class categoriesFor: #new!instance creation!private! !

GlorpConditionalMappingTest guid: (GUID fromString: '{9903CC4A-F926-4359-B7D3-750088912E5E}')!
GlorpConditionalMappingTest comment: 'This tests the conditional mapping basic API without going to the database.
'!
!GlorpConditionalMappingTest categoriesForClass!Unclassified! !
!GlorpConditionalMappingTest methodsFor!

setUp
	super setUp.
	descriptor := system descriptorFor: GlorpPassenger.
	mapping := descriptor newMapping: ConditionalMapping.
	mapping conditionalField: (descriptor primaryTable fieldNamed: 'ID').
	mapping if: #testIDLessThan5: then: (mapping1 := DirectMapping from: #blah to: (descriptor primaryTable fieldNamed: 'ID')).
	mapping if: #testIDMoreThan5: then: (mapping2 := DirectMapping from: #bletch to: (descriptor primaryTable fieldNamed: 'NAME')).
	mapping otherwise: (mapping3 := DirectMapping from: #bazoomer to: (descriptor primaryTable fieldNamed: 'ID')).
	mapping conditionalMethod: #id.!

setUpNew
	"Set up using the newer protocol"
	newMapping := descriptor newMapping: ConditionalMapping.
	newMapping
		forField: (descriptor primaryTable fieldNamed: 'ID')
		attribute: #id
		if: [:value | value = 1]
		useMapping: (mapping1 := DirectMapping from: #blah to: (descriptor primaryTable fieldNamed: 'ID')).
	newMapping if: #testIDMoreThan5: then: (mapping2 := DirectMapping from: #bletch to: (descriptor primaryTable fieldNamed: 'NAME')).
	newMapping otherwise: (mapping3 := DirectMapping from: #bazoomer to: (descriptor primaryTable fieldNamed: 'ID')).!

testApplicableMappingForReadNewProtocol

	| builder |
	self setUpNew.
	builder := ElementBuilder for: ([:x | x] asGlorpExpressionForDescriptor: descriptor) in: SimpleQuery new.
	self assert: (newMapping applicableMappingForRow: #(1 foo nil nil) in: builder) == mapping1.
	self assert: (newMapping applicableMappingForRow: #(6 foo nil nil) in: builder) == mapping2.
	self assert: (newMapping applicableMappingForRow: #(5 foo nil nil) in: builder) == mapping3.!

testApplicableMappingForReadOldProtocol

	| builder |
	builder := ElementBuilder for: ([:x | x] asGlorpExpressionForDescriptor: descriptor) in: SimpleQuery new.
	self assert: (mapping applicableMappingForRow: #(1 foo nil nil) in: builder) == mapping1.
	self assert: (mapping applicableMappingForRow: #(6 foo nil nil) in: builder) == mapping2.
	self assert: (mapping applicableMappingForRow: #(5 foo nil nil) in: builder) == mapping3.!

testApplicableMappingForWriteNewProtocol

	| passenger |
	self setUpNew.
	passenger := GlorpPassenger new.
	passenger id: 1.
	self assert: (newMapping applicableMappingForObject: passenger) == mapping1.
	passenger id: 6.
	self assert: (newMapping applicableMappingForObject: passenger) == mapping2.
	passenger id: 5.
	self assert: (newMapping applicableMappingForObject: passenger) == mapping3.!

testApplicableMappingForWriteOldProtocol

	| passenger |
	passenger := GlorpPassenger new.
	passenger id: 1.
	self assert: (mapping applicableMappingForObject: passenger) == mapping1.
	passenger id: 6.
	self assert: (mapping applicableMappingForObject: passenger) == mapping2.
	passenger id: 5.
	self assert: (mapping applicableMappingForObject: passenger) == mapping3.!

testDescriptor

	self assert: mapping1 descriptor == descriptor.
	self assert: mapping2 descriptor == descriptor.
	self assert: mapping3 descriptor == descriptor.!

testMappedFieldsOldProtocol

	self assert: mapping mappedFields asSortedCollection = descriptor primaryTable fields asSortedCollection.

	mapping := descriptor newMapping: ConditionalMapping.
	self assert: mapping mappedFields isEmpty.

	mapping conditionalField: (descriptor primaryTable fieldNamed: 'ID').
	self assert: mapping mappedFields size = 1.	

	mapping if: #testIDLessThan5: then: (mapping1 := DirectMapping from: #blah to: (descriptor primaryTable fieldNamed: 'NAME')).
	self assert: mapping mappedFields asSortedCollection = descriptor primaryTable fields asSortedCollection.! !
!GlorpConditionalMappingTest categoriesFor: #setUp!private!support! !
!GlorpConditionalMappingTest categoriesFor: #setUpNew!private!support! !
!GlorpConditionalMappingTest categoriesFor: #testApplicableMappingForReadNewProtocol!private!tests! !
!GlorpConditionalMappingTest categoriesFor: #testApplicableMappingForReadOldProtocol!private!tests! !
!GlorpConditionalMappingTest categoriesFor: #testApplicableMappingForWriteNewProtocol!private!tests! !
!GlorpConditionalMappingTest categoriesFor: #testApplicableMappingForWriteOldProtocol!private!tests! !
!GlorpConditionalMappingTest categoriesFor: #testDescriptor!private!tests! !
!GlorpConditionalMappingTest categoriesFor: #testMappedFieldsOldProtocol!private!tests! !

GlorpDictionaryMappingTest guid: (GUID fromString: '{6C8C4AF6-DE61-4465-9A02-12D547725C9B}')!
GlorpDictionaryMappingTest comment: ''!
!GlorpDictionaryMappingTest categoriesForClass!Unclassified! !
!GlorpDictionaryMappingTest methodsFor!

setUp
	super setUp.
	session system: (GlorpEncyclopediaDescriptorSystem forPlatform: session platform).
	session beginTransaction.!

tearDown
	session rollbackTransaction.
	super tearDown.!

testCasesToWrite

	"How des a dictionary mapping relate to 1:many vs many:many.
	dictionary of strings to strings
	dictionary of strings to objects
	dictionary of objects to objects
	keys always have to be related to values somehow, because I can't extract the association otherwise. Both might also be associated to source.
    You should be able to use the topological sort to determine the create/delete order of tables as well"!

testCollectionKeyQuery

	| encyclopedias matches |
	encyclopedias := session system exampleEncyclopedias.
	session transact: [session register: encyclopedias].
	session reset.
"	matches := session read: GlorpEncyclopedia	 where: [:each | each entries anySatisfy: [:eachEntry |
		((eachEntry getTable: 'ENCYC_ENTRY_LINK') getField: 'REFERENCE_NO') = 'unique']]."
	matches := session read: GlorpEncyclopedia	 where: [:each | each entries anySatisfy: [:eachEntry |
		eachEntry key = 'unique']].
	self assert: matches size = 1.
	self assert: matches first name = 'The Canadian Encyclopedia'.
	matches do: [:each | self assert: (each entries anySatisfy: [:eachEntry | eachEntry id = 'three'])].
	matches do: [:each | self assert: each entries size = 3].!

testCollectionValueQuery

	| encyclopedias matches |
	encyclopedias := session system exampleEncyclopedias.
	session transact: [session register: encyclopedias].
	session reset.
	matches := session read: GlorpEncyclopedia where: [:each | each entries anySatisfy: [:eachEntry |
		eachEntry value title = 'Vehicular Fish Decay']].
	self assert: matches size = 1.
	self assert: matches first name = 'The Canadian Encyclopedia'.
	matches do: [:each | self assert: (each entries anySatisfy: [:eachEntry | eachEntry id = 'three'])].
	matches do: [:each | self assert: each entries size = 3].!

testCollectionValueQueryWithImpliedValue

	| encyclopedias matches |
	encyclopedias := session system exampleEncyclopedias.
	session transact: [session register: encyclopedias].
	session reset.
	matches := session read: GlorpEncyclopedia where: [:each | each entries anySatisfy: [:eachEntry |
		eachEntry title = 'Vehicular Fish Decay']].
	self assert: matches size = 1.
	self assert: matches first name = 'The Canadian Encyclopedia'.
	matches do: [:each | self assert: (each entries anySatisfy: [:eachEntry | eachEntry id = 'three'])].
	matches do: [:each | self assert: each entries size = 3].!

testCollectionValueQueryWithImpliedValueAndObjectEquality

	| encyclopedias matches entry |
	encyclopedias := session system exampleEncyclopedias.
	session transact: [session register: encyclopedias].
	session reset.
	entry := session readOneOf: GlorpEncyclopediaEntry where: [:each | each title = 'Vehicular Fish Decay'].
	matches := session read: GlorpEncyclopedia where: [:each | each entries anySatisfy: [:eachEntry |
		eachEntry = entry]].
	self assert: matches size = 1.
	self assert: matches first name = 'The Canadian Encyclopedia'.
	matches do: [:each | self assert: (each entries anySatisfy: [:eachEntry | eachEntry id = 'three'])].
	matches do: [:each | self assert: each entries size = 3].!

testDeleteSimpleTypeOneToMany
	| publishers publisher |
	self assert: (session read: GlorpPublisher) isEmpty.
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	session modify: publisher in: [
		publisher titles: (publisher titles copyWithout: 'Mastering ENVY/Developer')].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	self assert: publisher titles size = 2.
	self assert: publisher titles asSortedCollection = (session system examplePublisher1 titles copyWithout: 'Mastering ENVY/Developer') asSortedCollection.!

testQueryWithDictionaryType

	| encyclopedias query dict linkTable entryTable refField linkTableField idField |
	encyclopedias := session system exampleEncyclopedias.
	session transact: [session register: encyclopedias].
	session reset.
	linkTable := session system tableNamed: 'ENCYC_ENTRY_LINK'.
	entryTable := session system tableNamed: 'ENCYC_ENTRY'.
	refField := linkTable fieldNamed: 'REFERENCE_NO'.
	linkTableField := linkTable fieldNamed: 'ENCYC_ENTRY_ID'.
	idField := entryTable fieldNamed: 'ID'.
	query := Query readManyOf: GlorpEncyclopediaEntry.
	query where: [:each | ((each getTable: linkTable) getField: linkTableField) = ((each getTable: entryTable) getField: idField)].
	query retrieveDictionaryWithKey: [:each | (each getTable: linkTable) getField: refField] value: [:each | each].
	dict := session execute: query.
	self assert: dict class == Dictionary.
	self assert: dict size = 5.
	self assert: (dict at: 'abcde') id = 'two'.
	self assert: (dict at: 'abcde') == (dict at: 'edcba').!

testReadWithAlsoFetch
	| encyclopedias query readBackEncyclopedias |
	encyclopedias := session system exampleEncyclopedias.
	session transact: [session register: encyclopedias].
	session reset.
	query := Query readManyOf: GlorpEncyclopedia.
	query orderBy: [:each | each name].
	query alsoFetch: [:each | each entries asOuterJoin].
	readBackEncyclopedias := session execute: query.
	session accessor denyReads.
	self verifyEncyclopedias: readBackEncyclopedias.!

testReadWithRetrieve
	| encyclopedias query readBackEncyclopedias |
	encyclopedias := session system exampleEncyclopedias.
	session transact: [session register: encyclopedias].
	session reset.
	query := Query readManyOf: GlorpEncyclopedia.
	query orderBy: [:each | each name].
	query retrieve: [:each | each].
	query retrieve: [:each | each entries asOuterJoin].
	readBackEncyclopedias := session execute: query.
	session accessor denyReads.
	self assert: readBackEncyclopedias size = 6.
	self verifyEncyclopedias: ((readBackEncyclopedias collect: [:each | each first]) asSet asSortedCollection: [:a :b | a name <= b name]).
	readBackEncyclopedias do: [:eachArray |
		eachArray last key isNil 
			ifTrue: [self assert: eachArray first entries isEmpty]
			ifFalse: [self assert: (eachArray first entries at: eachArray last key) = eachArray last value]].!

testSimpleTypeDictionary
	| publishers |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publishers := session read: GlorpPublisher where: [:each | each id = 1].
	publishers do: [:each | 
		each titlesWithNumberInStock keysAndValuesDo: [:eachTitle :eachNumber | 	
			self assert: eachTitle isString.
			self assert: eachNumber = 2]].
	self assert: publishers first titlesWithNumberInStock size = 3.
	self assert: publishers first titlesWithNumberInStock keys asSortedCollection = session system examplePublisher1 titles asSortedCollection.

"	publishers do: [:each | 
		each titlesWithNumberInStockLink keysAndValuesDo: [:eachTitle :eachNumber | 	
			self assert: eachTitle isString.
			self assert: eachNumber = 2]].
	self assert: publishers first titlesWithNumberInStockLink size = 3.
	self assert: publishers first titlesWithNumberInStockLink keys asSortedCollection = session system examplePublisher1 titles asSortedCollection."!

testSimpleTypeDictionaryComplexQuerying
	| publishers |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publishers := session read: GlorpPublisher where: [:each | each titlesWithNumberInStock sqlCount = 3].
	self assert: publishers size = 1.
	self assert: publishers first titlesWithNumberInStock size = 3.
	self assert: (publishers first titlesWithNumberInStock keys includes: 'Mastering ENVY/Developer').

"	publishers := session read: GlorpPublisher where: [:each | each titlesWithNumberInStockLink sqlCount > 0].
	publishers := publishers asSortedCollection: [:a :b | a name <= b name].
	self assert: publishers size = 2.
	self assert: publishers first titlesWithNumberInStock size = 3.
	self assert: (publishers first titlesWithNumberInStock keys includes: 'Mastering ENVY/Developer')."!

testSimpleTypeDictionaryQuerying
	| publishers |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.

	publishers := session read: GlorpPublisher where: [:each | each titlesWithNumberInStock anySatisfy: [:x | x key like: 'Master%']].
	self assert: publishers size = 1.
	self assert: publishers first titlesWithNumberInStock size = 3.
	self assert: (publishers first titlesWithNumberInStock keys includes: 'Mastering ENVY/Developer').

"	publishers := session read: GlorpPublisher where: [:each | each titlesWithNumberInStock anySatisfy: [:x | x value  = 2]].
	self assert: publishers size = 1.
	self assert: publishers first id = 1."!

testSimpleTypeDictionaryQueryingWithAlsoFetch
	| publishers publisherOne publisher2 q |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.

	q := Query read: GlorpPublisher where: [:each | each id < 3].
	q orderBy: [:each | each id].
	q alsoFetch: [:each | each titlesWithNumberInStock].
	publishers := session execute: q.
	session accessor denyReads.
	
	self assert: publishers asSet size = 2.
	publisherOne := publishers detect: [:each | each id = 1].
	self assert: publisherOne titlesWithNumberInStock size = 3.
	self assert: (publisherOne titlesWithNumberInStock includesKey: 'Mastering ENVY/Developer').
	self assert: (publisherOne titlesWithNumberInStock values asArray = #(2 2 2)).

	publisher2 := publishers detect: [:each | each id = 2].
	self assert: publisher2 titlesWithNumberInStock keys asArray first = 'A book'.
	self assert: (publisher2 titlesWithNumberInStock at: 'A book') = 200.!

testSimpleTypeDictionaryQueryingWithFilteredReads
	| publishers publisherOne publisher2 |
	((session system descriptorFor: GlorpPublisher) mappingForAttributeNamed: #titlesWithNumberInStock) useFilteredRead.
	"((session system descriptorFor: GlorpPublisher) mappingForAttributeNamed: #titlesWithNumberInStockLink) useFilteredRead."

	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.

	publishers := session read: GlorpPublisher where: [:each | each id < 3].
	self assert: publishers size = 2.
	publisherOne := publishers detect: [:each | each id = 1].
	self assert: publisherOne titlesWithNumberInStock size = 3.
	self assert: (publisherOne titlesWithNumberInStock includesKey: 'Mastering ENVY/Developer').
	self assert: (publisherOne titlesWithNumberInStock values asArray = #(2 2 2)).
"	self assert: publisherOne titlesWithNumberInStockLink size = 3.
	self assert: (publisherOne titlesWithNumberInStockLink includesKey: 'Mastering ENVY/Developer').
	self assert: (publisherOne titlesWithNumberInStockLink values asArray = #(2 2 2)).
"
	session accessor denyReads.
	publisher2 := publishers detect: [:each | each id = 2].
	self assert: publisher2 titlesWithNumberInStock keys asArray first = 'A book'.
"	self assert: publisher2 titlesWithNumberInStockLink keys asArray first = 'A book'."
	self assert: (publisher2 titlesWithNumberInStock at: 'A book') = 200.
"	self assert: (publisher2 titlesWithNumberInStockLink at: 'A book') = 200."!

testSimpleTypeDictionaryQueryingWithRetrieve
	| publishers publisherOne publisher2 q actualPublishers |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.

	q := Query read: GlorpPublisher where: [:each | each id < 3].
	q retrieve: [:each | each].
	q retrieve: [:each | each titlesWithNumberInStock].
	publishers := session execute: q.
	
	actualPublishers := publishers collect: [:each | each first].

	self assert: actualPublishers asSet size = 2.
	publisherOne := actualPublishers detect: [:each | each id = 1].
	self assert: publisherOne titlesWithNumberInStock size = 3.
	self assert: (publisherOne titlesWithNumberInStock includesKey: 'Mastering ENVY/Developer').
	self assert: (publisherOne titlesWithNumberInStock values asArray = #(2 2 2)).

	publisher2 := actualPublishers detect: [:each | each id = 2].
	self assert: publisher2 titlesWithNumberInStock keys asArray first = 'A book'.
	self assert: (publisher2 titlesWithNumberInStock at: 'A book') = 200.!

testSimpleTypeDictionaryRead
	| publishers |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publishers := session read: GlorpPublisher where: [:each | each titlesWithNumberInStock anySatisfy: [:eachTitleAssociation |
		eachTitleAssociation value = 2]].
	self assert: publishers size = 1.!

testSimpleTypeDictionaryReadWithImpliedValue
	| publishers |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publishers := session read: GlorpPublisher where: [:each | each titlesWithNumberInStock anySatisfy: [:eachTitleAssociation |
		eachTitleAssociation = 2]].
	self assert: publishers size = 1.!

testSimpleTypeOneToMany
	| publishers |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publishers := session read: GlorpPublisher where: [:each | each id = 1].
	publishers do: [:each | 
		each titles do: [:eachTitle | self assert: eachTitle isString]].
	self assert: publishers first titles size = 3.
	self assert: publishers first titles asSortedCollection = session system examplePublisher1 titles asSortedCollection.!

testSimpleTypeOneToManyComplexQuerying
	| publishers |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publishers := session read: GlorpPublisher where: [:each | each titles sqlCount = 3].
	self assert: publishers size = 1.
	self assert: publishers first titles size = 3.
	self assert: (publishers first titles includes: 'Mastering ENVY/Developer').!

testSimpleTypeOneToManyQuerying
	| publishers |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publishers := session read: GlorpPublisher where: [:each | each titles anySatisfy: [:x | x like: 'Master%' ]].
	self assert: publishers size = 1.
	self assert: (publishers first titles anySatisfy: [:each | each like: 'Master%']).!

testSimpleTypeOneToManyQueryingIncludes
	| publishers |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publishers := session read: GlorpPublisher where: [:each | each titles includes: 'Mastering ENVY/Developer' ].
	self assert: publishers size = 1.
	self assert: (publishers first titles includes: 'Mastering ENVY/Developer').!

testSimpleTypeOneToManyQueryingWithFilteredReads
	| publishers publisherOne publisher2 |
	((session system descriptorFor: GlorpPublisher) mappingForAttributeNamed: #titles) useFilteredRead.
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publishers := session read: GlorpPublisher where: [:each | each id < 3].
	self assert: publishers size = 2.
	publisherOne := publishers detect: [:each | each id = 1].
	self assert: publisherOne titles size = 3.
	self assert: (publisherOne titles includes: 'Mastering ENVY/Developer').
	session accessor denyReads.
	publisher2 := publishers detect: [:each | each id = 2].
	self assert: publisher2 titles first = 'A book'.!

testUpdate

	| encyclopedias canadian allEntryRows allLinkRows |
	encyclopedias := session system exampleEncyclopedias.
	session transact: [session register: encyclopedias].
	session reset.
	session accessor denyCommands: (Array with: DeleteCommand).
	session inUnitOfWorkDo: [
		| newEntry |
		canadian := session readOneOf: GlorpEncyclopedia where: [:each | each name like: 'The Ca%'].
		newEntry := GlorpEncyclopediaEntry new
			id: 'seven';
			title: 'The Latest Entry';
			text: 'This is all about the very newest stuff'.
		canadian entries at: 'unique' put: newEntry].
	self assert: (canadian entries at: 'abcde') id = 'two'.
	self assert: (canadian entries at: '12345') id = 'one'.
	self assert: (canadian entries at: 'unique') id = 'seven'.
	self assert: (canadian entries at: 'unique') title = 'The Latest Entry'.
	allEntryRows := session accessor executeSQLString: 'select * from ENCYC_ENTRY'.
	"We didn't actually delete the 'three' entry"
	self assert: allEntryRows size = 4.
	allLinkRows := session accessor executeSQLString: 'select * from ENCYC_ENTRY_LINK'.
	"But we should have only our 3 link table rows, plus 2 for the other encyclopedia"
	self assert: allLinkRows size = 5.!

testUpdateNonLinkTable
	"Test updating a dictionary where we don't have a link table, but the target table refers back to the containing object."
	| encyclopedias canadian bio newBio |
	encyclopedias := session system exampleEncyclopedias.
	bio := GlorpEncyclopediaBioEntry new title: 'Alan Kay'; text: 'A stub'.
	encyclopedias first biographicalEntries at: bio title put: bio.
	session transact: [session register: encyclopedias].
	session reset.
	session inUnitOfWorkDo: [
		canadian := session readOneOf: GlorpEncyclopedia where: [:each | each name like: 'The Ca%'].
		newBio := GlorpEncyclopediaBioEntry new
			title: 'Alan Kay';
			text: 'a bit more information'.
		canadian biographicalEntries at: 'Alan Kay' put: newBio].
	session reset.
	canadian := session readOneOf: GlorpEncyclopedia where: [:each | each name like: 'The Ca%'].
	self assert: canadian biographicalEntries size = 1.
	self assert: (canadian biographicalEntries at: 'Alan Kay') text = 'a bit more information'.
	self assert: (session count: GlorpEncyclopediaBioEntry) = 1.!

testUpdateSimpleTypeDictionaryAdding
	| publishers publisher |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	session modify: publisher in: [
		publisher titlesWithNumberInStock at: 'New Book' put: 1].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	self assert: (publisher titlesWithNumberInStock at: 'New Book') = 1.
	self assert: publisher titlesWithNumberInStock size = 4.!

testUpdateSimpleTypeDictionaryDeleting
	| publishers publisher |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	session modify: publisher in: [
		publisher titlesWithNumberInStock removeKey: 'Mastering ENVY/Developer'].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	self assert: (publisher titlesWithNumberInStock at: 'Mastering ENVY/Developer' ifAbsent: [999]) = 999.
	self assert: publisher titlesWithNumberInStock size = 2.!

testUpdateSimpleTypeDictionaryLinkedAdding
"	| publishers publisher |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	session modify: publisher in: [
		publisher titlesWithNumberInStockLink at: 'New Book' put: 1].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	self assert: (publisher titlesWithNumberInStockLink at: 'New Book') = 1.
	self assert: publisher titlesWithNumberInStockLink size = 4."!

testUpdateSimpleTypeDictionaryLinkedDeleting
"	| publishers publisher |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	session modify: publisher in: [
		publisher titlesWithNumberInStockLink removeKey: 'Mastering ENVY/Developer'].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	self assert: (publisher titlesWithNumberInStockLink at: 'Mastering ENVY/Developer' ifAbsent: [999]) = 999.
	self assert: publisher titlesWithNumberInStockLink size = 2."!

testUpdateSimpleTypeDictionaryLinkModifying
"	| publishers publisher |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	session modify: publisher in: [
		publisher titlesWithNumberInStockLink at: 'Mastering ENVY/Developer' put: 123].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	self assert: (publisher titlesWithNumberInStockLink at: 'Mastering ENVY/Developer') = 123."
	"It can't find how to delete properly, because it doesn't know the primary key of the old record, and we don't have it recorded anywhere in the image"
	"self assert: (session accessor executeSQLString: 'SELECT * FROM PUBLISHER_TITLE2') size = 4.
	self assert: (session accessor executeSQLString: 'SELECT * FROM PUB_TITLE_LINK') size = 4."!

testUpdateSimpleTypeDictionaryModifying
	| publishers publisher |
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	session modify: publisher in: [
		publisher titlesWithNumberInStock at: 'Mastering ENVY/Developer' put: 123].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	self assert: (publisher titlesWithNumberInStock at: 'Mastering ENVY/Developer') = 123.!

testUpdateSimpleTypeOneToMany
	| publishers publisher |
	self assert: (session read: GlorpPublisher) isEmpty.
	publishers := session system examplePublishers.
	session modify: publishers in: [].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	session modify: publisher in: [
		publisher titles: (Array with: 'New Improved Book'), publisher titles].
	session reset.
	publisher := session readOneOf: GlorpPublisher where: [:each | each id = 1].
	self assert: publisher titles size = 4.
	self assert: publisher titles asSortedCollection = (session system examplePublisher1 titles , (Array with: 'New Improved Book')) asSortedCollection.!

testWriteAndReadBack
	| encyclopedias query readBackEncyclopedias |
	encyclopedias := session system exampleEncyclopedias.
	session transact: [session register: encyclopedias].
	session reset.
	query := Query readManyOf: GlorpEncyclopedia.
	query orderBy: [:each | each name].
	readBackEncyclopedias := session execute: query.
	self verifyEncyclopedias: readBackEncyclopedias.!

testWriteAndReadBackKeyInLinkTable

	| query readBackPublishers publishers withEmps |
	publishers := session system examplePublishers.
	session transact: [session register: publishers].
	session reset.
	query := Query readManyOf: GlorpPublisher.
	query orderBy: [:each | each name].
	readBackPublishers := session execute: query.
	self assert: readBackPublishers size = 3.
	withEmps := readBackPublishers at: 2.
	self assert: withEmps name = 'Cambridge'.
	self assert: withEmps differentBunchOfEmployeesById size = 2.
	self assert: withEmps differentBunchOfEmployeesById keys asSortedCollection asArray = #(3 4).
	self assert: (withEmps differentBunchOfEmployeesById at: 3) name = 'Contractor 1'.
	self assert: (withEmps differentBunchOfEmployeesById at: 4) name = 'Contractor 2'.!

testWriteAndReadBackKeyInTargetTable

	| query readBackPublishers publishers withEmps |
	publishers := session system examplePublishers.
	session transact: [session register: publishers].
	session reset.
	query := Query readManyOf: GlorpPublisher.
	query orderBy: [:each | each name].
	readBackPublishers := session execute: query.
	self assert: readBackPublishers size = 3.
	withEmps := readBackPublishers at: 2.
	self assert: withEmps name = 'Cambridge'.
	self assert: withEmps employees size = 2.
	self assert: withEmps employees keys asSortedCollection asArray = #('CEO' 'Editor').
	self assert: (withEmps employees at: 'CEO') name = 'The Boss'.
	self assert: (withEmps employees at: 'Editor') name = 'Somebody'.!

verifyEncyclopedias: readBackEncyclopedias
	| plagiarists canadian |
	self assert: readBackEncyclopedias size = 3.
	canadian := readBackEncyclopedias first.
	self assert: canadian name = 'The Canadian Encyclopedia'.
	self assert: canadian entries size = 3.
	self assert: (canadian entries at: 'abcde') id = 'two'.
	self assert: (canadian entries at: '12345') id = 'one'.
	self assert: (canadian entries at: 'unique') id = 'three'.
	plagiarists := readBackEncyclopedias at: 2.
	self assert: plagiarists entries size = 2.
	self
		assert:
			(plagiarists entries at: '54321') = (canadian entries at: '12345').
	self
		assert:
			(plagiarists entries at: 'edcba') = (canadian entries at: 'abcde').
	self assert: readBackEncyclopedias last entries isEmpty.! !
!GlorpDictionaryMappingTest categoriesFor: #setUp!private!support! !
!GlorpDictionaryMappingTest categoriesFor: #tearDown!private!support! !
!GlorpDictionaryMappingTest categoriesFor: #testCasesToWrite!private!tests! !
!GlorpDictionaryMappingTest categoriesFor: #testCollectionKeyQuery!private!tests! !
!GlorpDictionaryMappingTest categoriesFor: #testCollectionValueQuery!private!tests! !
!GlorpDictionaryMappingTest categoriesFor: #testCollectionValueQueryWithImpliedValue!private!tests! !
!GlorpDictionaryMappingTest categoriesFor: #testCollectionValueQueryWithImpliedValueAndObjectEquality!private!tests! !
!GlorpDictionaryMappingTest categoriesFor: #testDeleteSimpleTypeOneToMany!private!tests-simple reference classes! !
!GlorpDictionaryMappingTest categoriesFor: #testQueryWithDictionaryType!private!tests! !
!GlorpDictionaryMappingTest categoriesFor: #testReadWithAlsoFetch!private!tests! !
!GlorpDictionaryMappingTest categoriesFor: #testReadWithRetrieve!private!tests! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeDictionary!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeDictionaryComplexQuerying!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeDictionaryQuerying!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeDictionaryQueryingWithAlsoFetch!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeDictionaryQueryingWithFilteredReads!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeDictionaryQueryingWithRetrieve!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeDictionaryRead!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeDictionaryReadWithImpliedValue!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeOneToMany!private!tests-simple reference classes! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeOneToManyComplexQuerying!private!tests-simple reference classes! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeOneToManyQuerying!private!tests-simple reference classes! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeOneToManyQueryingIncludes!private!tests-simple reference classes! !
!GlorpDictionaryMappingTest categoriesFor: #testSimpleTypeOneToManyQueryingWithFilteredReads!private!tests-simple reference classes! !
!GlorpDictionaryMappingTest categoriesFor: #testUpdate!private!tests! !
!GlorpDictionaryMappingTest categoriesFor: #testUpdateNonLinkTable!private!tests! !
!GlorpDictionaryMappingTest categoriesFor: #testUpdateSimpleTypeDictionaryAdding!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testUpdateSimpleTypeDictionaryDeleting!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testUpdateSimpleTypeDictionaryLinkedAdding!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testUpdateSimpleTypeDictionaryLinkedDeleting!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testUpdateSimpleTypeDictionaryLinkModifying!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testUpdateSimpleTypeDictionaryModifying!private!tests-simple reference dictionary! !
!GlorpDictionaryMappingTest categoriesFor: #testUpdateSimpleTypeOneToMany!private!tests-simple reference classes! !
!GlorpDictionaryMappingTest categoriesFor: #testWriteAndReadBack!private!tests! !
!GlorpDictionaryMappingTest categoriesFor: #testWriteAndReadBackKeyInLinkTable!private!tests-key in different tables! !
!GlorpDictionaryMappingTest categoriesFor: #testWriteAndReadBackKeyInTargetTable!private!tests-key in different tables! !
!GlorpDictionaryMappingTest categoriesFor: #verifyEncyclopedias:!private!tests! !

GlorpDirectMappingTest guid: (GUID fromString: '{051897A6-B904-42E1-A39B-9983BA0B9791}')!
GlorpDirectMappingTest comment: ''!
!GlorpDirectMappingTest categoriesForClass!Unclassified! !
!GlorpDirectMappingTest methodsFor!

setUp
	| descriptor |
	super setUp.
	mapping := DirectMapping from: #id to: ((system tableNamed: 'GR_CUSTOMER') fieldNamed: 'ID').
	descriptor := Descriptor new.
	descriptor classModel: (GlorpClassModel for: GlorpCustomer).
	descriptor addMapping: mapping.!

testExpressionFor
	| cust exp |
	cust := GlorpCustomer new.
	cust id: 12.
	exp := mapping
		expressionFor: cust
		basedOn: BaseExpression new
		relation: #=.
	self assert: exp rightChild class == ConstantExpression.
	self assert: exp rightChild value = 12.
	self assert: exp relation = #=.
	self assert: exp leftChild class == MappingExpression.!

testProxying
	| customers |
	session beginTransaction.
	[((system descriptorFor: GlorpPerson) mappingForAttributeNamed: #name) shouldProxy: true.
	session modify: GlorpPerson example1 in: [].
	session reset.
	customers := session read: GlorpPerson.
	self assert: customers first name isGlorpProxy.
	self deny: customers first name isInstantiated.
	self assert: customers first name = 'Zaphod Beeblebrox']
		ensure: [session rollbackTransaction].
	self deny: ((system descriptorFor: GlorpPerson) mappedFields includes: ((system tableNamed: 'PERSON') fieldNamed: 'NAME')).! !
!GlorpDirectMappingTest categoriesFor: #setUp!private!support! !
!GlorpDirectMappingTest categoriesFor: #testExpressionFor!private!tests! !
!GlorpDirectMappingTest categoriesFor: #testProxying!private!tests! !

"Binary Globals"!

